SystemOrganization addCategory: #'XML-Tests-Parser'!
SystemOrganization addCategory: 'XML-Tests-Parser-DOM'!
SystemOrganization addCategory: 'XML-Tests-Parser-DOM-Factories'!
SystemOrganization addCategory: 'XML-Tests-Parser-DTD'!
SystemOrganization addCategory: 'XML-Tests-Parser-ElementHandlers'!
SystemOrganization addCategory: 'XML-Tests-Parser-Files'!
SystemOrganization addCategory: 'XML-Tests-Parser-Namespaces'!
SystemOrganization addCategory: 'XML-Tests-Parser-Streams'!
SystemOrganization addCategory: 'XML-Tests-Parser-URI'!
SystemOrganization addCategory: 'XML-Tests-Parser-Utils'!
SystemOrganization addCategory: 'XML-Tests-Parser-Validation-DFA'!

XMLNodeVisitor subclass: #XMLRecordingNodeVisitor
	instanceVariableNames: 'messageRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLRecordingNodeVisitor commentStamp: 'monty 7/28/2016 10:01' prior: 0!
This node visitor records vititing messages sent by node accept methods using an XMLMessageRecorder.!

!XMLRecordingNodeVisitor methodsFor: 'accessing' stamp: 'monty 7/28/2016 09:22'!
messageRecorder
	^ messageRecorder ifNil: [messageRecorder := XMLMessageRecorder new]! !

!XMLRecordingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:06'!
visitCData: aCData
	self messageRecorder
		recordMessageReceiver: self
		selector: #visitCData:
		argument: aCData.

	^ super visitCData: aCData.! !

!XMLRecordingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:07'!
visitComment: aComment
	self messageRecorder
		recordMessageReceiver: self
		selector: #visitComment:
		argument: aComment.

	^ super visitComment: aComment.! !

!XMLRecordingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:07'!
visitDocument: aDocument
	self messageRecorder
		recordMessageReceiver: self
		selector: #visitDocument:
		argument: aDocument.

	^ super visitDocument: aDocument.! !

!XMLRecordingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:07'!
visitElement: anElement
	self messageRecorder
		recordMessageReceiver: self
		selector: #visitElement:
		argument: anElement.

	^ super visitElement: anElement.! !

!XMLRecordingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:07'!
visitNodeWithElements: aNodeWithElements
	self messageRecorder
		recordMessageReceiver: self
		selector: #visitNodeWithElements:
		argument: aNodeWithElements.

	^ super visitNodeWithElements: aNodeWithElements.! !

!XMLRecordingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:07'!
visitPI: aPI
	self messageRecorder
		recordMessageReceiver: self
		selector: #visitPI:
		argument: aPI.

	^ super visitPI: aPI.! !

!XMLRecordingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:06'!
visitStringNode: aStringNode
	self messageRecorder
		recordMessageReceiver: self
		selector: #visitStringNode:
		argument: aStringNode.

	^ super visitStringNode: aStringNode.! !

SAX2ElementHandler subclass: #SAX2HBookElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HBookElementHandler commentStamp: 'monty 8/16/2016 04:03' prior: 0!
Handler for the sample <books> <book> element.!

!SAX2HBookElementHandler methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:33'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	self parser parsingResult addLast: SAX2SampleBook new! !

SAX2ElementHandler subclass: #SAX2HBooksElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HBooksElementHandler commentStamp: 'monty 8/16/2016 04:03' prior: 0!
Handler for the sample <books> element.!

!SAX2HBooksElementHandler methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:33'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	self parser parsingResult: OrderedCollection new! !

SAX2ElementHandler subclass: #SAX2HContactsElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HContactsElementHandler commentStamp: 'monty 8/16/2016 04:01' prior: 0!
Handler for the sample <person> <contacts> element.!

SAX2ElementHandler subclass: #SAX2HEmailElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HEmailElementHandler commentStamp: 'monty 8/16/2016 04:01' prior: 0!
Handler for the sample <person> <contacts> <email> element.!

!SAX2HEmailElementHandler methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:32'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	self parser parsingResult addEmailAddress: (anAttributeDictionary at: 'address')! !

SAX2ElementHandler subclass: #SAX2HPersonElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HPersonElementHandler commentStamp: 'monty 8/16/2016 04:02' prior: 0!
Handler for the sample <person> element.!

!SAX2HPersonElementHandler methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:32'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	self parser parsingResult: SAX2SamplePerson new! !

SAX2ElementCharacterHandler subclass: #SAX2HAuthorElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HAuthorElementHandler commentStamp: 'monty 8/16/2016 04:01' prior: 0!
Handler for the sample <person> <contacts> element.!

!SAX2HAuthorElementHandler methodsFor: 'handling - content' stamp: 'monty 8/16/2016 03:43'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self parser parsingResult last addAuthor: self characters! !

SAX2ElementCharacterHandler subclass: #SAX2HDateOfBirthElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HDateOfBirthElementHandler commentStamp: 'monty 8/16/2016 04:01' prior: 0!
Handler for the sample <person> <date-of-birth> element.!

!SAX2HDateOfBirthElementHandler methodsFor: 'handling - content' stamp: 'monty 8/15/2016 04:17'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self parser parsingResult dateOfBirth:
		(Date readFrom: self characters readStream)! !

SAX2ElementCharacterHandler subclass: #SAX2HISBNElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HISBNElementHandler commentStamp: 'monty 8/16/2016 04:02' prior: 0!
Handler for the sample <books> <book> <isbn> element.!

!SAX2HISBNElementHandler methodsFor: 'handling - content' stamp: 'monty 8/16/2016 03:39'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self parser parsingResult last isbn: self characters! !

SAX2ElementCharacterHandler subclass: #SAX2HNameElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HNameElementHandler commentStamp: 'monty 8/16/2016 04:02' prior: 0!
Handler for the sample <person> <name> element.!

!SAX2HNameElementHandler methodsFor: 'handling - content' stamp: 'monty 8/15/2016 04:15'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self parser parsingResult name: self characters! !

SAX2ElementCharacterHandler subclass: #SAX2HResidenceElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HResidenceElementHandler commentStamp: 'monty 8/17/2016 22:02' prior: 0!
Handler for the sample <person> <residence> element.!

!SAX2HResidenceElementHandler methodsFor: 'handling - content' stamp: 'monty 8/17/2016 22:02'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self parser parsingResult residence: self characters! !

SAX2ElementCharacterHandler subclass: #SAX2HTitleElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2HTitleElementHandler commentStamp: 'monty 8/16/2016 04:02' prior: 0!
Handler for the sample <books> <book> <title> element.!

!SAX2HTitleElementHandler methodsFor: 'handling - content' stamp: 'monty 8/16/2016 03:46'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self parser parsingResult last title: self characters! !

XMLDocument subclass: #XMLDocumentWithCachingNodeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDocumentWithCachingNodeList commentStamp: 'monty 9/1/2016 08:19' prior: 0!
A class for testing documents that use XMLCachingNodeList instead of XMLNodeList.!

!XMLDocumentWithCachingNodeList methodsFor: 'defaults' stamp: 'monty 8/31/2016 06:47'!
nodeListClass
	^ XMLCachingNodeList! !

XMLDocument subclass: #XMLFDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFDocument commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLDocument!

!BitmapCharacterSet class methodsFor: '*XML-Tests-Parser' stamp: 'monty 5/6/2017 03:44'!
fromXMLBNF: aString
	"parses a subset of the BNF syntax used by the XML spec for character classes"
	| set readStream |

	set := self new.
	readStream := aString readStream.
	[readStream
		skipSeparators;
		atEnd]
		whileFalse: [
			(readStream peekFor: $[)
				ifTrue: [
					[readStream skipSeparators.
						readStream atEnd
							or: [readStream peekFor: $]]]
						whileFalse: [| start |
							start := self nextXMLBNFCharFrom: readStream.
							readStream
								skipSeparators;
								peekFor: $-;
								skipSeparators.
							set
								addRangeFrom: start
								to: (self nextXMLBNFCharFrom: readStream)]]
					ifFalse: [
						(self nextXMLBNFCharFrom: readStream)
							ifNotNil: [:nextChar |
								set add: nextChar]]].
	^ set.! !

!BitmapCharacterSet class methodsFor: '*XML-Tests-Parser' stamp: 'monty 9/29/2017 17:37'!
nextXMLBNFCharFrom: aStream
	(aStream peek == $"
		or: [aStream peek == $'])
		ifTrue: [^ (aStream upTo: aStream next) first].
	(aStream peekFor: $#)
		ifTrue: [
			^ (XMLIntegerReader
				readFrom: aStream
				withBase: 16
				andPrefixes: 'xX'
				orBase: 10) asCharacter].
	(aStream peekFor: $|)
		ifTrue: [^ nil].
	^ aStream next.! !

TestCase subclass: #DTDExternalEntityResolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DTD'!

DTDExternalEntityResolverTest subclass: #DTDCachingExternalEntityResolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DTD'!

DTDCachingExternalEntityResolverTest subclass: #DTDCachingExternalEntityResolverLimitingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DTD'!

!DTDCachingExternalEntityResolverLimitingTest methodsFor: 'testing' stamp: 'monty 10/4/2017 20:19'!
isTestingLimiting
	^ true! !

!DTDCachingExternalEntityResolverTest methodsFor: 'accessing' stamp: 'monty 3/22/2016 04:47'!
resolverClass
	^ DTDCachingExternalEntityResolver! !

DTDExternalEntityResolverTest subclass: #DTDExternalEntityResolverLimitingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DTD'!

!DTDExternalEntityResolverLimitingTest methodsFor: 'testing' stamp: 'monty 10/4/2017 20:19'!
isTestingLimiting
	^ true! !

!DTDExternalEntityResolverTest class methodsFor: 'testing' stamp: 'monty 3/22/2016 04:48'!
shouldInheritSelectors
	^ true! !

!DTDExternalEntityResolverTest methodsFor: 'accessing' stamp: 'monty 3/22/2016 04:39'!
entityLimitsClass
	^ DTDExternalEntityLimits! !

!DTDExternalEntityResolverTest methodsFor: 'testing' stamp: 'monty 10/4/2017 20:19'!
isTestingLimiting
	^ false! !

!DTDExternalEntityResolverTest methodsFor: 'instance creation' stamp: 'monty 3/22/2016 04:39'!
newEntityLimits
	^ self entityLimitsClass new! !

!DTDExternalEntityResolverTest methodsFor: 'instance creation' stamp: 'monty 10/4/2017 20:19'!
newResolver
	^ self isTestingLimiting
		ifTrue: [self resolverClass new asLimitingExternalEntityResolver]
		ifFalse: [self resolverClass new]! !

!DTDExternalEntityResolverTest methodsFor: 'accessing' stamp: 'monty 3/22/2016 03:51'!
resolverClass
	^ DTDExternalEntityResolver! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testCopy
	| resolver copy |

	(resolver := self newResolver)
		externalSubsetReadLimit: 1000000;
		maxExternalEntities: 10;
		maxExternalEntitySize: 10000;
		resolvesLocalFromNonLocal: true.

	copy := resolver copy.
	self
		deny: copy == resolver;
		assert: copy externalSubsetReadLimit = 1000000;
		assert: copy maxExternalEntities = 10;
		assert: copy maxExternalEntitySize = 10000;
		assert: copy resolvesLocalFromNonLocal.

	self isTestingLimiting
		ifTrue: [
			self
				assert: copy externalEntityResolver == resolver externalEntityResolver;
				assert: copy externalEntityLimits == resolver externalEntityLimits]
		ifFalse: [
			self deny: copy externalEntityLimits == resolver externalEntityLimits]! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 3/22/2016 04:41'!
testExternalEntityLimits
	| resolver newEntityLimits |

	resolver := self newResolver.
	self assert: resolver externalEntityLimits class == self entityLimitsClass.

	newEntityLimits := self newEntityLimits.
	self
		assert: (resolver externalEntityLimits: newEntityLimits) == resolver;
		assert: resolver externalEntityLimits == newEntityLimits.! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 6/26/2016 22:57'!
testExternalSubsetReadLimit
	| resolver |

	resolver := self newResolver.
	self assert:
		resolver externalSubsetReadLimit =
			DTDExternalEntityLimits defaultExternalSubsetReadLimit.
	self
		assert: (resolver externalSubsetReadLimit: 1000000) == resolver;
		assert: resolver externalSubsetReadLimit = 1000000;
		assert: (resolver externalSubsetReadLimit: nil) == resolver;
		assert: resolver externalSubsetReadLimit isNil.! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 6/26/2016 22:56'!
testMaxExternalEntities
	| resolver |

	resolver := self newResolver.
	self
		assert: resolver maxExternalEntities > 0;
		assert: (resolver maxExternalEntities: 10) == resolver;
		assert: resolver maxExternalEntities = 10;
		assert: (resolver maxExternalEntities: nil) == resolver;
		assert: resolver maxExternalEntities isNil.! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 6/26/2016 22:57'!
testMaxExternalEntitySize
	| resolver |

	resolver := self newResolver.
	self assert:
		resolver maxExternalEntitySize =
			DTDExternalEntityLimits defaultMaxExternalEntitySize.
	self
		assert: (resolver maxExternalEntitySize: 10000) == resolver;
		assert: resolver maxExternalEntitySize = 10000;
		assert: (resolver maxExternalEntitySize: nil) == resolver;
		assert: resolver maxExternalEntitySize isNil.! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 6/26/2016 22:54'!
testRemoveLimits
	| readLimit entityLimit entitySizeLimit resolver |

	readLimit := 100.
	entityLimit := 10.
	entitySizeLimit := 100.
	(resolver := self newResolver)
		externalSubsetReadLimit: readLimit;
		maxExternalEntities: entityLimit;
		maxExternalEntitySize: entitySizeLimit;
		resolvesLocalFromNonLocal: true.
	self
		assert: resolver externalSubsetReadLimit = readLimit;
		assert: resolver maxExternalEntities = entityLimit;
		assert: resolver maxExternalEntitySize = entitySizeLimit;
		assert: resolver resolvesLocalFromNonLocal.

	resolver removeLimits.
	self
		assert: resolver externalSubsetReadLimit isNil;
		assert: resolver maxExternalEntities isNil;
		assert: resolver maxExternalEntitySize isNil;
		assert: resolver resolvesLocalFromNonLocal.! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 6/26/2016 22:55'!
testResolvesLocalFromNonLocal
	| resolver |

	resolver := self newResolver.
	self
		deny: resolver resolvesLocalFromNonLocal;
		assert: (resolver resolvesLocalFromNonLocal: false) == resolver;
		deny: resolver resolvesLocalFromNonLocal;
		assert: (resolver resolvesLocalFromNonLocal: true) == resolver;
		assert: resolver resolvesLocalFromNonLocal.! !

!DTDExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testTotalResolvedExternalEntities
	| resolver |

	self isTestingLimiting
		ifFalse: [^ self].

	resolver := self newResolver.
	self assert: resolver totalResolvedExternalEntities = 0.

	resolver incrementTotalResolvedExternalEntities.
	self assert: resolver totalResolvedExternalEntities = 1.

	self assert:
		(self newResolver
			incrementTotalResolvedExternalEntities;
			totalResolvedExternalEntities) = 1.! !

DTDExternalEntityResolverTest subclass: #DTDStaticExternalEntityResolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DTD'!

DTDStaticExternalEntityResolverTest subclass: #DTDStaticExternalEntityResolverLimitingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DTD'!

!DTDStaticExternalEntityResolverLimitingTest methodsFor: 'testing' stamp: 'monty 10/4/2017 20:19'!
isTestingLimiting
	^ true! !

!DTDStaticExternalEntityResolverTest methodsFor: 'accessing' stamp: 'monty 3/22/2016 20:53'!
entityAssociations
	^ Array
		with: 'extern.dtd' -> '<!!ENTITY extern SYSTEM "extern/extern.ent">'
		with: 'extern/extern.ent' -> '<!!ENTITY extern SYSTEM "extern2.ent">'
		with: 'extern/extern2.ent' -> '<!!ELEMENT test ANY>'! !

!DTDStaticExternalEntityResolverTest methodsFor: 'accessing' stamp: 'monty 3/22/2016 21:19'!
entityDictionary
	| entities |

	entities := Dictionary new.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		entities
			at: uriString asXMLURI
			put: replacement].
	^ entities.! !

!DTDStaticExternalEntityResolverTest methodsFor: 'enumerating' stamp: 'monty 3/22/2016 20:58'!
entityURIStringsAndReplacementsDo: aBlock
	self entityAssociations do: [:each |
		aBlock
			value: each key
			value: each value]! !

!DTDStaticExternalEntityResolverTest methodsFor: 'accessing' stamp: 'monty 3/22/2016 21:20'!
newEntityReplacement
	^ '<!!--new replacement-->'! !

!DTDStaticExternalEntityResolverTest methodsFor: 'instance creation' stamp: 'monty 4/3/2016 00:52'!
newResolverWithEntities
	^ self newResolver externalEntities: self entityAssociations! !

!DTDStaticExternalEntityResolverTest methodsFor: 'accessing' stamp: 'monty 6/27/2016 04:13'!
resolverClass
	^ DTDStaticExternalEntityResolver! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testCopy
	| resolver copy |

	super testCopy.

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolverWithEntities.
	copy := resolver copy.
	self
		deny: copy == resolver;
		deny: copy externalEntities == resolver externalEntities;
		assert: copy externalEntities = resolver externalEntities.! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testExternalEntities
	| resolver replacementAssociation |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self
		assert: resolver externalEntities class == Dictionary;
		assert: resolver externalEntities isEmpty.

	resolver externalEntities: self entityAssociations.
	self assert: resolver externalEntities = self entityDictionary.

	replacementAssociation := 'new.ent' asXMLURI -> self newEntityReplacement.
	resolver externalEntities: (Array with: replacementAssociation).
	self assert: resolver externalEntities = (Dictionary with: replacementAssociation).

	resolver := self resolverClass externalEntities: self entityAssociations.
	self
		assert: resolver class == self resolverClass;
		assert: resolver externalEntities = self entityDictionary.! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testExternalEntityAtURI
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self
			assert: (resolver externalEntityAtURI: uriString) = '';
			assert: (resolver externalEntityAtURI: uriString asXMLURI) = ''.

		resolver
			externalEntityAtURI: uriString
			put: replacement.
		self
			assert: (resolver externalEntityAtURI: uriString) = replacement;
			assert: (resolver externalEntityAtURI: uriString asXMLURI) = replacement].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testExternalEntityAtURIIfAbsent
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self assert:
			(resolver
				externalEntityAtURI: uriString
				ifAbsent: [#absent]) = #absent.
		self assert:
			(resolver
				externalEntityAtURI: uriString asXMLURI
				ifAbsent: [#absent]) = #absent.

		resolver
			externalEntityAtURI: uriString
			put: replacement.
		self assert:
			(resolver
				externalEntityAtURI: uriString
				ifAbsent: [self fail]) = replacement.
		self assert:
			(resolver
				externalEntityAtURI: uriString asXMLURI
				ifAbsent: [self fail]) = replacement].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testExternalEntityAtURIIfAbsentPut
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self assert:
			(resolver
				externalEntityAtURI: uriString
				ifAbsentPut: [replacement]) = replacement.
		self assert: (resolver externalEntityAtURI: uriString) = replacement.
		self assert:
			(resolver
				externalEntityAtURI: uriString asXMLURI
				ifAbsentPut: [self fail]) = replacement.
		self assert: (resolver externalEntityAtURI: uriString) = replacement].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testExternalEntityAtURIPut
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self assert:
			(resolver
				externalEntityAtURI: uriString
				put: replacement) = replacement.
		self assert: (resolver externalEntityAtURI: uriString) = replacement.

		self assert:
			(resolver
				externalEntityAtURI: uriString asXMLURI
				put: self newEntityReplacement) = self newEntityReplacement.
		self assert:
			(resolver externalEntityAtURI: uriString asXMLURI) = self newEntityReplacement].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testHasExternalEntities
	self isTestingLimiting
		ifTrue: [^ self].

	self
		deny: self newResolver hasExternalEntities;
		assert: self newResolverWithEntities hasExternalEntities! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testIncludesExternalEntityURI
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self
			deny: (resolver includesExternalEntityURI: uriString);
			deny: (resolver includesExternalEntityURI: uriString asXMLURI).

		resolver
			externalEntityAtURI: uriString
			put: replacement.
		self
			assert: (resolver includesExternalEntityURI: uriString);
			assert: (resolver includesExternalEntityURI: uriString asXMLURI)].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testRemoveExternalEntities
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolverWithEntities.
	self
		assert: resolver removeExternalEntities == resolver;
		deny: resolver hasExternalEntities.! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testRemoveExternalEntityURI
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolverWithEntities.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self
			assert: (resolver removeExternalEntityURI: uriString) = replacement;
			deny: (resolver includesExternalEntityURI: uriString).
		self
			should: [resolver removeExternalEntityURI: uriString]
			raise: Error.
		self
			should: [resolver removeExternalEntityURI: uriString asXMLURI]
			raise: Error.].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testRemoveExternalEntityURIIfAbsent
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolverWithEntities.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self assert:
			(resolver
				removeExternalEntityURI: uriString
				ifAbsent: [self fail]) = replacement.
		self deny: (resolver includesExternalEntityURI: uriString).
		self assert:
			(resolver
				removeExternalEntityURI: uriString
				ifAbsent: [#absent]) = #absent.
		self assert:
			(resolver
				removeExternalEntityURI: uriString asXMLURI
				ifAbsent: [#absent]) = #absent].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testResolveExternalEntityURI
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement |
		self
			should: [resolver resolveExternalEntityURI: uriString]
			raise: XMLParserException.
		self
			should: [resolver resolveExternalEntityURI: uriString asXMLURI]
			raise: XMLParserException.

		resolver
			maxExternalEntitySize: replacement size;
			externalEntityAtURI: uriString
			put: replacement.
		self
			assert: (resolver resolveExternalEntityURI: uriString) = replacement;
			assert: (resolver resolveExternalEntityURI: uriString asXMLURI) = replacement.

		resolver maxExternalEntitySize: replacement size - 1.
		self
			should: [resolver resolveExternalEntityURI: uriString]
			raise: XMLLimitException.
		self
			should: [resolver resolveExternalEntityURI: uriString asXMLURI]
			raise: XMLLimitException].! !

!DTDStaticExternalEntityResolverTest methodsFor: 'tests' stamp: 'monty 10/4/2017 20:19'!
testStreamResolveExternalEntityURI
	| resolver |

	self isTestingLimiting
		ifTrue: [^ self].

	resolver := self newResolver.
	self entityURIStringsAndReplacementsDo: [:uriString :replacement | | stream |
		self
			should: [resolver streamResolveExternalEntityURI: uriString]
			raise: XMLParserException.
		self
			should: [resolver streamResolveExternalEntityURI: uriString asXMLURI]
			raise: XMLParserException.

		resolver
			maxExternalEntitySize: replacement size;
			externalEntityAtURI: uriString
			put: replacement.
		stream := resolver streamResolveExternalEntityURI: uriString.
		self
			assert: (stream isKindOf: ReadStream);
			assert: stream contents = replacement.
		stream := resolver streamResolveExternalEntityURI: uriString asXMLURI.
		self
			assert: (stream isKindOf: ReadStream);
			assert: stream contents = replacement.

		resolver maxExternalEntitySize: replacement size - 1.
		self
			should: [resolver streamResolveExternalEntityURI: uriString]
			raise: XMLLimitException.
		self
			should: [resolver streamResolveExternalEntityURI: uriString asXMLURI]
			raise: XMLLimitException].! !

TestCase subclass: #SAX2ElementHandlerParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2ElementHandlerParserTest methodsFor: 'source' stamp: 'monty 8/16/2016 03:37'!
sampleBooksXML
	^ '
		<books>
			<book>
				<title>Smalltalk-80: The Language and its Implementation</title>
				<isbn>0201113716</isbn>
				<authors>
					<author>Adele Goldberg</author>
					<author>David Robson</author>
				</authors>
			</book>
			<book>
				<title>Pharo By Example</title>
				<isbn>3952334146</isbn>
				<authors>
					<author>Andrew P. Black</author>
					<author>Stephane Ducasse</author>
					<author>Oscar Nierstrasz</author>
					<author>Damien Pollet</author>
					<author>Damien Cassou</author>
					<author>Marcus Denker</author>
				</authors>
			</book>
		</books>
	'! !

!SAX2ElementHandlerParserTest methodsFor: 'source' stamp: 'monty 8/17/2016 22:01'!
samplePersonXML
	^ '
		<person>
			<name>Tim Bray</name>
			<date-of-birth>June 21, 1955</date-of-birth>
			<contacts>
				<email address="tbray@textuality.com"/>
				<email address="tbray@tbray.org"/>
			</contacts>
			<residence>Vancouver, British Columbia, Canada</residence>
		</person>
	'! !

!SAX2ElementHandlerParserTest methodsFor: 'tests' stamp: 'monty 8/16/2016 21:24'!
testParsingSampleBooks
	"Basic factory-style parsing, with one factory for the entire document"

	| books |

	books :=
		(SAX2ElementParser on: self sampleBooksXML)
			elementHandlerFactory:
				(SAX2PluggableElementHandlerFactory new
					handleElement: 'books' withClass: SAX2HBooksElementHandler;
					handleElement: 'book' withClass: SAX2HBookElementHandler;
					handleElement: 'title' withClass: SAX2HTitleElementHandler;
					handleElement: 'isbn' withClass: SAX2HISBNElementHandler;
					handleElement: 'author' withClass: SAX2HAuthorElementHandler);
			parseDocument.

	self
		assert: books class == OrderedCollection;
		assert: books size = 2;
		assert: books first class == SAX2SampleBook;
		assert: books first title = 'Smalltalk-80: The Language and its Implementation';
		assert: books first isbn = '0201113716';
		assert: books first authors asArray = #('Adele Goldberg' 'David Robson');
		assert: books second class == SAX2SampleBook;
		assert: books second title = 'Pharo By Example';
		assert: books second isbn = '3952334146';
		assert:
			books second authors asArray =
				#('Andrew P. Black'
					'Stephane Ducasse'
					'Oscar Nierstrasz'
					'Damien Pollet'
					'Damien Cassou'
					'Marcus Denker').! !

!SAX2ElementHandlerParserTest methodsFor: 'tests' stamp: 'monty 8/17/2016 22:05'!
testParsingSamplePerson
	"FSM-style parsing, with element handlers being the states and
	the factories mapped to them being the transitions"

	| person rootFactory personFactory contactsFactory factoryMapper |

	rootFactory :=
		SAX2PluggableElementHandlerFactory new
			handleElement: 'person' withClass: SAX2HPersonElementHandler.
	personFactory :=
		SAX2PluggableElementHandlerFactory new
			handleElement: 'name' withClass: SAX2HNameElementHandler;
			handleElement: 'date-of-birth' withClass: SAX2HDateOfBirthElementHandler;
			handleElement: 'contacts' withClass: SAX2HContactsElementHandler;
			handleElement: 'residence' withClass: SAX2HResidenceElementHandler.
	contactsFactory :=
		SAX2PluggableElementHandlerFactory new
			handleElement: 'email' withClass: SAX2HEmailElementHandler.
	factoryMapper :=
		SAX2PluggableElementHandlerFactoryMapper new
			mapElementHandlerClass: SAX2HPersonElementHandler toFactory: personFactory;
			mapElementHandlerClass: SAX2HContactsElementHandler toFactory: contactsFactory.

	person :=
		(SAX2ElementParser on: self samplePersonXML)
			elementHandlerFactory: rootFactory;
			elementHandlerFactoryMapper: factoryMapper;
			parseDocument.

	self
		assert: person class == SAX2SamplePerson;
		assert: person name = 'Tim Bray';
		assert: person dateOfBirth = (Date year: 1955 month: 6 day: 21);
		assert: person emailAddresses asArray = #('tbray@textuality.com' 'tbray@tbray.org');
		assert: person residence = 'Vancouver, British Columbia, Canada'.! !

TestCase subclass: #SAX2ParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAX2ParserTest methodsFor: 'source' stamp: 'monty 7/13/2016 02:48'!
addressBookXML
	^ XMLParserTest addressBookXML! !

!SAX2ParserTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 20:58'!
contentHandlerClass
	^ SAX2ContentHandler! !

!SAX2ParserTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 20:57'!
declarationHandlerClass
	^ SAX2DeclarationHandler! !

!SAX2ParserTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 20:56'!
lexicalHandlerClass
	^ SAX2LexicalHandler! !

!SAX2ParserTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:00'!
testContentHandler
	| parser oldContentHandler newContentHandler |

	parser := SAX2Parser on: self addressBookXML.
	oldContentHandler := parser contentHandler.
	self
		assert: oldContentHandler class == self contentHandlerClass;
		assert: oldContentHandler parser == parser.

	newContentHandler := self contentHandlerClass new.
	self
		assert: (parser contentHandler: newContentHandler) == parser;
		assert: parser contentHandler == newContentHandler;
		assert: newContentHandler parser == parser;
		assert: (parser contentHandler: nil) == parser;
		assert: parser contentHandler class == self contentHandlerClass;
		assert: parser contentHandler parser == parser.! !

!SAX2ParserTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:00'!
testDeclarationHandler
	| parser oldDeclarationHandler newDeclarationHandler |

	parser := SAX2Parser on: self addressBookXML.
	oldDeclarationHandler := parser declarationHandler.
	self
		assert: oldDeclarationHandler class == self declarationHandlerClass;
		assert: oldDeclarationHandler parser == parser.

	newDeclarationHandler := self declarationHandlerClass new.
	self
		assert: (parser declarationHandler: newDeclarationHandler) == parser;
		assert: parser declarationHandler == newDeclarationHandler;
		assert: newDeclarationHandler parser == parser;
		assert: (parser declarationHandler: nil) == parser;
		assert: parser declarationHandler class == self declarationHandlerClass;
		assert: parser declarationHandler parser == parser.! !

!SAX2ParserTest methodsFor: 'tests' stamp: 'monty 8/26/2016 20:57'!
testLexicalHandler
	| parser oldLexicalHandler newLexicalHandler |

	parser := SAX2Parser on: self addressBookXML.
	oldLexicalHandler := parser lexicalHandler.
	self
		assert: oldLexicalHandler class == self lexicalHandlerClass;
		assert: oldLexicalHandler parser == parser.

	newLexicalHandler := self lexicalHandlerClass new.
	self
		assert: (parser lexicalHandler: newLexicalHandler) == parser;
		assert: parser lexicalHandler == newLexicalHandler;
		assert: newLexicalHandler parser == parser;
		assert: (parser lexicalHandler: nil) == parser;
		assert: parser lexicalHandler class == self lexicalHandlerClass;
		assert: parser lexicalHandler parser == parser.! !

!SAX2ParserTest methodsFor: 'tests' stamp: 'monty 7/13/2016 02:51'!
testParseDocument
	self
		shouldnt: [
			(SAX2Parser on: self addressBookXML)
				parseDocument]
		raise: XMLParserException! !

!SAX2ParserTest methodsFor: 'tests' stamp: 'monty 8/14/2016 18:10'!
testParsingResult
	| parser |

	parser := SAX2Parser on: self addressBookXML.
	self assert: parser parsingResult == parser.

	parser parsingResult: #result.
	self
		assert: parser parsingResult == #result;
		assert: parser parseDocument == #result.! !

TestCase subclass: #SAXHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:00'!
configurationClass
	^ XMLConfiguration! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:21'!
externalEntityResolverClass
	^ DTDCachingExternalEntityResolver! !

!SAXHandlerTest methodsFor: 'source' stamp: 'monty 6/25/2016 02:12'!
generalEntityXMLSource
	^ '
	<!!DOCTYPE root [
		<!!ENTITY % firstDeclaration "<!!ENTITY first &#39; &second; &#39;>">
		%firstDeclaration;
		<!!ENTITY second " replacement ">
	]>
	<root name="&second;">&first;</root>'! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:14'!
generalEntityXMLSourceSelectors
	^ #(startDocument
			startDTD:publicID:systemID:
			parameterEntityDeclaration:replacement:
			generalEntityDeclaration:replacement: generalEntityDeclaration:replacement:
			endDTD
			startElement:prefix:uri:localName:attributes:
			startEntity: startEntity: endEntity: endEntity: characters:
			endElement:prefix:uri:localName:
			endDocument)! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 7/1/2017 01:48'!
prefixedXMLAttributes
	^ (XMLNamespacedAttributeDictionary
		with: 'name' -> 'value'
		with: 'prefix:name' -> 'prefixValue')
			setNamespaceScope:
				(XMLNamespaceScope new
					defaultNamespace: 'defaultNS';
					mapPrefix: 'prefix' to: 'prefixNS')! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 7/1/2017 01:46'!
prefixedXMLAttributesNamespacesDisabled
	^ XMLAttributeDictionary
		with: 'xmlns:prefix' -> 'prefixNS'
		with: 'xmlns' -> 'defaultNS'
		with: 'name' -> 'value'
		with: 'prefix:name' -> 'prefixValue'! !

!SAXHandlerTest methodsFor: 'source' stamp: 'monty 7/1/2017 01:49'!
prefixedXMLSource
	^ '<prefix:test xmlns:prefix="prefixNS" xmlns="defaultNS" ',
		'name="value" prefix:name="prefixValue">',
		'test',
		'</prefix:test>'! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:41'!
prefixedXMLSourcePrefixURILocalNameSelectors
	^ #(startDocument
		startPrefixMapping:uri: startPrefixMapping:uri:
		startElement:prefix:uri:localName:attributes:
		characters:
		endElement:prefix:uri:localName:
		endPrefixMapping: endPrefixMapping:
		endDocument)! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:43'!
prefixedXMLSourcePrefixURILocalNameSelectorsNamespacesDisabled
	^ self removeNamespaceSelectorsFrom:
		self prefixedXMLSourcePrefixURILocalNameSelectors! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:42'!
prefixedXMLSourcePrefixURISelectors
	^ #(startDocument
		startPrefixMapping:uri: startPrefixMapping:uri:
		startElement:prefix:uri:attributes:
		characters:
		endElement:prefix:uri:
		endPrefixMapping: endPrefixMapping:
		endDocument)! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:42'!
prefixedXMLSourcePrefixURISelectorsNamespacesDisabled
	^ self removeNamespaceSelectorsFrom: self prefixedXMLSourcePrefixURISelectors
! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:42'!
prefixedXMLSourceSelectors
	^ #(startDocument
		startPrefixMapping:uri: startPrefixMapping:uri:
		startElement:attributes:
		characters:
		endElement:
		endPrefixMapping: endPrefixMapping:
		endDocument)! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:43'!
prefixedXMLSourceSelectorsNamespacesDisabled
	^ self removeNamespaceSelectorsFrom: self prefixedXMLSourceSelectors
! !

!SAXHandlerTest methodsFor: 'accessing' stamp: 'monty 6/25/2016 02:32'!
removeNamespaceSelectorsFrom: aSelectorCollection
	^ aSelectorCollection reject: [:each |
		#(startPrefixMapping:uri: endPrefixMapping:) includes: each]
! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 21:51'!
testCharacters
	| xml parser |

	xml :=
		'<test>one<non-empty>two</non-empty>three<!!--comment-->',
		'four<empty></empty>five<?pi pi?>six</test>'.

	(parser := SAXRecordingHandler on: xml)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				startElement:attributes:
				characters:
				startElement:attributes:
				characters:
				endElement:
				characters:
				comment:
				characters:
				startElement:attributes:
				endElement:
				characters:
				processingInstruction:data:
				characters:
				endElement:
				endDocument)).

	(parser allSentMessagesNamed: #characters:)
		with:
			#(#('one')
				#('two')
				#('three')
				#('four')
				#('five')
				#('six'))
		do: [:message :arguments |
			self assert: message arguments = arguments].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 21:20'!
testComment
	| xml parser |

	xml := '
		<!!--before DTD-->
		<!!DOCTYPE test [<!!--in DTD-->]>
		<!!--before element-->
		<test>
			<!!--in element-->
		</test>
		<!!--after element-->'.

	(parser := SAXRecordingHandler on: xml)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				comment:
				startDTD:publicID:systemID:
				comment:
				endDTD
				comment:
				startElement:attributes:
				characters:
				comment:
				characters:
				endElement:
				comment:
				endDocument)).

	(parser allSentMessagesNamed: #comment:)
		with:
			#(#('before DTD')
				#('in DTD')
				#('before element')
				#('in element')
				#('after element'))
		do: [:message :arguments |
			self assert: message arguments = arguments].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:00'!
testConfiguration
	| parser oldConfiguration newConfiguration |

	parser := SAXHandler on: self prefixedXMLSource.
	oldConfiguration := parser configuration.
	self assert: oldConfiguration class == self configurationClass.

	newConfiguration := self configurationClass new.
	self
		assert: (parser configuration: newConfiguration) == parser;
		assert: parser configuration class == self configurationClass.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:02'!
testDecodesCharacters
	| parser |

	parser := SAXHandler on: self prefixedXMLSource.
	self
		assert: parser decodesCharacters;
		assert: (parser decodesCharacters: false) == parser;
		deny: parser decodesCharacters;
		assert: (parser decodesCharacters: true) == parser;
		assert: parser decodesCharacters.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:00'!
testDocumentReadLimit
	| parser |

	parser := SAXHandler on: self prefixedXMLSource.
	self
		assert: parser documentReadLimit = XMLParserLimits defaultDocumentReadLimit;
		assert: (parser documentReadLimit: 100000) == parser;
		assert: parser documentReadLimit = 100000;
		assert: (parser documentReadLimit: nil) == parser;
		assert: parser documentReadLimit isNil.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:00'!
testDocumentURI
	| xml uri newURI parser |

	xml := self prefixedXMLSource.
	uri := 'test/test.xml'.
	newURI := 'new/new.xml'.
	parser :=
		SAXHandler
			on: xml
			documentURI: uri.
	self
		assert: parser documentURI = uri;
		assert: (parser documentURI: newURI) == parser;
		assert: parser documentURI = newURI.

	"reusing on: should clear it"
	self assert: (SAXHandler on: xml) documentURI = ''.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 21:29'!
testEndCData
	| xml parser |

	xml := '<test>one<!![CDATA[two]>]]]]>three</test>'.

	(parser := SAXRecordingHandler on: xml)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				startElement:attributes:
				characters:
				startCData
				characters:
				endCData
				characters:
				endElement:
				endDocument)).

	(parser allSentMessagesNamed: #characters:)
		with:
			#(#('one')
				#('two]>]]')
				#('three'))
		do: [:message :arguments |
			self assert: message arguments = arguments].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 22:23'!
testEndDTD
	#('<!!DOCTYPE test PUBLIC "publicID" "systemID" [<!!--comment-->]><test/>'
		'<!!DOCTYPE test SYSTEM "systemID" [<!!--comment-->]><test/>'
		'<!!DOCTYPE test [<!!--comment-->]><test/>')
		do: [:xml | | parser |
			(parser := SAXRecordingHandler on: xml)
				parseDocument.
			self assert:
				(parser wasSentSelectors:
					#(startDocument
						startDTD:publicID:systemID:
						comment:
						endDTD
						startElement:attributes:
						endElement:
						endDocument))].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 21:04'!
testEndDocument
	| saxHandler parser |

	saxHandler := SAXRecordingHandler on: '<test></test>'.
	parser := saxHandler parser.

	3 timesRepeat: [
		parser parseToken.
		self
			deny: (saxHandler wasSentSelector: #endDocument);
			deny: parser atEnd].

	parser parseToken.
	self
		assert: (saxHandler wasSentSelector: #endDocument);
		assert: parser atEnd.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:44'!
testEndElement
	| parser |

	(parser := SAXRecordingHandler on: self prefixedXMLSource)
		parseDocument.
	self
		assert: (parser wasSentSelectors: self prefixedXMLSourceSelectors);
		assert: (parser argumentsSentWith: #endElement:) = #('prefix:test').

	(parser := SAXRecordingHandler on: self prefixedXMLSource)
		usesNamespaces: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourceSelectorsNamespacesDisabled).
	self assert: (parser argumentsSentWith: #endElement:) = #('prefix:test').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:47'!
testEndElementPrefixURI
	| parser |

	(parser := SAXRecordingPrefixURIHandler on: self prefixedXMLSource)
		parseDocument.
	self assert:
		(parser wasSentSelectors: self prefixedXMLSourcePrefixURISelectors).
	self assert:
		(parser argumentsSentWith: #endElement:prefix:uri:) =
			#('prefix:test' 'prefix' 'prefixNS').

	(parser := SAXRecordingPrefixURIHandler on: self prefixedXMLSource)
		usesNamespaces: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURISelectorsNamespacesDisabled).
	self assert:
		(parser argumentsSentWith: #endElement:prefix:uri:) =
			#('prefix:test' 'prefix' '').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:49'!
testEndElementPrefixURILocalName
	| parser |

	(parser := SAXRecordingPrefixURILocalNameHandler on: self prefixedXMLSource)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURILocalNameSelectors).
	self assert:
		(parser argumentsSentWith: #endElement:prefix:uri:localName:) =
			#('prefix:test' 'prefix' 'prefixNS' 'test').

	(parser := SAXRecordingPrefixURILocalNameHandler on: self prefixedXMLSource)
		usesNamespaces: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURILocalNameSelectorsNamespacesDisabled).
	self assert:
		(parser argumentsSentWith: #endElement:prefix:uri:localName:) =
			#('prefix:test' 'prefix' '' 'test').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:15'!
testEndEntity
	| parser messages |

	(parser := SAXRecordingPrefixURILocalNameHandler on: self generalEntityXMLSource)
		parseDocument.
	self assert: (parser wasSentSelectors: self generalEntityXMLSourceSelectors).
	messages := parser allSentMessagesNamed: #endEntity:.
	self
		assert: messages first arguments = #('second');
		assert: messages second arguments = #('first').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:43'!
testEndPrefixMapping
	| parser messages |

	(parser := SAXRecordingPrefixURILocalNameHandler on: self prefixedXMLSource)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURILocalNameSelectors).
	messages := parser allSentMessagesNamed: #endPrefixMapping:.
	self
		assert: messages size = 2;
		assert: messages first arguments = #('prefix');
		assert: messages second arguments = #('').

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<one xmlns="defaultNS"><two xmlns="defaultNS"/></one>')
		parseDocument.
	messages := parser allSentMessagesNamed: #endPrefixMapping:.
	self
		assert: messages size = 1;
		assert: messages first arguments = #('').

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<one xmlns="defaultNS"><two xmlns="newDefaultNS"/></one>')
		parseDocument.
	messages := parser allSentMessagesNamed: #endPrefixMapping:.
	self
		assert: messages size = 2;
		assert: messages first arguments = #('');
		assert: messages second arguments = #('').

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<one xmlns:xml="', XMLNamespaceScope xmlNamespaceURI, '"/>')
		parseDocument.
	self assert:
		(parser allSentMessagesNamed: #endPrefixMapping:) isEmpty.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:21'!
testExternalEntityResolver
	| parser oldResolver newResolver |

	parser := SAXHandler on: self prefixedXMLSource.
	oldResolver := parser externalEntityResolver.
	self assert: oldResolver class == self externalEntityResolverClass.

	newResolver := self externalEntityResolverClass new.
	self
		assert: (parser externalEntityResolver: newResolver) == parser;
		assert: parser externalEntityResolver == newResolver.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 9/18/2017 06:04'!
testHasParser
	| parser |

	parser := SAXTestingMessageRecordingHandler on: self prefixedXMLSource.
	self deny: parser hasParser.
	parser parseDocument.

	parser hasParserResults do: [:each |
		self assert: each].

	parser on: self prefixedXMLSource.
	self deny: parser hasParser.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/24/2016 23:50'!
testIgnorableWhitespace
	| dtd xml parser |

	dtd := '
		<!!DOCTYPE one [ 
			<!!ELEMENT one (two)>
			<!!ELEMENT two (#PCDATA|three)*>
			<!!ELEMENT three ANY>
		]>'.
	xml := '
		<one>
			<two>
				test
				<three>
					test
				</three>
				test
			</two>
		</one>
	'.

	(parser := SAXRecordingPrefixURILocalNameHandler on: dtd, xml) parseDocument.
	self assert:
		(parser wasSentSelectors: 
			#(startDocument
				startDTD:publicID:systemID:
				elementDeclaration:contentModel:
				elementDeclaration:contentModel:
				elementDeclaration:contentModel:
				endDTD
				startElement:prefix:uri:localName:attributes:
				ignorableWhitespace:
				startElement:prefix:uri:localName:attributes:
				characters:
				startElement:prefix:uri:localName:attributes:
				characters:
				endElement:prefix:uri:localName:
				characters:
				endElement:prefix:uri:localName:
				ignorableWhitespace:
				endElement:prefix:uri:localName:
				endDocument)).
	(parser allSentMessagesNamed: #ignorableWhitespace:) do: [:each |
		self assert: each arguments first isXMLWhitespace].

	(parser := SAXRecordingPrefixURILocalNameHandler on: xml) parseDocument.
	self assert:
		(parser wasSentSelectors: 
			#(startDocument
				startElement:prefix:uri:localName:attributes:
				characters:
				startElement:prefix:uri:localName:attributes:
				characters:
				startElement:prefix:uri:localName:attributes:
				characters:
				endElement:prefix:uri:localName:
				characters:
				endElement:prefix:uri:localName:
				characters:
				endElement:prefix:uri:localName:
				endDocument)).

	self assert:
		(parser allSentMessagesNamed: #characters:) first arguments first isXMLWhitespace.
	self assert:
		(parser allSentMessagesNamed: #characters:) last arguments first isXMLWhitespace.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 00:14'!
testInterruptParsing
	| uniqueSelectors parser |

	uniqueSelectors := OrderedCollection new.
	self prefixedXMLSourcePrefixURILocalNameSelectors do: [:each |
		(uniqueSelectors includes: each)
			ifFalse: [uniqueSelectors addLast: each]].
	uniqueSelectors do: [:each |
		(parser :=
			SAXInterruptingRecordingPrefixURILocalNameHandler on:
				self prefixedXMLSource)
			interruptOn: each;
			parseDocument.
		self assert:
			(parser wasSentSelectors:
				((self prefixedXMLSourcePrefixURILocalNameSelectors copyUpTo: each) copyWith: each))].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 9/17/2017 10:31'!
testIsInCDataSection
	| xml parser |

	xml := '<test>one<!![CDATA[two]]>three<!![CDATA[four]]></test>'.
	parser := SAXTestingMessageRecordingHandler on: xml.
	self deny: parser isInCDataSection.
	parser parseDocument.

	parser allSentMessages
		with: parser isInCDataSectionResults
		do: [:message :result |
			((#(startCData #endCData) includes: message selector)
				or: [message selector == #characters:
					and: [#('two' 'four') includes: message arguments first]])
				ifTrue: [self assert: result]
				ifFalse: [self deny: result]].
	
	parser isInCDataSection: true.
	self assert: parser isInCDataSection.
	parser on: xml.
	self deny: parser isInCDataSection.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 9/17/2017 10:34'!
testIsInContent
	| xml parser seenElement |

	xml := '<?xml version="1.0"?>
	<!!--comment-->
	<?target data?>',
	self generalEntityXMLSource,
	'<?target data?>
	<!!--comment-->'.
	parser := SAXTestingMessageRecordingHandler on: xml.
	self deny: parser isInContent.
	parser parseDocument.

	seenElement := false.
	parser allSentSelectors
		with: parser isInContentResults
		do: [:selector :result |
			(seenElement
				or: [seenElement := selector asString beginsWith: 'startElement'])
				ifTrue: [self assert: result]
				ifFalse: [self deny: result]].
	
	self assert: parser isInContent.
	parser on: xml.
	self deny: parser isInContent.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:02'!
testIsValidating
	| parser |

	parser := SAXHandler on: self prefixedXMLSource.
	self
		assert: parser isValidating;
		assert: (parser isValidating: false) == parser;
		deny: parser isValidating;
		assert: (parser isValidating: true) == parser;
		assert: parser isValidating.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:04'!
testMaxEntityReplacementDepth
	| parser |

	parser := SAXHandler on: ''.
	self assert:
		parser maxEntityReplacementDepth =
			XMLParserLimits defaultMaxEntityReplacementDepth.
	self
		assert: (parser maxEntityReplacementDepth: 20) == parser;
		assert: parser maxEntityReplacementDepth = 20;
		assert: (parser maxEntityReplacementDepth: nil) == parser;
		assert: parser maxEntityReplacementDepth isNil.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 05:56'!
testOn
	| parser oldConfiguraiton |

	parser :=
		SAXHandler
			on: self prefixedXMLSource
			documentURI: 'oldURI'.
	oldConfiguraiton := parser configuration.
	parser parseDocument.
	self
		assert: (parser on: self generalEntityXMLSource) == parser;
		assert: parser input = self generalEntityXMLSource;
		deny: parser documentURI = 'oldURI';
		deny: parser configuration == oldConfiguraiton.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:04'!
testOptimizeForLargeDocuments
	| parser |

	parser := SAXHandler on: ''.

	parser optimizeForLargeDocuments.
	self
		deny: parser isValidating;
		deny: parser usesNamespaces;
		assert: parser documentReadLimit isNil.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 06:25'!
testPreservesUndeclaredEntityReferences
	| parser |

	parser := SAXHandler on: ''.
	self deny: parser preservesUndeclaredEntityReferences.

	"enabling should disable validation"
	self
		assert: (parser preservesUndeclaredEntityReferences: true) == parser;
		assert: parser preservesUndeclaredEntityReferences;
		deny: parser isValidating.

	self
		assert: (parser isValidating: true) == parser;
		assert: parser isValidating;
		deny: parser preservesUndeclaredEntityReferences.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 21:24'!
testProcessingInstructionData
	| xml parser |

	xml := '
		<?before DTD?>
		<!!DOCTYPE test [<?in DTD?>]>
		<?before element?>
		<test>
			<?in element?>
		</test>
		<?after element?>'.

	(parser := SAXRecordingHandler on: xml)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				processingInstruction:data:
				startDTD:publicID:systemID:
				processingInstruction:data:
				endDTD
				processingInstruction:data:
				startElement:attributes:
				characters:
				processingInstruction:data:
				characters:
				endElement:
				processingInstruction:data:
				endDocument)).

	(parser allSentMessagesNamed: #processingInstruction:data:)
		with:
			#(#('before' 'DTD')
				#('in' 'DTD')
				#('before' 'element')
				#('in' 'element')
				#('after' 'element'))
		do: [:message :arguments |
			self assert: message arguments = arguments].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 06:03'!
testRemoveLimits
	| parser readLimit depthLimit |

	readLimit := 100.
	depthLimit := 5.
	(parser := SAXHandler on: '')
		documentReadLimit: readLimit;
		maxEntityReplacementDepth: depthLimit.
	self
		assert: parser documentReadLimit = readLimit;
		assert: parser maxEntityReplacementDepth = depthLimit.

	self
		assert: parser removeLimits == parser;
		assert: parser documentReadLimit isNil;
		assert: parser maxEntityReplacementDepth isNil.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:06'!
testReplacesContentEntityReferences
	| parser |

	parser := SAXHandler on: self prefixedXMLSource.
	self
		assert: parser replacesContentEntityReferences;
		assert: (parser replacesContentEntityReferences: false) == parser;
		deny: parser replacesContentEntityReferences;
		assert: (parser replacesContentEntityReferences: true) == parser;
		assert: parser replacesContentEntityReferences.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 06:25'!
testRequiresDocumentConstraints
	| parser |

	(parser := SAXHandler on: '') isValidating: false.
	self deny: parser requiresDocumentConstraints.

	"enabling should force validation"
	self
		assert: (parser requiresDocumentConstraints: true) == parser;
		assert: parser requiresDocumentConstraints;
		assert: parser isValidating.

	self
		assert: (parser isValidating: false) == parser;
		deny: parser isValidating;
		deny: parser requiresDocumentConstraints.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:07'!
testResolvesExternalEntities
	| parser |

	parser := SAXHandler on: self prefixedXMLSource.
	"should not resolve external entities by default for security"
	self
		deny: parser resolvesExternalEntities;
		assert: (parser resolvesExternalEntities: true) == parser;
		assert: parser resolvesExternalEntities;
		assert: (parser resolvesExternalEntities: false) == parser;
		deny: parser resolvesExternalEntities.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 11/4/2016 01:26'!
testSkippedEntity
	| xml parser |

	xml := '<!!DOCTYPE root SYSTEM "extern.dtd"><root>&undeclared;</root>'.
	(parser := SAXRecordingPrefixURILocalNameHandler on: xml)
		isValidating: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors: 
			#(startDocument
				startDTD:publicID:systemID:
				endDTD
				startElement:prefix:uri:localName:attributes:
				skippedEntity:
				endElement:prefix:uri:localName:
				endDocument)).
	self assert: (parser argumentsSentWith: #skippedEntity:) = #('undeclared').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 11/4/2016 01:27'!
testSkippedEntityUndeclaredPreserved
	| xml parser |

	xml := '<!!DOCTYPE root SYSTEM "extern.dtd"><root>&undeclared;</root>'.
	(parser := SAXRecordingPrefixURILocalNameHandler on: xml)
		isValidating: false;
		preservesUndeclaredEntityReferences: true;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				startDTD:publicID:systemID:
				endDTD
				startElement:prefix:uri:localName:attributes:
				skippedEntity:
				characters:
				endElement:prefix:uri:localName:
				endDocument)).
	self
		assert: (parser argumentsSentWith: #skippedEntity:) = #('undeclared');
		assert: (parser argumentsSentWith: #characters:) = #('&undeclared;').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:25'!
testSkippedEntityUnreplaced
	| xml parser |

	xml := '<!!DOCTYPE root [<!!ENTITY declared "replacement">]><root>&declared;</root>'.
	(parser := SAXRecordingPrefixURILocalNameHandler on: xml)
		isValidating: true;
		replacesContentEntityReferences: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				startDTD:publicID:systemID:
				generalEntityDeclaration:replacement:
				endDTD
				startElement:prefix:uri:localName:attributes:
				skippedEntity:
				characters:
				endElement:prefix:uri:localName:
				endDocument)).
	self
		assert: (parser argumentsSentWith: #skippedEntity:) = #('declared');
		assert: (parser argumentsSentWith: #characters:) = #('&declared;').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 21:28'!
testStartCData
	| xml parser |

	xml := '<test>one<!![CDATA[<!![CDATA[two]]>three</test>'.

	(parser := SAXRecordingHandler on: xml)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			#(startDocument
				startElement:attributes:
				characters:
				startCData
				characters:
				endCData
				characters:
				endElement:
				endDocument)).

	(parser allSentMessagesNamed: #characters:)
		with:
			#(#('one')
				#('<!![CDATA[two')
				#('three'))
		do: [:message :arguments |
			self assert: message arguments = arguments].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 22:21'!
testStartDTDPublicIDSystemID
	#('<!!DOCTYPE test PUBLIC "publicID" "systemID"><test/>'
		'<!!DOCTYPE test SYSTEM "systemID"><test/>'
		'<!!DOCTYPE test><test/>')
		with:
			#(#('test' 'publicID' 'systemID')
				#('test' '' 'systemID')
				#('test' '' ''))
		do: [:xml :arguments | | parser |
			(parser := SAXRecordingHandler on: xml)
				parseDocument.
			self assert:
				(parser wasSentSelectors:
					#(startDocument
						startDTD:publicID:systemID:
						endDTD
						startElement:attributes:
						endElement:
						endDocument)).

			self assert:
				(parser argumentsSentWith: #startDTD:publicID:systemID:) =
					arguments].! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/27/2016 21:05'!
testStartDocument
	| saxHandler parser |

	saxHandler := SAXRecordingHandler on: '<test></test>'.
	parser := saxHandler parser.
	self deny: (saxHandler wasSentSelector: #startDocument).
	parser parseToken.
	self assert: (saxHandler wasSentSelector: #startDocument).! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:55'!
testStartElementAttributes
	| parser arguments |

	(parser := SAXRecordingHandler on: self prefixedXMLSource)
		parseDocument.
	self assert: (parser wasSentSelectors: self prefixedXMLSourceSelectors).
	arguments := parser argumentsSentWith: #startElement:attributes:.
	self
		assert: arguments size = 2;
		assert: arguments first = 'prefix:test';
		assert: arguments second = self prefixedXMLAttributes.

	(parser := SAXRecordingHandler on: self prefixedXMLSource)
		usesNamespaces: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourceSelectorsNamespacesDisabled).
	arguments := parser argumentsSentWith: #startElement:attributes:.
	self
		assert: arguments size = 2;
		assert: arguments first = 'prefix:test';
		assert: arguments second = self prefixedXMLAttributesNamespacesDisabled.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:56'!
testStartElementPrefixURIAttributes
	| parser arguments |

	(parser := SAXRecordingPrefixURIHandler on: self prefixedXMLSource)
		parseDocument.
	self assert:
		(parser wasSentSelectors: self prefixedXMLSourcePrefixURISelectors).
	arguments := parser argumentsSentWith: #startElement:prefix:uri:attributes:.
	self
		assert: arguments size = 4;
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third = 'prefixNS';
		assert: arguments fourth = self prefixedXMLAttributes.

	(parser := SAXRecordingPrefixURIHandler on: self prefixedXMLSource)
		usesNamespaces: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURISelectorsNamespacesDisabled).
	arguments := parser argumentsSentWith: #startElement:prefix:uri:attributes:.
	self
		assert: arguments size = 4;
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third = '';
		assert: arguments fourth = self prefixedXMLAttributesNamespacesDisabled.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:58'!
testStartElementPrefixURILocalNameAttributes
	| parser arguments |

	(parser := SAXRecordingPrefixURILocalNameHandler on: self prefixedXMLSource)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURILocalNameSelectors).
	arguments :=
		parser argumentsSentWith: #startElement:prefix:uri:localName:attributes:.
	self
		assert: arguments size = 5;
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third = 'prefixNS';
		assert: arguments fourth = 'test';
		assert: arguments fifth = self prefixedXMLAttributes.

	(parser := SAXRecordingPrefixURILocalNameHandler on: self prefixedXMLSource)
		usesNamespaces: false;
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURILocalNameSelectorsNamespacesDisabled).
	arguments :=
		parser argumentsSentWith: #startElement:prefix:uri:localName:attributes:.
	self
		assert: arguments size = 5;
		assert: arguments first = 'prefix:test';
		assert: arguments second = 'prefix';
		assert: arguments third = '';
		assert: arguments fourth = 'test';
		assert: arguments fifth = self prefixedXMLAttributesNamespacesDisabled.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 02:15'!
testStartEntity
	| parser messages |

	(parser := SAXRecordingPrefixURILocalNameHandler on: self generalEntityXMLSource)
		parseDocument.
	self assert: (parser wasSentSelectors: self generalEntityXMLSourceSelectors).
	messages := parser allSentMessagesNamed: #startEntity:.
	self
		assert: messages first arguments = #('first');
		assert: messages second arguments = #('second').! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/25/2016 03:05'!
testStartPrefixMappingURI
	| parser messages |

	(parser := SAXRecordingPrefixURILocalNameHandler on: self prefixedXMLSource)
		parseDocument.
	self assert:
		(parser wasSentSelectors:
			self prefixedXMLSourcePrefixURILocalNameSelectors).
	messages := parser allSentMessagesNamed: #startPrefixMapping:uri:.
	self
		assert: messages size = 2;
		assert: messages first arguments = #('prefix' 'prefixNS');
		assert: messages second arguments = #('' 'defaultNS').

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<one xmlns="defaultNS"><two xmlns="defaultNS"/></one>')
		parseDocument.
	messages := parser allSentMessagesNamed: #startPrefixMapping:uri:.
	self
		assert: messages size = 1;
		assert: messages first arguments = #('' 'defaultNS').

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<one xmlns="defaultNS"><two xmlns="newDefaultNS"/></one>')
		parseDocument.
	messages := parser allSentMessagesNamed: #startPrefixMapping:uri:.
	self
		assert: messages size = 2;
		assert: messages first arguments = #('' 'defaultNS');
		assert: messages second arguments = #('' 'newDefaultNS').

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<one xmlns:xml="', XMLNamespaceScope xmlNamespaceURI, '"/>')
		parseDocument.
	self assert:
		(parser allSentMessagesNamed: #startPrefixMapping:uri:) isEmpty.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/26/2016 23:07'!
testUsesNamespaces
	| parser |

	parser := SAXHandler on: self prefixedXMLSource.
	self
		assert: parser usesNamespaces;
		assert: (parser usesNamespaces: false) == parser;
		deny: parser usesNamespaces;
		assert: (parser usesNamespaces: true) == parser;
		assert: parser usesNamespaces.! !

!SAXHandlerTest methodsFor: 'tests' stamp: 'monty 6/24/2016 23:50'!
testXMLVersionEncodingStandalone
	| parser selectors arguments |

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<?xml version="1.0" encoding="UTF-8"?><test/>')
		parseDocument.
	selectors :=
		#(startDocument
			xmlVersion:encoding:standalone:
			startElement:prefix:uri:localName:attributes:
			endElement:prefix:uri:localName:
			endDocument).
	self assert: (parser wasSentSelectors: selectors).

	arguments := parser argumentsSentWith: #xmlVersion:encoding:standalone:.
	self
		assert: arguments first = 1.0;
		assert: arguments second = 'UTF-8';
		deny: arguments third.

	(parser :=
		SAXRecordingPrefixURILocalNameHandler on:
			'<?xml version="1.1" encoding="utf-8" standalone="yes"?><test/>')
		parseDocument.
	self assert: (parser wasSentSelectors: selectors).

	arguments := (parser argumentsSentWith: #xmlVersion:encoding:standalone:).
	self
		assert: arguments first = 1.1;
		assert: arguments second = 'utf-8';
		assert: arguments third.! !

TestCase subclass: #XMLAbstractSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLAbstractSetTest commentStamp: 'monty 3/29/2016 07:55' prior: 0!
An abstract and portable test case for sets.!

!XMLAbstractSetTest class methodsFor: 'testing' stamp: 'monty 3/29/2016 07:41'!
isAbstract
	^ true! !

!XMLAbstractSetTest class methodsFor: 'testing' stamp: 'monty 3/29/2016 07:41'!
shouldInheritSelectors
	^ true! !

!XMLAbstractSetTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:32'!
absentSetElement
	self subclassResponsibility! !

!XMLAbstractSetTest methodsFor: 'asserting' stamp: 'monty 3/29/2016 07:52'!
assertSet: aFirstSet equals: aSecondSet
	self
		assert: aFirstSet = aSecondSet;
		assert: aSecondSet = aFirstSet! !

!XMLAbstractSetTest methodsFor: 'asserting' stamp: 'monty 3/29/2016 07:41'!
denySet: aFirstSet equals: aSecondSet
	self
		deny: aFirstSet = aSecondSet;
		deny: aFirstSet == aSecondSet;
		deny: aSecondSet = aFirstSet;
		deny: aSecondSet == aFirstSet! !

!XMLAbstractSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 08:00'!
disjointSetElements
	self subclassResponsibility! !

!XMLAbstractSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 07:51'!
emptySet
	^ self setClass new! !

!XMLAbstractSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 07:46'!
setClass
	self subclassResponsibility! !

!XMLAbstractSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 08:01'!
setElements
	self subclassResponsibility! !

!XMLAbstractSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 08:00'!
setWithDisjointElements
	^ self setClass newFrom: self disjointSetElements! !

!XMLAbstractSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 07:52'!
setWithElements
	^ self setClass newFrom: self setElements! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:45'!
testAdd
	| set |

	set := self emptySet.
	self setElements do: [:each |
		self
			assert: (set add: each) == each;
			assert: (set includes: each)].
	self
		assert: set = self setWithElements;
		assert: (self setElements allSatisfy: [:each | (set add: each) == each]);
		assert: set = self setWithElements.! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 08:00'!
testConcatenation
	| firstSet secondSet |

	firstSet := self setWithElements.
	self assert: (firstSet, self setWithElements) = self setWithElements.

	secondSet := self setWithDisjointElements.	
	self
		assert: (firstSet, secondSet) = (secondSet, firstSet);
		deny: (firstSet, secondSet) = firstSet;
		deny: (firstSet, secondSet) = secondSet;
		assert:
			(firstSet, secondSet) =
				(self setClass newFrom: self setElements, self disjointSetElements).! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 08:07'!
testCopy
	| set copy |

	set := self setWithElements.
	copy := set copy.
	self
		assert: set = copy;
		deny: set == copy.

	set addAll: self disjointSetElements.
	self deny: set = copy.

	copy addAll: self disjointSetElements.
	self assert: set = copy.! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:45'!
testDo
	| enumerated |

	enumerated := OrderedCollection new.
	self emptySet do: [:each | enumerated addLast: each].
	self assert: enumerated size = 0.

	self setWithElements do: [:each | enumerated addLast: each].
	self
		assert: enumerated size = self setElements size;
		assert: (self setElements allSatisfy: [:each | enumerated includes: each]).! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:43'!
testEquals
	| set |

	set := self emptySet.
	self
		assertSet: set equals: self emptySet;
		denySet: set equals: self setWithElements;
		denySet: set equals: self setWithDisjointElements.

	set := self setWithElements.
	self
		assertSet: set equals: self setWithElements;
		denySet: set equals: self setWithDisjointElements.

	set := self setWithDisjointElements.
	self assertSet: set equals: self setWithDisjointElements.! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 08:00'!
testIncludes
	| set |

	set := self emptySet.
	self deny: (self setElements anySatisfy: [:each | set includes: each]).

	set := self setWithElements.
	self assert: (self setElements allSatisfy: [:each | set includes: each]).
	self deny: (self disjointSetElements anySatisfy: [:each | set includes: each]).

	set := self setWithDisjointElements.
	self assert: (self disjointSetElements allSatisfy: [:each | set includes: each]).! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:55'!
testNewFrom
	self assert: (self setClass newFrom: self setElements) = self setWithElements! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:43'!
testRemoveAll
	| set |

	set := self setWithElements.
	self
		assert: set removeAll == set;
		assert: set isEmpty.! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:08'!
testRemoveIfAbsent
	| set |

	set := self setWithElements.
	self setElements do: [:each |
		self assert:
			(set
				remove: each
				ifAbsent: [self fail]) == each.
		self deny: (set includes: each).
		self
			assert:
				(set
					remove: each
					ifAbsent: [self absentSetElement]) == self absentSetElement.
		self
			should: [set remove: each]
			raise: Error].
	self assert: set isEmpty.! !

!XMLAbstractSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:45'!
testSize
	| set size |

	set := self emptySet.
	size := 0.
	self assert: set size = size.
	self setElements do: [:each |
		set add: each.
		size := size + 1.
		self assert: set size = size].! !

XMLAbstractSetTest subclass: #XMLNFAStateSetTest
	instanceVariableNames: 'states disjointStates absentState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Validation-DFA'!

!XMLNFAStateSetTest class methodsFor: 'testing' stamp: 'monty 3/29/2016 08:02'!
isAbstract
	^ false! !

!XMLNFAStateSetTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:32'!
absentSetElement
	^ absentState
		ifNil: [absentState := XMLNFAMatchingState matcher: 'absent']! !

!XMLNFAStateSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 08:00'!
disjointSetElements
	disjointStates
		ifNil: [
			disjointStates :=
				Array
					with: (XMLNFAMatchingState matcher: 'three')
					with: (XMLNFAMatchingState matcher: 'four')].
	^ disjointStates copy.! !

!XMLNFAStateSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 07:07'!
setClass
	^ XMLNFAStateSet! !

!XMLNFAStateSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 08:29'!
setElements
	states
		ifNil: [
			states :=
				Array
					with: (XMLNFAMatchingState matcher: 'one')
					with: XMLNFAAcceptingState new
					with: (XMLNFAMatchingState matcher: 'two')
					with: XMLNFAAcceptingState new].
	^ states copy.! !

!XMLNFAStateSetTest methodsFor: 'tests' stamp: 'monty 8/8/2016 19:28'!
testIsAccepting
	| set isAccepting lastAccepting |

	set := self emptySet.
	isAccepting := false.
	self deny: set isAccepting.
	self setElements do: [:each |
		set add: each.
		each isAccepting
			ifTrue: [
				isAccepting := true.
				lastAccepting := each].
		self assert: set isAccepting = isAccepting].
	self assert: set isAccepting.

	self setElements do: [:each |
		set remove: each.
		(set includes: lastAccepting)
			ifTrue: [self assert: set isAccepting]
			ifFalse: [self deny: set isAccepting]].
	self deny: set isAccepting.

	self deny:
		(self setWithElements
			removeAll;
			isAccepting).! !

TestCase subclass: #XMLAttributeSpecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Utils'!

!XMLAttributeSpecTest class methodsFor: 'testing' stamp: 'monty 8/2/2016 08:47'!
shouldInheritSelectors
	^ true! !

!XMLAttributeSpecTest methodsFor: 'accessing' stamp: 'monty 8/2/2016 08:45'!
attributeSpecClass
	^ XMLAttributeSpec! !

!XMLAttributeSpecTest methodsFor: 'instance creation' stamp: 'monty 8/2/2016 08:47'!
newAttributeSpec
	^ self attributeSpecClass new! !

!XMLAttributeSpecTest methodsFor: 'tests' stamp: 'monty 8/2/2016 08:47'!
testAsXMLAttributeSpec
	| attributeSpec |

	attributeSpec := self newAttributeSpec.
	self assert: attributeSpec asXMLAttributeSpec == attributeSpec.! !

XMLAttributeSpecTest subclass: #XMLBasicAttributeSpecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Utils'!

!XMLBasicAttributeSpecTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 02:16'!
attributeSpecClass
	^ XMLBasicAttributeSpec! !

!XMLBasicAttributeSpecTest methodsFor: 'tests' stamp: 'monty 10/2/2017 13:38'!
testMatchesAttributes
	| attributeSpec |

	attributeSpec := #() asXMLAttributeSpec.
	self assert: (attributeSpec matchesAttributes: XMLAttributeDictionary new).
	self assert:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name' -> 'value')).

	attributeSpec := (Array with: 'name' -> 'value') asXMLAttributeSpec.
	self deny: (attributeSpec matchesAttributes: XMLAttributeDictionary new).
	self deny:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name' -> 'value2')).
	self deny:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name2' -> 'value')).
	self assert:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name' -> 'value')).

	attributeSpec :=
		(Array with: 'name' -> 'value' with: 'name2') asXMLAttributeSpec.
	self deny: (attributeSpec matchesAttributes: XMLAttributeDictionary new).
	self deny:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name' -> 'value2')).
	self deny:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name2' -> 'value')).
	self deny:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary
				with: 'name' -> 'value2'
				with: 'name2' -> 'value')).
	self assert:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary
				with: 'name' -> 'value'
				with: 'name2' -> 'value2')).
	self assert:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary
				with: 'name' -> 'value'
				with: 'name2' -> 'value2'
				with: 'name3' -> 'value3')).

	attributeSpec :=
		(Array with: 'name3' -> [:value | value endsWith: '3']) asXMLAttributeSpec.
	self deny: (attributeSpec matchesAttributes: XMLAttributeDictionary new).
	self deny:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name3' -> 'value2')).
	self assert:
		(attributeSpec matchesAttributes:
			(XMLAttributeDictionary with: 'name3' -> 'value3')).! !

TestCase subclass: #XMLCharacterMethodsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:19'!
allChars
	"to conserve memory, do not persistently cache this"
	^ BitmapCharacterSet fromXMLBNF:
		'#x9 | #xA | #xD | [#x20-#xD7FF] | [#xE000-#xFFFD] | [#x10000-#x10FFFF]'! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:19'!
allNameChars
	"to conserve memory, do not persistently cache this"
	^ self allNameStartChars,
		(BitmapCharacterSet fromXMLBNF:
			'"-" | "." | [0-9] | #xB7 | [#x0300-#x036F] | [#x203F-#x2040]')! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:19'!
allNameStartChars
	"to conserve memory, do not persistently cache this"
	^ BitmapCharacterSet fromXMLBNF:
		'":" | [A-Z] | "_" | [a-z] | [#xC0-#xD6] | [#xD8-#xF6] |
		[#xF8-#x2FF] | [#x370-#x37D] | [#x37F-#x1FFF] | [#x200C-#x200D] |
		[#x2070-#x218F] | [#x2C00-#x2FEF] | [#x3001-#xD7FF] |
		[#xF900-#xFDCF] | [#xFDF0-#xFFFD] | [#x10000-#xEFFFF]'! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:19'!
allNonChars
	"to conserve memory, do not persistently cache this"
	^ self allChars complement! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:19'!
allNonNameChars
	"to conserve memory, do not persistently cache this"
	^ self allNameChars complement! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:19'!
allNonNameStartCharNameChars
	"to conserve memory, do not persistently cache this"
	^ (BitmapCharacterSet fromXMLBNF:
		'"-" | "." | [0-9] | #xB7 | [#x0300-#x036F] | [#x203F-#x2040]')! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:19'!
allNonNameStartChars
	"to conserve memory, do not persistently cache this"
	^ self allNameStartChars complement! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 00:06'!
nonChars
	"These values are a limited selection from #allNonChars, including the
	start and end of each char range (used for performance)"
	^ #(16r1 16r2 16r3 16r4 16r5 16r6 16r7 16r8
			16rB 16rC 16rE 16rF
			16r10 16r11 16r12 16r13 16r14 16r15 16r16 16r17 16r18 16r19
			16r1A 16r1B 16r1C 16r1D 16r1E 16r1F
			16rD800 16rDFFF
			16rFFFE 16rFFFF)
			collect: [:each | each asCharacter]! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:46'!
nonNameChars
	"These are a limited selection of values from #allNonNameChars, including
	the start and end of each char range (used for performance)"
	^ #(16r01 16r0F 16r10
			16r2C 16r2F 16r3B
			16r40 16r5B 16r5E
			16r60 16r7B 16r80
			16rB6 16rB8 16rBF
			16rD7 16rF7 16r37E
			16r2000 16r200B 16r200E 16r206F
			16r2190 16r2BFF 16r2FFF 16r3000
			16rD800 16rF8FF 16rFDD0 16rFDEF
			16rFFFE 16r0FFFF 16rF0000 16r10FFFF)
			collect: [:each | each asCharacter]! !

!XMLCharacterMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 03:46'!
nonNameStartCharNameChars
	"These are a limited selection of values from #allNonNameStartCharNameChars,
	including the start and end of each char range (used for performance)"
	^ #($- $.
			$0 $1 $2 $3 $4 $5 $6 $7 $8 $9
			16rB7 16r0300 16r036F 16r203F 16r2040)
			collect: [:each | each asCharacter]! !

!XMLCharacterMethodsTest methodsFor: 'accessing' stamp: 'monty 5/5/2017 23:30'!
allChars
	^ self class allChars! !

!XMLCharacterMethodsTest methodsFor: 'accessing' stamp: 'monty 5/5/2017 23:31'!
allNameChars
	^ self class allNameChars! !

!XMLCharacterMethodsTest methodsFor: 'accessing' stamp: 'monty 5/5/2017 23:35'!
allNameStartChars
	^ self class allNameStartChars! !

!XMLCharacterMethodsTest methodsFor: 'accessing' stamp: 'monty 5/5/2017 23:30'!
allNonChars
	^ self class allNonChars! !

!XMLCharacterMethodsTest methodsFor: 'accessing' stamp: 'monty 5/5/2017 23:31'!
allNonNameChars
	^ self class allNonNameChars! !

!XMLCharacterMethodsTest methodsFor: 'accessing' stamp: 'monty 5/5/2017 23:33'!
allNonNameStartCharNameChars
	^ self class allNonNameStartCharNameChars! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 5/5/2017 23:41'!
testIsXMLChar
	self allChars do: [:each |
		self assert: each isXMLChar].
	self allNonChars do: [:each |
		self deny: each isXMLChar].
	self deny: nil isXMLChar.! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 5/5/2017 23:41'!
testIsXMLNCNameChar
	self allNameChars do: [:each |
		each == $:
			ifTrue: [self deny: each isXMLNCNameChar]
			ifFalse: [self assert: each isXMLNCNameChar]].
	self allNonNameChars do: [:each |
		self deny: each isXMLNCNameChar].
	self deny: nil isXMLNCNameChar.! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 5/5/2017 23:41'!
testIsXMLNCNameStartChar
	self allNameStartChars do: [:each |
		each == $:
			ifTrue: [self deny: each isXMLNCNameStartChar]
			ifFalse: [self assert: each isXMLNCNameStartChar]].
	self allNonNameChars do: [:each |
		self deny: each isXMLNCNameStartChar].
	self allNonNameStartCharNameChars do: [:each |
		self deny: each isXMLNCNameStartChar].
	self deny: nil isXMLNCNameStartChar.! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 5/5/2017 23:42'!
testIsXMLNameChar
	self allNameChars do: [:each |
		self assert: each isXMLNameChar].
	self allNonNameChars do: [:each |
		self deny: each isXMLNameChar].
	self deny: nil isXMLNameChar.! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 5/5/2017 23:42'!
testIsXMLNameStartChar
	self allNameStartChars do: [:each |
		self assert: each isXMLNameStartChar].
	self allNonNameChars do: [:each |
		self deny: each isXMLNameStartChar].
	self allNonNameStartCharNameChars do: [:each |
		self deny: each isXMLNameStartChar].
	self deny: nil isXMLNameStartChar.! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 5/5/2017 23:46'!
testIsXMLSeparator
	| separators |

	separators := BitmapCharacterSet newFrom: Character xmlSeparators.
	separators do: [:each |
		self assert: each isXMLSeparator].
	separators complement do: [:each |
		self deny: each isXMLSeparator].
	self deny: nil isXMLSeparator.! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 5/5/2017 23:46'!
testIsXMLWhitespace
	| whitespace |

	whitespace := BitmapCharacterSet newFrom: Character xmlWhitespace.
	whitespace do: [:each |
		self assert: each isXMLWhitespace].
	whitespace complement do: [:each |
		self deny: each isXMLWhitespace].
	self deny: nil isXMLWhitespace.! !

!XMLCharacterMethodsTest methodsFor: 'tests' stamp: 'monty 3/14/2016 00:25'!
testXMLSplit
	self
		assert: ($: xmlSplit: '') = (OrderedCollection with: '');
		assert: ($: xmlSplit: 'abc') = (OrderedCollection with: 'abc');
		assert: ($: xmlSplit: ':') = #('' '') asOrderedCollection;
		assert: ($: xmlSplit: '::') = #('' '' '') asOrderedCollection;
		assert: ($: xmlSplit: 'a:bc:') = #('a' 'bc' '') asOrderedCollection;
		assert: ($: xmlSplit: ':ab:c:') = #('' 'ab' 'c' '') asOrderedCollection;
		assert: ($: xmlSplit: 'a:bc:') = #('a' 'bc' '') asOrderedCollection;
		assert: ($: xmlSplit: 'ab::cd::ef') = #('ab'  '' 'cd' '' 'ef') asOrderedCollection;
		assert:
			($: xmlSplit: '::ab:::cd:::ef::') =
				#('' '' 'ab'  '' '' 'cd' '' '' 'ef' '' '') asOrderedCollection! !

TestCase subclass: #XMLClassFinderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Utils'!

!XMLClassFinderTest methodsFor: 'accessing' stamp: 'monty 9/27/2016 13:18'!
absentClassName
	^ (self presentClassName asString, 'ShouldNotBePresent') asString! !

!XMLClassFinderTest methodsFor: 'accessing' stamp: 'monty 9/27/2016 13:17'!
classFinder
	^ XMLClassFinder! !

!XMLClassFinderTest methodsFor: 'accessing' stamp: 'monty 9/27/2016 13:19'!
presentClass
	^ self class! !

!XMLClassFinderTest methodsFor: 'accessing' stamp: 'monty 9/27/2016 13:18'!
presentClassName
	^ self class name asSymbol! !

!XMLClassFinderTest methodsFor: 'tests' stamp: 'monty 9/27/2016 13:20'!
testClassNamed
	self assert:
		(self classFinder classNamed: self presentClassName) ==
			self presentClass.
	self assert: (self classFinder classNamed: self absentClassName) isNil.! !

!XMLClassFinderTest methodsFor: 'tests' stamp: 'monty 9/27/2016 13:20'!
testClassNamedIfAbsent
	self assert:
		(self classFinder
			classNamed: self presentClassName
			ifAbsent: [self fail]) == self presentClass.
	self assert:
		(self classFinder
			classNamed: self absentClassName
			ifAbsent: [#absent]) = #absent.! !

!XMLClassFinderTest methodsFor: 'tests' stamp: 'monty 10/20/2016 02:18'!
testClassNamedIfPresent
	self assert:
		(self classFinder
			classNamed: self presentClassName
			ifPresent: [:presentClass | #present -> presentClass]) =
				(#present -> self presentClass).
	"ensure cull: is used"
	self assert:
		(self classFinder
			classNamed: self presentClassName
			ifPresent: [#present]) = #present.
	self assert:
		(self classFinder
			classNamed: self absentClassName
			ifPresent: [self fail]) isNil.! !

!XMLClassFinderTest methodsFor: 'tests' stamp: 'monty 9/27/2016 13:21'!
testHasClassNamed
	self
		assert: (self classFinder hasClassNamed: self presentClassName);
		deny: (self classFinder hasClassNamed: self absentClassName)! !

TestCase subclass: #XMLConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLConfigurationTest class methodsFor: 'testing' stamp: 'monty 9/21/2016 00:34'!
shouldInheritSelectors
	^ true! !

!XMLConfigurationTest methodsFor: 'accessing' stamp: 'monty 9/21/2016 00:16'!
configurationClass
	^ XMLConfiguration! !

!XMLConfigurationTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 15:22'!
externalEntityResolverClass
	^ DTDCachingExternalEntityResolver! !

!XMLConfigurationTest methodsFor: 'instance creation' stamp: 'monty 9/21/2016 00:17'!
newConfiguration
	^ self configurationClass new! !

!XMLConfigurationTest methodsFor: 'accessing' stamp: 'monty 9/21/2016 09:39'!
otherParserHandlerClass
	^ SAX2Parser! !

!XMLConfigurationTest methodsFor: 'accessing' stamp: 'monty 9/21/2016 09:39'!
parserHandlerClass
	^ SAXHandler! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/22/2016 16:18'!
testCopy
	| configuration externalEntityResolver copy |

	externalEntityResolver := self externalEntityResolverClass new.
	(configuration := self newConfiguration)
		isValidating: false;
		usesNamespaces: false;
		decodesCharacters: false;
		parserHandlerClass: self otherParserHandlerClass;
		documentReadLimit: XMLParserLimits defaultDocumentReadLimit - 1;
		maxEntityReplacementDepth: XMLParserLimits defaultMaxEntityReplacementDepth - 1;
		preservesUndeclaredEntityReferences: true;
		replacesContentEntityReferences: false;
		resolvesExternalEntities: true;
		externalEntityResolver: externalEntityResolver.
	copy := configuration copy.
	self
		deny: copy == configuration;
		assert: copy isValidating = configuration isValidating;
		assert: copy usesNamespaces = configuration usesNamespaces;
		assert: copy decodesCharacters = configuration decodesCharacters;
		assert: copy requiresDocumentConstraints = configuration requiresDocumentConstraints;
		assert: copy parserHandlerClass == configuration parserHandlerClass.

	self
		deny: copy parserLimits == configuration parserLimits;
		assert: copy documentReadLimit = configuration documentReadLimit;
		assert: copy maxEntityReplacementDepth = configuration maxEntityReplacementDepth.

	self
		deny: copy entityConfiguration == configuration entityConfiguration;
		assert: copy preservesUndeclaredEntityReferences = configuration preservesUndeclaredEntityReferences;
		assert: copy replacesContentEntityReferences = configuration replacesContentEntityReferences;
		assert: copy resolvesExternalEntities = configuration resolvesExternalEntities;
		deny: copy externalEntityResolver == configuration externalEntityResolver;
		assert: copy externalEntityResolver class == configuration externalEntityResolver class.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 00:19'!
testDecodesCharacters
	| configuration |

	configuration := self newConfiguration.
	self
		assert: configuration decodesCharacters;
		assert: (configuration decodesCharacters: false) == configuration;
		deny: configuration decodesCharacters;
		assert: (configuration decodesCharacters: true) == configuration;
		assert: configuration decodesCharacters.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 09:36'!
testDocumentReadLimit
	| configuration |

	configuration := self newConfiguration.
	self
		assert: configuration documentReadLimit = XMLParserLimits defaultDocumentReadLimit;
		assert: (configuration documentReadLimit: 100000) == configuration;
		assert: configuration documentReadLimit = 100000;
		assert: (configuration documentReadLimit: nil) == configuration;
		assert: configuration documentReadLimit isNil.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 00:34'!
testEntityConfiguration
	| configuration newEntityConfiguration |

	configuration := self newConfiguration.
	self assert: configuration entityConfiguration class == DTDEntityConfiguration.

	newEntityConfiguration := DTDEntityConfiguration new.
	self assert:
		(configuration entityConfiguration: newEntityConfiguration) ==
			configuration.
	self assert: configuration entityConfiguration == newEntityConfiguration.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/22/2016 15:21'!
testExternalEntityResolver
	| configuration oldResolver newResolver |

	configuration := self newConfiguration.
	oldResolver := configuration externalEntityResolver.
	self assert: oldResolver class == self externalEntityResolverClass.

	newResolver := self externalEntityResolverClass new.
	self
		assert: (configuration externalEntityResolver: newResolver) == configuration;
		assert: configuration externalEntityResolver == newResolver.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 00:17'!
testIsValidating
	| configuration |
	
	configuration := self newConfiguration.
	self
		assert: configuration isValidating;
		assert: (configuration isValidating: false) == configuration;
		deny: configuration isValidating;
		assert: (configuration isValidating: true) == configuration;
		assert: configuration isValidating.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 09:37'!
testMaxEntityReplacementDepth
	| configuration |

	configuration := self newConfiguration.
	self assert:
		configuration maxEntityReplacementDepth =
			XMLParserLimits defaultMaxEntityReplacementDepth.
	self
		assert: (configuration maxEntityReplacementDepth: 20) == configuration;
		assert: configuration maxEntityReplacementDepth = 20;
		assert: (configuration maxEntityReplacementDepth: nil) == configuration;
		assert: configuration maxEntityReplacementDepth isNil.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 09:40'!
testParserHandlerClass
	| configuration |

	configuration := self newConfiguration.
	self assert: configuration parserHandlerClass == self parserHandlerClass.
	self assert:
		(configuration parserHandlerClass: self otherParserHandlerClass) ==
			configuration.
	self assert: configuration parserHandlerClass == self otherParserHandlerClass.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 00:22'!
testParserLimits
	| configuration newParserLimits |

	configuration := self newConfiguration.
	self assert: configuration parserLimits class == XMLParserLimits.

	newParserLimits := XMLParserLimits new.
	self
		assert: (configuration parserLimits: newParserLimits) == configuration;
		assert: configuration parserLimits == newParserLimits.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 09:42'!
testPreservesUndeclaredEntityReferences
	| configuration |

	configuration := self newConfiguration.
	self deny: configuration preservesUndeclaredEntityReferences.

	"enabling should disable validation"
	self assert:
		(configuration preservesUndeclaredEntityReferences: true) ==
			configuration.
	self
		assert: configuration preservesUndeclaredEntityReferences;
		deny: configuration isValidating.

	self
		assert: (configuration isValidating: true) == configuration;
		assert: configuration isValidating;
		deny: configuration preservesUndeclaredEntityReferences.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 09:42'!
testReplacesContentEntityReferences
	| configuration |
	
	configuration := self newConfiguration.
	self assert: configuration replacesContentEntityReferences.
	self assert:
		(configuration replacesContentEntityReferences: false) ==
			configuration.
	self deny: configuration replacesContentEntityReferences.
	self assert:
		(configuration replacesContentEntityReferences: true) ==
			configuration.
	self assert: configuration replacesContentEntityReferences.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 00:33'!
testRequiresDocumentConstraints
	| configuration |

	(configuration := self newConfiguration) isValidating: false.
	self deny: configuration requiresDocumentConstraints.

	"enabling should force validation"
	self
		assert: (configuration requiresDocumentConstraints: true) == configuration;
		assert: configuration requiresDocumentConstraints;
		assert: configuration isValidating.

	self
		assert: (configuration isValidating: false) == configuration;
		deny: configuration isValidating;
		deny: configuration requiresDocumentConstraints.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 09:38'!
testResolvesExternalEntities
	| configuration |

	configuration := self newConfiguration.
	"should not resolve external entities by default for security"
	self
		deny: configuration resolvesExternalEntities;
		assert: (configuration resolvesExternalEntities: true) == configuration;
		assert: configuration resolvesExternalEntities;
		assert: (configuration resolvesExternalEntities: false) == configuration;
		deny: configuration resolvesExternalEntities.! !

!XMLConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 00:19'!
testUsesNamespaces
	| configuration |

	configuration := self newConfiguration.
	self
		assert: configuration usesNamespaces;
		assert: (configuration usesNamespaces: false) == configuration;
		deny: configuration usesNamespaces;
		assert: (configuration usesNamespaces: true) == configuration;
		assert: configuration usesNamespaces.! !

XMLConfigurationTest subclass: #XMLDOMConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLDOMConfigurationTest methodsFor: 'accessing' stamp: 'monty 9/21/2016 10:06'!
configurationClass
	^ XMLDOMConfiguration! !

!XMLDOMConfigurationTest methodsFor: 'accessing' stamp: 'monty 9/21/2016 10:08'!
nodeFactoryClass
	^ XMLNodeFactory! !

!XMLDOMConfigurationTest methodsFor: 'accessing' stamp: 'monty 9/21/2016 09:40'!
parserHandlerClass
	^ XMLDOMParser! !

!XMLDOMConfigurationTest methodsFor: 'tests' stamp: 'monty 9/22/2016 15:20'!
testCopy
	| configuration nodeFactory copy |

	super testCopy.

	nodeFactory := self nodeFactoryClass new.
	(configuration := self newConfiguration)
		preservesCDataNodes: true;
		preservesCommentNodes: true;
		preservesIgnorableWhitespace: true;
		nodeFactory: nodeFactory.
	copy := configuration copy.
	self
		assert: copy preservesCDataNodes = configuration preservesCDataNodes;
		assert: copy preservesCommentNodes = configuration preservesCommentNodes;
		assert: copy preservesIgnorableWhitespace = configuration preservesIgnorableWhitespace;
		deny: copy nodeFactory == configuration nodeFactory;
		assert: copy nodeFactory class = configuration nodeFactory class.! !

!XMLDOMConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 10:08'!
testNodeFactory
	| configuration oldNodeFactory newNodeFactory |

	configuration := self newConfiguration.
	oldNodeFactory := configuration nodeFactory.
	self assert: oldNodeFactory class == self nodeFactoryClass.

	newNodeFactory := self nodeFactoryClass new.
	self
		assert: (configuration nodeFactory: newNodeFactory) == configuration;
		assert: configuration nodeFactory == newNodeFactory.! !

!XMLDOMConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 10:07'!
testPreservesCDataNodes
	| configuration |

	configuration := self newConfiguration.
	self
		deny: configuration preservesCDataNodes;
		assert: (configuration preservesCDataNodes: true) == configuration;
		assert: configuration preservesCDataNodes;
		assert: (configuration preservesCDataNodes: false) == configuration;
		deny: configuration preservesCDataNodes.! !

!XMLDOMConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 10:07'!
testPreservesCommentNodes
	| configuration |

	configuration := self newConfiguration.
	self
		deny: configuration preservesCommentNodes;
		assert: (configuration preservesCommentNodes: true) == configuration;
		assert: configuration preservesCommentNodes;
		assert: (configuration preservesCommentNodes: false) == configuration;
		deny: configuration preservesCommentNodes.! !

!XMLDOMConfigurationTest methodsFor: 'tests' stamp: 'monty 9/21/2016 10:06'!
testPreservesIgnorableWhitespace
	| configuration |

	configuration := self newConfiguration.
	configuration isValidating: false.
	"should enable validation"
	self
		deny: configuration preservesIgnorableWhitespace;
		assert: (configuration preservesIgnorableWhitespace: true) == configuration;
		assert: configuration preservesIgnorableWhitespace;
		assert: configuration isValidating.

	"disabling validation should disable it"
	self
		assert: (configuration isValidating: false) == configuration;
		deny: configuration preservesIgnorableWhitespace;
		deny: configuration isValidating! !

TestCase subclass: #XMLDFALimitsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Validation-DFA'!

!XMLDFALimitsTests methodsFor: 'tests' stamp: 'monty 4/13/2016 06:26'!
testDFAStateCacheLimit
	| names contentModel firstState currentState visitedStates |

	names :=
		(1 to: XMLDFAStateCache new maxCachedDFAStates) collect: [:each |
			'test', each printString].

	contentModel := String streamContents: [:stream |
		stream nextPut: $(.
		names withIndexDo: [:each :i |
			i > 1
				ifTrue: [stream nextPut: $,].
			stream nextPutAll: each].
		stream nextPut: $)].

	firstState :=
		(DTDElementContentModelParser
			element: 'test'
			contentModel: contentModel) parse dfa.
	currentState := firstState.
	visitedStates := Set new.
	names withIndexDo: [:name :i | | previousState |
		visitedStates add: currentState.
		previousState := currentState.
		currentState := currentState nextDFAStateMatching: name.
		self assert: currentState notNil.
		i = names size
			ifTrue: [
				visitedStates do: [:each |
					"the cache clearing was triggered by the last match, which
					added one transition from previousState to currentState,
					but other transitions should be cleared"
					each = previousState
						ifTrue: [self assert: each dfaStateTransitions size = 1]
						ifFalse: [self assert: each dfaStateTransitions isEmpty]].
				self
					assert: firstState dfaStateTransitions isEmpty;
					assert: firstState dfaStateCache cachedDFAStates size = 2;
					assert: currentState isAccepting]
			ifFalse: [
				visitedStates do: [:each | self deny: each dfaStateTransitions isEmpty].
				self
					assert: firstState dfaStateTransitions notEmpty;
					assert: firstState dfaStateCache cachedDFAStates size = (i + 1);
					deny: currentState isAccepting]].

	currentState := firstState.
	names withIndexDo: [:each :i |
		currentState := currentState nextDFAStateMatching: each.
		self deny: currentState isNil.
		i = names size
			ifTrue: [self assert: currentState isAccepting]
			ifFalse: [self deny: currentState isAccepting]].! !

!XMLDFALimitsTests methodsFor: 'tests' stamp: 'monty 4/13/2016 06:26'!
testDFAStateTransitionLimit
	| dfaState elementName |

	dfaState :=
		(DTDElementContentModelParser
			element: 'test'
			contentModel: '(test)') parse dfa.
	1 to: dfaState maxDFAStateTransitions do: [:i |
		elementName := 'test', i printString.
		dfaState nextDFAStateMatching: elementName.
		self
			assert: (dfaState dfaStateTransitions includesKey: elementName);
			assert: dfaState dfaStateTransitions size = i].

	elementName := 'test', (dfaState maxDFAStateTransitions + 1) printString.
	dfaState nextDFAStateMatching: elementName.
	self
		assert: (dfaState dfaStateTransitions includesKey: elementName);
		assert: dfaState dfaStateTransitions size = 1.! !

TestCase subclass: #XMLDOMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 6/24/2016 18:54'!
addressBookNamespacePrefixedXML
	^ XMLParserTest addressBookNamespacePrefixedXML! !

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 6/24/2016 18:54'!
addressBookNamespacedXML
	^ XMLParserTest addressBookNamespacedXML! !

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 6/24/2016 18:54'!
addressBookXML
	^ XMLParserTest addressBookXML! !

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 6/24/2016 18:55'!
addressBookXMLWithDTD
	^ XMLParserTest addressBookXMLWithDTD! !

!XMLDOMParserTest methodsFor: 'source' stamp: 'monty 4/6/2017 00:08'!
internalSubsetXMLWithDeclarations
	^ XMLParserTest internalSubsetXMLWithDeclarations! !

!XMLDOMParserTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:13'!
nodeFactoryClass
	^ XMLNodeFactory! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testAllElementsNamespaceURIs
	| document people |

	document := XMLDOMParser parse: self addressBookNamespacedXML.

	people :=
		document
			allElementsNamed: 'person'
			namespaceURI: 'defaultNS'.
	self
		assert: people size = 4;
		assert:
			(document
				allElementsNamed: 'person'
				namespaceURI: 'undeclaredNS') isEmpty.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/8/2016 12:06'!
testAttributeListClass
	(Array
		with: XMLAttributeList
		with: XMLCachingAttributeList)
		do: [:listClass | | document parser |
			parser := XMLDOMParser on: self addressBookXML.
			parser configuration attributeListClass: listClass.
			document := parser parseDocument.
			self assert: parser configuration attributeListClass == listClass.
			document allElements do: [:each |
				self assert: each attributeNodes class == listClass]]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/24/2014 12:06'!
testAttributeNamespaces
	| document  people |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	people := document allElementsNamed: 'person' namespaceURI: 'personNS'.
	self assert: people notEmpty.
	
	people do: [:each |
		self
			assert: each hasAttributes;
			deny: each attributeNames isEmpty;
			assert:
				(each attributeNames allSatisfy: [:name |
					(each attributeNodeAt: name namespaceURI: 'defaultNS') isNil]);
			assert: (each attributeNodeAt: 'ps:family-name' namespaceURI: 'personNS') notNil;
			assert: (each attributeNodeAt: 'ps:first-name' namespaceURI: 'personNS') notNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/24/2014 12:06'!
testAttributeNamespacesDisabled
	| document  people |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacePrefixedXML
			usingNamespaces: false.
	people := document allElementsNamed: 'person'.
	self assert: people notEmpty.
	people do: [:each |
		self
			assert: each hasAttributes;
			deny: each attributeNames isEmpty;
			assert: (each attributeNodeAt: 'ps:family-name' namespaceURI: 'personNS') isNil;
			assert: (each attributeNodeAt: 'ps:first-name' namespaceURI: 'personNS') isNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 08:20'!
testAttributeParent
	(XMLDOMParser parse: self addressBookXML) allElementsDo: [:element |
		element hasAttributes
			ifTrue: [
				element attributeNodesDo: [:each |
					self
						assert: each hasParent;
						assert: each parent == element;
						assert: each element == element]]]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 7/1/2016 05:51'!
testAttributes
	| document firstPerson  |

	document := XMLDOMParser parse: self addressBookXML.
	firstPerson := document findElementNamed: 'person'.
	self
		assert: (firstPerson attributeAt: 'employee-number') = 'A0000';
		assert: (firstPerson attributeAt: 'family-name') = 'Gates';
		assert: (firstPerson attributeAt: 'first-name') = 'Bob';
		assert:
			firstPerson attributeNames asArray =
				#('employee-number' 'family-name' 'first-name');
		assert: firstPerson attributeAssociations asArray =
			{('employee-number'->'A0000'). ('family-name'->'Gates'). ('first-name'->'Bob').}.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testAttributesExcludingDeclarations
	| document   |

	document := XMLDOMParser parse: self addressBookNamespacedXML.
	self deny: document root hasAttributes.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testAttributesIncludingDeclarations
	| document  root |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacedXML
			usingNamespaces: false.
	root := document root.
	self
		assert: root hasAttributes;
		assert: (root attributeAt: 'xmlns') = 'defaultNS';
		assert: (root attributeAt: 'xmlns:book') = 'bookNS';
		assert: (root attributeAt: 'xmlns:ps') = 'personNS'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/27/2016 06:19'!
testCDataSection
	#('' ']' ']]' ']]]' ']>' ']>]' ']>]>]')
		with: #('' ']' ']]' ']]]' ']&gt;' ']&gt;]' ']&gt;]&gt;]')
		do: [:suffix :escapedSuffix | | document element unescaped escaped xml |
			unescaped :=
				'this is CDATA test content 1 < 2 & 5 > 3', suffix.
			escaped :=
				'this is CDATA test content 1 &lt; 2 &amp; 5 &gt; 3', escapedSuffix.
			xml :=
				'<?xml version="1.0" encoding="UTF-8"?>
				<test-data>test<!![CDATA[', unescaped, ']]>test</test-data>'.
			document := XMLDOMParser parse: xml.
			element := document findElementNamed: 'test-data'.
			self
				assert: element nodes size = 1;
				assert: element firstNode isStringNode;
				assert: element firstNode printString = ('test', escaped, 'test').

			document :=
				(XMLDOMParser on: xml)
					preservesCDataNodes: true;
					parseDocument.
			element := document findElementNamed: 'test-data'.
			self
				assert: element nodes size = 3;
				assert: element nodes second isCData;
				assert: element nodes second printString =
					('<!![CDATA[', unescaped, ']]>');
				assert: element strings asArray =
					(Array with: 'test' with: unescaped with: 'test')].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/29/2016 08:23'!
testCDataSectionEntityReplacement
	| document element unescaped escaped xml |

	unescaped := 'this is CDATA test content 1 < 2 & 5 > 3'.
	escaped := 'this is CDATA test content 1 &lt; 2 &amp; 5 &gt; 3'.
	xml := 
		'<?xml version="1.0" encoding="UTF-8"?>
		<!!DOCTYPE test-data [
			<!!ENTITY cdata "<!![CDATA[this is CDATA test content 1 < 2 &#38; 5 > 3]]>">
		]>
		<test-data>test&cdata;test</test-data>'.
	document := XMLDOMParser parse: xml.
	element := document findElementNamed: 'test-data'.
	self
		assert: element nodes size = 1;
		assert: element firstNode isStringNode;
		assert: element firstNode printString = ('test', escaped, 'test').

	document :=
		(XMLDOMParser on: xml)
			preservesCDataNodes: true;
			parseDocument.
	element := document findElementNamed: 'test-data'.
	self
		assert: element nodes size = 3;
		assert: element nodes second isCData;
		assert: element nodes second printString = ('<!![CDATA[', unescaped, ']]>');
		assert: element strings asArray = (Array with: 'test' with: unescaped with: 'test').! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/24/2014 12:07'!
testChangingNamespaces
	| document people person |

	document := XMLDOMParser parse: self addressBookNamespacedXML.

	people := document allElementsNamed: 'person' namespaceURI: 'defaultNS'.
	(person := people third) prefix: 'ps'.
	self assert: person == (document findElementNamed: 'person' namespaceURI: 'personNS').
	self assert:
		(people copyWithout: person) =
			((document findElementNamed: 'addressbook') nodesSelect: [:each |
				each isElement and: [each namespaceURI = 'defaultNS']]).! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 7/1/2016 05:57'!
testComment
	| xml document comments |

	xml := '<!!--one--><test><!!--two--></test><!!--three-->'.
	document := XMLDOMParser parse: xml.
	comments := document allNodesSelect: [:each | each isComment].
	self assert: comments isEmpty.

	document :=
		(XMLDOMParser on: xml)
			preservesCommentNodes: true;
			parseDocument.
	comments := document allNodesSelect: [:each | each isComment].
	self
		assert: (comments allSatisfy: [:each | each isComment]);
		assert: (comments collect: [:each | each string]) asArray = #('one' 'two' 'three').! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 3/12/2015 18:19'!
testDeclaringXMLNamespace
	| xmlNamespace elements |

	xmlNamespace :=XMLNamespaceScope xmlNamespaceURI.
	self deny:
		((XMLDOMParser parse: self addressBookNamespacedXML) root
			declaresPrefix: 'xml'
			uri: xmlNamespace).

	elements :=
		(XMLDOMParser parse:
			'<one><two xmlns:xml="', xmlNamespace, '"/><xml:three/></one>') allElements.
	self
		deny: (elements first declaresPrefix: 'xml' uri: xmlNamespace);
		assert: (elements second declaresPrefix: 'xml' uri: xmlNamespace);
		deny: (elements third declaresPrefix: 'xml' uri: xmlNamespace).! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/6/2017 00:07'!
testDoctypeDeclaration
	| doctype |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetXMLWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.
	self
		assert: doctype root = 'root';
		assert: doctype publicID = 'pubid';
		assert: doctype systemID = 'external.dtd';
		assert: doctype nodes notEmpty;
		assert: (doctype nodes allSatisfy: [:each | each isDeclaration]).! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/17/2017 04:46'!
testDocument
	| parser document root |

	parser := XMLDOMParser on: self addressBookXML.
	self assert: parser document isNil.

	document := parser parseDocument.
	self assert: parser document == document.

	parser on: self addressBookXML.
	self assert: parser document isNil.

	document allNodesDo: [:each |
		self assert: each document == document].

	root := document root.
	root innerXML: self addressBookXML.
	document allNodesDo: [:each |
		self assert: each document == document].

	document removeNode: root.
	root allNodesDo: [:each |
		self assert: each document isNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/6/2017 00:07'!
testDocumentInternalSubset
	| document doctypeDeclaration |

	document := XMLDOMParser parse: self internalSubsetXMLWithDeclarations.
	doctypeDeclaration := document doctypeDeclaration.
	doctypeDeclaration allNodesDo: [:each |
		self assert: each document == document].

	document doctypeDeclaration: nil.
	doctypeDeclaration allNodesDo: [:each |
		self assert: each document isNil].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 7/1/2016 05:52'!
testElementMixedContent
	| xml mixedContent |

	xml := '<mixed-content> one <two/> <three/> four <five> </five> seven </mixed-content>'.
	mixedContent := (XMLDOMParser parse: xml) root.
	self
		assert: mixedContent nodes size = 7;
		assert: (mixedContent nodes first isStringNode: ' one ');
		assert: (mixedContent nodes second isElementNamed: 'two');
		deny: mixedContent nodes second hasChildren;
		assert: (mixedContent nodes third isStringNode: ' ');
		assert: (mixedContent nodes fourth isElementNamed: 'three');
		deny: mixedContent nodes fourth hasChildren;
		assert: (mixedContent nodes fifth isStringNode: ' four ');
		assert: (mixedContent nodes sixth isElementNamed: 'five');
		assert: mixedContent nodes sixth hasChildren;
		assert: mixedContent nodes sixth nodes size = 1;
		assert: (mixedContent nodes sixth nodes first isStringNode: ' ');
		assert: (mixedContent nodes seventh isStringNode: ' seven ').! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/29/2014 10:04'!
testElementNames
	| document root  persons |

	document := XMLDOMParser parse: self addressBookXML.
	root := document root.

	persons := 	root allNodesSelect: [:each |
			each isElement
				and: [(each isNamedAny: #('notperson' 'person'))
					and: [(each isNamed: 'person')
						and: [(each name = 'person') and: [each localName = 'person']]]]].
	self assert: persons size = 4.

	root allElementsNamed: 'person' do: [:p |
		self assert: (persons includes: p).
		persons remove: p].
	self assert: persons isEmpty.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:44'!
testElementPrefixes
	| document  persons |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	persons := 	document allElementsSelect: [:each |
		(each isNamedAny: #('notperson' 'ps:person'))
			and: [(each isNamedAny: #('notperson' 'person'))
				and: [(each isNamed: 'person')
					and: [(each isNamed: 'ps:person')
						and: [(each name = 'ps:person') and: [each localName = 'person']]]]]].
	self assert: persons size = 4.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:44'!
testElementPrefixesNamespacesDisabled
	| document  persons |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacePrefixedXML
			usingNamespaces: false.
	persons := 	document allElementsSelect: [:each |
		(each isNamedAny: #('notperson' 'ps:person'))
			and: [(each isNamedAny: #('notperson' 'person'))
				and: [(each isNamed: 'person')
					and: [(each isNamed: 'ps:person')
						and: [(each name = 'ps:person') and: [each localName = 'person']]]]]].
	self assert: persons size = 4.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testFindElementNamespaceURI
	| document people |

	document := XMLDOMParser parse: self addressBookNamespacedXML.

	people := document allElementsNamed: 'person' namespaceURI: 'defaultNS'.
	self assert:
		(document
			findElementNamed: 'person'
			namespaceURI: 'defaultNS'
			with: [:each | (each attributeAt: 'employee-number') = 'A7987']) == people last.
	self assert:
		(document
			findElementNamed: 'person'
			namespaceURI: 'defaultNS'
			with: [:each | (each attributeAt: 'family-name') = 'Brown']) == people second.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:34'!
testInnerXML
	| document |

	document := XMLDOMParser parse: self addressBookXML.
	document allElementsNamed: 'person' do: [:person | | contactInfo address1 address2 |
		#('address' 'job-info' 'manager') do: [:each |
			self assert: (person elementAt: each) innerXML = ''].

		contactInfo := person elementAt: 'contact-info'.
		address1 := (person attributeAt: 'first-name'), '@example.com'.
		address2 := (person attributeAt: 'first-name'), '@users.example.com'.
		self
			assert: (contactInfo innerXML: '<email></email><email2/>') innerXML = '<email /><email2 />';
			assert: contactInfo elements size = 2;
			assert: (contactInfo elements first isNamed: 'email');
			assert: (contactInfo elements second isNamed: 'email2');
			assert: (contactInfo firstElement innerXML: address1, '<!!--ignored-->') innerXML = address1;
			assert: (contactInfo elements second innerXML: '<!![CDATA[', address2, ']]>') innerXML = address2.
		self assert:
			contactInfo innerXML = 
				('<email>', address1, '</email><email2>', address2, '</email2>')].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 5/9/2015 23:34'!
testInnerXMLDocument
	| document |

	document := XMLDOMParser parse: self addressBookXMLWithDTD.
	self
		assert: ((document innerXML: '<new-root/>') root isNamed: 'new-root');
		assert: document innerXML = '<new-root />';
		assert: ((document root innerXML: 'test') contentString = 'test');
		assert: document root innerXML = 'test'.
	
	document := XMLDOMParser parse: self addressBookXMLWithDTD.
	self assert:
		(document innerXML: document innerXML) printString =
			(XMLDOMParser parse: self addressBookXMLWithDTD) printString.
	self
		should: [document innerXML: self addressBookXMLWithDTD]
		raise: XMLWellFormednessException.

	document := XMLDOMParser parse: '<root/>'.
	self
		should: [document innerXML: '<root1/><root2/>']
		raise: XMLWellFormednessException.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/4/2016 01:28'!
testInnerXMLEntities
	| document |

	document :=
		(XMLDOMParser on:
			'<!!DOCTYPE test [
					<!!ENTITY one "one">
					<!!ENTITY two "two">
					<!!ENTITY three "<!!--comment-->">
				]>
			<test name="&one;">&one;</test>')
			preservesCommentNodes: true;
			parseDocument.
	self
		assert: (document root attributeAt: 'name') = 'one';
		assert: document root contentString = 'one'.

	document innerXML: '<test name="&two;">&three;</test>'.
	self
		assert: (document root attributeAt: 'name') = 'two';
		assert: document root hasChildren;
		assert: document root nodes size = 1;
		assert: document root firstNode isComment;
		assert: document root firstNode string = 'comment'.

	document root innerXML: '&two;'.
	self
		assert: (document root attributeAt: 'name') = 'two';
		assert: document root contentString = 'two'.

	self
		should: [document innerXML: '<test name="&undeclared;"></test>']
		raise: XMLWellFormednessException.
	self
		should: [document innerXML: '<test name="">&undeclared;</test>']
		raise: XMLWellFormednessException.
	self
		should: [document innerXML: '&three;<test/>']
		raise: XMLWellFormednessException.
	self
		should: [document innerXML: '<test/>&three;']
		raise: XMLWellFormednessException.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/6/2017 00:07'!
testInternalAttributeDeclarations
	| doctype firstAttribute secondAttribute |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetXMLWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	firstAttribute := doctype nodes second.
	self
		assert: firstAttribute element = 'root';
		assert: firstAttribute attribute = 'name';
		assert: firstAttribute type = 'CDATA';
		assert: firstAttribute defaultPragma = 'IMPLIED';
		assert: firstAttribute defaultValue = ''.

	secondAttribute := doctype nodes third.
	self
		assert: secondAttribute element = 'root';
		assert: secondAttribute attribute = 'number';
		assert: secondAttribute type = '(one|two|three)';
		assert: secondAttribute defaultPragma = '';
		assert: secondAttribute defaultValue = 'three'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/6/2017 00:07'!
testInternalElementDeclaration
	| doctype elementDeclaration |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetXMLWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.
	elementDeclaration := doctype nodes first.
	self
		assert: elementDeclaration element = 'root';
		assert: elementDeclaration contentModel = '(#PCDATA|one|two)*'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/6/2017 00:07'!
testInternalGeneralEntityDeclarations
	| doctype firstEntity secondEntity |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetXMLWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	firstEntity := doctype nodes fourth.
	self
		deny: firstEntity isParameter;
		assert: firstEntity name = 'general';
		assert: firstEntity replacement = 'replacement';
		assert: firstEntity publicID = '';
		assert: firstEntity systemID = '';
		assert: firstEntity ndata = ''.

	secondEntity := doctype nodes fifth.
	self
		deny: secondEntity isParameter;
		assert: secondEntity name = 'externalGeneral';
		assert: secondEntity replacement = '';
		assert: secondEntity publicID = 'pubid2';
		assert: secondEntity systemID = 'external1.dtd';
		assert: secondEntity ndata = ''.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/6/2017 00:07'!
testInternalNotationDeclarations
	| doctype notation |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetXMLWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	notation := doctype nodes eighth.
	self
		assert: notation name = 'notation';
		assert: notation publicID = '';
		assert: notation systemID = 'note.doc'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/6/2017 00:07'!
testInternalParameterEntityDeclarations
	| doctype firstEntity secondEntity |

	doctype :=
		(XMLDOMParser
			parse: self internalSubsetXMLWithDeclarations
			usingNamespaces: true
			validation: true
			externalEntities: false) doctypeDeclaration.

	firstEntity := doctype nodes sixth.
	self
		assert: firstEntity isParameter;
		assert: firstEntity name = 'parameter';
		assert: firstEntity replacement = 'replacement';
		assert: firstEntity publicID = '';
		assert: firstEntity systemID = ''.

	secondEntity := doctype nodes seventh.
	self
		assert: secondEntity isParameter;
		assert: secondEntity name = 'externalParameter';
		assert: secondEntity replacement = '';
		assert: secondEntity publicID = '';
		assert: secondEntity systemID = 'external2.dtd'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:35'!
testNamespaces
	| document  |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	document allElementsDo: [:each |
		(each == document root or: [each isNamed: 'person'])
			ifTrue: [
				self assert: each hasPrefix.
				each == document root
					ifTrue: [
						self
							assert: each prefix = 'book';
							assert: each namespaceURI = 'bookNS']
					ifFalse: [
						self
							assert: each prefix = 'ps';
							assert: each namespaceURI = 'personNS']]
			ifFalse: [
				self
					assert: each namespaceURI = 'defaultNS';
					deny: each hasPrefix;
					assert: each prefix = '']].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 8/10/2016 20:25'!
testNamespacesCopyOnWrite
	| xml elements |

	xml := 
		'<one xmlns:prefix1="ns" xmlns="defualt">
			<two xmlns:prefix2="ns2"><three /></two>
			<four><five xmlns:prefix1="ns3" xmlns="defualt2" /></four>
		</one>'.
	elements := (XMLDOMParser parse: xml) allElements.
	self assert:
		(IdentitySet withAll: "avoid newFrom: for GS portability"
			(elements collect: [:each |
				each namespaceScope prefixMappings])) size = 3.

	elements := (XMLDOMParser parse: xml usingNamespaces: false) allElements.
	self assert:
		(IdentitySet withAll: "avoid newFrom: for GS portability"
			(elements collect: [:each |
				each namespaceScope prefixMappings])) size = elements size.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testNamespacesDeclaring
	| document |

	document := XMLDOMParser parse: self addressBookNamespacedXML.
	document allElementsDo: [:each |
		self assert: each hasNamespaces.
		each == document root
			ifTrue: [
				self
					assert: each declaresDefaultNamespace;
					assert: (each declaresPrefix: 'ps' uri: 'personNS')]
			ifFalse: [ 
				self
					deny: each declaresDefaultNamespace;
					deny: (each declaresPrefix: 'ps' uri: 'personNS')].
		self
			deny: (each declaresPrefix: 'undeclared' uri: 'undeclaredNS');
			deny: (each isDeclaredPrefix: 'undeclared');
			deny: (each isDeclaredPrefix: 'undeclared' uri: 'undeclaredNS');
			assert: (each isDeclaredPrefix: 'ps');
			assert: (each isDeclaredPrefix: 'ps' uri: 'personNS')].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testNamespacesDeclaringDisabled
	| document |

	document := XMLDOMParser parse: self addressBookNamespacedXML usingNamespaces: false.
	document allElementsDo: [:each |
		self
			deny: each hasNamespaces;
			deny: each declaresDefaultNamespace;
			deny: (each declaresPrefix: 'ps' uri: 'personNS');
			deny: (each isDeclaredPrefix: 'ps');
			deny: (each isDeclaredPrefix: 'ps' uri: 'personNS')].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:35'!
testNamespacesDisabled
	| document |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacePrefixedXML
			usingNamespaces: false.
	document allElementsDo: [:each |
		self assert: each namespaceURI = ''.
		(each == document root or: [each isNamed: 'person'])
			ifTrue: [
				self
					assert: each hasPrefix;
					assert:
						each prefix =
							((each == document root) ifTrue: ['book'] ifFalse: ['ps'])]
			ifFalse: [
				self
					deny: each hasPrefix;
					assert: each prefix = '']].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/1/2017 00:47'!
testNamespacesDisabledAttributes
	| document |

	document :=
		XMLDOMParser
			parse: '<root xmlns:prefix="prefixNS" xmlns="defaultNS" name="value"/>'
			usingNamespaces: false.
	self
		assert: document root attributeNames asArray = #('xmlns:prefix' 'xmlns' 'name');
		assert: (document root attributeAt: 'xmlns:prefix') = 'prefixNS';
		assert: (document root attributeAt: 'xmlns') = 'defaultNS';
		assert: (document root attributeAt: 'name') = 'value'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/3/2017 01:33'!
testNamespacesDisabledReuse
	| parser document oldRootScope newRootScope |

	parser := XMLDOMParser on: self addressBookNamespacedXML.
	document :=
		parser
			usesNamespaces: true;
			parseDocument.
	oldRootScope := document root namespaceScope.
	self assert: oldRootScope hasNamespaces.

	document :=
		parser
			on: self addressBookNamespacedXML;
			usesNamespaces: false;
			parseDocument.
	newRootScope := document root namespaceScope.
	self
		deny: newRootScope = oldRootScope;
		deny: newRootScope hasNamespaces.

	self
		should: [
			parser
				on: '<test xmlns:unused="unusedNS"><used:test/></test>';
				usesNamespaces: true;
				parseDocument]
		raise: XMLNamespaceException.
	self
		shouldnt: [
			document :=
				parser
					on: '<test xmlns:unused="unusedNS"><used:test/></test>';
					usesNamespaces: false;
					parseDocument]
		raise: XMLNamespaceException.
	self deny: document root hasNamespaces.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 1/25/2014 04:46'!
testNamespacesResolving
	| document |

	document := XMLDOMParser parse: self addressBookNamespacedXML.
	document allElementsDo: [:each |
		self
			assert: each defaultNamespace = 'defaultNS';
			assert: (each resolvePrefix: '') = 'defaultNS';
			assert: (each resolvePrefix: 'book') = 'bookNS';
			assert: (each resolvePrefix: 'ps') = 'personNS';
			assert:
				each namespaceURI =
					(each hasPrefix
						ifTrue: [each resolvePrefix: each prefix]
						ifFalse: [each defaultNamespace])]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:35'!
testNamespacesResolvingDisabled
	| document |

	document :=
		XMLDOMParser
			parse: self addressBookNamespacedXML
			usingNamespaces: false.
	document allElementsDo: [:each |
		self
			assert: each defaultNamespace = '';
			assert: (each resolvePrefix: '') = '';
			assert: (each resolvePrefix: 'book') = '';
			assert: (each resolvePrefix: 'ps') = '';
			assert:
				each namespaceURI =
					(each hasPrefix
						ifTrue: [each resolvePrefix: each prefix]
						ifFalse: [each defaultNamespace])]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 12/21/2013 06:21'!
testNodeDetecting
	| document people |

	document := XMLDOMParser parse: self addressBookXML.
	people := document root elementsAt: 'person'.
	self assert:
		((document findElementNamed: 'addressbook') nodesDetect: [:each |
			each isElement and: [(each attributeAt: 'family-name') = 'Brown']]) == people second.
	self assert:
		((document findElementNamed: 'addressbook')
			nodesDetect: [:each | each isElement and: [(each attributeAt: 'unknown') = 'Brown']]
			ifNone: ['not found']) = 'not found'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:14'!
testNodeFactory
	| parser oldNodeFactory newNodeFactory |

	parser := XMLDOMParser on: self addressBookXML.
	oldNodeFactory := parser nodeFactory.
	self assert: oldNodeFactory class == self nodeFactoryClass.

	newNodeFactory := self nodeFactoryClass new.
	self
		assert: (parser nodeFactory: newNodeFactory) == parser;
		assert: parser nodeFactory == newNodeFactory.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/8/2016 07:19'!
testNodeListClass
	(Array
		with: XMLNodeList
		with: XMLCachingNodeList)
		do: [:listClass | | document parser |
			parser := XMLDOMParser on: self addressBookXML.
			parser configuration nodeListClass: listClass.
			document := parser parseDocument.
			self
				assert: parser configuration nodeListClass == listClass;
				assert: document nodes class == listClass.
			document allElements do: [:each |
				self assert: each nodes class == listClass]]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 08:17'!
testNodeParent
	(XMLDOMParser parse: self addressBookXML) allNodesDo: [:node |
		node hasChildren
			ifTrue: [
				node nodesDo: [:each |
					self
						assert: each hasParent;
						assert: each parent == node]]]! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/19/2017 07:19'!
testNodeStack
	| parser  |

	parser := XMLDOMParser on: self addressBookXML.
	self assert: parser nodeStack isEmpty.

	parser := XMLDOMParser on: self addressBookXML.
	parser parser parseToken.
	self deny: parser nodeStack isEmpty.

	parser on: self addressBookXML.
	self assert: parser nodeStack isEmpty.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 22:10'!
testOptimizeForLargeDocuments
	| parser |

	parser := XMLDOMParser on: ''.

	parser optimizeForLargeDocuments.
	self
		deny: parser isValidating;
		deny: parser usesNamespaces;
		assert: parser documentReadLimit isNil;
		assert: parser nodeFactory attributeListClass == XMLAttributeList.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:31'!
testOverridingDefaultNamespace
	| document |

	document :=
		XMLDOMParser parse:
			'<outer xmlns="default"><inner xmlns=""/></outer>'.
	self
		assert: document root namespaceURI = 'default';
		assert: document root defaultNamespace = 'default';
		assert: document root firstNode namespaceURI = '';
		assert: document root firstNode defaultNamespace = ''.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/26/2014 21:28'!
testParseDocumentUntil
	| i document |

	self
		shouldnt: [
			i := 0.
			document :=
				(XMLDOMParser on: '<root><one>two<#malformed')
					parseDocumentUntil: [(i := i + 1) > 4]]
		raise: XMLWellFormednessException.
	self
		assert: document allNodes size = 4;
		assert: (document findElementNamed: 'one') nodes size = 1;
		assert: (document findElementNamed: 'one') contentString = 'two'.
	self
		should: [
			i := 0.
			(XMLDOMParser on: '<root><one>two<#malformed')
				parseDocumentUntil: [(i := i + 1) > 5]]
		raise: XMLWellFormednessException.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/14/2014 23:11'!
testParseDocumentWhile
	| i document |

	self
		shouldnt: [
			i := 0.
			document :=
				(XMLDOMParser on: '<root><one>two<#malformed')
					parseDocumentWhile: [(i := i + 1) <= 4]]
		raise: XMLWellFormednessException.
	self
		assert: document allNodes size = 4;
		assert: (document findElementNamed: 'one') nodes size = 1;
		assert: (document findElementNamed: 'one') contentString = 'two'.
	self
		should: [
			i := 0.
			(XMLDOMParser on: '<root><one>two<#malformed')
				parseDocumentWhile: [(i := i + 1) <= 5]]
		raise: XMLWellFormednessException.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/29/2014 13:54'!
testParsedElementNames
	| document |

	document := XMLDOMParser parse: self addressBookNamespacePrefixedXML.
	self assert:
		document elementNames =
			(document elements collect: [:each | each name ]).

	document allElementsDo: [:element |
		self assert:
			element elementNames =
				(element elements collect: [:each | each name])].! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 22:34'!
testPreservesCDataNodes
	| parser |

	parser := XMLDOMParser on: self addressBookXML.
	self
		deny: parser preservesCDataNodes;
		assert: (parser preservesCDataNodes: true) == parser;
		assert: parser preservesCDataNodes;
		assert: (parser preservesCDataNodes: false) == parser;
		deny: parser preservesCDataNodes.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 7/4/2016 21:47'!
testPreservesCommentNodes
	| parser |

	parser := XMLDOMParser on: self addressBookXML.
	self
		deny: parser preservesCommentNodes;
		assert: (parser preservesCommentNodes: true) == parser;
		assert: parser preservesCommentNodes;
		assert: (parser preservesCommentNodes: false) == parser;
		deny: parser preservesCommentNodes.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 22:39'!
testPreservesIgnorableWhitespace
	| parser |

	parser := XMLDOMParser on: self addressBookXML.
	parser isValidating: false.
	"should enable validation"
	self
		deny: parser preservesIgnorableWhitespace;
		assert: (parser preservesIgnorableWhitespace: true) == parser;
		assert: parser preservesIgnorableWhitespace;
		assert: parser isValidating.

	"disabling validation should disable it"
	self
		assert: (parser isValidating: false) == parser;
		deny: parser preservesIgnorableWhitespace;
		deny: parser isValidating! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/29/2016 08:24'!
testProcessingInstruction
	| document |

	document :=
		XMLDOMParser parse:
			'<?xml version="1.1" standalone="yes"?><?firstTarget first>Data?>',
			'<root><?secondTarget second?Data?></root> '.

	self
		assert: document version = 1.1;
		assert: document nodes size = 2;
		assert: document firstNode isPI;
		assert: document firstNode target = 'firstTarget';
		assert: document firstNode data = 'first>Data';
		assert: document root firstNode target = 'secondTarget';
		assert: document root firstNode data = 'second?Data'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 10/30/2016 09:40'!
testProcessingInstructionEntityReplacement
	| document doctypeDeclaration root |

	document :=
		XMLDOMParser parse:
			'<?xml version="1.1" standalone="yes"?>
			<!!DOCTYPE root [
				<!!ENTITY % first "<?firstTarget first>Data?>">
				%first;
				<!!ENTITY second "<?secondTarget second?Data?>">
			]><root>&second;</root> '.

	self
		assert: document version = 1.1;
		assert: document hasDoctypeDeclaration;
		assert: document nodes size = 1.

	doctypeDeclaration := document doctypeDeclaration.
	self
		assert: doctypeDeclaration nodes size = 3;
		assert: doctypeDeclaration nodes second isPI;
		assert: doctypeDeclaration nodes second target = 'firstTarget';
		assert: doctypeDeclaration nodes second data = 'first>Data'.

	root := document root.
	self
		assert: root nodes size = 1;
		assert: root firstNode isPI;
		assert: root firstNode target = 'secondTarget';
		assert: root firstNode data = 'second?Data'.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/30/2016 23:44'!
testRootElement
	| document root  |

	document := XMLDOMParser parse: self addressBookXML.
	self assert: document class == XMLDocument.
	root := document root.
	self assert: (root class == XMLElement).

	self assert:
		(root allNodesDetect: [:each |
			each isElement
				and: [each isNamedAny: #('AddressBook' 'addressbook')]]) == root.
	self assert: (root findElementNamed: 'addressbook') == root.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 11/4/2016 01:31'!
testUnreplacedEntityRererencePrinting
	| xml |

	xml :=
		'<!!DOCTYPE one [<!!ENTITY three "three">]>',
		'<one two="&quot;&three;&quot;">',
		'&lt;four five=&#34;&amp;six;&#34;/&gt;',
		'</one>'.
	self assert:
		((XMLDOMParser on: xml)
			isValidating: false;
			replacesContentEntityReferences: false;
			parseDocument) printString = xml.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 4/15/2016 06:23'!
testWhitespacePreservation
	| xml root notPreserved preserved |

	xml := '
		<!!DOCTYPE root [
			<!!ELEMENT root (not-preserved)>
			<!!ELEMENT not-preserved (preserved+)>
			<!!ELEMENT preserved (not-preserved?)>
			<!!ATTLIST root xml:space (default|preserve) #IMPLIED>
			<!!ATTLIST not-preserved xml:space (default|preserve) #IMPLIED>
			<!!ATTLIST preserved xml:space (default|preserve) "preserve">
		]>
		<root xml:space="preserve">
			<not-preserved xml:space="default">
				<preserved>
				</preserved>
			</not-preserved>
		</root>'.
	root := (XMLDOMParser parse: xml) root.
	self
		assert: root nodes size = 3;
		assert: root nodes first isStringNode;
		assert: root nodes first isWhitespace;
		assert: (root nodes second isElementNamed: 'not-preserved');
		assert: root nodes third isStringNode;
		assert: root nodes third isWhitespace.

	notPreserved := root nodes second.
	self
		assert: notPreserved nodes size = 1;
		assert: (notPreserved nodes first isElementNamed: 'preserved').

	preserved := notPreserved firstNode.
	self
		assert: preserved nodes size = 1;
		assert: preserved nodes first isStringNode;
		assert: preserved nodes first isWhitespace.! !

!XMLDOMParserTest methodsFor: 'tests' stamp: 'monty 3/9/2016 20:49'!
testXMLDeclaration
	| document |

	document :=
		XMLDOMParser parse:
			'<?xml version="1.0" encoding="UTF-8"?><test/>'.
	self
		assert: document version = 1.0;
		assert: document encoding = 'UTF-8';
		deny: document isStandalone.

	document :=
		XMLDOMParser parse:
			'<?xml version="1.1" encoding="utf-8" standalone="yes"?><test/>'.
	self
		assert: document version = 1.1;
		assert: document encoding = 'utf-8';
		assert: document isStandalone.! !

TestCase subclass: #XMLElementClassMapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Utils'!

XMLElementClassMapperTest subclass: #XMLBasicElementClassMapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Utils'!

!XMLBasicElementClassMapperTest methodsFor: 'acccessing' stamp: 'monty 8/26/2016 02:16'!
mapperClass
	^ XMLBasicElementClassMapper! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/12/2016 20:57'!
testClassForElement
	| mapper |

	mapper := self newMapper.
	self
		assert: (mapper classForElement: 'test') isNil;
		assert: (mapper classForElement: 'prefix:test') isNil.

	mapper
		mapElement: 'test'
		toClass: self elementClass.
	self
		assert: (mapper classForElement: 'test') == self elementClass;
		assert: (mapper classForElement: 'prefix:test') == self elementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self
		assert: (mapper classForElement: 'test') == self elementClass;
		assert: (mapper classForElement: 'prefix:test') == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self
		assert: (mapper classForElement: 'test') == self elementClass;
		assert: (mapper classForElement: 'prefix:test') == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self
		assert: (mapper classForElement: 'test') == self elementClass;
		assert: (mapper classForElement: 'prefix:test') == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		toClass: self otherElementClass.
	self
		assert: (mapper classForElement: 'test') == self elementClass;
		assert: (mapper classForElement: 'prefix:test') == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/12/2016 21:00'!
testClassForElementAttributes
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) isNil.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes) isNil.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) == self otherElementClass.
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes) == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes) == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes) == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:23'!
testClassForElementAttributesIfNone
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes
			ifNone: [#none]) == #none.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes
			ifNone: [#none]) == #none.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:10'!
testClassForElementIfNone
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			ifNone: [#none]) == #none.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			ifNone: [#none]) == #none.

	mapper
		mapElement: 'test'
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			ifNone: [self fail]) == self elementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			ifNone: [self fail]) == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			ifNone: [self fail]) == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			ifNone: [self fail]) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			ifNone: [self fail]) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/12/2016 21:07'!
testClassForElementNamespaceURI
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') isNil.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS') isNil.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS') == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS') == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS') == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS') == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS') == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/12/2016 21:09'!
testClassForElementNamespaceURIAttributes
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) isNil.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes) isNil.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:11'!
testClassForElementNamespaceURIAttributesIfNone
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [#none]) == #none.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [#none]) == #none.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:11'!
testClassForElementNamespaceURIIfNone
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			ifNone: [#none]) == #none.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			ifNone: [#none]) == #none.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self elementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			ifNone: [self fail]) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/12/2016 21:22'!
testClassForElementNamespaceURILocalNameAttributes
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) isNil.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) isNil.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:11'!
testClassForElementNamespaceURILocalNameAttributesIfNone
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [#none]) == #none.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [#none]) == #none.

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.

	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.

	"QName mappings should take precedence over NCName mappings"
	mapper
		mapElement: 'prefix:test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self otherElementClass.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self elementClass.
	self assert:
		(mapper
			classForElement: 'prefix:test'
			namespaceURI: 'testNS'
			localName: 'test'
			attributes: self attributes
			ifNone: [self fail]) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 9/21/2016 23:02'!
testCopy
	| mapper copy |

	mapper := self newMapperWithMappings.
	copy := mapper copy.
	self
		deny: mapper == copy;
		deny: mapper elementClassMap == copy elementClassMap;
		assert: mapper elementClassMap = copy elementClassMap.

	mapper elementClassMap values
		with: copy elementClassMap values
		do: [:classOrCollection :classOrCollectionCopy |
			"the collection values need to be copied so any new mappings
			in either the copy or original don't affect the other"
			classOrCollection isCollection
				ifTrue: [
					self
						deny: classOrCollection == classOrCollectionCopy;
						assert: classOrCollection = classOrCollectionCopy]
				ifFalse: [
					self deny: classOrCollection == classOrCollectionCopy]].

	mapper
		mapElement: 'test'
		toClass: self otherElementClass.
	self deny: mapper elementClassMap = copy elementClassMap.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/15/2016 15:04'!
testMapElementAttributeSpecToClass
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			mapElement: 'test'
			attributeSpec: self attributes asXMLAttributeSpec
			toClass: self elementClass) == mapper.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) == self elementClass.

	self assert:
		(mapper
			mapElement: 'test'
			attributeSpec: self attributes asXMLAttributeSpec
			toClass: self otherElementClass) == mapper.
	self assert:
		(mapper
			classForElement: 'test'
			attributes: self attributes) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/15/2016 15:05'!
testMapElementNamespaceURIAttributeSpecToClass
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			mapElement: 'test'
			namespaceURI: 'testNS'
			attributeSpec: self attributes asXMLAttributeSpec
			toClass: self elementClass) == mapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self elementClass.

	self assert:
		(mapper
			mapElement: 'test'
			namespaceURI: 'testNS'
			attributeSpec: self attributes asXMLAttributeSpec
			toClass: self otherElementClass) == mapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS'
			attributes: self attributes) == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/15/2016 15:05'!
testMapElementNamespaceURIToClass
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			mapElement: 'test'
			namespaceURI: 'testNS'
			toClass: self elementClass) == mapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') == self elementClass.

	self assert:
		(mapper
			mapElement: 'test'
			namespaceURI: 'testNS'
			toClass: self otherElementClass) == mapper.
	self assert:
		(mapper
			classForElement: 'test'
			namespaceURI: 'testNS') == self otherElementClass.! !

!XMLBasicElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/15/2016 15:06'!
testMapElementToClass
	| mapper |

	mapper := self newMapper.
	self assert:
		(mapper
			mapElement: 'test'
			toClass: self elementClass) == mapper.
	self assert: (mapper classForElement: 'test') == self elementClass.

	self assert:
		(mapper
			mapElement: 'test'
			toClass: self otherElementClass) == mapper.
	self assert: (mapper classForElement: 'test') == self otherElementClass.! !

!XMLElementClassMapperTest methodsFor: 'acccessing' stamp: 'monty 6/30/2017 06:53'!
attributes
	^ XMLAttributeDictionary
		with: 'name' -> 'value'
		with: 'name2' -> 'value2'! !

!XMLElementClassMapperTest methodsFor: 'acccessing' stamp: 'monty 7/27/2016 08:19'!
elementClass
	^ XMLElement! !

!XMLElementClassMapperTest methodsFor: 'acccessing' stamp: 'monty 7/27/2016 08:20'!
mapperClass
	^ XMLElementClassMapper ! !

!XMLElementClassMapperTest methodsFor: 'instance creation' stamp: 'monty 7/27/2016 08:19'!
newMapper
	^ self mapperClass new! !

!XMLElementClassMapperTest methodsFor: 'instance creation' stamp: 'monty 8/26/2016 02:16'!
newMapperWithMappings
	| mapper |

	mapper := XMLBasicElementClassMapper new.
	mapper
		mapElement: 'test'
		toClass: self elementClass.
	mapper
		mapElement: 'test'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		toClass: self elementClass.
	mapper
		mapElement: 'test'
		namespaceURI: 'testNS'
		attributeSpec: self attributes asXMLAttributeSpec
		toClass: self elementClass.
	^ mapper.! !

!XMLElementClassMapperTest methodsFor: 'acccessing' stamp: 'monty 7/27/2016 08:19'!
otherElementClass
	^ XMLFElement! !

!XMLElementClassMapperTest methodsFor: 'tests' stamp: 'monty 7/28/2016 08:51'!
testCamelCasedNameFromClassNameSegments
	| mapper |

	mapper := self newMapper.
	#(#('ONE' 'Two' 'Three')
		#('One' 'Two' 'Three')
		#('A' 'Bc' 'D')
		#('Ab' 'Cd')
		#('Ab')
		#('AB')
		#('a' 'B')
		#('a' 'Ba'))
		with:
			#('oneTwoThree'
				'oneTwoThree'
				'aBcD'
				'abCd'
				'ab'
				'ab'
				'aB'
				'aBa')
		do: [:segments :name |
			self assert:
				(mapper camelCasedNameFromClassNameSegments: segments) =
					name].! !

!XMLElementClassMapperTest methodsFor: 'tests' stamp: 'monty 7/27/2016 08:24'!
testClassNameSegmentsFrom
	| mapper |

	mapper := self newMapper.
	#('ONETwoThree'
		'OneTwoThree'
		'ABcD'
		'AbCd'
		'Ab'
		'AB'
		'aB'
		'aBa')
		with:
			#(#('ONE' 'Two' 'Three')
				#('One' 'Two' 'Three')
				#('A' 'Bc' 'D')
				#('Ab' 'Cd')
				#('Ab')
				#('AB')
				#('a' 'B')
				#('a' 'Ba'))
		do: [:string :segments |
			self assert:
				(mapper classNameSegmentsFrom: string) =
					segments asOrderedCollection].! !

!XMLElementClassMapperTest methodsFor: 'tests' stamp: 'monty 7/28/2016 08:53'!
testHyphenatedNameFromClassNameSegments
	| mapper |

	mapper := self newMapper.
	#(#('ONE' 'Two' 'Three')
		#('One' 'Two' 'Three')
		#('A' 'Bc' 'D')
		#('Ab' 'Cd')
		#('Ab')
		#('AB')
		#('a' 'B')
		#('a' 'Ba'))
		with:
			#('one-two-three'
				'one-two-three'
				'a-bc-d'
				'ab-cd'
				'ab'
				'ab'
				'a-b'
				'a-ba')
		do: [:segments :name |
			self assert:
				(mapper hyphenatedNameFromClassNameSegments: segments) =
					name].! !

!XMLElementClassMapperTest methodsFor: 'tests' stamp: 'monty 8/18/2016 05:41'!
testNameFromClassNameSegments
	| mapper |

	mapper := self newMapper.
	#(#('ONE' 'Two' 'Three')
		#('One' 'Two' 'Three')
		#('A' 'Bc' 'D')
		#('Ab' 'Cd')
		#('Ab')
		#('AB')
		#('a' 'B')
		#('a' 'Ba'))
		with:
			#('ONETwoThree'
				'OneTwoThree'
				'ABcD'
				'AbCd'
				'Ab'
				'AB'
				'aB'
				'aBa')
		do: [:segments :name |
			self assert:
				(mapper nameFromClassNameSegments: segments) =
					name].! !

!XMLElementClassMapperTest methodsFor: 'tests' stamp: 'monty 7/28/2016 08:54'!
testUnderscoredNameFromClassNameSegments
	| mapper |

	mapper := self newMapper.
	#(#('ONE' 'Two' 'Three')
		#('One' 'Two' 'Three')
		#('A' 'Bc' 'D')
		#('Ab' 'Cd')
		#('Ab')
		#('AB')
		#('a' 'B')
		#('a' 'Ba'))
		with:
			#('one_two_three'
				'one_two_three'
				'a_bc_d'
				'ab_cd'
				'ab'
				'ab'
				'a_b'
				'a_ba')
		do: [:segments :name |
			self assert:
				(mapper underscoredNameFromClassNameSegments: segments) =
					name].! !

TestCase subclass: #XMLEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLEncodingTest methodsFor: 'converting' stamp: 'monty 2/12/2016 05:58'!
asciiToUTF16BE: anASCIIString
	^ XMLStreamAdapterTest asciiToUTF16BE: anASCIIString! !

!XMLEncodingTest methodsFor: 'converting' stamp: 'monty 2/12/2016 05:58'!
asciiToUTF16LE: anASCIIString
	^ XMLStreamAdapterTest asciiToUTF16LE: anASCIIString! !

!XMLEncodingTest methodsFor: 'converting' stamp: 'monty 2/12/2016 05:58'!
asciiToUTF32BE: anASCIIString
	^ XMLStreamAdapterTest asciiToUTF32BE: anASCIIString! !

!XMLEncodingTest methodsFor: 'converting' stamp: 'monty 2/12/2016 05:58'!
asciiToUTF32LE: anASCIIString
	^ XMLStreamAdapterTest asciiToUTF32LE: anASCIIString! !

!XMLEncodingTest methodsFor: 'asserting' stamp: 'monty 11/23/2016 03:39'!
assertIsDecodedSourceXMLDocument: aDocument
	self assert: (self isDecodedSourceXMLDocument: aDocument)! !

!XMLEncodingTest methodsFor: 'converting' stamp: 'monty 7/29/2016 08:23'!
convertableStreamOn: aString
	^ XMLDecodingReadStreamAdapter on: aString readStream! !

!XMLEncodingTest methodsFor: 'asserting' stamp: 'monty 11/23/2016 03:42'!
denyIsDecodedSourceXMLDocument: aDocument
	self deny: (self isDecodedSourceXMLDocument: aDocument)! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 11/8/2014 19:48'!
encodingDeclaration: anEncoding
	^ '<?xml version="1.0" encoding="', anEncoding, '"?>'! !

!XMLEncodingTest methodsFor: 'testing' stamp: 'monty 11/23/2016 03:39'!
isDecodedSourceXMLDocument: aDocument
	aDocument nodes size = 1
		ifFalse: [^ false].
	(aDocument firstNode isElementNamed: 'encoding-test')
		ifFalse: [^ false].
	aDocument firstNode nodes size = 1
		ifFalse: [^ false].
	^ aDocument firstNode firstNode isStringNode: 'encoding test'.! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 2/11/2016 02:18'!
sourceContent
	^ 'encoding test'! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 2/11/2016 02:18'!
sourceXML
	^ self sourceXMLWithContent: self sourceContent! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 2/10/2016 23:39'!
sourceXMLWithContent: aCharacterOrString
	^ '<encoding-test>', aCharacterOrString asString, '</encoding-test>'! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 2/12/2016 00:20'!
sourceXMLWithEncoding: anEncoding andASCIIContentAsUTF16BE: anASCIIContentString
	^ ((self encodingDeclaration: anEncoding) allButLast: 2),
		(self asciiToUTF16BE: '?>', anASCIIContentString)! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 2/12/2016 00:20'!
sourceXMLWithEncoding: anEncoding andASCIIContentAsUTF16LE: anASCIIContentString
	^ ((self encodingDeclaration: anEncoding) allButLast: 2),
		(self asciiToUTF16LE: '?>', anASCIIContentString)! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 2/12/2016 00:20'!
sourceXMLWithEncoding: anEncoding andASCIIContentAsUTF32BE: anASCIIContentString
	^ ((self encodingDeclaration: anEncoding) allButLast: 2),
		(self asciiToUTF32BE: '?>', anASCIIContentString)! !

!XMLEncodingTest methodsFor: 'source' stamp: 'monty 2/12/2016 00:20'!
sourceXMLWithEncoding: anEncoding andASCIIContentAsUTF32LE: anASCIIContentString
	^ ((self encodingDeclaration: anEncoding) allButLast: 2),
		(self asciiToUTF32LE: '?>', anASCIIContentString)! !

!XMLEncodingTest methodsFor: 'converting' stamp: 'monty 2/14/2016 04:02'!
stringFrom: aCollection
	^ XMLStreamAdapterTest stringFrom: aCollection! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 8/1/2016 09:58'!
testDecodingBinary
	| source binarySource parser stream |

	source := self sourceXML.
	binarySource := source asArray collect: [:each | each asciiValue].
	parser := (SAXHandler on: binarySource) parser.
	stream := parser tokenizer streamReader stream.
	self
		assert: stream isXMLConvertingStreamAdapter;
		assert: stream hasDefaultStreamConverter;
		assert: stream upToEnd = source.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testDecodingCharacterReferences
	| document |

	document :=
		XMLDOMParser parse:
			(self sourceXMLWithContent:
				(String streamContents: [:stream |
					self sourceContent do: [:each |
						stream
							nextPutAll: '&#';
							nextPutAll: each asciiValue asString;
							nextPut: $;]])).
	self assert: document root contentString = self sourceContent.

	document :=
		XMLDOMParser parse:
			(self sourceXMLWithContent:
				(String streamContents: [:stream |
					self sourceContent do: [:each |
						stream
							nextPutAll: '&#x';
							nextPutAll: each asciiValue printStringHex asLowercase;
							nextPut: $;]])).
	self assert: document root contentString = self sourceContent.

	document :=
		XMLDOMParser parse:
			(self sourceXMLWithContent:
				(String streamContents: [:stream |
					self sourceContent do: [:each |
						stream
							nextPutAll: '&#x';
							nextPutAll: each asciiValue printStringHex asUppercase;
							nextPut: $;]])).
	self assert: document root contentString = self sourceContent.

	#('&#0;' '&#x110000;' '&#-1;' '&#9:;' '&#xFFG;') do: [:each |
		self
			should: [XMLDOMParser parse: (self sourceXMLWithContent: each)]
			raise: XMLWellFormednessException].

	XMLCharacterMethodsTest nonChars do: [:each |
		self
			should: [
				XMLDOMParser parse:
					(self sourceXMLWithContent: '&#', each asciiValue asString, ';')]
			raise: XMLWellFormednessException].! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 2/10/2016 23:40'!
testEncodingDeclarationLatin1
	| xml |

	xml := self sourceXMLWithContent: (self stringFrom: #(126 127 128 255)).
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf8BOM, (self encodingDeclaration: 'UTF-8'), xml)]
		raise: XMLEncodingException.
	self
		shouldnt: [
			SAXHandler parse:
				(self convertableStreamOn:
					self utf8BOM, (self encodingDeclaration: 'latin-1'), xml)]
		raise: XMLEncodingException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:49'!
testEncodingDeclarationUTF16BE
	| document |

	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self encodingDeclaration: 'UTF-16-BE'), self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-BE'
						andASCIIContentAsUTF16LE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-BE'
						andASCIIContentAsUTF32BE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-BE'
						andASCIIContentAsUTF32LE: self sourceXML))]
		raise: XMLParserException.

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self convertableStreamOn:
						(self
							sourceXMLWithEncoding: 'UTF-16-BE'
							andASCIIContentAsUTF16BE: self sourceXML))]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-BE'
						andASCIIContentAsUTF16BE: self sourceXML)))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:48'!
testEncodingDeclarationUTF16LE
	| document |

	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self encodingDeclaration: 'UTF-16-LE'), self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-LE'
						andASCIIContentAsUTF16BE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-LE'
						andASCIIContentAsUTF32BE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-LE'
						andASCIIContentAsUTF32LE: self sourceXML))]
		raise: XMLParserException.

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self convertableStreamOn:
						(self
							sourceXMLWithEncoding: 'UTF-16-LE'
							andASCIIContentAsUTF16LE: self sourceXML))]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-16-LE'
						andASCIIContentAsUTF16LE: self sourceXML)))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:48'!
testEncodingDeclarationUTF32BE
	| document |

	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self encodingDeclaration: 'UTF-32-BE'), self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-BE'
						andASCIIContentAsUTF16BE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-BE'
						andASCIIContentAsUTF16LE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-BE'
						andASCIIContentAsUTF32LE: self sourceXML))]
		raise: XMLParserException.

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self convertableStreamOn:
						(self
							sourceXMLWithEncoding: 'UTF-32-BE'
							andASCIIContentAsUTF32BE: self sourceXML))]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-BE'
						andASCIIContentAsUTF32BE: self sourceXML)))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:47'!
testEncodingDeclarationUTF32LE
	| document |

	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self encodingDeclaration: 'UTF-32-LE'), self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-LE'
						andASCIIContentAsUTF16BE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-LE'
						andASCIIContentAsUTF16LE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-LE'
						andASCIIContentAsUTF32BE: self sourceXML))]
		raise: XMLParserException.

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self convertableStreamOn:
						(self
							sourceXMLWithEncoding: 'UTF-32-LE'
							andASCIIContentAsUTF32LE: self sourceXML))]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-32-LE'
						andASCIIContentAsUTF32LE: self sourceXML)))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:46'!
testEncodingDeclarationUTF8
	| document |

	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-8'
						andASCIIContentAsUTF16BE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-8'
						andASCIIContentAsUTF16LE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-8'
						andASCIIContentAsUTF32BE: self sourceXML))]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				(self convertableStreamOn:
					(self
						sourceXMLWithEncoding: 'UTF-8'
						andASCIIContentAsUTF32LE: self sourceXML))]
		raise: XMLParserException.

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self convertableStreamOn:
						(self encodingDeclaration: 'UTF-8'), self sourceXML)]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:46'!
testExternalEntityByteOrderMarkDetection
	| content entity |

	content :=
		'<!!DOCTYPE encoding-test [
				<!!ENTITY external SYSTEM "extern.ent">
			]>', (self sourceXMLWithContent: '&external;').
	entity := self sourceContent.
	(Array
		with: self utf8BOM, entity
		with: self utf16BigEndianBOM, (self asciiToUTF16BE: entity)
		with: self utf16LittleEndianBOM, (self asciiToUTF16LE: entity)
		with: self utf32BigEndianBOM, (self asciiToUTF32BE: entity)
		with: self utf32LittleEndianBOM, (self asciiToUTF32LE: entity))
		do: [:each | | resolver document |
			(resolver := DTDStaticExternalEntityResolver new)
				externalEntityAtURI: 'extern.ent'
				put: each.
			self
				shouldnt: [
					document :=
						(XMLDOMParser on: content)
							externalEntityResolver: resolver copy;
							resolvesExternalEntities: true;
							parseDocument]
				raise: XMLParserException.
			self assertIsDecodedSourceXMLDocument: document.
			[
				document :=
					(XMLDOMParser on: content)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						decodesCharacters: false;
						parseDocument]
				on: XMLParserException
				do: [:error | document := nil].
			document
				ifNotNil: [self denyIsDecodedSourceXMLDocument: document]].! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:36'!
testExternalEntityImplicitEncodingDetection
	| content entity |

	content :=
		'<!!DOCTYPE encoding-test [
				<!!ENTITY external SYSTEM "extern.ent">
			]>', (self sourceXMLWithContent: '&external;').
	entity := self sourceContent.
	(Array
		with: (self asciiToUTF16BE: entity)
		with: (self asciiToUTF16LE: entity)
		with: (self asciiToUTF32BE: entity)
		with: (self asciiToUTF32LE: entity))
		do: [:each | | resolver document |
			(resolver := DTDStaticExternalEntityResolver new)
				externalEntityAtURI: 'extern.ent'
				put: each.
			self
				shouldnt: [
					document :=
						(XMLDOMParser on: content)
							externalEntityResolver: resolver copy;
							resolvesExternalEntities: true;
							parseDocument]
				raise: XMLParserException.
			self assertIsDecodedSourceXMLDocument: document.
			self
				should: [
					(SAXHandler on: content)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						decodesCharacters: false;
						parseDocument]
				raise: XMLParserException].! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:35'!
testExternalEntityTextDeclaration
	| content entity |

	content :=
		'<!!DOCTYPE encoding-test [
				<!!ENTITY external SYSTEM "extern.ent">
			]>', (self sourceXMLWithContent: '&external;').
	entity := self sourceContent.
	(Array
		with:
			(self
				sourceXMLWithEncoding: 'UTF-16-BE'
				andASCIIContentAsUTF16BE: entity)
		with:
			(self
				sourceXMLWithEncoding: 'UTF-16-LE'
				andASCIIContentAsUTF16LE: entity)
		with:
			(self
				sourceXMLWithEncoding: 'UTF-32-BE'
				andASCIIContentAsUTF32BE: entity)
		with:
			(self
				sourceXMLWithEncoding: 'UTF-32-LE'
				andASCIIContentAsUTF32LE: entity))
		do: [:each | | resolver document |
			(resolver := DTDStaticExternalEntityResolver new)
				externalEntityAtURI: 'extern.ent'
				put: each.
			self
				shouldnt: [
					document :=
						(XMLDOMParser on: content)
							externalEntityResolver: resolver copy;
							resolvesExternalEntities: true;
							parseDocument]
				raise: XMLParserException.
			self assertIsDecodedSourceXMLDocument: document.
			self
				should: [
					(SAXHandler on: content)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						decodesCharacters: false;
						parseDocument]
				raise: XMLParserException].! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:11'!
testExternalSubsetByteOrderMarkDetection
	| content subset |

	content :=
		'<!!DOCTYPE encoding-test SYSTEM "extern.dtd">',
		(self sourceXMLWithContent: '&external;').
	subset := '<!!ENTITY external "', self sourceContent, '">'.
	(Array
		with: self utf8BOM, subset
		with: self utf16BigEndianBOM, (self asciiToUTF16BE: subset)
		with: self utf16LittleEndianBOM, (self asciiToUTF16LE: subset)
		with: self utf32BigEndianBOM, (self asciiToUTF32BE: subset)
		with: self utf32LittleEndianBOM, (self asciiToUTF32LE: subset))
		do: [:each | | resolver document |
			(resolver := DTDStaticExternalEntityResolver new)
				externalEntityAtURI: 'extern.dtd'
				put: each.
			self
				shouldnt: [
					document :=
						(XMLDOMParser on: content)
							externalEntityResolver: resolver copy;
							resolvesExternalEntities: true;
							parseDocument]
				raise: XMLParserException.
			self assertIsDecodedSourceXMLDocument: document.
			self
				should: [
					(SAXHandler on: content)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						decodesCharacters: false;
						parseDocument]
				raise: XMLParserException].! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:11'!
testExternalSubsetImplicitEncodingDetection
	| content subset |

	content :=
		'<!!DOCTYPE encoding-test SYSTEM "extern.dtd">',
		(self sourceXMLWithContent: '&external;').
	subset := '<!!ENTITY external "', self sourceContent, '">'.
	(Array
		with: (self asciiToUTF16BE: subset)
		with: (self asciiToUTF16LE: subset)
		with: (self asciiToUTF32BE: subset)
		with: (self asciiToUTF32LE: subset))
		do: [:each | | resolver document |
			(resolver := DTDStaticExternalEntityResolver new)
				externalEntityAtURI: 'extern.dtd'
				put: each.
			self
				shouldnt: [
					document :=
						(XMLDOMParser on: content)
							externalEntityResolver: resolver copy;
							resolvesExternalEntities: true;
							parseDocument]
				raise: XMLParserException.
			self assertIsDecodedSourceXMLDocument: document.
			self
				should: [
					(SAXHandler on: content)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						decodesCharacters: false;
						parseDocument]
				raise: XMLParserException].! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 03:10'!
testExternalSubsetTextDeclaration
	| content subset |

	content :=
		'<!!DOCTYPE encoding-test SYSTEM "extern.dtd">',
		(self sourceXMLWithContent: '&external;').
	subset := '<!!ENTITY external "', self sourceContent, '">'.
	(Array
		with:
			(self
				sourceXMLWithEncoding: 'UTF-16-BE'
				andASCIIContentAsUTF16BE: subset)
		with:
			(self
				sourceXMLWithEncoding: 'UTF-16-LE'
				andASCIIContentAsUTF16LE: subset)
		with:
			(self
				sourceXMLWithEncoding: 'UTF-32-BE'
				andASCIIContentAsUTF32BE: subset)
		with:
			(self
				sourceXMLWithEncoding: 'UTF-32-LE'
				andASCIIContentAsUTF32LE: subset))
			do: [:each | | resolver document |
				(resolver := DTDStaticExternalEntityResolver new)
					externalEntityAtURI: 'extern.dtd'
					put: each.
				self
					shouldnt: [
						document :=
							(XMLDOMParser on: content)
								externalEntityResolver: resolver copy;
								resolvesExternalEntities: true;
								parseDocument]
					raise: XMLParserException.
				self assertIsDecodedSourceXMLDocument: document.
				self
					should: [
						(SAXHandler on: content)
							externalEntityResolver: resolver copy;
							resolvesExternalEntities: true;
							decodesCharacters: false;
							parseDocument]
					raise: XMLParserException].! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 02:59'!
testImplicitUTF16BigEndianEncodingDetection
	| document |

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self asciiToUTF16BE: self sourceXML)]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self asciiToUTF16BE: self sourceXML))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 02:59'!
testImplicitUTF16LittleEndianEncodingDetection
	| document |

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self asciiToUTF16LE: self sourceXML)]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self asciiToUTF16LE: self sourceXML))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 02:58'!
testImplicitUTF32BigEndianEncodingDetection
	| document |

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self asciiToUTF32BE: self sourceXML)]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self asciiToUTF32BE: self sourceXML))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 02:58'!
testImplicitUTF32LittleEndianEncodingDetection
	| document |

	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					(self asciiToUTF32LE: self sourceXML)]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				(self asciiToUTF32LE: self sourceXML))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 02:58'!
testUTF16BigEndianByteOrderMarkDetection
	| document |

	self
		should: [
			SAXHandler parse:
				self utf16BigEndianBOM, self sourceXML]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf16BigEndianBOM, (self asciiToUTF16LE: self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf16BigEndianBOM, (self asciiToUTF32BE: self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf16BigEndianBOM, (self asciiToUTF32LE: self sourceXML)]
		raise: XMLParserException.
	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					self utf16BigEndianBOM, (self asciiToUTF16BE: self sourceXML)]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				self utf16BigEndianBOM, (self asciiToUTF16BE: self sourceXML))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 02:58'!
testUTF16LittleEndianByteOrderMarkDetection
	| document |

	self
		should: [
			SAXHandler parse:
				self utf16LittleEndianBOM, self sourceXML]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf16LittleEndianBOM, (self asciiToUTF16BE: self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf16LittleEndianBOM, (self asciiToUTF32BE: self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf16LittleEndianBOM, (self asciiToUTF32LE: self sourceXML)]
		raise: XMLParserException.
	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					self utf16LittleEndianBOM, (self asciiToUTF16LE: self sourceXML)]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				self utf16LittleEndianBOM, (self asciiToUTF16LE: self sourceXML))
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 11/23/2016 02:56'!
testUTF8ByteOrderMarkDetection
	| document |

	self
		should: [
			SAXHandler parse:
				self utf8BOM, (self asciiToUTF16BE: self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf8BOM, (self asciiToUTF16LE: self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf8BOM, (self asciiToUTF32BE: self sourceXML)]
		raise: XMLParserException.
	self
		should: [
			SAXHandler parse:
				self utf8BOM, (self asciiToUTF32LE: self sourceXML)]
		raise: XMLParserException.
	self
		shouldnt: [
			document :=
				XMLDOMParser parse:
					self utf8BOM, self sourceXML]
		raise: XMLParserException.
	self assertIsDecodedSourceXMLDocument: document.
	self
		should: [
			(SAXHandler on:
				self utf8BOM, self sourceXML)
					decodesCharacters: false;
					parseDocument]
		raise: XMLParserException.! !

!XMLEncodingTest methodsFor: 'tests' stamp: 'monty 2/10/2016 23:32'!
testWideCharacterNames
	| wideNames document |

	(wideNames := OrderedCollection new)
		addLast: (self stringFrom: #(16rC0 16rD6 16rD8 16rF6 16rF8 16r2FF $- $.));
		addLast: (self stringFrom: #(16r370 16r37D 16r37F 16r1FFF 16r200C $0 $9));
		addLast: (self stringFrom: #(16r200D 16r2070 16r218F 16r2C00 16r2FEF 16rB7));
		addLast: (self stringFrom: #(16r3001 16rD7FF 16rF900 16rFDCF 16rFDF0 16r0300));
		addLast: (self stringFrom: #(16rFFFD 16r10000 16rEFFFF 16r036F 16r203F 16r2040)).

	self
		shouldnt: [| source |
			source :=
				'<!!DOCTYPE {1} [
					<!!ELEMENT {1} ({2}, {3}, {4})>
					<!!ELEMENT {2} EMPTY>
					<!!ELEMENT {3} (#PCDATA)*>
					<!!ELEMENT {4} EMPTY>
					<!!ATTLIST {1} {5} ({3} | {4} | {5}) #IMPLIED>
				]>
				<{1} {5}="{4}">
					<{2}/>
					<{3}>{5}</{3}>
					<{4}/>
				</{1}>' format: wideNames.

			"a char-wise copy of source is parsed because wide chars aren't immediate
			types in pre-Spur Pharo/Squeak, so this can catch improper use of == on
			wide chars in those images"
			document := XMLDOMParser parse: (source collect: [:each | each copy])]
		raise: XMLParserException.

	self
		assert: document root name = wideNames first;
		assert: (document root attributeAt: wideNames fifth) = wideNames fourth;
		assert: (document root elementNames) asOrderedCollection = (wideNames copyFrom: 2 to: 4);
		assert: document contentString = wideNames fifth.! !

!XMLEncodingTest methodsFor: 'accessing' stamp: 'monty 1/22/2016 21:04'!
utf16BigEndianBOM
	^ XMLUTF16BigEndianStreamConverter byteOrderMark! !

!XMLEncodingTest methodsFor: 'accessing' stamp: 'monty 1/22/2016 21:05'!
utf16LittleEndianBOM
	^ XMLUTF16LittleEndianStreamConverter byteOrderMark! !

!XMLEncodingTest methodsFor: 'accessing' stamp: 'monty 1/22/2016 21:06'!
utf32BigEndianBOM
	^ XMLUTF32BigEndianStreamConverter byteOrderMark! !

!XMLEncodingTest methodsFor: 'accessing' stamp: 'monty 1/22/2016 21:06'!
utf32LittleEndianBOM
	^ XMLUTF32LittleEndianStreamConverter byteOrderMark! !

!XMLEncodingTest methodsFor: 'accessing' stamp: 'monty 1/22/2016 21:05'!
utf8BOM
	^ XMLUTF8StreamConverter byteOrderMark! !

TestCase subclass: #XMLIntegerReaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Utils'!

!XMLIntegerReaderTest methodsFor: 'accessing' stamp: 'monty 10/24/2014 20:31'!
maxBase
	^ XMLIntegerReader maxBase! !

!XMLIntegerReaderTest methodsFor: 'instance creation' stamp: 'monty 9/28/2017 12:52'!
newStreamOn: aCollection
	^ XMLExceptionRaisingReadStream on: aCollection! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 9/29/2017 17:37'!
testBaseMarker
	2 to: self maxBase do: [:base | | stream defaultBase |
		defaultBase := (base - 1) max: 2.
		stream := self newStreamOn: ((base printStringBase: base) copyWithFirst: $#).
		self
			assert:
				(XMLIntegerReader
					readFrom: stream
					withBase: base
					andPrefixes: '@#$'
					orBase: defaultBase) = base;
			assert: stream atEnd.

		stream := self newStreamOn: (base printStringBase: defaultBase).
		self
			assert:
				(XMLIntegerReader
					readFrom: stream
					withBase: base
					andPrefixes: '@#$'
					orBase: defaultBase) = base;
			assert: stream atEnd]! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 9/28/2017 12:57'!
testBases
	2 to: self maxBase do: [:base | | stream |
		(0 to: base), (base + 1 to: base * 10 by: base) do: [:i |
			stream := self newStreamOn: (i printStringBase: base).
			self
				assert: (XMLIntegerReader readFrom: stream withBase: base) = i;
				assert: stream atEnd]].
	self
		should: [
			XMLIntegerReader
				readFrom: (self newStreamOn: '1')
				withBase: 1]
		raise: Error.
	self
		should: [
			XMLIntegerReader
				readFrom: (self newStreamOn: '1')
				withBase: self maxBase + 1]
		raise: Error.! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 9/28/2017 12:57'!
testMaxIntegerValue
	| maxValue |

	maxValue := XMLIntegerReader maxIntegerValue.
	2 to: self maxBase do: [:base |
		self assert:
			(XMLIntegerReader
				readFrom: (self newStreamOn: (maxValue printStringBase: base))
				withBase: base) = maxValue.
		1 to: base do: [:i |
			self  assert:
				(XMLIntegerReader
					readFrom: (self newStreamOn: ((maxValue + i) printStringBase: base))
					withBase: base) = maxValue]].! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 9/28/2017 12:58'!
testNonDigit
	2 to: self maxBase do: [:base | | digitInterval letterInterval uppercaseLetterInterval |
		base > 10
			ifTrue: [
				digitInterval := $0 asciiValue to: $9 asciiValue.
				letterInterval := $a asciiValue to: $a asciiValue + (base - 11).
				uppercaseLetterInterval := $A asciiValue to: $A asciiValue + (base - 11)]
			ifFalse: [
				digitInterval := $0 asciiValue to: $0 asciiValue + base - 1.
				letterInterval := #().
				uppercaseLetterInterval := #()].
		0 to: 256 do: [:each | | char reader |
			char := each asCharacter.
			reader := XMLIntegerReader on: (self newStreamOn: char asString).
			((digitInterval includes: each)
				or: [(letterInterval includes: each)
					or: [uppercaseLetterInterval includes: each]])
				ifTrue: [
					self
						assert: (reader nextIntegerWithBase: base) notNil;
						assert: reader atEnd]
				ifFalse: [
					self
						assert: (reader nextIntegerWithBase: base) isNil;
						deny: reader atEnd;
						assert: reader next = char;
						assert: reader atEnd]]]! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 9/28/2017 12:58'!
testPositioning
	| reader string |

	string := 'test'.
	reader := XMLIntegerReader on: (self newStreamOn: string).
	string do: [:each |
		self
			deny: reader atEnd;
			assert: reader peek = each;
			assert: reader next = each].
	self
		assert: reader atEnd;
		assert: reader peek isNil;
		assert: reader next isNil.! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 9/29/2017 17:37'!
testPrintStream
	| printStream reader |

	printStream := String new writeStream.
	(reader := XMLIntegerReader on: (self newStreamOn: '123xABChdefO11'))
		printStream: printStream.
	self
		assert: (reader nextIntegerWithBase: 10) = 123;
		assert: printStream contents = '123';
		assert: (reader nextIntegerWithBase: 16 andPrefixes: 'x' orBase: 10) = 2748;
		assert: printStream contents = '123xABC';
		assert: (reader nextIntegerWithBase: 16 andPrefixes: 'h' orBase: 10) = 3567;
		assert: printStream contents = '123xABChdef'.

	reader printStream: nil.
	self
		assert: (reader nextIntegerWithBase: 8 andPrefixes: 'oO' orBase: 10) = 9;
		assert: printStream contents = '123xABChdef';
		assert: reader atEnd.! !

!XMLIntegerReaderTest methodsFor: 'tests' stamp: 'monty 9/28/2017 12:59'!
testReadLimit
	2 to: self maxBase do: [:base | | stream |
		"101 regardless of base"
		stream := self newStreamOn: (base * base + 1 printStringBase: base).
		self
			assert: (XMLIntegerReader readFrom: stream withBase: base upTo: 2) = base;
			deny: stream atEnd;
			assert: stream next == $1]! !

TestCase subclass: #XMLKeyValueCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Utils'!

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 9/17/2016 14:21'!
associations
	| associations |

	associations := Array new: self maxSize.
	1 to: associations size do: [:i |
		associations
			at: i
			put: ('key', i asString) -> ('value', i asString)].
	^ associations.! !

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 11/15/2014 20:42'!
cacheClass
	^ XMLKeyValueCache! !

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 9/26/2016 13:11'!
defaultMaxSize
	^ 32! !

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 9/17/2016 14:22'!
keys
	^ self associations collect: [:each | each key]! !

!XMLKeyValueCacheTest methodsFor: 'enumerating' stamp: 'monty 9/17/2016 14:23'!
keysAndValuesDo: aBlock
	self associations do: [:each |
		aBlock
			value: each key
			value: each value]! !

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 11/15/2014 20:57'!
maxSize
	^ 20! !

!XMLKeyValueCacheTest methodsFor: 'instance creation' stamp: 'monty 11/15/2014 20:58'!
newCache
	^ self cacheClass new! !

!XMLKeyValueCacheTest methodsFor: 'instance creation' stamp: 'monty 11/15/2014 21:18'!
newCacheWithEntries
	| cache |

	cache := self cacheClass maxSize: self maxSize.
	self keysAndValuesDo: [:key :value |
		cache
			at: key
			put: value].
	^ cache.! !

!XMLKeyValueCacheTest methodsFor: 'asserting' stamp: 'monty 9/17/2016 14:42'!
should: aBlock inAnyOrderEnumerate: aCollection
	| enumerated |

	enumerated := OrderedCollection new.
	aBlock value: [:each | enumerated addLast: each].
	self
		assert: enumerated size = aCollection size;
		assert: enumerated asSet = aCollection asSet.! !

!XMLKeyValueCacheTest methodsFor: 'asserting' stamp: 'monty 9/17/2016 14:49'!
should: aBlock inAnyOrderEnumerateKeysAndValues: anAssociationCollection
	| enumerated |

	enumerated := OrderedCollection new.
	aBlock value: [:first :second |
		enumerated addLast: first -> second].
	self
		assert: enumerated size = anAssociationCollection size;
		assert: enumerated asSet = anAssociationCollection asSet.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:30'!
testAt
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert: (cache at: key) = value].
	self assert: (cache at: 'absentKey') isNil.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 21:20'!
testAtIfAbsent
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert:
			(cache
				at: key
				ifAbsent: [self fail]) = value].
	self assert:
		(cache
			at: 'absentKey'
			ifAbsent: ['absentValue']) = 'absentValue'.

	"the ifAbsent: block can modify the cache too, so make sure
	it is cleared if needed to make room"
	self assert:
		(cache
			at: 'absentKey'
			ifAbsent: [
				cache
					at: 'newKey'
					put: 'newValue']) = 'newValue'.
	self
		assert: cache size = 1;
		assert: (cache at: 'newKey') = 'newValue'.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 21:21'!
testAtIfAbsentPut
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert:
			(cache
				at: key
				ifAbsentPut: [self fail]) = value.
		self
			assert: (cache at: key) = value;
			assert: cache size = self maxSize].
	self assert:
		(cache
			at: 'newKey'
			ifAbsentPut: ['newValue']) = 'newValue'.
	self
		assert: (cache at: 'newKey') = 'newValue';
		assert: cache size = 1.

	"the ifAbsentPut: block can modify the cache too, so make sure
	it is cleared if needed to make room"
	cache := self newCacheWithEntries.
	self assert:
		(cache
			at: 'newKey'
			ifAbsentPut: [
				cache
					at: 'newKeyTwo'
					put: 'newValue']) = 'newValue'.
	self
		assert: cache size = 2;
		assert: (cache at: 'newKey') = 'newValue';
		assert: (cache at: 'newKeyTwo') = 'newValue'.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 21:21'!
testAtIfPresent
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert:
			(cache
				at: key
				ifPresent: [:each | #present -> each]) = (#present -> value).
		"ensure cull: is used"
		self assert:
			(cache
				at: key
				ifPresent: [#present]) = #present].
	self assert:
		(cache
			at: 'absentKey'
			ifPresent: [self fail]) isNil.

	"the ifPresent: block can modify the cache too, so make sure
	it is cleared if needed to make room"
	self assert:
		(cache
			at: 'absentKey'
			ifAbsent: [
				cache
					at: 'newKey'
					put: 'newValue']) = 'newValue'.
	self
		assert: cache size = 1;
		assert: (cache at: 'newKey') = 'newValue'.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 21:48'!
testAtIfPresentPut
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert:
			(cache
				at: key
				ifPresent: [:each | each ~= value]
				put: [self fail]) = value.
		self assert: (cache at: key) = value.

		"ensure cull: is used"
		self assert:
			(cache
				at: key
				ifPresent: [false]
				put: [self fail]) = value.
		self assert: (cache at: key) = value.

		self assert:
			(cache
				at: key
				ifPresent: [:each | each = value]
				put: ['newValue']) = 'newValue'.
		self assert: (cache at: key) = 'newValue'].

	self assert:
		(cache
			at: 'absentKey'
			ifPresent: [self fail]
			put: [self fail]) isNil.
	self deny: (cache includesKey: 'absentKey').

	"the ifPresent: block can modify the cache too, so make sure
	it is cleared if needed to make room"
	self assert:
		(cache
			at: self keys first
			ifPresent: [
				cache
					at: 'newKey'
					put: 'newValue'.
				false]
			put: [self fail]) = 'newValue'.
	self
		assert: cache size = 1;
		assert: (cache at: 'newKey') = 'newValue'.

	"the put: block can modify the cache too, so make sure
	it is cleared if needed to make room"
	cache := self cacheClass maxSize: 1.
	cache
		at: self keys first
		put: self values first.
	self assert:
		(cache
			at: self keys first
			ifPresent: [true]
			put: [
				cache
					at: 'newKey'
					put: 'newValue']) = 'newValue'.
	self
		assert: cache size = 1;
		assert: (cache at: self keys first) = 'newValue'.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 18:16'!
testAtPut
	| cache |

	cache := self cacheClass maxSize: self maxSize.
	self associations withIndexDo: [:each :i | | key value |
		key := each key.
		value := each value.
		self assert:
			(cache
				at: key
				put: value) = value.
		self
			assert: (cache at: key) = value;
			assert: cache size = i].
	self assert:
		(cache
			at: 'newKey'
			put: 'newValue') = 'newValue'.
	self
		assert: (cache at: 'newKey') = 'newValue';
		assert: cache size = 1.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/26/2016 13:14'!
testCapacity
	self
		assert: self newCache capacity = self defaultMaxSize;
		assert: self newCacheWithEntries capacity = self maxSize! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:25'!
testClear
	| cache |

	cache := self newCacheWithEntries.
	self deny: cache isEmpty.

	cache clear.
	self assert: cache isEmpty.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/27/2016 13:27'!
testCopy
	| cache copy |

	cache := self newCacheWithEntries.
	copy := cache copy.
	self
		deny: cache == copy;
		assert: cache collection = copy collection;
		deny: cache collection == copy collection;
		deny: cache mutex == copy mutex.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:31'!
testIncludesKey
	| cache |

	cache := self newCacheWithEntries.
	self keys do: [:key |
		self assert: (cache includesKey: key)].
	self deny: (cache includesKey: 'absentKey').! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 20:53'!
testIsEmpty
	self
		assert: self newCache isEmpty;
		deny: self newCacheWithEntries isEmpty! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:35'!
testKeys
	self
		assert: self newCache keys isEmpty;
		assert: self newCacheWithEntries keys asSet = self keys asSet! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:50'!
testKeysAndValuesDo
	self
		should: [:block | self newCache keysAndValuesDo: block]
		inAnyOrderEnumerateKeysAndValues: #().

	self
		should: [:block | self newCacheWithEntries keysAndValuesDo: block]
		inAnyOrderEnumerateKeysAndValues: self associations.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:43'!
testKeysDo
	self
		should: [:block | self newCache keysDo: block]
		inAnyOrderEnumerate: #().

	self
		should: [:block | self newCacheWithEntries keysDo: block]
		inAnyOrderEnumerate: self keys.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/26/2016 13:14'!
testMaxSize
	| cache |

	cache := self newCache.
	self
		assert: cache size = 0;
		assert: cache maxSize = self defaultMaxSize.

	cache := self newCacheWithEntries.
	self
		assert: cache size = self maxSize;
		assert: cache maxSize = self maxSize.

	self
		assert: (cache maxSize: self maxSize + 1) == cache;
		assert: cache maxSize = (self maxSize + 1);
		assert: cache size = self maxSize.

	self
		assert: (cache maxSize: 0) == cache;
		assert: cache maxSize = 0;
		assert: cache size = 0.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 2/16/2016 08:00'!
testNotEmpty
	self
		deny: self newCache notEmpty;
		assert: self newCacheWithEntries notEmpty! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:24'!
testRemoveAll
	| cache |

	cache := self newCacheWithEntries.
	self deny: cache isEmpty.

	cache removeAll.
	self assert: cache isEmpty.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 13:44'!
testRemoveKey
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self
			assert: (cache removeKey: key) = value;
			deny: (cache includesKey: key).

		"does not raise errors to support concurrent removal"
		self assert: (cache removeKey: key) isNil].
	self assert: cache isEmpty.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 21:11'!
testRemoveKeyIfAbsent
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert:
			(cache
				removeKey: key
				ifAbsent: [self fail]) = value.
		self deny: (cache includesKey: key).
		self assert:
			(cache
				removeKey: key
				ifAbsent: ['absentValue']) = 'absentValue'].
	self assert: cache isEmpty.

	cache := self newCacheWithEntries.
	self assert:
		(cache
			removeKey: 'absentKey'
			ifAbsent: [
				cache
					at: 'newKey'
					put: 'newValue']) = 'newValue'.
	self
		assert: cache size = 1;
		assert: (cache at: 'newKey') = 'newValue'.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/28/2016 23:07'!
testRemoveKeyIfPresent
	| cache |

	cache := self newCacheWithEntries.
	self keysAndValuesDo: [:key :value |
		self assert:
			(cache
				removeKey: key
				ifPresent: [:each | each ~= value]) = value.
		self assert: (cache includesKey: key).

		"ensure cull: is used"
		self assert:
			(cache
				removeKey: key
				ifPresent: [false]) = value.
		self assert: (cache includesKey: key).

		self assert:
			(cache
				removeKey: key
				ifPresent: [:each | each = value]) = value.
		self deny: (cache includesKey: key).

		self assert:
			(cache
				removeKey: key
				ifPresent: [self fail]) isNil.
		self deny: (cache includesKey: key)].
	self assert: cache isEmpty.! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 11/15/2014 20:57'!
testSize
	self
		assert: self newCache size = 0;
		assert: self newCacheWithEntries size = self maxSize! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:35'!
testValues
	self
		assert: self newCache values isEmpty;
		assert: self newCacheWithEntries values asSet = self values asSet! !

!XMLKeyValueCacheTest methodsFor: 'tests' stamp: 'monty 9/17/2016 14:43'!
testValuesDo
	self
		should: [:block | self newCache valuesDo: block]
		inAnyOrderEnumerate: #().

	self
		should: [:block | self newCacheWithEntries valuesDo: block]
		inAnyOrderEnumerate: self values.! !

!XMLKeyValueCacheTest methodsFor: 'accessing' stamp: 'monty 9/17/2016 14:22'!
values
	^ self associations collect: [:each | each value]! !

TestCase subclass: #XMLNamespaceScopeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Namespaces'!

!XMLNamespaceScopeTest methodsFor: 'accessing' stamp: 'monty 12/29/2014 17:54'!
namespaces
	^ OrderPreservingStringDictionary new
		at: 'prefix1' put: 'ns1';
		at: 'prefix2' put: 'ns2';
		at: '' put: 'defaultNS';
		yourself! !

!XMLNamespaceScopeTest methodsFor: 'instance creation' stamp: 'monty 12/28/2014 23:18'!
newNamespaceScope
	^ XMLNamespaceScope new! !

!XMLNamespaceScopeTest methodsFor: 'instance creation' stamp: 'monty 12/28/2014 23:24'!
newNamespaceScopeWithNamespaces
	| scope |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		scope
			mapPrefix: prefix
			to: uri].
	^ scope.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 9/21/2016 09:19'!
testCopy
	| scope oldPrefixMappings copy |

	scope := self newNamespaceScopeWithNamespaces.
	oldPrefixMappings := scope prefixMappings.
	copy := scope copy.
	self
		deny: copy == scope;
		assert: copy = scope;
		assert: copy prefixMappings == oldPrefixMappings.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:31'!
testDefaultNamespace
	| scope oldPrefixMappings |

	scope := self newNamespaceScope.
	self assert: scope defaultNamespace = ''.

	oldPrefixMappings := scope prefixMappings.
	scope defaultNamespace: 'test'.
	self
		assert: scope defaultNamespace = 'test';
		assert: (scope prefixMappings at: '') = 'test';
		deny: scope prefixMappings = oldPrefixMappings.

	scope unmapPrefix: ''.
	self assert: scope defaultNamespace = ''.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 12/28/2014 23:31'!
testEquals
	self
		assert: self newNamespaceScope = self newNamespaceScope;
		assert: self newNamespaceScopeWithNamespaces = self newNamespaceScopeWithNamespaces;
		deny: self newNamespaceScope = self newNamespaceScopeWithNamespaces;
		deny: self newNamespaceScopeWithNamespaces = self newNamespaceScope! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 3/6/2016 19:57'!
testHasDefaultNamespace
	| scope |

	scope := self newNamespaceScope.
	self deny: scope hasDefaultNamespace.

	scope defaultNamespace: 'test'.
	self assert: scope hasDefaultNamespace.

	scope defaultNamespace: ''.
	self assert: scope hasDefaultNamespace.

	scope unmapPrefix: ''.
	self deny: scope hasDefaultNamespace.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 3/6/2016 19:57'!
testHasNamespaces
	| scope |

	scope := self newNamespaceScope.
	self deny: scope hasNamespaces.

	scope mapPrefixesAndURIs: self namespaces.
	self assert: scope hasNamespaces.
	self namespaces keysDo: [:each |
		self assert: scope hasNamespaces.
		scope unmapPrefix: each].
	self deny: scope hasNamespaces.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:07'!
testHash
	"We can only safely test that equal objects have the same hash; testing
	that different objects have different hashes would be unreliable
	because #hash is non-cryptographic and has collisions."
	self assert:
		self newNamespaceScope hash =
			self newNamespaceScope hash.
	self assert:
		self newNamespaceScopeWithNamespaces hash =
			self newNamespaceScopeWithNamespaces hash.
	self assert:
		self newNamespaceScope hash =
			(self newNamespaceScopeWithNamespaces
				unmapPrefixes;
				hash).! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 3/6/2016 19:58'!
testIncludesPrefix
	| scope |

	scope := self newNamespaceScope.
	self
		deny: (scope includesPrefix: 'xml');
		deny: (scope includesPrefix: 'xmlns').

	"cannot map xmlns prefix, but can map xml"
	scope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert: (scope includesPrefix: 'xml').

	self namespaces keysAndValuesDo: [:prefix :uri |
		self deny: (scope includesPrefix: prefix).
		scope mapPrefix: prefix to: uri.
		self assert: (scope includesPrefix: prefix)].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 3/6/2016 19:58'!
testIncludesPrefixMappedTo
	| scope |

	scope := self newNamespaceScope.
	self
		deny: (scope includesPrefix: 'xml' mappedTo: XMLNamespaceScope xmlNamespaceURI);
		deny: (scope includesPrefix: 'xmlns' mappedTo: XMLNamespaceScope xmlnsNamespaceURI).

	"cannot map xmlns prefix, but can map xml"
	scope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert: (scope includesPrefix: 'xml' mappedTo: XMLNamespaceScope xmlNamespaceURI).

	self namespaces keysAndValuesDo: [:prefix :uri |
		self deny: (scope includesPrefix: prefix mappedTo: uri).
		scope mapPrefix: prefix to: uri.
		self assert: (scope includesPrefix: prefix mappedTo: uri)].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 12/28/2014 23:57'!
testInheritMappingsFrom
	| outerScope innerScope |

	outerScope := self newNamespaceScopeWithNamespaces.
	innerScope := self newNamespaceScope.
	innerScope inheritMappingsFrom: outerScope.
	self assert: innerScope prefixMappings == outerScope prefixMappings.

	innerScope := self newNamespaceScopeWithNamespaces.
	innerScope inheritMappingsFrom: outerScope.
	self
		assert: innerScope prefixMappings = outerScope prefixMappings;
		deny: innerScope prefixMappings == outerScope prefixMappings.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 3/6/2016 18:38'!
testMapPrefixTo
	| scope oldPrefixMappings |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		"save to ensure prefixMappings is copied, even if unchanged"
		oldPrefixMappings := scope prefixMappings.
		scope
			mapPrefix: prefix
			to: uri.
		self
			assert: (scope prefixMappings at: prefix) = uri;
			deny: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings.

		"save to ensure prefixMappings is copied, even if unchanged"
		oldPrefixMappings := scope prefixMappings.
		scope
			mapPrefix: prefix
			to: uri.
		self
			assert: (scope prefixMappings at: prefix) = uri;
			assert: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings].
	self assert:
		scope prefixMappings associations asArray =
			self namespaces associations asArray.

	self namespaces keysDo: [:each |
		"save to ensure prefixMappings is copied, even if unchanged"
		oldPrefixMappings := scope prefixMappings.
		scope
			mapPrefix: each
			to: 'newNS'.
		self
			assert: (scope prefixMappings at: each) = 'newNS';
			deny: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings].

	"save to ensure prefixMappings is copied, even if unchanged"
	oldPrefixMappings := scope prefixMappings.
	scope
		mapPrefix: 'xml'
		to: scope xmlNamespaceURI.
	self
		assert: (scope prefixMappings at: 'xml') = scope xmlNamespaceURI;
		deny: scope prefixMappings = oldPrefixMappings;
		deny: scope prefixMappings == oldPrefixMappings.

	"cannot rebind xmlns prefix at all, even to the same URI"
	self
		should: [
			scope
				mapPrefix: 'xmlns'
				to: scope xmlnsNamespaceURI]
		raise: XMLNamespaceException.

	"cannot bind a new prefix to the xml, xmlns, or empty namespace URI"
	(Array
		with: scope xmlNamespaceURI
		with: scope xmlnsNamespaceURI
		with: '') do: [:each |
		self
			should: [
				scope
					mapPrefix: 'newPrefix'
					to: each]
			raise: XMLNamespaceException].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 12:13'!
testMapPrefixesAndURIs
	| outerScope innerScope namespaces |

	namespaces := self namespaces.
	(outerScope := self newNamespaceScope) mapPrefixesAndURIs: namespaces.
	self
		assert: outerScope prefixMappings = namespaces;
		deny: outerScope prefixMappings == namespaces.

	"copying shares dictionary until modified"
	innerScope := outerScope copy.
	self
		assert: innerScope prefixMappings = outerScope prefixMappings;
		assert: innerScope prefixMappings == outerScope prefixMappings.

	"modifying creates new dictionary"
	innerScope mapPrefixesAndURIs: namespaces.
	self
		assert: innerScope prefixMappings = outerScope prefixMappings;
		deny: innerScope prefixMappings == outerScope prefixMappings.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 2/24/2016 06:14'!
testMappedPrefixes
	| scope prefixes |

	scope := self newNamespaceScope.
	prefixes := OrderedCollection new.
	self namespaces keysAndValuesDo: [:prefix :uri |
		scope
			mapPrefix: prefix
			to: uri.
		prefixes addLast: prefix.
		self assert: scope mappedPrefixes = prefixes asArray].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:32'!
testPrefixMappingAt
	| scope |

	scope := self newNamespaceScope.
	self
		assert: (scope prefixMappingAt: 'xml') = '';
		assert: (scope prefixMappingAt: 'xmlns') = ''.

	"cannot map xmlns prefix, but can map xml"
	scope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert: (scope prefixMappingAt: 'xml') = XMLNamespaceScope xmlNamespaceURI.

	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (scope prefixMappingAt: prefix) = ''.
		scope mapPrefix: prefix to: uri.
		self assert: (scope prefixMappingAt: prefix) = uri].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:52'!
testPrefixMappingAtIfAbsent
	| scope |

	scope := self newNamespaceScope.
	self assert:
		(scope
			prefixMappingAt: 'xml'
			ifAbsent: [#absent]) = #absent.
	self assert:
		(scope
			prefixMappingAt: 'xmlns'
			ifAbsent: [#absent]) = #absent.

	"cannot map xmlns prefix, but can map xml"
	scope mapPrefix: 'xml' to: XMLNamespaceScope xmlNamespaceURI.
	self assert:
		(scope
			prefixMappingAt: 'xml'
			ifAbsent: [self fail]) = XMLNamespaceScope xmlNamespaceURI.

	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert:
			(scope
				prefixMappingAt: prefix
				ifAbsent: [#absent]) = #absent.
		scope mapPrefix: prefix to: uri.
		self assert:
			(scope
				prefixMappingAt: prefix
				ifAbsent: [self fail]) = uri].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 4/21/2015 11:49'!
testPrefixesAndURIsDo
	| associations |

	associations := OrderedCollection new.
	self newNamespaceScope prefixesAndURIsDo: [:prefix :uri |
		associations addLast: prefix -> uri].
	self assert: associations isEmpty.

	self newNamespaceScopeWithNamespaces prefixesAndURIsDo: [:prefix :uri |
		associations addLast: prefix -> uri].
	self assert: associations asArray = self namespaces associations asArray.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:55'!
testResolvePrefix
	| scope |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (scope resolvePrefix: prefix) = ''.
		scope mapPrefix: prefix to: uri.
		self assert: (scope resolvePrefix: prefix) = uri].

	self assert:
		(scope resolvePrefix: 'xml') = scope xmlNamespaceURI.
	self assert:
		(scope resolvePrefix: 'xmlns') = scope xmlnsNamespaceURI.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:54'!
testResolvePrefixIfUnresolvable
	| scope |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert:
			(scope
				resolvePrefix: prefix
				ifUnresolvable: ['unresolvable']) = 'unresolvable'.
		scope mapPrefix: prefix to: uri.
		self assert:
			(scope
				resolvePrefix: prefix
				ifUnresolvable: [self fail]) = uri].

	self assert:
		(scope
			resolvePrefix: 'xml'
			ifUnresolvable: [self fail]) = scope xmlNamespaceURI.
	self  assert:
		(scope
			resolvePrefix: 'xmlns'
			ifUnresolvable: [self fail]) = scope xmlnsNamespaceURI.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 3/6/2016 18:41'!
testResolvePrefixesOfNamespaceURI
	| scope |

	scope := self newNamespaceScope.

	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert:
			(scope resolvePrefixesOfNamespaceURI: uri) isEmpty.

		scope
			mapPrefix: prefix
			to: uri.
		self assert:
			(scope resolvePrefixesOfNamespaceURI: uri) =
				(Set with: prefix).

		scope
			mapPrefix: 'newPrefix'
			to: uri.
		self assert:
			(scope resolvePrefixesOfNamespaceURI: uri) =
				(Set with: prefix with: 'newPrefix')].

	self assert:
		(scope resolvePrefixesOfNamespaceURI: scope xmlNamespaceURI) =
			(Set with: 'xml').
	self assert:
		(scope resolvePrefixesOfNamespaceURI: scope xmlnsNamespaceURI) =
			(Set with: 'xmlns').

	"cannot map xmlns prefix at all, but can map xml to the same URI"
	scope
		mapPrefix: 'xml'
		to: scope xmlNamespaceURI.
	self assert:
		(scope resolvePrefixesOfNamespaceURI: scope xmlNamespaceURI) =
			(Set with: 'xml').! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 12/28/2014 23:30'!
testSize
	self
		assert: self newNamespaceScope size = 0;
		assert: self newNamespaceScopeWithNamespaces size = self namespaces size! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 8/23/2016 17:48'!
testUnmapPrefix
	| scope |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |  | oldPrefixMappings |
		self
			should: [scope unmapPrefix: prefix]
			raise: XMLNamespaceException.
		self deny: (scope includesPrefix: prefix).
		scope
			mapPrefix: prefix
			to: uri.
	
		oldPrefixMappings := scope prefixMappings.
		self
			assert: (scope unmapPrefix: prefix) = uri;
			deny: (scope includesPrefix: prefix).

		"ensure prefixMappings is copied when removing"
		self
			assert: (oldPrefixMappings includesKey: prefix);
			deny: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings.

		self
			should: [scope unmapPrefix: prefix]
			raise: XMLNamespaceException].
	self assert: scope prefixMappings isEmpty.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:53'!
testUnmapPrefixIfAbsent
	| scope |

	scope := self newNamespaceScope.
	self namespaces keysAndValuesDo: [:prefix :uri |  | oldPrefixMappings |
		self assert:
			(scope
				unmapPrefix: prefix
				ifAbsent: [#absent]) = #absent.
		self deny: (scope includesPrefix: prefix).
		scope
			mapPrefix: prefix
			to: uri.

		oldPrefixMappings := scope prefixMappings.
		self assert:
			(scope
				unmapPrefix: prefix
				ifAbsent: [self fail]) = uri.
		self deny: (scope includesPrefix: prefix).

		"ensure prefixMappings is copied when removing"
		self
			assert: (oldPrefixMappings includesKey: prefix);
			deny: scope prefixMappings = oldPrefixMappings;
			deny: scope prefixMappings == oldPrefixMappings.

		self
			assert:
				(scope
					unmapPrefix: prefix
					ifAbsent: [#absent]) = #absent].
	self assert: scope prefixMappings isEmpty.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 8/23/2016 17:47'!
testUnmapPrefixes
	| scope oldPrefixMappings |

	scope := self newNamespaceScopeWithNamespaces.
	oldPrefixMappings := scope prefixMappings.
	self
		assert: scope unmapPrefixes == scope;
		deny: scope hasNamespaces.

	"ensure prefixMappings is copied when removing"
	self
		assert: oldPrefixMappings = self namespaces;
		deny: scope prefixMappings = oldPrefixMappings;
		deny: scope prefixMappings == oldPrefixMappings.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 8/26/2016 03:33'!
testValidatePrefixesOfAttributes
	| scope attributes |

	scope := self newNamespaceScopeWithNamespaces.
	attributes :=
		self namespaces keys collect: [:each |
			each = ''
				ifTrue: ['name']
				ifFalse: [each, ':name']].
	self
		shouldnt: [
			scope validatePrefixesOfAttributes: attributes]
		raise: XMLNamespaceException.
	self
		should: [
			scope validatePrefixesOfAttributes:
				(attributes copyWith: 'undeclared:name')]
		raise: XMLNamespaceException.
	self
		should: [
			scope validatePrefixesOfAttributes:
				(attributes copyWith: ':name')]
		raise: XMLNamespaceException.

	self namespaces keysAndValuesDo: [:prefix :uri | | attribute |
		scope
			mapPrefix: 'alias', prefix
			to: uri.
		attribute := 'alias', prefix, ':name'.
		prefix = ''
			ifTrue: [
				self
					shouldnt: [
						scope validatePrefixesOfAttributes:
							(attributes copyWith: attribute)]
					raise: XMLNamespaceException]
			ifFalse: [
				self
					should: [
						scope validatePrefixesOfAttributes:
							(attributes copyWith: attribute)]
					raise: XMLNamespaceException]].! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 2/17/2016 00:33'!
testXMLNSNamespaceURI
	| namespaceURI |

	namespaceURI := 'http://www.w3.org/2000/xmlns/'.
	self
		assert: self newNamespaceScope xmlnsNamespaceURI = namespaceURI;
		assert: XMLNamespaceScope xmlnsNamespaceURI = namespaceURI.! !

!XMLNamespaceScopeTest methodsFor: 'tests' stamp: 'monty 2/17/2016 00:33'!
testXMLNamespaceURI
	| namespaceURI |

	namespaceURI := 'http://www.w3.org/XML/1998/namespace'.
	self
		assert: self newNamespaceScope xmlNamespaceURI = namespaceURI;
		assert: XMLNamespaceScope xmlNamespaceURI = namespaceURI.! !

TestCase subclass: #XMLNestedStreamReaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLNestedStreamReaderTest class methodsFor: 'asserting' stamp: 'monty 9/28/2017 14:39'!
shouldInheritTests
	^ true! !

!XMLNestedStreamReaderTest methodsFor: 'accessing' stamp: 'monty 3/18/2016 23:52'!
absentChar
	^ $!!! !

!XMLNestedStreamReaderTest methodsFor: 'accessing' stamp: 'monty 3/18/2016 19:24'!
cr
	^ Character cr! !

!XMLNestedStreamReaderTest methodsFor: 'accessing' stamp: 'monty 3/18/2016 19:24'!
lf
	^ Character lf! !

!XMLNestedStreamReaderTest methodsFor: 'instance creation' stamp: 'monty 9/26/2017 08:24'!
newStreamOn: aCollection
	^ XMLExceptionRaisingReadStream on: aCollection! !

!XMLNestedStreamReaderTest methodsFor: 'instance creation' stamp: 'monty 9/26/2017 08:26'!
newStreamOnSourceXML
	^ self newStreamOn: self sourceXML! !

!XMLNestedStreamReaderTest methodsFor: 'instance creation' stamp: 'monty 9/28/2017 14:37'!
newStreamReaderOn: aStream
	^ self streamReaderClass on: aStream! !

!XMLNestedStreamReaderTest methodsFor: 'instance creation' stamp: 'monty 9/26/2017 08:26'!
newStreamReaderOnSourceXML
	^ self newStreamReaderOn: self newStreamOnSourceXML! !

!XMLNestedStreamReaderTest methodsFor: 'accessing' stamp: 'monty 9/28/2017 14:43'!
nonLineEndingSeparators
	^ self separators reject: [:each |
		each = self cr
			or: [each = self lf]]! !

!XMLNestedStreamReaderTest methodsFor: 'accessing' stamp: 'monty 3/18/2016 19:26'!
normalizedLineEnding
	^ self lf! !

!XMLNestedStreamReaderTest methodsFor: 'source' stamp: 'monty 3/18/2016 20:30'!
normalizedSourceXML
	^ self sourceXMLNormalizedWith: self normalizedLineEnding! !

!XMLNestedStreamReaderTest methodsFor: 'accessing' stamp: 'monty 9/28/2017 14:13'!
separators
	^ Character xmlSeparators! !

!XMLNestedStreamReaderTest methodsFor: 'source' stamp: 'monty 9/28/2017 14:43'!
sourceXML
	^ self sourceXMLTemplate format:
		(Array
			with: self lf
			with: (String with: self cr with: self lf)
			with: (String withAll: self nonLineEndingSeparators)
			with: self cr)! !

!XMLNestedStreamReaderTest methodsFor: 'source' stamp: 'monty 9/28/2017 14:43'!
sourceXMLNormalizedWith: aCharacter
	^ self sourceXMLTemplate format:
		(Array
			with: aCharacter
			with: aCharacter
			with: (String withAll: self nonLineEndingSeparators)
			with: aCharacter)! !

!XMLNestedStreamReaderTest methodsFor: 'source' stamp: 'monty 9/28/2017 14:42'!
sourceXMLTemplate
	^ '{1}	<test>{2}	   test{3}test{4}</test>'! !

!XMLNestedStreamReaderTest methodsFor: 'accessing' stamp: 'monty 9/28/2017 14:37'!
streamReaderClass
	^ XMLNestedStreamReader! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 11/14/2016 09:48'!
testAtEnd
	| streamReader |

	streamReader := self newStreamReaderOnSourceXML.
	self normalizedSourceXML size timesRepeat: [
		self deny: streamReader atEnd.
		streamReader next].
	self
		assert: streamReader atEnd;
		assert: streamReader stream atEnd.

	streamReader pushBack: self normalizedSourceXML.
	self normalizedSourceXML size timesRepeat: [
		self deny: streamReader atEnd.
		streamReader next].
	self
		assert: streamReader atEnd;
		assert: streamReader stream atEnd.

	streamReader pushBack: ''.
	self
		assert: streamReader atEnd;
		assert: streamReader stream atEnd.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 08:27'!
testCloseStreams
	| stream streamReader pushedBackStream evaluated |

	stream := self newStreamOnSourceXML.
	streamReader := self newStreamReaderOn: stream.

	pushedBackStream := self newStreamOnSourceXML.
	evaluated := false.
	streamReader
		pushBackStream: pushedBackStream
		whenPoppedDo: [evaluated := true]
		isExternal: true.
	self
		assert: streamReader stream == pushedBackStream;
		assert: streamReader hasPushedBackStreams;
		deny: stream wasClosed;
		deny: pushedBackStream wasClosed.

	self
		assert: streamReader closeStreams == streamReader;
		assert: streamReader atEnd;
		deny: streamReader stream == stream;
		deny: streamReader stream == pushedBackStream;
		deny: streamReader hasPushedBackStreams;
		assert: stream wasClosed;
		assert: pushedBackStream wasClosed;
		deny: evaluated.

	self
		shouldnt: [streamReader closeStreams]
		raise: Error.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 09:20'!
testHasPushedBackStreams
	| streamReader |

	streamReader := self newStreamReaderOnSourceXML.
	self deny: streamReader hasPushedBackStreams.

	streamReader pushBackStream: (self newStreamOn: '').
	self assert: streamReader hasPushedBackStreams.

	streamReader next.
	self deny: streamReader hasPushedBackStreams.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 3/18/2016 20:53'!
testIsBinary
	self deny: self newStreamReaderOnSourceXML isBinary! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 3/18/2016 20:53'!
testIsStream
	self assert: self newStreamReaderOnSourceXML isStream! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 09:20'!
testLineEndingNormalizationAcrossStreams
	| streamReader |

	streamReader :=
		self newStreamReaderOn:
			(self newStreamOn: (String with: self lf)).
	streamReader pushBackCharacter: self cr.
	streamReader
		pushBackStream:
			(self newStreamOn:
				(String with: self cr with: self lf))
		whenPoppedDo: nil
		isExternal: true.
	self
		assert: streamReader next = self normalizedLineEnding;
		deny: streamReader atEnd;
		assert: streamReader next = self cr;
		deny: streamReader atEnd;
		assert: streamReader next = self normalizedLineEnding;
		assert: streamReader atEnd.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 4/5/2016 06:41'!
testNext
	| streamReader currentLineNumber currentColumnNumber currentPosition |

	streamReader := self newStreamReaderOnSourceXML.
	currentLineNumber := 1.
	currentColumnNumber := currentPosition := 0.
	self normalizedSourceXML do: [:each |
		self assert: streamReader next = each.
		each = self normalizedLineEnding
			ifTrue: [
				currentLineNumber := currentLineNumber + 1.
				currentColumnNumber := 0]
			ifFalse: [currentColumnNumber := currentColumnNumber + 1].
		currentPosition := currentPosition + 1.
		self
			assert: streamReader currentLineNumber = currentLineNumber;
			assert: streamReader currentColumnNumber = currentColumnNumber;
			assert: streamReader currentPosition = currentPosition].
	self assert: streamReader next isNil.

	streamReader := self newStreamReaderOnSourceXML.
	self
		assert: (streamReader next: self normalizedSourceXML size) = self normalizedSourceXML;
		assert: streamReader currentLineNumber = currentLineNumber;
		assert: streamReader currentColumnNumber = currentColumnNumber;
		assert: streamReader currentPosition = currentPosition;
		assert: (streamReader next: self normalizedSourceXML size) = ''.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 3/18/2016 20:54'!
testNormalizedLineEndingChar
	| streamReader |

	streamReader := self newStreamReaderOnSourceXML.
	self
		assert: (streamReader normalizedLineEndingChar: $N) == streamReader;
		assert: (streamReader normalizedLineEndingChar) == $N;
		assert: streamReader upToEnd = (self sourceXMLNormalizedWith: $N).! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 07:26'!
testPeek
	| streamReader currentLineNumber currentColumnNumber currentPosition |

	streamReader := self newStreamReaderOnSourceXML.
	currentLineNumber := 1.
	currentColumnNumber := currentPosition := 0.
	self normalizedSourceXML do: [:each |
		self
			assert: streamReader peek = each;
			assert: streamReader currentLineNumber = currentLineNumber;
			assert: streamReader currentColumnNumber = currentColumnNumber.

		streamReader next.
		each = self normalizedLineEnding
			ifTrue: [
				currentLineNumber := currentLineNumber + 1.
				currentColumnNumber := 0]
			ifFalse: [currentColumnNumber := currentColumnNumber + 1].
		currentPosition := currentPosition + 1.
		self
			assert: streamReader currentLineNumber = currentLineNumber;
			assert: streamReader currentColumnNumber = currentColumnNumber;
			assert: streamReader currentPosition = currentPosition].
	self assert: streamReader peek isNil.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 07:24'!
testPeekFor
	| streamReader |

	streamReader := self newStreamReaderOnSourceXML.
	self normalizedSourceXML do: [:each |
		self
			deny: (streamReader peekFor: #absent);
			deny: (streamReader peekFor: nil);
			assert: (streamReader peekFor: each);
			deny: (streamReader peekFor: #absent);
			deny: (streamReader peekFor: nil)].
	self
		deny: (streamReader peekFor: #absent);
		deny: (streamReader peekFor: nil).! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 09:21'!
testPushBackStreamWhenPoppedDoIsExternal
	| streamReader evaluated |

	streamReader := self newStreamReaderOn: (self newStreamOn: '').
	evaluated := false.
	self assert:
		(streamReader
			pushBackStream: self newStreamReaderOnSourceXML
			whenPoppedDo: [evaluated := true]
			isExternal: true) == streamReader.
	self normalizedSourceXML do: [:each |
		self
			assert: streamReader peek = each;
			assert: streamReader next = each;
			deny: evaluated].
	self
		assert: streamReader next isNil;
		assert: evaluated.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 08:29'!
testPushBackStreamWhenPoppedDoIsExternalException
	"ensure that throwing an exception from the callback doesn't stop
	the stream from being closed or getting popped"

	| stream streamReader evaluated |

	stream := self newStreamOnSourceXML.
	streamReader := self newStreamReaderOnSourceXML.
	evaluated := false.
	streamReader
		pushBackStream: stream
		whenPoppedDo: [
			evaluated := true.
			Error signal]
		isExternal: true.
	self
		assert: streamReader stream == stream;
		deny: evaluated;
		deny: stream wasClosed.

	self
		should: [streamReader upToEnd]
		raise: Error.
	self
		deny: streamReader stream == stream;
		assert: evaluated;
		assert: stream wasClosed.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/28/2017 14:13'!
testSkipSeparators
	| streamReader stream currentLineNumber currentColumnNumber currentPosition |

	streamReader := self newStreamReaderOnSourceXML.
	stream := self newStreamOn: self normalizedSourceXML.
	currentLineNumber := 1.
	currentColumnNumber := currentPosition := 0.
	[stream atEnd]
		whileFalse: [| totalSeparatorsSkipped |
			totalSeparatorsSkipped := 0.
			[self separators includes: stream peek]
				whileTrue: [
					stream next = self normalizedLineEnding
						ifTrue: [
							currentLineNumber := currentLineNumber + 1.
							currentColumnNumber := 0]
						ifFalse: [currentColumnNumber := currentColumnNumber + 1].
					currentPosition := currentPosition + 1.
					totalSeparatorsSkipped := totalSeparatorsSkipped + 1].
			streamReader skipSeparators.
			self
				assert: streamReader currentLineNumber = currentLineNumber;
				assert: streamReader currentColumnNumber = currentColumnNumber;
				assert: streamReader currentPosition = currentPosition.
			totalSeparatorsSkipped > 0
				ifFalse: [
					stream next.
					streamReader next.
					currentColumnNumber := currentColumnNumber + 1.
					currentPosition := currentPosition + 1]].! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 9/26/2017 08:28'!
testStreamPushbackPortability
	| streamReader output lastPeek lastNext |

	streamReader := self newStreamReaderOn: (self newStreamOn: '').
	streamReader
		pushBackStream: self newStreamOnSourceXML
		whenPoppedDo: nil
		isExternal: true.
	output := String new writeStream.
	self
		shouldnt: [
			self normalizedSourceXML size timesRepeat: [
				output nextPut:
					(streamReader
						peek;
						next)].
			lastPeek := streamReader peek.
			lastNext := streamReader next]
		raise: Error.
	self
		assert: output contents = self normalizedSourceXML;
		assert: lastPeek isNil;
		assert: lastNext isNil;
		assert: streamReader atEnd.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 3/18/2016 23:52'!
testUpTo
	self normalizedSourceXML do: [:each | | streamReader |
		streamReader := self newStreamReaderOnSourceXML.
		self assert:
			(streamReader upTo: each) =
				(self normalizedSourceXML copyUpTo: each).
		self assert:
			streamReader upToEnd =
				(self normalizedSourceXML copyAfter: each)].
	self assert:
		(self newStreamReaderOnSourceXML upTo: self absentChar) = self normalizedSourceXML.! !

!XMLNestedStreamReaderTest methodsFor: 'tests' stamp: 'monty 3/18/2016 23:19'!
testUpToEnd
	| streamReader |

	self normalizedSourceXML withIndexDo: [:each :i |
		streamReader := self newStreamReaderOnSourceXML.
		streamReader next: i.
		self
			assert: streamReader upToEnd = (self normalizedSourceXML allButFirst: i);
			assert: streamReader upToEnd = ''].
	streamReader := self newStreamReaderOnSourceXML.
	self
		assert: streamReader upToEnd = self normalizedSourceXML;
		assert: streamReader upToEnd = ''.! !

TestCase subclass: #XMLNodeCanonicalPrintingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNodeCanonicalPrintingTest methodsFor: 'private' stamp: 'monty 11/27/2016 18:49'!
onCanonicalLineBreakJoin: aLineCollection
	^ XMLWriterTest onCanonicalLineBreakJoin: aLineCollection! !

!XMLNodeCanonicalPrintingTest methodsFor: 'tests' stamp: 'monty 11/13/2016 18:12'!
testCharacterReferences
	| xml |

	xml := '<!!DOCTYPE doc [
<!!ATTLIST normId id ID #IMPLIED>
<!!ATTLIST normNames attr NMTOKENS #IMPLIED>
]>
<doc>
   <text>First line&#x0d;&#10;Second line</text>
   <value>&#x32;</value>
   <compute><!![CDATA[value>"0" && value<"10" ?"valid":"error"]]></compute>
   <compute expr=''value>"0" &amp;&amp; value&lt;"10" ?"valid":"error"''>valid</compute>
   <norm attr='' &apos;   &#x20;&#13;&#xa;&#9;   &apos; ''/>
   <normNames attr=''   A   &#x20;&#13;&#xa;&#9;   B   ''/>
   <normId id='' &apos;   &#x20;&#13;&#xa;&#9;   &apos; ''/>
</doc>'.

	self assert:
		((XMLDOMParser on: xml)
			isValidating: false;
			parseDocument) canonicallyPrinted =
				(self onCanonicalLineBreakJoin:
					#('<doc>'
						'   <text>First line&#xD;'
						'Second line</text>'
						'   <value>2</value>'
						'   <compute>value&gt;"0" &amp;&amp; value&lt;"10" ?"valid":"error"</compute>'
						'   <compute expr="value>&quot;0&quot; &amp;&amp; value&lt;&quot;10&quot; ?&quot;valid&quot;:&quot;error&quot;">valid</compute>'
						'   <norm attr=" ''    &#xD;&#xA;&#x9;   '' "></norm>'
						'   <normNames attr="A &#xD;&#xA;&#x9; B"></normNames>'
						'   <normId id="'' &#xD;&#xA;&#x9; ''"></normId>'
						'</doc>')).! !

!XMLNodeCanonicalPrintingTest methodsFor: 'tests' stamp: 'monty 11/13/2016 18:18'!
testEntityReferences
	| xml resolver |

	xml := '<!!DOCTYPE doc [
<!!ATTLIST doc attrExtEnt ENTITY #IMPLIED>
<!!ENTITY ent1 "Hello">
<!!ENTITY ent2 SYSTEM "world.txt">
<!!ENTITY entExt SYSTEM "earth.gif" NDATA gif>
<!!NOTATION gif SYSTEM "viewgif.exe">
]>
<doc attrExtEnt="entExt">
   &ent1;, &ent2;!!
</doc>

<!!-- Let world.txt contain "world" (excluding the quotes) --> '.

	(resolver := DTDStaticExternalEntityResolver new)
		externalEntityAtURI: 'world.txt'
		put: 'world'.
	self assert:
		((XMLDOMParser on: xml)
			externalEntityResolver: resolver copy;
			resolvesExternalEntities: true;
			isValidating: false;
			parseDocument) canonicallyPrinted =
				(self onCanonicalLineBreakJoin:
					#('<doc attrExtEnt="entExt">'
						'   Hello, world!!'
						'</doc>')).

	self assert:
		((XMLDOMParser on: xml)
			externalEntityResolver: resolver copy;
			resolvesExternalEntities: true;
			isValidating: false;
			preservesCommentNodes: true;
			parseDocument) canonicallyPrinted =
				(self onCanonicalLineBreakJoin:
					#('<doc attrExtEnt="entExt">'
						'   Hello, world!!'
						'</doc>'
						'<!!-- Let world.txt contain "world" (excluding the quotes) -->')).! !

!XMLNodeCanonicalPrintingTest methodsFor: 'tests' stamp: 'monty 11/8/2016 18:56'!
testPIsAndComments
	| xml |

	xml := '<?xml version="1.0"?>

<?xml-stylesheet   href="doc.xsl"
   type="text/xsl"   ?>

<!!DOCTYPE doc SYSTEM "doc.dtd">

<doc>Hello, world!!<!!-- Comment 1 --></doc>

<?pi-without-data     ?>

<!!-- Comment 2 -->

<!!-- Comment 3 -->'.

	self assert:
		(XMLDOMParser parse: xml)
			canonicallyPrinted =
				(self onCanonicalLineBreakJoin:
					#('<?xml-stylesheet href="doc.xsl"'
						'   type="text/xsl"   ?>'
						'<doc>Hello, world!!</doc>'
						'<?pi-without-data?>')).

	self assert:
		((XMLDOMParser on: xml)
			preservesCommentNodes: true;
			parseDocument) canonicallyPrinted =
				(self onCanonicalLineBreakJoin:
					#('<?xml-stylesheet href="doc.xsl"'
						'   type="text/xsl"   ?>'
						'<doc>Hello, world!!<!!-- Comment 1 --></doc>'
						'<?pi-without-data?>'
						'<!!-- Comment 2 -->'
						'<!!-- Comment 3 -->')).! !

!XMLNodeCanonicalPrintingTest methodsFor: 'tests' stamp: 'monty 11/8/2016 18:56'!
testStartAndEndTags
	| xml |

	xml := '<!!DOCTYPE doc [<!!ATTLIST e9 attr CDATA "default">]>
<doc>
   <e1   />
   <e2   ></e2>
   <e3   name = "elem3"   id="elem3"   />
   <e4   name="elem4"   id="elem4"   ></e4>
   <e5 a:attr="out" b:attr="sorted" attr2="all" attr="I''m"
      xmlns:b="http://www.ietf.org"
      xmlns:a="http://www.w3.org"
      xmlns="http://example.org"/>
   <e6 xmlns="" xmlns:a="http://www.w3.org">
      <e7 xmlns="http://www.ietf.org">
         <e8 xmlns="" xmlns:a="http://www.w3.org">
            <e9 xmlns="" xmlns:a="http://www.ietf.org"/>
         </e8>
      </e7>
   </e6>
</doc>'.

	self assert:
		((XMLDOMParser on: xml)
			isValidating: false;
			parseDocument) canonicallyPrinted =
				(self onCanonicalLineBreakJoin:
					#('<doc>'
						'   <e1></e1>'
						'   <e2></e2>'
						'   <e3 id="elem3" name="elem3"></e3>'
						'   <e4 id="elem4" name="elem4"></e4>'
						'   <e5 xmlns="http://example.org" xmlns:a="http://www.w3.org" xmlns:b="http://www.ietf.org" attr="I''m" attr2="all" b:attr="sorted" a:attr="out"></e5>'
						'   <e6 xmlns:a="http://www.w3.org">'
						'      <e7 xmlns="http://www.ietf.org">'
						'         <e8 xmlns="">'
						'            <e9 xmlns:a="http://www.ietf.org" attr="default"></e9>'
						'         </e8>'
						'      </e7>'
						'   </e6>'
						'</doc>')).! !

!XMLNodeCanonicalPrintingTest methodsFor: 'tests' stamp: 'monty 11/8/2016 18:56'!
testWhitespace
	| xml |

	xml := '
<doc>
   <clean>   </clean>
   <dirty>   A   B   </dirty>
   <mixed>
      A
      <clean>   </clean>
      B
      <dirty>   A   B   </dirty>
      C
   </mixed>
</doc>
'.

	self assert:
		(XMLDOMParser parse: xml)
			canonicallyPrinted =
				(self onCanonicalLineBreakJoin:
					#('<doc>'
						'   <clean>   </clean>'
						'   <dirty>   A   B   </dirty>'
						'   <mixed>'
						'      A'
						'      <clean>   </clean>'
						'      B'
						'      <dirty>   A   B   </dirty>'
						'      C'
						'   </mixed>'
						'</doc>')).! !

TestCase subclass: #XMLNodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLNodeFactoryTest class methodsFor: 'testing' stamp: 'monty 6/24/2016 04:25'!
shouldInheritSelectors
	^ true! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 8/12/2016 18:07'!
attributeAssociations
	^ Array
		with: 'one' -> '1'
		with: 'two' -> '2'! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 7/1/2017 01:51'!
attributes
	^ XMLAttributeDictionary newFrom: self attributeAssociations! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 8/4/2016 20:32'!
factoryClass
	^ XMLNodeFactory! !

!XMLNodeFactoryTest methodsFor: 'instance creation' stamp: 'monty 8/4/2016 20:14'!
newFactory
	^ self factoryClass new! !

!XMLNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:16'!
pluggableFactoryClass
	^ XMLPluggableNodeFactory ! !

!XMLNodeFactoryTest methodsFor: 'source' stamp: 'monty 8/1/2016 15:01'!
sampleUserXML
	^
	XMLWriter new
		enablePrettyPrinting;
		writeWith: [:writer |
			writer pi
				target: 'xml-stylesheet';
				data: 'type="text/css" href="sample.css"'.
			writer comment: 'sample'.
			writer tag
				name: 'user:user';
				xmlnsAt: 'user' put: 'urn:user';
				with: [
					writer
						tag: 'user:username' with: 'jsmith';
						tag: 'user:real-name' with: 'John Smith';
						tag: 'user:date-registered' with: [writer cdata: DateAndTime now printString];
						tag: 'user:date-last-active' with: [writer cdata: DateAndTime now printString];
						tag: 'table-name' with: 'users';
						tag: 'row-id' with: '1000';
						tag: 'serializationFormat' with: 'XML']];
		contents! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:17'!
testAsPluggableNodeFactory
	| factory pluggableFactory |

	factory := self factoryClass new.
	pluggableFactory := factory asPluggableNodeFactory.
	self assert: pluggableFactory class == self pluggableFactoryClass.
	factory class == self pluggableFactoryClass
		ifTrue: [self assert: pluggableFactory == factory]
		ifFalse: [self deny: pluggableFactory == factory].! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/6/2016 23:19'!
testAttributeDeclarationClass
	self assert: self newFactory attributeDeclarationClass == XMLAttributeDeclaration! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 9/2/2016 13:59'!
testAttributeListClass
	self assert: self newFactory attributeListClass == XMLCachingAttributeList! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:21'!
testCDataClass
	self assert: self newFactory cdataClass == XMLCData! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:17'!
testClassForElement
	self assert: (self newFactory classForElement: 'test') == XMLElement! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:22'!
testClassForElementNamespaceURI
	self assert:
		(self newFactory
			classForElement: 'test'
			namespaceURI: '') == XMLElement.
	self assert:
		(self newFactory
			classForElement: 'test'
			namespaceURI: 'testNS') == XMLElement.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:16'!
testCommentClass
	self assert: self newFactory commentClass == XMLComment! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/6/2016 23:07'!
testDoctypeDeclarationClass
	self assert: self newFactory doctypeDeclarationClass == XMLDoctypeDeclaration! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:23'!
testDocumentClass
	self assert: self newFactory documentClass == XMLDocument! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:24'!
testElementClass
	self assert: self newFactory elementClass == XMLElement! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/6/2016 23:06'!
testElementDeclarationClass
	self assert: self newFactory elementDeclarationClass == XMLElementDeclaration! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/6/2016 23:09'!
testGeneralEntityDeclarationClass
	self assert:
		self newFactory generalEntityDeclarationClass ==
			XMLGeneralEntityDeclaration! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:26'!
testNewCData
	| cdata |

	cdata := self newFactory newCData: 'test'.
	self
		assert: cdata class == XMLCData;
		assert: cdata string = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:29'!
testNewComment
	| comment |

	comment := self newFactory newComment: 'test'.
	self
		assert: comment class == XMLComment;
		assert: comment string = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:28'!
testNewDocument
	self assert: self newFactory newDocument class == XMLDocument! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/5/2016 13:39'!
testNewElement
	self assert: self newFactory newElement class == XMLElement! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:33'!
testNewElementNamed
	| element |

	element := self newFactory newElementNamed: 'test'.
	self
		assert: element class == XMLElement;
		assert: element name = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/12/2016 18:07'!
testNewElementNamedAttributes
	| element |

	element :=
		self newFactory
			newElementNamed: 'test'
			attributes: self attributeAssociations.
	self
		assert: element class == XMLElement;
		assert: element name = 'test';
		assert: element attributes = self attributes! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:30'!
testNewElementNamedNamespaceURI
	| element |

	element :=
		self newFactory
			newElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'.
	self
		assert: element class == XMLElement;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/12/2016 18:08'!
testNewElementNamedNamespaceURIAttributes
	| element |

	element :=
		self newFactory
			newElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'
			attributes: self attributeAssociations.
	self
		assert: element class == XMLElement;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS';
		assert: element attributes = self attributes.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:27'!
testNewPI
	self assert: self newFactory newPI class == XMLPI! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/9/2016 17:17'!
testNewPITargetData
	| pi |

	pi :=
		self newFactory
			newPITarget: 'target'
			data: 'data'.
	self
		assert: pi class == XMLPI;
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/5/2016 16:37'!
testNewStringNode
	| cdata |

	cdata := self newFactory newStringNode: 'test'.
	self
		assert: cdata class == XMLString;
		assert: cdata string = 'test'.! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:21'!
testNodeListClass
	self assert: self newFactory nodeListClass == XMLNodeList! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/6/2016 23:06'!
testNotationDeclarationClass
	self assert: self newFactory notationDeclarationClass == XMLNotationDeclaration! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:20'!
testPIClass
	self assert: self newFactory piClass == XMLPI! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/6/2016 23:09'!
testParameterEntityDeclarationClass
	self assert:
		self newFactory parameterEntityDeclarationClass ==
			XMLParameterEntityDeclaration! !

!XMLNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/5/2016 16:49'!
testStringNodeClass
	self assert: self newFactory stringNodeClass == XMLString! !

XMLNodeFactoryTest subclass: #XMLPluggableNodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

XMLPluggableNodeFactoryTest subclass: #XMLPluggableElementFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
dateElementClass
	^ XMLFDateElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 09:38'!
defaultElementClass
	^ self elementClass! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:22'!
elementClassMapperClass
	^ XMLBasicElementClassMapper! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 15:58'!
factoryClass
	^ XMLPluggableElementFactory! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
realNameElementClass
	^ XMLFRealNameElement! !

!XMLPluggableElementFactoryTest methodsFor: 'source' stamp: 'monty 8/26/2016 01:17'!
sampleUsersXML
	^
		'<users>
			<user>
				<Username>jsmith</Username>
				<RealName>John Smith</RealName>
			</user>
			<User>
				<username>msmith</username>
				<realName>Michael Smith</realName>
			</User>
			<user>
				<Username>jsmith2</Username>
				<real-name>James Smith</real-name>
			</user>
			<User>
				<username>rsmith</username>
				<real_name>Robert Smith</real_name>
			</User>
		</users>'.! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
serializationFormatElementClass
	^ XMLFSerializationFormatElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:39'!
tableElementClass
	^ XMLFTableElement! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 7/20/2015 21:34'!
testAddElementNamed
	| element userElement dataElement |

	element := XMLElement name: 'root'.
	element
		defaultNamespace: 'dataNS';
		declarePrefix: 'prefix' uri: 'prefixNS'.
	element nodeFactory:
		(XMLPluggableElementFactory new
			handleElement: 'data'
			namespaceURI: 'dataNS'
			withClass: XMLFElement;
			handleElement: 'user'
			namespaceURI: 'prefixNS'
			withClass: XMLFUserElement).

	userElement := element addElementNamed: 'prefix:user'.
	self
		assert: userElement class == XMLFUserElement;
		assert: (userElement isNamed: 'prefix:user');
		assert: userElement namespaceURI = 'prefixNS'.

	dataElement := element addElementNamed: 'data'.
	self
		assert: dataElement class == XMLFElement;
		assert: (dataElement isNamed: 'data');
		assert: dataElement namespaceURI = 'dataNS'.

	self assert: (element addElementNamed: 'default') class == XMLElement.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:14'!
testClassForElement
	| factory |

	(factory := self newFactoryWithClasses)
		handleElement: 'user'
		withClass: self userElementClass.
	self
		assert: (factory classForElement: 'user') == self userElementClass;
		assert: (factory classForElement: 'prefix:user') == self userElementClass;
		assert: (factory classForElement: 'absent') == self elementClass.

	factory
		handleElement: 'prefix:user'
		withClass: self usernameElementClass.
	self
		assert: (factory classForElement: 'user') == self userElementClass;
		assert: (factory classForElement: 'prefix:user') == self usernameElementClass;
		assert: (factory classForElement: 'prefix:absent') == self elementClass.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:14'!
testClassForElementNamespaceURI
	| factory |

	(factory := self newFactoryWithClasses)
		handleElement: 'user'
		namespaceURI: 'userNS'
		withClass: self userElementClass.
	self assert:
		(factory
			classForElement: 'user'
			namespaceURI: 'userNS') == self userElementClass.
	self assert:
		(factory
			classForElement: 'prefix:user'
			namespaceURI: 'userNS') == self userElementClass.
	self assert:
		(factory
			classForElement: 'user'
			namespaceURI: 'absentNS') == self elementClass.

	factory
		handleElement: 'prefix:user'
		namespaceURI: 'userNS'
		withClass: self usernameElementClass.
	self assert:
		(factory
			classForElement: 'user'
			namespaceURI: 'userNS') == self userElementClass.
	self assert:
		(factory
			classForElement: 'prefix:user'
			namespaceURI: 'userNS') == self usernameElementClass.
	self assert:
		(factory
			classForElement: 'prefix:user'
			namespaceURI: 'absentNS') == self elementClass.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:14'!
testCopy
	| factory copy |

	factory := self newFactoryWithClasses.
	factory handleElement: 'user' withClass: XMLFUserElement.
	copy := factory copy.
	self
		deny: copy == factory;
		deny: copy elementClassMapper == factory elementClassMapper.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'JAA 3/24/2011 18:25'!
testElementClassAccessor
	| document |

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: XMLPluggableElementFactory new;
			parseDocument.
	self assert: (document allElementsDetect: [:each | (each isMemberOf: XMLElement) not]) isNil.

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: (XMLPluggableElementFactory new elementClass: self defaultElementClass);
			parseDocument.
	self assert: (document allElementsDetect: [:each | (each isMemberOf: self defaultElementClass) not]) isNil.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:23'!
testElementClassMapper
	| factory oldMapper newMapper |

	factory := self newFactoryWithClasses.
	oldMapper := factory elementClassMapper.
	self assert: oldMapper class == self elementClassMapperClass.

	newMapper := self elementClassMapperClass new.
	self
		assert: (factory elementClassMapper: newMapper) == factory;
		assert: factory elementClassMapper == newMapper.! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:14'!
testElementClassNameMatching
	| document |

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory:
				(self newFactoryWithClasses
					handleElementsMatchingClass: self userElementClass;
					handleElementsMatchingClasses:
						(Array
							with: self realNameElementClass
							with: self serializationFormatElementClass));
			parseDocument.

	self
		assert: ((document root) isMemberOf: self userElementClass);
		assert: ((document root elementAt: 'real-name') isMemberOf: self realNameElementClass);
		assert:
			((document root elementAt: 'serializationFormat')
				isMemberOf: self serializationFormatElementClass).! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:14'!
testElementNameAndNamespaceMatching
	| factory document root |

	(factory := self newFactoryWithClasses)
		elementClass: self defaultElementClass;
		handleElement: 'user:user' namespaceURI: 'urn:user' withClass: self userElementClass;
		handleElement: 'user:user' withClass: self wrongElementClass;
		handleElement: 'user' namespaceURI: 'urn:user' withClass: self wrongElementClass;
		handleElement: 'user' withClass: self wrongElementClass;
		handleElement: 'user:username' withClass: self usernameElementClass;
		handleElement: 'username' namespaceURI: 'urn:user' withClass: self wrongElementClass;
		handleElement: 'username' withClass: self wrongElementClass;
		handleElement: 'real-name' namespaceURI: 'urn:user' withClass: self realNameElementClass;
		handleElement: 'real-name' withClass: self wrongElementClass;
		handleElement: 'date-registered' withClass: self dateElementClass;
		handleElement: 'user:date-last-active' namespaceURI: 'urn:notuser' withClass: self wrongElementClass;
		handleElement: 'notuser:date-last-active' namespaceURI: 'urn:user' withClass: self wrongElementClass;
		handleElement: 'date-last-active' namespaceURI: 'urn:notuser' withClass: self wrongElementClass;
		handleElement: 'notuser:date-last-active' withClass: self wrongElementClass.

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: factory;
			parseDocument.
	self
		assert: ((root := document root) isMemberOf: self userElementClass);
		assert: ((root elementAt: 'username') isMemberOf: self usernameElementClass);
		assert: ((root elementAt: 'real-name') isMemberOf: self realNameElementClass);
		assert: ((root elementAt: 'date-registered') isMemberOf: self dateElementClass);
		assert:
			((root elements copyAfter: (root elementAt: 'date-registered'))
				allSatisfy: [:each | each isMemberOf: self defaultElementClass]).! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:14'!
testElementsNameAndNamespaceMatching
	| factory document root |

	factory := self newFactoryWithClasses.
	factory
		handleElements: #('date-registered' 'date-last-active')
		namespaceURI: 'urn:user'
		withClass: self dateElementClass.
	factory
		handleElements: #('date-registered' 'date-last-active')
		withClass: self wrongElementClass.
	factory
		handleElements: #('table-name' 'not-table-name')
		withClass: self tableElementClass.

	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: factory;
			parseDocument.
	root := document root.
	self
		assert: ((root elementAt: 'date-registered') isMemberOf: self dateElementClass);
		assert: ((root elementAt: 'date-last-active') isMemberOf: self dateElementClass);
		assert: ((root elementAt: 'table-name') isMemberOf: self tableElementClass).! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/26/2016 20:52'!
testHandleElementsMatchingClass
	| document |

	document :=
		(XMLDOMParser on: self sampleUsersXML)
			nodeFactory:
				(XMLPluggableElementFactory new
					handleElementsMatchingClass: XMLFUserElement;
					handleElementsMatchingClass: XMLFUsernameElement;
					handleElementsMatchingClass: XMLFRealNameElement);
			parseDocument.

	document root elementsDo: [:element |
			self
				assert: (element class == XMLFUserElement);
				assert: (element elements first class == XMLFUsernameElement);
				assert: (element elements second class == XMLFRealNameElement)].! !

!XMLPluggableElementFactoryTest methodsFor: 'tests' stamp: 'monty 8/26/2016 20:52'!
testHandleElementsMatchingClasses
	| document |

	document :=
		(XMLDOMParser on: self sampleUsersXML)
			nodeFactory:
				(XMLPluggableElementFactory new
					handleElementsMatchingClasses:
						(Array
							with: XMLFUserElement
							with: XMLFUsernameElement
							with: XMLFRealNameElement));
			parseDocument.

	document root elementsDo: [:element |
			self
				assert: (element class == XMLFUserElement);
				assert: (element elements first class == XMLFUsernameElement);
				assert: (element elements second class == XMLFRealNameElement)].! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
userElementClass
	^ XMLFUserElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
usernameElementClass
	^ XMLFUsernameElement! !

!XMLPluggableElementFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
wrongElementClass
	^ XMLFWrongElement! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 9/8/2016 09:55'!
attributeListClass
	^ XMLFAttributeList! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:36'!
cdataClass
	^ XMLFCData! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:36'!
commentClass
	^ XMLFComment! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
documentClass
	^ XMLFDocument! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:37'!
elementClass
	^ XMLFElement! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 16:51'!
factoryClass
	^ XMLPluggableNodeFactory! !

!XMLPluggableNodeFactoryTest methodsFor: 'instance creation' stamp: 'monty 8/5/2016 16:49'!
newFactoryWithClasses
	^ self newFactory
		documentClass: self documentClass;
		elementClass: self elementClass;
		stringNodeClass: self stringNodeClass;
		cdataClass: self cdataClass;
		commentClass: self commentClass;
		piClass: self piClass! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 9/8/2016 09:55'!
nodeListClass
	^ XMLFNodeList! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 11/1/2014 22:38'!
piClass
	^ XMLFPI! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:16'!
pluggableFactoryClass
	^ self factoryClass! !

!XMLPluggableNodeFactoryTest methodsFor: 'accessing' stamp: 'monty 8/5/2016 16:50'!
stringNodeClass
	^ XMLFString! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 9/2/2016 08:26'!
testAttributeListClass
	| factory |

	super testAttributeListClass.

	factory := self newFactoryWithClasses.
	self
		assert: (factory attributeListClass: self attributeListClass) == factory;
		assert: factory attributeListClass == self attributeListClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:22'!
testCDataClass
	super testCDataClass.

	self assert: self newFactoryWithClasses cdataClass == self cdataClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:17'!
testClassForElement
	super testClassForElement.

	self assert: (self newFactoryWithClasses classForElement: 'test') == self elementClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:23'!
testClassForElementNamespaceURI
	super testClassForElementNamespaceURI.

	self assert:
		(self newFactoryWithClasses
			classForElement: 'test'
			namespaceURI: '') == self elementClass.
	self assert:
		(self newFactoryWithClasses
			classForElement: 'test'
			namespaceURI: 'testNS') == self elementClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:17'!
testCommentClass
	super testCommentClass.

	self assert: self newFactoryWithClasses commentClass == self commentClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:23'!
testDocumentClass
	super testDocumentClass.

	self assert: self newFactoryWithClasses documentClass == self documentClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:24'!
testElementClass
	super testElementClass.

	self assert: self newFactoryWithClasses elementClass == self elementClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:26'!
testNewCData
	| cdata |

	super testNewCData.

	cdata := self newFactoryWithClasses newCData: 'test'.
	self
		assert: cdata class == self cdataClass;
		assert: cdata string = 'test'.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:29'!
testNewComment
	| comment |
	
	super testNewComment.

	comment := self newFactoryWithClasses newComment: 'test'.
	self
		assert: comment class == self commentClass;
		assert: comment string = 'test'.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:28'!
testNewDocument
	super testNewDocument.

	self assert: self newFactoryWithClasses newDocument class == self documentClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/5/2016 13:39'!
testNewElement
	super testNewElement.

	self assert: self newFactoryWithClasses newElement class == self elementClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:31'!
testNewElementNamed
	| element |

	super testNewElementNamed.

	element := self newFactoryWithClasses newElementNamed: 'test'.
	self
		assert: element class == self elementClass;
		assert: element name = 'test'.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:30'!
testNewElementNamedNamespaceURI
	| element |

	super testNewElementNamedNamespaceURI.

	element :=
		self newFactoryWithClasses
			newElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'.
	self
		assert: element class == self elementClass;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS'.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:27'!
testNewPI
	super testNewPI.

	self assert: self newFactoryWithClasses newPI class == self piClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/9/2016 17:18'!
testNewPITargetData
	| pi |

	super testNewPITargetData.

	pi :=
		self newFactoryWithClasses
			newPITarget: 'target'
			data: 'data'.
	self
		assert: pi class == self piClass;
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/5/2016 16:49'!
testNewStringNode
	| string |

	super testNewStringNode.

	string := self newFactoryWithClasses newStringNode: 'test'.
	self
		assert: string class == self stringNodeClass;
		assert: string string = 'test'.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:33'!
testNodeListClass
	| factory |

	super testNodeListClass.

	factory := self newFactoryWithClasses.
	self
		assert: (factory nodeListClass: self nodeListClass) == factory;
		assert: factory nodeListClass == self nodeListClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/4/2016 20:19'!
testPIClass
	super testPIClass.

	self assert: self newFactoryWithClasses piClass == self piClass.! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/5/2016 16:50'!
testParsingSample
	| document factory |

	factory := self newFactoryWithClasses.
	document :=
		(XMLDOMParser on: self sampleUserXML)
			nodeFactory: factory;
			preservesCDataNodes: true;
			preservesCommentNodes: true;
			parseDocument.
	self
		assert: document class == self documentClass;
		assert: document nodeFactory == factory.

	document allElementsDo: [:each |
		self
			assert: each class == self elementClass;
			assert: each nodeFactory == factory].

	document allNodesDo: [:each |
		each isStringNode
			ifTrue: [
				self assert:
					each class == 
						(each isCData
							ifTrue: [self cdataClass]
							ifFalse: [self stringNodeClass])].
		each isComment
			ifTrue: [self assert: each class == self commentClass].
		each isPI
			ifTrue: [self assert: each class == self piClass]].! !

!XMLPluggableNodeFactoryTest methodsFor: 'tests' stamp: 'monty 8/5/2016 16:50'!
testStringNodeClass
	super testStringNodeClass.

	self assert: self newFactoryWithClasses stringNodeClass == self stringNodeClass.! !

TestCase subclass: #XMLNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNodeTest commentStamp: '<historical>' prior: 0!
This is a base class for node tests.!

XMLNodeTest subclass: #XMLAttributeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLAttributeTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 00:03'!
escapedString
	^ '&lt;test name=&quot;&amp;name;&quot;>''&amp;value;''&lt;/test>'! !

!XMLAttributeTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:17'!
nodeClass
	^ XMLAttribute! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 20:59'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self assert:
		((self nodeClass name: 'one' value: 'two') canonicallyEquals:
			(self nodeClass name: 'one' value: 'two')).
	self deny:
		((self nodeClass name: 'one' value: 'two') canonicallyEquals:
			self newNode).! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:16'!
testCopy
	| node copy |

	(node := self newNode)
		element: self newElement.
	copy := node copy.
	self
		deny: copy == node;
		assert: copy element isNil.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:17'!
testElement
	| attribute element |

	attribute := self newNode.
	self assert: attribute element isNil.

	element := self newElement.
	self
		assert: (attribute element: element) == attribute;
		assert: attribute element == element.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:17'!
testExpandedName
	| element attribute |

	element := self newElement.
	attribute := self nodeClass name: 'one' value: 'two'.
	element attributeNodes add: attribute.
	self assert: (attribute expandedName = 'one').

	element defaultNamespace: 'defaultNS'.
	self assert: (attribute expandedName = 'one').

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	attribute name: 'prefix:two'.
	self assert: (attribute expandedName = 'Q{prefixNS}two').! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasLanguage
	| attribute |

	attribute := self newNode.
	attribute name: 'xml:lang'.
	self
		deny: (attribute hasLanguage: 'en-us');
		deny: (attribute hasLanguage: 'EN-US');
		deny: (attribute hasLanguage: 'En');
		deny: (attribute hasLanguage: 'de-de');
		deny: (attribute hasLanguage: 'DE-DE');
		deny: (attribute hasLanguage: 'De').

	attribute value: 'En-Us'.
	self
		assert: (attribute hasLanguage: 'en-us');
		assert: (attribute hasLanguage: 'EN-US');
		assert: (attribute hasLanguage: 'En');
		deny: (attribute hasLanguage: 'de-de');
		deny: (attribute hasLanguage: 'DE-DE');
		deny: (attribute hasLanguage: 'De').! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:17'!
testHasNamespaceURI
	| element attribute |

	attribute := self nodeClass name: 'test' value: ''.
	self deny: attribute hasNamespaceURI.

	element :=
		self elementClass
			name: 'test'
			namespaceURI: 'defaultNS'.
	element attributeNodes add: attribute.
	self deny: attribute hasNamespaceURI.

	element
		declarePrefix: 'prefix'
		uri: 'prefixNS'.
	attribute name: 'prefix:test'.
	self assert: attribute hasNamespaceURI.

	attribute name: 'test'.
	self deny: attribute hasNamespaceURI.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasPrefix
	| attribute |

	attribute := self newNode.
	self deny: attribute hasPrefix.

	attribute name: 'one'.
	self deny: attribute hasPrefix.

	attribute name: 'prefix:two'.
	self assert: attribute hasPrefix.

	attribute name: 'three'.
	self deny: attribute hasPrefix.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsAttribute
	self assert: self newNode isAttribute! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 12/23/2014 21:04'!
testIsInLanguage
	| element |

	super testIsInLanguage.
	element := self newElementWithAttributes.	
	element attributeNodesDo: [:each |
		self
			deny: (each isInLanguage: 'en');
			deny: (each isInLanguage: 'EN');
			deny: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'en-us');
			deny: (each isInLanguage: 'EN-US');
			deny: (each isInLanguage: 'En-Us')].

	element attributeAt: 'xml:lang' put: 'En'.
	element attributeNodesDo: [:each |
		self
			assert: (each isInLanguage: 'en');
			assert: (each isInLanguage: 'EN');
			assert: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'en-us');
			deny: (each isInLanguage: 'EN-US');
			deny: (each isInLanguage: 'En-Us')].! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsNamed
	| attribute |

	(attribute := self newNode)
		name: 'one'.
	self
		assert: (attribute isNamed: 'one');
		deny: (attribute isNamed: 'two').

	attribute name: 'one:two'.
	self
		assert: (attribute isNamed: 'one:two');
		assert: (attribute isNamed: 'two');
		deny: (attribute isNamed: 'one').! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsNamedAny
	| attribute |

	(attribute := self newNode) name: 'one'.
	self
		assert: (attribute isNamedAny: #('two' 'one' 'three') asSet);
		deny: (attribute isNamedAny: #('two' 'three') asSet).

	attribute name: 'one:two'.
	self
		assert: (attribute isNamedAny: #('one' 'one:two' 'three'));
		assert: (attribute isNamedAny: #('one' 'two' 'three'));
		deny: (attribute isNamedAny: #('one' 'three')).! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testLocalName
	| attribute |

	attribute := self newNode.
	self assert: attribute name = ''.

	attribute name: 'one'.
	self assert: attribute localName = 'one'.

	attribute name: 'two'.
	self assert: attribute localName = 'two'.

	attribute name: 'prefix:three'.
	self assert: attribute localName = 'three'.

	attribute name: 'four'.
	self assert: attribute localName = 'four'.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testName
	| attribute |

	"XMLAttribute class>>#name: is not tested here because it is soft-deprecated"

	attribute := self newNode.
	self
		assert: attribute name = '';
		assert: (attribute name: 'one') == attribute;
		assert: attribute name = 'one';
		assert: (attribute name: 'prefix:two') == attribute;
		assert: attribute name = 'prefix:two'.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/26/2016 20:48'!
testNameValue
	| attribute |

	attribute :=
		self nodeClass
			name: 'one'
			value: 'two'.
	self
		assert: attribute class == self nodeClass;
		assert: attribute name = 'one';
		assert: attribute value = 'two'.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/26/2016 20:48'!
testNamed
	| attribute |

	attribute := self nodeClass named: 'test'.
	self
		assert: attribute class == self nodeClass;
		assert: attribute name = 'test'.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testNamespaceURI
	| element attribute|

	element := self newElement.
	attribute := self newNode.
	element attributeNodes add: attribute.
	self assert: attribute namespaceURI = ''.

	element defaultNamespace: 'defaultNS'.
	self assert: attribute namespaceURI = ''.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	attribute name: 'prefix:test'.
	self assert: attribute namespaceURI = 'prefixNS'.
	
	attribute name: 'test'.
	self assert: attribute namespaceURI = ''.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testPrefix
	| attribute |

	attribute := self newNode.
	self assert: attribute prefix = ''.

	attribute name: 'one'.
	self assert: attribute prefix = ''.

	attribute name: 'prefix:two'.
	self assert: attribute prefix = 'prefix'.

	attribute name: 'three'.
	self assert: attribute prefix = ''.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 2/26/2017 11:39'!
testResolvePrefix
	| element attribute|

	element := self newElementWithAttributes.
	attribute := element attributeNodes first.
	self namespaces keysAndValuesDo: [:prefix :uri |
		"no default namespace for attributes"
		prefix = ''
			ifTrue: [self assert: (attribute resolvePrefix: prefix) = '']
			ifFalse: [self assert: (attribute resolvePrefix: prefix) = uri]].

	self assert:
		(attribute resolvePrefix: 'xml') = XMLNamespaceScope xmlNamespaceURI.
	self  assert:
		(attribute resolvePrefix: 'xmlns') = XMLNamespaceScope xmlnsNamespaceURI.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:54'!
testResolvePrefixIfUnresolvable
	| element attribute|

	element := self newElementWithAttributes.
	attribute := element attributeNodes first.
	self namespaces keysAndValuesDo: [:prefix :uri |
		prefix = ''
			ifTrue: [
				"no default namespace for attributes"
				self assert:
					(attribute
						resolvePrefix: prefix
						ifUnresolvable: ['unresolvable']) = 'unresolvable']
			ifFalse: [
				self assert:
					(attribute
						resolvePrefix: prefix
						ifUnresolvable: [self fail]) = uri]].

	self assert:
		(attribute
			resolvePrefix: 'xml'
			ifUnresolvable: [self fail]) = XMLNamespaceScope xmlNamespaceURI.
	self  assert:
		(attribute
			resolvePrefix: 'xmlns'
			ifUnresolvable: [self fail]) = XMLNamespaceScope xmlnsNamespaceURI.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testSortKey
	self assert: (self newNode name: 'test') sortKey = 'test'! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testValue
	| attribute |

	attribute := self newNode.
	self
		assert: attribute value = '';
		assert: (attribute value: 'test') == attribute;
		assert: attribute value = 'test'.! !

!XMLAttributeTest methodsFor: 'tests' stamp: 'monty 11/23/2014 05:17'!
testWriteXMLOn
	self
		assert: (self nodeClass name: 'name' value: '') printString = 'name=""';
		assert: (self nodeClass name: 'name' value: 'value') printString = 'name="value"';
		assert:
			(self nodeClass
				name: 'name'
				value: self markupString) printString = ('name="', self escapedString, '"')! !

XMLNodeTest subclass: #XMLCommentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLCommentTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:17'!
nodeClass
	^ XMLComment! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAcceptNodeVisitor
	| visitor comment message |

	visitor := XMLRecordingNodeVisitor new.
	comment := self newNode.
	self
		assert: (comment acceptNodeVisitor: visitor) == comment;
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitComment:;
		assert: message arguments = (Array with: comment);
		deny: visitor messageRecorder hasMessages.! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 9/5/2016 20:59'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self assert:
		((self nodeClass string: 'test') canonicallyEquals:
			(self nodeClass string: 'test')).
	self deny:
		((self nodeClass string: 'test') canonicallyEquals:
			self newNode).! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsComment
	self assert: self newNode isComment! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 12/3/2014 01:09'!
testSortKey
	self assert: (self nodeClass string: 'test') sortKey = 'test'! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:26'!
testString
	| comment |

	comment := self nodeClass string: self markupString.
	self
		assert: comment class == self nodeClass;
		assert: comment string = self markupString.

	comment := self newNode.
	self assert: comment string = ''.

	comment string: self markupString.
	self assert: comment string = self markupString.

	comment string: ''.
	self assert: comment string = ''.! !

!XMLCommentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testWriteXMLOn
	self
		assert: self newNode printString = '<!!---->';
		assert:
			(self nodeClass string: self markupString) printString =
				('<!!--', self markupString, '-->')! !

XMLNodeTest subclass: #XMLDeclarationNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDeclarationNodeTest commentStamp: 'monty 11/23/2014 18:43' prior: 0!
Abstract, do not run.!

XMLDeclarationNodeTest subclass: #XMLAttributeDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLAttributeDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 19:21'!
isAbstract
	^ false! !

!XMLAttributeDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 19:22'!
nodeClass
	^ XMLAttributeDeclaration! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testAttribute
	| declaration |

	declaration := self newNode.
	self
		assert: declaration attribute = '';
		assert: (declaration attribute: 'test') == declaration;
		assert: declaration attribute = 'test'.! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testDefaultPragma
	| declaration |

	declaration := self newNode.
	self
		assert: declaration defaultPragma = '';
		assert: (declaration defaultPragma: 'REQUIRED') == declaration;
		assert: declaration defaultPragma = 'REQUIRED'.! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testDefaultValue
	| declaration |

	declaration := self newNode.
	self
		assert: declaration defaultValue = '';
		assert: (declaration defaultValue: 'test') == declaration;
		assert: declaration defaultValue = 'test'.! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testElement
	| declaration |

	declaration := self newNode.
	self
		assert: declaration element = '';
		assert: (declaration element: 'test') == declaration;
		assert: declaration element = 'test'.! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:37'!
testElementAttributeTypeDefaultPragmaDefaultValue
	| declaration |

	declaration :=
		self nodeClass
			element: 'one'
			attribute: 'two'
			type: 'CDATA'
			defaultPragma: '#IMPLIED'
			defaultValue: 'default'.
	self
		assert: declaration class == self nodeClass;
		assert: declaration element = 'one';
		assert: declaration attribute = 'two';
		assert: declaration type = 'CDATA';
		assert: declaration defaultPragma = '#IMPLIED';
		assert: declaration defaultValue = 'default'.! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:25'!
testType
	| declaration |

	declaration := self newNode.
	self
		assert: declaration type = '';
		assert: (declaration type: 'CDATA') == declaration;
		assert: declaration type = 'CDATA'.! !

!XMLAttributeDeclarationTest methodsFor: 'tests' stamp: 'monty 2/21/2017 01:05'!
testWriteXMLOn
	self assert:
		(self nodeClass
			element: 'one'
			attribute: 'two'
			type: 'CDATA'
			defaultPragma: ''
			defaultValue: 'three') printString = '<!!ATTLIST one two CDATA "three">'.
	self assert:
		(self nodeClass
			element: 'one'
			attribute: 'two'
			type: 'ENTITY'
			defaultPragma: 'FIXED'
			defaultValue: 'three') printString = '<!!ATTLIST one two ENTITY #FIXED "three">'.
	self assert:
		(self nodeClass
			element: 'one'
			attribute: 'two'
			type: '(three|four)'
			defaultPragma: '#IMPLIED'
			defaultValue: 'four') printString = '<!!ATTLIST one two (three|four) #IMPLIED>'.! !

!XMLDeclarationNodeTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 18:14'!
isAbstract
	^ true! !

!XMLDeclarationNodeTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:11'!
nodeClass
	^ XMLDeclarationNode! !

!XMLDeclarationNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsDeclaration
	self assert: self newNode isDeclaration! !

XMLDeclarationNodeTest subclass: #XMLElementDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 18:27'!
isAbstract
	^ false! !

!XMLElementDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:25'!
nodeClass
	^ XMLElementDeclaration! !

!XMLElementDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:14'!
testContentModel
	| declaration |

	declaration := self newNode.
	self
		assert: declaration contentModel = '';
		assert: (declaration contentModel: '(one|two)') == declaration;
		assert: declaration contentModel = '(one|two)'.! !

!XMLElementDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:23'!
testElement
	| declaration |

	declaration := self newNode.
	self
		assert: declaration element = '';
		assert: (declaration element: 'test') == declaration;
		assert: declaration element = 'test'.! !

!XMLElementDeclarationTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:37'!
testElementContentModel
	| declaration |

	declaration :=
		self nodeClass
			element: 'one'
			contentModel: '(two|three)'.
	self
		assert: declaration class == self nodeClass;
		assert: declaration element = 'one';
		assert: declaration contentModel = '(two|three)'! !

!XMLElementDeclarationTest methodsFor: 'assertions' stamp: 'monty 11/23/2014 18:31'!
testWriteXMLOn
	self assert:
		(self nodeClass
			element: 'one'
			contentModel: '(two | three)') printString = '<!!ELEMENT one (two | three)>'.
	self assert:
		(self nodeClass
			element: 'one'
			contentModel: 'EMPTY') printString = '<!!ELEMENT one EMPTY>'.! !

XMLDeclarationNodeTest subclass: #XMLEntityDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLEntityDeclarationTest commentStamp: 'monty 11/23/2014 18:46' prior: 0!
Abstract, do not run.!

!XMLEntityDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:46'!
nodeClass
	^ XMLEntityDeclaration! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/28/2017 09:59'!
testIsExternal
	| declaration |

	declaration := self newNode.
	self deny: declaration isExternal.

	declaration systemID: 'test'.
	self assert: declaration isExternal.

	declaration publicID: 'test'.
	self assert: declaration isExternal.

	declaration systemID: ''.
	self assert: declaration isExternal.

	declaration publicID: ''.
	self deny: declaration isExternal.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsParameter
	self deny: self newNode isParameter! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/28/2017 09:56'!
testIsUnparsed
	self deny: self newNode isUnparsed! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:13'!
testName
	| declaration |

	declaration := self newNode.
	self
		assert: declaration name = '';
		assert: (declaration name: 'test') == declaration;
		assert: declaration name = 'test'.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:36'!
testNamePublicIDSystemID
	| declaration |

	declaration :=
		self nodeClass
			name: 'one'
			publicID: 'two'
			systemID: 'three'.
	self
		assert: declaration class == self nodeClass;
		assert: declaration name = 'one';
		assert: declaration publicID = 'two';
		assert: declaration systemID = 'three'.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 8/26/2016 22:01'!
testNameReplacement
	| declaration |

	declaration :=
		self nodeClass
			name: 'one'
			replacement: 'two'.
	self
		assert: declaration class == self nodeClass;
		assert: declaration name = 'one';
		assert: declaration replacement = 'two'.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:12'!
testPublicID
	| declaration |

	declaration := self newNode.
	self
		assert: declaration publicID = '';
		assert: (declaration publicID: 'test') == declaration;
		assert: declaration publicID = 'test'.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:14'!
testReplacement
	| declaration |

	declaration := self newNode.
	self
		assert: declaration replacement = '';
		assert: (declaration replacement: 'test') == declaration;
		assert: declaration replacement = 'test'.! !

!XMLEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:12'!
testSystemID
	| declaration |

	declaration := self newNode.
	self
		assert: declaration systemID = '';
		assert: (declaration systemID: 'test') == declaration;
		assert: declaration systemID = 'test'.! !

XMLEntityDeclarationTest subclass: #XMLGeneralEntityDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLGeneralEntityDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 18:47'!
isAbstract
	^ false! !

!XMLGeneralEntityDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 18:59'!
nodeClass
	^ XMLGeneralEntityDeclaration! !

!XMLGeneralEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/28/2017 09:58'!
testIsUnparsed
	super testIsUnparsed.

	self assert: (self newNode ndata: 'test') isUnparsed.! !

!XMLGeneralEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:13'!
testNData
	| declaration |

	declaration := self newNode.
	self
		assert: declaration ndata = '';
		assert: (declaration ndata: 'test') == declaration;
		assert: declaration ndata = 'test'.! !

!XMLGeneralEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:37'!
testNamePublicIDSystemIDNdata
	| declaration |

	declaration :=
		self nodeClass
			name: 'one'
			publicID: 'two'
			systemID: 'three'
			ndata: 'four'.
	self
		assert: declaration class == self nodeClass;
		assert: declaration name = 'one';
		assert: declaration publicID = 'two';
		assert: declaration systemID = 'three';
		assert: declaration ndata = 'four'.! !

!XMLGeneralEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:07'!
testWriteXMLOn
	self assert:
		(self nodeClass name: 'one' replacement: 'two') printString =
			'<!!ENTITY one "two">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three') printString =
			'<!!ENTITY one PUBLIC "two" "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: '' systemID: 'three') printString =
			'<!!ENTITY one SYSTEM "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three' ndata: 'four') printString =
			'<!!ENTITY one PUBLIC "two" "three" NDATA four>'.! !

XMLEntityDeclarationTest subclass: #XMLParameterEntityDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLParameterEntityDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 19:18'!
isAbstract
	^ false! !

!XMLParameterEntityDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 19:01'!
nodeClass
	^ XMLParameterEntityDeclaration! !

!XMLParameterEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsParameter
	self assert: self newNode isParameter! !

!XMLParameterEntityDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:07'!
testWriteXMLOn
	self assert:
		(self nodeClass name: 'one' replacement: 'two') printString =
			'<!!ENTITY % one "two">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three') printString =
			'<!!ENTITY % one PUBLIC "two" "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: '' systemID: 'three') printString =
			'<!!ENTITY % one SYSTEM "three">'.! !

XMLDeclarationNodeTest subclass: #XMLNotationDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNotationDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/23/2014 19:12'!
isAbstract
	^ false! !

!XMLNotationDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/23/2014 19:15'!
nodeClass
	^ XMLNotationDeclaration! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:12'!
testName
	| declaration |

	declaration := self newNode.
	self
		assert: declaration name = '';
		assert: (declaration name: 'test') == declaration;
		assert: declaration name = 'test'.! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:59'!
testNamePublicIDSystemID
	| declaration |

	declaration :=
		self nodeClass
			name: 'one'
			publicID: 'two'
			systemID: 'three'.
	self
		assert: declaration class == self nodeClass;
		assert: declaration name = 'one';
		assert: declaration publicID = 'two';
		assert: declaration systemID = 'three'.! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:12'!
testPublicID
	| declaration |

	declaration := self newNode.
	self
		assert: declaration publicID = '';
		assert: (declaration publicID: 'test') == declaration;
		assert: declaration publicID = 'test'.! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:12'!
testSystemID
	| declaration |

	declaration := self newNode.
	self
		assert: declaration systemID = '';
		assert: (declaration systemID: 'test') == declaration;
		assert: declaration systemID = 'test'.! !

!XMLNotationDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2014 19:20'!
testWriteXMLOn
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: 'three') printString =
			'<!!NOTATION one PUBLIC "two" "three">'.
	self assert:
		(self nodeClass name: 'one' publicID: '' systemID: 'two') printString =
			'<!!NOTATION one SYSTEM "two">'.
	self assert:
		(self nodeClass name: 'one' publicID: 'two' systemID: '') printString =
			'<!!NOTATION one PUBLIC "two">'.! !

!XMLNodeTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 10:56'!
shouldInheritSelectors
	^ true! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'monty 8/26/2016 22:21'!
assertElement: anElement hasAttributes: anAssociationCollection
	| attributeNodes |

	self assert: anElement attributeNodes size = anAssociationCollection size.
	attributeNodes := anElement attributeNodes copy.
	anAssociationCollection associationsDo: [:each | | attributeNode |
		attributeNode := attributeNodes removeFirst.
		self
			assert: attributeNode name = each key;
			assert: attributeNode value = each value].! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'monty 11/7/2014 14:19'!
assertList: aList collects: aSecondList
	self
		assert: aList = aSecondList;
		assert: aList class == self collectListClass.! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'monty 3/9/2015 19:06'!
assertList: aList selects: aSecondList
	self
		assert: aList = aSecondList;
		assert: aList class == self selectListClass.! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 00:19'!
attributeAssociations
	^ Array
		with: 'one' -> '1'
		with: 'two' -> '2'
		with: 'prefix:two' -> '3'  "different from 'two', because of the prefix"
		with: 'prefix:four' -> '4'! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 9/5/2016 04:22'!
attributeClass
	^ XMLAttribute! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 9/8/2016 09:53'!
attributeListClass
	^ XMLCachingAttributeList! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 9/6/2016 03:16'!
attributeNames
	^ self attributeAssociations collect: [:each | each key]! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 19:34'!
attributeValues
	^ self attributeAssociations collect: [:each | each value]! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 18:50'!
attributes
	^ self attributesClass newFrom: self attributeAssociations! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 18:50'!
attributesClass
	^ OrderPreservingStringDictionary! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 11/7/2014 14:19'!
collectListClass
	^ XMLOrderedList! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 9/1/2016 21:16'!
elementClass
	^ XMLElement! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 12/1/2014 09:31'!
escapedString
	^ '&lt;test name="&amp;name;"&gt;''&amp;value;''&lt;/test&gt;'! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 11/7/2014 13:56'!
markupString
	^ '<test name="&name;">''&value;''</test>'! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 2/24/2016 16:31'!
namespaceAssociations
	^ Array
		with: '' -> 'defaultNS'
		with: 'prefix' -> 'prefixNS'
		with: 'prefixTwo' -> 'prefixTwoNS'! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 18:50'!
namespaces
	^ self attributesClass newFrom: self namespaceAssociations! !

!XMLNodeTest methodsFor: 'instance creation' stamp: 'monty 9/1/2016 21:16'!
newElement
	^ self elementClass
		name: 'test'
		namespaces: self namespaceAssociations! !

!XMLNodeTest methodsFor: 'instance creation' stamp: 'monty 9/5/2016 04:22'!
newElementWithAttributes
	| element |

	element := self newElement.
	self attributeAssociations do: [:each |
		element attributeNodes addLast:
			(self attributeClass
				name: each key
				value: each value)].
	^ element.! !

!XMLNodeTest methodsFor: 'instance creation' stamp: 'monty 8/27/2016 17:20'!
newNode
	^ self nodeClass new! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 10:59'!
nodeClass
	^ XMLNode! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 3/7/2017 10:07'!
nodeFactoryClass
	^ XMLNodeFactory! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 9/8/2016 09:59'!
otherAttributeListClass
	"must be different from attributeListClass"
	^ XMLFAttributeList! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 9/8/2016 10:00'!
otherElementClass
	"must be different from elementClass"
	^ XMLFElement! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 3/9/2015 19:06'!
selectListClass
	^ XMLNodeList! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'JAAyer 10/28/2010 21:25'!
should: aBlock enumerate: aCollection
	| enumerated |

	enumerated := OrderedCollection new.
	aBlock value: [:each | enumerated add: each].
	self assert: enumerated = aCollection asOrderedCollection.! !

!XMLNodeTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 03:18'!
should: aBlock enumerate: aFirstCollection and: aSecondCollection
	| firstEnumerated secondEnumerated |

	firstEnumerated := OrderedCollection new.
	secondEnumerated := OrderedCollection new.
	aBlock value: [:first :second |
		firstEnumerated addLast: first.
		secondEnumerated addLast: second].
	self
		assert: firstEnumerated = aFirstCollection asOrderedCollection;
		assert: secondEnumerated = aSecondCollection asOrderedCollection.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAcceptNodeVisitor
	| visitor node |

	visitor := XMLRecordingNodeVisitor new.
	node := self newNode.
	self
		assert: (node acceptNodeVisitor: visitor) == node;
		deny: visitor messageRecorder hasMessages.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAncestorElements
	self assert: self newNode ancestorElements isEmpty! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 9/6/2016 01:47'!
testAncestorElementsDo
	| node |

	node := self newNode.
	self
		should: [:block |  node ancestorElementsDo: block]
		enumerate: #().! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAncestorNodes
	self assert: self newNode ancestorNodes isEmpty! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 9/6/2016 01:47'!
testAncestorNodesDo
	| node |

	node := self newNode.
	self
		should: [:block |  node ancestorNodesDo: block]
		enumerate: #().! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testCanHaveChildren
	self deny: self newNode canHaveChildren! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testCanonicallyEquals
	self assert: (self newNode canonicallyEquals: self newNode)! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testConfiguration
	self assert: self newNode configuration isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:24'!
testContentString
	self assert: self newNode contentString = ''! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testCopy
	| node copy |

	(node := self newNode)
		parent: self newNode.
	copy := node copy.
	self
		deny: copy == node;
		deny: copy hasParent. ! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testDocument
	self assert: self newNode document isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testDocumentRoot
	| node |

	node := self newNode.
	self assert: node documentRoot == node.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasChildren
	self deny: self newNode hasChildren! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasParent
	| node |

	node := self newNode.
	self deny: node hasParent.

	node parent: self newNode.
	self assert: node hasParent.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsAttribute
	self deny: self newNode isAttribute! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsCData
	self deny: self newNode isCData! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsComment
	self deny: self newNode isComment! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsContentNode
	self deny: self newNode isContentNode! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsDeclaration
	self deny: self newNode isDeclaration! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsDocument
	self deny: self newNode isDocument! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsElement
	self deny: self newNode isElement! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsElementNamed
	self deny: (self newNode isElementNamed: '')! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsElementNamedAny
	self deny: (self newNode isElementNamedAny: #())! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsInLanguage
	self deny: (self newNode isInLanguage: 'test')! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsPI
	self deny: self newNode isPI! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsStringNode
	self
		deny: self newNode isStringNode;
		deny: (self newNode isStringNode: '').! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewCData
	| cdata |

	cdata := self newNode newCData: 'test'.
	self
		assert: cdata isCData;
		assert: cdata string = 'test'.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewComment
	| comment |

	comment := self newNode newComment: 'test'.
	self
		assert: comment isComment;
		assert: comment string = 'test'.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewDocument
	| node document |

	node := self newNode.
	document := node newDocument.
	self assert: document isDocument.
	node configuration
		ifNotNil: [
			self
				assert: document configuration == node configuration;
				assert: document nodeFactory == node nodeFactory].! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewElement
	| node element |

	node := self newNode.
	element := node newElement.
	self assert: element isElement.
	node configuration
		ifNotNil: [
			self
				assert: element configuration == node configuration;
				assert: element nodeFactory == node nodeFactory].! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewElementNamed
	| node element |

	node := self newNode.
	element := node newElementNamed: 'test'.
	self
		assert: element isElement;
		assert: element name = 'test'.
	node configuration
		ifNotNil: [
			self
				assert: element configuration == node configuration;
				assert: element nodeFactory == node nodeFactory].! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewElementNamedAttributes
	| node element |

	node := self newNode.
	element :=
		node
			newElementNamed: 'test'
			attributes: self unprefixedAttributeAssociations.
	self
		assert: element isElement;
		assert: element name = 'test';
		assertElement: element hasAttributes: self unprefixedAttributes.
	node configuration
		ifNotNil: [
			self
				assert: element configuration == node configuration;
				assert: element nodeFactory == node nodeFactory].! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewElementNamedNamespaceURI
	| node element |

	node := self newNode.
	element :=
		node
			newElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'.
	self
		assert: element isElement;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS'.
	node configuration
		ifNotNil: [
			self
				assert: element configuration == node configuration;
				assert: element nodeFactory == node nodeFactory].! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewElementNamedNamespaceURIAttributes
	| node element |

	node := self newNode.
	element :=
		node
			newElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'
			attributes: self attributeAssociations.
	self
		assert: element isElement;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS';
		assertElement: element hasAttributes: self attributes.
	node configuration
		ifNotNil: [
			self
				assert: element configuration == node configuration;
				assert: element nodeFactory == node nodeFactory].! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewPI
	self assert: self newNode newPI isPI.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewPITargetData
	| pi |

	pi :=
		self newNode
			newPITarget: 'target'
			data: 'data'.
	self
		assert: pi isPI;
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewStringNode
	| stringNode |

	stringNode := self newNode newStringNode: 'test'.
	self
		assert: stringNode isStringNode;
		assert: stringNode string = 'test'.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNextNode
	self assert: self newNode nextNode isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 3/7/2017 10:07'!
testNodeFactory
	self assert: self newNode nodeFactory class == self nodeFactoryClass! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testParent
	| node parent |

	node := self newNode.
	self assert: node parent isNil.

	parent := self newNode.
	self
		assert: (node parent: parent) == node;
		assert: node parent == parent.! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testPreviousNode
	self assert: self newNode previousNode isNil! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:24'!
testRawContentString
	self assert: self newNode rawContentString = ''! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testSortKey
	self assert: self newNode sortKey = self nodeClass name asString! !

!XMLNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testValidate
	self
		shouldnt: [self newNode validate]
		raise: XMLValidationException! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
unprefixedAttributeAssociations
	^ self attributeAssociations collect: [:each |
		each key xmlLocalNameAfterPrefix -> each value]! !

!XMLNodeTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 18:51'!
unprefixedAttributes
	^ self attributesClass newFrom: self unprefixedAttributeAssociations! !

XMLNodeTest subclass: #XMLNodeWithChildrenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNodeWithChildrenTest commentStamp: 'monty 11/4/2014 19:05' prior: 0!
Abstract, do not run.!

XMLNodeWithChildrenTest subclass: #XMLDoctypeDeclarationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDoctypeDeclarationTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:06'!
isAbstract
	^ false! !

!XMLDoctypeDeclarationTest methodsFor: 'instance creation' stamp: 'monty 8/27/2016 17:20'!
newNodeWithNodes
	^ self newNode
		addNode: (XMLComment string: 'before');
		addNode: (XMLGeneralEntityDeclaration name: 'one' replacement: 'two');
		addNode: (XMLParameterEntityDeclaration name: 'three' publicID: 'four' systemID: 'four');
		addNode: (XMLElementDeclaration element: 'five' contentModel: '(six|sevent|eight)');
		addNode:
			(XMLAttributeDeclaration
				element: 'five'
				attribute: 'nine'
				type: 'CDATA'
				defaultPragma: '#IMPLIED'
				defaultValue: 'ten');
		addNode:
			(XMLNotationDeclaration
				name: 'eleven'
				publicID: 'twelve'
				systemID: 'twelve');
		addNode: (XMLPI target: 'thirteen' data: 'fourteen');
		addNode: (XMLComment string: 'after');
		yourself! !

!XMLDoctypeDeclarationTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:02'!
nodeClass
	^ XMLDoctypeDeclaration! !

!XMLDoctypeDeclarationTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:19'!
nodeListClass
	^ XMLInternalSubsetList! !

!XMLDoctypeDeclarationTest methodsFor: 'accessing' stamp: 'monty 3/9/2015 19:06'!
selectListClass
	^ XMLInternalSubsetList! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/22/2014 20:40'!
testAllNodes
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assert: allNodes size = 9;
		assert: allNodes first == nodeWithNodes;
		assert: allNodes second isComment;
		assert: allNodes second string = 'before';
		assert: allNodes third class == XMLGeneralEntityDeclaration;
		assert: allNodes fourth class == XMLParameterEntityDeclaration;
		assert: allNodes fifth class == XMLElementDeclaration;
		assert: allNodes sixth class == XMLAttributeDeclaration;
		assert: allNodes seventh class == XMLNotationDeclaration;
		assert: allNodes eighth isPI;
		assert: allNodes ninth isComment;
		assert: allNodes ninth string = 'after'.! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testCanonicallyEquals
	self
		assert: (self newNode canonicallyEquals: self newNode);
		assert: (self newNodeWithNodes canonicallyEquals: self newNodeWithNodes);
		assert: (self newNodeWithNodes canonicallyEquals: self newNode)! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testPublicID
	| doctype |

	doctype := self newNode.
	self
		assert: doctype publicID = '';
		assert: (doctype publicID: 'test') == doctype;
		assert: doctype publicID = 'test'.! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testRoot
	| doctype |

	doctype := self newNode.
	self
		assert: doctype root = '';
		assert: (doctype root: 'test') == doctype;
		assert: doctype root = 'test'.! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 8/26/2016 22:12'!
testRootPublicIDSystemID
	| doctype |

	doctype :=
		self nodeClass
			root: 'one'
			publicID: 'two'
			systemID: 'three'.
	self
		assert: doctype class == self nodeClass;
		assert: doctype root = 'one';
		assert: doctype publicID = 'two';
		assert: doctype systemID = 'three'.! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testSystemID
	| doctype |

	doctype := self newNode.
	self
		assert: doctype systemID = '';
		assert: (doctype systemID: 'test') == doctype;
		assert: doctype systemID = 'test'.! !

!XMLDoctypeDeclarationTest methodsFor: 'tests' stamp: 'monty 11/23/2016 17:05'!
testWriteXMLOn
	| doctype elementDeclaration |

	doctype := self newNode.
	self assert: doctype printString = '<!!DOCTYPE >'.
	doctype root: 'one'.
	self assert: doctype printString = '<!!DOCTYPE one>'.
	doctype publicID: 'two'.
	self assert: doctype printString = '<!!DOCTYPE one PUBLIC "two" "">'.
	doctype systemID: 'three'.
	self assert: doctype printString = '<!!DOCTYPE one PUBLIC "two" "three">'.

	elementDeclaration := XMLElementDeclaration element: 'four' contentModel: '(five|six)'.
	doctype addNode: elementDeclaration.
	self assert:
		doctype printString =
			('<!!DOCTYPE one PUBLIC "two" "three" [', elementDeclaration printString, ']>').

	self assert:
		(self nodeClass root: 'one' publicID: '' systemID: 'two') printString =
			'<!!DOCTYPE one SYSTEM "two">'.! !

!XMLNodeWithChildrenTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:01'!
isAbstract
	^ true! !

!XMLNodeWithChildrenTest methodsFor: 'accessing' stamp: 'monty 6/21/2015 02:20'!
copiedClasses
	"an object that isKindOf: any of these should be copied if it's
	reachable from a copied node directly or through another copied object"

	^ #(OrderedCollection Dictionary
		XMLNode XMLNamespaceScope XMLOrderedList
		XMLConfiguration XMLNodeFactory)! !

!XMLNodeWithChildrenTest methodsFor: 'instance creation' stamp: 'monty 8/27/2016 17:20'!
newNodeWithNodes
	^ self newNode
		addNode: (XMLComment string: 'one');
		addNode: (XMLPI target: 'two' data: 'three');
		addNode: (XMLComment string: 'four');
		addNode: (XMLPI target: 'five' data: 'six');
		yourself! !

!XMLNodeWithChildrenTest methodsFor: 'accessing' stamp: 'monty 11/4/2014 19:03'!
nodeClass
	^ XMLNodeWithChildren! !

!XMLNodeWithChildrenTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 21:19'!
nodeListClass
	^ XMLNodeList! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddComment
	| nodeWithNodes comment |

	nodeWithNodes := self newNode.
	comment := nodeWithNodes addComment: 'test'.
	self
		assert: nodeWithNodes nodes size = 1;
		assert: nodeWithNodes firstNode == comment;
		assert: comment isComment;
		assert: comment string = 'test'.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/30/2016 07:34'!
testAddNode
	| node nodesAdded nodeWithNodes |

	node := self newNode.
	nodesAdded := node nodes copyEmpty.
	nodeWithNodes := self newNodeWithNodes.

	"adding nodes from another node should remove them from the previous node"
	nodeWithNodes nodes copy do: [:each |
		nodesAdded addLast: each.
		self
			assert: (node addNode: each) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node;
			deny: (nodeWithNodes nodes includes: each)].
	self deny: nodeWithNodes hasChildren.

	"adding already present nodes should move them in-place"
	node nodes copy do: [:each |
		nodesAdded
			remove: each;
			addLast: each.
		self
			assert: (node addNode: each) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/5/2016 05:49'!
testAddNodeAfter
	| node nodesAdded nodeWithNodes nodeAfter |

	node := self newNode.
	nodesAdded := node nodes copyEmpty.
	nodeWithNodes := self newNodeWithNodes.

	"adding nodes from another node should remove them from the previous node"
	nodeAfter := nodeWithNodes firstNode.
	nodesAdded addLast: nodeAfter.
	node addNode: nodeAfter.
	nodeWithNodes nodes reversed do: [:each |
		nodesAdded
			add: each
			after: nodeAfter.
		self
			assert: (node addNode: each after: nodeAfter) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node;
			deny: (nodeWithNodes nodes includes: each)].
	self deny: nodeWithNodes hasChildren.

	"adding already present nodes should move them in-place"
	nodeAfter := nodesAdded last.
	node nodes allButLast reverseDo: [:each |
		nodesAdded
			remove: each;
			add: each after: nodeAfter.
		self
			assert: (node addNode: each after: nodeAfter) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/31/2016 07:32'!
testAddNodeBefore
	| node nodesAdded nodeWithNodes nodeBefore |

	node := self newNode.
	nodesAdded := node nodes copyEmpty.
	nodeWithNodes := self newNodeWithNodes.

	"adding nodes from another node should remove them from the previous node"
	nodeBefore := nodeWithNodes lastNode.
	nodesAdded addLast: nodeBefore.
	node addNode: nodeBefore.
	nodeWithNodes nodes copy do: [:each |
		nodesAdded
			add: each
			before: nodeBefore.
		self
			assert: (node addNode: each before: nodeBefore) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node;
			deny: (nodeWithNodes nodes includes: each)].
	self deny: nodeWithNodes hasChildren.

	"adding already present nodes should move them in-place"
	nodeBefore := nodesAdded first.
	node nodes allButFirst reverseDo: [:each |
		nodesAdded
			remove: each;
			add: each before: nodeBefore.
		self
			assert: (node addNode: each before: nodeBefore) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/5/2016 05:49'!
testAddNodeFirst
	| node nodesAdded nodeWithNodes |

	node := self newNode.
	nodesAdded := node nodes copyEmpty.
	nodeWithNodes := self newNodeWithNodes.

	"adding nodes from another node should remove them from the previous node"
	nodeWithNodes nodes copy do: [:each |
		nodesAdded addFirst: each.
		self
			assert: (node addNodeFirst: each) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node;
			deny: (nodeWithNodes nodes includes: each)].
	self deny: nodeWithNodes hasChildren.

	"adding already present nodes should move them in-place"
	node nodes reversed do: [:each |
		nodesAdded
			remove: each;
			addFirst: each.
		self
			assert: (node addNodeFirst: each) == each;
			assert: node nodes = nodesAdded;
			assert: each parent == node].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/30/2016 07:26'!
testAddNodes
	| node nodesAdded nodeWithNodes |

	node := self newNode.
	nodeWithNodes := self newNodeWithNodes.

	"adding nodes from another node should remove them from the previous node"
	nodesAdded := nodeWithNodes nodes copy.
	self
		assert: (node addNodes: nodesAdded) = nodesAdded;
		assert: node nodes = nodesAdded;
		assert: (node nodes allSatisfy: [:each | each parent == node]);
		deny: nodeWithNodes hasChildren.

	"adding already present nodes should move them in-place"
	nodesAdded := nodesAdded reversed.
	self
		assert: (node addNodes: nodesAdded) = nodesAdded;
		assert: node nodes = nodesAdded;
		assert: (node nodes allSatisfy: [:each | each parent == node]).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddPITargetData
	| nodeWithNodes pi |

	nodeWithNodes := self newNode.
	pi :=
		nodeWithNodes
			addPITarget: 'target'
			data: 'data'.
	self
		assert: nodeWithNodes nodes size = 1;
		assert: nodeWithNodes firstNode == pi;
		assert: pi isPI;
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:50'!
testAllNodes
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assert: allNodes size = 5;
		assert: allNodes first == nodeWithNodes;
		assert: allNodes second isComment;
		assert: allNodes second string = 'one';
		assert: allNodes third isPI;
		assert: allNodes third target = 'two';
		assert: allNodes third data = 'three';
		assert: allNodes fourth isComment;
		assert: allNodes fourth string = 'four';
		assert: allNodes fifth isPI;
		assert: allNodes fifth target = 'five';
		assert: allNodes fifth data = 'six'.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:57'!
testAllNodesCollect
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assertList: (nodeWithNodes allNodesCollect: [:each | each identityHash])
		collects: (allNodes collect: [:each | each identityHash]).

	allNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node allNodesCollect: [:each | each identityHash])
					collects: (node allNodes collect: [:each | each identityHash])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:01'!
testAllNodesDetect
	| nodeWithNodes allNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	detectedNode := nodeWithNodes allNodesDetect: [:each | each isPI].
	self
		assert: detectedNode notNil;
		assert: detectedNode isPI;
		assert: detectedNode = (allNodes detect: [:each | each isPI]);
		assert: (nodeWithNodes allNodesDetect: [:each | each isElementNamed: 'absent']) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:01'!
testAllNodesDetectIfNone
	| nodeWithNodes allNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	detectedNode :=
		nodeWithNodes
			allNodesDetect: [:each | each isPI]
			ifNone: [self fail].
	self
		assert: detectedNode isPI;
		assert: detectedNode = (allNodes detect: [:each | each isPI] ifNone: [#absent]);
		assert:
			(nodeWithNodes
				allNodesDetect: [:each | each isElementNamed: 'absent']
				ifNone: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:56'!
testAllNodesDo
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		should: [:block | nodeWithNodes allNodesDo: block]
		enumerate: allNodes.

	allNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					should: [:block | node allNodesDo: block]
					enumerate: node allNodes]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 20:57'!
testAllNodesSelect
	| nodeWithNodes allNodes |

	nodeWithNodes := self newNodeWithNodes.
	allNodes := nodeWithNodes allNodes.
	self
		assertList: (nodeWithNodes allNodesSelect: [:each | each isComment])
		selects: (allNodes select: [:each | each isComment]).

	allNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node allNodesSelect: [:each | each isComment])
					selects: (node allNodes select: [:each | each isComment])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 3/8/2015 13:48'!
testAncestorNodes
	| nodeWithNodes ancestorStack |

	super testAncestorNodes.

	nodeWithNodes := self newNodeWithNodes.
	ancestorStack := OrderedCollection new.
	nodeWithNodes allNodesDo: [:each |
		[ancestorStack isEmpty
			or: [ancestorStack last == each parent]]
			whileFalse: [ancestorStack removeLast].
		self assert:
			each ancestorNodes asOrderedCollection =
				ancestorStack reversed.
		ancestorStack addLast: each].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 3/8/2015 13:48'!
testAncestorNodesDo
	| nodeWithNodes |

	super testAncestorNodesDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each ancestorNodesDo: block]
			enumerate: each ancestorNodes].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testCanHaveChildren
	self assert: self newNode canHaveChildren! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self
		assert: (self newNodeWithNodes canonicallyEquals: self newNodeWithNodes);
		deny: (self newNodeWithNodes canonicallyEquals: self newNode).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 7/6/2016 02:31'!
testCopy
	"this traverses the object graph of each node and compares it with
	its copy to make sure nodes and the inst vars that should be copied
	are copied. See #copiedClasses"
	| nodeWithNodes nodeWithNodesCopy unvisitedPairs visitedPairs copiedClasses |

	super testCopy.

	nodeWithNodes := self newNodeWithNodes.
	"initialize the configuration (if it can have one)"
	nodeWithNodes configuration
		ifNotNil: [:config | config nodeFactory: XMLPluggableNodeFactory new].

	nodeWithNodesCopy := nodeWithNodes copy.
	self
		assert: nodeWithNodes printString = nodeWithNodesCopy printString;
		assert: nodeWithNodes allNodes size = nodeWithNodesCopy allNodes size.

	unvisitedPairs := Set new.
	nodeWithNodes allNodes
		with: nodeWithNodesCopy allNodes
		do: [:node :nodeCopy | unvisitedPairs add: node -> nodeCopy].

	visitedPairs := Set new.
	copiedClasses :=
		self copiedClasses collect: [:each |
			XMLClassFinder classNamed: each].
	[unvisitedPairs isEmpty]
		whileFalse: [ | pair originalObject copyObject |
			pair := unvisitedPairs remove: unvisitedPairs anyOne.
			originalObject := pair key.
			copyObject := pair value.

			self deny: originalObject == copyObject.
			visitedPairs add: pair.
			1
				to: (originalObject class instSize min: copyObject class instSize)
				do: [:i | | newPair |
					newPair := (originalObject instVarAt: i) -> (copyObject instVarAt: i).
					((visitedPairs includes: newPair)
						or: [copiedClasses noneSatisfy: [:each | newPair key isKindOf: each]])
						ifFalse: [unvisitedPairs add: newPair]]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:43'!
testDescendantNodes
	| nodeWithNodes descendantNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendantNodes := nodeWithNodes descendantNodes.
	self
		assertList: descendantNodes
		selects: nodeWithNodes allNodes allButFirst.

	descendantNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: node descendantNodes
					selects: node allNodes allButFirst]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:44'!
testDescendantNodesCollect
	| nodeWithNodes descendantNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendantNodes := nodeWithNodes descendantNodes.
	self
		assertList: (nodeWithNodes descendantNodesCollect: [:each | each identityHash])
		collects: (descendantNodes collect: [:each | each identityHash]).

	descendantNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node descendantNodesCollect: [:each | each identityHash])
					collects: (node descendantNodes collect: [:each | each identityHash])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:00'!
testDescendantNodesDetect
	| nodeWithNodes descendantNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	descendantNodes := nodeWithNodes descendantNodes.
	detectedNode := nodeWithNodes descendantNodesDetect: [:each | each isPI].
	self
		assert: detectedNode notNil;
		assert: detectedNode isPI;
		assert: detectedNode = (descendantNodes detect: [:each | each isPI]);
		assert: (nodeWithNodes descendantNodesDetect: [:each | each isElementNamed: 'absent']) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:00'!
testDescendantNodesDetectIfNone
	| nodeWithNodes descendantNodes detectedNode |

	nodeWithNodes := self newNodeWithNodes.
	descendantNodes := nodeWithNodes descendantNodes.
	detectedNode :=
		nodeWithNodes
			descendantNodesDetect: [:each | each isPI]
			ifNone: [self fail].
	self
		assert: detectedNode isPI;
		assert: detectedNode = (descendantNodes detect: [:each | each isPI] ifNone: [#absent]);
		assert:
			(nodeWithNodes
				descendantNodesDetect: [:each | each isElementNamed: 'absent']
				ifNone: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:45'!
testDescendantNodesDo
	| nodeWithNodes descendantNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendantNodes := nodeWithNodes descendantNodes.
	self
		should: [:block | nodeWithNodes descendantNodesDo: block]
		enumerate: descendantNodes.

	descendantNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					should: [:block | node descendantNodesDo: block]
					enumerate: node descendantNodes]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:46'!
testDescendantNodesSelect
	| nodeWithNodes descendantNodes |

	nodeWithNodes := self newNodeWithNodes.
	descendantNodes := nodeWithNodes descendantNodes.
	self
		assertList: (nodeWithNodes descendantNodesSelect: [:each | each isComment])
		selects: (descendantNodes select: [:each | each isComment]).

	descendantNodes do: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: (node descendantNodesSelect: [:each | each isComment])
					selects: (node descendantNodes select: [:each | each isComment])]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 00:16'!
testDocument
	| nodeWithNodes document |

	nodeWithNodes := self newNodeWithNodes.
	document := nodeWithNodes document.
	nodeWithNodes allNodesDo: [:each |
		self assert: each document == document].

	document
		ifNotNil: [ | root |
			root := document root.
			document removeNodes.
			root allNodesDo: [:each |
				self assert: each document isNil]].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 3/26/2015 11:24'!
testDocumentRoot
	| nodeWithNodes |

	super testDocumentRoot.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self assert: each documentRoot == nodeWithNodes].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:37'!
testFirstNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes copy do: [:each |
		self  assert: nodeWithNodes firstNode = each.
		nodeWithNodes removeNode: each].
	self assert: nodeWithNodes firstNode isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 21:09'!
testHasChildren
	super testHasChildren.

	self assert: self newNodeWithNodes hasChildren.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIncludesNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes do: [:each |
		self assert: (nodeWithNodes includesNode: each)].
	self deny: (nodeWithNodes includesNode: self newNode).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:36'!
testLastNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes reversed do: [:each |
		self  assert: nodeWithNodes lastNode = each.
		nodeWithNodes removeNode: each].

	self assert: nodeWithNodes lastNode isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:36'!
testNextNode
	| nodeWithNodes nextNode |

	super testNextNode.
	nodeWithNodes := self newNodeWithNodes.
	nextNode := nil.
	nodeWithNodes nodes reverseDo: [:each |
		self assert: each nextNode = nextNode.
		nextNode := each].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 12:59'!
testNodeAfter
	| nodeWithNodes nodeAfter |

	nodeWithNodes := self newNodeWithNodes.
	nodeAfter := nil.
	nodeWithNodes nodes reverseDo: [:each |
		self assert: (nodeWithNodes nodeAfter: each) = nodeAfter.
		nodeAfter := each].
	self assert: (nodeWithNodes nodeAfter: self newNode) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 12:58'!
testNodeAt
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	self assert: (nodeWithNodes nodeAt: 0) isNil.
	1 to: nodeWithNodes nodes size do: [:i |
		self assert: (nodeWithNodes nodeAt: i) = (nodeWithNodes nodes at: i)].
	self assert: (nodeWithNodes nodeAt: nodeWithNodes nodes size + 1) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 12:58'!
testNodeAtIfAbsent
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	1 to: nodeWithNodes nodes size do: [:i |
		self assert:
			(nodeWithNodes
				nodeAt: i
				ifAbsent: [self fail]) = (nodeWithNodes nodes at: i)].
	self assert:
		(nodeWithNodes
			nodeAt: 0
			ifAbsent: [#absent]) = #absent.
	self assert:
		(nodeWithNodes
			nodeAt: nodeWithNodes nodes size + 1
			ifAbsent: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 12/16/2014 11:21'!
testNodeAtPut
	| nodeWithNodes newNodeClass newNode |

	nodeWithNodes := self newNodeWithNodes.
	newNodeClass := nodeWithNodes firstNode class.
	self
		should: [nodeWithNodes nodeAt: 0 put: newNodeClass new]
		raise: Error.
	1 to: nodeWithNodes nodes size do: [:i |
		newNode := newNodeClass new.
		self
			assert: (nodeWithNodes nodeAt: i put: newNode) == newNode;
			assert: (nodeWithNodes nodeAt: i) == newNode].

	newNode := newNodeClass new.
	self assert:
		(nodeWithNodes
			nodeAt: nodeWithNodes nodes size + 1
			put: newNode) == newNode.
	self assert: (nodeWithNodes nodeAt: nodeWithNodes nodes size) == newNode.
	self
		should: [
			nodeWithNodes
				nodeAt: nodeWithNodes nodes size + 2
				put: newNodeClass new]
		raise: Error.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 12:59'!
testNodeBefore
	| nodeWithNodes nodeBefore |

	nodeWithNodes := self newNodeWithNodes.
	nodeBefore := nil.
	nodeWithNodes nodes do: [:each |
		self assert: (nodeWithNodes nodeBefore: each) = nodeBefore.
		nodeBefore := each].
	self assert: (nodeWithNodes nodeBefore: self newNode) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/24/2014 22:14'!
testNodeListCopying
	| nodeWithNodes nodeListCopy |

	nodeWithNodes := self newNodeWithNodes.
	nodeListCopy := nodeWithNodes nodes copy.
	self
		assert: nodeListCopy = nodeWithNodes nodes;
		deny: nodeListCopy == nodeWithNodes nodes;
		assert: nodeWithNodes nodes observer == nodeWithNodes;
		assert: nodeListCopy observer isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNodes
	self assert: self newNode nodes class == self nodeListClass! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 21:04'!
testNodesCollect
	| node |

	node := self newNodeWithNodes.
	self
		assertList: (node nodesCollect: [:each | each identityHash])
		collects: (node nodes collect: [:each | each identityHash]).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:00'!
testNodesDetect
	| node detectedNode |

	node := self newNodeWithNodes.
	detectedNode := node nodesDetect: [:each | each isComment].
	self
		assert: detectedNode notNil;
		assert: detectedNode = (node nodes detect: [:each | each isComment]);
		assert: (node nodesDetect: [:each | each isElementNamed: 'absent']) isNil.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:57'!
testNodesDetectIfNone
	| node |

	node := self newNodeWithNodes.
	self assert:
		(node
			nodesDetect: [:each | each isComment]
			ifNone: [self fail]) =
				(node nodes detect: [:each | each isComment]).
	self assert:
		(node
			nodesDetect: [:each | each isElementNamed: 'absent']
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/6/2016 01:48'!
testNodesDo
	| node |

	node := self newNode.
	self
		should: [:block | node nodesDo: block]
		enumerate: #().

	node := self newNodeWithNodes.
	self
		should: [:block | node nodesDo: block]
		enumerate: node nodes.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/23/2014 21:04'!
testNodesSelect
	| node |

	node := self newNodeWithNodes.
	self
		assertList: (node nodesSelect: [:each | each hasChildren])
		selects: (node nodes select: [:each | each hasChildren]).! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:35'!
testPreviousNode
	| nodeWithNodes previousNode |

	super testPreviousNode.
	nodeWithNodes := self newNodeWithNodes.
	previousNode := nil.
	nodeWithNodes nodes do: [:each |
		self assert: each previousNode = previousNode.
		previousNode := each].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testRemoveNode
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes copy do: [:each |
		self
			assert: (nodeWithNodes includesNode: each);
			assert: (nodeWithNodes removeNode: each) == each;
			deny: (nodeWithNodes includesNode: each)].
	self deny: nodeWithNodes hasChildren.
	self
		should: [nodeWithNodes removeNode: self newNode]
		raise: Error.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:56'!
testRemoveNodeIfAbsent
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes nodes copy do: [:each |
		self assert: (nodeWithNodes includesNode: each).
		self assert:
			(nodeWithNodes
				removeNode: each
				ifAbsent: [self fail]) == each.
		self deny: (nodeWithNodes includesNode: each)].
	self deny: nodeWithNodes hasChildren.
	self assert:
		(nodeWithNodes
			removeNode: self newNode
			ifAbsent: [#absent]) == #absent.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:20'!
testRemoveNodes
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	self
		assert: nodeWithNodes hasChildren;
		assert: nodeWithNodes removeNodes == nodeWithNodes;
		deny: nodeWithNodes hasChildren.! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 11/19/2014 20:53'!
testRemoveNodesAll
	| nodeWithNodes |

	nodeWithNodes := self newNodeWithNodes.
	1 to: nodeWithNodes nodes size do: [:i | | removed |
		removed := (nodeWithNodes nodes copyFrom: 1 to: i).
		self
			assert: (removed allSatisfy: [:each | nodeWithNodes includesNode: each]);
			assert: (nodeWithNodes removeNodes: removed) == removed;
			deny: (removed anySatisfy: [:each | nodeWithNodes includesNode: each]).
		nodeWithNodes := self newNodeWithNodes].! !

!XMLNodeWithChildrenTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testReplaceNodeWith
	| nodeWithNodes replacements nodes firstIndex secondIndex |

	nodeWithNodes := self newNodeWithNodes.
	replacements := OrderedCollection new.
	nodeWithNodes nodes copy do: [:each |
		self assert:
			(nodeWithNodes
				replaceNode: each
				with: (replacements add: self newNode)) == replacements last].
	self assert: nodeWithNodes nodes asOrderedCollection = replacements.

	nodeWithNodes := self newNodeWithNodes.
	nodes := nodeWithNodes nodes copy.
	nodes do: [:each |
		self assert:
			(nodeWithNodes
				replaceNode: each
				with: each) == each].
	self assert: nodeWithNodes nodes = nodes.

	firstIndex := 1.
	secondIndex := nodes size.
	[firstIndex < secondIndex]
		whileTrue: [
			nodeWithNodes
				replaceNode: (nodes at: firstIndex)
				with: (nodes at: secondIndex).
			firstIndex := firstIndex + 1.
			secondIndex := secondIndex - 1].
	self assert: nodeWithNodes nodes = nodes reversed.

	self
		should: [
			nodeWithNodes
				replaceNode: nodes anyOne copy
				with: self newNode]
		raise: Error.! !

XMLNodeWithChildrenTest subclass: #XMLNodeWithElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLNodeWithElementsTest commentStamp: 'monty 11/4/2014 19:05' prior: 0!
Abstract, do not run.!

XMLNodeWithElementsTest subclass: #XMLDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDocumentTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:08'!
isAbstract
	^ false! !

!XMLDocumentTest methodsFor: 'instance creation' stamp: 'monty 11/14/2015 05:20'!
newNodeWithElements
	^ super newNodeWithElements
		doctypeDeclaration: (XMLDoctypeDeclaration new root: 'zero');
		yourself! !

!XMLDocumentTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:08'!
nodeClass
	^ XMLDocument! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAcceptNodeVisitor
	| visitor document message |

	visitor := XMLRecordingNodeVisitor new.
	document := self newNode.
	self
		assert: (document acceptNodeVisitor: visitor) == document;
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitDocument:;
		assert: message arguments = (Array with: document);
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitNodeWithElements:;
		assert: message arguments = (Array with: document);
		deny: visitor messageRecorder hasMessages.

	super testAcceptNodeVisitor.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 9/5/2016 22:04'!
testDoctypeDeclaration
	| document doctypeDeclaration newDocument |

	document := self newNode.
	self assert: document doctypeDeclaration isNil.

	doctypeDeclaration := XMLDoctypeDeclaration new.
	self
		assert: (document doctypeDeclaration: doctypeDeclaration) == document;
		assert: document doctypeDeclaration == doctypeDeclaration;
		assert: doctypeDeclaration parent == document.

	"adding a doctypeDeclaration from another doc should remove it from the
	other doc"
	newDocument := self newNode.
	self
		assert:
			(newDocument doctypeDeclaration: document doctypeDeclaration) ==
				newDocument;
		assert: newDocument doctypeDeclaration == doctypeDeclaration;
		assert: newDocument doctypeDeclaration parent == newDocument;
		assert: document doctypeDeclaration isNil.

	newDocument doctypeDeclaration: nil.
	self
		assert: newDocument doctypeDeclaration isNil;
		assert: doctypeDeclaration parent isNil.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:29'!
testDoctypeDefinition
	| document doctypeDefinition |

	document := self newNode.
	self assert: document doctypeDefinition isNil.

	doctypeDefinition := DTDDoctypeDefinition new.
	self
		assert: (document doctypeDefinition: doctypeDefinition) == document;
		assert: document doctypeDefinition == doctypeDefinition.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testDocument
	| document |

	super testDocument.

	document := self newNode.
	self assert: document document == document.

	document := self newNodeWithElements.
	self assert: document document == document.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:26'!
testEncoding
	| document |

	document := self newNode.
	self
		assert: document encoding = '';
		assert: (document encoding: 'UTF-8') == document;
		assert: document encoding = 'UTF-8'.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:28'!
testHasDoctypeDeclaration
	| document |

	document := self newNode.
	self deny: document hasDoctypeDeclaration.

	document doctypeDeclaration: XMLDoctypeDeclaration new.	
	self assert: document hasDoctypeDeclaration.

	document doctypeDeclaration: nil.
	self deny: document hasDoctypeDeclaration.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:29'!
testHasDoctypeDefinition
	| document |

	document := self newNode.
	self deny: document hasDoctypeDefinition.

	document doctypeDefinition: DTDDoctypeDefinition new.
	self assert: document hasDoctypeDefinition.

	document doctypeDefinition: nil.
	self deny: document hasDoctypeDefinition.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:29'!
testHasEncoding
	| document |

	document := self newNode.
	self deny: document hasEncoding.

	document encoding: 'UTF-8'.
	self assert: document hasEncoding.

	document encoding: ''.
	self deny: document hasEncoding.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:30'!
testHasRoot
	| nodeWithElements |

	self deny: self newNode hasRoot.
	nodeWithElements := self newNodeWithElements.

	self assert: nodeWithElements hasRoot.

	nodeWithElements removeNode: nodeWithElements root.
	self deny: nodeWithElements hasRoot.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsDocument
	self assert: self newNode isDocument! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:30'!
testIsStandalone
	| document |

	document := self newNode.
	self
		deny: document isStandalone;
		assert: (document isStandalone: true) == document;
		assert: document isStandalone.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/19/2017 01:12'!
testRoot
	| document newRoot |

	newRoot := self newElementWithAttributes.
	document := self nodeClass root: newRoot.
	self
		assert: document class == self nodeClass;
		assert: document root == newRoot.
	 
	self assert: self newNode root isNil.

	document := self newNodeWithElements.
	self
		assert: document root == document nodes second;
		assert: document nodes size = 3;
		assert: document nodes first isComment;
		assert: (document nodes second isElementNamed: 'zero');
		assert: document nodes third isComment.

	newRoot := self elementClass named: 'new-root'.
	self
		assert: (document root: newRoot) == document;
		assert: document root == newRoot;
		assert: document nodes size = 3;
		assert: document nodes first isComment;
		assert: document nodes second == newRoot;
		assert: document nodes third isComment.

	document removeNodes.
	self assert: document root isNil.

	self
		should: [document root: 'test' asXMLStringNode]
		raise: XMLDOMException.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 7/27/2016 07:19'!
testValidate
	| xml document |

	super testValidate.

	xml := '
		<!!DOCTYPE one [
			<!!ELEMENT one (two+, three)>
			<!!ATTLIST one idref IDREF #REQUIRED>
			<!!ELEMENT two (#PCDATA)*>
			<!!ATTLIST two id ID #REQUIRED>
			<!!ELEMENT three EMPTY>]>
		<!!--comment-->
		<one idref="a">
			<two id="a">three</two>
			<two id="b"><!!--comment--></two>
			<three></three>
		</one>
		<?target data?>'.

	document :=
		(XMLDOMParser on: xml)
			preservesCommentNodes: true;
			parseDocument.
	self
		shouldnt: [document validate]
		raise: XMLValidationException.
	self assert:
		(document canonicallyEquals: 
			((XMLDOMParser on: xml)
				preservesCommentNodes: true;
				parseDocument)).

	document
		allElementsNamed: 'two'
		do: [:each | each attributeAt: 'id' put: 'a'].
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	document root name: 'zero'.
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	document root attributeAt: 'idref' put: 'undeclared'.
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	document root addElementNamed: 'four'.
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	(document root elementAt: 'three') addNode:
		(XMLComment string: 'comment').
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	(document root elementAt: 'three') addNode:
		(XMLPI
			target: 'target'
			data: 'data').
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	(document root elementAt: 'three') addNode: (XMLCData string: 'five').
	self
		should: [document validate]
		raise: XMLValidationException.

	document := XMLDOMParser parse: xml.
	(document root elementAt: 'three') addElementNamed: 'four'.
	self
		should: [document validate]
		raise: XMLValidationException.

	(document := XMLDOMParser parse: xml) doctypeDefinition: nil.
	document root
		name: 'zero';
		attributeAt: 'idref' put: 'undeclared';
		addElementNamed: 'four';
		allElementsNamed: 'two' do: [:each | each attributeAt: 'id' put: 'same'].
	(document root elementAt: 'three')
		addNode: (XMLComment string: 'comment');
		addNode:
			(XMLPI
				target: 'target'
				data: 'data');
		addNode: (XMLCData string: 'five');
		addElementNamed: 'four'.
	self
		shouldnt: [document validate]
		raise: XMLValidationException.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 4/7/2015 00:10'!
testValidateNoSubset
	| xml document |

	xml := '<!!DOCTYPE one>
		<one idref="a">
			<two id="a">three</two><two id="b"><!!--comment--></two>
		</one>'.

	document :=
		(XMLDOMParser on: xml)
			preservesCommentNodes: true;
			parseDocument.
	self
		shouldnt: [document validate]
		raise: XMLValidationException.
	self assert:
		(document canonicallyEquals: 
			((XMLDOMParser on: xml)
				preservesCommentNodes: true;
				parseDocument)).

	document root name: 'five'.
	self
		should: [document validate]
		raise: XMLValidationException.

	document doctypeDefinition: nil.
	self
		shouldnt: [document validate]
		raise: XMLValidationException.! !

!XMLDocumentTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:31'!
testVersion
	| document |

	document := self newNode.
	self
		assert: document version isNil;
		assert: (document version: 1.0) == document;
		assert: document version = 1.0.! !

XMLDocumentTest subclass: #XMLDocumentWithCachingNodeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLDocumentWithCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 9/1/2016 21:26'!
elementClass
	^ XMLElementWithCachingNodeList! !

!XMLDocumentWithCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 8/31/2016 06:49'!
nodeClass
	^ XMLDocumentWithCachingNodeList! !

!XMLDocumentWithCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 8/31/2016 06:48'!
nodeListClass
	^ XMLCachingNodeList! !

XMLNodeWithElementsTest subclass: #XMLElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementTest class methodsFor: 'testing' stamp: 'monty 11/2/2014 11:09'!
isAbstract
	^ false! !

!XMLElementTest methodsFor: 'instance creation' stamp: 'monty 11/14/2015 05:20'!
newNodeWithElements
	^ super newNodeWithElements
		name: 'root';
		yourself! !

!XMLElementTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:09'!
nodeClass
	^ XMLElement! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAcceptNodeVisitor
	| visitor element message |

	visitor := XMLRecordingNodeVisitor new.
	element := self newNode.
	self
		assert: (element acceptNodeVisitor: visitor) == element;
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitElement:;
		assert: message arguments = (Array with: element);
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitNodeWithElements:;
		assert: message arguments = (Array with: element);
		deny: visitor messageRecorder hasMessages.

	super testAcceptNodeVisitor.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddElementNamed
	| element |

	super testAddElementNamed.

	element := self newNode.
	element
		declarePrefix: 'prefix'
		uri: 'prefixNS'.
	self
		shouldnt: [element addElementNamed: 'prefix:test']
		raise: XMLNamespaceException.
	self
		assert: element nodes size = 1;
		assert: element firstNode isElement;
		assert: element firstNode name = 'prefix:test';
		assert: element firstNode namespaceURI = 'prefixNS'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddElementNamedAttributes
	| element |

	super testAddElementNamedAttributes.

	element := self newNode.
	element
		declarePrefix: 'prefix'
		uri: 'prefixNS'.
	self
		shouldnt: [
			element
				addElementNamed: 'prefix:test'
				attributes: self attributeAssociations]
		raise: XMLNamespaceException.
	self
		assert: element nodes size = 1;
		assert: element firstNode isElement;
		assert: element firstNode name = 'prefix:test';
		assert: element firstNode namespaceURI = 'prefixNS';
		assertElement: element firstNode hasAttributes: self attributes.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:23'!
testAttributeAssociations
	| element |

	element := self newElementWithAttributes.
	self
		assertList: element attributeAssociations
		collects: (element attributeNodes collect: [:each | each name -> each value]).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:36'!
testAttributeAt
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert: (element attributeAt: each name) = each value].
	self assert: (element attributeAt: 'absent') = ''.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:40'!
testAttributeAtIfAbsent
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert:
			(element
				attributeAt: each name
				ifAbsent: [self fail]) = each value].
	self assert:
		(element
			attributeAt: 'absent'
			ifAbsent: [#absent]) = #absent.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:40'!
testAttributeAtIfAbsentPut
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert:
			(element
				attributeAt: each name
				ifAbsentPut: [self fail]) = each value].
	self assert:
		(element
			attributeAt: 'newName'
			ifAbsentPut: ['newValue']) = 'newValue'.
	self assert: (element attributeAt: 'newName') = 'newValue'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:13'!
testAttributeAtPut
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each | | newValue |
		newValue := 'new', each value.
		self
			assert: (element attributeAt: each name put: newValue) = newValue;
			assert: (element attributeAt: each name) = newValue].
	self
		assert: (element attributeAt: 'newName' put: 'newValue') = 'newValue';
		assert: (element attributeAt: 'newName') = 'newValue'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/2/2016 05:49'!
testAttributeListCopying
	| element attributeListCopy |

	element := self newElementWithAttributes.
	attributeListCopy := element attributeNodes copy.
	self
		assert: attributeListCopy = element attributeNodes;
		deny: attributeListCopy == element attributeNodes;
		assert: element attributeNodes observer == element;
		assert: attributeListCopy observer isNil.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:13'!
testAttributeNames
	| element |

	element := self newElementWithAttributes.
	self
		assertList: element attributeNames
		collects: (element attributeNodes collect: [:each | each name])! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:31'!
testAttributeNamesAndValuesDo
	| element |

	element := self newNode.
	self
		should: [:twoArgumentBlock |
			element attributeNamesAndValuesDo: twoArgumentBlock]
		enumerate: #()
		and: #().

	element := self newElementWithAttributes.
	self
		should: [:twoArgumentBlock |
			element attributeNamesAndValuesDo: twoArgumentBlock]
		enumerate: self attributeNames
		and: self attributeValues.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:20'!
testAttributeNamesDo
	| element |

	element := self newNode.
	self
		should: [:block | element attributeNamesDo: block]
		enumerate: #().

	element := self newElementWithAttributes.
	self
		should: [:block | element attributeNamesDo: block]
		enumerate: element attributeNames.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 4/18/2016 11:46'!
testAttributeNodeAt
	| element |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert: (element attributeNodeAt: each name) = each].
	self assert:
		(element attributeNodeAt: 'two') = element attributeNodes second.
	self assert:
		(element attributeNodeAt: 'absent') isNil.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:45'!
testAttributeNodeAtIfAbsent
	| element attributeLocalNames |

	element := self newElementWithAttributes.
	element attributeNodes do: [:each |
		self assert:
			(element
				attributeNodeAt: each name
				ifAbsent: [self fail]) = each].
	attributeLocalNames :=
		(element attributeNodes collect: [:each | each localName]) asSet.
	attributeLocalNames do: [:localName |
		self assert:
			(element
				attributeNodeAt: localName
				ifAbsent: [self fail]) =
					(element attributeNodes detect: [:each | each localName = localName])].
	self assert:
		(element
			attributeNodeAt: 'absent'
			ifAbsent: [#absent]) = #absent.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 4/18/2016 11:44'!
testAttributeNodeAtNamespaceURI
	| element |

	element := self newElementWithAttributes.
	self assert:
		(element attributeNodeAt: 'prefix:two' namespaceURI: 'prefixNS') =
			(element attributeNodes third).
	self assert:
		(element attributeNodeAt: 'two' namespaceURI: 'prefixNS') =
			(element attributeNodes third).
	self assert:
		(element attributeNodeAt: 'prefix:two' namespaceURI: 'absent') isNil.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:45'!
testAttributeNodeAtNamespaceURIIfAbsent
	| element |

	element := self newElementWithAttributes.
	self assert:
		(element
			attributeNodeAt: 'prefix:two'
			namespaceURI: 'prefixNS'
			ifAbsent: [self fail]) =
				element attributeNodes third.
	self assert:
		(element
			attributeNodeAt: 'two'
			namespaceURI: 'prefixNS'
			ifAbsent: [self fail]) =
				element attributeNodes third.
	self assert:
		(element
			attributeNodeAt: 'prefix:two'
			namespaceURI: 'absent'
			ifAbsent: [#absent]) = #absent.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 05:47'!
testAttributeNodes
	| element attributeNodes |

	element := self newElementWithAttributes.
	attributeNodes := element attributeNodes.
	self assert: attributeNodes class == self attributeListClass.
	self assert:
		(attributeNodes collect: [:each | each name -> each value]) asArray
			= self attributeAssociations asArray.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 22:12'!
testAttributeNodesAdding
	| element attributesAdded elementWithAttributes |

	element := self newElement.
	attributesAdded := element attributeNodes copyEmpty.
	elementWithAttributes := self newElementWithAttributes.

	"adding from another element should remove them from the previous element"
	elementWithAttributes attributeNodes copy do: [:each |
		attributesAdded addLast: each.
		element attributeNodes addLast: each.
		self
			assert: each element == element;
			assert: each parent == element;
			assert: element attributeNodes = attributesAdded;
			deny: (elementWithAttributes attributeNodes includes: each)].

	"adding already present nodes should move them in-place"
	element attributeNodes reversed do: [:each |
		attributesAdded
			remove: each;
			addLast: each.
		element attributeNodes addLast: each.
		self
			assert: each element == element;
			assert: each parent == element;
			assert: element attributeNodes = attributesAdded]! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/6/2016 01:48'!
testAttributeNodesDo
	| element |

	element := self newNode.
	self
		should: [:block | element attributeNodesDo: block]
		enumerate: #().

	element := self newElementWithAttributes.
	self
		should: [:block | element attributeNodesDo: block]
		enumerate: element attributeNodes.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:47'!
testAttributePrefixAliasing
	| element |

	(element := self newElementWithAttributes)
		declarePrefix: 'alias' uri: 'prefixNS'.
	self
		should: [
			element attributeNodes addLast:
				(self attributeClass named: 'alias:four')]
		raise: XMLNamespaceException.

	(element := self newElementWithAttributes)
		declarePrefix: 'alias' uri: 'prefixNS'.
	self
		should: [(element attributeNodeAt: 'two') name: 'alias:two']
		raise: XMLNamespaceException.

	(element := self newElementWithAttributes)
		declarePrefix: 'alias' uri: 'prefixNS';
		usesNamespaces: false.
	self
		shouldnt: [
			element attributeNodes addLast:
				(self attributeClass named: 'alias:four').
			(element attributeNodeAt: 'two') name: 'alias:two']
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:47'!
testAttributePrefixUndeclared
	| element |

	element := self newElementWithAttributes.
	self
		should: [
			element attributeNodes add:
				(self attributeClass named: 'undeclared:newName')]
		raise: XMLNamespaceException.

	element := self newElementWithAttributes.
	self
		should: [
			(element attributeNodeAt: 'one') name: 'undeclared:one']
		raise: XMLNamespaceException.

	element := self newElementWithAttributes.
	self
		shouldnt: [
			element usesNamespaces: false.
			element attributeNodes add:
				(self attributeClass named: 'undeclared:newName').
			(element attributeNodeAt: 'one') name: 'undeclared:one']
		raise: XMLNamespaceException.
! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2016 00:21'!
testAttributeRenaming
	| elementWithAttributes attributeNodes attributeNode oldSize oldNames oldName |

	elementWithAttributes := self newElementWithAttributes.
	attributeNodes := elementWithAttributes attributeNodes.

	attributeNode := attributeNodes first.
	oldSize := attributeNodes size.
	oldNames := elementWithAttributes attributeNames.
	oldName := attributeNode name.
	attributeNode name: 'newName'.
	self
		assert: attributeNodes size = oldSize;
		assert: attributeNodes first == attributeNode;
		assert: elementWithAttributes attributeNames = (oldNames allButFirst copyWithFirst: 'newName');
		deny: (elementWithAttributes includesAttribute: oldName);
		assert: (elementWithAttributes attributeNodeAt: 'newName') == attributeNode.

	oldNames := elementWithAttributes attributeNames.
	oldName := attributeNode name.
	attributeNode name: oldNames last.
	self
		assert: attributeNodes size = (oldSize - 1);
		assert: attributeNodes first == attributeNode;
		assert:
			elementWithAttributes attributeNames =
				((oldNames copyFrom: 2 to: oldNames size - 1) copyWithFirst: oldNames last);
		deny: (elementWithAttributes includesAttribute: oldName);
		assert: (elementWithAttributes attributeNodeAt: attributeNode name) == attributeNode.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:19'!
testAttributeSorting
	| element |

	element :=
		self nodeClass
			name: 'sorted'
			attributes: (Array with: 'c' -> '3' with: 'b' -> '2' with: 'a' -> '1').
	self assert:
		(element attributeNodes sorted
			collect: [:each | each name]) asArray = #('a' 'b' 'c').
	self assert:
		((element attributeNodes sorted: [:a :b | a name <= b name])
			collect: [:each | each name]) asArray = #('a' 'b' 'c').
	"sorted/sorted: should sort copies"
	self assert: element attributeNames asArray = #('c' 'b' 'a').

	element attributeNodes sort.
	self assert: element attributeNames asArray = #('a' 'b' 'c').
	element attributeNodes sort: [:a :b | a name > b name].
	self assert: element attributeNames asArray = #('c' 'b' 'a').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 18:59'!
testAttributes
	| element attributeDictionary |

	element := self newElementWithAttributes.
	attributeDictionary := element attributes.
	self
		assert: attributeDictionary class == self attributesClass;
		assert: attributeDictionary size = element attributeNodes size.
	self assert:
		(element attributeNodes allSatisfy: [:each |
			(attributeDictionary at: each name) = each value]).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:19'!
testCanonicalPrinting
	| element |

	element :=
		self nodeClass
			name: 'test'
			namespaces: (Array with: 'b' -> 'ns2' with: 'a' -> 'ns1' with: '' -> 'default')
			attributes: (Array with: 'c' -> '3' with: 'b' -> '2' with: 'a' -> '1').

	self assert:
		element printString =
			'<test xmlns:b="ns2" xmlns:a="ns1" xmlns="default" c="3" b="2" a="1" />'.
	self assert:
		element canonicallyPrinted =
			'<test xmlns="default" xmlns:a="ns1" xmlns:b="ns2" a="1" b="2" c="3"></test>'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 00:30'!
testDeclareNamespaces
	| element |

	element := self newNode.
	self assert: (element declareNamespaces: self namespaces) == element.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	element := self newNode.
	self assert: (element declareNamespaces: self namespaces associations) == element.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	(element := self newNode) usesNamespaces: false.
	self
		assert: (element declareNamespaces: #()) == element;
		assert: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 00:29'!
testDeclarePrefixURI
	| element elementsWithDeclaredPrefix |

	element := self newNodeWithElements.
	self assert:
		(element
			declarePrefix: 'newPrefix'
			uri: 'prefixNS') == element.
	element allElementsDo: [:each |
		self assert:
			(each
				isDeclaredPrefix: 'newPrefix'
				uri: 'prefixNS')].
	self assert:
		(element
			declarePrefix: 'newPrefix'
			uri: 'newPrefixNS') == element.
	element allElementsDo: [:each |
		self assert:
			(each
				isDeclaredPrefix: 'newPrefix'
				uri: 'newPrefixNS')].

	elementsWithDeclaredPrefix :=
		element allElementsSelect: [:each | each prefix = 'prefix'].
	self assert:
		(element
			declarePrefix: 'prefix'
			uri: 'newPrefixNS') == element.
	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each)
			ifTrue: [
				self
					assert: (each isDeclaredPrefix: 'prefix');
					deny:
						(each
							isDeclaredPrefix: 'prefix'
							uri: 'newPrefixNS')]
				ifFalse: [
					self assert:
						(each
							isDeclaredPrefix: 'prefix'
							uri: 'newPrefixNS')]].

	self
		should: [element declarePrefix: 'nonDefault' uri: '']
		raise: XMLNamespaceException.
	"cannot rebind the xml prefix to a new NS"
	self 
		should: [element declarePrefix: 'xml' uri: 'newNS']
		raise: XMLNamespaceException.
	"cannot rebind the xmlns prefix, even to the same NS"
	self
		should: [element declarePrefix: 'xmlns' uri: XMLNamespaceScope xmlnsNamespaceURI]
		raise: XMLNamespaceException.

	(element := self newNode) usesNamespaces: false.
	self assert:
		(element
			declarePrefix: 'prefix'
			uri: 'prefixNS') == element.
	self assert: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 01:06'!
testDeclaredPrefixes
	| element prefixes |

	element := self newNode.
	prefixes := OrderedCollection new.
	self namespaces keysAndValuesDo: [:prefix :uri |
		element
			declarePrefix: prefix
			uri: uri.
		prefixes addLast: prefix.
		self assert: element declaredPrefixes = prefixes asArray].

	(element := self newNode) usesNamespaces: false.
	self
		assert: element declaredPrefixes isEmpty;
		deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 00:35'!
testDeclaresDefaultNamespace
	| element |

	element := self newNodeWithElements.
	self deny: element declaresDefaultNamespace.

	element defaultNamespace: 'defaultNS'.
	self assert: element declaresDefaultNamespace.
	element elementsDo: [:each |
		self deny: each declaresDefaultNamespace].

	element elementsDo: [:each |
		each defaultNamespace: 'newDefaultNS'.
		self assert: each declaresDefaultNamespace].

	self assert: element declaresDefaultNamespace.	
	element undeclarePrefix: ''.
	self deny: element declaresDefaultNamespace.
	element elementsDo: [:each |
		self assert: each declaresDefaultNamespace].

	(element := self newNode) usesNamespaces: false.
	self
		deny: element declaresDefaultNamespace;
		deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 00:39'!
testDeclaresPrefixURI
	| element |

	element := self newNodeWithElements.
	self deny: element declaresDefaultNamespace.

	element
		declarePrefix: 'prefix'
		uri: 'prefixNS'.
	self assert:
		(element
			declaresPrefix: 'prefix'
			uri: 'prefixNS').
	element elementsDo: [:each |
		self deny:
			(each
				declaresPrefix: 'prefix'
				uri: 'prefixNS')].

	element elementsDo: [:each |
		each
			declarePrefix: 'prefix'
			uri: 'newPrefixNS'.
		self assert:
			(each
				declaresPrefix: 'prefix'
				uri: 'newPrefixNS')].

	self assert:
		(element
			declaresPrefix: 'prefix'
			uri: 'prefixNS').
	element undeclarePrefix: 'prefix'.
	self deny:
		(element
			declaresPrefix: 'prefix'
			uri: 'prefixNS').
	element elementsDo: [:each |
		self assert:
			(each
				declaresPrefix: 'prefix'
				uri: 'newPrefixNS')].

	(element := self newNode) usesNamespaces: false.
	self deny:
		(element
			declaresPrefix: 'prefix'
			uri: 'prefixNS').
	self deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2017 07:22'!
testDefaultNamespace
	| element elementsWithDefaultNamespace |

	element := self newNodeWithElements.
	elementsWithDefaultNamespace :=
		element allElementsSelect: [:each |
			each defaultNamespace notEmpty].

	self assert: (element defaultNamespace: 'newDefaultNS') == element.
	element allElementsDo: [:each |
		(elementsWithDefaultNamespace includes: each)
			ifTrue: [self deny: (each defaultNamespace = 'newDefaultNS')]
			ifFalse: [self assert: (each defaultNamespace = 'newDefaultNS')]].

	self assert: (element defaultNamespace: '') == element.
	element allElementsDo: [:each |
		(elementsWithDefaultNamespace includes: each)
			ifTrue: [self deny: each defaultNamespace = '']
			ifFalse: [self assert: each defaultNamespace = '']].

	(element := self newNode) usesNamespaces: false.
	self
		assert: element defaultNamespace = '';
		deny: element usesNamespaces;
		assert: (element defaultNamespace: '') == element;
		assert: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:19'!
testElementSorting
	| element |

	(element := self nodeClass named: 'sorted')
		addElementNamed: 'c';
		addElementNamed: 'b';
		addElementNamed: 'a'.

	self assert: (element nodes sorted collect: [:each | each name]) asArray = #('a' 'b' 'c').
	self assert:
		((element nodes sorted: [:a :b | a name <= b name])
			collect: [:each | each name]) asArray = #('a' 'b' 'c').

	self assert: (element nodesCollect: [:each | each name]) asArray = #('c' 'b' 'a').
	element nodes sort.
	self assert: (element nodesCollect: [:each | each name]) asArray = #('a' 'b' 'c').
	element nodes sort: [:a :b | a name > b name].
	self assert: (element nodesCollect: [:each | each name]) asArray = #('c' 'b' 'a').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 12/30/2014 02:40'!
testExpandedName
	| element |

	element := self nodeClass named: 'test'.
	self assert: (element expandedName = 'test').

	element defaultNamespace: 'defaultNS'.
	self assert: (element expandedName = 'Q{defaultNS}test').

	element name: 'prefix:test' namespaceURI: 'prefixNS'.
	self assert: (element expandedName = 'Q{prefixNS}test').

	element
		defaultNamespace: '';
		name: 'test'.
	self assert: (element expandedName = 'test').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasAttributes
	self
		deny: self newNode hasAttributes;
		assert: self newElementWithAttributes hasAttributes;
		deny: self newElementWithAttributes removeAttributes hasAttributes! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/20/2017 19:23'!
testHasID
	| element document |

	element := self newElementWithAttributes.
	self deny: (element hasID: 'test').

	element
		attributeAt: 'xml:id'
		put: 'test'.
	self assert: (element hasID: 'test').

	document := element newDocument.
	document root: element.
	document doctypeDefinition: DTDDoctypeDefinition new.
	document doctypeDefinition
		addValidatorForAttributeIn: element name
		named: 'xml:id'
		type: 'CDATA'
		defaultPragma: 'REQUIRED'
		defaultValue: ''.
	self deny: (element hasID: 'test').

	element
		attributeAt: 'id'
		put: 'test'.
	self deny: (element hasID: 'test').

	document doctypeDefinition
		addValidatorForAttributeIn: element name
		named: 'id'
		type: 'ID'
		defaultPragma: 'REQUIRED'
		defaultValue: ''.
	self assert: (element hasID: 'test').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:42'!
testHasNamespaceURI
	| element |

	element := self nodeClass named: 'test'.
	self deny: element hasNamespaceURI.

	element defaultNamespace: 'defaultNS'.
	self assert: element hasNamespaceURI.

	element defaultNamespace: ''.
	self deny: element hasNamespaceURI.

	element name: 'prefix:test' namespaceURI: 'prefixNS'.
	self assert: element hasNamespaceURI.

	element name: 'test'.
	self deny: element hasNamespaceURI.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasNamespaces
	| element |

	element := self newNode.
	self deny: element hasNamespaces.

	element defaultNamespace: 'defaultNS'.
	self assert: element hasNamespaces.

	element undeclarePrefix: ''.
	self deny: element hasNamespaces.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	self assert: element hasNamespaces.

	element undeclarePrefix: 'prefix'.
	self deny: element hasNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasPrefix
	| element |

	element := self newNode.
	self deny: element hasPrefix.

	element name: 'one'.
	self deny: element hasPrefix.

	element declarePrefix: 'prefix' uri: 'prefixNS'.
	element name: 'prefix:two'.
	self assert: element hasPrefix.

	element name: 'three'.
	self deny: element hasPrefix.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:31'!
testIncludesAttribute
	| element |

	element := self newElementWithAttributes.
	element attributeNames do: [:each |
		self assert: (element includesAttribute: each).
		element removeAttribute: each.
		self deny: (element includesAttribute: each)].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 01:10'!
testIsDeclaredPrefix
	| element elementsWithDeclaredPrefix |

	element := self newNodeWithElements.
	elementsWithDeclaredPrefix :=
		element allElementsSelect: [:each |
			each isDeclaredPrefix: 'prefix'].

	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifFalse: [self deny: (each isDeclaredPrefix: 'prefix')]].

	element declarePrefix: 'prefix' uri: 'newPrefixNS'.
	element allElementsDo: [:each | self assert: (each isDeclaredPrefix: 'prefix')].

	element undeclarePrefix: 'prefix'.
	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifTrue: [self assert: (each isDeclaredPrefix: 'prefix')]
			ifFalse: [self deny: (each isDeclaredPrefix: 'prefix')]].

	(element := self newNode) usesNamespaces: false.
	self
		deny: (element isDeclaredPrefix: 'prefix');
		deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 01:10'!
testIsDeclaredPrefixURI
	| element elementsWithDeclaredPrefix |

	element := self newNodeWithElements.
	elementsWithDeclaredPrefix :=
		element allElementsSelect: [:each |
			each isDeclaredPrefix: 'prefix'].

	element allElementsDo: [:each |
		self deny:
			(each
				isDeclaredPrefix: 'prefix'
				uri: 'newPrefixNS')].

	element
		declarePrefix: 'prefix'
		uri: 'newPrefixNS'.
	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifTrue: [
				self assert: (each isDeclaredPrefix: 'prefix').
				self deny:
					(each
						isDeclaredPrefix: 'prefix'
						uri: 'newPrefixNS')]
			ifFalse: [
				self assert:
					(each
						isDeclaredPrefix: 'prefix'
						uri: 'newPrefixNS')]].

	element undeclarePrefix: 'prefix'.
	element allElementsDo: [:each |
		(elementsWithDeclaredPrefix includes: each )
			ifTrue: [self assert: (each isDeclaredPrefix: 'prefix')]
			ifFalse: [self deny: (each isDeclaredPrefix: 'prefix')]].

	(element := self newNode) usesNamespaces: false.
	self deny:
		(element
			isDeclaredPrefix: 'prefix'
			uri: 'prefixNS').
	self deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsElement
	self assert: self newNode isElement! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 19:39'!
testIsElementNamed
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isElementNamed: 'one');
		deny: (element isElementNamed: 'two').
	
	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isElementNamed: 'one:two');
		assert: (element isElementNamed: 'two');
		deny: (element isElementNamed: 'one').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 19:39'!
testIsElementNamedAny
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isElementNamedAny: #('two' 'one' 'three'));
		deny: (element isElementNamedAny: #('two' 'three')).

	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isElementNamedAny: #('one' 'one:two' 'three'));
		assert: (element isElementNamedAny: #('one' 'two' 'three'));
		deny: (element isElementNamedAny: #('one' 'three')).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 12/23/2014 16:19'!
testIsInLanguage
	| nodeWithElements |

	super testIsInLanguage.
	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each |
		self
			deny: (each isInLanguage: 'en-us');
			deny: (each isInLanguage: 'EN-US');
			deny: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'de-de');
			deny: (each isInLanguage: 'DE-DE');
			deny: (each isInLanguage: 'De')].

	nodeWithElements attributeAt: 'xml:lang' put: 'En-Us'.
	nodeWithElements allNodesDo: [:each |
		self
			assert: (each isInLanguage: 'en-us');
			assert: (each isInLanguage: 'EN-US');
			assert: (each isInLanguage: 'En');
			deny: (each isInLanguage: 'de-de');
			deny: (each isInLanguage: 'DE-DE');
			deny: (each isInLanguage: 'De')].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 19:39'!
testIsNamed
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isNamed: 'one');
		deny: (element isNamed: 'two').

	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isNamed: 'one:two');
		assert: (element isNamed: 'two');
		deny: (element isNamed: 'one').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 4/14/2016 12:19'!
testIsNamedAny
	| element |

	element := self nodeClass named: 'one'.
	self
		assert: (element isNamedAny: #('two' 'one' 'three') asSet);
		deny: (element isNamedAny: #('two' 'three') asSet).

	element name: 'one:two' namespaceURI: 'testNS'.
	self
		assert: (element isNamedAny: #('one' 'one:two' 'three'));
		assert: (element isNamedAny: #('one' 'two' 'three'));
		deny: (element isNamedAny: #('one' 'three')).! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 19:40'!
testIsRoot
	| element |

	element := self newNodeWithElements.
	self assert: element allElements first isRoot.

	element descendantElementsDo: [:each |
		self deny: each isRoot].

	(element removeNodes: element elements copy) do: [:each |
		self assert: each isRoot].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:26'!
testLocalName
	| element |

	element := self newNode.
	self
		assert: element localName = '';
		assert: (element name: 'one') == element;
		assert: element localName = 'one';
		assert: (element name: 'two') == element;
		assert: element localName = 'two'.

	element
		declarePrefix: 'prefix'
		uri: 'prefixNS'.
	self
		assert: (element name: 'prefix:three') == element;
		assert: element localName = 'three';
		assert: (element name: 'four') == element;
		assert: element localName = 'four'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:26'!
testName
	| element |

	"XMLElement class>>#name: is not tested here because it is soft-deprecated"

	element := self newNode.
	self
		assert: element name = '';
		assert: (element name: 'one') == element;
		assert: element name = 'one';
		assert: (element name: 'two') == element;
		assert: element name = 'two'.
	self
		should: [element name: 'unmapped:two']
		raise: XMLNamespaceException.

	element usesNamespaces: false.
	self
		shouldnt: [element name: 'unmapped:three']
		raise: XMLNamespaceException.
	self assert: element name = 'unmapped:three'.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 03:10'!
testNameAttributes
	| attributes unprefixedAttributes element |

	attributes := self attributes.
	unprefixedAttributes := self unprefixedAttributes.
	element :=
		self nodeClass
			name: 'one'
			attributes: self unprefixedAttributeAssociations.
	self
		assert: element class == self nodeClass;
		assert: element name = 'one';
		assertElement: element hasAttributes: unprefixedAttributes.

	"attributes: should accept any collection of associations"
	element :=
		self nodeClass
			name: 'two'
			attributes: unprefixedAttributes associations.
	self
		assert: element name = 'two';
		assert: element class == self nodeClass;
		assertElement: element hasAttributes: unprefixedAttributes.

	self
		should: [
			self nodeClass
				name: 'undeclared:three'
				attributes: unprefixedAttributes]
		raise: XMLNamespaceException.
	"prefixed attributes are not accepted"
	self
		should: [
			self nodeClass
				name: 'four'
				attributes: attributes]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 03:06'!
testNameNamespaceURI
	| element |

	element :=
		self nodeClass
			name: 'one'
			namespaceURI: 'defaultNS'.
	self
		assert: element class == self nodeClass;
		assert: element name = 'one';
		assert: element namespaceURI = 'defaultNS'.

	element :=
		self nodeClass
			name: 'prefix:two'
			namespaceURI: 'prefixNS'.
	self
		assert: element class == self nodeClass;
		assert: element name = 'prefix:two';
		assert: element namespaceURI = 'prefixNS'.
	self
		should: [
			self nodeClass
				name: 'prefix:three'
				namespaceURI: '']
		raise: XMLNamespaceException.

	element := self newNode.
	self assert:
		(element
			name: 'one'
			namespaceURI: 'defaultNS') == element.
	self
		assert: element name = 'one';
		assert: element namespaceURI = 'defaultNS'.

	self assert:
		(element
			name: 'prefix:two'
			namespaceURI: 'prefixNS') == element.
	self
		assert: element name = 'prefix:two';
		assert: element namespaceURI = 'prefixNS'.

	self
		should: [
			element
				name: 'prefix:three'
				namespaceURI: '']
		raise: XMLNamespaceException.

	(element := self newNode) usesNamespaces: false.
	self assert:
		(element
			name: 'four'
			namespaceURI: 'defaultNS') == element.
	self
		assert: element name = 'four';
		assert: element namespaceURI = 'defaultNS';
		assert: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 03:15'!
testNameNamespaceURIAttributes
	| attributes unprefixedAttributes element |

	attributes := self attributes.
	unprefixedAttributes := self unprefixedAttributes.
	element :=
		self nodeClass
			name: 'one'
			namespaceURI: 'defaultNS'
			attributes: unprefixedAttributes.
	self
		assert: element class == self nodeClass;
		assert: element name = 'one';
		assert: element namespaceURI = 'defaultNS';
		assertElement: element hasAttributes: unprefixedAttributes.

	element :=
		self nodeClass
			name: 'prefix:two'
			namespaceURI: 'prefixNS'
			attributes: attributes associations.
	self
		assert: element class == self nodeClass;
		assert: element name = 'prefix:two';
		assert: element namespaceURI = 'prefixNS';
		assertElement: element hasAttributes: attributes.

	"if the attributes have a prefix, then the element must have the
	same prefix and the namespace must be non-empty"
	self
		should: [
			self nodeClass
				name: 'three'  "no prefix"
				namespaceURI: ''  "no namespace"
				attributes: attributes]
		raise: XMLNamespaceException.
	self
		should: [
			self nodeClass
				name: 'four' "no prefix"
				namespaceURI: 'prefixNS'
				attributes: attributes]
		raise: XMLNamespaceException.
	self
		should: [
			self nodeClass
				name: 'prefix:five'
				namespaceURI: ''  "no namespace"
				attributes: unprefixedAttributes]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 03:21'!
testNameNamespaces
	| element |
	
	element :=
		self nodeClass
			name: 'one'
			namespaces: self namespaces.
	self
		assert: element class == self nodeClass;
		assert: element name = 'one';
		assert: element namespaceURI = 'defaultNS'.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	"namespaces: should accept any collection of associations"
	element :=
		self nodeClass
			name: 'two'
			namespaces: self namespaces associations.
	self
		assert: element class == self nodeClass;
		assert: element name = 'two';
		assert: element namespaceURI = 'defaultNS'.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	element :=
		self nodeClass
			name: 'prefix:three'
			namespaces: self namespaces.
	self
		assert: element class == self nodeClass;
		assert: element name = 'prefix:three';
		assert: element namespaceURI = 'prefixNS'.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	self
		should: [
			self nodeClass
				name: 'undeclared:three'
				namespaces: self namespaces]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/27/2016 03:22'!
testNameNamespacesAttributes
	| element |

	element :=
		self nodeClass
			name: 'one'
			namespaces: self namespaces
			attributes: self attributes.
	self
		assert: element class == self nodeClass;
		assert: element name = 'one';
		assert: element namespaceURI = 'defaultNS';
		assertElement: element hasAttributes: self attributes.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	element :=
		self nodeClass
			name: 'two'
			namespaces: self namespaces associations
			attributes: self attributes associations.
	self
		assert: element class == self nodeClass;
		assert: element name = 'two';
		assert: element namespaceURI = 'defaultNS';
		assertElement: element hasAttributes: self attributes.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element isDeclaredPrefix: prefix uri: uri)].

	self
		should: [
			self nodeClass
				name: 'undeclared:three'
				namespaces: self namespaces
				attributes: self attributes]
		raise: XMLNamespaceException.
	self
		should: [
			self nodeClass
				name: 'four'
				namespaces: #()
				attributes: self attributes]
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2016 20:51'!
testNamed
	| element |

	element := self nodeClass named: 'test'.
	self
		assert: element class == self nodeClass;
		assert: element name = 'test'.
	self
		should: [self nodeClass named: 'undeclared:test']
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:26'!
testNamespaceURI
	| element |

	element := self newNode.
	self assert: element namespaceURI = ''.

	element defaultNamespace: 'defaultNS'.
	self assert: element namespaceURI = 'defaultNS'.

	element
		name: 'prefix:test'
		namespaceURI: 'prefixNS'.
	self assert: element namespaceURI = 'prefixNS'.
	
	element
		defaultNamespace: '';
		name: 'test'.
	self assert: element namespaceURI = ''.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:25'!
testNextElement 
	| root nextElement |

	root := self newNodeWithElements firstElement.
	nextElement := nil.
	root elements reverseDo: [:each |
		self assert: each nextElement = nextElement.
		nextElement := each].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:26'!
testPrefix
	| element |

	element := self newNode.
	self
		assert: element prefix = '';
		assert: (element name: 'one') == element;
		assert: element prefix = ''.

	element
		declarePrefix: 'prefix'
		uri: 'prefixNS'.
	self
		assert: (element prefix: 'prefix') == element;
		assert: element name = 'prefix:one';
		assert: element prefix = 'prefix';
		assert: (element name: 'prefix:two') == element;
		assert: element name = 'prefix:two';
		assert: element prefix = 'prefix';
		assert: (element prefix: '') == element;
		assert: element name = 'two';
		assert: element prefix = ''.

	self
		should: [element prefix: 'undeclared']
		raise: XMLNamespaceException.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:25'!
testPreviousElement 
	| root previousElement |

	root := self newNodeWithElements firstElement.
	previousElement := nil.
	root elements do: [:each |
		self assert: each previousElement = previousElement.
		previousElement := each].! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:19'!
testPrintingDefaultNamespaces
	| element |

	element :=
		self nodeClass
			name: 'element'
			namespaceURI: 'default'.
	element addNode:
		((self nodeClass
			name: 'element'
			namespaceURI: '')
			addElementNamed: 'empty';
			yourself).

	self assert:
		element printString =
			('<element xmlns="default">',
			'<element xmlns=""><empty /></element>',
			'</element>').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:19'!
testPrintingNonRootNamespaces
	| element |

	element :=
		self nodeClass
			name: 'element'.
	element addNode:
		(self nodeClass
			name: 'used:empty'
			namespaces: (Array with: '' -> 'defaultNS' with: 'used' -> 'usedNS')).

	self assert:
		element printString =
			('<element>',
			'<used:empty xmlns="defaultNS" xmlns:used="usedNS" />',
			'</element>').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:18'!
testPrintingRootNamespaces
	| element |

	element :=
		self nodeClass
			name: 'used:element'
			namespaces: (Array with: '' -> 'defaultNS' with: 'used' -> 'usedNS').
	element addElementNamed: 'empty'.

	self assert:
		element printString =
			('<used:element xmlns="defaultNS" xmlns:used="usedNS">',
			'<empty />',
			'</used:element>').! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:24'!
testRemoveAttribute
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self
			assert: (element removeAttribute: each name) = each value;
			deny: (element includesAttribute: each name).
		self
			should: [element removeAttribute: each name]
			raise: Error].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:23'!
testRemoveAttributeIfAbsent
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self assert:
			(element
				removeAttribute: each name
				ifAbsent: [self fail]) = each value.
		self deny: (element includesAttribute: each name).
		self assert:
			(element
				removeAttribute: each name
				ifAbsent: [#absent]) = #absent].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:22'!
testRemoveAttributeNode
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self
			assert: (element removeAttributeNode: each) = each ;
			deny: (element attributeNodes includes: each).
		self
			should: [element removeAttribute: each]
			raise: Error].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:22'!
testRemoveAttributeNodeIfAbsent
	| element |

	element := self newElementWithAttributes.
	element attributeNodes copy do: [:each |
		self assert:
			(element
				removeAttributeNode: each
				ifAbsent: [self fail]) = each.
		self deny: (element attributeNodes includes: each).
		self assert:
			(element
				removeAttributeNode: each
				ifAbsent: [#absent]) = #absent].
	self assert: element attributeNodes isEmpty.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 11/23/2014 00:40'!
testRemoveAttributes
	| element |

	element := self newElementWithAttributes.
	self
		assert: element removeAttributes == element;
		assert: element attributeNodes isEmpty;
		deny: element hasAttributes.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:53'!
testResolvePrefix
	| element |

	element := self newNode.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element resolvePrefix: prefix) = ''.
		element declarePrefix: prefix uri: uri.
		self assert: (element resolvePrefix: prefix) = uri].

	self assert:
		(element resolvePrefix: 'xml') = XMLNamespaceScope xmlNamespaceURI.
	self assert:
		(element resolvePrefix: 'xmlns') = XMLNamespaceScope xmlnsNamespaceURI.

	(element := self newNode) usesNamespaces: false.
	self
		assert: (element resolvePrefix: 'xml') = '';
		assert: (element resolvePrefix: 'xmlns') = '';
		deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:54'!
testResolvePrefixIfUnresolvable
	| element |

	element := self newNode.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert:
			(element
				resolvePrefix: prefix
				ifUnresolvable: ['unresolvable']) = 'unresolvable'.
		element declarePrefix: prefix uri: uri.
		self assert:
			(element
				resolvePrefix: prefix
				ifUnresolvable: [self fail]) = uri].

	self assert:
		(element
			resolvePrefix: 'xml'
			ifUnresolvable: [self fail]) = XMLNamespaceScope xmlNamespaceURI.
	self  assert:
		(element
			resolvePrefix: 'xmlns'
			ifUnresolvable: [self fail]) = XMLNamespaceScope xmlnsNamespaceURI.

	(element := self newNode) usesNamespaces: false.
	self assert:
		(element
			resolvePrefix: 'xml'
			ifUnresolvable: ['unresolvable']) = 'unresolvable'.
	self  assert:
		(element
			resolvePrefix: 'xmlns'
			ifUnresolvable: ['unresolvable']) = 'unresolvable'.
	self deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:57'!
testResolvePrefixesOfNamespaceURI
	| element |

	element := self newNode.
	self namespaces keysAndValuesDo: [:prefix :uri |
		self assert: (element resolvePrefixesOfNamespaceURI: uri) isEmpty.

		element
			declarePrefix: prefix
			uri: uri.
		self assert:
			(element resolvePrefixesOfNamespaceURI: uri) =
				(Set with: prefix).

		element
			declarePrefix: 'newPrefix'
			uri: uri.
		self assert:
			(element resolvePrefixesOfNamespaceURI: uri) =
				(Set with: prefix with: 'newPrefix')].

	self assert:
		(element resolvePrefixesOfNamespaceURI:
			XMLNamespaceScope xmlNamespaceURI) =
				(Set with: 'xml').
	self assert:
		(element resolvePrefixesOfNamespaceURI:
			XMLNamespaceScope xmlnsNamespaceURI) =
				(Set with: 'xmlns').

	(element := self newNode) usesNamespaces: false.
	self assert:
		(element resolvePrefixesOfNamespaceURI:
			XMLNamespaceScope xmlNamespaceURI) isEmpty.
	self assert:
		(element resolvePrefixesOfNamespaceURI:
			XMLNamespaceScope xmlnsNamespaceURI) isEmpty.
	self deny: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 3/2/2016 15:54'!
testSetAttributes
	| element newAttributeAssociations |

	element := self newElementWithAttributes.
	newAttributeAssociations :=
		Array
			with: 'newName' -> 'newValue'
			with: 'newName2' -> 'newValue2'.
	element setAttributes: newAttributeAssociations.

	self assert:
		(element attributeNodes collect: [:each |
			each name -> each value]) asArray =
				newAttributeAssociations.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 12/2/2014 22:59'!
testSortKey
	self assert: (self nodeClass named: 'test') sortKey = 'test'! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:51'!
testUndeclareDefaultNamespace
	| element oldRootDefaultNamespace elementsWithCustomDefaultNamespace |

	element := self newNodeWithElements.
	oldRootDefaultNamespace := element defaultNamespace.
	elementsWithCustomDefaultNamespace :=
		element descendantElementsSelect: [:each |
			each defaultNamespace notEmpty
				and: [each defaultNamespace ~= oldRootDefaultNamespace]].

	element
		defaultNamespace: 'newDefaultNS';
		undeclareDefaultNamespace;
		allElementsDo: [:each |
			(elementsWithCustomDefaultNamespace includes: each)
				ifTrue: [
					self
						assert: each defaultNamespace notEmpty;
						deny: each defaultNamespace = oldRootDefaultNamespace;
						deny: each defaultNamespace = 'newDefaultNS']
				ifFalse: [self assert: each defaultNamespace isEmpty]].

	(element := self newNode) usesNamespaces: false.
	self
		assert: element undeclareDefaultNamespace == element;
		assert: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:50'!
testUndeclarePrefix
	| element |

	element := self newElementWithAttributes.
	element
		declarePrefix: 'unused'
		uri: 'unusedNS'.
	element addElementNamed: 'prefixTwo:inner'.

	self
		assert: (element undeclarePrefix: '') == element;
		assert: (element undeclarePrefix: 'unused') == element.
	element allElementsDo: [:each |
		self
			deny: (each isDeclaredPrefix: '');
			deny: (each isDeclaredPrefix: 'unusused');
			assert: (each isDeclaredPrefix: 'prefixTwo')].

	"this prefix is used by the subelement so it can't be undeclared"
	self
		should: [element undeclarePrefix: 'prefixTwo']
		raise: XMLNamespaceException.

	(element := self newElementWithAttributes)
		attributeAt: 'prefixTwo:name'
		put: 'value'.
	"this prefix is used by an attribute so it can't be undeclared"
	self
		should: [element undeclarePrefix: 'prefixTwo']
		raise: XMLNamespaceException.

	(element := self newNode) usesNamespaces: false.
	self
		assert: (element undeclarePrefix: '') == element;
		assert: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 8/26/2017 02:49'!
testUndeclarePrefixes
	| element innerElement |

	element :=
		self nodeClass
			name: 'outer'
			namespaces: self namespaces
			attributes: self unprefixedAttributes.
	(innerElement := element addElementNamed: 'prefixTwo:inner')
		declarePrefix: 'prefixTwo'
		uri: 'newNS'.

	self
		assert: (element undeclarePrefixes) == element;
		deny: element hasNamespaces;
		assert: innerElement hasNamespaces;
		assert: innerElement declaredPrefixes asArray = #('prefixTwo');
		assert: (innerElement resolvePrefix: 'prefixTwo') = 'newNS'.

	self
		should: [innerElement undeclarePrefixes]
		raise: XMLNamespaceException.

	(element := self newNode) usesNamespaces: false.
	self
		assert: element undeclarePrefixes == element;
		assert: element usesNamespaces.! !

!XMLElementTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:18'!
testWriteXMLOn
	| element attributes |

	element := self nodeClass named: 'element'.
	self assert: element printString = '<element />'.
	
	element addString: 'test'.
	self assert: element printString = '<element>test</element>'.

	"attribute order should be preserved when printing"
	attributes :=
		self attributesClass
			with: 'b' -> 'one'
			with: 'a' -> 'two'
			with: 'c' -> 'three'
			with: 'e' -> 'four'
			with: 'd' -> 'five'.
	element setAttributes: attributes.
	self assert:
		element printString =
			'<element b="one" a="two" c="three" e="four" d="five">test</element>'.
	element setAttributes: attributes associations reversed.
	self assert:
		element printString =
			'<element d="five" e="four" c="three" a="two" b="one">test</element>'.! !

XMLElementTest subclass: #XMLElementWithCachingNodeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementWithCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 9/1/2016 21:25'!
elementClass
	^ XMLElementWithCachingNodeList! !

!XMLElementWithCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 8/31/2016 06:57'!
nodeClass
	^ XMLElementWithCachingNodeList! !

!XMLElementWithCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 8/31/2016 06:57'!
nodeListClass
	^ XMLCachingNodeList! !

XMLElementTest subclass: #XMLElementWithoutCachingAttributeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementWithoutCachingAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/2/2016 13:58'!
attributeListClass
	^ XMLAttributeList! !

!XMLElementWithoutCachingAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/2/2016 13:58'!
elementClass
	^ XMLElementWithoutCachingAttributeList! !

!XMLElementWithoutCachingAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/2/2016 13:58'!
nodeClass
	^ XMLElementWithoutCachingAttributeList! !

!XMLNodeWithElementsTest methodsFor: 'asserting' stamp: 'monty 4/17/2016 05:15'!
assertElements: aPrettyPrintFormattedElementCollection werePrettyPrintFormattedFrom: anElementCollection
	anElementCollection
		with: aPrettyPrintFormattedElementCollection
		do: [:element :prettyElement |
			element hasChildren
				ifTrue: [
					"if the first node wasn't a string node, then whitespace
					formatting should have been output before it"
					element firstNode isStringNode
						ifFalse: [
							self
								assert: prettyElement firstNode isStringNode;
								assert: prettyElement firstNode isWhitespace].

					"if there were no string nodes at all, then trailing
					whitespace formatting should have been output"	
					element hasStringNodes
						ifFalse: [
							self
								assert: prettyElement lastNode isStringNode;
								assert: prettyElement lastNode isWhitespace]]].! !

!XMLNodeWithElementsTest methodsFor: 'accessing' stamp: 'monty 8/26/2016 20:55'!
configurationClass
	^ XMLDOMConfiguration! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/1/2016 09:09'!
elementBefore
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elementBefore |
				elementBefore := nil.
				node elements do: [:each |
					self assert: (node elementBefore: each) == elementBefore.
					elementBefore := each]]].! !

!XMLNodeWithElementsTest methodsFor: 'instance creation' stamp: 'monty 9/1/2016 21:22'!
newNodeWithElements
	^ self newNode
		addNode: (XMLComment string: 'before');
		addNode:
			((self elementClass named: 'zero')
				addNode: (XMLComment string: 'during');
				addNode:
					((self elementClass named: 'one')
						attributeAt: 'one' put: '1';
						addNode: (XMLString string: 'testing one');
						addNode: (self elementClass named: 'two');
						addNode: (XMLPI target: 'target' data: 'data');
						yourself);
				addNode: (XMLString string: 'testing two');
				addNode:
					((self elementClass name: 'three' namespaceURI: 'testNS')
						addNode: (self elementClass named: 'four');
						addNode: (XMLCData string: 'testing three');
						yourself);
				addNode:
					((self elementClass name: 'prefix:four' namespaceURI: 'testNS')
						attributeAt: 'four' put: '4';
						addNode:
							(self elementClass name: 'prefix:five' namespaceURI: 'testNS');
						yourself);
				addNode: (self elementClass named: 'four');
				yourself);
		addNode: (XMLComment string: 'after');
		yourself.! !

!XMLNodeWithElementsTest methodsFor: 'instance creation' stamp: 'monty 11/7/2014 14:18'!
newNodeWithNodes
	^ self newNodeWithElements! !

!XMLNodeWithElementsTest methodsFor: 'accessing' stamp: 'monty 11/4/2014 19:02'!
nodeClass
	^ XMLNodeWithElements! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/5/2016 13:17'!
testAcceptNodeVisitor
	| visitor nodeWithElements message |

	visitor := XMLRecordingNodeVisitor new.
	nodeWithElements := self newNodeWithElements.
	self
		assert: (nodeWithElements acceptNodeVisitor: visitor) == nodeWithElements;
		assert: visitor messageRecorder hasMessages.

	"skip the messages for the nodeWithElements"
	[visitor messageRecorder hasMessages
		and: [
			visitor messageRecorder peekMessage arguments =
				(Array with: nodeWithElements)]]
		whileTrue: [visitor messageRecorder nextMessage].

	nodeWithElements descendantNodesDo: [:node | | visitingSelectors |
		visitingSelectors :=
			(#(
				#(isElement #(visitElement: visitNodeWithElements:))
				#(isCData #(visitCData: #visitStringNode:))
				#(isStringNode #(#visitStringNode:))
				#(isComment #(visitComment:))
				#(isPI #(visitPI:)))
					detect: [:each | node perform: each first]
					ifNone: [#(nil #())]) second.

		self assert: visitingSelectors notEmpty.
		visitingSelectors do: [:selector |
			self assert: visitor messageRecorder hasMessages.

			message := visitor messageRecorder nextMessage.
			self
				assert: message selector = selector;
				assert: message arguments = (Array with: node)]].

	self deny: visitor messageRecorder hasMessages.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddCData
	| nodeWithElements cdataNode |

	nodeWithElements := self newNode.
	cdataNode := nodeWithElements addCData: 'test'.
	self
		assert: cdataNode isCData;
		assert: cdataNode string = 'test';
		assert: nodeWithElements nodes size = 1;
		assert: nodeWithElements firstNode == cdataNode.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddCDataNodeFactoryUse
	| nodeWithElements firstCDataNode lastCDataNode |

	nodeWithElements := self newNode.
	firstCDataNode := nodeWithElements addCData: 'one'.
	nodeWithElements nodeFactory:
		(XMLPluggableNodeFactory new
			cdataClass: XMLFCData).
	lastCDataNode := nodeWithElements addCData: 'two'.
	self
		assert: nodeWithElements nodes size = 2;
		assert: firstCDataNode class == XMLCData;
		assert: firstCDataNode string = 'one';
		assert: lastCDataNode class == XMLFCData;
		assert: lastCDataNode string = 'two'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddComment
	| nodeWithElements comment |

	super testAddComment.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				commentClass: XMLFComment).
	comment := nodeWithElements addComment: 'test'.
	self
		assert: nodeWithElements nodes size = 1;
		assert: nodeWithElements firstNode == comment;
		assert: comment class == XMLFComment;
		assert: comment string = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddElementNamed
	| nodeWithElements element |

	nodeWithElements := self newNode.
	element := nodeWithElements addElementNamed: 'one'.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element isElement;
		assert: element name = 'one'.
	self
		should: [nodeWithElements addElementNamed: 'undeclared:two']
		raise: XMLNamespaceException.

	nodeWithElements := self newNode.
	nodeWithElements usesNamespaces: false.
	self
		shouldnt: [nodeWithElements addElementNamed: 'undeclared:three']
		raise: XMLNamespaceException.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddElementNamedAttributes
	| nodeWithElements element |

	nodeWithElements := self newNode.
	element :=
		nodeWithElements
			addElementNamed: 'one'
			attributes: self unprefixedAttributeAssociations.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element isElement;
		assert: element name = 'one';
		assertElement: element hasAttributes: self unprefixedAttributes.
	self
		should: [
			nodeWithElements
				addElementNamed: 'undeclared:two'
				attributes: self unprefixedAttributeAssociations]
		raise: XMLNamespaceException.
	self
		should: [
			"attributes with undeclared prefixes should be caught too"
			nodeWithElements
				addElementNamed: 'three'
				attributes: self attributeAssociations]
		raise: XMLNamespaceException.

	nodeWithElements := self newNode.
	nodeWithElements usesNamespaces: false.
	self
		shouldnt: [
			nodeWithElements
				addElementNamed: 'undeclared:four'
				attributes: self attributeAssociations]
		raise: XMLNamespaceException.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:58'!
testAddElementNamedAttributesNodeFactoryUse
	| nodeWithElements element |

	nodeWithElements := self newNode.
	nodeWithElements nodeFactory:
		(XMLPluggableElementFactory new
			handleElement: 'test'
			attributes: self unprefixedAttributeAssociations
			withClass: self otherElementClass).
	element :=
		nodeWithElements
			addElementNamed: 'test'
			attributes: self unprefixedAttributeAssociations.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element class == self otherElementClass;
		assert: element name = 'test';
		assertElement: element hasAttributes: self unprefixedAttributes.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddElementNamedNamespaceURI
	| nodeWithElements element |

	nodeWithElements := self newNode.
	element :=
		nodeWithElements
			addElementNamed: 'test'
			namespaceURI: 'defaultNS'.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element isElement;
		assert: element name = 'test';
		assert: element namespaceURI = 'defaultNS'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/25/2017 23:59'!
testAddElementNamedNamespaceURIAttributes
	| nodeWithElements element |

	nodeWithElements := self newNode.
	element :=
		nodeWithElements
			addElementNamed: 'prefix:one'
			namespaceURI: 'prefixNS'
			attributes: self attributeAssociations.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element isElement;
		assert: element name = 'prefix:one';
		assert: element namespaceURI = 'prefixNS';
		assertElement: element hasAttributes: self attributes.
	self
		should: [
			"attributes with undeclared prefixes should be caught"
			nodeWithElements
				addElementNamed: 'two'
				namespaceURI: 'defaultNS'
				attributes: self attributeAssociations]
		raise: XMLNamespaceException.

	"this forces namespace support"
	nodeWithElements := self newNode.
	nodeWithElements usesNamespaces: false.
	self
		shouldnt: [
			nodeWithElements
				addElementNamed: 'three'
				namespaceURI: ''
				attributes: self unprefixedAttributeAssociations]
		raise: XMLNamespaceException.
	nodeWithElements usesNamespaces: false.
	self
		should: [
			nodeWithElements
				addElementNamed: 'four'
				namespaceURI: ''
				attributes: self attributeAssociations]
		raise: XMLNamespaceException.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:58'!
testAddElementNamedNamespaceURIAttributesNodeFactoryUse
	| nodeWithElements element |

	nodeWithElements := self newNode.
	nodeWithElements nodeFactory:
		(XMLPluggableElementFactory new
			handleElement: 'prefix:test'
			namespaceURI: 'prefixNS'
			attributes: self attributeAssociations
			withClass: self otherElementClass).
	element :=
		nodeWithElements
			addElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'
			attributes: self attributeAssociations.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element class == self otherElementClass;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS';
		assertElement: element hasAttributes: self attributes.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:58'!
testAddElementNamedNamespaceURINodeFactoryUse
	| nodeWithElements element |

	nodeWithElements := self newNode.
	nodeWithElements nodeFactory:
		(XMLPluggableElementFactory new
			handleElement: 'test'
			namespaceURI: 'defaultNS'
			withClass: self otherElementClass).
	element :=
		nodeWithElements
			addElementNamed: 'test'
			namespaceURI: 'defaultNS'.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element class == self otherElementClass;
		assert: element name = 'test';
		assert: element namespaceURI = 'defaultNS'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:58'!
testAddElementNamedNodeFactoryUse
	| nodeWithElements element |

	nodeWithElements := self newNode.
	nodeWithElements nodeFactory:
		(XMLPluggableElementFactory new
			handleElement: 'test'
			withClass: self otherElementClass).
	element := nodeWithElements addElementNamed: 'test'.
	self
		assert: nodeWithElements nodes size = 1;
		assert: element class == self otherElementClass;
		assert: element name = 'test'.
! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAddPITargetData
	| nodeWithElements pi |

	super testAddPITargetData.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				piClass: XMLFPI).
	pi :=
		nodeWithElements
			addPITarget: 'target'
			data: 'data'.
	self
		assert: nodeWithElements nodes size = 1;
		assert: nodeWithElements firstNode == pi;
		assert: pi class == XMLFPI;
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:21'!
testAddString
	| nodeWithElements firstStringNode elementNode lastStringNode |

	nodeWithElements := self newNode.
	firstStringNode := nodeWithElements addString: 'one'.
	self
		assert: (firstStringNode isStringNode: 'one');
		assert: nodeWithElements nodes size = 1;
		assert: nodeWithElements firstNode == firstStringNode.

	self
		assert: (nodeWithElements addString: 'two') == firstStringNode;
		assert: (firstStringNode isStringNode: 'onetwo');
		assert: nodeWithElements nodes size = 1;
		assert: nodeWithElements nodes first == firstStringNode.

	elementNode := nodeWithElements addNode: (self elementClass named: 'three').
	self
		assert: (elementNode isElementNamed: 'three');
		assert: nodeWithElements nodes size = 2;
		assert: nodeWithElements nodes first == firstStringNode;
		assert: nodeWithElements nodes second == elementNode.

	lastStringNode := nodeWithElements addString: 'four'.
	self
		assert: (lastStringNode isStringNode: 'four');
		assert: nodeWithElements nodes size = 3;
		assert: nodeWithElements nodes first == firstStringNode;
		assert: nodeWithElements nodes second == elementNode;
		assert: nodeWithElements nodes third == lastStringNode.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:21'!
testAddStringNodeFactoryUse
	| nodeWithElements firstStringNode elementNode lastStringNode |

	nodeWithElements := self newNode.
	firstStringNode := nodeWithElements addString: 'one'.
	self
		assert: (firstStringNode isStringNode: 'one');
		assert: nodeWithElements nodes size = 1;
		assert: nodeWithElements firstNode == firstStringNode.

	nodeWithElements nodeFactory:
		(XMLPluggableNodeFactory new
			stringNodeClass: XMLFString).
	self
		assert: (nodeWithElements addString: 'two') == firstStringNode;
		assert: (firstStringNode isStringNode: 'onetwo');
		assert: nodeWithElements nodes size = 1;
		assert: nodeWithElements nodes first == firstStringNode.

	elementNode := nodeWithElements addNode: (self elementClass named: 'three').
	self
		assert: (elementNode isElementNamed: 'three');
		assert: nodeWithElements nodes size = 2;
		assert: nodeWithElements nodes first == firstStringNode;
		assert: nodeWithElements nodes second == elementNode.

	lastStringNode := nodeWithElements addString: 'four'.
	self
		assert: lastStringNode class == XMLFString;
		assert: (lastStringNode isStringNode: 'four');
		assert: nodeWithElements nodes size = 3;
		assert: nodeWithElements nodes first == firstStringNode;
		assert: nodeWithElements nodes second == elementNode;
		assert: nodeWithElements nodes third == lastStringNode.

	self
		assert: (nodeWithElements addString: 'five') == lastStringNode;
		assert: lastStringNode class == XMLFString;
		assert: (lastStringNode isStringNode: 'fourfive');
		assert: nodeWithElements nodes size = 3;
		assert: nodeWithElements nodes first == firstStringNode;
		assert: nodeWithElements nodes second == elementNode;
		assert: nodeWithElements nodes third == lastStringNode.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:29'!
testAllElements
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	nodeWithElements isElement
		ifTrue: [
			self assert: allElements first = nodeWithElements.
			allElements removeFirst].
	self assert:
		(allElements collect: [:each | each name]) asArray =
			#('zero' 'one' 'two' 'three' 'four' 'prefix:four' 'prefix:five' 'four').
	self
		assertList: allElements first allElements selects: (allElements copyFrom: 1 to: 8);
		assertList: allElements second allElements selects: (allElements copyFrom: 2 to: 3);
		assertList: allElements third allElements selects: (allElements copyFrom: 3 to: 3);
		assertList: allElements fourth allElements selects: (allElements copyFrom: 4 to: 5);
		assertList: allElements fifth allElements selects: (allElements copyFrom: 5 to: 5);
		assertList: allElements sixth allElements selects: (allElements copyFrom: 6 to: 7);
		assertList: allElements seventh allElements selects: (allElements copyFrom: 7 to: 7);
		assertList: allElements eighth allElements selects: (allElements copyFrom: 8 to: 8).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testAllElementsCollect
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	self
		assertList: (nodeWithElements allElementsCollect: [:each | each identityHash])
		collects: (allElements collect: [:each | each identityHash]).

	allElements do: [:node |
		self
			assertList: (node allElementsCollect: [:each | each identityHash])
			collects: (node allElements collect: [:each | each identityHash])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:01'!
testAllElementsDetect
	| nodeWithElements allElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	detectedElement := nodeWithElements allElementsDetect: [:each | each isNamed: 'prefix:four'].
	self
		assert: detectedElement notNil;
		assert: (detectedElement isNamed: 'prefix:four');
		assert: detectedElement = (allElements detect: [:each | each isNamed: 'prefix:four']);
		assert: (nodeWithElements allElementsDetect: [:each | each isNamed: 'absent']) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:02'!
testAllElementsDetectIfNone
	| nodeWithElements allElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	detectedElement :=
		nodeWithElements
			allElementsDetect: [:each | each isNamed: 'prefix:four']
			ifNone: [self fail].
	self assert: (detectedElement isNamed: 'prefix:four').
	self assert:	
		detectedElement =
			(allElements detect: [:each | each isNamed: 'prefix:four']).
	self assert:
		(nodeWithElements
			allElementsDetect: [:each | each isNamed: 'absent']
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testAllElementsDo
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	self
		should: [:block | nodeWithElements allElementsDo: block]
		enumerate: allElements.

	allElements do: [:element |
		self
			should: [:block | element allElementsDo: block]
			enumerate: element allElements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:22'!
testAllElementsNamed
	| nodeWithElements allElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert: (nodeWithElements allElementsNamed: 'absent') isEmpty.

	allElements := nodeWithElements allElements.
	namedElements := nodeWithElements allElementsNamed: 'four'. 
	self
		assert: namedElements size = 3;
		assertList: namedElements selects: (allElements select: [:each | each isNamed: 'four']).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:25'!
testAllElementsNamedDo
	| nodeWithElements allElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements allElementsNamed: 'absent' do: block]
		enumerate: #().

	allElements := nodeWithElements allElements.
	namedElements := nodeWithElements allElementsNamed: 'four'. 
	self
		should: [:block | nodeWithElements allElementsNamed: 'four' do: block]
		enumerate: namedElements.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:22'!
testAllElementsNamedNamespaceURI
	| nodeWithElements allElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert: (nodeWithElements allElementsNamed: 'four' namespaceURI: 'absent') isEmpty.

	allElements := nodeWithElements allElements.
	namedElements := nodeWithElements allElementsNamed: 'four' namespaceURI: 'testNS'. 
	self
		assert: namedElements size = 2;
		assertList: namedElements
		selects:
			(allElements select: [:each |
				(each isNamed: 'four')
					and: [each namespaceURI = 'testNS']]).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/7/2014 14:07'!
testAllElementsSelect
	| nodeWithElements allElements |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	self
		assertList: (nodeWithElements allElementsSelect: [:each | each hasChildren])
		selects: (allElements select: [:each | each hasChildren]).

	allElements do: [:node |
		self
			assertList: (node allElementsSelect: [:each | each hasChildren])
			selects: (node allElements select: [:each | each hasChildren])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:32'!
testAllNodes
	| nodeWithElements allNodes |

	nodeWithElements := self newNodeWithElements.
	allNodes := nodeWithElements allNodes.
	self
		assert: allNodes size = 16;
		assert: (allNodes at: 1) = nodeWithElements;
		assert: (allNodes at: 2) isComment;
		assert: ((allNodes at: 3) isElementNamed: 'zero');
		assert: (allNodes at: 4) isComment;
		assert: ((allNodes at: 5) isElementNamed: 'one');
		assert: ((allNodes at: 6) isStringNode: 'testing one');
		assert: ((allNodes at: 7) isElementNamed: 'two');
		assert: (allNodes at: 8) isPI;
		assert: ((allNodes at: 9) isStringNode: 'testing two');
		assert: ((allNodes at: 10) isElementNamed: 'three');
		assert: ((allNodes at: 11) isElementNamed: 'four');
		assert: ((allNodes at: 12) isStringNode: 'testing three');
		assert: ((allNodes at: 13) isElementNamed: 'prefix:four');
		assert: ((allNodes at: 14) isElementNamed: 'prefix:five');
		assert: ((allNodes at: 15) isElementNamed: 'four');
		assert: (allNodes at: 16) isComment.
	self
		assertList: (allNodes at: 3) allNodes selects: (allNodes copyFrom: 3 to: 15);
		assertList: (allNodes at: 5) allNodes selects: (allNodes copyFrom: 5 to: 8);
		assertList: (allNodes at: 7) allNodes selects: (allNodes copyFrom: 7 to: 7);
		assertList: (allNodes at: 10) allNodes selects: (allNodes copyFrom: 10 to: 12);
		assertList: (allNodes at: 11) allNodes selects: (allNodes copyFrom: 11 to: 11);
		assertList: (allNodes at: 13) allNodes selects: (allNodes copyFrom: 13 to: 14);
		assertList: (allNodes at: 14) allNodes selects: (allNodes copyFrom: 14 to: 14);
		assertList: (allNodes at: 15) allNodes selects: (allNodes copyFrom: 15 to: 15).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:32'!
testAncestorElements
	| nodeWithElements ancestorStack |

	super testAncestorElements.

	nodeWithElements := self newNodeWithElements.
	ancestorStack := OrderedCollection new.
	nodeWithElements allNodesDo: [:each |
		[ancestorStack isEmpty
			or: [ancestorStack last = each parent]]
			whileFalse: [ancestorStack removeLast].
		self assert:
			each ancestorElements asOrderedCollection =
				ancestorStack reversed.
		each isElement
			ifTrue: [ancestorStack addLast: each]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 3/8/2015 17:07'!
testAncestorElementsDo
	| nodeWithElements |

	super testAncestorElementsDo.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each |
		self
			should: [:block | each ancestorElementsDo: block]
			enumerate: each ancestorElements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/30/2016 07:45'!
testConfiguration
	| nodeWithElements configuration newConfiguration |

	nodeWithElements := self newNodeWithElements.
	configuration := nodeWithElements configuration.
	self assert: configuration class == self configurationClass.
	nodeWithElements allElementsDo: [:element |
		self assert: element configuration == configuration.
		element attributeNodes do: [:each |
			self assert: each configuration == configuration]].

	"ensure descendants inherit the new config when it's set"
	newConfiguration := self configurationClass new.
	nodeWithElements configuration: newConfiguration.
	self assert: nodeWithElements configuration == newConfiguration.
	nodeWithElements allElementsDo: [:element |
		self assert: element configuration == newConfiguration.
		element attributeNodes do: [:each |
			self assert: each configuration == newConfiguration]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:43'!
testContentNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements contentNodes
		selects: (nodeWithElements nodes select: [:each | each isContentNode]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element contentNodes
			selects: (element nodes select: [:each | each isContentNode])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:44'!
testContentNodesDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements contentNodesDo: block]
		enumerate: nodeWithElements contentNodes.
	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each contentNodesDo: block]
			enumerate: each contentNodes].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/2/2015 16:35'!
testContentStringAt
	| root |

	root := self newNodeWithElements firstElement.
	root elementsDo: [:each |
		self assert: (root contentStringAt: each name) = each contentString].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:50'!
testDescendantElements
	| nodeWithElements descendantElements |

	nodeWithElements := self newNodeWithElements.
	descendantElements := nodeWithElements descendantElements.
	self assert:
		(descendantElements collect: [:each | each name]) asArray =
			#('zero' 'one' 'two' 'three' 'four' 'prefix:four' 'prefix:five' 'four').
	self
		assertList: descendantElements first descendantElements selects: (descendantElements copyFrom: 2 to: 8);
		assertList: descendantElements second descendantElements selects: (descendantElements copyFrom: 3 to: 3);
		assertList: descendantElements third descendantElements selects: descendantElements copyEmpty;
		assertList: descendantElements fourth descendantElements selects: (descendantElements copyFrom: 5 to: 5);
		assertList: descendantElements fifth descendantElements selects: descendantElements copyEmpty;
		assertList: descendantElements sixth descendantElements selects: (descendantElements copyFrom: 7 to: 7);
		assertList: descendantElements seventh descendantElements selects: descendantElements copyEmpty;
		assertList: descendantElements eighth descendantElements selects: descendantElements copyEmpty.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:49'!
testDescendantElementsCollect
	| nodeWithElements descendantElements |

	nodeWithElements := self newNodeWithElements.
	descendantElements := nodeWithElements descendantElements.
	self
		assertList: (nodeWithElements descendantElementsCollect: [:each | each identityHash])
		collects: (descendantElements collect: [:each | each identityHash]).

	descendantElements do: [:node |
		self
			assertList: (node descendantElementsCollect: [:each | each identityHash])
			collects: (node descendantElements collect: [:each | each identityHash])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:03'!
testDescendantElementsDetect
	| nodeWithElements descendantElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	descendantElements := nodeWithElements descendantElements.
	detectedElement := nodeWithElements descendantElementsDetect: [:each | each isNamed: 'prefix:four'].
	self
		assert: detectedElement notNil;
		assert: (detectedElement isNamed: 'prefix:four');
		assert: detectedElement = (descendantElements detect: [:each | each isNamed: 'prefix:four']);
		assert: (detectedElement descendantElementsDetect: [:each | each isNamed: 'prefix:four']) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:03'!
testDescendantElementsDetectIfNone
	| nodeWithElements descendantElements detectedElement |

	nodeWithElements := self newNodeWithElements.
	descendantElements := nodeWithElements descendantElements.
	detectedElement :=
		nodeWithElements
			descendantElementsDetect: [:each | each isNamed: 'prefix:four']
			ifNone: [self fail].
	self assert: (detectedElement isNamed: 'prefix:four').
	self assert:	
		detectedElement =
			(descendantElements detect: [:each | each isNamed: 'prefix:four']).
	self assert:
		(detectedElement
			descendantElementsDetect: [:each | each isNamed: 'prefix:four']
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:49'!
testDescendantElementsDo
	| nodeWithElements descendantElements |

	nodeWithElements := self newNodeWithElements.
	descendantElements := nodeWithElements descendantElements.
	self
		should: [:block | nodeWithElements descendantElementsDo: block]
		enumerate: descendantElements.

	descendantElements do: [:element |
		self
			should: [:block | element descendantElementsDo: block]
			enumerate: element descendantElements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:49'!
testDescendantElementsNamed
	| nodeWithElements descendantElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert: (nodeWithElements descendantElementsNamed: 'absent') isEmpty.

	descendantElements := nodeWithElements descendantElements.
	namedElements := nodeWithElements descendantElementsNamed: 'four'. 
	self assert: namedElements size = 3.
	self
		assertList: namedElements
		selects: (descendantElements select: [:each | each isNamed: 'four']).

	namedElements do: [:each |
		self assert: (each descendantElementsNamed: 'four') isEmpty]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:49'!
testDescendantElementsNamedDo
	| nodeWithElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements descendantElementsNamed: 'absent' do: block]
		enumerate: #().

	namedElements := nodeWithElements descendantElementsNamed: 'four'. 
	self
		should: [:block | nodeWithElements descendantElementsNamed: 'four' do: block]
		enumerate: namedElements.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:49'!
testDescendantElementsNamedNamespaceURI
	| nodeWithElements descendantElements namedElements |

	nodeWithElements := self newNodeWithElements.
	self assert:
		(nodeWithElements
			descendantElementsNamed: 'four'
			namespaceURI: 'absent') isEmpty.

	descendantElements := nodeWithElements descendantElements.
	namedElements :=
		nodeWithElements
			descendantElementsNamed: 'four'
			namespaceURI: 'testNS'. 
	self
		assert: namedElements size = 2;
		assertList: namedElements
		selects:
			(descendantElements select: [:each |
				(each isNamed: 'four')
					and: [each namespaceURI = 'testNS']]).! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:48'!
testDescendantElementsSelect
	| nodeWithElements descendantElements |

	nodeWithElements := self newNodeWithElements.
	descendantElements := nodeWithElements descendantElements.
	self
		assertList: (nodeWithElements descendantElementsSelect: [:each | each hasChildren])
		selects: (descendantElements select: [:each | each hasChildren]).

	descendantElements do: [:node |
		self
			assertList: (node descendantElementsSelect: [:each | each hasChildren])
			selects: (node descendantElements select: [:each | each hasChildren])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:32'!
testElementAfter
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elementAfter |
				elementAfter := nil.
				node elements reverseDo: [:each |
					self assert: (node elementAfter: each) = elementAfter.
					elementAfter := each]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:08'!
testElementAt
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elements localNames qualifiedNames |
				elements := node elements.
				localNames := (elements collect: [:each | each localName]) asSet.
				qualifiedNames :=
					(elements
						select: [:each | each hasPrefix]
						thenCollect: [:each | each name]) asSet.
				localNames do: [:localName |
					self assert:
						(node elementAt: localName) =
							(elements detect: [:each | each localName = localName]).
					self assert: (node elementAt: 'absent:', localName) isNil].
				qualifiedNames do: [:qualifiedName |
					self assert:
						(node elementAt: qualifiedName) =
							(elements detect: [:each |
								each hasPrefix
									and: [each name = qualifiedName]])].
			self assert: (node elementAt: 'absent') isNil]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:10'!
testElementAtAddedInPlace
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [
				(Array
					with: node elements
					with: node elements reversed) do: [:elements | | localNames qualifiedNames |
					localNames := (elements collect: [:each | each localName]) asSet.
					qualifiedNames :=
						(elements
							select: [:each | each hasPrefix]
							thenCollect: [:each | each name]) asSet.
					node addNodes: elements.
					localNames do: [:localName |
						self assert:
							(node elementAt: localName) =
								(elements detect: [:each | each localName = localName])].
					qualifiedNames do: [:qualifiedName |
						self assert:
							(node elementAt: qualifiedName) =
								(elements detect: [:each |
									each hasPrefix
										and: [each name = qualifiedName]])]]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:40'!
testElementAtIfAbsent
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elements localNames qualifiedNames |
				elements := node elements.
				localNames := (elements collect: [:each | each localName]) asSet.
				qualifiedNames :=
					(elements
						select: [:each | each hasPrefix]
						thenCollect: [:each | each name]) asSet.
				localNames do: [:localName |
					self assert:
						(node
							elementAt: localName
							ifAbsent: [self fail]) =
								(elements detect: [:each | each localName = localName]).
					self assert:
						(node
							elementAt: 'absent:', localName
							ifAbsent: [#absent]) = #absent].
				qualifiedNames do: [:qualifiedName |
					self assert:
						(node
							elementAt: qualifiedName
							ifAbsent: [self fail]) =
								(elements detect: [:each |
									each hasPrefix
										and: [each name = qualifiedName]])].
			self assert:
				(node
					elementAt: 'absent'
					ifAbsent: [#absent]) = #absent]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:11'!
testElementAtNamespaceURI
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elements localNames qualifiedNames namespaceURIs |
				elements := node elements.
				localNames := (elements collect: [:each | each localName]) asSet.
				qualifiedNames :=
					(elements
						select: [:each | each hasPrefix]
						thenCollect: [:each | each name]) asSet.
				namespaceURIs := (elements collect: [:each | each namespaceURI]) asSet.
				localNames do: [:localName |
					namespaceURIs do: [:uri |
						self assert:
							(node
								elementAt: localName
								namespaceURI: uri) =
									(elements detect: [:each |
										each localName = localName
											and: [each namespaceURI = uri]])].
					self assert:
						(node
							elementAt: localName
							namespaceURI: 'absentNS') isNil].
				qualifiedNames do: [:qualifiedName |
					namespaceURIs do: [:uri |
						self assert:
							(node
								elementAt: qualifiedName
								namespaceURI: uri) =
									(elements detect: [:each |
										each hasPrefix
											and: [each name = qualifiedName
												and: [each namespaceURI = uri]]])].
					self assert:
						(node
							elementAt: qualifiedName
							namespaceURI: 'absentNS') isNil]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:11'!
testElementAtNamespaceURIIfAbsent
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elements localNames qualifiedNames namespaceURIs |
				elements := node elements.
				localNames := (elements collect: [:each | each localName]) asSet.
				qualifiedNames :=
					(elements
						select: [:each | each hasPrefix]
						thenCollect: [:each | each name]) asSet.
				namespaceURIs := (elements collect: [:each | each namespaceURI]) asSet.
				localNames do: [:localName |
					namespaceURIs do: [:uri |
						self assert:
							(node
								elementAt: localName
								namespaceURI: uri
								ifAbsent: [#absent]) =
									(elements
										detect: [:each |
											each localName = localName
												and: [each namespaceURI = uri]]
										ifNone: [#absent])].
					self assert:
						(node
							elementAt: localName
							namespaceURI: 'absentNS'
							ifAbsent: [#absent]) = #absent].
				qualifiedNames do: [:qualifiedName |
					namespaceURIs do: [:uri |
						self assert:
							(node
								elementAt: qualifiedName
								namespaceURI: uri
								ifAbsent: [#absent]) =
									(elements
										detect: [:each |
											each hasPrefix
												and: [each name = qualifiedName
													and: [each namespaceURI = uri]]]
										ifNone: [#absent])].
					self assert:
						(node
							elementAt: qualifiedName
							namespaceURI: 'absentNS'
							ifAbsent: [#absent]) = #absent]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:33'!
testElementBefore
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elementBefore |
				elementBefore := nil.
				node elements do: [:each |
					self assert: (node elementBefore: each) = elementBefore.
					elementBefore := each]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:09'!
testElementNames
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements elementNames
		collects: (nodeWithElements elements collect: [:each | each name]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element elementNames
			collects: (element elements collect: [:each | each name])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:33'!
testElementRenamingToNext
	self newNodeWithElements
		usesNamespaces: false;
		allElementsDo: [:each | | parent oldName oldLocalName nextElement |
			((parent := each parent) notNil
				and: [(nextElement := each nextElement) notNil])
				ifTrue: [
					oldName := each name.
					oldLocalName := each localName.
					
					each name: nextElement name.
					each name = oldName
						ifFalse: [
							self
								deny: ((parent elementAt: oldName) = each);
								deny: ((parent elementsAt: oldName) includes: each)].
					each localName = oldLocalName
						ifFalse: [
							self
								deny: ((parent elementAt: oldLocalName) = each);
								deny: ((parent elementsAt: oldLocalName) includes: each)].
					self
						assert: ((parent elementsAt: each name) after: each) = nextElement;
						assert: ((parent elementsAt: each localName) after: each) = nextElement]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:33'!
testElementRenamingToPrevious
	self newNodeWithElements
		usesNamespaces: false;
		allElementsDo: [:each | | parent oldName oldLocalName previousElement |
			((parent := each parent) notNil
				and: [(previousElement := each previousElement) notNil])
				ifTrue: [
					oldName := each name.
					oldLocalName := each localName.
					
					each name: previousElement name.
					each name = oldName
						ifFalse: [
							self
								deny: ((parent elementAt: oldName) = each);
								deny: ((parent elementsAt: oldName) includes: each)].
					each localName = oldLocalName
						ifFalse: [
							self
								deny: ((parent elementAt: oldLocalName) = each);
								deny: ((parent elementsAt: oldLocalName) includes: each)].
					self
						assert: ((parent elementsAt: each name) before: each) = previousElement;
						assert: ((parent elementsAt: each localName) before: each) = previousElement]].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:07'!
testElements
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [
				self
					assertList: node elements 
					selects: (node nodes select: [:each | each isElement])]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:04'!
testElementsAddedInPlace
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [
				(Array
					with: node elements
					with: node elements reversed) do: [:elements |
					node addNodes: elements.
					self
						assertList: node elements 
						selects: elements]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:12'!
testElementsAt
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elements localNames qualifiedNames |
				elements := node elements.
				localNames := (elements collect: [:each | each localName]) asSet.
				qualifiedNames :=
					(elements
						select: [:each | each hasPrefix]
						thenCollect: [:each | each name]) asSet.
				localNames do: [:localName |
					self
						assertList: (node elementsAt: localName)
						selects:
							(elements select: [:each |
								each localName = localName]).
					self
						assertList: (node elementsAt: 'absent:', localName)
						selects: elements copyEmpty].
				qualifiedNames do: [:qualifiedName |
					self
						assertList: (node elementsAt: qualifiedName)
						selects:
							(elements select: [:each |
								each hasPrefix
									and: [each name = qualifiedName]])].
			self
				assertList: (node elementsAt: 'absent')
				selects: elements copyEmpty]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:16'!
testElementsAtAddedInPlace
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [
				(Array
					with: node elements
					with: node elements reversed) do: [:elements | | localNames qualifiedNames |
					localNames := (elements collect: [:each | each localName]) asSet.
					qualifiedNames :=
						(elements
							select: [:each | each hasPrefix]
							thenCollect: [:each | each name]) asSet.
					node addNodes: elements.
					localNames do: [:localName |
						self
							assertList: (node elementsAt: localName)
							selects:
								(elements select: [:each |
									each localName = localName])].
					qualifiedNames do: [:qualifiedName |
						self
							assertList: (node elementsAt: qualifiedName)
							selects:
								(elements select: [:each |
									each hasPrefix
										and: [each name = qualifiedName]])]]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:14'!
testElementsAtDo
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elements localNames qualifiedNames |
				elements := node elements.
				localNames := (elements collect: [:each | each localName]) asSet.
				qualifiedNames :=
					(elements
						select: [:each | each hasPrefix]
						thenCollect: [:each | each name]) asSet.
				localNames do: [:localName |
					self
						should: [:block | node elementsAt: localName do: block]
						enumerate:
							(elements select: [:each |
								each localName = localName]).
					self
						should: [:block | node elementsAt: 'absent:', localName do: block]
						enumerate: #()].
				qualifiedNames do: [:qualifiedName |
					self
						should: [:block | node elementsAt: qualifiedName do: block]
						enumerate:
							(elements select: [:each |
								each hasPrefix
									and: [each name = qualifiedName]])].
			self
				should: [:block | node elementsAt: 'absent' do: block]
				enumerate: #()]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/4/2016 02:15'!
testElementsAtNamespaceURI
	self newNodeWithElements allNodesDo: [:node |
		node canHaveChildren
			ifTrue: [| elements localNames qualifiedNames namespaceURIs |
				elements := node elements.
				localNames := (elements collect: [:each | each localName]) asSet.
				qualifiedNames :=
					(elements
						select: [:each | each hasPrefix]
						thenCollect: [:each | each name]) asSet.
				namespaceURIs := (elements collect: [:each | each namespaceURI]) asSet.
				localNames do: [:localName |
					namespaceURIs do: [:uri |
						self
							assertList:
								(node
									elementsAt: localName
									namespaceURI: uri)
							selects:
								(elements select: [:each |
									each localName = localName
										and: [each namespaceURI = uri]])].
					self
						assertList:
							(node
								elementsAt: localName
								namespaceURI: 'absentNS')
						selects: elements copyEmpty].
				qualifiedNames do: [:qualifiedName |
					namespaceURIs do: [:uri |
						self
							assertList:
								(node
									elementsAt: qualifiedName
									namespaceURI: uri)
							selects:
								(elements select: [:each |
									each hasPrefix
										and: [each name = qualifiedName
											and: [each namespaceURI = uri]]])].
					self
						assertList:
							(node
								elementsAt: qualifiedName
								namespaceURI: 'absentNS')
						selects: elements copyEmpty]]]! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 02:30'!
testElementsCollect
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: (nodeWithElements elementsCollect: [:each | each name])
		collects: (nodeWithElements elements collect: [:each | each name]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: (element elementsCollect: [:each | each name])
			collects: (element elements collect: [:each | each name])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:04'!
testElementsDetect
	| root element |

	root := self newNodeWithElements firstElement.
	element :=
		root elementsDetect: [:each |
			(each isNamed: 'four')
				and: [each namespaceURI = 'testNS']].
	self deny: element isNil.
	self assert:
		element = 
			(root elements detect: [:each |
				(each isNamed: 'four')
					and: [each namespaceURI = 'testNS']]).
	self assert:
		(root elementsDetect: [:each |
			(each isNamed: 'four')
				and: [each namespaceURI = 'absentNS']]) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:59'!
testElementsDetectIfNone
	| root |

	root := self newNodeWithElements firstElement.
	self assert: 
		(root
			elementsDetect: [:each |
				(each isNamed: 'four')
					and: [each namespaceURI = 'testNS']]
			ifNone: [self fail]) =
				(root elements
					detect: [:each |
						(each isNamed: 'four')
							and: [each namespaceURI = 'testNS']]).
	self assert:
		(root
			elementsDetect: [:each |
				(each isNamed: 'four')
					and: [each namespaceURI = 'absentNS']]
			ifNone: [#absent]) = #absent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/1/2016 09:11'!
testElementsDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements elementsDo: block]
		enumerate: nodeWithElements elements.
	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each elementsDo: block]
			enumerate: each elements].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 02:32'!
testElementsSelect
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: (nodeWithElements elementsSelect: [:each | each hasChildren])
		selects: (nodeWithElements elements select: [:each | each hasChildren]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: (element elementsSelect: [:each | each hasChildren])
			selects: (element elements select: [:each | each hasChildren])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 21:57'!
testFindElementNamed
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement := nodeWithElements findElementNamed: 'four'.
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'four');
		assert: foundElement == (allElements detect: [:each | each isNamed: 'four']);
		assert: (foundElement findElementNamed: 'four') == foundElement;
		assert: (nodeWithElements findElementNamed: 'absent') isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:02'!
testFindElementNamedNamespaceURI
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement := nodeWithElements findElementNamed: 'four' namespaceURI: 'testNS'.
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'four').
	self assert:
		foundElement ==
			(allElements detect: [:each |
				(each isNamed: 'four') and: [each namespaceURI = 'testNS']]).
	self
		assert: (foundElement findElementNamed: 'four' namespaceURI: 'testNS') == foundElement;
		assert: (nodeWithElements findElementNamed: 'four' namespaceURI: 'absentNS') isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 09:09'!
testFindElementNamedNamespaceURIWith
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement :=
		nodeWithElements
			findElementNamed: 'four'
			namespaceURI: 'testNS'
			with: [:each | each hasChildren].
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'prefix:four').
	self assert:
		foundElement ==
			(allElements detect: [:each |
				(each isNamed: 'four')
					and: [(each namespaceURI = 'testNS')
						and: [each hasChildren]]]).
	self assert:
		(foundElement
			findElementNamed: 'four'
			namespaceURI: 'testNS'
			with: [:each | each hasChildren]) == foundElement.
	self assert:
		(nodeWithElements 
			findElementNamed: 'four'
			namespaceURI: 'testNS'
			with: [:each | false]) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/22/2014 22:04'!
testFindElementNamedWith
	| nodeWithElements allElements foundElement |

	nodeWithElements := self newNodeWithElements.
	allElements := nodeWithElements allElements.
	foundElement := nodeWithElements findElementNamed: 'four' with: [:each | each hasChildren].
	self
		assert: foundElement notNil;
		assert: (foundElement isNamed: 'four').
	self assert:
		foundElement ==
			(allElements detect: [:each | (each isNamed: 'four') and: [each hasChildren]]).
	self
		assert: (foundElement findElementNamed: 'four' with: [:each | each hasChildren]) == foundElement;
		assert: (nodeWithElements findElementNamed: 'four' with: [:each | false]) isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 3/20/2017 18:43'!
testFindElementWithID
	| dtd content contentWithUndeclaredAttribute document idElement xmlIDElement |

	dtd := '
		<!!DOCTYPE a [
			<!!ELEMENT a (
				b,
				c,
				d,
				e
			)>
			<!!ELEMENT b EMPTY>
			<!!ELEMENT c EMPTY>
			<!!ELEMENT d EMPTY>
			<!!ELEMENT e EMPTY>
			<!!ATTLIST b id CDATA #REQUIRED>
			<!!ATTLIST c id ID #REQUIRED>
			<!!ATTLIST d xml:id ID #REQUIRED>
		]>'.
	content := '
		<a>
			<b id="one"/>
			<c id="one"/>
			<d xml:id="two"/>
			<e/>
		</a>'.
	contentWithUndeclaredAttribute := '
		<a>
			<b id="one"/>
			<c id="one"/>
			<d xml:id="two" undeclared="three"/>
			<e />
		</a>'.

	#(true false) do: [:isValidating |
		document :=
			XMLDOMParser
				parse:
					dtd,
						(isValidating
							ifTrue: [content]
							ifFalse: [contentWithUndeclaredAttribute])
				usingNamespaces: true
				validation: isValidating.
		idElement := document findElementNamed: 'c'.
		xmlIDElement := document findElementNamed: 'd'.
		self
			assert: (document findElementWithID: 'one') = idElement;
			assert: (idElement findElementWithID: 'one') = idElement;
			assert: (idElement nextElement findElementWithID: 'one') isNil;
			assert: (document findElementWithID: 'two') = xmlIDElement;
			assert: (xmlIDElement findElementWithID: 'two') = xmlIDElement;
			assert: (xmlIDElement nextElement findElementWithID: 'two') isNil;
			assert: (document findElementWithID: 'three') isNil.

		"remove them so they can't access the DTD anymore"
		document root
			removeNode: idElement;
			removeNode: xmlIDElement.
		self
			assert: (document findElementWithID: 'one') isNil;
			assert: (idElement findElementWithID: 'one') isNil;
			assert: (document findElementWithID: 'two') isNil;
			"xml:id is always an ID attribute, even without a DTD declaring it"
			assert: (xmlIDElement findElementWithID: 'two') = xmlIDElement].

	#(true false) do: [:isValidating |
		document :=
			XMLDOMParser
				parse: contentWithUndeclaredAttribute
				usingNamespaces: true
				validation: isValidating.
		xmlIDElement := document findElementNamed: 'd'.
		self
			assert: (document findElementWithID: 'one') isNil;
			"xml:id is always an ID attribute, even without a DTD declaring it"
			assert: (document findElementWithID: 'two') = xmlIDElement;
			assert: (xmlIDElement findElementWithID: 'two') = xmlIDElement].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:33'!
testFirstElement
	| root |

	root := self newNodeWithElements nodeAt: 2.
	root elements copy do: [:each |
		self assert: root firstElement = each.
		root removeNode: each].
	self assert: root firstElement isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:42'!
testHasContentNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self assert: nodeWithElements hasContentNodes.
	nodeWithElements allElementsDo: [:element |
		self assert: element hasContentNodes = element contentNodes notEmpty].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasElements
	self
		deny: self newNode hasElements;
		assert: self newNodeWithElements hasElements;
		deny: self newNodeWithElements removeNodes hasElements! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:41'!
testHasStringNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self deny: nodeWithElements hasStringNodes.
	nodeWithElements allElementsDo: [:element |
		self assert: element hasStringNodes = element stringNodes notEmpty].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/25/2014 00:02'!
testIncludesElement
	| root |
	
	root := self newNodeWithElements firstElement.
	self deny: (root includesElement: 'absent').
	root elements copy do: [:each |
		self assert: (root includesElement: each name).
		root removeNode: each.
		self deny: (root includesElement: each name)].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:21'!
testInnerXML
	| node element |

	node := self newNode.
	element :=
		node addNode:
			(self elementClass
				name: 'test'
				namespaces: (Array with: 'prefix'-> 'ns')).
	element innerXML: '<prefix:inner></prefix:inner>'.
	element firstNode innerXML: 'test<!!--comment-->'.
	self
		assert: element nodes size = 1;
		assert: (element firstNode isNamed: 'prefix:inner');
		assert: (element firstNode contentString = 'test');
		assert:
			node innerXML =
				'<test xmlns:prefix="ns"><prefix:inner>test</prefix:inner></test>';
		assert:
			element innerXML =
				'<prefix:inner xmlns:prefix="ns">test</prefix:inner>';
		assert: element firstNode innerXML = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/2/2016 04:58'!
testInnerXMLIsInContent
	| node parser |

	node := self newNodeWithElements.
	parser := XMLDOMParser on: '<content/>'.
	self deny: parser isInContent.

	node innerXMLParsedWith: parser.
	self
		assert: node nodes size = 1;
		assert: (node firstNode isElementNamed: 'content');
		deny: node firstNode hasChildren;
		assert: parser isInContent.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/22/2016 09:59'!
testInnerXMLPrettyPrinted
	| nodeWithElements printString prettyPrintString prettyNodeWithElements |

	nodeWithElements := self newNodeWithElements.
	"remove any whitespace formatting around elements
	(avoid descendantNodesDo: because we're removing)"
	nodeWithElements descendantNodes do: [:each |
		(each isStringNode
			and: [each isWhitespace])
			ifTrue: [each parent removeNode: each]].

	printString := nodeWithElements innerXML.
	prettyPrintString := nodeWithElements innerXMLPrettyPrinted.
	self deny: printString = prettyPrintString.

	prettyNodeWithElements :=
		(XMLDOMParser on: prettyPrintString)
			preservesCommentNodes: true;
			parseDocument.
	self
		assertElements: prettyNodeWithElements descendantElements
		werePrettyPrintFormattedFrom: nodeWithElements descendantElements! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/4/2016 01:29'!
testInnerXMLResetting
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [nodeWithElements firstElement innerXML: '<one><two></one></two>']
		raise: XMLWellFormednessException.
	self assert: nodeWithElements printString = self newNodeWithNodes printString.

	self
		should: [nodeWithElements firstElement innerXML: '<one>&invalid;</one>']
		raise: XMLWellFormednessException.
	self assert: nodeWithElements printString = self newNodeWithNodes printString.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsContentNode
	self assert: self newNode isContentNode! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:34'!
testLastElement
	| root |

	root := self newNodeWithElements nodeAt: 2.
	root elements reversed do: [:each |
		self assert: root lastElement = each.
		root removeNode: each].
	self assert: root lastElement isNil.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewCData
	| nodeWithElements cdata |

	super testNewCData.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				cdataClass: XMLFCData).
	cdata := nodeWithElements newCData: 'test'.
	self
		assert: cdata class == XMLFCData;
		assert: cdata string = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewComment
	| nodeWithElements comment |

	super testNewComment.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				commentClass: XMLFComment).
	comment := nodeWithElements newComment: 'test'.
	self
		assert: comment class == XMLFComment;
		assert: comment string = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewDocument
	| nodeWithElements document |

	super testNewDocument.

	(nodeWithElements := self newNode)
		 nodeFactory:
			(XMLPluggableNodeFactory new
				documentClass: XMLFDocument).
	document := nodeWithElements newDocument.
	self
		assert: document class == XMLFDocument;
		assert: document configuration == nodeWithElements configuration;
		assert: document nodeFactory == nodeWithElements nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:58'!
testNewElement
	| nodeWithElements element |

	super testNewElement.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				elementClass: self otherElementClass).
	element := nodeWithElements newElement.
	self
		assert: element class == self otherElementClass;
		assert: element configuration == nodeWithElements configuration;
		assert: element nodeFactory == nodeWithElements nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:58'!
testNewElementNamed
	| nodeWithElements element |

	super testNewElementNamed.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableElementFactory new
				handleElement: 'test' withClass: self otherElementClass).
	element := nodeWithElements newElementNamed: 'test'.
	self
		assert: element class == self otherElementClass;
		assert: element name = 'test';
		assert: element configuration == nodeWithElements configuration;
		assert: element nodeFactory == nodeWithElements nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:59'!
testNewElementNamedAttributes
	| nodeWithElements element |

	super testNewElementNamedAttributes.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableElementFactory new
				handleElement: 'test'
				attributes: self unprefixedAttributeAssociations
				withClass: self otherElementClass;
				attributeListClass: self otherAttributeListClass).
	element :=
		nodeWithElements
			newElementNamed: 'test'
			attributes: self unprefixedAttributeAssociations.
	self
		assert: element class == self otherElementClass;
		assert: element name = 'test';
		assert: element attributeNodes class == self otherAttributeListClass;
		assertElement: element hasAttributes: self unprefixedAttributes;
		assert: element configuration == nodeWithElements configuration;
		assert: element nodeFactory == nodeWithElements nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 12:08'!
testNewElementNamedNamespaceURI
	| nodeWithElements element |

	super testNewElementNamedNamespaceURI.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableElementFactory new
				handleElement: 'prefix:test'
				namespaceURI: 'prefixNS'
				withClass: self otherElementClass).
	element :=
		nodeWithElements
			newElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'.
	self
		assert: element class == self otherElementClass;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS';
		assert: element configuration == nodeWithElements configuration;
		assert: element nodeFactory == nodeWithElements nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/8/2016 09:59'!
testNewElementNamedNamespaceURIAttributes
	| nodeWithElements element |

	super testNewElementNamedNamespaceURIAttributes.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableElementFactory new
				handleElement: 'prefix:test'
				namespaceURI: 'prefixNS'
				attributes: self attributeAssociations
				withClass: self otherElementClass;
				attributeListClass: self otherAttributeListClass).
	element :=
		nodeWithElements
			newElementNamed: 'prefix:test'
			namespaceURI: 'prefixNS'
			attributes: self attributeAssociations.
	self
		assert: element class == self otherElementClass;
		assert: element name = 'prefix:test';
		assert: element namespaceURI = 'prefixNS';
		assert: element attributeNodes class == self otherAttributeListClass;
		assertElement: element hasAttributes: self attributes;
		assert: element configuration == nodeWithElements configuration;
		assert: element nodeFactory == nodeWithElements nodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewPI
	| nodeWithElements |

	super testNewPI.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				piClass: XMLFPI).
	self assert: nodeWithElements newPI class == XMLFPI.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewPITargetData
	| nodeWithElements pi |

	super testNewPITargetData.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				piClass: XMLFPI).
	pi :=
		nodeWithElements
			newPITarget: 'target'
			data: 'data'.
	self
		assert: pi class == XMLFPI;
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testNewStringNode
	| nodeWithElements stringNode |

	super testNewStringNode.

	(nodeWithElements := self newNode)
		nodeFactory:
			(XMLPluggableNodeFactory new
				stringNodeClass: XMLFString).
	stringNode := nodeWithElements newStringNode: 'test'.
	self
		assert: stringNode class == XMLFString;
		assert: stringNode string = 'test'.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:25'!
testNodeFactory
	| nodeWithElements oldNodeFactory newNodeFactory |

	nodeWithElements := self newNodeWithElements.
	oldNodeFactory := nodeWithElements nodeFactory.
	self assert: oldNodeFactory class == self nodeFactoryClass.

	newNodeFactory := self nodeFactoryClass new.
	self
		assert: (nodeWithElements nodeFactory: newNodeFactory) == nodeWithElements;
		assert: nodeWithElements nodeFactory == newNodeFactory.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 5/8/2015 05:38'!
testOuterXMLForNode
	| nodeWithElements root nodes |

	nodeWithElements := self newNodeWithElements.
	root := nodeWithElements firstElement.
	nodes := root nodes copy.
	nodes copy withIndexDo: [:each :i | | innerXML newNode |
		innerXML := '<new', i printString, '>test</new', i printString, '>'.
		root outerXML: innerXML forNode: each.
		newNode := root nodeAt: i.
		self
			assert: newNode printString = innerXML;
			deny: root nodes = nodes.
		nodes at: i put: newNode.
		self assert: root nodes = nodes].

	nodes copy do: [:each |
		root outerXML: '' forNode: each.
		self deny: root nodes = nodes.
		nodes remove: each.
		self assert: root nodes = nodes].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 3/4/2017 16:42'!
testOuterXMLForNodeResetting
	| nodeWithElements root |

	nodeWithElements := self newNodeWithElements.
	root := nodeWithElements firstElement.
	self
		should: [
			root
				outerXML: '<one><two></one></two>'
				forNode: root firstNode]
		raise: XMLWellFormednessException.
	self assert: nodeWithElements printString = self newNodeWithNodes printString.

	self
		should: [
			root
				outerXML: '<one>&invalid;</one>'
				forNode: root firstNode]
		raise: XMLWellFormednessException.
	self assert: nodeWithElements printString = self newNodeWithNodes printString.

	self
		should: [
			root
				outerXML: '<one />'
				forNode: self nodeClass new]
		raise: XMLDOMException.
	self assert: nodeWithElements printString = self newNodeWithNodes printString.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 9/22/2016 09:59'!
testPrettyPrinted
	| nodeWithElements printString prettyPrintString prettyNodeWithElements |

	nodeWithElements := self newNodeWithElements.
	"remove any whitespace formatting around elements
	(avoid #allNodesDo: because we're removing)"
	nodeWithElements allNodes do: [:each |
		(each isStringNode
			and: [each isWhitespace])
			ifTrue: [each parent removeNode: each]].

	printString := nodeWithElements printString.
	prettyPrintString := nodeWithElements prettyPrinted.
	self deny: printString = prettyPrintString.

	prettyNodeWithElements :=
		(XMLDOMParser on: prettyPrintString)
			preservesCommentNodes: true;
			parseDocument.
	self
		assertElements: prettyNodeWithElements allElements
		werePrettyPrintFormattedFrom: nodeWithElements allElements.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/14/2015 05:21'!
testPrintedWithoutSelfClosingTags
	| nodeWithElements printString printStringWithoutSelfClosingTags |

	nodeWithElements := self newNodeWithElements.
	printString := nodeWithElements printString.
	printStringWithoutSelfClosingTags := nodeWithElements printedWithoutSelfClosingTags.
	self deny: printString = printStringWithoutSelfClosingTags.

	nodeWithElements allElementsDo: [:each |
		each hasChildren
			ifFalse: [
				printString :=
					printString
						copyReplaceAll: '<', each name, ' />'
						with: '<', each name, '></', each name, '>']].
	self assert: printString = printStringWithoutSelfClosingTags.! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 2/2/2015 16:35'!
testRawContentString
	self assert: self newNodeWithElements rawContentString = 'testing onetesting twotesting three'! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 4/20/2016 11:04'!
testRawContentStringAt
	| root |

	root := self newNodeWithElements firstElement.
	root elementsDo: [:each |
		self assert: (root rawContentStringAt: each name) = each rawContentString].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:24'!
testStringNodes
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements stringNodes
		selects: (nodeWithElements nodes select: [:each | each isStringNode]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element stringNodes
			selects: (element nodes select: [:each | each isStringNode])].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:23'!
testStringNodesDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements stringNodesDo: block]
		enumerate: nodeWithElements stringNodes.
	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each stringNodesDo: block]
			enumerate: each stringNodes].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:26'!
testStrings
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		assertList: nodeWithElements strings
		collects: (nodeWithElements stringNodes collect: [:each | each string]).
	nodeWithElements allElementsDo: [:element |
		self
			assertList: element strings
			collects: (element stringNodes collect: [:each | each string]).].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 11/24/2014 05:27'!
testStringsDo
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self
		should: [:block | nodeWithElements stringsDo: block]
		enumerate: nodeWithElements strings.
	nodeWithElements allElementsDo: [:each |
		self
			should: [:block | each stringsDo: block]
			enumerate: each strings].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 8/21/2017 03:15'!
testUsesNamespaces
	| nodeWithElements |

	nodeWithElements := self newNodeWithElements.
	self assert: nodeWithElements usesNamespaces.
	nodeWithElements allElementsDo: [:each |
		self assert: each usesNamespaces].

	self
		assert: (nodeWithElements usesNamespaces: false) == nodeWithElements;
		deny: nodeWithElements usesNamespaces.
	nodeWithElements allElementsDo: [:each |
		self deny: each usesNamespaces.
		self
			shouldnt: [each prefix: 'undeclared']
			raise: XMLNamespaceException].

	self
		assert: (nodeWithElements usesNamespaces: true) == nodeWithElements;
		assert: nodeWithElements usesNamespaces.
	nodeWithElements allElementsDo: [:each |
		self assert: each usesNamespaces.
		self
			should: [each prefix: 'undeclaredTwo']
			raise: XMLNamespaceException].! !

!XMLNodeWithElementsTest methodsFor: 'tests' stamp: 'monty 4/6/2015 06:54'!
testValidate
	super testValidate.
	self
		shouldnt: [self newNodeWithNodes validate]
		raise: XMLValidationException.! !

XMLNodeTest subclass: #XMLPITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLPITest methodsFor: 'instance creation' stamp: 'monty 9/5/2016 21:18'!
newPIWithTargetAndData
	^ self nodeClass
		target: 'target'
		data: 'data'! !

!XMLPITest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:18'!
nodeClass
	^ XMLPI! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAcceptNodeVisitor
	| visitor pi message |

	visitor := XMLRecordingNodeVisitor new.
	pi := self newNode.
	self
		assert: (pi acceptNodeVisitor: visitor) == pi;
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitPI:;
		assert: message arguments = (Array with: pi);
		deny: visitor messageRecorder hasMessages.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:19'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self assert:
		(self newPIWithTargetAndData canonicallyEquals:
			self newPIWithTargetAndData).
	self deny:
		(self newPIWithTargetAndData canonicallyEquals:
			self newNode).! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:17'!
testData
	| pi |

	pi := self newNode.
	self
		assert: pi data = '';
		assert: (pi data: 'test') == pi;
		assert: pi data = 'test'.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 11/8/2016 10:40'!
testHasData
	| pi |

	pi := self newNode.
	self deny: pi hasData.

	pi data: 'data'.
	self assert: pi hasData.

	pi data: ''.
	self deny: pi hasData.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsPI
	self assert: self newNode isPI! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:28'!
testSortKey
	self assert: self newPIWithTargetAndData sortKey = 'target'! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:17'!
testTarget
	| pi |

	pi := self newNode.
	self
		assert: pi target = '';
		assert: (pi target: 'test') == pi;
		assert: pi target = 'test'.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 8/26/2016 21:41'!
testTargetData
	| pi |

	pi :=
		self nodeClass
			target: 'target'
			data: 'data'.
	self
		assert: pi class == self nodeClass;
		assert: pi target = 'target';
		assert: pi data = 'data'.! !

!XMLPITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:21'!
testWriteXMLOn
	| pi |

	pi := self newPIWithTargetAndData.
	self assert: pi printString = '<?target data?>'.

	pi data: ' ', pi data.
	self assert: pi printString = '<?target  data?>'.! !

XMLNodeTest subclass: #XMLStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLStringTest subclass: #XMLCDataTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLCDataTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:17'!
nodeClass
	^ XMLCData! !

!XMLCDataTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAcceptNodeVisitor
	| visitor cdata message |

	visitor := XMLRecordingNodeVisitor new.
	cdata := self newNode.
	self
		assert: (cdata acceptNodeVisitor: visitor) == cdata;
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitCData:;
		assert: message arguments = (Array with: cdata);
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitStringNode:;
		assert: message arguments = (Array with: cdata);
		deny: visitor messageRecorder hasMessages.! !

!XMLCDataTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsCData
	self assert: self newNode isCData! !

!XMLCDataTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testWriteXMLOn
	self
		assert: self newNode printString = '<!![CDATA[]]>';
		assert: (self nodeClass string: self markupString) printString = ('<!![CDATA[', self markupString, ']]>').! !

!XMLStringTest methodsFor: 'accessing' stamp: 'monty 11/2/2014 11:18'!
nodeClass
	^ XMLString! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAcceptNodeVisitor
	| visitor stringNode message |

	visitor := XMLRecordingNodeVisitor new.
	stringNode := self newNode.
	self
		assert: (stringNode acceptNodeVisitor: visitor) == stringNode;
		assert: visitor messageRecorder hasMessages.

	message := visitor messageRecorder nextMessage.
	self
		assert: message selector == #visitStringNode:;
		assert: message arguments = (Array with: stringNode);
		deny: visitor messageRecorder hasMessages.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAppend
	| stringNode |

	stringNode := self newNode.
	stringNode append: 'one'.
	self assert: stringNode string = 'one'.

	stringNode append: (self nodeClass string: 'two').
	self assert: stringNode string = 'onetwo'.

	stringNode append: 'three'.
	self assert: stringNode string = 'onetwothree'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:15'!
testAsString
	self
		assert: self newNode asString = '';
		assert: (self nodeClass string: 'test') asString = 'test'! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 7/28/2016 09:41'!
testAsXMLEscapedString
	| stringNode |

	stringNode := self nodeClass string: self markupString.
	self	
		assert: stringNode string = self markupString;
		deny: stringNode string = self escapedString;
		assert: stringNode asXMLEscapedString = self escapedString.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testAsXMLStringNode
	| stringNode |

	stringNode := self newNode.
	self assert: stringNode asXMLStringNode == stringNode.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 7/28/2016 09:46'!
testBeginsWith
	| stringNode |

	stringNode := self nodeClass string: 'test'.
	0 to: stringNode string size - 1 do: [:i | | prefix |
		prefix := stringNode string allButLast: i.
		self
			assert: (stringNode beginsWith: prefix);
			assert: (stringNode beginsWith: (self nodeClass string: prefix));
			deny: (stringNode beginsWith: (prefix copyWith: $.));
			deny: (stringNode beginsWith: (self nodeClass string: (prefix copyWith: $.)))].! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:00'!
testCanonicallyEquals
	super testCanonicallyEquals.
	self assert:
		((self nodeClass string: 'test') canonicallyEquals:
			(self nodeClass string: 'test')).
	self deny:
		((self nodeClass string: 'test') canonicallyEquals:
			self newNode).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:15'!
testDeleteFromTo
	| stringNode |

	stringNode := self newNode.
	stringNode deleteFrom: 1 to: 0.
	self assert: stringNode string = ''.

	stringNode append: 'onetwothree'.
	stringNode deleteFrom: 0 to: -1.
	stringNode deleteFrom: 12 to: 13.
	self assert: stringNode string = 'onetwothree'.

	stringNode deleteFrom: 4 to: 6.
	self assert: stringNode string = 'onethree'.

	stringNode deleteFrom: 4 to: 8.
	self assert: stringNode string = 'one'.

	stringNode deleteFrom: 1 to: 3.
	self assert: stringNode string = ''.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 7/28/2016 09:48'!
testEndsWith
	| stringNode |

	stringNode := self nodeClass string: 'test'.
	0 to: stringNode string size - 1 do: [:i | | suffix |
		suffix := stringNode string allButFirst: i.
		self
			assert: (stringNode endsWith: suffix);
			assert: (stringNode endsWith: (self nodeClass string: suffix));
			deny: (stringNode endsWith: (suffix copyWithFirst: $.));
			deny: (stringNode endsWith: (self nodeClass string: (suffix copyWithFirst: $.)))].! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIncludesSubstring
	| stringNode |

	stringNode := self newNode.
	self
		assert: (stringNode includesSubstring: '');
		assert: (stringNode includesSubstring: (self nodeClass string: ''));
		deny: (stringNode includesSubstring: 'one');
		deny: (stringNode includesSubstring: (self nodeClass string: 'one')).
	stringNode prepend: 'one'.
	self
		assert: (stringNode includesSubstring: 'one');
		assert: (stringNode includesSubstring: (self nodeClass string: 'one')).

	self
		deny: (stringNode includesSubstring: 'three');
		deny: (stringNode includesSubstring: (self nodeClass string: 'three')).
	stringNode append: 'three'.
	self
		assert: (stringNode includesSubstring: 'three');
		assert: (stringNode includesSubstring: (self nodeClass string: 'three')).

	self
		deny: (stringNode includesSubstring: 'two');
		deny: (stringNode includesSubstring: (self nodeClass string: 'two')).
	stringNode replaceFrom: 4 to: 3 with: 'two'.
	self
		assert: (stringNode includesSubstring: 'two');
		assert: (stringNode includesSubstring: (self nodeClass string: 'two')).

	self
		assert: (stringNode includesSubstring: '');
		assert: (stringNode includesSubstring: (self nodeClass string: '')).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIndexOfSubstring
	| stringNode |

	stringNode := self newNode.
	self
		assert: (stringNode indexOfSubstring: 'one') isZero;
		assert: (stringNode indexOfSubstring: (self nodeClass string: 'one')) isZero.
	stringNode prepend: 'one'.
	self
		assert: (stringNode indexOfSubstring: 'one') = 1;
		assert: (stringNode indexOfSubstring: (self nodeClass string: 'one')) = 1.

	self
		assert: (stringNode indexOfSubstring: 'two') isZero;
		assert: (stringNode indexOfSubstring: (self nodeClass string: 'two')) isZero.
	stringNode append: 'two'.
	self
		assert: (stringNode indexOfSubstring: 'two') = 4;
		assert: (stringNode indexOfSubstring: (self nodeClass string: 'two')) = 4.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsContentNode
	self assert: self newNode isContentNode! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/8/2016 10:38'!
testIsEmpty
	| node |

	node := self newNode.
	self assert: node isEmpty.

	node string: ' '.
	self deny: node isEmpty.

	node string: ''.
	self assert: node isEmpty.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/8/2016 10:37'!
testIsStringNode
	| stringNode |

	self assert: self newNode isStringNode.

	stringNode := self newNode.
	self
		assert: (stringNode isStringNode: '');
		assert: (stringNode isStringNode: self newNode);
		deny: (stringNode isStringNode: 'test');
		deny: (stringNode isStringNode: (self nodeClass string: 'test')).

	stringNode string: 'test'.
	self
		assert: (stringNode isStringNode: 'test');
		assert: (stringNode isStringNode: (self nodeClass string: 'test'));
		deny: (stringNode isStringNode: '');
		deny: (stringNode isStringNode: self newNode).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsWhitespace
	| stringNode |

	stringNode := self newNode.
	self deny: stringNode isWhitespace.

	stringNode string: Character xmlWhitespace.
	self assert: stringNode isWhitespace.

	stringNode append: 'non-space'.
	self deny: stringNode isWhitespace.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/1/2016 21:18'!
testMergeAdjacent
	| element nodes |

	(element := self newElement)
		addNode: (self nodeClass string: 'one');
		addNode: (self nodeClass string: 'two');
		addNode: (self nodeClass string: 'three');
		addNode: XMLComment new;
		addNode: (self nodeClass string: 'four');
		addNode: (self nodeClass string: 'five');
		addNode: XMLComment new;
		addNode: (self nodeClass string: 'six').

	element nodes second mergeAdjacent.
	nodes := element nodes.
	self
		assert: nodes size = 6;
		assert: (nodes first isStringNode and: [nodes first string = 'onetwothree']);
		assert: nodes second isComment;
		assert: (nodes third isStringNode and: [nodes third string = 'four']);
		assert: (nodes fourth isStringNode and: [nodes fourth string = 'five']);
		assert: nodes fifth isComment;
		assert: (nodes sixth isStringNode and: [nodes sixth string = 'six']).

	nodes fourth mergeAdjacent.
	nodes fifth mergeAdjacent.
	self
		assert: nodes size = 5;
		assert: (nodes first isStringNode and: [nodes first string = 'onetwothree']);
		assert: nodes second isComment;
		assert: (nodes third isStringNode and: [nodes third string = 'fourfive']);
		assert: nodes fourth isComment;
		assert: (nodes fifth isStringNode and: [nodes fifth string = 'six']).! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 11/8/2016 10:39'!
testNotEmpty
	| node |

	node := self newNode.
	self deny: node notEmpty.

	node string: ' '.
	self assert: node notEmpty.

	node string: ''.
	self deny: node notEmpty.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testPrepend
	| stringNode |

	stringNode := self newNode.
	stringNode prepend: 'three'.
	self assert: stringNode string = 'three'.

	stringNode prepend: (self nodeClass string: 'two').
	self assert: stringNode string = 'twothree'.

	stringNode prepend: 'one'.
	self assert: stringNode string = 'onetwothree'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:15'!
testReplaceAllWith
	| stringNode |

	(stringNode := self newNode) replaceAll: 'old' with: 'new'.
	self assert: stringNode string = ''.

	stringNode string: 'one old two old three old'.
	stringNode replaceAll: 'old' with: (self nodeClass string: 'new').
	self assert: stringNode string = 'one new two new three new'.

	stringNode replaceAll: 'new' with: ''.
	self assert: stringNode string = 'one  two  three '.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testReplaceFromToWith
	| stringNode |

	(stringNode := self newNode) replaceFrom: -1 to: -3 with: 'one'.
	self assert: stringNode string = 'one'.

	stringNode replaceFrom: 1 to: 0 with: 'zero'.
	self assert: stringNode string = 'zeroone'.

	stringNode replaceFrom: 9 to: 7 with: (self nodeClass string: 'fourthree').
	self assert: stringNode string = 'zeroonefourthree'.

	stringNode replaceFrom: 8 to: 11 with: ' two '.
	self assert: stringNode string = 'zeroone two three'.

	stringNode replaceFrom: 0 to: 4 with: ''.
	self assert: stringNode string = 'one two three'.

	stringNode replaceFrom: 14 to: 13 with: (self nodeClass string: ' four').
	self assert: stringNode string = 'one two three four'.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testSize
	self
		assert: self newNode size = 0;
		assert: (self nodeClass string: 'test') size = 4! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 12/2/2014 22:59'!
testSortKey
	self assert: (self nodeClass string: 'test') sortKey = 'test'! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:16'!
testSplitAt
	| stringNode newStringNode element |

	stringNode := self nodeClass string: 'onetwo'.
	newStringNode := stringNode splitAt: 0.
	self
		deny: stringNode == newStringNode;
		assert: stringNode string = '';
		assert: newStringNode string = 'onetwo'.

	stringNode := self nodeClass string: 'onetwo'.
	newStringNode := stringNode splitAt: 7.
	self
		deny: stringNode == newStringNode;
		assert: stringNode string = 'onetwo';
		assert: newStringNode string = ''.

	(element := self newElement) addNode: stringNode.
	newStringNode := stringNode splitAt: 4.
	self
		deny: stringNode == newStringNode;
		assert: stringNode string = 'one';
		assert: newStringNode string = 'two';
		assert: (element nodeAfter: stringNode) == newStringNode.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:16'!
testString
	| stringNode |

	stringNode := self nodeClass string: self markupString.
	self
		assert: stringNode class == self nodeClass;
		assert: stringNode string = self markupString.

	stringNode := self newNode.
	self assert: stringNode string = ''.

	stringNode string: self markupString.
	self assert: stringNode string = self markupString.

	stringNode string: ''.
	self assert: stringNode string = ''.! !

!XMLStringTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:37'!
testWriteXMLOn
	self assert: self newNode printString = ''.
	self assert:
		(self nodeClass string: self markupString) printString =
			self escapedString.! !

TestCase subclass: #XMLNullReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLNullReadStreamTest methodsFor: 'instance creation' stamp: 'monty 11/22/2016 23:38'!
newStream
	^ self streamClass new! !

!XMLNullReadStreamTest methodsFor: 'accessing' stamp: 'monty 11/22/2016 23:38'!
streamClass
	^ XMLNullReadStream! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:39'!
testAtEnd
	self assert: self newStream atEnd! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:42'!
testClose
	| stream |

	stream := self newStream.
	self
		shouldnt: [
			stream
				close;
				close]
		raise: Error.! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:47'!
testContents
	| stream |

	stream := self newStream.
	self
		assert: stream contents = '';
		assert: stream contents = ''.! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:41'!
testIsBinary
	self deny: self newStream isBinary! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:39'!
testIsStream
	self assert: self newStream isStream! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:40'!
testNext
	| stream |

	stream := self newStream.
	self
		assert: stream next isNil;
		assert: stream next isNil.! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:40'!
testPeek
	| stream |

	stream := self newStream.
	self assert: stream peek isNil.

	stream next.
	self assert: stream peek isNil.! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:49'!
testPosition
	| stream |

	stream := self newStream.
	self
		assert: stream position = 0;
		assert: (stream position: 1) == stream;
		assert: stream position = 0.! !

!XMLNullReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:47'!
testUpToEnd
	| stream |

	stream := self newStream.
	self
		assert: stream upToEnd = '';
		assert: stream upToEnd = ''.! !

TestCase subclass: #XMLOrderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLOrderedListTest subclass: #XMLObservableListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLObservableListTest subclass: #XMLAttributeListTest
	instanceVariableNames: 'attributes newAttribute absentAttribute changedAttributes prefixedAttribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/5/2016 04:21'!
absentListItem
	^ absentAttribute
		ifNil: [
			absentAttribute :=
				self attributeClass
					name: 'absentName'
					value: 'absentValue']! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:06'!
afterAddingToNotifications
	^ #(addedAttribute:)! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:06'!
afterRemovingFromNotifications
	^ #(removedAttribute:)! !

!XMLAttributeListTest methodsFor: 'testing' stamp: 'monty 1/18/2015 11:26'!
allowsDuplicates
	^ false! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 20:36'!
attributeAssociations
	^ self listItems collect: [:each | each name -> each value]! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/5/2016 04:21'!
attributeClass
	^ XMLAttribute! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 19:25'!
attributeNames
	^ self listItems collect: [:each | each name]! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 19:30'!
attributeValues
	^ self listItems collect: [:each | each value]! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 7/2/2017 02:10'!
attributesClass
	^ OrderPreservingStringDictionary! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/5/2016 04:21'!
changedListItem: anAttribute
	^ (changedAttributes ifNil: [changedAttributes := IdentityDictionary new])
		at: anAttribute
		ifAbsentPut: [
			self attributeClass
				name: 'new', anAttribute name
				value: 'new', anAttribute value]! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:07'!
listClass
	^ XMLAttributeList! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/5/2016 04:21'!
listItems
	attributes ifNil: [
		attributes :=
			super listItems collect: [:each |
				self attributeClass
					name: each
					value: each]].
	^ attributes copy.! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/5/2016 04:21'!
newListItem
	^ newAttribute
		ifNil: [
			newAttribute :=
				self attributeClass
					name: 'newName'
					value: 'newValue']! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:12'!
observerClass
	^ XMLRecordingAttributeListObserver! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 8/27/2016 20:57'!
prefixedAttribute
	^ prefixedAttribute
		ifNil: [prefixedAttribute := self newListItem copy prefix: 'prefix']! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:25'!
reverseSortBlock
	^ [:a :b | a sortKey > b sortKey]! !

!XMLAttributeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:25'!
sortBlock
	^ [:a :b | a sortKey <= b sortKey]! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:17'!
testAddAttributeAssociation
	| list |

	list := self emptyList.
	self listItems do: [:each | | attribute |
		self assert: (list attributeNodeAt: each name) = self defaultValue.
		attribute := list addAttributeAssociation: each name -> each value.
		self
			assert: attribute class == self attributeClass;
			assert: attribute name = each name;
			assert: attribute value = each value;
			assert: (list attributeNodeAt: each name) = attribute].! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:18'!
testAddAttributeNameValue
	| list |

	list := self emptyList.
	self listItems do: [:each | | attribute |
		self assert: (list attributeNodeAt: each name)  = self defaultValue.
		attribute :=
			list
				addAttributeName: each name
				value: each value.
		self
			assert: attribute class == self attributeClass;
			assert: attribute name = each name;
			assert: attribute value = each value;
			assert: (list attributeNodeAt: each name) = attribute].! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:41'!
testAsDictionary
	| list dictionary |

	list := self listWithItems.
	dictionary := list asDictionary.
	self
		assert: dictionary class == self attributesClass;
		assert:
			dictionary =
				(self attributesClass newFrom: self attributeAssociations).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:41'!
testAttributeAssociations
	| list |

	list := self listWithItems.
	self
		assertList: list attributeAssociations
		collectedFrom: list
		equals: (self listSpecies newFrom: self attributeAssociations).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/6/2016 00:46'!
testAttributeAt
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert: (list attributeAt: each name) = ''.
	
		list add: each.
		self assert: (list attributeAt: each name) = each value].

	self
		assert: (list attributeAt: self prefixedAttribute name) = '';
		assert: (list attributeAt: self prefixedAttribute localName) = ''.

	list add: self prefixedAttribute.
	self assert:
		(list attributeAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeAt: self prefixedAttribute localName) =
			''.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:31'!
testAttributeAtIfAbsent
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert:
			(list
				attributeAt: each name
				ifAbsent: [self absentListItem value]) = self absentListItem value.
	
		list add: each.
		self assert:
			(list
				attributeAt: each name
				ifAbsent: [self fail]) = each value].

	self assert:
		(list
			attributeAt: self prefixedAttribute name
			ifAbsent: [self absentListItem value]) = self absentListItem value.
	self assert:
		(list
			attributeAt: self prefixedAttribute localName
			ifAbsent: [self absentListItem value]) = self absentListItem value.

	list add: self prefixedAttribute.
	self assert:
		(list
			attributeAt: self prefixedAttribute name
			ifAbsent: [self fail]) = self prefixedAttribute value.
	self assert:
		(list
			attributeAt: self prefixedAttribute localName
			ifAbsent: [self absentListItem value]) = self absentListItem value.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:29'!
testAttributeAtIfAbsentPut
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert:
			(list
				attributeAt: each name
				ifAbsentPut: [each value]) = each value.
		self assert: (list attributeAt: each name) = each value.

		self assert:
			(list
				attributeAt: each name
				ifAbsentPut: [self fail]) = each value.
		self assert: (list attributeAt: each name) = each value].

	self assert:
		(list
			attributeAt: self prefixedAttribute name
			ifAbsentPut: [self prefixedAttribute value]) = self prefixedAttribute value.
	self assert:
		(list
			attributeAt: self prefixedAttribute localName
			ifAbsentPut: [self newListItem value]) = self newListItem value.
	self assert:
		(list attributeAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeAt: self prefixedAttribute localName) =
			self newListItem value.

	self assert:
		(list
			attributeAt: self prefixedAttribute name
			ifAbsentPut: [self fail]) = self prefixedAttribute value.
	self assert:
		(list
			attributeAt: self prefixedAttribute localName
			ifAbsentPut: [self fail]) = self newListItem value.
	self assert:
		(list attributeAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeAt: self prefixedAttribute localName) =
			self newListItem value.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 21:19'!
testAttributeAtPut
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert:
			(list
				attributeAt: each name
				put: each value) = each value.
		self assert: (list attributeAt: each name) = each value].

	self assert:
		(list
			attributeAt: self prefixedAttribute name
			put: self prefixedAttribute value) = self prefixedAttribute value.
	self assert:
		(list
			attributeAt: self prefixedAttribute localName
			put: self newListItem value) = self newListItem value.
	self assert:
		(list attributeAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeAt: self prefixedAttribute localName) =
			self newListItem value.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:41'!
testAttributeNames
	| list |

	list := self listWithItems.
	self
		assertList: list attributeNames
		collectedFrom: list
		equals: (self listSpecies newFrom: self attributeNames).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:32'!
testAttributeNamesAndValuesDo
	| list |

	list := self emptyList.
	self
		should: [:twoArgumentBlock |
			list attributeNamesAndValuesDo: twoArgumentBlock]
		enumerate: #()
		and: #().

	list := self listWithItems.
	self
		should: [:twoArgumentBlock |
			list attributeNamesAndValuesDo: twoArgumentBlock]
		enumerate: self attributeNames
		and: self attributeValues.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:32'!
testAttributeNamesDo
	| list |

	list := self emptyList.
	self
		should: [:block | list attributeNamesDo: block]
		enumerate: #().

	list := self listWithItems.
	self
		should: [:each | list attributeNamesDo: each]
		enumerate: self attributeNames.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 11:41'!
testAttributeNodeAt
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert: (list attributeNodeAt: each name) = self defaultValue.
	
		list add: each.
		self assert: (list attributeNodeAt: each name) = each].

	self
		assert: (list attributeNodeAt: self prefixedAttribute name) = self defaultValue;
		assert: (list attributeNodeAt: self prefixedAttribute localName) = self defaultValue.

	list add: self prefixedAttribute.
	self
		assert: (list attributeNodeAt: self prefixedAttribute name) = self prefixedAttribute;
		assert: (list attributeNodeAt: self prefixedAttribute localName) = self prefixedAttribute.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:18'!
testAttributeNodeAtIfAbsent
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert:
			(list
				attributeNodeAt: each name
				ifAbsent: [self absentListItem]) = self absentListItem.
	
		list add: each.
		self assert:
			(list
				attributeNodeAt: each name
				ifAbsent: [self fail]) = each].

	self assert:
		(list
			attributeNodeAt: self prefixedAttribute name
			ifAbsent: [self absentListItem]) = self absentListItem.
	self assert:
		(list
			attributeNodeAt: self prefixedAttribute localName
			ifAbsent: [self absentListItem]) = self absentListItem.

	list add: self prefixedAttribute.
	self assert:
		(list
			attributeNodeAt: self prefixedAttribute name
			ifAbsent: [self fail]) = self prefixedAttribute.
	self assert:
		(list
			attributeNodeAt: self prefixedAttribute localName
			ifAbsent: [self fail]) = self prefixedAttribute.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/6/2016 00:47'!
testAttributeValueAt
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert: (list attributeValueAt: each name) = ''.
	
		list add: each.
		self assert: (list attributeValueAt: each name) = each value].

	self
		assert: (list attributeValueAt: self prefixedAttribute name) = '';
		assert: (list attributeValueAt: self prefixedAttribute localName) = ''.

	list add: self prefixedAttribute.
	self assert:
		(list attributeValueAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeValueAt: self prefixedAttribute localName) =
			''.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:31'!
testAttributeValueAtIfAbsent
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert:
			(list
				attributeValueAt: each name
				ifAbsent: [self absentListItem value]) = self absentListItem value.
	
		list add: each.
		self assert:
			(list
				attributeValueAt: each name
				ifAbsent: [self fail]) = each value].

	self assert:
		(list
			attributeValueAt: self prefixedAttribute name
			ifAbsent: [self absentListItem value]) = self absentListItem value.
	self assert:
		(list
			attributeValueAt: self prefixedAttribute localName
			ifAbsent: [self absentListItem value]) = self absentListItem value.

	list add: self prefixedAttribute.
	self assert:
		(list
			attributeValueAt: self prefixedAttribute name
			ifAbsent: [self fail]) = self prefixedAttribute value.
	self assert:
		(list
			attributeValueAt: self prefixedAttribute localName
			ifAbsent: [self absentListItem value]) = self absentListItem value.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:32'!
testAttributeValueAtIfAbsentPut
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert:
			(list
				attributeValueAt: each name
				ifAbsentPut: [each value]) = each value.
		self assert: (list attributeValueAt: each name) = each value.

		self assert:
			(list
				attributeValueAt: each name
				ifAbsentPut: [self fail]) = each value.
		self assert: (list attributeValueAt: each name) = each value].

	self assert:
		(list
			attributeValueAt: self prefixedAttribute name
			ifAbsentPut: [self prefixedAttribute value]) = self prefixedAttribute value.
	self assert:
		(list
			attributeValueAt: self prefixedAttribute localName
			ifAbsentPut: [self newListItem value]) = self newListItem value.
	self assert:
		(list attributeValueAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeValueAt: self prefixedAttribute localName) =
			self newListItem value.

	self assert:
		(list
			attributeValueAt: self prefixedAttribute name
			ifAbsentPut: [self fail]) = self prefixedAttribute value.
	self assert:
		(list
			attributeValueAt: self prefixedAttribute localName
			ifAbsentPut: [self fail]) = self newListItem value.
	self assert:
		(list attributeValueAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeValueAt: self prefixedAttribute localName) =
			self newListItem value.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 21:19'!
testAttributeValueAtPut
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self assert:
			(list
				attributeValueAt: each name
				put: each value) = each value.
		self assert: (list attributeValueAt: each name) = each value].

	self assert:
		(list
			attributeValueAt: self prefixedAttribute name
			put: self prefixedAttribute value) = self prefixedAttribute value.
	self assert:
		(list
			attributeValueAt: self prefixedAttribute localName
			put: self newListItem value) = self newListItem value.
	self assert:
		(list attributeValueAt: self prefixedAttribute name) =
			self prefixedAttribute value.
	self assert:
		(list attributeValueAt: self prefixedAttribute localName) =
			self newListItem value.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:42'!
testAttributes
	| list dictionary |

	list := self listWithItems.
	dictionary := list attributes.
	self
		assert: dictionary class == self attributesClass;
		assert:
			dictionary =
				(self attributesClass newFrom: self attributeAssociations).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 21:07'!
testIncludesAttribute
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self deny: (list includesAttribute: each name).

		list add: each.
		self assert: (list includesAttribute: each name)].

	self
		deny: (list includesAttribute: self prefixedAttribute name);
		deny: (list includesAttribute: self prefixedAttribute localName).

	list add: self prefixedAttribute.
	self
		assert: (list includesAttribute: self prefixedAttribute name);
		deny: (list includesAttribute: self prefixedAttribute localName).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 21:08'!
testIncludesAttributeNode
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self deny: (list includesAttributeNode: each name).

		list add: each.
		self assert: (list includesAttributeNode: each name)].

	self
		deny: (list includesAttributeNode: self prefixedAttribute name);
		deny: (list includesAttributeNode: self prefixedAttribute localName).

	list add: self prefixedAttribute.
	self
		assert: (list includesAttributeNode: self prefixedAttribute name);
		assert: (list includesAttributeNode: self prefixedAttribute localName).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 21:15'!
testIncludesAttributeNodeNamespaceURI
	| list |

	list := self emptyList.
	self listItems do: [:each |
		self deny:
			(list
				includesAttributeNode: each name
				namespaceURI: 'defaultNS').

		list add: each.
		self deny:
			(list
				includesAttributeNode: each name
				namespaceURI: 'defaultNS').
		self assert:
			(list
				includesAttributeNode: each name
				namespaceURI: '')].

	self deny:
		(list
			includesAttributeNode: self prefixedAttribute name
			namespaceURI: 'defaultNS').
	self deny:
		(list
			includesAttributeNode: self prefixedAttribute localName
			namespaceURI: 'defaultNS').
	self deny:
		(list
			includesAttributeNode: self prefixedAttribute name
			namespaceURI: '').
	self deny:
		(list
			includesAttributeNode: self prefixedAttribute localName
			namespaceURI: '').

	list add: self prefixedAttribute.
	self deny:
		(list
			includesAttributeNode: self prefixedAttribute name
			namespaceURI: 'defaultNS').
	self deny:
		(list
			includesAttributeNode: self prefixedAttribute localName
			namespaceURI: 'defaultNS').
	self assert:
		(list
			includesAttributeNode: self prefixedAttribute name
			namespaceURI: '').
	self assert:
		(list
			includesAttributeNode: self prefixedAttribute localName
			namespaceURI: '').! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 21:57'!
testRemoveAttribute
	| list |

	list := self listWithItems.
	self listItems do: [:each |
		self
			assert: (list removeAttribute: each name) = each value;
			deny: (list includes: each).
	
		self
			should: [list removeAttribute: each name]
			raise: Error].

	list add: self prefixedAttribute.
	self
		should: [list removeAttribute: self prefixedAttribute localName]
		raise: Error.
	self assert: (list includes: self prefixedAttribute).
	self assert:
		(list removeAttribute: self prefixedAttribute name) =
			self prefixedAttribute value.
	self deny: (list includes: self prefixedAttribute).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:36'!
testRemoveAttributeIfAbsent
	| list |

	list := self listWithItems.
	self listItems do: [:each |
		self assert:
			(list
				removeAttribute: each name
				ifAbsent: [self fail]) = each value.
		self deny: (list includes: each).
	
		self assert:
			(list
				removeAttribute: each name
				ifAbsent: [self absentListItem value]) = self absentListItem value].

	list add: self prefixedAttribute.
	self assert:
		(list
			removeAttribute: self prefixedAttribute localName
			ifAbsent: [self absentListItem value]) = self absentListItem value.
	self assert: (list includes: self prefixedAttribute).
	self assert:
		(list
			removeAttribute: self prefixedAttribute name
			ifAbsent: [self fail]) = self prefixedAttribute value.
	self deny: (list includes: self prefixedAttribute).! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/5/2016 08:56'!
testSetAttributes
	| list associations |

	list := self emptyList.
	associations := self attributeAssociations.
	self
		assert: (list setAttributes: associations) == list;
		assert: list attributeAssociations asArray = associations asArray.

	associations :=
		self changedListItems collect: [:each | each name -> each value].
	self
		assert: (list setAttributes: associations) == list;
		assert: list attributeAssociations asArray = associations asArray.! !

!XMLAttributeListTest methodsFor: 'tests' stamp: 'monty 9/5/2016 08:46'!
testSetAttributesFromOrderPreservingDictionary
	| element list dictionary |

	element := XMLElement new.
	list := self listClass observer: element.
	dictionary := OrderPreservingDictionary newFrom: self attributeAssociations.
	self assert:
		(list setAttributesFromOrderPreservingDictionary: dictionary) == list.
	self assert:
		list attributeAssociations asArray =
			self attributeAssociations asArray.
	list do: [:each |
		self
			assert: each class == self attributeClass;
			assert: each parent == element;
			assert: each element == element]! !

XMLAttributeListTest subclass: #XMLCachingAttributeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLCachingAttributeListTest methodsFor: 'accessing' stamp: 'monty 9/2/2016 06:20'!
listClass
	^ XMLCachingAttributeList! !

!XMLCachingAttributeListTest methodsFor: 'accessing' stamp: 'monty 2/20/2017 23:43'!
listCopyClass
	^ XMLAttributeList! !

XMLObservableListTest subclass: #XMLNodeListTest
	instanceVariableNames: 'document nodes newNode absentNode changedNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

XMLNodeListTest subclass: #XMLCachingNodeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:48'!
listClass
	^ XMLCachingNodeList! !

!XMLCachingNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:50'!
listCopyClass
	^ XMLNodeList! !

!XMLCachingNodeListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testSort
	| list cachedElements |

	super testSort.

	list := self listWithItems.
	cachedElements := list elements.
	list sort: self reverseSortBlock.
	self assert: list elements = (cachedElements sort: self reverseSortBlock).! !

!XMLCachingNodeListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testSwapWith
	| list cachedElements start end |

	super testSwapWith.

	list := self listWithItems.
	cachedElements := list elements.
	start := 1.
	end := list size.
	[start < end]
		 whileTrue: [
			list swap: start with: end.
			start := start + 1.
			end := end - 1].
	self assert: list elements = cachedElements reversed.! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 8/5/2016 16:39'!
absentListItem
	^ absentNode ifNil: [absentNode := super absentListItem asXMLStringNode]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 8/30/2016 17:26'!
afterAddingToNotifications
	^ #(addedNode:)! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 8/30/2016 17:25'!
afterRemovingFromNotifications
	^ #(removedNode:)! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 4/18/2016 02:42'!
changedListItem: anObject
	^ (changedNodes ifNil: [changedNodes := IdentityDictionary new])
		at: anObject
		ifAbsentPut: [anObject copy]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:54'!
listClass
	^ XMLNodeList! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 4/17/2016 10:28'!
listContentNodes
	^ self listItems select: [:each | each isContentNode]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 4/17/2016 13:13'!
listElementNames
	^ self listElements collect: [:each | each name]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 4/17/2016 10:24'!
listElements
	^ self listItems select: [:each | each isElement]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 8/14/2016 21:26'!
listItems
	nodes
		ifNil: [
			document := XMLDocument new.
			(document addElementNamed: 'root')
				addElementNamed: 'one';
				addString: 'two';
				addElementNamed: 'prefix:three' namespaceURI: 'prefixNS';
				addNode: (XMLComment string: 'four');
				addElementNamed: 'three';
				addString: 'five';
				addElementNamed: 'six';
				addNode: (XMLPI target: 'seven' data: 'seven');
				addElementNamed: 'eight';
				addString: 'nine'.
			nodes := document root nodes asArray].
	"return a copy of the array, but share the nodes"
	^ nodes copy.! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 4/17/2016 10:26'!
listStringNodes
	^ self listItems select: [:each | each isStringNode]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 4/17/2016 13:15'!
listStrings
	^ self listStringNodes collect: [:each | each string]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 8/5/2016 16:39'!
newListItem
	^ newNode ifNil: [newNode := super newListItem asXMLStringNode]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:53'!
observerClass
	^ XMLRecordingNodeListObserver! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:35'!
reverseSortBlock
	^ [:a :b | a sortKey > b sortKey]! !

!XMLNodeListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:35'!
sortBlock
	^ [:a :b | a sortKey <= b sortKey]! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 10:29'!
testContentNodes
	| list |

	list := self listWithItems.
	self
		assertList: list contentNodes
		copiedFrom: list
		equals: (self listClass newFrom: self listContentNodes).! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:07'!
testContentNodesDo
	| list |

	list := self emptyList.
	self
		should: [:block | list contentNodesDo: block ]
		enumerate: #().

	list addAll: self listItems.
	self
		should: [:block | list contentNodesDo: block ]
		enumerate: self listContentNodes.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:18'!
testContentStringAt
	| list |

	list := self listWithItems.
	self listElements do: [:each |
		self assert:
			(list contentStringAt: each name) = each contentString].! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:19'!
testElementAfter
	| list elementAfter |

	list := self listWithItems.
	elementAfter := nil.
	self listElements reverseDo: [:each |
		self assert: (list elementAfter: each) = elementAfter.
		elementAfter := each].! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:19'!
testElementAt
	| list |

	list := self listWithItems.
	self listElements do: [:each | | changedElement |
		self assert: (list elementAt: each name) = each.

		changedElement := self changedListItem: each.
		list addFirst: changedElement.
		self assert: (list elementAt: each name) = changedElement.

		list
			remove: each;
			remove: changedElement.
		self assert: (list elementAt: each name) = self defaultValue].! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:20'!
testElementAtIfAbsent
	| list |

	list := self listWithItems.
	self listElements do: [:each | | changedElement |
		self assert:
			(list
				elementAt: each name
				ifAbsent: [self fail]) = each.

		changedElement := self changedListItem: each.
		list addFirst: changedElement.
		self assert:
			(list
				elementAt: each name
				ifAbsent: [self fail]) = changedElement.

		list
			remove: each;
			remove: changedElement.
		self assert:
			(list
				elementAt: each name
				ifAbsent: [self newListItem]) = self newListItem].! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:20'!
testElementBefore
	| list elementBefore |

	list := self listWithItems.
	elementBefore := nil.
	self listElements do: [:each |
		self assert: (list elementBefore: each) = elementBefore.
		elementBefore := each].! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:13'!
testElementNames
	| list |

	list := self listWithItems.
	self
		assertList: list elementNames
		collectedFrom: list
		equals: (self listSpecies newFrom: self listElementNames).! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 10:24'!
testElements
	| list |

	list := self listWithItems.
	self
		assertList: list elements
		copiedFrom: list
		equals: (self listClass newFrom: self listElements).! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/20/2016 09:54'!
testElementsAt
	self listElements do: [:element | | list elementsAt changedElement |
		list := self listWithItems.
		elementsAt :=
			self listElements select: [:each |
				each isNamed: element name].
		self assert:
			(list elementsAt: element name) =
				(self listClass newFrom: elementsAt).

		changedElement := self changedListItem: element.
		list addFirst: changedElement.
		elementsAt := elementsAt copyWithFirst: changedElement.
		self assert:
			(list elementsAt: element name) =
				(self listClass newFrom: elementsAt).

		list remove: element.
		elementsAt := elementsAt copyWithout: element.
		self assert:
			(list elementsAt: element name) =
				(self listClass newFrom: elementsAt)].! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:13'!
testElementsCollect
	| list |

	list := self listWithItems.
	self
		assertList: (list elementsCollect: [:each | each name])
		collectedFrom: list
		equals: (self listSpecies newFrom: self listElementNames).! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:07'!
testElementsDo
	| list |

	list := self emptyList.
	self
		should: [:block | list elementsDo: block ]
		enumerate: #().

	list addAll: self listItems.
	self
		should: [:block | list elementsDo: block ]
		enumerate: self listElements.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/18/2016 03:45'!
testElementsSelect
	| list selectedElements |

	list := self listWithItems.
	selectedElements :=
		self listElements
			copyFrom: 1
			to: (self listElements size / 2) floor.
	self
		assertList: (list elementsSelect: [:each | selectedElements includes: each])
		copiedFrom: list
		equals: (self listClass newFrom: selectedElements).! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:20'!
testFirstElement
	| list |

	list := self listWithItems.
	self listElements do: [:each |
		self assert: list firstElement = each.
		list remove: each].
	self assert: list firstElement = self defaultValue.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 10:28'!
testHasContentNodes
	| list |

	list := self emptyList.
	self deny: list hasContentNodes.

	list addAll: self listItems.
	self assert: list hasContentNodes.

	list removeAll: self listContentNodes.
	self deny: list hasContentNodes.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 10:25'!
testHasElements
	| list |

	list := self emptyList.
	self deny: list hasElements.

	list addAll: self listItems.
	self assert: list hasElements.

	list removeAll: self listElements.
	self deny: list hasElements.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 10:27'!
testHasStringNodes
	| list |

	list := self emptyList.
	self deny: list hasStringNodes.

	list addAll: self listItems.
	self assert: list hasStringNodes.

	list removeAll: self listStringNodes.
	self deny: list hasStringNodes.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 13:20'!
testLastElement
	| list |

	list := self listWithItems.
	self listElements reverseDo: [:each |
		self assert: list lastElement = each.
		list remove: each].
	self assert: list lastElement = self defaultValue.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:18'!
testRawContentStringAt
	| list |

	list := self listWithItems.
	self listElements do: [:each |
		self assert:
			(list rawContentStringAt: each name) = each rawContentString].! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 10:26'!
testStringNodes
	| list |

	list := self listWithItems.
	self
		assertList: list stringNodes
		copiedFrom: list
		equals: (self listClass newFrom: self listStringNodes).! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:08'!
testStringNodesDo
	| list |

	list := self emptyList.
	self
		should: [:block | list stringNodesDo: block ]
		enumerate: #().

	list addAll: self listItems.
	self
		should: [:block | list stringNodesDo: block ]
		enumerate: self listStringNodes.! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:14'!
testStrings
	| list |

	list := self listWithItems.
	self
		assertList: list strings
		collectedFrom: list
		equals: (self listSpecies newFrom: self listStrings).! !

!XMLNodeListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:15'!
testStringsDo
	| list |

	list := self emptyList.
	self
		should: [:block | list stringsDo: block ]
		enumerate: #().

	list addAll: self listItems.
	self
		should: [:block | list stringsDo: block ]
		enumerate: self listStrings.! !

!XMLObservableListTest class methodsFor: 'testing' stamp: 'JAA 3/26/2011 19:00'!
shouldInheritSelectors
	^ true! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:45'!
afterAddingToNotifications
	^ #(added:to:)! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:45'!
afterRemovingFromNotifications
	^ #(removed:from:)! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:30'!
assertList: aFirstList copiedFrom: aSecondList equals: aThirdList
	super
		assertList: aFirstList
		copiedFrom: aSecondList
		equals: aThirdList.
	self
		denyList: aFirstList
		sharesObserverWith: aSecondList.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:30'!
assertList: aFirstList isCopyOf: aSecondList
	super
		assertList: aFirstList
		isCopyOf: aSecondList.
	self
		denyList: aFirstList
		sharesObserverWith: aSecondList.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:31'!
assertList: aList receivedNotificationOfAdding: anObject
	self
		assertList: aList
		receivedNotificationOfAfterAdding: anObject! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:33'!
assertList: aList receivedNotificationOfAfterAdding: anObject
	self
		assertNotification: aList observer nextNotification
		for: anObject
		withList: aList
		hasType: self afterAddingToNotifications! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:33'!
assertList: aList receivedNotificationOfRemoving: anObject
	self
		assertNotification: aList observer nextNotification
		for: anObject
		withList: aList
		hasType: self afterRemovingFromNotifications! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:31'!
assertList: aList receivedNotificationOfReplacing: anOldObject with: aNewObject
	self
		assertList: aList
		receivedNotificationOfRemoving: anOldObject.
	self
		assertList: aList
		receivedNotificationOfAfterAdding: aNewObject.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:33'!
assertNotification: aNotification for: anObject withList: aList hasType: aSelectorCollection
	self
		assert: aNotification notNil;
		assert: (aSelectorCollection includes: aNotification selector).
	self assert:
		aNotification arguments =
			((Array with: anObject with: aList)
				copyFrom: 1
				to: (aNotification selector asString occurrencesOf: $:)).! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 9/5/2016 21:10'!
denyList: aFirstList sharesObserverWith: aSecondList
	self deny:
		(aFirstList observer notNil
			and: [aFirstList observer == aSecondList observer])! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:41'!
emptyList
	| list |

	list := super emptyList.
	self observerOnList: list.
	^ list.! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'JAA 3/26/2011 19:01'!
listClass
	^ XMLObservableList! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:23'!
listWithItems
	| list |

	list := super listWithItems.
	self observerOnList: list.
	^ list.! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:24'!
listWithSingleItem
	| list |

	list := super listWithSingleItem.
	self observerOnList: list.
	^ list.! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:52'!
observerClass
	^ XMLRecordingListObserver! !

!XMLObservableListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 09:53'!
observerOnList: aList
	| observer |

	observer := self observerClass new.
	aList observer: observer.
	^ observer.! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:34'!
should: aBlock add: anObject toAndNotify: aList
	self
		should: aBlock
		addAll: (Array with: anObject)
		toAndNotify: aList! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:34'!
should: aBlock addAll: aCollection toAndNotify: aList
	aList observer clearNotifications.
	aBlock value.
	aCollection do: [:each |
		self assert: (aList includes: each).
		self 
			assertList: aList
			receivedNotificationOfAdding: each].! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:34'!
should: aBlock remove: anObject fromAndNotify: aList
	self
		should: aBlock
		removeAll: (Array with: anObject)
		fromAndNotify: aList! !

!XMLObservableListTest methodsFor: 'assertions' stamp: 'monty 8/30/2016 17:34'!
should: aBlock removeAll: aCollection fromAndNotify: aList
	aList observer clearNotifications.
	aBlock value.
	aCollection do: [:each |
		self deny: (aList includes: each).
		self
			assertList: aList
			receivedNotificationOfRemoving: each].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAdd
	| list |

	super testAdd.

	list := self emptyList.
	self listItems do: [:each |
		self
			should: [list add: each]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAfter
	| list |

	super testAddAfter.

	list := self listWithSingleItem.
	self listItems allButFirst reverseDo: [:each |
		self
			should: [list add: each after: self singleListItem]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAfterIndex
	| list |

	super testAddAfterIndex.

	list := self listWithSingleItem.
	self listItems allButFirst reverseDo: [:each |
		self
			should: [list add: each afterIndex: 1]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAll
	| list |

	super testAddAll.

	list := self emptyList.
	self
		should: [list addAll: self listItems]
		addAll: self listItems
		toAndNotify: list.
	self
		should: [list addAll: self changedListItems]
		addAll: self changedListItems
		toAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAllFirst
	| list |

	super testAddAllFirst.

	list := self emptyList.
	self
		should: [list addAllFirst: self listItems]
		addAll: self listItems reversed
		toAndNotify: list.
	self
		should: [list addAllFirst: self changedListItems]
		addAll: self changedListItems reversed
		toAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAllLast
	| list |

	super testAddAllLast.

	list := self emptyList.
	self
		should: [list addAllLast: self listItems]
		addAll: self listItems
		toAndNotify: list.
	self
		should: [list addAllLast: self changedListItems]
		addAll: self changedListItems
		toAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddBefore
	| list last |

	super testAddBefore.

	last := self listItems last.
	(list := self emptyList) add: last.
	"allButLastDo: is not portable"
	self listItems allButLast do: [:each |
		self
			should: [list add: each before: last]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddBeforeIndex
	| list |

	super testAddBeforeIndex.

	(list := self emptyList) add: self listItems last.
	self listItems allButLast withIndexDo: [:each :i |
		self
			should: [list add: each beforeIndex: i]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddFirst
	| list |

	super testAddFirst.

	list := self emptyList.
	self listItems reverseDo: [:each |
		self
			should: [list addFirst: each]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddLast
	| list |

	super testAddLast.

	list := self emptyList.
	self listItems do: [:each |
		self
			should: [list addLast: each]
			add: each
			toAndNotify: list].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 8/28/2016 06:00'!
testAtPut
	| list |

	super testAtPut.

	list := self listWithItems.
	1 to: list size do: [:i | | old new |
		old := list at: i.
		new := self changedListItems at: i.
		list at: i put: new.
		self
			assertList: list
			receivedNotificationOfReplacing: old
			with: new].
	self
		should: [list at: list size + 2 put: self newListItem]
		raise: Error.
	self deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 1/17/2015 11:52'!
testOfSize
	self
		should: [self listClass ofSize: 10]
		raise: Error! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveAll
	| list |

	super testRemoveAll.

	list := self listWithItems.
	self
		should: [list removeAll]
		removeAll: self listItems reversed
		fromAndNotify: list.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveAt
	super testRemoveAt.

	self listItems withIndexDo: [:each :i | | list |
		list := self listWithItems.
		self
			should: [list removeAt: i]
			remove: each
			fromAndNotify: list.
		self
			should: [list removeAt: 0] raise: Error;
			should: [list removeAt: list size + 1] raise: Error;
			deny: list observer hasNotifications].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveFirst
	| list |

	super testRemoveFirst.

	list := self listWithItems.
	self listItems do: [:each |
		self
			should: [list removeFirst]
			remove: each
			fromAndNotify: list].
	self
		should: [list removeFirst] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveFirstFew
	| list |

	super testRemoveFirstFew.

	1 to: self listItems size do: [:i |
		list := self listWithItems.
		self
			should: [list removeFirst: i]
			removeAll: (self listItemsFirst: i)
			fromAndNotify: list].
	list := self emptyList.
	self
		should: [list removeFirst: list size + 1] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveIfAbsent
	| list |

	super testRemoveIfAbsent.

	list := self listWithItems.
	self
		should: [
			list
				remove: self singleListItem
				ifAbsent: [self absentListItem]]
		remove: self singleListItem
		fromAndNotify: list.
	self assert:
		(list
			remove: self singleListItem
			ifAbsent: [self absentListItem]) = self absentListItem.
	self deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveLast
	| list |

	super testRemoveLast.

	list := self listWithItems.
	self listItems reverseDo: [:each |
		self
			should: [list removeLast]
			remove: each
			fromAndNotify: list].
	self
		should: [list removeFirst] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveLastFew
	| list |
	
	super testRemoveLastFew.

	1 to: self listItems size do: [:i |
		list := self listWithItems.
		self
			should: [list removeLast: i]
			removeAll: (self listItemsLast: i) reversed
			fromAndNotify: list].
	list := self emptyList.
	self
		should: [list removeFirst: list size + 1] raise: Error;
		deny: list observer hasNotifications.! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReplaceFromToWith
	super testReplaceFromToWith.

	1 to: self listItems size do: [:start |
		start to: self listItems size do: [:stop | | list old new |
			list := self listWithItems.
			old := self listItems copyFrom: start to: stop.
			new := self changedListItems copyFrom: 1 to: stop - start + 1.
			list
				replaceFrom: start
				to: stop
				with: self changedListItems.
			old with: new do: [:oldElement :newElement |
				self
					assertList: list
					receivedNotificationOfReplacing: oldElement
					with: newElement].
			self deny: list observer hasNotifications]].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReplaceFromToWithStartingAt
	super testReplaceFromToWithStartingAt.

	1 to: self listItems size do: [:start |
		start to: self listItems size do: [:stop | | list old new |
			list := self listWithItems.
			old := self listItems copyFrom: start to: stop.
			new := self changedListItems copyFrom: start to: stop.
			list
				replaceFrom: start
				to: stop
				with: self changedListItems
				startingAt: start.
			old with: new do: [:oldElement :newElement |
				self
					assertList: list
					receivedNotificationOfReplacing: oldElement
					with: newElement].
			self deny: list observer hasNotifications]].! !

!XMLObservableListTest methodsFor: 'tests' stamp: 'monty 2/26/2017 12:38'!
testReset
	| list |

	super testReset.
	list := self listWithItems.
	self
		should: [list reset]
		removeAll: self listItems reversed
		fromAndNotify: list.! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:19'!
absentListItem
	^ 'absent'! !

!XMLOrderedListTest methodsFor: 'testing' stamp: 'monty 1/18/2015 11:26'!
allowsDuplicates
	^ true! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 10/28/2014 19:09'!
assertList: aList collectedFrom: aSecondList equals: aThirdList
	self
		assert: aList = aThirdList;
		assert: aList class = aSecondList species;
		deny: aList == aSecondList;
		deny: aList collection == aSecondList collection! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/12/2015 11:29'!
assertList: aList copiedFrom: aSecondList equals: aThirdList
	self
		assert: aList = aThirdList;
		assert: aList class == self listCopyClass;
		assert: aList collection class == aSecondList collection class;
		deny: aList == aSecondList;
		deny: aList collection == aSecondList collection! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/11/2015 07:39'!
assertList: aFirstList equals: aSecondList
	self
		assert: aFirstList = aFirstList;
		assert: aSecondList = aSecondList;
		assert: aFirstList = aSecondList;
		assert: aSecondList = aFirstList! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/12/2015 11:29'!
assertList: aList isCopyOf: aSecondList
	self
		assert: aList = aSecondList;
		assert: aList class == self listCopyClass;
		assert: aList collection class == aSecondList collection class;
		assert: aList collection = aSecondList collection;
		deny: aList == aSecondList;
		deny: aList collection == aSecondList collection! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/1/2016 07:32'!
assertList: aList replacedItems: anOldItemCollection withItems: aNewItemCollection from: aStart to: aStop
	"items before aStart should not have been replaced"
	1 to: aStart - 1 do: [:i |
		self assert: (aList at: i) = (anOldItemCollection at: i)].

	"items within the range should be replaced"
	aStart to: aStop do: [:i |
		self assert: (aList at: i) = (aNewItemCollection at: i)].

	"items after aStop should not have been replaced"
	aStop + 1 to: aList size do: [:i |
		self assert: (aList at: i) = (anOldItemCollection at: i)].! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 4/18/2016 02:42'!
changedListItem: anObject
	^ anObject asUppercase! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 4/18/2016 02:42'!
changedListItems
	^ self listItems collect: [:each | self changedListItem: each]! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 4/18/2016 02:42'!
changedSingleListItem
	^ self changedListItem: self singleListItem! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 06:33'!
customCollection
	^ XMLStubOrderedListCustomCollection new! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 06:30'!
customCollectionEmptyList
	^ self listClass collection: self customCollection! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
customCollectionListWithItems
	^ (self listClass collection: self customCollection)
		addAll: self listItems;
		yourself! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
customCollectionListWithSingleItem
	^ (self listClass collection: self customCollection)
		add: self singleListItem;
		yourself! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:46'!
defaultValue
	^ nil! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 4/11/2015 07:39'!
denyList: aFirstList equals: aSecondList
	self
		deny: aFirstList = aSecondList;
		deny: aSecondList = aFirstList! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:19'!
emptyList
	^ self listClass new! !

!XMLOrderedListTest methodsFor: 'testing' stamp: 'monty 12/14/2014 13:59'!
hasCapacity
	"for portability"
	^ self listClass collectionClass includesSelector: #capacity! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/24/2011 20:15'!
listClass
	^ XMLOrderedList! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 11:47'!
listCopyClass
	^ self listClass! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 2/26/2017 08:57'!
listItems
	^ #('one' 'two' 'three' 'four' 'five'
		'six' 'seven' 'eight' 'nine' 'ten'
		'eleven') copy! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
listItemsFirst: anInteger
	"first: is not portable to GS"
	^ self listItems
		copyFrom: 1
		to: ((anInteger max: 0) min: self listItems size)! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
listItemsLast: anInteger
	"last: is not portable to GS"
	anInteger > 0
		ifFalse: [^ #()].
	^ self listItems
		copyFrom: ((self listItems size - anInteger + 1) max: 1)
		to: self listItems size.! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'JAA 3/26/2011 18:15'!
listSpecies
	^ XMLOrderedList! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
listWithItems
	^ self listClass new
		addAll: self listItems;
		yourself! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
listWithSingleItem
	^ self listClass new
		add: self singleListItem;
		yourself! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:31'!
newListItem
	^ 'new'! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:34'!
reverseSortBlock
	^ [:a :b | a > b]! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'JAA 3/26/2011 17:37'!
should: aBlock enumerate: aCollection
	| enumerated |

	enumerated := OrderedCollection new.
	aBlock value: [:each | enumerated add: each].
	self assert: enumerated = aCollection asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 03:18'!
should: aBlock enumerate: aFirstCollection and: aSecondCollection
	| firstEnumerated secondEnumerated |

	firstEnumerated := OrderedCollection new.
	secondEnumerated := OrderedCollection new.
	aBlock value: [:first :second |
		firstEnumerated addLast: first.
		secondEnumerated addLast: second].
	self
		assert: firstEnumerated = aFirstCollection asOrderedCollection;
		assert: secondEnumerated = aSecondCollection asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
singleListItem
	^ self listItems first! !

!XMLOrderedListTest methodsFor: 'accessing' stamp: 'monty 1/17/2015 10:34'!
sortBlock
	^ [:a :b | a <= b]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAdd
	| list |

	list := self emptyList.
	self
		deny: list = self listWithItems;
		assert: (self listItems allSatisfy: [:each | (list add: each) == each]);
		assert: (list = self listWithItems).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddAfter
	| list |

	list := self listWithSingleItem.
	self
		assert:
			(self listItems allButFirst reversed
				allSatisfy: [:each | (list add: each after: self singleListItem) = each]);
		assert: list = self listWithItems;
		should: [list add: self newListItem after: self absentListItem] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddAfterIndex
	| list |

	list := self listWithSingleItem.
	self
		assert:
			(self listItems allButFirst reversed
				allSatisfy: [:each | (list add: each afterIndex: 1) = each]);
		assert: list = self listWithItems;
		should: [list add: self newListItem afterIndex: self listItems size + 1] raise: Error;
		should: [list add: self newListItem afterIndex: -1] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAll
	| list |

	list := self emptyList.
	self
		deny: list = self listWithItems;
		assert: (list addAll: self listItems) = self listItems;
		assert: list = self listWithItems;
		assert: (list addAll: self changedListItems) = self changedListItems;
		assert: list = (self listClass newFrom: (self listItems, self changedListItems)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAllFirst
	| list |

	list := self emptyList.
	self
		assert: (list addAllFirst: self listItems) = self listItems;
		assert: list = self listWithItems;
		assert: (list addAllFirst: self changedListItems) = self changedListItems;
		assert: list = (self listClass newFrom: self changedListItems, self listItems).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAllLast
	| list |

	list := self emptyList.
	self
		assert: (list addAllLast: self listItems) = self listItems;
		assert: list = self listWithItems;
		assert: (list addAllLast: self changedListItems) = self changedListItems;
		assert: list = (self listClass newFrom: self listItems, self changedListItems).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddBefore
	| list last |

	last := self listItems last.
	(list := self emptyList) add: last.
	self
		assert:
			(self listItems allButLast
				allSatisfy: [:each | (list add: each before: last) = each]);
		assert: list = self listWithItems;
		should: [list add: self newListItem before: self absentListItem] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddBeforeIndex
	| list |

	(list := self emptyList) add: self listItems last.
	self listItems allButLast withIndexDo: [:each :i |
		self assert: (list add: each beforeIndex: i) = each].
	self
		assert: list = self listWithItems;
		should: [list add: self newListItem beforeIndex: self listItems size + 2] raise: Error;
		should: [list add: self newListItem beforeIndex: 0] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddFirst
	| list |

	list := self emptyList.
	self
		assert: (self listItems reversed allSatisfy: [:each | (list addFirst: each) = each]);
		assert: list = self listWithItems.

	self assert: (self listItems allSatisfy: [:each | (list addFirst: each) = each]).
	self assert:
		list =
			(self listClass newFrom: 
				(self allowsDuplicates
					ifTrue: [self listItems reversed, self listItems]
					ifFalse: [self listItems reversed])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddLast
	| list |

	list := self emptyList.
	self
		assert: (self listItems allSatisfy: [:each | (list addLast: each) = each]);
		assert: list = self listWithItems.

	self assert: (self listItems allSatisfy: [:each | (list addLast: each) = each]).
	self assert:
		list =
			(self listClass newFrom: 
				(self allowsDuplicates
					ifTrue: [self listItems, self listItems]
					ifFalse: [self listItems])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:26'!
testAfter
	| list |

	list := self listWithItems.
	1 to: list size - 1 do: [:i |
		self assert:
			(list after: (self listItems at: i)) =
				(self listItems at: i + 1)].
	self
		assert: (list after: self listItems last) = self defaultValue;
		assert: (list after: self absentListItem) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:26'!
testAfterIfAbsent
	| list |

	list := self listWithItems.
	1 to: list size - 1 do: [:i |
		self assert:
			(list
				after: (self listItems at: i)
				ifAbsent: [self fail]) = (self listItems at: i + 1)].
	self assert:
		(list
			after: self listItems last
			ifAbsent: [self newListItem]) = self newListItem.
	self assert:
		(list
			after: self absentListItem
			ifAbsent: [self newListItem]) = self newListItem.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAllButFirst
	| list |

	self assert: self emptyList allButFirst = self emptyList.

	list := self listWithItems.
	self
		assertList: list allButFirst
		copiedFrom: list
		equals: (self listClass newFrom: self listItems allButFirst).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAllButFirstDo
	self
		should: [:block | self emptyList allButFirstDo: block]
		enumerate: #().
	self
		should: [:block | self listWithItems allButFirstDo: block]
		enumerate: self listItems allButFirst.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAllButFirstFew
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assertList: (list allButFirst: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItems allButFirst: i)).
		self
			assertList: (list allButFirst: i + list size)
			copiedFrom: list
			equals: self emptyList.
		self
			assertList: (list allButFirst: i * -1)
			copiedFrom: list
			equals: list.
		self assert: (self emptyList allButFirst: i) = self emptyList].
	self
		assertList: (list allButFirst: 0)
		copiedFrom: list
		equals: list.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAllButLast
	| list |

	self assert: self emptyList allButLast = self emptyList.

	list := self listWithItems.
	self
		assertList: list allButLast
		copiedFrom: list
		equals: (self listClass newFrom: self listItems allButLast).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAllButLastDo
	self
		should: [:block | self emptyList allButLastDo: block]
		enumerate: #().
	self
		should: [:block | self listWithItems allButLastDo: block]
		enumerate: self listItems allButLast.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAllButLastFew
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assertList: (list allButLast: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItems allButLast: i)).
		self
			assertList: (list allButLast: i + list size)
			copiedFrom: list
			equals: self emptyList.
		self
			assertList: (list allButLast: i * -1)
			copiedFrom: list
			equals: list.
		self assert: (self emptyList allButLast: i) = self emptyList].
	self
		assertList: (list allButLast: 0)
		copiedFrom: list
		equals: list.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAnyOne
	self
		assert: self emptyList anyOne = self defaultValue;
		assert: self listWithItems anyOne = self listItems first.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAsArray
	self
		assert: self emptyList asArray = #();
		assert: self listWithItems asArray = self listItems asArray! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAsOrderedCollection
	| list |

	list := self listWithItems.
	self
		assert: self emptyList asOrderedCollection = OrderedCollection new;
		assert: list asOrderedCollection = self listItems asOrderedCollection;
		deny: list asOrderedCollection == list collection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAt
	| list |

	list := self listWithItems.
	self
		assert: ((1 to: list size) allSatisfy: [:i | (list at: i) = (self listItems at: i)]);
		assert: (list at: 0) = self defaultValue;
		assert: (list at: list size + 1) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:18'!
testAtIfAbsent
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self assert:
			(list
				at: i
				ifAbsent: [self fail]) = (self listItems at: i)].
	self
		assert: (list at: 0 ifAbsent: [self newListItem]) = self newListItem;
		assert: (list at: list size + 1 ifAbsent: [self newListItem]) = self newListItem.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAtLast
	| list |

	list := self listWithItems.
	1 to: list size do: [:i | self assert: (list atLast: i) = (self listItems atLast: i)].
	self
		assert: (list atLast: 0) = self defaultValue;
		assert: (list atLast: list size + 1) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAtLastIfAbsent
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self assert: (list atLast: i ifAbsent: [self newListItem]) = (self listItems atLast: i)].
	self
		assert: (list atLast: 0 ifAbsent: [self newListItem]) = self newListItem;
		assert: (list atLast: list size + 1 ifAbsent: [self newListItem]) = self newListItem.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAtPut
	| list |

	list := self listWithItems.
	1 to: list size do: [:i | | replacement |
		replacement := list at: i.
		self
			assert: (list at: i put: replacement) == replacement;
			assert: (list at: i) == replacement].
	self assert: list = self listWithItems.

	self assert: (list at: list size + 1 put: self newListItem) = self newListItem.
	self assert:
		list =
			(self listClass newFrom: (self listItems copyWith: self newListItem)).

	list := self listWithItems.
	1 to: list size do: [:i | | replacement |
		replacement := self changedListItems at: i.
		self
			assert: (list at: i put: replacement) == replacement;
			assert: (list at: i) == replacement].
	self assert: list = (self listClass newFrom: self changedListItems).

	list := self listWithItems.
	self listItems do: [:each |
		self assert: (list at: list size + 1 put: each) == each].
	self assert:
		list =
			(self allowsDuplicates
				ifTrue: [self listClass newFrom: self listItems, self listItems]
				ifFalse: [self listWithItems]).
	self
		should: [list at: 0 put: self newListItem]
		raise: Error.
	self
		should: [list at: list size + 2 put: self newListItem]
		raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:25'!
testBefore
	| list |

	list := self listWithItems.
	2 to: list size do: [:i |
		self assert: (list before: (self listItems at: i)) = (self listItems at: i - 1)].
	self
		assert: (list before: self listItems first) = self defaultValue;
		assert: (list before: self absentListItem) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:27'!
testBeforeIfAbsent
	| list |

	list := self listWithItems.
	2 to: list size do: [:i |
		self assert:
			(list
				before: (self listItems at: i)
				ifAbsent: [self fail]) = (self listItems at: i - 1)].
	self assert:
		(list
			before: self listItems first
			ifAbsent: [self newListItem]) = self newListItem.
	self assert:
		(list
			before: self absentListItem
			ifAbsent: [self newListItem]) = self newListItem.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testBeginsWith
	| list |

	self deny: (self emptyList beginsWith: self listItems).
	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list beginsWith: (self listItems copyFrom: 1 to: i));
			deny: (list beginsWith: ((self listItems copyFrom: 1 to: i) copyWith: self absentListItem));
			deny: (list beginsWith: ((self listItems copyFrom: 1 to: i) copyWithFirst: self absentListItem))].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCapacity
	self hasCapacity
		ifTrue: [
			self
				assert: self emptyList capacity >= 0;
				assert: self listWithSingleItem capacity >= 1;
				assert: self listWithItems capacity >= self listItems size]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/18/2016 02:42'!
testCollect
	| list |

	list := self listWithItems.
	self
		assertList: (list collect: [:each | self changedListItem: each])
		collectedFrom: list
		equals: (self listSpecies newFrom: self changedListItems).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/18/2016 02:42'!
testCollectThenSelect
	| list |

	list := self listWithItems.
	self
		assertList:
			(list
				collect: [:each | self changedListItem: each]
				thenSelect: [:each | each ~= self changedSingleListItem])
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self changedListItems copyWithout: self changedSingleListItem)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testConcatenation
	| list |

	list := self emptyList.
	self
		assertList: (list, self emptyList) copiedFrom: list equals: self emptyList;
		assertList: (list, self listWithItems) copiedFrom: list equals: self listWithItems.

	list := self listWithItems.
	self assertList: (list, self emptyList) copiedFrom: list equals: self listWithItems.
	self
		assertList: (list, self listWithItems)
		copiedFrom: list
		equals: (self listClass newFrom: (self listItems, self listItems)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testCopy
	| list |

	list := self emptyList.
	self assertList: list copy isCopyOf: list.

	list := self listWithSingleItem.
	self assertList: list copy isCopyOf: list.

	list := self listWithItems.
	self assertList: list copy isCopyOf: list.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyAfter
	| list |

	list := self listWithItems.
	list do: [:each |
		self
			assertList: (list copyAfter: each)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItems copyAfter: each)).
		self assert: (self emptyList copyAfter: each) = self emptyList].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyAfterLast
	| list |

	list := self listWithItems.
	list do: [:each |
		self
			assertList: (list copyAfterLast: each)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItems copyAfterLast: each)).
		self assert: (self emptyList copyAfterLast: each) = self emptyList].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testCopyEmpty
	| list |

	list := self emptyList.
	self assertList: list copyEmpty copiedFrom: list equals: self emptyList.

	list := self listWithSingleItem.
	self assertList: list copyEmpty copiedFrom: list equals: self emptyList.

	list := self listWithItems.
	self assertList: list copyEmpty copiedFrom: list equals: self emptyList.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testCopyFromTo
	| list emptyList |

	list := self listWithItems.
	emptyList  := self emptyList.
	-1 to: list size + 1 do: [:start |
		start to: list size + 1 do: [:stop |
			self
				assertList: (list copyFrom: start to: stop)
				copiedFrom: list
				equals: (self listWithItems copyFrom: (start max: 1) to: (stop min: list size)).
			self
				assertList: (list copyFrom: start to: start - 1)
				copiedFrom: list
				equals: self emptyList.
			self
				assertList: (list copyFrom: start to: start - 2)
				copiedFrom: list
				equals: self emptyList.
			self
				assertList: (emptyList copyFrom: start to: stop)
				copiedFrom: list
				equals: self emptyList]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/18/2016 02:42'!
testCopyReplaceAllWith
	| list |

	list := self listClass newFrom: self listItems, self listItems.
	1 to: self listItems size do: [:i | | replacedElements |
		replacedElements := self listItemsLast: i.
		self
			assertList:
				(list
					copyReplaceAll: replacedElements
					with: (replacedElements collect: [:each | self changedListItem: each]))
			copiedFrom: list
			equals: 
				(self listClass newFrom:
					((self listItems, self listItems) 
						copyReplaceAll: replacedElements
						with: (replacedElements collect: [:each | self changedListItem: each]))).
		self
			assertList:
				(list
					copyReplaceAll: (Array with: self absentListItem)
					with: (Array with: self newListItem))
			copiedFrom: list
			equals: list.	
		self
			assertList: (list copyReplaceAll: #() with: (Array with: self newListItem))
			copiedFrom: list
			equals: list.
		self
			assertList: (list copyReplaceAll: (self listItems copyWith: self absentListItem) with: #())
			copiedFrom: list
			equals: list].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyReplaceFromToWith
	| list emptyList |

	list := self listWithItems.
	emptyList := self emptyList.
	-1 to: list size + 1 do: [:start |
		start to: list size + 1 do: [:stop |
			self
				assertList: (list copyReplaceFrom: start to: stop with: self changedListItems)
				copiedFrom: list
				equals:
					(self listClass newFrom:
						(self listItemsFirst: start - 1),
						(self changedListItems),
						(self listItemsLast: list size - stop)).
			self
				assertList: (emptyList copyReplaceFrom: start to: stop with: self listItems)
				copiedFrom: emptyList
				equals: self listWithItems]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyUpTo
	| list |

	list := self listWithItems.
	list do: [:each |
		self
			assertList: (list copyUpTo: each)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItems copyUpTo: each))].
	self
		assertList: (list copyUpTo: self absentListItem)
		copiedFrom: list
		equals: self listWithItems.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyUpToLast
	| list |

	list := self listClass newFrom: self listItems, self listItems.
	list do: [:each |
		self
			assertList: (list copyUpToLast: each)
			copiedFrom: list
			equals:
				(self listClass newFrom:
					(self allowsDuplicates
						ifTrue: [self listItems, self listItems copyUpToLast: each]
						ifFalse: [self listItems copyUpToLast: each]))].
	self
		assertList: (list copyUpToLast: self absentListItem)
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self allowsDuplicates
					ifTrue: [self listItems, self listItems]
					ifFalse: [self listItems])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testCopyWith
	| list |

	list := self emptyList.
	self
		assertList: (list copyWith: self singleListItem)
		copiedFrom: list
		equals: self listWithSingleItem.

	list := self listWithItems.
	self
		assertList: (list copyWith: self newListItem)
		copiedFrom: list
		equals: (self listClass newFrom: (self listItems copyWith: self newListItem)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testCopyWithFirst
	| list |

	list := self emptyList.
	self
		assertList: (list copyWithFirst: self singleListItem)
		copiedFrom: list
		equals: self listWithSingleItem.

	list := self listWithItems.
	self
		assertList: (list copyWithFirst: self newListItem)
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self listItems copyWithFirst: self newListItem)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 2/26/2017 08:40'!
testCopyWithout
	self listItems do: [:each | | list |
		list := self emptyList.
		self
			assertList: (list copyWithout: each)
			copiedFrom: list
			equals: self emptyList.

		list := self listWithItems.
		self
			assertList: (list copyWithout: self absentListItem)
			copiedFrom: list
			equals: self listWithItems.
		self
			assertList: (list copyWithout: each)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItems copyWithout: each))]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 2/26/2017 08:44'!
testCopyWithoutAll
	1 to: self listItems size do: [:i | | itemsToRemove list |
		itemsToRemove := self listItems copyFrom: 1 to: i.
		list := self emptyList.
		self
			assertList: (list copyWithoutAll: itemsToRemove)
			copiedFrom: list
			equals: self emptyList.

		list := self listWithItems.
		self
			assertList: (list copyWithoutAll: (Array with: self absentListItem))
			copiedFrom: list
			equals: self listWithItems.
		self
			assertList: (list copyWithoutAll: itemsToRemove)
			copiedFrom: list
			equals:
				(self listClass newFrom:
					(self listItems copyWithoutAll: itemsToRemove))]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/25/2011 16:02'!
testDefaultValue
	self assert: self emptyList defaultValue = self defaultValue! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testDetect
	| list |

	list := self listWithItems.
	self listItems do: [:element |
		self assert: (list detect: [:each | each = element]) = element].
	self assert: (list detect: [:each | each = self absentListItem]) = self defaultValue.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testDetectIfNone
	| list |

	list := self listWithItems.
	self listItems do: [:element |
		self assert:
			(list
				detect: [:each | each = element]
				ifNone: [self newListItem]) = element].
	self assert:
		(list
			detect: [:each | each = self absentListItem]
			ifNone: [self newListItem]) = self newListItem.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testDo
	self
		should: [:block | self emptyList do: block] enumerate: #();
		should: [:block | self listWithItems do: block] enumerate: self listItems! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testDoWithIndex
	| list enumerated |

	list := self listWithItems.
	enumerated := OrderedCollection new.
	list withIndexDo: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listItems withIndexCollect: [:each : i | each -> i ])
				asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testEighth
	self
		assert: self emptyList eighth = self defaultValue;
		assert: self listWithItems eighth = (self listItems at: 8).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testEndsWith
	| list |

	self deny: (self emptyList endsWith: self listItems).
	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list endsWith: (self listItems copyFrom: i to: list size));
			deny: (list endsWith: ((self listItems copyFrom: i to: list size) copyWith: self absentListItem));
			deny: (list endsWith: ((self listItems copyFrom: i to: list size) copyWithFirst: self absentListItem))].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testEquals
	self
		assertList: self emptyList equals: self emptyList;
		assertList: self listWithSingleItem equals: self listWithSingleItem;
		assertList: self listWithItems equals: self listWithItems;
		denyList: self emptyList equals: self listWithSingleItem;
		denyList: self emptyList equals: self listWithItems;
		denyList: self listWithSingleItem equals: self listWithItems! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testEqualsCustomCollection
	self
		assertList: self emptyList
		equals: self customCollectionEmptyList.
	self
		assertList: self listWithSingleItem
		equals: self customCollectionListWithSingleItem.
	self
		assertList: self listWithItems
		equals: self customCollectionListWithItems.
	self
		denyList: self emptyList
		equals: self customCollectionListWithSingleItem.
	self
		denyList: self emptyList
		equals: self customCollectionListWithItems.
	self
		denyList: self listWithSingleItem
		equals: self customCollectionEmptyList.
	self
		denyList: self listWithSingleItem
		equals: self customCollectionListWithItems.
	self
		denyList: self listWithItems
		equals: self customCollectionEmptyList.
	self
		denyList: self listWithItems
		equals: self customCollectionListWithSingleItem.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testEqualsSpecies
	| emptySpeciesList speciesListWithSingleElement speciesListWithElements |

	emptySpeciesList := self listSpecies new.
	speciesListWithSingleElement := self listSpecies with: self singleListItem.
	speciesListWithElements := self listSpecies newFrom: self listItems.
	self
		assertList: self emptyList equals: emptySpeciesList;
		assertList: self listWithSingleItem equals: speciesListWithSingleElement;
		assertList: self listWithItems equals: speciesListWithElements;
		denyList: self emptyList equals: speciesListWithSingleElement;
		denyList: self emptyList equals: speciesListWithElements;
		denyList: self listWithSingleItem equals: emptySpeciesList;
		denyList: self listWithSingleItem equals: speciesListWithElements;
		denyList: self listWithItems equals: emptySpeciesList;
		denyList: self listWithItems equals: speciesListWithSingleElement.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testFifth
	self
		assert: self emptyList fifth = self defaultValue;
		assert: self listWithItems fifth = (self listItems at: 5).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testFirst
	self
		assert: self emptyList first = self defaultValue;
		assert: self listWithItems first = (self listItems at: 1).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testFirstFew
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assertList: (list first: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItemsFirst: i)).
		self
			assertList: (list first: list size + i)
			copiedFrom: list
			equals: self listWithItems.
		self
			assertList: (list first: (i * -1))
			copiedFrom: list
			equals: self emptyList].
	self
		assertList: (list first: 0)
		copiedFrom: list
		equals: self emptyList.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testFourth
	self
		assert: self emptyList fourth = self defaultValue;
		assert: self listWithItems fourth = (self listItems at: 4).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:07'!
testHash
	"We can only safely test that equal objects have the same hash; testing
	that different objects have different hashes would be unreliable
	because #hash is non-cryptographic and has collisions."
	self
		assert: self emptyList hash = self emptyList hash;
		assert: self listWithSingleItem hash = self listWithSingleItem hash;
		assert: self listWithItems hash = self listWithItems hash;
		assert:
			(self listWithItems
				removeAll;
				hash) = self emptyList hash.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testHashCustomCollection
	self assert:
		self emptyList hash = self customCollectionEmptyList hash.
	self assert:
		self listWithSingleItem hash =
			self customCollectionListWithSingleItem hash.
	self assert:
		self listWithItems hash =
			self customCollectionListWithItems hash.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testIdentityIndexOf
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list identityIndexOf: (list at: i)) = i;
			assert: (list identityIndexOf: (list at: i) copy) isZero].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testIdentityIndexOfIfAbsent
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list identityIndexOf: (list at: i) ifAbsent: [-1]) = i;
			assert: (list identityIndexOf: (list at: i) copy ifAbsent: [-1]) = -1].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testIndexOf
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i)) = i;
			assert: (list indexOf: (self listItems at: i)) = i].
	self assert: (list indexOf: self absentListItem) isZero.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testIndexOfIfAbsent
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i) ifAbsent: [-1]) = i;
			assert: (list indexOf: (self listItems at: i) ifAbsent: [-1]) = i].
	self assert: (list indexOf: self absentListItem ifAbsent: [-1]) = -1.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testIndexOfStartingAt
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i) startingAt: i) = i;
			assert: (list indexOf: (list at: i) startingAt: i + 1) isZero].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testIndexOfStartingAtIfAbsent
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assert: (list indexOf: (list at: i) startingAt: i ifAbsent: [-1]) = i;
			assert: (list indexOf: (list at: i) startingAt: i + 1 ifAbsent: [-1]) = -1].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/20/2016 05:35'!
testIndexOfSubCollectionStartingAt
	| list |

	list := self listWithItems.
	1 to: self listItems size do: [:i |
		i to: self listItems size do: [:j |
			self assert:
				(list
					indexOfSubCollection: (self listItems copyFrom: i to: j)
					startingAt: 1) = i.
			self assert:
				(list
					indexOfSubCollection: (self listItems copyFrom: i to: j)
					startingAt: i) = i.
			self assert:
				(list
					indexOfSubCollection: (self listItems copyFrom: i to: j)
					startingAt: i + 1) = 0]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/20/2016 05:36'!
testIndexOfSubCollectionStartingAtIfAbsent
	| list |

	list := self listWithItems.
	1 to: self listItems size do: [:i |
		i to: self listItems size do: [:j |
			self assert:
				(list
					indexOfSubCollection: (self listItems copyFrom: i to: j)
					startingAt: 1
					ifAbsent: [-1]) = i.
			self assert:
				(list
					indexOfSubCollection: (self listItems copyFrom: i to: j)
					startingAt: i
					ifAbsent: [-1]) = i.
			self assert:
				(list
					indexOfSubCollection: (self listItems copyFrom: i to: j)
					startingAt: i + 1
					ifAbsent: [-1]) = -1]].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 2/21/2017 03:50'!
testIsEmpty
	self
		assert: self emptyList isEmpty;
		deny: self listWithSingleItem isEmpty;
		deny: self listWithItems isEmpty! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testLast
	self
		assert: self emptyList last = self defaultValue;
		assert: self listWithItems last = self listItems last.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testLastFew
	| list |

	list := self listWithItems.
	1 to: list size do: [:i |
		self
			assertList: (list last: i)
			copiedFrom: list
			equals: (self listClass newFrom: (self listItemsLast: i)).
		self
			assertList: (list last: list size + i)
			copiedFrom: list
			equals: self listWithItems.
		self
			assertList: (list last: (i * -1))
			copiedFrom: list
			equals: self emptyList].
	self
		assertList: (list last: 0)
		copiedFrom: list
		equals: self emptyList.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testLastIndexOf
	| list |

	list := self listClass newFrom: self listItems, self listItems.
	list do: [:each |
		self assert:
			(list lastIndexOf: each) =
				(self allowsDuplicates
					ifTrue: [self listItems, self listItems lastIndexOf: each]
					ifFalse: [self listItems lastIndexOf: each])].
	self assert: (list lastIndexOf: self newListItem) isZero.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testLastIndexOfIfAbsent
	| list |

	list := self listClass newFrom: self listItems, self listItems.
	list do: [:each |
		self assert:
			(list lastIndexOf: each ifAbsent: [-1]) =
				(self allowsDuplicates
					ifTrue: [self listItems, self listItems lastIndexOf: each]
					ifFalse: [self listItems lastIndexOf: each])].
	self assert: (list lastIndexOf: self newListItem ifAbsent: [-1])  = -1.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 12/14/2014 13:58'!
testNew
	| list |

	list := self listClass new: 20.
	self assert: list = self emptyList.
	self hasCapacity
		ifTrue: [self assert: list capacity >= 20].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testNewFrom
	self assert: (self listClass newFrom: self listItems) = self listWithItems! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testNewWithAll
	| list |

	list := self listClass new: 10 withAll: self singleListItem.
	self allowsDuplicates
		ifTrue: [self assert: list size = 10]
		ifFalse: [self assert: list size = 1].
	self assert: (list allSatisfy: [:each | each = self singleListItem]).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testNinth
	self
		assert: self emptyList ninth = self defaultValue;
		assert: self listWithItems ninth = (self listItems at: 9).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'JAA 3/26/2011 18:32'!
testOfSize
	self assert: (self listClass ofSize: 10) size = 10! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 8/27/2016 20:32'!
testPairsDo
	"does not require the receiver to have an even number of items"

	0 to: self listItems size do: [:i | | list odd even |
		list := self listClass newFrom: (self listItems allButLast: i).
		odd := OrderedCollection new.
		even := OrderedCollection new.
		list withIndexDo: [:each :oddOrEven |
			oddOrEven odd
				ifTrue: [
					oddOrEven < list size
						ifTrue: [odd addLast: each]]
				ifFalse: [even addLast: each]].
		self
			should: [:twoArgumentBlock | list pairsDo: twoArgumentBlock]
			enumerate: odd
			and: even]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 2/28/2017 04:52'!
testReadStream
	| list stream position |

	list := self listWithItems.
	stream := list readStream.
	position := 0.
	self
		assert: stream isStream;
		assert: stream position = 0.
	self listItems do: [:each |
		self
			deny: stream atEnd;
			assert: stream next = each.
		position := position + 1.
		self assert: stream position = position].
	self assert: stream atEnd.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReject
	| list |

	list := self listWithItems.
	self
		assertList: (list reject: [:each | each = self singleListItem])
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self listWithItems copyWithout: self singleListItem)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/18/2016 02:42'!
testRejectThenCollect
	| list |

	list := self listWithItems.
	self
		assertList:
			(list
				reject: [:each | each = self singleListItem]
				thenCollect: [:each | self changedListItem: each])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self changedListItems copyWithout: self changedSingleListItem)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 2/21/2017 03:57'!
testRemoveAll
	| list |

	list := self listWithItems.
	self
		assert: list removeAll == list;
		assert: list isEmpty;
		assert: list removeAll == list;
		assert: list isEmpty.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveAt
	self listItems withIndexDo: [:each :i | | list |
		list := self listWithItems.
		self
			assert: (list removeAt: i) = each;
			assert: (list = (self listClass newFrom: (self listItems copyWithout: each)))].
	self
		should: [self listWithItems removeAt: 0] raise: Error;
		should: [self listWithItems removeAt: self listItems size + 1] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveFirst
	| list |

	list := self listWithItems.
	self listItems do: [:each | 
	self
		assert: list removeFirst = each;
		assert: list = (self listClass newFrom: (self listItems copyAfter: each))].
	self should: [list removeFirst] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveFirstFew
	1 to: self listItems size do: [:i | | list removedElements |
		list := self listWithItems.
		removedElements := list removeFirst: i.
		self
			assert: removedElements asArray = (self listItemsFirst: i);
			assert: list = (self listClass newFrom: (self listItems allButFirst: i));
			assert: (list removeFirst: 0) isEmpty;
			should: [self emptyList removeFirst: i] raise: Error].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:28'!
testRemoveIfAbsent
	| list |

	list := self listWithItems.
	self listItems do: [:each |
		self assert:
			(list
				remove: each
				ifAbsent: [self fail]) = each.
		self deny: (list includes: each).

		self assert:
			(list
				remove: each
				ifAbsent: [self absentListItem]) = self absentListItem].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveLast
	| list |

	list := self listWithItems.
	self listItems reverseDo: [:each |
		self
			assert: list removeLast = each;
			assert: list = (self listClass newFrom: (self listItems copyUpTo: each))].
	self should: [list removeLast] raise: Error.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveLastFew
	| list removedElements |

	1 to: self listItems size do: [:i |
		list := self listWithItems.
		removedElements := list removeLast: i.
		self
			assert: removedElements asArray = (self listItemsLast: i) asArray;
			assert: list = (self listClass newFrom: (self listItems allButLast: i));
			assert: (list removeLast: 0) isEmpty;
			should: [self emptyList removeLast: i] raise: Error].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/1/2016 07:42'!
testReplaceFromToWith
	| list |

	1 to: self listItems size do: [:start |
		start to: self listItems size do: [:stop |
			list := self listWithItems.
			self assert:
				(list
					replaceFrom: start
					to: stop
					with: (self changedListItems allButFirst: start - 1)) == list.

			self
				assertList: list
				replacedItems: self listItems
				withItems: self changedListItems
				from: start
				to: stop.

			start > 1
				ifTrue: [
					self
						should: [
							self emptyList
								replaceFrom: start
								to: stop
								with: self listItems]
						raise: Error]
				ifFalse: [
					self assert:
						(self emptyList
							replaceFrom: start
							to: stop
							with: self listItems) =
								(self listClass newFrom: (self listItemsFirst: stop))]]]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/1/2016 07:42'!
testReplaceFromToWithStartingAt
	1 to: self listItems size do: [:start |
		start to: self listItems size do: [:stop | | list |
			list := self listWithItems.
			self assert:
				(list
					replaceFrom: start
					to: stop
					with: self changedListItems
					startingAt: start) == list.

			self
				assertList: list
				replacedItems: self listItems
				withItems: self changedListItems
				from: start
				to: stop.

			start > 1
				ifTrue: [
					self
						should: [
							self emptyList
								replaceFrom: start
								to: stop
								with: self listItems
								startingAt: start]
						raise: Error]
				ifFalse: [
					self assert:
						(self emptyList
							replaceFrom: start
							to: stop
							with: self listItems
							startingAt: start) =
								(self listClass newFrom: (self listItemsFirst: stop))]]]! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testReset
	| list oldCapacity |

	list := self listWithItems.
	self hasCapacity
		ifTrue: [oldCapacity := list capacity].
	list reset.
	self assert: list isEmpty.
	oldCapacity
		ifNotNil: [self assert: list capacity >= oldCapacity].! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReverse
	| list |

	list := self listWithItems.
	self
		assertList: list reverse
		copiedFrom: list
		equals: (self listClass newFrom: self listItems reverse).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReverseDo
	self
		should: [:block | self emptyList reverseDo: block] enumerate: #();
		should: [:block | self listWithItems reverseDo: block] enumerate: self listItems reversed.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReversed
	| list |

	list := self listWithItems.
	self
		assertList: list reversed
		copiedFrom: list
		equals: (self listClass newFrom: self listItems reversed).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testSecond
	self
		assert: self emptyList second = self defaultValue;
		assert: self listWithItems second = (self listItems at: 2).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testSelect
	| list |

	list := self listWithItems.
	self
		assertList: (list select: [:each | each ~= self singleListItem])
		copiedFrom: list
		equals:
			(self listClass newFrom:
				(self listWithItems copyWithout: self singleListItem)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/18/2016 02:42'!
testSelectThenCollect
	| list |

	list := self listWithItems.
	self
		assertList:
			(list
				select: [:each | each ~= self singleListItem]
				thenCollect: [:each | self changedListItem: each])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self changedListItems copyWithout: self changedSingleListItem)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testSeventh
	self
		assert: self emptyList seventh = self defaultValue;
		assert: self listWithItems seventh = (self listItems at: 7).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testSixth
	self
		assert: self emptyList sixth = self defaultValue;
		assert: self listWithItems sixth = (self listItems at: 6).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testSize
	self
		assert: self emptyList size isZero;
		assert: self listWithSingleItem size = 1;
		assert: self listWithItems size = self listItems size! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testSort
	| list |

	list := self listWithItems.
	self
		assert: list sort == list;
		assert: list = (self listClass newFrom: (self listItems copy sort: self sortBlock));
		assert: (list sort: self reverseSortBlock) == list;
		assert: list = (self listClass newFrom: (self listItems copy sort: self reverseSortBlock)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testSorted
	| list |

	list := self listWithItems.
	self
		assertList: list sorted
		copiedFrom: list
		equals: (self listClass newFrom: (self listItems copy sorted: self sortBlock)).
	self
		assertList: (list sorted: self reverseSortBlock)
		copiedFrom: list
		equals: (self listClass newFrom: (self listItems copy sorted: self reverseSortBlock)).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 10/19/2014 06:27'!
testSpecies
	self
		assert: self emptyList species = self listSpecies! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 8/20/2017 20:48'!
testSwapWith
	| list start end |

	list := self listWithItems.

	start := 1.
	end := list size.
	[start < end]
		whileTrue: [
			list swap: start with: end.
			start := start + 1.
			end := end - 1].
	self assert: list = (self listClass newFrom: self listItems reversed).

	start := 1.
	end := list size.
	[start < end]
		whileTrue: [
			list swap: end with: start.
			start := start + 1.
			end := end - 1].
	self assert: list = self listWithItems.

	1 to: list size do: [:i | list swap: i with: i].
	self assert: list = self listWithItems.

	self
		should: [list swap: 0 with: 1]
		raise: Error.
	self
		should: [list swap: 1 with: 0]
		raise: Error.
	self
		should: [list swap: list size + 1 with: list size]
		raise: Error.
	self
		should: [list swap: list size with: list size + 1]
		raise: Error.
	self assert: list = self listWithItems.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testThird
	self
		assert: self emptyList third = self defaultValue;
		assert: self listWithItems third = (self listItems at: 3).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testWithCollect
	| list |

	list := self listWithItems.
	self
		assertList: (list with: (1 to: list size + 1) collect: [:each :i | each -> i])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self listItems withIndexCollect: [:each :i | each -> i])).
	self
		assertList: (list with: (1 to: list size - 1) collect: [:each :i | each -> i])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self listItems allButLast
					withIndexCollect: [:each :i | each -> i])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testWithDo
	| list enumerated |

	list := self listWithItems.
	enumerated := OrderedCollection new.
	list with: (1 to: list size + 1) do: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listItems withIndexCollect: [:each : i | each -> i ])
				asOrderedCollection.

	enumerated removeAll.
	list with: (1 to: list size - 1) do: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listItems allButLast
				withIndexCollect: [:each : i | each -> i ])
					asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testWithIndexCollect
	| list |

	list := self listWithItems.
	self
		assertList: (list withIndexCollect: [:each :i | each -> i])
		collectedFrom: list
		equals:
			(self listSpecies newFrom:
				(self listItems withIndexCollect: [:each :i | each -> i])).! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testWithIndexDo
	| enumerated |

	enumerated := OrderedCollection new.
	self listWithItems withIndexDo: [:each :i | enumerated addLast: each -> i].
	self assert:
		enumerated =
			(self listItems withIndexCollect: [:each : i | each -> i ]) asOrderedCollection.! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 2/28/2017 13:28'!
testWriteStream
	self
		should: [self emptyList writeStream]
		raise: Error! !

!XMLOrderedListTest methodsFor: 'tests' stamp: 'monty 4/17/2016 13:25'!
testXMLLastOrNil
	self
		assert: self emptyList xmlLastOrNil = self defaultValue;
		assert: self listWithSingleItem xmlLastOrNil = self singleListItem;
		assert: self listWithItems xmlLastOrNil = self listItems last! !

TestCase subclass: #XMLParserExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:35'!
baseURI
	^ 'test.xml'! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:33'!
columnNumber
	^ 10! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:27'!
errorMessage
	^ 'an error occurred'! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:34'!
errorMessageWithBaseURI
	^ '{1} (in {2})'
		format:
			(Array
				with: self errorMessage
				with: self baseURI)! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:34'!
errorMessageWithLineAndColumnNumber
	^ '{1} (near line {2}, column {3})'
		format:
			(Array
				with: self errorMessage
				with: self lineNumber
				with: self columnNumber)! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:34'!
errorMessageWithLineAndColumnNumberAndBaseURI
	^ '{1} (near line {2}, column {3} in {4})'
		format:
			(Array
				with: self errorMessage
				with: self lineNumber
				with: self columnNumber
				with: self baseURI)! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:43'!
errorMessageWithLineNumber
	^ '{1} (near line {2})'
		format:
			(Array
				with: self errorMessage
				with: self lineNumber)! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:43'!
errorMessageWithLineNumberAndBaseURI
	^ '{1} (near line {2} in {3})'
		format:
			(Array
				with: self errorMessage
				with: self lineNumber
				with: self baseURI)! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:36'!
exceptionClass
	^ XMLParserException! !

!XMLParserExceptionTest methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:32'!
lineNumber
	^ 100! !

!XMLParserExceptionTest methodsFor: 'instance creation' stamp: 'monty 9/4/2017 02:40'!
newException
	^ self exceptionClass new! !

!XMLParserExceptionTest methodsFor: 'instance creation' stamp: 'monty 9/4/2017 02:40'!
newExceptionWithErrorMessage
	^ self newException
		messageText: self errorMessage;
		yourself! !

!XMLParserExceptionTest methodsFor: 'tests' stamp: 'monty 9/4/2017 02:39'!
testBaseURI
	| exception |

	exception := self newException.
	self
		assert: exception baseURI = '';
		assert: (exception baseURI: self baseURI) == exception;
		assert: exception baseURI = self baseURI.! !

!XMLParserExceptionTest methodsFor: 'tests' stamp: 'monty 9/4/2017 02:36'!
testColumnNumber
	| exception |

	exception := self newException.
	self
		assert: exception columnNumber isNil;
		assert: (exception columnNumber: self columnNumber) == exception;
		assert: exception columnNumber = self columnNumber.! !

!XMLParserExceptionTest methodsFor: 'tests' stamp: 'monty 9/4/2017 02:39'!
testHasBaseURI
	| exception |

	exception := self newException.
	self deny: exception hasBaseURI.
	
	exception baseURI: self baseURI.
	self assert: exception hasBaseURI.

	exception baseURI: ''.
	self deny: exception hasBaseURI.! !

!XMLParserExceptionTest methodsFor: 'tests' stamp: 'monty 9/4/2017 02:38'!
testHasColumnNumber
	| exception |

	exception := self newException.
	self deny: exception hasColumnNumber.
	
	exception columnNumber: self columnNumber.
	self assert: exception hasColumnNumber.

	exception columnNumber: nil.
	self deny: exception hasColumnNumber.! !

!XMLParserExceptionTest methodsFor: 'tests' stamp: 'monty 9/4/2017 02:37'!
testHasLineNumber
	| exception |

	exception := self newException.
	self deny: exception hasLineNumber.
	
	exception lineNumber: self lineNumber.
	self assert: exception hasLineNumber.

	exception lineNumber: nil.
	self deny: exception hasLineNumber.! !

!XMLParserExceptionTest methodsFor: 'tests' stamp: 'monty 9/4/2017 02:37'!
testLineNumber
	| exception |

	exception := self newException.
	self
		assert: exception lineNumber isNil;
		assert: (exception lineNumber: self lineNumber) == exception;
		assert: exception lineNumber = self lineNumber.! !

!XMLParserExceptionTest methodsFor: 'tests' stamp: 'monty 9/19/2017 10:03'!
testMessageText
	| exception |

	exception := self newExceptionWithErrorMessage.
	self assert: exception messageText = self errorMessage.

	"column numbers without line numbers are ignored"
	(exception := self newExceptionWithErrorMessage)
		columnNumber: self columnNumber.
	self assert: exception messageText = self errorMessage.

	(exception := self newExceptionWithErrorMessage)
		lineNumber: self lineNumber.
	self assert: exception messageText = self errorMessageWithLineNumber.

	(exception := self newExceptionWithErrorMessage)
		baseURI: self baseURI.
	self assert: exception messageText = self errorMessageWithBaseURI.

	(exception := self newExceptionWithErrorMessage)
		lineNumber: self lineNumber;
		columnNumber: self columnNumber.
	self assert: exception messageText = self errorMessageWithLineAndColumnNumber.

	(exception := self newExceptionWithErrorMessage)
		lineNumber: self lineNumber;
		baseURI: self baseURI.
	self assert: exception messageText = self errorMessageWithLineNumberAndBaseURI.

	"column numbers without line numbers are ignored"
	(exception := self newExceptionWithErrorMessage)
		columnNumber: self columnNumber;
		baseURI: self baseURI.
	self assert: exception messageText = self errorMessageWithBaseURI.

	(exception := self newExceptionWithErrorMessage)
		lineNumber: self lineNumber;
		columnNumber: self columnNumber;
		baseURI: self baseURI.
	self assert:
		exception messageText =
			self errorMessageWithLineAndColumnNumberAndBaseURI.! !

TestCase subclass: #XMLParserLimitsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLParserLimitsTest methodsFor: 'source' stamp: 'monty 1/19/2014 04:10'!
recursiveEntitiesNamed: aName depth: aLimit isParameter: aBoolean
	| xml |

	xml := String new writeStream.
	1 to: aLimit do: [:i |
		xml
			cr;
			nextPutAll: '<!!ENTITY '.
		aBoolean
			ifTrue: [xml nextPutAll: '% '].
		xml
			nextPutAll: aName, i printString;
			nextPutAll: ' "'.
			(i = aLimit)
				ifTrue: [xml nextPutAll: '<!!--last-->']
				ifFalse: [
					aBoolean
						ifTrue: [xml nextPutAll: '&#37;']
						ifFalse: [xml nextPut: $&].
					xml
						nextPutAll: aName, (i + 1) printString;
						nextPut: $;].
		xml nextPutAll: '">'].
	^ xml contents.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 11/16/2014 00:24'!
testDocumentReadLimit
	| xml replacement |

	replacement := 'entity replacement'.
	xml := '<!!DOCTYPE test [<!!ENTITY entity "', replacement, '">]><test>&entity;</test>'.
	self
		shouldnt: [
			(SAXHandler on: xml)
				documentReadLimit: xml size + replacement size;
				parseDocument]
		raise: XMLLimitException.
	self
		should: [
			(SAXHandler on: xml)
				documentReadLimit: xml size + replacement size - 1;
				parseDocument]
		raise: XMLLimitException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				documentReadLimit: nil;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 03:54'!
testRecursiveGeneralEntityReplacement
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit
			isParameter: false.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 22:50'!
testRecursiveGeneralEntityReplacementPastLimit
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit + 1
			isParameter: false.
	self
		should: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: nil;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 03:56'!
testRecursiveParameterEntityReplacement
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit
			isParameter: true.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 1/19/2014 22:49'!
testRecursiveParameterEntityReplacementPastLimit
	| limit xml |

	limit := 3.
	xml :=
		self
			xmlWithRecursiveEntitiesNamed: 'entity'
			depth: limit + 1
			isParameter: true.
	self
		should: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: limit;
				parseDocument]
		raise: XMLLimitException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				maxEntityReplacementDepth: nil;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 6/26/2016 22:59'!
testResolvingLocalFromNonLocal
	| parser |

	self
		should: [
			(parser :=
				SAXHandler
					on: '<!!DOCTYPE root SYSTEM "file://local/uri">'
					documentURI: 'http://www.example.com')
				externalEntityResolver resolvesLocalFromNonLocal: false.
			parser
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'tests' stamp: 'monty 3/20/2016 18:45'!
testStreamReaderMaxPushBack
	| streamReader |

	streamReader := XMLNestedStreamReader on: '' readStream.
	self
		shouldnt: [
			streamReader maxNestedStreams
				timesRepeat: [streamReader pushBack: 'test']]
		raise: XMLLimitException.
	self
		should: [streamReader pushBack: 'test']
		raise: XMLLimitException.! !

!XMLParserLimitsTest methodsFor: 'source' stamp: 'monty 3/7/2016 20:08'!
xmlWithRecursiveEntitiesNamed: aName depth: aLimit isParameter: aBoolean
	| xml |

	(xml := String new writeStream)
		nextPutAll: '<!!DOCTYPE test ['.
	xml nextPutAll:
		(self
			recursiveEntitiesNamed: aName
			depth: aLimit
			isParameter: aBoolean).
	aBoolean
		ifTrue: [xml nextPutAll: '%', aName, '1;]><test/>']
		ifFalse: [xml nextPutAll: ']><test>&', aName, '1;</test>'].

	^ xml contents.! !

TestCase subclass: #XMLParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLParserTest class methodsFor: 'source' stamp: 'monty 6/22/2016 18:29'!
addressBookNamespacePrefixedXML
	"
	| xmlWithPrefixes |

	xmlWithPrefixes := self addressBookNamespacedXML.
	#('<addressbook' '</addressbook' '<person' '</person' 'family-name=' 'first-name=')
		with: #('<book:addressbook' '</book:addressbook' '<ps:person' '</ps:person' 'ps:family-name=' 'ps:first-name=')
		do: [:source :replacement |
			xmlWithPrefixes := xmlWithPrefixes copyReplaceAll: source with: replacement].
	^ xmlWithPrefixes.
	"

	^  '<book:addressbook xmlns=''defaultNS'' xmlns:book=''bookNS'' xmlns:ps=''personNS''>
  <ps:person employee-number="A0000" ps:family-name="Gates" ps:first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </ps:person>
  <ps:person employee-number="A7000" ps:family-name="Brown"
    ps:first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </ps:person>
  <ps:person employee-number="A7890" ps:family-name="DePaiva"
    ps:first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </ps:person>
  <ps:person employee-number="A7987" ps:family-name="Smith" ps:first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </ps:person>
</book:addressbook>
'! !

!XMLParserTest class methodsFor: 'source' stamp: 'monty 6/22/2016 18:31'!
addressBookNamespacedXML
	"
	^ '<addressbook xmlns=''defaultNS'' xmlns:book=''bookNS'' xmlns:ps=''personNS''>',
		(self addressBookXML copyAfter: $>)
	"

	^ '<addressbook xmlns=''defaultNS'' xmlns:book=''bookNS'' xmlns:ps=''personNS''>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!XMLParserTest class methodsFor: 'source' stamp: 'monty 1/12/2014 23:36'!
addressBookXML
	^'<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!XMLParserTest class methodsFor: 'source' stamp: 'monty 1/12/2014 23:36'!
addressBookXMLWithDTD
	^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE addressbook SYSTEM "addressbook.dtd">
<?xml-stylesheet type="text/xsl" href="demo.xsl"?>
<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!XMLParserTest class methodsFor: 'source' stamp: 'monty 4/6/2017 00:08'!
internalSubsetXMLWithDeclarations
	^ '<!!DOCTYPE root PUBLIC "pubid" "external.dtd" [
			<!!ELEMENT root ( #PCDATA | one | two)* >
			<!!ATTLIST root
						name CDATA #IMPLIED
						number ( one | two | three ) "three">
			<!!ENTITY general "replacement">
			<!!ENTITY externalGeneral PUBLIC "pubid2" "external1.dtd">
			<!!ENTITY % parameter "replacement">
			<!!ENTITY % externalParameter SYSTEM "external2.dtd">
			<!!NOTATION notation SYSTEM "note.doc">
		]>
		<root>test</root>'! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 6/22/2016 18:24'!
addressBookNamespacePrefixedXML
	^ self class addressBookNamespacePrefixedXML! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 6/22/2016 18:24'!
addressBookNamespacedXML
	^ self class addressBookNamespacedXML! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 1/12/2014 23:36'!
addressBookXML
	^ self class addressBookXML! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 1/12/2014 23:37'!
addressBookXMLWithDTD
	^ self class addressBookXMLWithDTD! !

!XMLParserTest methodsFor: 'accessing' stamp: 'monty 4/9/2016 00:56'!
badNameAttributeListValues
	^ self badNameAttributeValues reject: [:badNameAttributeValue |
		badNameAttributeValue allSatisfy: [:each | each isXMLWhitespace]]! !

!XMLParserTest methodsFor: 'accessing' stamp: 'monty 4/9/2016 00:56'!
badNameAttributeValues
	^ self badNames reject: [:badName |
		(badName includes: $<)
			or: [badName anySatisfy: [:each | each isXMLChar not]]]! !

!XMLParserTest methodsFor: 'accessing' stamp: 'monty 4/9/2016 00:51'!
badNames
	^ XMLStringMethodsTest badNames! !

!XMLParserTest methodsFor: 'accessing' stamp: 'monty 4/9/2016 00:56'!
badNmtokenAttributeListValues
	^ self badNmtokenAttributeValues reject: [:badNmtokenAttributeValue |
		badNmtokenAttributeValue allSatisfy: [:each | each isXMLWhitespace]]! !

!XMLParserTest methodsFor: 'accessing' stamp: 'monty 4/9/2016 00:57'!
badNmtokenAttributeValues
	^ self badNmtokens reject: [:badName |
		(badName includes: $<)
			or: [badName anySatisfy: [:each | each isXMLChar not]]]! !

!XMLParserTest methodsFor: 'accessing' stamp: 'monty 4/9/2016 00:51'!
badNmtokens
	^ XMLStringMethodsTest badNmtokens! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'JAA 3/24/2011 18:26'!
benchmark1
	"
	XMLParserTest new benchmark1
	600 timesRepeat => 2131 (Alexandre Bergel 3/29/2010 09:09)
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [SAXHandler parse: self addressBookXML]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'JAA 3/24/2011 18:26'!
benchmark2
	"
	XMLParserTest new benchmark2
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [XMLDOMParser parse: self addressBookXML]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 2/6/2014 19:17'!
benchmark3
	"
	XMLParserTest new benchmark3
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [XMLDOMParser parse: self addressBookXMLWithDTD]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 11/16/2013 07:34'!
benchmark4
	| doc |
	"
	XMLParserTest new benchmark4
	"
	doc := XMLDOMParser
		parse: self addressBookXML readStream
		usingNamespaces: false.
	^ [500000 timesRepeat: [
		doc root firstElement
			elementAt: 'contact-info';
			elementAt: 'address';
			elementAt: 'job-info';
			elementAt: 'manager']] timeToRun.! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 6/24/2016 03:01'!
benchmark5
	"
	XMLParserTest new benchmark5
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [XMLDOMParser parse: self addressBookNamespacedXML]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 6/24/2016 03:01'!
benchmark6
	"
	XMLParserTest new benchmark6
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [XMLDOMParser parse: self addressBookNamespacePrefixedXML]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 8/14/2016 18:25'!
benchmark7
	"
	XMLParserTest new benchmark7
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [SAX2Parser parse: self addressBookXML]] timeToRun! !

!XMLParserTest methodsFor: 'benchmark' stamp: 'monty 8/16/2016 00:04'!
benchmark8
	"
	XMLParserTest new benchmark8
	"
	Smalltalk garbageCollect.
	^ [4000 timesRepeat: [SAX2ElementParser parse: self addressBookXML]] timeToRun! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 12/19/2013 02:04'!
elementDeclarationsNamed: aNameCollection
	| stream |

	stream := String new writeStream.
	aNameCollection do: [:each |
		stream
			nextPutAll: '<!!ELEMENT ';
			nextPutAll: each;
			nextPutAll: ' EMPTY>';
			cr].
	^ stream contents.! !

!XMLParserTest methodsFor: 'source' stamp: 'monty 4/6/2017 00:08'!
internalSubsetXMLWithDeclarations
	^ self class internalSubsetXMLWithDeclarations! !

!XMLParserTest methodsFor: 'accessing' stamp: 'monty 5/3/2017 22:49'!
nonChars
	^ XMLCharacterMethodsTest nonChars! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:51'!
testAttributeBadName
	self badNames do: [:each |
		self
			should: [SAXHandler parse: '<test ', each, '="value"/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:29'!
testAttributeDeclarationEntities
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!NOTATION first SYSTEM "first.txt">
			<!!NOTATION second SYSTEM "second.txt">
			<!!ENTITY firstEntity SYSTEM "first.txt" NDATA first>
			<!!ENTITY secondEntity SYSTEM "second.txt" NDATA second>
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root unparsedEntities ENTITIES #IMPLIED>
		]>'.
	#('<root unparsedEntities="firstEntity" />'
		'<root unparsedEntities=" secondEntity " />'
		'<root unparsedEntities="firstEntity secondEntity" />'
		'<root unparsedEntities=" firstEntity secondEntity " />')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].

	#('<root unparsedEntities="firstEntity secondEntity thirdEntity" />'
		'<root unparsedEntities="thirdEntity" />'
		'<root unparsedEntities="" />')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:31'!
testAttributeDeclarationEntity
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!NOTATION first SYSTEM "first.txt">
			<!!NOTATION second SYSTEM "second.txt">
			<!!ENTITY firstEntity SYSTEM "first.txt" NDATA first>
			<!!ENTITY secondEntity SYSTEM "second.txt" NDATA second>
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root unparsedEntity ENTITY #IMPLIED>
		]>'.
	#('<root unparsedEntity="firstEntity" />'
		'<root unparsedEntity=" secondEntity " />')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].

	#('<root unparsedEntity="thirdEntity" />'
		'<root unparsedEntity="" />')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:31'!
testAttributeDeclarationEnumeration
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root ANY>
			<!!ATTLIST root number ( one | two | three) #IMPLIED>
		]>'.
	#('one'
		'two'
		'three'
		'  one  '
		'		two 	'
		'
		three
		') do: [:each |
		self
			shouldnt: [SAXHandler parse: dtd, '<root number="', each, '"/>']
			raise: XMLValidationException].

	#('<root number="four"/>'
		'<root number=""/>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 11:54'!
testAttributeDeclarationEnumerationValueRedundance
	| xml |

	xml := '
		<!!DOCTYPE root [
			<!!ELEMENT root ANY>
			<!!ATTLIST root number ( one | two | one ) #IMPLIED>
		]><root/>'.
	self
		should: [SAXHandler parse: xml]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:07'!
testAttributeDeclarationID
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root (unique|unique2)+>
			<!!ELEMENT unique EMPTY>
			<!!ELEMENT unique2 EMPTY>
			<!!ATTLIST unique id ID #REQUIRED>
			<!!ATTLIST unique2 id ID #IMPLIED>
		]>'.
	self
		shouldnt: [
			SAXHandler parse:
				dtd,
				'<root>
					<unique id=" one "/><unique id="two"/>
					<unique2 id="three"/>
				</root>']
		raise: XMLValidationException.

	#('<root><unique id="one"/><unique id=" one "/><unique2 id="three"/></root>'
		'<root><unique id="one"/><unique id="two"/><unique2 id=" one "/></root>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].

	"ID attributes can't have defaults values or #FIXED defaults
	and must be #REQUIRED or #IMPLIED"
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ELEMENT root ANY>
					<!!ELEMENT unique EMPTY>
					<!!ATTLIST unique id ID #FIXED "one">]>
					<root/>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ELEMENT root ANY>
					<!!ELEMENT unique EMPTY>
					<!!ATTLIST unique id ID "one">]>
					<root/>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:07'!
testAttributeDeclarationIDRef
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root (unique|ref)+>
			<!!ELEMENT unique EMPTY>
			<!!ELEMENT ref EMPTY>
			<!!ELEMENT refs EMPTY>
			<!!ATTLIST unique id ID #REQUIRED>
			<!!ATTLIST ref idref IDREF #REQUIRED>
		]>'.
	self
		shouldnt: [
			SAXHandler parse:
				dtd, '
				<root>
					<unique id=" one "/><ref idref="one"/>
					<ref idref=" two "/><unique id="two"/>
				</root>']
		raise: XMLValidationException.

	#('<root><unique id="one"/><ref idref="two"/></root>'
		'<root><ref idref="one"/></root>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:07'!
testAttributeDeclarationIDRefs
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root (unique|ref)+>
			<!!ELEMENT unique EMPTY>
			<!!ELEMENT ref EMPTY>
			<!!ELEMENT refs EMPTY>
			<!!ATTLIST unique id ID #REQUIRED>
			<!!ATTLIST ref idrefs IDREFS #REQUIRED>
		]>'.
	self
		shouldnt: [
			SAXHandler parse:
				dtd, '
				<root>
					<unique id=" one "/><ref idrefs="one"/>
					<ref idrefs=" two "/><ref idrefs="one two"/>
					<ref idrefs=" two one "/><unique id="two"/>
				</root>']
		raise: XMLValidationException.

	#('<root><unique id="one"/><ref idrefs="one two"/></root>'
		'<root><ref idrefs="one"/></root>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 12:55'!
testAttributeDeclarationNmtoken
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root ANY>
			<!!ATTLIST root name NMTOKEN #IMPLIED>
		]>'.
	#('<root name="one"/>'
		'<root name=" two "/>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].

	#('<root name="one two three"/>'
		'<root name="one#"/>'
		'<root name="#"/>'
		'<root name=""/>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 12:57'!
testAttributeDeclarationNmtokens
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root ANY>
			<!!ATTLIST root names NMTOKENS #IMPLIED>
		]>'.
	#('<root names="one"/>'
		'<root names="one two three"/>'
		'<root names=" one "/>'
		'<root names=" one two three "/>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].

	#('<root names="one two three#"/>'
		'<root names="one#"/>'
		'<root names="#"/>'
		'<root names=""/>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:08'!
testAttributeDeclarationNotation
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!NOTATION txtFile PUBLIC "//file.txt//">
			<!!NOTATION confFile PUBLIC "//file.conf//">
			<!!ELEMENT root ANY>
			<!!ATTLIST root note NOTATION (txtFile | confFile ) #IMPLIED>
		]>'.
	#('txtFile' 'confFile' ' 	txtFile ' '
		confFile 	')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, '<root note="', each, '"/>']
				raise: XMLValidationException].

	#('<root note="htmlFile" />'
		'<root note="" />')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 11:49'!
testAttributeDeclarationNotationDeclared
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!NOTATION txtFile PUBLIC "//file.txt//">
			<!!NOTATION confFile PUBLIC "//file.conf//">
			<!!ELEMENT root ANY>
			<!!ATTLIST root note NOTATION {1} #IMPLIED>
		]><root note="txtFile"/>'.

	"event if the value used in the attribute is declared, all values
	in the NOTATION enumeration list must be declared too"
	#('(txtFile | htmlFile)' '(zipFile)' '(htmlFile | confFile)')
		do: [:each | | xml |
			xml := xmlTemplate format: (Array with: each).
			self
				should: [SAXHandler parse: xml]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 11:49'!
testAttributeDeclarationNotationRedundance
	"only one notation attribute is allowed per element"
	| xml |

	xml := '
		<!!DOCTYPE root [
			<!!NOTATION txtFile PUBLIC "//file.txt//">
			<!!NOTATION confFile PUBLIC "//file.conf//">
			<!!NOTATION txtFile2 PUBLIC "//file.txt//">
			<!!NOTATION confFile2 PUBLIC "//file.conf//">
			<!!ELEMENT root ANY>
			<!!ATTLIST root
				note NOTATION (txtFile | confFile) #IMPLIED
				note2 NOTATION (txtFile2 | confFile2) #IMPLIED>
		]><root/>'.
	self
		should: [SAXHandler parse: xml]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 11:54'!
testAttributeDeclarationNotationValueRedundance
	| xml |

	xml := '
		<!!DOCTYPE root [
			<!!NOTATION txtFile PUBLIC "//file.txt//">
			<!!NOTATION confFile PUBLIC "//file.conf//">
			<!!ELEMENT root ANY>
			<!!ATTLIST root
				note NOTATION (txtFile | confFile | txtFile) #IMPLIED>
		]><root/>'.
	self
		should: [SAXHandler parse: xml]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:10'!
testAttributeDeclarationPrefixed
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!ELEMENT root EMPTY>
		<!!ATTLIST root
			xmlns:prefix CDATA #IMPLIED
			prefix:name CDATA #IMPLIED
			unprefixed CDATA #IMPLIED>
		]>'.

	#('<root xmlns:prefix="prefixNS" prefix:name="value" unprefixed="value"/>'
		'<root xmlns:prefix="prefixNS" prefix:name="value" />'
		'<root unprefixed="value" />'
		'<root/>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].

	"valid, but a namespace exception"
	self
		should: [SAXHandler parse: dtd, '<root prefix:name="value"/>']
		raise: XMLNamespaceException.
	self
		shouldnt: [
			(SAXHandler on: dtd, '<root prefix:name="value"/>')
				usesNamespaces: false;
				parseDocument]
		raise: XMLNamespaceException.

	#('<root xmlns:prefix="prefixNS" prefix:name="value" prefix:unprefixed="value"/>'
		'<root name="value" unprefixed="value" />')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/13/2016 05:27'!
testAttributeDeclarationPrefixedDefault
	| dtd |

	dtd := '<!!DOCTYPE root [
		<!!ELEMENT root EMPTY>
		<!!ATTLIST root
			xmlns:prefix CDATA #FIXED "prefixNS"
			prefix:name CDATA "value"
			unprefixed CDATA "value">
		]>'.

	#('<root xmlns:prefix="prefixNS" prefix:name="value" unprefixed="value"/>'
		'<root prefix:name="value" unprefixed="value"/>'
		'<root xmlns:prefix="prefixNS" />'
		'<root prefix:name="value"/>'
		'<root unprefixed="value"/>'
		'<root/>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].

	#('<root name="value" />'
		'<root xmlns:prefix="newPrefixNS" />'
		'<root prefix:unprefixed="value" />')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 9/16/2017 02:00'!
testAttributeDeclarationRedundance
	"additional declarations for the same attribute are ignored"

	| dtd resolver |

	dtd := '
		<!!DOCTYPE root SYSTEM "extern.dtd" [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root redundant CDATA #IMPLIED>
			<!!ATTLIST root redundant IDREF #FIXED "two">
		]>'.
	(resolver := DTDStaticExternalEntityResolver new)
		externalEntityAtURI: 'extern.dtd'
		put: '<!!ATTLIST root redundant ENTITY #REQUIRED>'.
	#('<root redundant="one"/>'
		'<root/>')
		do: [:each |
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						externalEntityResolver: resolver;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 20:23'!
testAttributeDeclarationWhitespace
	#('<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLISTtest name (value) #FIXED "value">]>'
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test name(value) #FIXED "value">]>'
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test name (value)#FIXED "value">]>'
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test name (value) #FIXED"value">]>'
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test name (value) #FIXED "value"name2
			(value) #FIXED "value">]>')
		do: [:each |
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].
	#('<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST   test   name  ( value )  #FIXED  "value">]>'
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test
				name (value) #FIXED "value"
				name2 (value) #FIXED "value">]>'
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST   test   >]>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/21/2016 18:57'!
testAttributeDefaultFixedValue
	| dtd document root |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root
				one CDATA #FIXED "fixedDefault"
				one CDATA #FIXED "redundant"
				two IDREF #FIXED "fixedDefaultTwo"
				three CDATA #FIXED ""
				four ID #REQUIRED >
		]>'.

	#(true false) do: [:isValidating |
		document :=
			(XMLDOMParser on:
				dtd,
				'<root ',
				'	one=''fixedDefault'' ',
				'	two=" fixedDefaultTwo  " ',
				'	three="" ',
				'four="fixedDefaultTwo"/>')
				isValidating: isValidating;
				parseDocument.
		root := document root.
		self
			assert: (root attributeAt: 'one') = 'fixedDefault';
			assert: (root attributeAt: 'two') = 'fixedDefaultTwo';
			assert: (root includesAttribute: 'three');
			assert: (root attributeAt: 'three') = '';
			assert: (root attributeAt: 'four') = 'fixedDefaultTwo'.

		"attributes with fixed defaults are set automatically if not present"
		document :=
			(XMLDOMParser on: dtd, '<root four="fixedDefaultTwo"/>')
				isValidating: isValidating;
				parseDocument.
		root := document root.
		self
			assert: (root attributeAt: 'one') = 'fixedDefault';
			assert: (root attributeAt: 'two') = 'fixedDefaultTwo';
			assert: (root includesAttribute: 'three');
			assert: (root attributeAt: 'three') = ''].

	"but if present cannot have non-default values"
	#('one' 'two' 'three')
		with: #('fixedDefault' 'fixedDefaultTwo' '')
		do: [:name :fixedDefault | | xml |
			xml := dtd, '<root ', name, '="nonDefault"/>'.
			self
				should: [SAXHandler parse: xml]
				raise: XMLValidationException.
			self
				shouldnt: [
					document :=
						(XMLDOMParser on: xml)
							isValidating: false;
							parseDocument]
				raise: XMLValidationException.
			root := document root.
			self
				assert: (root attributeAt: 'one') = 'fixedDefault';
				assert: (root attributeAt: 'two') = 'fixedDefaultTwo';
				assert: (root includesAttribute: 'three');
				assert: (root attributeAt: 'three') = ''].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/19/2017 17:35'!
testAttributeDefaultFixedValueEntityReference
	"tests that general entities referenced in attribute declaration #FIXED
	default values were declared before the declaration is parsed"

	#('<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one CDATA #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">'
		"no ID test because they can't have default values, but IDREF/IDREFS can"
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one IDREF #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two ID #REQUIRED>'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one IDREFS #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two ID #REQUIRED>'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!NOTATION note PUBLIC "note.txt">
			<!!ENTITY value PUBLIC "note.txt" "note.txt" NDATA note>
			<!!ATTLIST one one ENTITY #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!NOTATION note PUBLIC "note.txt">
			<!!ENTITY value PUBLIC "note.txt" "note.txt" NDATA note>
			<!!ATTLIST one one ENTITIES #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one NMTOKEN #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one NMTOKENS #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one (value) #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!NOTATION value PUBLIC "note.txt">
			<!!ATTLIST one one NOTATION (value) #FIXED "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">')
	do: [:each | | badSubset goodSubset badContent goodContent document|
		"the 'undeclared' entity declaration must come before
		the rest of the subset for it to be OK"
		badSubset := each, '<!!ENTITY undeclared "value">'.
		goodSubset := '<!!ENTITY undeclared "value">', each.
		badContent :=
			'<root>
				<one one="otherValue"/><!!--override the #FIXED default value-->
				<two two="value"/><!!--don''t override the #FIXED default value-->
			</root>'.
		goodContent :=
			'<root>
				<one/><!!--inherit the #FIXED default value-->
				<two two="value"/><!!--don''t override the #FIXED default value-->
			</root>'.

		self
			should: [
				SAXHandler parse: '<!!DOCTYPE root [', badSubset, ']>', goodContent]
			raise: XMLWellFormednessException.
		self
			should: [
				(SAXHandler on: '<!!DOCTYPE root SYSTEM "extern.dtd">', goodContent)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities:
							(Array with: 'extern.dtd' -> badSubset));
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLValidationException.

		self
			shouldnt: [
				document :=
					(XMLDOMParser on:
						'<!!DOCTYPE root SYSTEM "extern.dtd">', goodContent)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> badSubset));
						resolvesExternalEntities: true;
						isValidating: false;
						parseDocument]
			raise: XMLValidationException.
		self
			assert: ((document root elementAt: 'one') attributeAt: 'one') = '';
			assert: ((document root elementAt: 'two') attributeAt: 'two') = 'value'.

		self
			shouldnt: [
				document :=
					XMLDOMParser parse:
						'<!!DOCTYPE root [', goodSubset, ']>', goodContent]
			raise: XMLValidationException.
		self
			assert: ((document root elementAt: 'one') attributeAt: 'one') = 'value';
			assert: ((document root elementAt: 'two') attributeAt: 'two') = 'value'.

		self
			shouldnt: [
				document :=
					(XMLDOMParser on:
						'<!!DOCTYPE root SYSTEM "extern.dtd">', goodContent)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> goodSubset));
						resolvesExternalEntities: true;
						parseDocument]
			raise: XMLValidationException.
		self
			assert: ((document root elementAt: 'one') attributeAt: 'one') = 'value';
			assert: ((document root elementAt: 'two') attributeAt: 'two') = 'value'.

		"#FIXED default values cannot be changed"
		self
			should: [SAXHandler parse: '<!!DOCTYPE root [', goodSubset, ']>', badContent]
			raise: XMLValidationException.
		self
			should: [
				(SAXHandler on: '<!!DOCTYPE root SYSTEM "extern.dtd">', badContent)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities:
							(Array with: 'extern.dtd' -> goodSubset));
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLValidationException.

		"...unless validation is off"
		self
			shouldnt: [
				(SAXHandler on: '<!!DOCTYPE root [', goodSubset, ']>', badContent)
					isValidating: false;
					parseDocument]
			raise: XMLValidationException.
		self
			shouldnt: [
				(SAXHandler on: '<!!DOCTYPE root SYSTEM "extern.dtd">', badContent)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities:
							(Array with: 'extern.dtd' -> goodSubset));
					resolvesExternalEntities: true;
					isValidating: false;
					parseDocument]
			raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:27'!
testAttributeDefaultImplied
	| dtd document root |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root
				one CDATA #IMPLIED
				one CDATA #REQUIRED
				two CDATA #IMPLIED >
		]>'.

	document :=
		XMLDOMParser parse:
			dtd, '<root one=''nonDefault'' two="nonDefaultTwo" />'.
	root := document root.
	self
		assert: (root attributeAt: 'one') = 'nonDefault';
		assert: (root attributeAt: 'two') = 'nonDefaultTwo'.

	document := XMLDOMParser parse: dtd, '<root one='''' two="" />'.
	root := document root.
	self
		assert: (root includesAttribute: 'one');
		assert: (root attributeAt: 'one') = '';
		assert: (root includesAttribute: 'two');
		assert: (root attributeAt: 'two') = ''.

	"implied makes them optional"
	document := XMLDOMParser parse: dtd, '<root />'.
	root := document root.
	self
		deny: (root includesAttribute: 'one');
		deny: (root includesAttribute: 'two').! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:27'!
testAttributeDefaultRequired
	| dtd document root |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root
				one CDATA #REQUIRED
				one CDATA #IMPLIED
				two CDATA #REQUIRED >
		]>'.

	document :=
		XMLDOMParser parse:
			dtd, '<root one=''nonDefault'' two="nonDefaultTwo" />'.
	root := document root.
	self
		assert: (root attributeAt: 'one') = 'nonDefault';
		assert: (root attributeAt: 'two') = 'nonDefaultTwo'.

	"empty values still count as being present"
	document := XMLDOMParser parse: dtd, '<root one='''' two="" />'.
	root := document root.
	self
		assert: (root includesAttribute: 'one');
		assert: (root attributeAt: 'one') = '';
		assert: (root includesAttribute: 'two');
		assert: (root attributeAt: 'two') = ''.

	"all required attributes must be present"
	#('<root one="nonDefault" />'
		'<root two="nonDefault" />') do: [:each |
		self
			should: [SAXHandler parse: dtd, each]
			raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/21/2016 19:00'!
testAttributeDefaultValue
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root
				one CDATA "default"
				one CDATA "redundant"
				two CDATA ""
				three NMTOKEN " defaultThree " >
		]>'.

	#(true false) do: [:isValidating | | document root |
		document :=
			(XMLDOMParser on:
				dtd,
				'<root ',
				'	one=''nonDefault'' ',
				'	two="nonDefaultTwo" ',
				'	three="nonDefaultThree"/>')
				isValidating: isValidating;
				parseDocument.
		root := document root.
		self
			assert: (root attributeAt: 'one') = 'nonDefault';
			assert: (root attributeAt: 'two') = 'nonDefaultTwo';
			assert: (root attributeAt: 'three') = 'nonDefaultThree'.

		"empty but present attributes shouldn't get the default value"
		document := XMLDOMParser parse: dtd, '<root one='''' two=""/>'.
		root := document root.
			self
				assert: (root includesAttribute: 'one');
				assert: (root attributeAt: 'one') = '';
				assert: (root includesAttribute: 'two');
				assert: (root attributeAt: 'two') = '';
				assert: (root attributeAt: 'three') = 'defaultThree'.

		"attributes with defaults are set automatically if not present"
		document := XMLDOMParser parse: dtd, '<root />'.
		root := document root.
		self
			assert: (root attributeAt: 'one') = 'default';
			assert: (root includesAttribute: 'two');
			assert: (root attributeAt: 'two') = '';
			assert: (root attributeAt: 'three') = 'defaultThree'].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:58'!
testAttributeDefaultValueEntities
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!NOTATION note PUBLIC "note">
			<!!ENTITY one PUBLIC "one" "" NDATA note>
			<!!ATTLIST root entity ENTITIES " one {1} ">
		]><root entity="one" />'.

	self badNameAttributeListValues do: [:each |
		self
			should: [		
				SAXHandler parse:
					(xmlTemplate format: (Array with: each))]
			raise: XMLValidationException.
		self
			shouldnt: [
				(SAXHandler on:
					(xmlTemplate format: (Array with: each)))
					isValidating: false;
					parseDocument]
			raise: XMLValidationException.].
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'two'))]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:58'!
testAttributeDefaultValueEntity
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!NOTATION note PUBLIC "note">
			<!!ENTITY one PUBLIC "one" "" NDATA note>
			<!!ATTLIST root entity ENTITY "{1}">
		]><root entity="one" />'.

	self badNameAttributeValues do: [:each |
		self
			should: [		
				SAXHandler parse:
					(xmlTemplate format: (Array with: each))]
			raise: XMLValidationException.
		self
			shouldnt: [
				(SAXHandler on:
					(xmlTemplate format: (Array with: each)))
					isValidating: false;
					parseDocument]
			raise: XMLValidationException.].
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'one'))]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/19/2017 17:37'!
testAttributeDefaultValueEntityReference
	"tests that general entities referenced in attribute declaration default
	values were declared before the declaration is parsed"

	#('<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one CDATA "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA "otherValue">'
		"no ID test because they can't have default values, but IDREF/IDREFS can"
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one IDREF "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two ID #REQUIRED>'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one IDREFS "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two ID #REQUIRED>'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!NOTATION note PUBLIC "note.txt">
			<!!ENTITY value PUBLIC "note.txt" "note.txt" NDATA note>
			<!!ATTLIST one one ENTITY "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA "otherValue">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!NOTATION note PUBLIC "note.txt">
			<!!ENTITY value PUBLIC "note.txt" "note.txt" NDATA note>
			<!!ATTLIST one one ENTITIES "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA "otherValue">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one NMTOKEN "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA #FIXED "value">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one NMTOKENS "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA "otherValue">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ATTLIST one one (value) "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA "otherValue">'
		'<!!ELEMENT root (one,two)>
			<!!ELEMENT one EMPTY>
			<!!NOTATION value PUBLIC "note.txt">
			<!!ATTLIST one one NOTATION (value) "&undeclared;">
			<!!ELEMENT two EMPTY>
			<!!ATTLIST two two CDATA "otherValue">')
	do: [:each | | badSubset goodSubset content document|
		"the 'undeclared' entity declaration must come before
		the rest of the subset for it to be OK"
		badSubset := each, '<!!ENTITY undeclared "value">'.
		goodSubset := '<!!ENTITY undeclared "value">', each.
		content :=
			'<root>
				<one/><!!--inherit the default value-->
				<two two="value"/><!!--override the default value-->
			</root>'.

		self
			should: [SAXHandler parse: '<!!DOCTYPE root [', badSubset, ']>', content]
			raise: XMLWellFormednessException.
		self
			should: [
				(SAXHandler on: '<!!DOCTYPE root SYSTEM "extern.dtd">', content)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities:
							(Array with: 'extern.dtd' -> badSubset));
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLValidationException.

		self
			shouldnt: [
				document :=
					(XMLDOMParser on: '<!!DOCTYPE root SYSTEM "extern.dtd">', content)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> badSubset));
						resolvesExternalEntities: true;
						isValidating: false;
						parseDocument]
			raise: XMLValidationException.
		self
			assert: ((document root elementAt: 'one') attributeAt: 'one') = '';
			assert: ((document root elementAt: 'two') attributeAt: 'two') = 'value'.

		self
			shouldnt: [
				document :=
					XMLDOMParser parse: '<!!DOCTYPE root [', goodSubset, ']>', content]
			raise: XMLValidationException.
		self
			assert: ((document root elementAt: 'one') attributeAt: 'one') = 'value';
			assert: ((document root elementAt: 'two') attributeAt: 'two') = 'value'.

		self
			shouldnt: [
				document :=
					(XMLDOMParser on: '<!!DOCTYPE root SYSTEM "extern.dtd">', content)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> goodSubset));
						resolvesExternalEntities: true;
						parseDocument]
			raise: XMLValidationException.
		self
			assert: ((document root elementAt: 'one') attributeAt: 'one') = 'value';
			assert: ((document root elementAt: 'two') attributeAt: 'two') = 'value']! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/7/2016 07:49'!
testAttributeDefaultValueEnumeration
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root name (one|two|three) " {1} ">
		]><root name="one" />'.

	self
		should: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'four'))]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on:
				(xmlTemplate format: (Array with: 'four')))
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'one'))]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:58'!
testAttributeDefaultValueIDRef
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root
				id ID #REQUIRED
				idref IDREF "{1}">
		]><root id="one" idref="one" />'.

	self badNameAttributeValues do: [:each |
		self
			should: [		
				SAXHandler parse:
					(xmlTemplate format: (Array with: each))]
			raise: XMLValidationException.
		self
			shouldnt: [
				(SAXHandler on:
					(xmlTemplate format: (Array with: each)))
					isValidating: false;
					parseDocument]
			raise: XMLValidationException.].
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'one'))]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:58'!
testAttributeDefaultValueIDRefs
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root
				id ID #REQUIRED
				idref IDREFS " one {1} ">
		]><root id="one" idref="one" />'.

	self badNameAttributeListValues do: [:each |
		self
			should: [		
				SAXHandler parse:
					(xmlTemplate format: (Array with: each))]
			raise: XMLValidationException.
		self
			shouldnt: [
				(SAXHandler on:
					(xmlTemplate format: (Array with: each)))
					isValidating: false;
					parseDocument]
			raise: XMLValidationException.].
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'two'))]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:58'!
testAttributeDefaultValueNmtoken
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root name NMTOKEN "{1}">
		]><root name="one" />'.

	self badNmtokenAttributeValues do: [:each |
		self
			should: [		
				SAXHandler parse:
					(xmlTemplate format: (Array with: each))]
			raise: XMLValidationException.
		self
			shouldnt: [
				(SAXHandler on:
					(xmlTemplate format: (Array with: each)))
					isValidating: false;
					parseDocument]
			raise: XMLValidationException.].
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'one'))]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:58'!
testAttributeDefaultValueNmtokens
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root name NMTOKENS " one {1} ">
		]><root name="one" />'.

	self badNmtokenAttributeListValues do: [:each |
		self
			should: [		
				SAXHandler parse:
					(xmlTemplate format: (Array with: each))]
			raise: XMLValidationException.
		self
			shouldnt: [
				(SAXHandler on:
					(xmlTemplate format: (Array with: each)))
					isValidating: false;
					parseDocument]
			raise: XMLValidationException.].
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'two'))]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/21/2016 19:43'!
testAttributeDefaultValueNonProcessing
	| dtd document root |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root one CDATA "default">
			%undeclared;
			<!!ATTLIST root two CDATA "defaultTwo">
		]>'.

	document :=
		(XMLDOMParser on: dtd, '<root />')
			isValidating: false;
			parseDocument.
	root := document root.
	self
		assert: root attributeNodes size = 1;
		assert: (root attributeAt: 'one') = 'default'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/21/2016 19:43'!
testAttributeDefaultValueNonProcessingStandalone
	| dtd document root |

	dtd := '<?xml version="1.0" standalone="yes"?>
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root one CDATA "default">
			%undeclared;
			<!!ATTLIST root two CDATA "defaultTwo">
		]>'.

	document :=
		(XMLDOMParser on: dtd, '<root />')
			isValidating: false;
			parseDocument.
	root := document root.
	self
		assert: root attributeNodes size = 2;
		assert: (root attributeAt: 'one') = 'default';
		assert: (root attributeAt: 'two') = 'defaultTwo'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/7/2016 07:50'!
testAttributeDefaultValueNotation
	| xmlTemplate |

	xmlTemplate := '
		<!!DOCTYPE root [
			<!!NOTATION one PUBLIC "one.note">
			<!!NOTATION two PUBLIC "two.note">
			<!!NOTATION three PUBLIC "three.note">
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root note NOTATION (one|two|three) " {1} ">
		]><root note="one" />'.

	self
		should: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'four'))]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				(xmlTemplate format: (Array with: 'one'))]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on:
				(xmlTemplate format: (Array with: 'four')))
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/10/2016 14:50'!
testAttributeRedundance
	#('<test name="value" newName="newValue" name="value" />'
		'<test name="value" newName="newValue" name="newValue" />'
		'<test xml:lang="en" name="value" xml:lang="de" />')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 8/26/2016 03:30'!
testAttributeUndeclared
	self
		shouldnt: [
			SAXHandler
				parse: '<!!DOCTYPE root [<!!ENTITY ignored "ignored">]><root name="value"/>'
				usingNamespaces:true
				validation: true]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ELEMENT root ANY>
					<!!ATTLIST root name CDATA #IMPLIED>]><root name="value"></root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ELEMENT root ANY>]><root name="value"></root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ELEMENT root ANY>
					<!!ATTLIST root name CDATA #IMPLIED>]><root newName="value"></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testAttributeValueBadChar
	self nonChars do: [:each |
		self
			should: [SAXHandler parse: '<test name="', each asString, '"/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testAttributeValueExternalEntityReference
	| xmlTemplate entities xml |
	
	xmlTemplate := '
		<!!DOCTYPE test [
			<!!ENTITY internal "value">
			<!!ENTITY external SYSTEM  "extern.ent">
			<!!ENTITY interalReferencingExternal "&external;">
			<!!ENTITY
				interalReferencinginteralReferencingExternal
				"&interalReferencingExternal;">
		]>
		<test name="&{1};"/>'.
	entities := Array with: 'extern.ent' -> 'value'.

	self
		shouldnt: [
			xml := xmlTemplate format: (Array with: 'internal').
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities: entities);
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.

	#('external' 'interalReferencingExternal'
		'interalReferencinginteralReferencingExternal')
		do: [:each |
			xml := xmlTemplate format: (Array with: each).
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities: entities);
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/19/2013 05:55'!
testAttributeValueNormalization
	| separators unnormalized normalized document |

	separators :=
		String
			with: Character space
			with: Character tab
			with: Character lf.
	unnormalized := separators, 'nonspace', separators.
	normalized := '   nonspace   '.
	document :=
		(XMLDOMParser parse:
			'<root name="', unnormalized,'">', unnormalized, '</root>').
	self
		assert: (document root attributeAt: 'name') = normalized;
		assert: (document root contentString) = unnormalized.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/22/2015 15:11'!
testAttributeValueWithAngleBrackets
	self
		should: [SAXHandler parse: '<test name="<test name=''value''/>"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<test name="&lt;test name=''value''/>"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<test name=''&lt;test name="value"/>''/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/31/2016 06:40'!
testAttributeXMLBase
	| document |

	document :=
		XMLDOMParser parse: '
			<one xml:base="a/b">
				<two xml:base="c/d">
					<three xml:base="/e/f">test</three>
					<four xml:base=""><!!--resolved as inherited base--> 
						<five/><!!--no base attribute-->
					</four>
				</two>
			</one>'.
	self assert:
		(document allElementsCollect: [:each | each attributeAt: 'xml:base']) asArray =
			#('a/b' 'a/c/d' '/e/f' 'a/c/d' '').

	"resolution should not cause decoding/encoding"
	document :=
		XMLDOMParser parse: '
			<one xml:base="[%61]/{%62}">
				<two xml:base="{%63}/(%64)">
					<three xml:base="/!!%65!!/|%66|">test</three>
				</two>
			</one>'.
	self assert:
		(document allElementsCollect: [:each | each attributeAt: 'xml:base']) asArray =
			#('[%61]/{%62}' '[%61]/{%63}/(%64)' '/!!%65!!/|%66|').

	document :=
		XMLDOMParser
			parse:
				'<one xml:base=""><!!--resolved as inherited base-->
					<two/><!!--no base attribute-->
				</one>'
			documentURI: 'doc.xml'.
	self assert: (document root attributeAt: 'xml:base') = 'doc.xml'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 13:20'!
testAttributeXMLIDDTDValidation
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE one [
					<!!ELEMENT one ANY>
					<!!ELEMENT two ANY>
					<!!ATTLIST one xml:id ID #IMPLIED>
					<!!ATTLIST two xml:id ID #IMPLIED>]>
				<one xml:id="validOne">
					<two xml:id="validTwo"/>
				</one>']
		raise: XMLValidationException.

	#('<!!DOCTYPE one [
			<!!ELEMENT one ANY>
			<!!ATTLIST one xml:id CDATA #IMPLIED>]>
		<one/>'
		'<!!DOCTYPE one [
			<!!ELEMENT one ANY>
			<!!ATTLIST one
				xml:id ID #IMPLIED
				id ID #IMPLIED>]>
		<one/>'
		'<!!DOCTYPE one [
			<!!ELEMENT one ANY>
			<!!ATTLIST one
				id ID #IMPLIED
				xml:id ID #IMPLIED>]>
		<one/>'
		'<!!DOCTYPE one [
			<!!ELEMENT one ANY>
			<!!ATTLIST one xml:id ID #IMPLIED>]>
		<one xml:id="invalid:id"/>'
		'<!!DOCTYPE one [
			<!!ELEMENT one ANY>
			<!!ELEMENT two ANY>
			<!!ATTLIST one xml:id ID #IMPLIED>
			<!!ATTLIST two xml:id ID #IMPLIED>]>
		<one xml:id="duplicate">
			<two xml:id="duplicate"/>
		</one>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:28'!
testAttributeXMLIDValidation
	| xml xmlWithDuplicateID |

	xml := '<a xml:id="one"><b xml:id="two"/></a>'.
	xmlWithDuplicateID := '<a xml:id="one"><b xml:id="one"/></a>'.
	self
		shouldnt: [SAXHandler parse: xml]
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: xmlWithDuplicateID]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on: xmlWithDuplicateID)
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/9/2016 23:25'!
testAttributeXMLReserved
	| xml document element |

	xml := '<a xml="one" xmll="two" xml:="three" xmlnss="four"></a>'.
	document := XMLDOMParser parse: xml usingNamespaces: true.
	element := document root.
	self
		assert: element attributes size = 4;
		assert: (element attributeAt: 'xml') = 'one';
		assert: (element attributeAt: 'xmll') = 'two';
		assert: (element attributeAt: 'xml:') = 'three';
		assert: (element attributeAt: 'xmlnss') = 'four'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/9/2016 20:17'!
testAttributeXMLReservedNamespaces
	| xml xmlWithDuplicateID document element |

	xml :=
		'<test
			xml:id="test"
			xmlns="defaultNS"
			xmlns:test="testNS"
			xname="xvalue"/>'.
	document := XMLDOMParser parse: xml.
	element := document root.
	self
		assert: element namespaceScope mappedPrefixes size = 2;
		assert: element namespaceURI = 'defaultNS';
		assert: (element declaresPrefix: '' uri: 'defaultNS');
		assert: (element declaresPrefix: 'test' uri: 'testNS');
		assert: element attributes size = 2;
		assert: (element attributeAt: 'xml:id') = 'test';
		assert: (element attributeAt: 'xname') = 'xvalue'.

	document :=
		XMLDOMParser
			parse: xml
			usingNamespaces: false.
	element := document root.
	self
		deny: element hasNamespaces;
		assert: element attributes size = 4;
		assert: (element attributeAt: 'xml:id') = 'test';
		assert: (element attributeAt: 'xmlns') = 'defaultNS';
		assert: (element attributeAt: 'xmlns:test') = 'testNS';
		assert: (element attributeAt: 'xname') = 'xvalue'.

	"test that reserved attributes are still processed when namespaces
	are present by triggering an xml:id duplicate validation exception"
	xmlWithDuplicateID := '<test xml:id="test">', xml, '<test/>'.
	self
		should: [SAXHandler parse: xmlWithDuplicateID]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/13/2016 02:13'!
testAttributeXMLSpaceValidation
	"xml:space must be declared an enumeration type with only 'default' and
	'preserve' as allowed values"
	| xmlTemplate xml |

	xmlTemplate := '
		<!!DOCTYPE whitespace [
			<!!ELEMENT whitespace EMPTY>
			<!!ATTLIST whitespace xml:space {1} #IMPLIED>
		]>
		<whitespace></whitespace>'.
	#('CDATA'
		'ID'
		'IDREF'
		'IDREFS'
		'ENTITY'
		'ENTITIES'
		'(default|preserve|other)'
		'(default|preserve|default)'
		'NOTATION (default|preserve)')
		do: [:each |
			xml := xmlTemplate format: (Array with: each).
			self
				should: [SAXHandler parse: xml]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].

	#('(default|preserve)' '(preserve|default)' '(default)' '(preserve)')
		do: [:each |
			xml := xmlTemplate format: (Array with: each).
			self
				shouldnt: [SAXHandler parse: xml]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testCDataBadChar
	self nonChars do: [:each |
		self
			should: [SAXHandler parse: '<test><!![CDATA[', each asString, ']]>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/11/2016 11:25'!
testCDataOutsideElement
	#('<!!DOCTYPE test [ <!![CDATA[test]]> ]><test/>'
		'<!![CDATA[test]]><test/>'
		'	<!![CDATA[test]]><test/>'
		'<test/><!![CDATA[test]]>'
		'<test/>	<!![CDATA[test]]>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 03:07'!
testCDataSectionUnterminated
	#('<test><!!['
		'<test><!![</test>'
		'<test><!![CDATA['
		'<test><!![CDATA[</test>'
		'<test><!![CDATA[ test'
		'<test><!![CDATA[ test</test>'
		'<test><!![CDATA[ test ]'
		'<test><!![CDATA[ test ]</test>'
		'<test><!![CDATA[ test ]]'
		'<test><!![CDATA[ test ]]</test>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/14/2016 18:46'!
testCharacterReferenceUnexpected
	#('<!!DOCTYPE test [&#32;]><test/>'
		'&#32;<test/>'
		'<test/>&#32;')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			self
				should: [
					(SAXHandler on: each)
						replacesContentEntityReferences: false;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 03:54'!
testCharacterReferenceUnterminated
	#('<test>&#'
		'<test>&#</test>'
		'<test>&#x'
		'<test>&#x</test>'
		'<test>&#34'
		'<test>&#34</test>'
		'<test>&#x22'
		'<test>&#x22</test>'
		'<test>&#;'
		'<test>&#;</test>'
		'<test>&#x;'
		'<test>&#x;</test>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			self
				should: [
					(SAXHandler on: each)
						replacesContentEntityReferences: false;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:52'!
testComment
	self
		shouldnt: [SAXHandler parse: '<test><!!-- <comment/> - - --></test>']
		raise: XMLWellFormednessException.
	"can't contain --"
	self
		should: [SAXHandler parse: '<test><!!-- <comment/> -- --></test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testCommentBadChar
	self nonChars do: [:each |
		self
			should: [SAXHandler parse: '<!!--', each asString, '-->']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 03:06'!
testCommentUnterminated
	#('<!!--' '<!!-- comment' '<!!-- comment -' '<!!-- comment --')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: '<test/>', each]
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: '<test>', each, '<test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/21/2016 02:50'!
testConditionalSectionInInternalSubset
	#('<!![INCLUDE[ <!!-- comment --> ]]>'
		'<!![IGNORE[ <!!-- comment --> ]]>'
		'<!!ENTITY % include "INCLUDE"> <!![%include;[ <!!-- comment --> ]]>'
		'<!!ENTITY % ignore "IGNORE"> <!![%ignore;[ <!!-- comment --> ]]>'
		) do: [:each |
			self
				should: [SAXHandler parse:'<!!DOCTYPE test [', each, ']><test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/3/2016 01:11'!
testConditionalSectionInInternalSubsetExternallyDefined
	| conditionalSections |

	conditionalSections := '
		<!![INCLUDE[<!!ELEMENT test ANY>]]>
		<!![IGNORE[<!!ELEMENT test EMPTY>]]>'.
	self
		shouldnt: [
			"the rule against internal subset include/ignore sections
			shouldn't apply to external entities included in the subset"
			(SAXHandler on: '
				<!!DOCTYPE test [
					<!!ENTITY % extern SYSTEM "extern.ent">
					%extern;
					<!!ATTLIST test name CDATA #IMPLIED>
				]>
				<test name="value">test</test>')
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.ent' -> conditionalSections));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.
	self
		should: [| entityReplacementMixedSections |
			"the rule against internal subset include/ignore sections
			should apply to internal entities included in the subset
			if they're internal even to an external entity"
			entityReplacementMixedSections :=
				'<!!ENTITY % extern2 "', conditionalSections, '">'.
			(SAXHandler on: '
				<!!DOCTYPE test [
					<!!ENTITY % extern SYSTEM "extern.ent">
					%extern;
					%extern2;
					<!!ATTLIST test name CDATA #IMPLIED>
				]>
				<test name="value">test</test>')
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.ent' -> entityReplacementMixedSections));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testConditionalSectionLabelReplacementIgnore
	| xml dtd |

	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.

	#('<!!ENTITY % label "{1}"> <!![%label;[ <malformed-xml/> ]]>'
		'<!!ENTITY % label "{1}"> <!![ %label; [ <malformed-xml/> ]]>')
		do: [:each |
			self
				should: [
					dtd := each format: (Array with: 'INCLUDE').
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> dtd));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException.
			self
				shouldnt: [
					dtd := each format: (Array with: 'IGNORE').
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> dtd));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/3/2016 01:14'!
testConditionalSectionLabelReplacementInclude
	| xml dtd |

	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.
	#('<!!ENTITY % label "{1}">
		<!![%label;[
			<!!ENTITY % comment "<!!--comment-->">
		]]> %comment;'
		'<!!ENTITY % label "{1}">
		<!![ %label; [
			<!!ENTITY % comment "<!!--comment-->">
		]]> %comment;')
		do: [:each |
			self
				shouldnt: [
					dtd := each format: (Array with: 'INCLUDE').
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> dtd));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				should: [
					dtd := each format: (Array with: 'IGNORE').
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> dtd));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/3/2016 01:13'!
testConditionalSectionMixedIncludeIgnore
	| xml dtd |

	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.
	dtd := '
		<!![INCLUDE[
			<!![IGNORE[ %comment; ]]>
			<!!ENTITY % comment "<!!--comment]]>-->">
			<!![INCLUDE[
				<!![IGNORE[ %commentTwo; ]]>
				<!!ENTITY % commentTwo "<!!--comment]]>-->">
				%commentTwo;
			]]>
			%comment;
			%commentTwo;
		]]>
		%comment;
		%commentTwo;'.
	self
		shouldnt: [
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testConditionalSectionNestedIgnore
	| xml dtdTemplate dtd |

	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.
	dtdTemplate := '
		<!![ IGNORE [
			<!!--ignored terminator {1} -->
			<!![ INCLUDE [
				<!!ENTITY % comment "<!!--ignored terminator {1} -->">
				%comment;
			]]>
			%comment;
		]]>'.
	self
		shouldnt: [
			dtd := dtdTemplate format: (Array with: ']]').
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.
	self
		should: [
			dtd := dtdTemplate format: (Array with: ']]>').
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/3/2016 01:12'!
testConditionalSectionNestedInclude
	| xml dtd |

	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.
	dtd := '
		<!![ INCLUDE [
			<!!--ignored terminator ]]> -->
			<!![ INCLUDE [
				<!!ENTITY % comment "<!!--ignored terminator ]]> -->">
				%comment;
			]]>
			%comment;
		]]>
		%comment;'.
	self
		shouldnt: [
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testConditionalSectionUnterminatedIgnore
	| xml |

	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.
	#('<!![IGNORE['
		'<!![IGNORE[<!!--comment-->'
		'<!![IGNORE[<!!--comment--><!![IGNORE['
		'<!![IGNORE[<!!--comment--><!![IGNORE[ ]]>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testConditionalSectionUnterminatedInclude
	| xml |

	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.
	#('<!![INCLUDE['
		'<!![INCLUDE[<!!--comment-->'
		'<!![INCLUDE[<!!--comment--><!![INCLUDE['
		'<!![INCLUDE[<!!--comment--><!![INCLUDE[ ]]>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 03:12'!
testContentlessDocument
	#(''
		' 	'
		'<?xml version="1.0"?>'
		'	<!!DOCTYPE test>'
		'	<!!DOCTYPE test [<!!--comment-->]>'
		'	<!!--comment-->'
		'	<?target data?>'
		'<?xml version="1.0"?><!!DOCTYPE test>'
		'<?xml version="1.0"?><!!DOCTYPE test><!!--comment-->'
		'<?xml version="1.0"?><!!DOCTYPE test><!!--comment--><?pi data?>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			self
				shouldnt: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/10/2016 15:05'!
testContentlessSubset
	#(''
		'<?xml encoding="UTF-8"?>'
		'<!!--comment-->'
		'<?target data?>'
		'<?xml encoding="UTF-8"?><!!--comment-->'
		'<?xml encoding="UTF-8"?><!!--comment--><?target data?>')
		do: [:each |
			self
				shouldnt: [
					((SAXHandler on: '') parser driver
						externalSubsetParserOn: each
						documentURI: 'extern.dtd') parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/12/2016 19:10'!
testDoctypeDeclarationBadPublicIDChar
	| validChars |

	validChars :=
		'!!#$%''()*+,-./0123456789:;=?@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz',
		(Character xmlSeparators copyWithout: Character tab).
	0 to: 255 do: [:each | | char charString |
		char := each asCharacter.
		(validChars includes: char)
			ifFalse: [
				charString := char asString.
				self
					should: [
						SAXHandler parse:
							'<!!DOCTYPE test PUBLIC "//public//', charString, '" "external.dtd"><test/>']
					raise: XMLWellFormednessException]].
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test PUBLIC "//public//', validChars, '" "external.dtd"><test/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:22'!
testDoctypeDeclarationInContent
	self
		should: [SAXHandler parse: '<test><!!DOCTYPE test></test>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<!!DOCTYPE test><test></test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/8/2016 08:49'!
testDoctypeDeclarationRedundance
	#('<!!DOCTYPE test><!!DOCTYPE test>'
		'<!!DOCTYPE test><!!--comment--><!!DOCTYPE test>'
		'<!!DOCTYPE test><!!pi data?><!!DOCTYPE test>'
		'<!!DOCTYPE test [<!!DOCTYPE test>]>'
		'<test><!!DOCTYPE test></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2015 05:24'!
testDoctypeDeclarationRoot
	| xmlWithInvalidRoot xmlWithValidRoot |

	xmlWithInvalidRoot := '<!!DOCTYPE root><invalidRoot/>'.
	xmlWithValidRoot := '<!!DOCTYPE root><root/>'.
	self
		should: [SAXHandler parse: xmlWithInvalidRoot]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler
				parse: xmlWithInvalidRoot
				usingNamespaces: false
				validation: false]
		raise: XMLValidationException.
	self
		shouldnt: [SAXHandler parse: xmlWithValidRoot]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 03:11'!
testDoctypeDeclarationUnterminated
	#('<!!DOCTYPE'
		'<!!DOCTYPE >'
		'<!!DOCTYPE test'
		'<!!DOCTYPE test PUBLIC'
		'<!!DOCTYPE test PUBLIC>'
		'<!!DOCTYPE test PUBLIC "'
		'<!!DOCTYPE test PUBLIC ">'
		'<!!DOCTYPE test PUBLIC "publicid'
		'<!!DOCTYPE test PUBLIC "publicid"'
		'<!!DOCTYPE test PUBLIC "publicid">'
		'<!!DOCTYPE test PUBLIC '''
		'<!!DOCTYPE test PUBLIC ''>'
		'<!!DOCTYPE test PUBLIC ''publicid'
		'<!!DOCTYPE test PUBLIC ''publicid'''
		'<!!DOCTYPE test PUBLIC "publicid">'
		'<!!DOCTYPE test PUBLIC "publicid" "'
		'<!!DOCTYPE test PUBLIC "publicid" ">'
		'<!!DOCTYPE test PUBLIC "publicid" "systemid'
		'<!!DOCTYPE test PUBLIC "publicid" "systemid"'
		'<!!DOCTYPE test PUBLIC "publicid" '''
		'<!!DOCTYPE test PUBLIC "publicid" ''>'
		'<!!DOCTYPE test PUBLIC "publicid" ''systemid'
		'<!!DOCTYPE test PUBLIC "publicid" ''systemid'''
		'<!!DOCTYPE test PUBLIC "publicid" "systemid''>'
		'<!!DOCTYPE test PUBLIC "publicid" ''systemid">'
		'<!!DOCTYPE test PUBLIC "publicid" "systemid" ['
		'<!!DOCTYPE test PUBLIC "publicid" "systemid" [>'
		'<!!DOCTYPE test PUBLIC "publicid" "systemid" []'
		'<!!DOCTYPE test SYSTEM'
		'<!!DOCTYPE test SYSTEM>'
		'<!!DOCTYPE test SYSTEM "'
		'<!!DOCTYPE test SYSTEM ">'
		'<!!DOCTYPE test SYSTEM "systemid'
		'<!!DOCTYPE test SYSTEM "systemid"'
		'<!!DOCTYPE test SYSTEM '''
		'<!!DOCTYPE test SYSTEM ''>'
		'<!!DOCTYPE test SYSTEM ''systemid'
		'<!!DOCTYPE test SYSTEM ''systemid'''
		'<!!DOCTYPE test SYSTEM "systemid''>'
		'<!!DOCTYPE test SYSTEM ''systemid">'
		'<!!DOCTYPE test SYSTEM "systemid" ['
		'<!!DOCTYPE test SYSTEM "systemid" [>'
		'<!!DOCTYPE test SYSTEM "systemid" []'
		'<!!DOCTYPE test ['
		'<!!DOCTYPE test [>'
		'<!!DOCTYPE test []')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2016 01:03'!
testDoctypeDeclarationWhitespace
	"whitespace is mandatory after the 'DOCTYPE', before and within any external id,
	but is optional before the '[' and after the ']' of the interal subset"
	#('<!!DOCTYPEtest>'
		'<!!DOCTYPE testPUBLIC "publicid" "systemid">'
		'<!!DOCTYPE test PUBLIC"publicid" "systemid">'
		'<!!DOCTYPE test PUBLIC "publicid""systemid">'
		'<!!DOCTYPE testSYSTEM "systemid">'
		'<!!DOCTYPE test SYSTEM"systemid">')
		do: [:each |
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].

	#('<!!DOCTYPE
			test
			PUBLIC
			   "publicid"
			   "systemid"
		 >'
		'<!!DOCTYPE
			test
			SYSTEM
			   "systemid"
		>'
		'<!!DOCTYPE
			test
			PUBLIC
			   "publicid"
			   "systemid"
			[
			]
		 >'
		'<!!DOCTYPE
			test
			SYSTEM
			   "systemid"
			[
			]
		>'
		'<!!DOCTYPE test PUBLIC "publicid" "systemid"[]>'
		'<!!DOCTYPE test SYSTEM "systemid"[]>'
		'<!!DOCTYPE test[]>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/26/2016 06:26'!
testDocumentConstraintsRequired
	self
		shouldnt: [
			(SAXHandler on: '<!!DOCTYPE root [<!!ELEMENT root EMPTY>]><root/>')
				requiresDocumentConstraints: true;
				parseDocument]
		raise: XMLValidationException.
	self
		should: [
			(SAXHandler on: '<root/>')
				requiresDocumentConstraints: true;
				parseDocument]
		raise: XMLValidationException.
	self
		should: [
			(SAXHandler on: '
				<!!DOCTYPE root [
					<!!ENTITY one "two">
					<!!ENTITY % three "four">
					<!!NOTATION five PUBLIC "six">
					<!!--seven-->]>
				<root/>')
				requiresDocumentConstraints: true;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:56'!
testElementAnyDeclaration
	self
		shouldnt: [
			SAXHandler parse: 
				'<!!DOCTYPE one [
					<!!ELEMENT one ANY>
					<!!ELEMENT two ANY>]>
				<one>one<two><!![CDATA[two]]><two /></two>three</one>']
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse: 
				'<!!DOCTYPE root [
					<!!ELEMENT root ANY>
					<!!ELEMENT two ANY>]>
				<root><two></two></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:51'!
testElementBadName
	self badNames do: [:each |
		self
			should: [SAXHandler parse: '<', each, '/>']
			raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/2/2016 00:29'!
testElementContentModelBadBinaryOperator
	#('<!!DOCTYPE a [<!!ELEMENT a (,b)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b,)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (,b c)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b c,)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (|b)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b|)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (|b c)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b c|)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b, c | d)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b | c, d)>]>')
		do: [:each |
			self
				should: [
					(SAXHandler on: each, '<a></a>')
						isValidating: false;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/2/2016 00:29'!
testElementContentModelBadParenthesis
	#('<!!DOCTYPE a [<!!ELEMENT a b>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b>]>'
		'<!!DOCTYPE a [<!!ELEMENT a b)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a ((b)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b))>]>')
		do: [:each |
			self
				should: [
					(SAXHandler on: each, '<a></a>')
						isValidating: false;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/2/2016 00:29'!
testElementContentModelBadUnaryOperator
	#('<!!DOCTYPE a [<!!ELEMENT a (?b)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (*b)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (+b)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b??)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b**)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b++)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b?*)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b?+)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b*?)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b*+)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b+?)>]>'
		'<!!DOCTYPE a [<!!ELEMENT a (b+*)>]>')
		do: [:each |
			self
				should: [
					(SAXHandler on: each, '<a></a>')
						isValidating: false;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:40'!
testElementContentModelBranching
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root ((one|two),(three|four|five))>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><three/></root>';
				parse: dtd, '<root><one/><four/></root>';
				parse: dtd, '<root><one/><five/></root>';
				parse: dtd, '<root><two/><three/></root>';
				parse: dtd, '<root><two/><four/></root>';
				parse: dtd, '<root><two/><five/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><three/><four/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><four/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:40'!
testElementContentModelManyBranches
	| dtd names |

	names := (1 to: 50) collect: [:each | 'element', each printString].
	dtd := String streamContents: [:stream |
		stream
			nextPutAll: '<!!DOCTYPE root [';
			nextPutAll: (self elementDeclarationsNamed: names);
			nextPutAll: '<!!ELEMENT root ('.
		names
			do: [:each | stream nextPutAll: each]
			separatedBy: [stream nextPut: $|].
		stream nextPutAll: ')>]>'].

	names do: [:each |
		self
			shouldnt: [SAXHandler parse: dtd, '<root><', each, '/></root>']
			raise: XMLValidationException].
	self
		should: [
			SAXHandler parse:
				dtd, '<root><element', (names size + 1) printString, '/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:58'!
testElementContentModelNonDeterministic
	| template |
	
	template :=
		'<!!DOCTYPE a [
			<!!ELEMENT a {1}>
			<!!ELEMENT b EMPTY>
			<!!ELEMENT c EMPTY>
			<!!ELEMENT d EMPTY>
		]>{2}'.

	#(#('((b,c)|(b,d))' '(b,(c|d))' '<a><b/><c/></a>')
		#('(b?,b*)' '(b,b*)' '<a><b/></a>')
		#('(b+,b?)' '(b,b+)' '<a><b/><b/></a>')
		) do: [:each | | nonDeterministic deterministic source |
		nonDeterministic := each first.
		deterministic := each second.
		source := each third.
		self
			should: [
				SAXHandler parse:
					(template format: (Array with: nonDeterministic with: source))]
			raise: XMLValidationException.
		self
			shouldnt: [
				SAXHandler parse:
					(template format: (Array with: deterministic with: source))]
			raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:40'!
testElementContentModelOptional
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root (one?,two,three?,(four?, five)?)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><three/></root>';
				parse: dtd, '<root><one/><two/><three/><five/></root>';
				parse: dtd, '<root><two/></root>';
				parse: dtd, '<root><one/><two/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><three/><four/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/><four/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/><five/><four/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:40'!
testElementContentModelOptionalBranching
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five' 'six')),
		'<!!ELEMENT root (((one,two)|(three,four)),five?)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><five/></root>';
				parse: dtd, '<root><three/><four/><five/></root>';
				parse: dtd, '<root><one/><two/></root>';
				parse: dtd, '<root><three/><four/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><three/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><five/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:40'!
testElementContentModelOptionalEmpty
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three')),
		'<!!ELEMENT root (one?,two)?>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/></root>';
				parse: dtd, '<root><two/></root>';
				parse: dtd, '<root></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><one/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><three/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><one/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:40'!
testElementContentModelPlus
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root ((one?,two)+,three,four+,five)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><one/><two/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><three/><four/><four/><five/></root>';
				parse: dtd, '<root><two/><three/><four/><five/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><three/><four/><five/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><four/><four/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><one/><two/><three/><five/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:41'!
testElementContentModelStar
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three' 'four' 'five')),
		'<!!ELEMENT root ((one?,two)*,(three)*,four,five*)>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><two/><one/><two/><three/><four/><five/></root>';
				parse: dtd, '<root><three/><three/><four/><five/></root>';
				parse: dtd, '<root><four/><five/><five/></root>';
				parse: dtd, '<root><four/></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><three/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:41'!
testElementContentModelStarEmpty
	| dtd |

	dtd := '<!!DOCTYPE root [',
		(self elementDeclarationsNamed: #('one' 'two' 'three')),
		'<!!ELEMENT root (one*,two)*>]>'.

	self
		shouldnt: [
			SAXHandler
				parse: dtd, '<root><one/><one/><two/><two/></root>';
				parse: dtd, '<root><two/><one/><two/></root>';
				parse: dtd, '<root><two/><two/></root>';
				parse: dtd, '<root></root>']
		raise: XMLValidationException.

	self
		should: [SAXHandler parse: dtd, '<root><one/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><three/></root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/4/2016 01:32'!
testElementContentWhitespace
	| xmlTemplate |

	"LibXML2 and Xerces allow general entity refs with empty and whitespace
	replacements and char refs to whitespace chars inbetween elements in
	elements with DTD-valited 'element content'. This tests for that behavior."
	xmlTemplate := '
		<!!DOCTYPE element-content [
			<!!ELEMENT element-content (one, two)>
			<!!ELEMENT one EMPTY>
			<!!ELEMENT two EMPTY>
			<!!ENTITY empty ''''>
			<!!ENTITY non-empty "non empty">
			<!!ENTITY whitespace " 	
				">
		]>
		<element-content>{1}<one/>{1}<two/>{1}</element-content>'.
	(Array
		with: (String withAll: Character xmlSeparators)
		with: '&empty;'
		with: '&whitespace;'
		with: '')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: (xmlTemplate format: (Array with: each))]
				raise: XMLValidationException].
	Character xmlSeparators do: [:each |
		self
			shouldnt: [
				SAXHandler parse:
					(xmlTemplate format:
						(Array with: '&#', each asciiValue asString, ';'))]
			raise: XMLValidationException].

	(Array
		with: 'one'
		with: '2'
		with: '&non-empty;'
		with: '&#34;')
		do: [:each | | xml |
			xml := xmlTemplate format: (Array with: each).
			self
				should: [SAXHandler parse: xml]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/12/2016 20:59'!
testElementDeclarationMixedContent
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root (#PCDATA | one | two | three)*>
			<!!ELEMENT one EMPTY>
			<!!ELEMENT two (#PCDATA)>
			<!!ELEMENT three (#PCDATA)*>
			<!!ELEMENT four EMPTY>]>'.
	self
		shouldnt: [
			SAXHandler parse:
				dtd, '<root>text<one/><two><!![CDATA[text]]></two></root>']
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				dtd, '<root><three>text<!!--comment--></three></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><four/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><two><three/></two></root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse: "missing *"
				'<!!DOCTYPE root [<!!ELEMENT root (#PCDATA|one)>]><root/>']
		raise: XMLWellFormednessException.
	'+*?,' do: [:each |
		self
			should: [
				SAXHandler parse:
					'<!!DOCTYPE root [<!!ELEMENT two (#PCDATA', each asString, ')>]><root/>']
			raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/12/2016 21:01'!
testElementDeclarationMixedContentRedundance
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!ELEMENT root EMPTY>
			<!!ELEMENT one (#PCDATA | one | two | one)*>
		]>'.
	self
		should: [SAXHandler parse: dtd, '<root/>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/13/2016 04:08'!
testElementDeclarationPrefixed
	| dtd |

	dtd := '<!!DOCTYPE prefix:root [
		<!!ELEMENT prefix:root ANY>
		<!!ATTLIST prefix:root xmlns:prefix CDATA #IMPLIED>
		<!!ELEMENT unprefixed EMPTY>]>'.
	self
		shouldnt: [SAXHandler parse: dtd, '<prefix:root xmlns:prefix="ns"><unprefixed/></prefix:root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root><unprefixed/></root>']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<prefix:root xmlns:prefix="ns"><prefix:unprefixed/></prefix:root>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/20/2016 23:00'!
testElementDeclarationRedundance
	#('<!!DOCTYPE test [<!!ELEMENT test EMPTY><!!ELEMENT test EMPTY>]><test/>'
		'<!!DOCTYPE test [<!!ELEMENT test EMPTY><!!ELEMENT test ANY>]><test/>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLValidationException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 20:21'!
testElementDeclarationWhitespace
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE test [<!!ELEMENTtest (#PCDATA)>]><test/>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE test [<!!ELEMENT test(#PCDATA)>]><test/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test [<!!ELEMENT test (	#PCDATA	)   >]><test/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/13/2016 06:49'!
testElementEmptyDeclaration
	| dtd |

	dtd := '<!!DOCTYPE empty [<!!ELEMENT empty EMPTY>]>'.

	#('<empty/>'
		'<empty></empty>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: dtd, each]
				raise: XMLValidationException].

	"the spec says EMPTY elements can't have any content, even whitespace,
	comments or PIs"
	#('<empty><empty/></empty>'
		'<empty>non-empty</empty>'
		'<empty> </empty>'
		'<empty>	</empty>'
		'<empty>
</empty>'
		'<empty>&#32;</empty>' "Character space asciiValue"
		'<empty>&#9;</empty>' "Character tab asciiValue"
		'<empty>&#10;</empty>' "Character lf asciiValue"
		'<empty>&#13;</empty>' "Character cr asciiValue"
		'<empty><!![CDATA[non-empty]]></empty>'
		'<empty><!!--non-empty--></empty>'
		'<empty><?non empty?></empty>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: dtd, each)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/30/2016 02:41'!
testElementNesting
	#('<unclosed>'
		'</unopened>'
		'<root></unopened></root>'
		'<root><unclosed></root>'
		'<root><first><second></first></second></root>'
		'<root><first><second></second></root></first>'
		'<root><first><second></root></second></first>'
		'<root/><secondRoot/>'
		'<root><first/></root><secondRoot/>'
		'<root><first/></root><secondRoot><second/></secondRoot>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/30/2016 02:42'!
testElementUnmatchedEndTag
	#('<test></t>'
		'<test></te>'
		'<test></tes>'
		'<test></testing>'
		'<test></Test>'
		'<test></TEST>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/30/2016 02:33'!
testElementUnterminatedEndTag
	#('<test><'
		'<test><test><</test>'
		'<test></'
		'<test><test></</test>'
		'<test></test'
		'<test><test></test</test>'
		'<test></ test'
		'<test><test></ test</test>'
		'<test></ test>'
		'<test><test></ test></test>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/16/2016 07:33'!
testElementUnterminatedStartTag
	#('<'
		'<></>'
		'</>'
		'<test'
		'<test</test>'
		'<test/'
		'<test name'
		'<test name></test>'
		'<test name/>'
		'<test name='
		'<test name=></test>'
		'<test name=/>'
		'<test name="'
		'<test name="></test>'
		'<test name="/>'
		'<test name="value'
		'<test name="value"'
		'<test name="value"</test>'
		'<test name="value"/'
		'<test name='''
		'<test name=''></test>'
		'<test name=''/>'
		'<test name=''value'
		'<test name=''value'''
		'<test name=''value''</test>'
		'<test name=''value''/'
		'<test name="value''></test>'
		'<test name=''value"></test>'
		'<test name="value''/>'
		'<test name=''value"/>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/21/2016 02:51'!
testElementWhitespace
	self
		should: [SAXHandler parse: '<root name1="value1"name2="value2"/>']
		raise: XMLWellFormednessException.
	self
		should: [SAXHandler parse: '<root name1=''value1''name2="value2"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<root name1="value1" name2="value2"/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			SAXHandler parse: '
				<root
					name1
					   =
					"value1"
					name2
					   =
					"value2"
				/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/23/2016 01:03'!
testElementsUndeclared
	self
		shouldnt: [
			"entity and notation declarations aren't enough to trigger
			DTD validation; at least one element or attlist declaration
			is needed"
			SAXHandler
				parse: '
					<!!DOCTYPE root [
						<!!ENTITY ignored "">
						<!!NOTATION ignored2 PUBLIC "ignored2">
					]>
					<root/>'
				usingNamespaces:true
				validation: true]
		raise:XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ELEMENT root ANY>]><root><undeclared/></root>']
		raise: XMLValidationException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ATTLIST root name CDATA #IMPLIED>]><root/>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:52'!
testEntityDeclarationBadName
	self badNames do: [:each |
		self
			should: [
				SAXHandler parse:
					'<!!DOCTYPE test [
						<!!ENTITY ', each, ' "value">
					]><test/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 04:05'!
testEntityDeclarationUnterminated
	#('<!!ENTITY'
		'<!!ENTITY>'
		'<!!ENTITY name'
		'<!!ENTITY name>'
		'<!!ENTITY name "'
		'<!!ENTITY name ">'
		'<!!ENTITY name "value'
		'<!!ENTITY name "value"'
		'<!!ENTITY name '''
		'<!!ENTITY name ''>'
		'<!!ENTITY name ''value'
		'<!!ENTITY name ''value'''
		'<!!ENTITY name "value''>'
		'<!!ENTITY name ''value">'
		'<!!ENTITY name PUBLIC'
		'<!!ENTITY name PUBLIC>'
		'<!!ENTITY name PUBLIC "'
		'<!!ENTITY name PUBLIC ">'
		'<!!ENTITY name PUBLIC "publicid"'
		'<!!ENTITY name PUBLIC "publicid">'
		'<!!ENTITY name PUBLIC '''
		'<!!ENTITY name PUBLIC ''>'
		'<!!ENTITY name PUBLIC ''publicid'''
		'<!!ENTITY name PUBLIC ''publicid''>'
		'<!!ENTITY name PUBLIC "publicid''>'
		'<!!ENTITY name PUBLIC ''publicid">'
		'<!!ENTITY name PUBLIC "publicid" "'
		'<!!ENTITY name PUBLIC "publicid" ">'
		'<!!ENTITY name PUBLIC "publicid" "systemid'
		'<!!ENTITY name PUBLIC "publicid" "systemid"'
		'<!!ENTITY name PUBLIC "publicid" '''
		'<!!ENTITY name PUBLIC "publicid" ''>'
		'<!!ENTITY name PUBLIC "publicid" ''systemid'
		'<!!ENTITY name PUBLIC "publicid" ''systemid'''
		'<!!ENTITY name PUBLIC "publicid" "systemid''>'
		'<!!ENTITY name PUBLIC "publicid" ''systemid">'
		'<!!ENTITY name SYSTEM'
		'<!!ENTITY name SYSTEM>'
		'<!!ENTITY name SYSTEM "'
		'<!!ENTITY name SYSTEM ">'
		'<!!ENTITY name SYSTEM "systemid'
		'<!!ENTITY name SYSTEM "systemid"'
		'<!!ENTITY name SYSTEM '''
		'<!!ENTITY name SYSTEM ''>'
		'<!!ENTITY name SYSTEM ''systemid'
		'<!!ENTITY name SYSTEM ''systemid'''
		'<!!ENTITY name SYSTEM "systemid''>'
		'<!!ENTITY name SYSTEM ''systemid">'
		'<!!ENTITY name SYSTEM "systemid''>'
		'<!!ENTITY name SYSTEM ''systemid">')
		do: [:each |
			self
				should: [
					SAXHandler parse:
						'<!!DOCTYPE test [
							<!!NOTATION gif SYSTEM "file.gif">',
							each]
				raise: XMLWellFormednessException.
			self
				should: [
					SAXHandler parse:
						'<!!DOCTYPE test [
							<!!NOTATION gif SYSTEM "file.gif">',
							each,
						']><test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testEntityDeclarationValueBadChar
	self nonChars do: [:each |
		self
			should: [
				SAXHandler parse:
					'<!!DOCTYPE test [
						<!!ENTITY name "', each asString, '">
					]><test/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/16/2016 06:38'!
testEntityDeclarationWhitespace
	#('<!!ENTITYname "value">'
		'<!!ENTITY name"value">'
		'<!!ENTITY name PUBLIC"publicid" "systemid">'
		'<!!ENTITY name PUBLIC "publicid""systemid">'
		'<!!ENTITY name SYSTEM"systemid">'
		'<!!ENTITY name PUBLIC "publicid" "systemid"NDATA GIF>'
		'<!!ENTITY name SYSTEM "systemid"NDATA GIF>'
		'<!!ENTITY% name "value">'
		'<!!ENTITY %name "value">')
		do: [:each |
			self
				should: [SAXHandler parse: '<!!DOCTYPE test [', each, ']><test/>']
				raise: XMLWellFormednessException].

	#('<!!ENTITY  name 	"value"   >'
		'<!!ENTITY   % 	 name "value"	>'
		'<!!ENTITY   name   PUBLIC   "publicid"    "systemid"   >'
		'<!!ENTITY   name   SYSTEM    "systemid"   >')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: '<!!DOCTYPE test [', each, ']><test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/6/2016 05:14'!
testEntityExternalResolutionGeneral
	| xml entities document |

	xml := '
		<!!DOCTYPE test [
			<!!ENTITY extern SYSTEM "/base/extern.ent">
			<!!ENTITY extern2 SYSTEM "/base/extern2.ent">
			<!!ENTITY extern3 SYSTEM "/base/extern3.ent">
		]>
		<test>&extern;&extern2;&extern3;</test>'.
	entities :=
		Array
			with:
				'/base/extern.ent' ->
					'<?xml version="1.0" encoding="UTF-8"?>one'
			with:
				'/base/extern2.ent' ->
					'<?xml encoding="UTF-8"?>two'
			with: '/base/extern3.ent' -> 'three'.
	1 to: entities size - 1 do: [:i |
		self
			should: [
				(SAXHandler on: xml)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities:
							(entities copyFrom: 1 to: i));
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLParserException].
	self
		should: [
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities: entities);
				resolvesExternalEntities: false;
				parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: xml)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities: entities);
					resolvesExternalEntities: true;
					parseDocument]
		raise: XMLParserException.
	self assert: document root contentString = 'onetwothree'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/6/2016 10:56'!
testEntityExternalResolutionParameter
	| xml entities document |

	xml := '
		<!!DOCTYPE test [
			<!!ENTITY % extern SYSTEM "/base/extern.ent">
			%extern;
			%extern2;
			%extern3;
		]>
		<test>&extern4;</test>'.
	entities :=
		Array
			with:
				'/base/extern.ent' ->
					'<?xml version="1.0" encoding="UTF-8"?>
					<!!ENTITY % extern2 SYSTEM "sub/extern2.ent">'
			with:
				'/base/sub/extern2.ent' ->
					'<?xml encoding="UTF-8"?>
					<!!ENTITY % extern3 SYSTEM "./extern3.ent">'
			with:
				'/base/sub/extern3.ent' ->
					'<!!ENTITY % extern5 SYSTEM "./extern5.ent">
					<!!ENTITY extern4 "%extern5;">'
			with:
				'/base/sub/extern5.ent' ->
					'<?xml encoding="UTF-8"?>test'.
	1 to: entities size - 1 do: [:i |
		self
			should: [
				(SAXHandler on: xml)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities:
							(entities copyFrom: 1 to: i));
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLParserException].
	self
		should: [
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities: entities);
				resolvesExternalEntities: false;
				parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities: entities);
				resolvesExternalEntities: false;
				isValidating: false;
				parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: xml)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities: entities);
					resolvesExternalEntities: true;
					parseDocument]
		raise: XMLParserException.
	self assert: document root contentString = 'test'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/13/2017 05:15'!
testEntityExternalResolutionParameterInDeclaration
	"test the handling of external parameter entity references in declarations"
	| invalidXML validXML resolver |

	invalidXML := '
		<!!DOCTYPE one SYSTEM "extern.dtd">
		<one><two/><four/></one>'.
	validXML := '
		<!!DOCTYPE one SYSTEM "extern.dtd">
		<one><two/><three/><four/></one>'.
	(resolver := DTDStaticExternalEntityResolver new)
		externalEntityAtURI: 'extern.dtd'
		put:
			'<!!ENTITY % two SYSTEM "two.ent">
			<!!ENTITY % three SYSTEM "three.ent">
			<!!ENTITY % four SYSTEM "four.ent">
			<!!ELEMENT one (%two; , %three; , %four;)>
			<!!ELEMENT two EMPTY>
			<!!ELEMENT three EMPTY>
			<!!ELEMENT four EMPTY>'.
	resolver
		externalEntityAtURI: 'two.ent'
		put:
			'<?xml encoding="UTF-8"?>
			two'.
	resolver
		externalEntityAtURI: 'three.ent'
		put: 'three'.
	resolver
		externalEntityAtURI: 'four.ent'
		put: '<?xml encoding="UTF-8"?>four'.
	self
		should: [
			(SAXHandler on: invalidXML)
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on: validXML)
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testEntityExternalSubsetResolution
	| xml entities |

	xml := '<!!DOCTYPE test SYSTEM "/base/extern.ent"><test>&extern4;</test>'.
	entities :=
		Array
			with:
				'/base/extern.ent' ->
					'<!!ENTITY % extern2 SYSTEM "sub/extern2.ent">
					%extern2;
					%extern3;'
			with: '/base/sub/extern2.ent' -> '<!!ENTITY % extern3 SYSTEM "./extern3.ent">'
			with: '/base/sub/extern3.ent' -> '<!!ENTITY extern4 "test">'.
	1 to: entities size - 1 do: [:i |
		self
			should: [
				(SAXHandler on: xml)
					externalEntityResolver:
						(DTDStaticExternalEntityResolver externalEntities:
							(entities copyFrom: 1 to: i));
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLParserException].
	self
		should: [
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities: entities);
				resolvesExternalEntities: false;
				parseDocument]
		raise: XMLParserException.
	self
		shouldnt: [
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities: entities);
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLParserException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/21/2016 01:24'!
testEntityLiteralContextNesting
	| xml inner outer document |

	xml := '<?xml version="1.0"?>
	<!!DOCTYPE entities [
		<!!ENTITY % inner " <!!ENTITY inner  &#34; '' inner &#39; &#34;>">
		%inner;
		<!!ENTITY outer '' &#39; " &inner; &#39; " ''>
	]>
	<entities one="&outer;" two="&inner;" three=''&outer;'' four=''&inner;''>&outer;&inner;</entities>'.
	inner := ' '' inner '' '.
	outer := ' '' " ', inner, ' '' " '.

	self
		shouldnt: [document := XMLDOMParser parse: xml]
		raise: XMLWellFormednessException.
	self
		assert: (document root attributeAt: 'one') = outer;
		assert: (document root attributeAt: 'two') = inner;
		assert: (document root attributeAt: 'three') = outer;
		assert: (document root attributeAt: 'four') = inner;
		assert: (document root contentString) = (outer, inner).! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testEntityNestingAttributeDeclaration
	| xml |
	
	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.

	"these are wellformedness exceptions because the replacement is surrounded with
	spaces which interrupt the '<!!ATTLIST' sequence"
	#('<!!ELEMENT test EMPTY>
		<!!ENTITY % partial "<">
		%partial;!!ATTLIST test name CDATA #IMPLIED>'
		'<!!ELEMENT test EMPTY>
		<!!ENTITY % partial "<!!">
		%partial;ATTLIST test name CDATA #IMPLIED')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].

	"these are validity exceptions"
	#('<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "<!!ATTLIST">
			%partial; test name CDATA #IMPLIED>'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "<!!ATTLIST test">
			%partial; name CDATA #IMPLIED>'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "<!!ATTLIST test name">
			%partial; CDATA #IMPLIED>'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "<!!ATTLIST test name CDATA">
			%partial; #IMPLIED>'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "<!!ATTLIST test name CDATA #IMPLIED">
			%partial;>'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial ">">
			<!!ATTLIST test name CDATA #IMPLIED %partial;'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "#IMPLIED>">
			<!!ATTLIST test name CDATA %partial;'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "CDATA #IMPLIED>">
			<!!ATTLIST test name %partial;'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "name CDATA #IMPLIED>">
			<!!ATTLIST test %partial;'
		'<!!ELEMENT test EMPTY>
			<!!ENTITY % partial "test name CDATA #IMPLIED>">
			<!!ATTLIST %partial;')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLException].
	self
		shouldnt: [| dtd |
			dtd := '
				<!!ELEMENT test EMPTY>
				<!!ENTITY % total "<!!ATTLIST test name CDATA #IMPLIED>">
				%total;'.
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2016 23:56'!
testEntityNestingCharacterReference
	"even though general entity refs are bypassed in entity values, they are still
	checked for well formedness (they must be complete), so the only way to have an
	entity value containing part of a general ref is to use a char escape for the &"
	#('<!!DOCTYPE test [
				<!!ENTITY partial "&#38;">
			]><test>&partial;#64;</test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "&#38;#">
			]><test>&partial;64;</test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "&#38;#64">
			]><test>&partial;;</test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "#64;">
			]><test>&&partial;</test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "64;">
			]><test>&#&partial;</test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial ";">
			]><test>&#64&partial;</test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "&#38;">
			]><test name="&partial;#64;"></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "&#38;#">
			]><test name="&partial;64;"></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "&#38;#64">
			]><test name="&partial;;"></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "#64;">
			]><test name="&&partial;"></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "64;">
			]><test name="&#&partial;"></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial ";">
			]><test name="&#64&partial;"></test>')
		do: [:each |
			self
				should: [
					(SAXHandler on: each)
						isValidating: false;
						parseDocument]
				raise: XMLWellFormednessException].
	self
		shouldnt: [
			(SAXHandler on:
				'<!!DOCTYPE test [
					<!!ENTITY total "&#38;#64;">
				]><test name="&total;">&total;</test>')
				isValidating: false;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/7/2016 01:47'!
testEntityNestingComment
	#('<!!DOCTYPE test [
				<!!ENTITY partial "<">
			]><test>&partial;!!--ignored--></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<!!">
			]><test>&partial;--ignored--></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<!!-">
			]><test>&partial;-ignored--></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<!!--">
			]><test>&partial;ignored--></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<!!--ignored">
			]><test>&partial;--></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<!!--ignored-">
			]><test>&partial;-></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<!!--ignored--">
			]><test>&partial;></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].

	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test [
						<!!ENTITY total "<?name value?>">
					]><test>&total;</test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/30/2016 09:37'!
testEntityNestingElement
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test [
					<!!ENTITY total1 "<a name=''value''/>">
					<!!ENTITY total2 "<b>&total1;</b>">
					<!!ENTITY total3 "<c>&total1;&total2;</c>">
				]><test>&total1;&total2;&total3;</test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testEntityNestingElementDeclaration
	| xml |
	
	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.

	"these are wellformedness exceptions because the replacement is surrounded
	with spaces which interrupt the '<!!ELEMENT' sequence"
	#('<!!ENTITY % partial "<">%partial;!!ELEMENT test EMPTY>'
		'<!!ENTITY % partial "<!!">%partial;ELEMENT test EMPTY')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].

	"these are validity exceptions"
	#('<!!ENTITY % partial "<!!ELEMENT">%partial;test EMPTY>'
		'<!!ENTITY % partial "<!!ELEMENT test">%partial;EMPTY>'
		'<!!ENTITY % partial "<!!ELEMENT test EMPTY">%partial;>'
		'<!!ENTITY % partial ">"><!!ELEMENT test EMPTY%partial;'
		'<!!ENTITY % partial "EMPTY>"><!!ELEMENT test %partial;'
		'<!!ENTITY % partial "test EMPTY>"><!!ELEMENT %partial;'
		'<!!ENTITY % partial "("><!!ELEMENT test %partial; #PCDATA)>'
		'<!!ENTITY % partial ")"><!!ELEMENT test (#PCDATA %partial;>'
		'<!!ENTITY % partial "(#PCDATA"><!!ELEMENT test %partial;)>'
		'<!!ENTITY % partial "#PCDATA)"><!!ELEMENT test (%partial;>'
		'<!!ENTITY % partial "("><!!ELEMENT test %partial; a?)>'
		'<!!ENTITY % partial ")"><!!ELEMENT test (a? %partial;>'
		'<!!ENTITY % partial "(a?"><!!ELEMENT test %partial;)>'
		'<!!ENTITY % partial "a?)"><!!ELEMENT test (%partial;>'
		'<!!ENTITY % partial "(a|b"><!!ELEMENT test (%partial;))?>'
		'<!!ENTITY % partial "a|b)"><!!ELEMENT test ((%partial;)?>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLException].

	#('<!!ENTITY % partial1 "(a|b)">
			<!!ENTITY % partial2 "(c,d)">
			<!!ENTITY % partial3 "(%partial1;, %partial2;)?">
			<!!ENTITY % total "<!!ELEMENT test %partial3;>">
			%total;'
		'<!!ENTITY % partial1 "a">
			<!!ENTITY % partial2 "b">
			<!!ENTITY % partial3 "(#PCDATA | %partial1; | %partial2;)*">
			<!!ENTITY % total "<!!ELEMENT test %partial3;>">
			%total;')
		do: [:each |
			self
				shouldnt: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/26/2016 03:27'!
testEntityNestingElementPartialEndTag
	#('<!!DOCTYPE test [
				<!!ENTITY partial "<">
			]><test><a name=''value''>&partial;/a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "</">
			]><test><a name=''value''>&partial;a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "</a">
			]><test><a name=''value''>&partial;></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "</a>">
			]><test><a name=''value''>&partial;</test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/26/2016 03:27'!
testEntityNestingElementPartialSelfClosingTag
	#('<!!DOCTYPE test [
				<!!ENTITY partial "<">
			]><test>&partial;a name=''value''/></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a">
			]><test>&partial;name=''value''/></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name">
			]><test>&partial;=''value''/></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=">
			]><test>&partial;''value''/></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''">
			]><test>&partial;value''/></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''value">
			]><test>&partial;''/></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''value''">
			]><test>&partial;/></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''value''/">
			]><test>&partial;></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/26/2016 03:27'!
testEntityNestingElementPartialStartTag
	#('<!!DOCTYPE test [
				<!!ENTITY partial "<">
			]><test>&partial;a name=''value''></a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a">
			]><test>&partial;name=''value''></a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name">
			]><test>&partial;=''value''></a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=">
			]><test>&partial;''value''></a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''">
			]><test>&partial;value''></a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''value">
			]><test>&partial;''></a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''value''">
			]><test>&partial;></a></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<a name=''value''>">
			]><test>&partial;</a></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/6/2016 23:43'!
testEntityNestingGeneralEntityReference
	"even though general entity refs are bypassed in entity values, they are still
	checked for well formedness (they must be complete), so the only way to declare
	an entity with a replacement containing a '&' is to escape it as char ref"
	#('<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "&#38;">
		]><test>&partial;name;</test>'
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "&#38;name">
		]><test>&partial;;</test>'
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "name;">
		]><test>&&partial;</test>'
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "name;">
		]><test>&name&partial;</test>'
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "&#38;">
		]><test name="&partial;name;"></test>'
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "&#38;name">
		]><test name="&partial;;"></test>'
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "name;">
		]><test name="&&partial;"></test>'
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY partial "name;">
		]><test name="&name&partial;"></test>')
		do: [:each |
			self
				should: [
					(SAXHandler on: each)
						isValidating: false;
						parseDocument]
				raise: XMLWellFormednessException].
	self
		shouldnt: [
			(SAXHandler on:
				'<!!DOCTYPE test [
					<!!ENTITY name "value">
					<!!ENTITY total "&name;">
				]><test name="&total;">&total;</test>')
				isValidating: false;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/25/2016 17:51'!
testEntityNestingIgnoreSection
	"If any of the '<!![', '[', or ']]>' of a conditional section is contained
	in the replacement text for a parameter-entity reference, all of them
	MUST be contained in the same replacement text."
	| xml |
	
	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.

	"these are wellformedness exceptions because the replacement is surrounded
	with spaces which interrupt the '<!![' and ']]>' sequences"
	#('<!!ENTITY % partial "<">%partial;!![IGNORE[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!!">%partial;[IGNORE[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![IGNORE[<!!--ignore-->]">%partial;]>'
		'<!!ENTITY % partial "<!![IGNORE[<!!--ignore-->]]">%partial;>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].

	"these are validity exceptions"
	#('<!!ENTITY % partial "<!![">%partial;IGNORE[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![IGNORE">%partial;[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![IGNORE[">%partial;<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![IGNORE[<!!--ignore-->">%partial;]]>'
		'<!!ENTITY % partial "IGNORE["><!![%partial;<!!--ignore-->]]>'
		'<!!ENTITY % partial "IGNORE[<!!--ignore-->"><!![%partial;]]>'
		'<!!ENTITY % partial "IGNORE[<!!--ignore-->]]>"><!![%partial;')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLException].
	self
		shouldnt: [| dtd |
			dtd := '
				<!!ENTITY % partial "IGNORE">
				<!!ENTITY % total "<!![%partial;[<!!--ignore-->]]]]]>">
				%total;'.
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/25/2016 17:48'!
testEntityNestingIncludeSection
	"If any of the '<!![', '[', or ']]>' of a conditional section is contained
	in the replacement text for a parameter-entity reference, all of them
	MUST be contained in the same replacement text."
	| xml |
	
	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.

	"these are wellformedness exceptions because the replacement is surrounded
	with spaces which interrupt the '<!![' and ']]>' sequences"
	#('<!!ENTITY % partial "<">%partial;!![INCLUDE[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!!">%partial;[INCLUDE[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![INCLUDE[<!!--ignore-->]">%partial;]>'
		'<!!ENTITY % partial "<!![INCLUDE[<!!--ignore-->]]">%partial;>'
		'<!!ENTITY % partial "]"<!![INCLUDE[<!!--ignore-->%partial;]>'
		'<!!ENTITY % partial "]]"><!![INCLUDE[<!!--ignore-->%partial;>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].

	"these are validity exceptions"
	#('<!!ENTITY % partial "<!![">%partial;INCLUDE[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![INCLUDE">%partial;[<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![INCLUDE[">%partial;<!!--ignore-->]]>'
		'<!!ENTITY % partial "<!![INCLUDE[<!!--ignore-->">%partial;]]>'
		'<!!ENTITY % partial "INCLUDE["><!![%partial;<!!--ignore-->]]>'
		'<!!ENTITY % partial "INCLUDE[<!!--ignore-->"><!![%partial;]]>'
		'<!!ENTITY % partial "INCLUDE[<!!--ignore-->]]>"><!![%partial;'
		'<!!ENTITY % partial "]]>"><!![INCLUDE[<!!--ignore-->%partial;')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLException].
	self
		shouldnt: [| dtd |
			dtd := '
				<!!ENTITY % partial1 "INCLUDE">
				<!!ENTITY % partial2 "<!!--ignore-->">
				<!!ENTITY % total "<!![%partial1;[%partial2;]]>">
				%total;'.
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/7/2016 00:03'!
testEntityNestingProcessingInstruction
	#('<!!DOCTYPE test [
				<!!ENTITY partial "<">
			]><test>&partial;?name value?></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<?">
			]><test>&partial;name value?></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<?name">
			]><test>&partial; value?></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<?name value">
			]><test>&partial;?></test>'
		'<!!DOCTYPE test [
				<!!ENTITY partial "<?name value?">
			]><test>&partial;></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].

	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test [
						<!!ENTITY total "<?name value?>">
					]><test>&total;</test>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testEntityNestingSubsetComment
	| xml |
	
	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.

	"these are wellformedness exceptions because the replacement is surrounded
	with spaces which interrupt the '<!!--' and '-->' sequences"
	#('<!!ENTITY % partial "<">%partial;!!--ignore-->'
		'<!!ENTITY % partial "<!!">%partial;--ignore-->'
		'<!!ENTITY % partial "<!!-">%partial;-ignore-->'
		'<!!ENTITY % partial "<!!--ignore-">%partial;->'
		'<!!ENTITY % partial "<!!--ignore--">%partial;>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].

	#('<!!ENTITY % partial "<!!--">%partial;ignore-->'
		'<!!ENTITY % partial "<!!--ignore">%partial;-->')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLException].
	self
		shouldnt: [| dtd |
			dtd := '
				<!!ENTITY % total "<!!--ignore-->">
				%total;'.
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testEntityNestingSubsetProcessingInstruction
	| xml |
	
	xml := '<!!DOCTYPE test SYSTEM "extern.dtd"><test/>'.

	"these are wellformedness exceptions because the replacement is surrounded
	with spaces which interrupt the '<?name' and '?>' sequences"
	#('<!!ENTITY % partial "<">%partial;?name value?>'
		'<!!ENTITY % partial "<?">%partial;name value?>'
		'<!!ENTITY % partial "<?name value?">%partial;>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLWellFormednessException].

	#('<!!ENTITY % partial "<?name">%partial; value?>'
		'<!!ENTITY % partial "<?name value">%partial;?>')
		do: [:each |
			self
				should: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: xml)
						externalEntityResolver:
							(DTDStaticExternalEntityResolver externalEntities:
								(Array with: 'extern.dtd' -> each));
						isValidating: false;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLException].
	self
		shouldnt: [| dtd |
			dtd := '
				<!!ENTITY % total "<?name value?>">
				%total;'.
			(SAXHandler on: xml)
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.dtd' -> dtd));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/21/2016 01:18'!
testEntityReferenceInternalDeclaration
	#('<!!DOCTYPE root [
			<!!ENTITY % name "root">
			<!!ENTITY % contentModel "EMPTY">
			<!!ELEMENT %name; %contentModel;>
		]><root/>',
		'<!!DOCTYPE root [
			<!!ENTITY % name "value">
			<!!ENTITY % name2 "%name;">
		]><root/>'
		'<!!DOCTYPE root [
			<!!ENTITY % name "value">
			<!!ENTITY name2 "%name;">
		]><root/>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % element "<!!ELEMENT root EMPTY>">
					%element;
				]><root/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 12/3/2016 01:11'!
testEntityReferenceInternalDeclarationExternallyDefined
	| declarations |

	self
		shouldnt: [
			"the rule against param entity refs in internal declarations
			shouldn't apply to declarations in external entities included
			in the subset"
			declarations := '
				<!!ENTITY % name "test">
				<!!ENTITY % contentModel "(#PCDATA)">
				<!!ELEMENT %name; %contentModel;>'.
			(SAXHandler on: '
				<!!DOCTYPE test [
					<!!ENTITY % extern SYSTEM "extern.ent">
					%extern;
					<!!ATTLIST test name CDATA #IMPLIED>
				]>
				<test name="value">test</test>')
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.ent' -> declarations));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.
	self
		should: [
			"the rule against param entity refs in internal declarations
			should apply to declarations in internal entities included
			in the subset even if they're internal to an external entity"
			declarations :=
				'<!!ENTITY % extern2 "
					<!!ENTITY &#37; name &#34;test&#34;>
					<!!ENTITY &#37; contentModel &#34;(#PCDATA)&#34;>
					<!!ELEMENT &#37;name; &#37;contentModel;>
				">'.
			(SAXHandler on: '
				<!!DOCTYPE test [
					<!!ENTITY % extern SYSTEM "extern.ent">
					%extern;
					%extern2;
					<!!ATTLIST test name CDATA #IMPLIED>
				]>
				<test name="value">test</test>')
				externalEntityResolver:
					(DTDStaticExternalEntityResolver externalEntities:
						(Array with: 'extern.ent' -> declarations));
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/29/2016 21:44'!
testEntityReferencePredefined
	| document references replacements |

	references := String new writeStream.
	replacements := String new writeStream.
	XMLWellFormedParserTokenizer predefinedEntities keysAndValuesDo: [:name :char |
		references
			nextPut: $&;
			nextPutAll: name;
			nextPut: $;.
		replacements nextPut: char].

	document :=
		XMLDOMParser parse:
			('<!!DOCTYPE root [
				<!!ENTITY nonRecursive "&amp;nonRecursive;">]>
			<root name=''{1}''>
				<one>{1}</one>
				<two>&nonRecursive;</two>
			</root>' format: (Array with: references contents)).
	self
		assert: (document root attributeAt: 'name') = replacements contents;
		assert: (document root contentStringAt: 'one') = replacements contents;
		assert: (document root contentStringAt: 'two') = '&nonRecursive;'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/4/2016 05:56'!
testEntityReferenceUndeclared
	"it's a WFC if there's no DTD or an internal-only DTD that
	contains no param entity refs or if it's standalone"
	#('<test>&undeclared;</test>'
		'<test name="&undeclared;"/>'
		'<DOCTYPE test [
			<!!ELMENT test EMPTY>
		]>
		<test>&undeclared;</test>'
		'<DOCTYPE test [
			<!!ELMENT test EMPTY>
			<!!ATTLIST test name CDATA #IMPLIED>
		]>
		<test name="&undeclared;"/>'
		'<?xml version="1.0" standalone="yes"?>
		<!!DOCTYPE test SYSTEM "extern.dtd">
		<test>&undeclared;</test>'
		'<?xml version="1.0" standalone="yes"?>
		<!!DOCTYPE test SYSTEM "extern.dtd">
		<test name="&undeclared;"/>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].

	"otherwise it's a validity constraint only"
	#('<!!DOCTYPE test SYSTEM "extern.dtd">
		<test>&undeclared;</test>'
		'<!!DOCTYPE test SYSTEM "extern.dtd">
		<test name="&undeclared;"/>'
		'<!!DOCTYPE test [
			%undeclared;
		]>
		<test>&undeclared;</test>'
		'<!!DOCTYPE test [
			%undeclared;
		]>
		<test name="&undeclared;"/>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: each)
						isValidating: false;
						parseDocument]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/5/2016 10:11'!
testEntityReferenceUndeclaredInEntityValue
	| resolver |

	(resolver := DTDStaticExternalEntityResolver new)
		externalEntityAtURI: 'extern.dtd'
		put: '<!!ENTITY unreferenced "%undeclared;">'.
	self
		should: [
			(SAXHandler on: '<!!DOCTYPE root SYSTEM "extern.dtd"><root/>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on: '<!!DOCTYPE root SYSTEM "extern.dtd"><root/>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				isValidating: false;
				parseDocument]
		raise: XMLWellFormednessException.

	"the spec only requires general entity refs in replacements to be
	well-formed, not declared, unless it's referenced too"
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY unreferenced "&undeclared;">
				]><root/>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY unreferenced "&undeclared;">
				]><root>&unreferenced;</root>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/4/2016 05:57'!
testEntityReferenceUndeclaredPreserved
	| xml parser document |

	xml := '
		<!!DOCTYPE root PUBLIC "extern" "extern.dtd" [
			<!!ENTITY unreferenced "&undeclaredOne;">
			%undeclaredOne;
		]>
		<root name="&#34;&undeclaredOne;&#34;">&lt;&undeclaredTwo;&gt;</root>'.
	(parser := XMLDOMParser on: xml)
		isValidating: false;
		preservesUndeclaredEntityReferences: true.
	document := parser parseDocument.

	self
		assert: document doctypeDeclaration nodes size = 1;
		assert: document doctypeDeclaration firstNode replacement = '&undeclaredOne;';
		assert: (document root attributeAt: 'name') = '"&undeclaredOne;"';
		assert: (document root contentString) = '<&undeclaredTwo;>'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/14/2016 18:44'!
testEntityReferenceUnexpected
	#('<!!DOCTYPE test [
			<!!ENTITY entity "<!!--comment-->">
			&entity;]>
		<test/>'
		'<!!DOCTYPE test [
			<!!ENTITY entity "<!!--comment-->">
			]>
		&entity;
		<test/>'
		'<!!DOCTYPE test [
			<!!ENTITY entity "<!!--comment-->">
			]>
		<test/>
		&entity;')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			"should still raise errors even when replacement is disabled"
			self
				should: [
					(SAXHandler on: each)
						replacesContentEntityReferences: false;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/29/2016 21:42'!
testEntityReferenceUnreplaced
	| beforeSubset subset afterSubset xml document |

	beforeSubset := '<?xml version="1.1"?> <!!DOCTYPE entity ['.
	subset :=
		'<!!ENTITY % first "<!!ENTITY second &#34;replacement&#34;>">
		%first;'.
	afterSubset := ']><entity>&second;</entity>'.
	xml := beforeSubset, subset, afterSubset.
	self assert: (XMLDOMParser parse: xml) root contentString = 'replacement'.
	
	document :=
		(XMLDOMParser on: xml)
			replacesContentEntityReferences: false;
			parseDocument.
	self assert: document root contentString = '&second;'.
	self
		should: [
			(SAXHandler on: (beforeSubset, '%first;]>'))
				replacesContentEntityReferences: false;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/29/2016 21:44'!
testEntityReferenceUnreplacedInContent
	| xml document |

	xml := '
		<!!DOCTYPE one [<!!ENTITY declared "replacement">]>
		<one two="&quot;&declared;&quot;">&#60;&declared;&#x2F;&#x3e;</one>'.
	document :=
		(XMLDOMParser on: xml)
			replacesContentEntityReferences: false;
			parseDocument.
	self
		assert: (document root attributeAt: 'two') = '&quot;&declared;&quot;';
		assert: document root contentString = '&#60;&declared;&#x2F;&#x3e;'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/4/2016 06:00'!
testEntityReferenceUnreplacedInContentUndeclared
	| xml document |

	xml := '
		<!!DOCTYPE one SYSTEM "extern.dtd" [
			<!!ENTITY declared "replacement">
		]>
		<one two="&quot;&undeclared;&quot;">&#60;&undeclared;&#62;</one>'.
	self
		should: [
			(SAXHandler on: xml)
				replacesContentEntityReferences: false;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: xml)
					replacesContentEntityReferences: false;
					isValidating: false;
					parseDocument]
		raise: XMLValidationException.
	self
		assert: (document root attributeAt: 'two') = '&quot;&undeclared;&quot;';
		assert: document root contentString = '&#60;&undeclared;&#62;'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 10/14/2016 18:44'!
testEntityReferenceUnterminated
	#('<!!DOCTYPE test [
			<!!ENTITY % entity "<!!ELEMENT test EMPTY>">
			%]><test/>'
		'<!!DOCTYPE test [
			<!!ENTITY % entity "<!!ELEMENT test EMPTY>">
			%;]><test/>'
		'<!!DOCTYPE test [
			<!!ENTITY % entity "<!!ELEMENT test EMPTY>">
			%entity]><test/>'
		'<test>&'
		'<test>&</test>'
		'<test>&amp'
		'<test>&amp</test>'
		'<test>&;'
		'<test>&;</test>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			"should still raise errors even when replacement is disabled"
			self
				should: [
					(SAXHandler on: each)
						replacesContentEntityReferences: false;
						parseDocument]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/21/2016 03:01'!
testEntityReferenceUnterminatedInEntityValue
	#('<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY param "&">
		]><test/>',
		'<!!DOCTYPE test [
			<!!ENTITY name "value">
			<!!ENTITY param "&name">
		]><test/>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].

	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test [
					<!!ENTITY name "value">
					<!!ENTITY param "&name;">
				]><test/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/21/2016 01:15'!
testEntityReplacement
	| document |

	document := XMLDOMParser parse: '
		<!!DOCTYPE root [
			<!!ENTITY % name1Declaration "<!!ENTITY name1 &#39;replacement1&#x27;>">
			%name1Declaration;
			<!!ENTITY name2 "replacement2 &name1;" >
			<!!ENTITY name3 "replacement3 &name2;" >
			<!!ENTITY quotes "&#x27;quoted &#x22;value&#34;&#39;">
		]>
		<root name="&quotes;">&name1; &name2; &name3; ',
		'%name1Declaration;</root>'.
	self assert:
		document root contentString =
			('replacement1 ',
			'replacement2 replacement1 ',
			'replacement3 replacement2 replacement1 ',
			'%name1Declaration;').
	self assert:
		(document root attributeAt: 'name') =
			(('quoted "value"' copyWithFirst: $') copyWith: $').! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:27'!
testEntityReplacementEmpty
	| xml document |

	xml := '<?xml version="1.0"?>
	<!!DOCTYPE entities [
		<!!ENTITY % inner "">
		%inner;
		<!!ENTITY inner  ""> 
		<!!ENTITY outer ''&inner;''>]>
	<entities one="&outer;" two="&inner;" three=''&outer;'' four=''&inner;''>&outer;&inner;</entities>'.

	self
		shouldnt: [document := XMLDOMParser parse: xml]
		raise: XMLWellFormednessException.
	self
		assert: (document root attributeAt: 'one') = '';
		assert: (document root attributeAt: 'two') = '';
		assert: (document root attributeAt: 'three') = '';
		assert: (document root attributeAt: 'four') = '';
		assert: document root contentString = ''.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:51'!
testEntityReplacementSelfReferential
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ENTITY first "&first;">]><root>&first;</root>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [<!!ENTITY % first "&#37;first;">%first;]><root/>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY first "&second;">
					<!!ENTITY second "&first;">]><root>&first;</root>']
		raise: XMLWellFormednessException.
	self
		should: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % first "&#37;second;">
					<!!ENTITY % second "&#37;first;">
					%first;]><root/>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY first "&second;">
					<!!ENTITY second "<!!--replacement-->">]><root>&first;</root>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE root [
					<!!ENTITY % first "&#37;second;">
					<!!ENTITY % second "<!!--replacement-->">
					%first;]><root/>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/27/2016 04:13'!
testEntityReplacementStandard
	"this test comes from the XML spec"
	| dtd xml doc |

	dtd := '
		<!!ENTITY % pub    "&#xc9;ditions Gallimard" >
		<!!ENTITY   rights "All rights reserved" >
		<!!ENTITY   book   "La Peste: Albert Camus, &#xA9; 1947 %pub;. &rights;" >'.
	xml := '
		<!!DOCTYPE test SYSTEM ''extern.dtd''>
		<test>&book;</test>'.
	doc :=
		(XMLDOMParser on: xml)
			externalEntityResolver:
				(DTDStaticExternalEntityResolver externalEntities:
					(Array with: 'extern.dtd' -> dtd));
			resolvesExternalEntities: true;
			parseDocument.
	self assert:
		doc root contentString =
			('La Peste: Albert Camus, ', 16rA9 asCharacter asString, ' 1947 ',
				16rC9 asCharacter asString, 'ditions Gallimard. All rights reserved').! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/15/2016 16:18'!
testEntityReplacementStandardLiteral
	"this test comes from the XML spec"
	| dtd xml resolver doc |

	dtd := '
		<!!ENTITY % YN ''"Yes"'' >
		<!!ENTITY WhatHeSaid "He said %YN;" >'.
	xml := '
		<!!DOCTYPE element SYSTEM ''extern.dtd''>
		<element attribute="&WhatHeSaid;"></element>'.
	(resolver := DTDStaticExternalEntityResolver new)
		externalEntityAtURI: 'extern.dtd'
		put: dtd.
	doc :=
		(XMLDOMParser on: xml)
			externalEntityResolver: resolver;
			resolvesExternalEntities: true;
			parseDocument.
	self assert: (doc root attributeAt: 'attribute') = 'He said "Yes"'.

	dtd := '<!!ENTITY EndAttr "27''" >'.
	xml := '
		<!!DOCTYPE element SYSTEM ''extern.dtd''>
		<element attribute=''a-&EndAttr;></element>'.
	(resolver := DTDStaticExternalEntityResolver new)
		externalEntityAtURI: 'extern.dtd'
		put: dtd.
	self
		should: [
			(SAXHandler on: xml)
				externalEntityResolver: resolver;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/4/2016 00:24'!
testEntityReplacementTerminatingInternalSubset
	#('<!!DOCTYPE root [<!!ENTITY % end "]>">%end;'
		'<!!DOCTYPE root [<!!ENTITY % end "]">%end;>')
		do: [:each |
			self
				should: [SAXHandler parse: each,  '<root/>']
				raise: XMLWellFormednessException].
	#('<!!DOCTYPE root [<!!ENTITY % end "">%end;]>'
		'<!!DOCTYPE root [<!!ENTITY % end "<!!--]>-->">%end;]>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each,  '<root/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/8/2016 06:16'!
testEntityURIInheritance
	| xml parser driver |

	xml := '<!!DOCTYPE root [%first;]><root xml:base="/new/xml">&second;</root>'.
	parser :=
		(SAXHandler
			on: xml
			documentURI: 'test.xml') parser.
	(driver := parser driver)
		doctypeDefinition parameterEntities
			at: 'first'
			put:
				(DTDExternalParameterEntity
					name: 'first'
					replacement: '<!!ENTITY second "<!!--comment-->">'
					uri: 'test.ent').

	self assert: driver baseURI = 'test.xml'.

	3 timesRepeat: [parser parseToken].
	self assert: driver baseURI = 'test.ent'.

	2 timesRepeat: [parser parseToken].
	self assert: driver baseURI = 'test.xml'.
	
	"internal entities (declared in the internal subset or in an external DTD)
	can't change abase URI according to the xml:base spec"
	2 timesRepeat: [parser parseToken].
	self assert: driver baseURI = '/new/xml'.

	3 timesRepeat: [parser parseToken].
	self
		assert: driver baseURI = 'test.xml';
		assert: parser atEnd.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/24/2015 20:33'!
testIsInContent
	| xml handler parser |

	xml := '<?xml version="1.0"?>
			<!!--comment-->
			<?target data?>
			<!!DOCTYPE root [<!!ELEMENT root EMPTY>]>
			<!!--comment-->
			<?target data?>
			<root/>'.
	handler := SAXHandler on: xml.
	parser := handler parser.
	9 timesRepeat: [
		parser parseToken.
		self deny: handler isInContent].
	parser parseToken.
	self assert: handler isInContent.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/22/2015 03:34'!
testLineEndingsDoNotMatter
	| source docFromSourceWithCRs docFromSourceWithLFs docFromSourceWithCRLFs |

	source := '<root>{1}one{1}two{1}</root>'.
	docFromSourceWithCRs := XMLDOMParser parse: (source format: (Array with: String cr)).
	docFromSourceWithLFs := XMLDOMParser parse: (source format: (Array with: String lf)).
	docFromSourceWithCRLFs := XMLDOMParser parse: (source format: (Array with: String crlf)).
	self
		assert: (docFromSourceWithCRs root contentString) = (docFromSourceWithLFs root contentString);
		assert: (docFromSourceWithLFs root contentString) = (docFromSourceWithCRLFs root contentString).! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 8/25/2016 00:34'!
testNamespaceAttributePrefixAliasing
	| xmlns |

	xmlns := 'xmlns:prefix1="ns" xmlns:prefix2="ns"'.
	self
		shouldnt: [
			SAXHandler
				parse: '<test ', xmlns, ' prefix1:name1="value" prefix2:name2="value2"/>'
				usingNamespaces: true]
		raise: XMLNamespaceException.

	(Array
		with: '<test ', xmlns, ' prefix1:aliased="value" prefix2:aliased="value2"/>'
		with: "ensure it checks inherited namespaces"
			'<test ', xmlns, '>
				<test2 prefix1:aliased="value" prefix2:aliased="value2"/>
			</test>'
		with: "and default attributes"
			'<!!DOCTYPE test [
				<!!ELEMENT test (test2)>
				<!!ATTLIST test
					xmlns:prefix1 CDATA #IMPLIED
					xmlns:prefix2 CDATA #IMPLIED>
				<!!ELEMENT test2 EMPTY>
				<!!ATTLIST test2
					prefix1:aliased CDATA "value"
					prefix2:aliased CDATA "value2">
			]>
			<test ', xmlns, '>
				<test2/>
			</test>')
		do: [:each |
			self
				should: [
					SAXHandler
						parse: each
						usingNamespaces: true]
				raise: XMLNamespaceException.
			self
				shouldnt: [
					SAXHandler
						parse: each
						usingNamespaces: false]
				raise: XMLNamespaceException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:45'!
testNamespaceDeclaration
	self
		shouldnt: [SAXHandler parse: '<prefix:root prefix:name="test" xmlns:prefix="NS"/>']
		raise: XMLNamespaceException.
	self
		shouldnt: [SAXHandler parse: '<root xmlns="defaultNS"/>']
		raise: XMLNamespaceException.
	self
		shouldnt: [SAXHandler parse: '<root xmlns=""/>' usingNamespaces: true]
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:46'!
testNamespaceDeclarationBadPrefix
	self
		should: [SAXHandler parse: '<root xmlns:invalid:prefix="invalidNS"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root xmlns::invalidprefix="invalidNS"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root xmlns:invalidprefix:="invalidNS"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<:invalidname />']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<invalidname: />']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root :invalidname="test" />']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root invalidname:="test" />']
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:47'!
testNamespaceDeclarationBadURI
	self
		should: [SAXHandler parse: '<root xmlns:empty=""/>' usingNamespaces: true]
		raise: XMLNamespaceException.

	"Cannot change xmlns or xml prefixes"
	self
		should: [SAXHandler parse: '<root xmlns:xmlns="newNS"/>' usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root xmlns:xml="newNS" />' usingNamespaces: true]
		raise: XMLNamespaceException.

	"Redundant xml prefix mapping is ok, but xmlns is not"
	self
		shouldnt: [
			SAXHandler
				parse: '<root xmlns:xml="', XMLNamespaceScope xmlNamespaceURI, '"/>'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	self
		should: [
			SAXHandler
				parse: '<root xmlns:xmlns="', XMLNamespaceScope xmlnsNamespaceURI, '"/>'
				usingNamespaces: true]
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/8/2016 09:04'!
testNamespaceDeclarationRedundance
	#('<test xmlns:prefix="prefixNS" xmlns:prefixTwo="prefixTwoNS" xmlns:prefix="prefixNS" />'
		'<test xmlns:prefix="prefixNS" xmlns:prefixTwo="prefixTwoNS" xmlns:prefix="prefixTwoNS" />'
		'<test xmlns="defaultNS" xmlns:prefix="prefixNS" xmlns="defaultNS" />'
		'<test xmlns="defaultNS" xmlns:prefix="prefixNS" xmlns="defaultTwoNS" />')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 6/24/2016 03:04'!
testNamespaceParsing
	self
		shouldnt: [SAXHandler parse: self addressBookNamespacedXML]
		raise: XMLException.
	self
		shouldnt: [
			SAXHandler
				parse: self addressBookNamespacedXML
				usingNamespaces: false]
		raise: XMLException.

	self
		shouldnt: [SAXHandler parse: self addressBookNamespacePrefixedXML]
		raise: XMLException.
	self
		shouldnt: [
			SAXHandler
				parse: self addressBookNamespacePrefixedXML
				usingNamespaces: false]
		raise: XMLException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 8/25/2016 00:32'!
testNamespacePrefixInheritance
	self
		shouldnt: [
			SAXHandler
				parse:
					'<one xmlns:prefix1="ns">
						<prefix1:two xmlns:prefix2="ns2">
							<prefix2:three><prefix1:four /></prefix2:three>
						</prefix1:two>
					</one>'
				usingNamespaces: true]
		raise: XMLNamespaceException.
	
	#('<one xmlns:prefix1="ns">
			<prefix1:two xmlns:prefix2="ns2" />
			<prefix2:three />
		</one>'
		'<one xmlns:prefix1="ns">
			<prefix1:two xmlns:prefix2="ns2">
				<prefix2:three xmlns:prefix3="ns3" />
			</prefix1:two>
			<prefix3:four />
		</one>')
		do: [:each |
			self
				should: [
					SAXHandler
						parse: each
						usingNamespaces: true]
				raise: XMLNamespaceException.
			self
				shouldnt: [
					SAXHandler
						parse: each
						usingNamespaces: false]
				raise: XMLNamespaceException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:46'!
testNamespaceUndeclared
	self
		shouldnt: [SAXHandler parse: '<prefix:root prefix:name="test"/>' usingNamespaces: false]
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<prefix:root/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<root prefix:name="test"/>']
		raise: XMLNamespaceException.

	"xml is OK as a prefix, xmlns is not"
	self
		shouldnt: [SAXHandler parse: '<xml:root xml:name="test"/>']
		raise: XMLNamespaceException.
	self
		should: [SAXHandler parse: '<xmlns:root />']
		raise: XMLNamespaceException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 21:33'!
testNotationDeclarationRedundance
	#('<!!DOCTYPE test [
			<!!NOTATION name PUBLIC "note">
			<!!NOTATION name PUBLIC "newnote">
		]>'
		'<!!DOCTYPE test [
			<!!NOTATION name PUBLIC "note">
			<!!NOTATION name PUBLIC "note">
		]>'
		'<!!DOCTYPE test [
			<!!NOTATION name PUBLIC "note">
			<!!NOTATION name SYSTEM "newnote">
		]>')
		do: [:each |
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: each, '<test/>')
						isValidating: false;
						parseDocument]
				raise: XMLValidationException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 03:01'!
testNotationDeclarationUnterminated
	#('<!!NOTATION'
		'<!!NOTATION>'
		'<!!NOTATION name'
		'<!!NOTATION name>'
		'<!!NOTATION name PUBLIC'
		'<!!NOTATION name PUBLIC>'
		'<!!NOTATION name PUBLIC "'
		'<!!NOTATION name PUBLIC ">'
		'<!!NOTATION name PUBLIC "pubicid"'
		'<!!NOTATION name PUBLIC '''
		'<!!NOTATION name PUBLIC ''>'
		'<!!NOTATION name PUBLIC ''pubicid'''
		'<!!NOTATION name PUBLIC "pubicid''>'
		'<!!NOTATION name PUBLIC ''pubicid">'
		'<!!NOTATION name SYSTEM'
		'<!!NOTATION name SYSTEM>'
		'<!!NOTATION name SYSTEM "'
		'<!!NOTATION name SYSTEM ">'
		'<!!NOTATION name SYSTEM "systemid"'
		'<!!NOTATION name SYSTEM '''
		'<!!NOTATION name SYSTEM ''>'
		'<!!NOTATION name SYSTEM ''systemid'''
		'<!!NOTATION name SYSTEM "systemid''>'
		'<!!NOTATION name SYSTEM ''systemid">')
		do: [:each |
			self
				should: [SAXHandler parse: '<!!DOCTYPE test [', each]
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: '<!!DOCTYPE test [', each, ']><test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 20:19'!
testNotationDeclarationWhitespace
	#('<!!DOCTYPE test [<!!NOTATIONname PUBLIC "publicid">]>'
		'<!!DOCTYPE test [<!!NOTATION name PUBLIC"publicid">]>'
		'<!!DOCTYPE test [<!!NOTATION name PUBLIC "publicid""systemid">]>'
		'<!!DOCTYPE test [<!!NOTATION name SYSTEM"systemid">]>')
		do: [:each |
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].

	#('<!!DOCTYPE test [<!!NOTATION     name  PUBLIC  "publicid"   >]>'
		'<!!DOCTYPE test [<!!NOTATION name PUBLIC        "publicid"   "systemid"   >]>'
		'<!!DOCTYPE test [<!!NOTATION name SYSTEM        "systemid"		>]>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testPCDataBadChar
	self nonChars do: [:each |
		self
			should: [SAXHandler parse: '<test>', each asString, '</test>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/11/2016 11:15'!
testPCDataOutsideElement
	#('<!!DOCTYPE test [ test ]><test/>'
		'test<test/>'
		'	test<test/>'
		'<test/>test'
		'<test/>	test')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/11/2016 11:16'!
testPCDataWithCDataTerminator
	self
		should: [SAXHandler parse: '<test>test]]>test</test>']
		raise: XMLWellFormednessException.

	#('<test>test]] >test</test>'
		'<test>test] ]>test</test>'
		'<test>test ] ] > test</test>'
		'<test name="test]]>test]] >test] ]>test ] ] > test"/>')
		do: [:each | 
			self
				shouldnt: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/27/2013 16:52'!
testParserLittleDocument

	| doc |
	doc := XMLDOMParser parse: 
'<?xml version="1.0" encoding="UTF-8"?>
<!!--an example-->
<example:user xmlns:example="urn://example">
    <username>jsmith</username>
    <real-name>John Smith</real-name>
    <age>25</age>
    <id>101</id>
</example:user>' readStream.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testProcessingInstructionBadChar
	self nonChars do: [:each |
		self
			should: [SAXHandler parse: '<?pi ', each asString, '?><test/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/9/2016 00:53'!
testProcessingInstructionBadTarget
	self badNames, #('xml' 'XML' 'Xml' 'xML' 'XMl' 'xmL' 'XmL' 'xMl')
		do: [:each |
			self
				should: [SAXHandler parse: '<?', each, ' value?><test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 03:08'!
testProcessingInstructionUnterminated
	#('<?'
		'<??'
		'<??>'
		'<?name'
		'<?name?'
		'<?name value'
		'<?name value?'
		'<?name value>')
		do: [:each | 
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: '<test/>', each]
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: '<test/>', each, '<test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 19:53'!
testProcessingInstructionWhitespace
	self
		should: [SAXHandler parse: '<pi><?target?data?></pi>']
		raise: XMLWellFormednessException.
	self
		shouldnt: [SAXHandler parse: '<pi><?target ?data  ?></pi>']
		raise: XMLWellFormednessException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 03:39'!
testStandalone
	| xmlWithDTD standaloneXMLWithDTD resolver |

	xmlWithDTD := self addressBookXMLWithDTD.
	standaloneXMLWithDTD :=
		xmlWithDTD
			copyReplaceAll: '?>'
			with: ' standalone="yes" ?>'.
	"an empty static resolver that won't be able to resolve the DTD system ID"
	resolver := DTDStaticExternalEntityResolver new.
	self
		shouldnt: [
			(SAXHandler on: xmlWithDTD)
				externalEntityResolver: resolver copy;
				parseDocument]
		raise: XMLParserException.
	self
		should: [
			(SAXHandler on: xmlWithDTD)
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLParserException.
	self
		should: [
			(SAXHandler on: xmlWithDTD)
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				isValidating: false;
				parseDocument]
		raise: XMLParserException.

	self
		shouldnt: [
			(SAXHandler on: standaloneXMLWithDTD)
				externalEntityResolver: resolver copy;
				parseDocument]
		raise: XMLParserException.
	"with validation, standlone external subsets must be retrieved"
	self
		should: [
			(SAXHandler on: standaloneXMLWithDTD)
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLParserException.
	"but without validation, they are ignored"
	self
		shouldnt: [
			(SAXHandler on: standaloneXMLWithDTD)
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				isValidating: false;
				parseDocument]
		raise: XMLParserException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 09:52'!
testStandaloneExternalAttributeDefaultValue
	| standalone notStandalone dtdTemplate defaultValueStandaloneContent nonDefaultValueStandaloneContent |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtdTemplate := '
		<!!DOCTYPE test [
			<!!ELEMENT test (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ELEMENT two EMPTY>
			<!!ENTITY % extern ''{1}''>
			%extern;
			{2}
		]>'.
	"the attributes defined internally can rely on default values, but
	the standalone externally defined ones can't"
	defaultValueStandaloneContent :=
		'<test><one/><two one="one" two="two" three="one"/></test>'.
	nonDefaultValueStandaloneContent :=
		'<test><one one="one"/><two one="one"/></test>'.
	#(
		#('<!!ATTLIST one one CDATA "one">'
				'<!!ATTLIST two one CDATA "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three CDATA "one">')
		"ID attributes cannot have default values so are not tested"
		#('<!!ATTLIST one one IDREF "one">'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three IDREF "one">')
		#('<!!ATTLIST one one IDREFS "one">'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three IDREFS "one">')
		#('<!!ATTLIST one one ENTITY "one">'
				'<!!NOTATION note PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA note>
				<!!ATTLIST two one ENTITY "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three ENTITY "one">')
		#('<!!ATTLIST one one ENTITIES "one">'
				'<!!NOTATION note PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA note>
				<!!ATTLIST two one ENTITIES "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three ENTITIES "one">')
		#('<!!ATTLIST one one NMTOKEN "one">'
				'<!!ATTLIST two one NMTOKEN "one">
				<!!ATTLIST two two NMTOKEN "two">
				<!!ATTLIST two three NMTOKEN "one">')
		#('<!!ATTLIST one one NMTOKENS "one">'
				'<!!ATTLIST two one NMTOKENS "one">
				<!!ATTLIST two two NMTOKENS "two">
				<!!ATTLIST two three NMTOKENS "one">')
		#('<!!ATTLIST one one (one) "one">'
				'<!!ATTLIST two one (one) "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three (one) "one">')
		#('<!!ATTLIST one one NOTATION (one) "one">'
				'<!!NOTATION one PUBLIC "note.txt">
				<!!ATTLIST two one NOTATION (one) "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three CDATA "one">'))
		do: [:each | | dtd |
			dtd := dtdTemplate format: each.
			self
				should: [SAXHandler parse: standalone, dtd, defaultValueStandaloneContent]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: standalone, dtd, defaultValueStandaloneContent)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [SAXHandler parse: standalone, dtd, nonDefaultValueStandaloneContent]
				raise: XMLValidationException.

			self
				shouldnt: [SAXHandler parse: notStandalone, dtd, defaultValueStandaloneContent]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 09:55'!
testStandaloneExternalAttributeDefaultValueExternalSubset
	| standalone notStandalone dtdTemplate defaultValueStandaloneContent nonDefaultValueStandaloneContent |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtdTemplate :=
		'<!!DOCTYPE test SYSTEM "extern.dtd" [
			<!!ELEMENT test (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ELEMENT two EMPTY>
			{1}
		]>'.
	"the attributes defined internally can rely on default values, but
	the standalone externally defined ones can't"
	defaultValueStandaloneContent :=
		'<test><one/><two one="one" two="two" three="one"/></test>'.
	nonDefaultValueStandaloneContent :=
		'<test><one one="one"/><two one="one"/></test>'.
	#(
		#('<!!ATTLIST one one CDATA "one">'
				'<!!ATTLIST two one CDATA "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three CDATA "one">')
		"ID attributes cannot have default values so are not tested"
		#('<!!ATTLIST one one IDREF "one">'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three IDREF "one">')
		#('<!!ATTLIST one one IDREFS "one">'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three IDREFS "one">')
		#('<!!ATTLIST one one ENTITY "one">'
				'<!!NOTATION note PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA note>
				<!!ATTLIST two one ENTITY "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three ENTITY "one">')
		#('<!!ATTLIST one one ENTITIES "one">'
				'<!!NOTATION note PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA note>
				<!!ATTLIST two one ENTITIES "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three ENTITIES "one">')
		#('<!!ATTLIST one one NMTOKEN "one">'
				'<!!ATTLIST two one NMTOKEN "one">
				<!!ATTLIST two two NMTOKEN "two">
				<!!ATTLIST two three NMTOKEN "one">')
		#('<!!ATTLIST one one NMTOKENS "one">'
				'<!!ATTLIST two one NMTOKENS "one">
				<!!ATTLIST two two NMTOKENS "two">
				<!!ATTLIST two three NMTOKENS "one">')
		#('<!!ATTLIST one one (one) "one">'
				'<!!ATTLIST two one (one) "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three (one) "one">')
		#('<!!ATTLIST one one NOTATION (one) "one">'
				'<!!NOTATION one PUBLIC "note.txt">
				<!!ATTLIST two one NOTATION (one) "one">
				<!!ATTLIST two two CDATA "two">
				<!!ATTLIST two three CDATA "one">'))
		do: [:each | | resolver dtd |
			(resolver := DTDStaticExternalEntityResolver new)
				externalEntityAtURI: 'extern.dtd'
				put: each first.
			dtd := dtdTemplate format: (Array with: each second).
			self
				should: [
					(SAXHandler on: standalone, dtd, defaultValueStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: standalone, dtd, defaultValueStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						isValidating: false;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: standalone, dtd, nonDefaultValueStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.

			self
				shouldnt: [
					(SAXHandler on: notStandalone, dtd, defaultValueStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 09:39'!
testStandaloneExternalAttributeNormalization
	| standalone notStandalone dtdTemplate dtd unnormalizedStandaloneContent normalizedStandaloneContent |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtdTemplate := '
		<!!DOCTYPE test [
			<!!ELEMENT test (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ELEMENT two EMPTY>
			<!!ENTITY % extern "{1}">
			%extern;
			{2}
		]>'.
	"the attributes defined internally can require further normalization, but
	the standalone externally defined ones can't"
	unnormalizedStandaloneContent :=
		'<test><one one=" one "/><two one="one" two="two" three="one"/></test>'.
	normalizedStandaloneContent :=
		'<test><one one="one"/><two one=" one " two=" two " three=" one "/></test>'.
	#(
		#('<!!ATTLIST one one ID #IMPLIED>'
				'<!!ATTLIST two one CDATA #IMPLIED>
				<!!ATTLIST two two ID #IMPLIED>
				<!!ATTLIST two three CDATA #IMPLIED>')
		#('<!!ATTLIST one one IDREF #IMPLIED>'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three IDREF #IMPLIED>')
		#('<!!ATTLIST one one IDREFS #IMPLIED>'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three IDREFS #IMPLIED>')
		#('<!!ATTLIST one one ENTITY #IMPLIED>'
				'<!!NOTATION note PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA note>
				<!!ATTLIST two one ENTITY #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three ENTITY #IMPLIED>')
		#('<!!ATTLIST one one ENTITIES #IMPLIED>'
				'<!!NOTATION note PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA note>
				<!!ATTLIST two one ENTITIES #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three ENTITIES #IMPLIED>')
		#('<!!ATTLIST one one NMTOKEN #IMPLIED>'
				'<!!ATTLIST two one NMTOKEN #IMPLIED>
				<!!ATTLIST two two NMTOKEN #IMPLIED>
				<!!ATTLIST two three NMTOKEN #IMPLIED>')
		#('<!!ATTLIST one one NMTOKENS #IMPLIED>'
				'<!!ATTLIST two one NMTOKENS #IMPLIED>
				<!!ATTLIST two two NMTOKENS #IMPLIED>
				<!!ATTLIST two three NMTOKENS #IMPLIED>')
		#('<!!ATTLIST one one (one) #IMPLIED>'
				'<!!ATTLIST two one (one) #IMPLIED>
				<!!ATTLIST two two (two) #IMPLIED>
				<!!ATTLIST two three (one) #IMPLIED>')
		#('<!!ATTLIST one one NOTATION (one) #IMPLIED>'
				'<!!NOTATION one PUBLIC "note.txt">
				<!!ATTLIST two one NOTATION (one) #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three CDATA #IMPLIED>'))
		do: [:each |
			dtd := dtdTemplate format: each.
			self
				should: [SAXHandler parse: standalone, dtd, unnormalizedStandaloneContent]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: standalone, dtd, unnormalizedStandaloneContent)
						isValidating: false;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [SAXHandler parse: standalone, dtd, normalizedStandaloneContent]
				raise: XMLValidationException.

			self
				shouldnt: [SAXHandler parse: notStandalone, dtd, unnormalizedStandaloneContent]
				raise: XMLValidationException].

	"CDATA is never further normalized, so standalone external doesn't affect it"
	dtd :=
		dtdTemplate format:
			#('<!!ATTLIST one one CDATA #IMPLIED>'
					'<!!ATTLIST two one CDATA #IMPLIED>
					<!!ATTLIST two two CDATA #IMPLIED>
					<!!ATTLIST two three CDATA #IMPLIED>').
	self
		shouldnt: [SAXHandler parse: standalone, dtd, unnormalizedStandaloneContent]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 09:38'!
testStandaloneExternalAttributeNormalizationExternalSubset
	| standalone notStandalone dtdTemplate dtd unnormalizedStandaloneContent normalizedStandaloneContent resolver |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtdTemplate := '
		<!!DOCTYPE test SYSTEM "extern.dtd" [
			<!!ELEMENT test (one,two)>
			<!!ELEMENT one EMPTY>
			<!!ELEMENT two EMPTY>
			{1}
		]>'.
	"the attributes defined internally can require further normalization, but
	the standalone externally defined ones can't"
	unnormalizedStandaloneContent :=
		'<test><one one=" one "/><two one="one" two="two" three="one"/></test>'.
	normalizedStandaloneContent :=
		'<test><one one="one"/><two one=" one " two=" two " three=" one "/></test>'.
	resolver := DTDStaticExternalEntityResolver new.
	#(
		#('<!!ATTLIST one one ID #IMPLIED>'
				'<!!ATTLIST two one CDATA #IMPLIED>
				<!!ATTLIST two two ID #IMPLIED>
				<!!ATTLIST two three CDATA #IMPLIED>')
		#('<!!ATTLIST one one IDREF #IMPLIED>'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three IDREF #IMPLIED>')
		#('<!!ATTLIST one one IDREFS #IMPLIED>'
				'<!!ATTLIST two one ID #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three IDREFS #IMPLIED>')
		#('<!!ATTLIST one one ENTITY #IMPLIED>'
				'<!!NOTATION note PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA note>
				<!!ATTLIST two one ENTITY #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three ENTITY #IMPLIED>')
		#('<!!ATTLIST one one ENTITIES #IMPLIED>'
				'<!!NOTATION one PUBLIC "note.txt">
				<!!ENTITY one PUBLIC "note.txt" "note.txt" NDATA one>
				<!!ATTLIST two one ENTITIES #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three ENTITIES #IMPLIED>')
		#('<!!ATTLIST one one NMTOKEN #IMPLIED>'
				'<!!ATTLIST two one NMTOKEN #IMPLIED>
				<!!ATTLIST two two NMTOKEN #IMPLIED>
				<!!ATTLIST two three NMTOKEN #IMPLIED>')
		#('<!!ATTLIST one one NMTOKENS #IMPLIED>'
				'<!!ATTLIST two one NMTOKENS #IMPLIED>
				<!!ATTLIST two two NMTOKENS #IMPLIED>
				<!!ATTLIST two three NMTOKENS #IMPLIED>')
		#('<!!ATTLIST one one (one) #IMPLIED>'
				'<!!ATTLIST two one (one) #IMPLIED>
				<!!ATTLIST two two (two) #IMPLIED>
				<!!ATTLIST two three (one) #IMPLIED>')
		#('<!!ATTLIST one one NOTATION (one) #IMPLIED>'
				'<!!NOTATION one PUBLIC "note.txt">
				<!!ATTLIST two one NOTATION (one) #IMPLIED>
				<!!ATTLIST two two CDATA #IMPLIED>
				<!!ATTLIST two three CDATA #IMPLIED>'))
		do: [:each |
			(resolver := resolver copy)
				externalEntityAtURI: 'extern.dtd'
				put: each first.
			dtd := dtdTemplate format: (Array with: each second).
			self
				should: [
					(SAXHandler on: standalone, dtd, unnormalizedStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: standalone, dtd, unnormalizedStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						isValidating: false;
						parseDocument]
				raise: XMLValidationException.
			self
				shouldnt: [
					(SAXHandler on: standalone, dtd, normalizedStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException.

			self
				shouldnt: [
					(SAXHandler on: notStandalone, dtd, unnormalizedStandaloneContent)
						externalEntityResolver: resolver copy;
						resolvesExternalEntities: true;
						parseDocument]
				raise: XMLValidationException].

	"CDATA is never further normalized, so standalone external doesn't affect it"
	(resolver := resolver copy)
		externalEntityAtURI: 'extern.dtd'
		put:
			'<!!ATTLIST two one CDATA #IMPLIED>
			<!!ATTLIST two two CDATA #IMPLIED>
			<!!ATTLIST two three CDATA #IMPLIED>'.
	dtd := dtdTemplate format: #('<!!ATTLIST one one CDATA #IMPLIED>').
	self
		shouldnt: [
			(SAXHandler on: standalone, dtd, unnormalizedStandaloneContent)
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 05:53'!
testStandaloneExternalElementDeclarartion
	| standalone notStandalone dtd |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtd := '
		<!!DOCTYPE test [
			<!!ELEMENT test (elementContent)>
			<!!ENTITY % extern "<!!ELEMENT elementContent (elementContent*)>">
			%extern;
		]>'.
	"the externally defined element can't have whitespace around its element 
	ontent, but the internally defined one (test) can"
	self
		should: [
			SAXHandler parse:
				standalone, dtd, '<test><elementContent> <elementContent/> </elementContent></test>']
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on:
				standalone, dtd, '<test><elementContent> <elementContent/> </elementContent></test>')
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				standalone, dtd, '<test> <elementContent><elementContent/></elementContent> </test>']
		raise: XMLValidationException.

	self
		shouldnt: [
			SAXHandler parse:
				notStandalone, dtd, '<test><elementContent> <elementContent/> </elementContent></test>']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 05:53'!
testStandaloneExternalElementDeclarartionExternalSubset
	| standalone notStandalone dtd resolver |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtd := '
		<!!DOCTYPE test SYSTEM "extern.dtd" [
			<!!ELEMENT test (elementContent)>
		]>'.
	resolver :=
		DTDStaticExternalEntityResolver externalEntities:
			(Array with: 'extern.dtd' -> '<!!ELEMENT elementContent (elementContent*)>').
	"the externally defined element can't have whitespace around its element 
	ontent, but the internally defined one (test) can"
	self
		should: [
			(SAXHandler on:
				standalone, dtd, '<test><elementContent> <elementContent/> </elementContent></test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on:
				standalone, dtd, '<test><elementContent> <elementContent/> </elementContent></test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				isValidating: false;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			(SAXHandler on:
				standalone, dtd, '<test> <elementContent><elementContent/></elementContent> </test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.

	self
		shouldnt: [
			(SAXHandler on:
				notStandalone, dtd, '<test><elementContent> <elementContent/> </elementContent></test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 05:31'!
testStandaloneExternalExternalEntity
	| standalone notStandalone dtd resolver document |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtd := '
		<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ENTITY % extern SYSTEM "extern.ent">
			%extern;
			<!!ENTITY otherName SYSTEM "otherName.ent">
		]>'.
	resolver :=
		DTDStaticExternalEntityResolver externalEntities:
			(Array
				with: 'extern.ent' -> '<!!ENTITY name SYSTEM "name.ent">'
				with: 'name.ent' -> 'value'
				with: 'otherName.ent' -> 'otherValue').
	self
		should: [
			(SAXHandler on: standalone, dtd, '<test>&name;</test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: standalone, dtd, '<test>&name;</test>')
					externalEntityResolver: resolver copy;
					resolvesExternalEntities: true;
					isValidating: false;
					parseDocument]
		raise: XMLParserException.
	self assert: document contentString = 'value'.
	"external entities only count as 'external markup declarations' in standalone
	docs if they were defined in the external DTD subset or in a parameter entity"
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: standalone, dtd, '<test>&otherName;</test>')
					externalEntityResolver: resolver copy;
					resolvesExternalEntities: true;
					parseDocument]
		raise: XMLValidationException.
	self assert: document contentString = 'otherValue'.

	self
		shouldnt: [
			document :=
				(XMLDOMParser on: notStandalone, dtd, '<test>&name;</test>')
					externalEntityResolver: resolver copy;
					resolvesExternalEntities: true;
					parseDocument]
		raise: XMLValidationException.
	self assert: document contentString = 'value'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 09:22'!
testStandaloneExternalExternalEntityExternalSubset
	| standalone notStandalone dtd subset resolver document |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtd := '
		<!!DOCTYPE test SYSTEM "extern.dtd" [
			<!!ENTITY otherName SYSTEM "otherName.ent">
		]>'.
	subset := '
		<!!ELEMENT test ANY>
		<!!ATTLIST test name CDATA #IMPLIED>
		<!!ENTITY name SYSTEM "name.ent">'.
	resolver :=
		DTDStaticExternalEntityResolver externalEntities:
			(Array
				with: 'extern.dtd' -> subset
				with: 'name.ent' -> 'value'
				with: 'otherName.ent' -> 'otherValue').
	self
		should: [
			(SAXHandler on: standalone, dtd, '<test>&name;</test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.
	self
		should: [
			(SAXHandler on: standalone, dtd, '<test>&name;</test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				isValidating: false;
				parseDocument]
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			(SAXHandler on: standalone, dtd, '<test/>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.

	self
		shouldnt: [
			document :=
				(XMLDOMParser on: notStandalone, dtd, '<test>&name;</test>')
					externalEntityResolver: resolver copy;
					resolvesExternalEntities: true;
					parseDocument]
		raise: XMLValidationException.
	self assert: document contentString = 'value'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 05:32'!
testStandaloneExternalExternalEntityRedundance
	| standaloneXML resolver document |

	standaloneXML :=
		'<?xml version="1.0" standalone="yes"?>
		<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test name CDATA #IMPLIED>
			<!!ENTITY name "value">
			<!!ENTITY % extern SYSTEM "extern.ent">
			%extern;
		]>
		<test>&name;</test>'.
	resolver :=
		DTDStaticExternalEntityResolver externalEntities:
			(Array
				with: 'extern.ent' -> '<!!ENTITY name SYSTEM "name.ent">'
				with: 'name.ent' -> 'otherValue').
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: standaloneXML)
					externalEntityResolver: resolver copy;
					resolvesExternalEntities: true;
					parseDocument]
		raise: XMLValidationException.
	self assert: document contentString = 'value'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 05:32'!
testStandaloneExternalInternalEntity
	| standalone notStandalone dtd document |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtd := '
		<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ENTITY % entity ''<!!ENTITY name "value">''>
			%entity;
			<!!ENTITY otherName "otherValue">
		]>'.
	self
		should: [SAXHandler parse: standalone, dtd, '<test>&name;</test>']
		raise: XMLValidationException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: standalone, dtd, '<test>&name;</test>')
					isValidating: false;
					parseDocument]
		raise: XMLValidationException.
	self assert: document contentString = 'value'.
	self
		shouldnt: [SAXHandler parse: standalone, dtd, '<test>&otherName;</test>']
		raise: XMLValidationException.

	self
		shouldnt: [
			document :=
				XMLDOMParser parse: notStandalone, dtd, '<test>&name;</test>']
		raise: XMLValidationException.
	self assert: document contentString = 'value'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/20/2017 03:14'!
testStandaloneExternalInternalEntityAttributeDefaultValue
	| standaloneDTD document |

	standaloneDTD :=
		'<?xml version="1.0" standalone="yes"?>
		<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ENTITY % entity ''<!!ENTITY name "value">''>
			%entity;
			<!!ATTLIST test name CDATA "&name;">
			<!!ENTITY otherName "otherValue">
		]>'.
	self
		should: [SAXHandler parse: standaloneDTD, '<test name="&name;"/>']
		raise: XMLValidationException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: standaloneDTD, '<test name="&name;"/>')
					isValidating: false;
					parseDocument]
		raise: XMLValidationException.
	self assert: (document root attributeAt: 'name') = 'value'.

	"Xerces doesn't flag this because the reference is only in the default
	value declaration, but it probably should count because it's still an
	internal (to the document) reference to an external standalone entity"
	self
		should: [XMLDOMParser parse: standaloneDTD, '<test/>']
		raise: XMLValidationException.
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: standaloneDTD, '<test/>')
					isValidating: false;
					parseDocument]
		raise: XMLValidationException.
	self assert: (document root attributeAt: 'name') = 'value'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 04:58'!
testStandaloneExternalInternalEntityExternalSubset
	| standalone notStandalone dtd subset resolver document |

	standalone := '<?xml version="1.0" standalone="yes"?>'.
	notStandalone := '<?xml version="1.0" standalone="no"?>'.
	dtd := '<!!DOCTYPE test SYSTEM "extern.dtd">'.
	subset := '
		<!!ELEMENT test ANY>
		<!!ATTLIST test name CDATA #IMPLIED>
		<!!ENTITY name "value">'.
	resolver :=
		DTDStaticExternalEntityResolver externalEntities:
			(Array with: 'extern.dtd' -> subset).
	self
		should: [
			(SAXHandler on: standalone, dtd, '<test>&name;</test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.
	self
		should: [
			(SAXHandler on: standalone, dtd, '<test>&name;</test>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				isValidating: false;
				parseDocument]
		raise: XMLWellFormednessException.
	self
		shouldnt: [
			(SAXHandler on: standalone, dtd, '<test/>')
				externalEntityResolver: resolver copy;
				resolvesExternalEntities: true;
				parseDocument]
		raise: XMLValidationException.
	
	self
		shouldnt: [
			document :=
				(XMLDOMParser on: notStandalone, dtd, '<test>&name;</test>')
					externalEntityResolver: resolver copy;
					resolvesExternalEntities: true;
					parseDocument]
		raise: XMLValidationException.
	self assert: document contentString = 'value'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/3/2016 04:59'!
testStandaloneExternalInternalEntityRedundance
	| standaloneXML document |

	standaloneXML :=
		'<?xml version="1.0" standalone="yes"?>
		<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test name CDATA #IMPLIED>
			<!!ENTITY name "value">
			<!!ENTITY % entity ''<!!ENTITY name "otherValue">''>
			%entity;
		]>
		<test>&name;</test>'.
	self
		shouldnt: [document := XMLDOMParser parse: standaloneXML]
		raise: XMLValidationException.
	self assert: document contentString = 'value'.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 5/3/2017 22:49'!
testSystemIDBadChar
	self nonChars do: [:each |
		self
			should: [
				SAXHandler parse:
					'<!!DOCTYPE test SYSTEM "', each asString, '"><test/>']
			raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 11/26/2016 19:28'!
testSystemIDFragment
	#('<!!DOCTYPE test [
			<!!ENTITY one SYSTEM "test#one">
		]><test/>'
		'<!!DOCTYPE test [
			<!!ENTITY % one SYSTEM "test#one">
		]><test/>'
		'<!!DOCTYPE test [
			<!!NOTATION note SYSTEM "two">
			<!!ENTITY two SYSTEM "test#two" NDATA note>
		]><test/>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLParserException].

	"DOCTYPE and NOTATION system IDs with fragments are OK"
	self
		shouldnt: [
			SAXHandler parse:
				'<!!DOCTYPE test SYSTEM "test#one" [
					<!!NOTATION note SYSTEM "test#two">
					<!!ENTITY one SYSTEM "test">
					<!!ENTITY % two SYSTEM "test">
					<!!ENTITY three SYSTEM "test" NDATA note>
				]><test/>']		
		raise: XMLParserException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/13/2016 00:11'!
testUnparsedEntity
	| dtd |

	dtd := '
		<!!DOCTYPE root [
			<!!NOTATION note PUBLIC "-//ext//note//EN">
			<!!ENTITY unparsedEntity SYSTEM "note.txt" NDATA note>
			<!!ELEMENT root EMPTY>
			<!!ATTLIST root notation ENTITY #REQUIRED>
		]>'.
	self
		shouldnt: [SAXHandler parse: dtd, '<root notation="unparsedEntity" />']
		raise: XMLValidationException.
	self
		should: [SAXHandler parse: dtd, '<root notation="undeclaredUnparsedEntity" />']
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/13/2016 00:13'!
testUnparsedEntityDeclarationRedundance
	| dtd |

	dtd :=
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test
				name CDATA #IMPIED>
			<!!NOTATION external-note SYSTEM "external.txt">
			<!!ENTITY external-ent SYSTEM "external.txt" NDATA external-note>
			<!!ENTITY external-ent "value">
		]>'.
	#('<test>&external-ent;</test>' '<test name="&external-ent;"></test>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 04:02'!
testUnparsedEntityDeclarationUnterminated
	#('<!!ENTITY name PUBLIC "publicid" "systemid" NDATA'
		'<!!ENTITY name PUBLIC "publicid" "systemid" NDATA>'
		'<!!ENTITY name PUBLIC "publicid" "systemid" NDATA gif'
		'<!!ENTITY name SYSTEM "systemid" NDATA'
		'<!!ENTITY name SYSTEM "systemid" NDATA>'
		'<!!ENTITY name SYSTEM "systemid" NDATA gif')
		do: [:each |
			self
				should: [
					SAXHandler parse:
						'<!!DOCTYPE test [
							<!!NOTATION gif SYSTEM "file.gif">',
							each]
				raise: XMLWellFormednessException.
			self
				should: [
					SAXHandler parse:
						'<!!DOCTYPE test [
							<!!NOTATION gif SYSTEM "file.gif">',
							each,
						']><test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/13/2016 00:11'!
testUnparsedEntityReference
	| dtd |

	dtd :=
		'<!!DOCTYPE test [
			<!!ELEMENT test ANY>
			<!!ATTLIST test
				name CDATA #IMPIED>
			<!!NOTATION external-note SYSTEM "external.txt">
			<!!ENTITY external-ent SYSTEM "external.txt" NDATA external-note>
		]>'.
	#('<test>&external-ent;</test>' '<test name="&external-ent;"></test>')
		do: [:each |
			self
				should: [SAXHandler parse: dtd, each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/13/2016 00:31'!
testUnparsedEntityUndeclaredNotations
	| beforeNotation afterNotation |

	beforeNotation := '
		<!!DOCTYPE test [
			<!!ELEMENT test EMPTY>
			<!!ENTITY notationEntity SYSTEM "note.txt" NDATA note>'.
	afterNotation := ']><test/>'.
	self
		should: [SAXHandler parse: beforeNotation, afterNotation]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler
				parse: beforeNotation, afterNotation
				usingNamespaces: true
				validation: false]
		raise: XMLValidationException.
	self
		shouldnt: [
			SAXHandler parse:
				beforeNotation, '<!!NOTATION note SYSTEM "note.txt">', afterNotation]
		raise: XMLValidationException.! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 4/1/2016 06:35'!
testXMLDeclarationEncodingNameBadChar
	| validChars |

	validChars := '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_.-'.
	0 to: 255 do: [:each | | char charString |
		char := each asCharacter.
		(validChars includes: char)
			ifFalse: [
				charString := char asString.
				self
					should: [SAXHandler parse: '<?xml version="1.0" encoding="ISO', charString, '"?>']
					raise: XMLWellFormednessException]].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/14/2016 01:17'!
testXMLDeclarationRedundance
	#('
<?xml version="1.0"?><test/>'
		' <?xml version="1.0"?><test/>'
		'	<?xml version="1.0"?><test/>'
		'<?xml version="1.0"?><?xml version="1.0"?><test/>'
		'<?xml version="1.0"?><!!--comment--><?xml version="1.0"?><test/>'
		'<?xml version="1.0"?><!!DOCTYPE test [<?xml version="1.0"?>]><test/>'
		'<?xml version="1.0"?><test><?xml version="1.0"?></test>'
		'<test><?xml version="1.0"?></test>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 20:16'!
testXMLDeclarationStandaloneAttribute
	#('<?xml version="1.0" standalone=""?>'
		'<?xml version="1.0" standalone="YES"?>'
		'<?xml version="1.0" standalone="Yes"?>'
		'<?xml version="1.0" standalone=" yes "?>'
		'<?xml version="1.0" standalone="NO"?>'
		'<?xml version="1.0" standalone="No"?>'
		'<?xml version="1.0" standalone=" no "?>')
		do: [:each |
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].

	#('<?xml version="1.0" standalone="no"?>'
		'<?xml version="1.0" standalone="yes"?>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 7/17/2016 02:57'!
testXMLDeclarationUnterminated
	#('<?xml'
		'<?xml ?'
		'<?xml ?>'
		'<?xml version'
		'<?xml version?'
		'<?xml version?>'
		'<?xml version='
		'<?xml version=?'
		'<?xml version=?>'
		'<?xml version="'
		'<?xml version="?'
		'<?xml version="?>'
		'<?xml version="1.0'
		'<?xml version="1.0"'
		'<?xml version="1.0"?'
		'<?xml version=''1.0'
		'<?xml version=''1.0'''
		'<?xml version=''1.0''?'
		'<?xml version="1.0''?>'
		'<?xml version=''1.0"?>'
		'<?xml version="1.0" encoding'
		'<?xml version="1.0" encoding?'
		'<?xml version="1.0" encoding?>'
		'<?xml version="1.0" encoding='
		'<?xml version="1.0" encoding=?'
		'<?xml version="1.0" encoding=?>'
		'<?xml version="1.0" encoding="'
		'<?xml version="1.0" encoding="?'
		'<?xml version="1.0" encoding="?>'
		'<?xml version="1.0" encoding="UTF-8'
		'<?xml version="1.0" encoding="UTF-8"'
		'<?xml version="1.0" encoding="UTF-8"?'
		'<?xml version="1.0" encoding=''UTF-8'
		'<?xml version="1.0" encoding=''UTF-8'''
		'<?xml version="1.0" encoding=''UTF-8''?'
		'<?xml version="1.0" encoding="UTF-8''?>'
		'<?xml version="1.0" encoding=''UTF-8"?>'
		'<?xml version="1.0" encoding="UTF-8" standalone'
		'<?xml version="1.0" encoding="UTF-8" standalone?'
		'<?xml version="1.0" encoding="UTF-8" standalone?>'
		'<?xml version="1.0" encoding="UTF-8" standalone='
		'<?xml version="1.0" encoding="UTF-8" standalone=?'
		'<?xml version="1.0" encoding="UTF-8" standalone=?>'
		'<?xml version="1.0" encoding="UTF-8" standalone="'
		'<?xml version="1.0" encoding="UTF-8" standalone="?'
		'<?xml version="1.0" encoding="UTF-8" standalone="?>'
		'<?xml version="1.0" encoding="UTF-8" standalone="yes'
		'<?xml version="1.0" encoding="UTF-8" standalone="yes"'
		'<?xml version="1.0" encoding="UTF-8" standalone="yes"?'
		'<?xml version="1.0" encoding="UTF-8" standalone=''yes'
		'<?xml version="1.0" encoding="UTF-8" standalone=''yes'''
		'<?xml version="1.0" encoding="UTF-8" standalone=''yes''?'
		'<?xml version="1.0" encoding="UTF-8" standalone="yes''?>'
		'<?xml version="1.0" encoding="UTF-8" standalone=''yes"?>')
		do: [:each |
			self
				should: [SAXHandler parse: each]
				raise: XMLWellFormednessException.
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException]! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/7/2016 20:17'!
testXMLDeclarationVersionAttribute
	#('<?xml version=""?>'
		'<?xml version="1"?>'
		'<?xml version="1."?>'
		'<?xml version="1.0."?>'
		'<?xml version="1.0.1"?>'
		'<?xml version="10"?>'
		'<?xml version="10."?>'
		'<?xml version="10.00."?>'
		'<?xml version="10.00.10"?>'
		'<?xml version="one"?>'
		'<?xml version="one."?>'
		'<?xml version="one.zero."?>'
		'<?xml version="one.zero.one"?>')
		do: [:each |
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].

	#('<?xml version="1.0"?>'
		'<?xml version="1.1"?>'
		'<?xml version="1.00"?>'
		'<?xml version="1.10"?>')
		do: [:each |
			self
				shouldnt: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].! !

!XMLParserTest methodsFor: 'tests' stamp: 'monty 3/8/2016 09:50'!
testXMLDeclarationWhitespace
	#('<? xml version="1.0" encoding="UTF-8" standalone="yes"?>'
		'<?xml version="1.0"standalone="yes"?>'
		'<?xml version="1.0"encoding="UTF-8" standalone="yes"?>'
		'<?xml version="1.0" encoding="UTF-8"standalone="yes"?>')
		do: [:each |
			self
				should: [SAXHandler parse: each, '<test/>']
				raise: XMLWellFormednessException].
	self
		shouldnt: [
			SAXHandler parse:
				'<?xml
					version
					 =
					 "1.0"
					encoding
					 =
					 "UTF-8"	
					standalone
					 =
					 "yes"
					?>
				<test/>']
		raise: XMLWellFormednessException.! !

TestCase subclass: #XMLSingleCharacterReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLSingleCharacterReadStreamTest methodsFor: 'accessing' stamp: 'monty 4/6/2016 06:20'!
character
	^ $!!! !

!XMLSingleCharacterReadStreamTest methodsFor: 'instance creation' stamp: 'monty 4/6/2016 06:20'!
newStreamOnCharacter
	^ self streamClass on: self character! !

!XMLSingleCharacterReadStreamTest methodsFor: 'accessing' stamp: 'monty 4/6/2016 06:20'!
streamClass
	^ XMLSingleCharacterReadStream! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 4/6/2016 06:21'!
testAtEnd
	| stream |

	stream := self newStreamOnCharacter.
	self deny: stream atEnd.

	stream next.
	self assert: stream atEnd.! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 4/13/2016 01:52'!
testClose
	| stream |

	stream := self newStreamOnCharacter.
	self
		deny: stream atEnd;
		assert: stream close == stream;
		assert: stream atEnd.! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:45'!
testContents
	| stream |

	stream := self newStreamOnCharacter.
	self assert: stream contents = self character asString.

	stream next.
	self assert: stream contents = self character asString.! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:37'!
testIsBinary
	self deny: self newStreamOnCharacter isBinary! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:37'!
testIsStream
	self assert: self newStreamOnCharacter isStream! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 4/6/2016 06:21'!
testNext
	| stream |

	stream := self newStreamOnCharacter.
	self
		assert: stream next = self character;
		assert: stream next isNil.! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 4/6/2016 06:21'!
testPeek
	| stream |

	stream := self newStreamOnCharacter.
	self assert: stream peek = self character.

	stream next.
	self assert: stream peek isNil.! !

!XMLSingleCharacterReadStreamTest methodsFor: 'tests' stamp: 'monty 11/22/2016 23:44'!
testUpToEnd
	| stream |

	stream := self newStreamOnCharacter.
	self
		assert: stream upToEnd = self character asString;
		assert: stream upToEnd = ''.! !

TestCase subclass: #XMLSkippableTest
	instanceVariableNames: 'skippableTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

XMLSkippableTest class
	instanceVariableNames: 'isSkipping'!

!XMLSkippableTest commentStamp: 'monty 9/10/2016 03:11' prior: 0!
An abstract class for TestCases with skippable tests.!

XMLSkippableTest class
	instanceVariableNames: 'isSkipping'!

XMLSkippableTest subclass: #XMLExternalEntityTest
	instanceVariableNames: 'tempFileManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLExternalEntityTest commentStamp: 'monty 9/10/2016 03:12' prior: 0!
These tests use HTTP and the file system and are skipped by default. This enables them:
	self stopSkipping!

!XMLExternalEntityTest class methodsFor: 'testing' stamp: 'monty 9/10/2016 02:54'!
isAbstract
	^ false! !

!XMLExternalEntityTest class methodsFor: 'accessing' stamp: 'monty 4/23/2017 14:03'!
skippableTests
	^ #(testExternalSubsetReadLimit
			testOnFileNamed
			testOnURL
			testOnURLUpToLimit
			testParsingDocBookArticle
			testParsingDocBookExample
			testParsingEncodedFile
			testParsingEncodedFileWithBOM
			testParsingEncodedFileWithEncodingAttribute
			testParsingEncodedFileWithEncodingAttributeAndBOM
			testParsingExternalEntities
			testParsingExternalEntitiesLimit
			testParsingFile
			testParsingRetrievedURL
			testParsingURL)! !

!XMLExternalEntityTest methodsFor: 'accessing' stamp: 'monty 10/2/2017 16:41'!
defaultTimeLimit
	"this is needed for Pharo5+ to prevent it from timing out
	the long-running HTTP tests when skipping is disabled"
	^ self defaultTimeout seconds! !

!XMLExternalEntityTest methodsFor: 'accessing' stamp: 'monty 9/19/2016 10:11'!
defaultTimeout
	"this is needed for Squeak to prevent it from timing out
	the long-running HTTP tests when skipping is disabled"
	^ 60 * 10! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 4/26/2015 23:59'!
docBookArticleSource
	^ '<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN" "http://docbook.org/xml/4.5/docbookx.dtd">
<article>
	<articleinfo>
		<title>About Pharo</title>
		<author>
			<honorific>Dr.</honorific>
			<firstname>Stephane</firstname>
			<surname>Ducasse</surname>
		</author>
	</articleinfo>
	<section>
		<title>Mission</title>
		<para>Pharo''s goal is to deliver a clean, innovative, free open-source environment. Here is the to be revised Pharo vision document.</para>
		<para>By providing a stable and small core system, excellent developing tools, and maintained releases, Pharo is an attractive platform to build and deploy mission critical applications.</para>
		<para>Pharo fosters a healthy ecosystem of both private and commercial contributors who advance and maintain the core system and its external packages.</para>
	</section>
	<section>
		<title>Pharo features</title>
		<para>A dynamic, pure object-oriented programming language in the tradition of Smalltalk</para>
		<para>An IDE (integrated development environment)</para>
		<para>A huge library and set of external packages</para>
	</section>
	<section>
		<title>Pharo and Business</title>
		<para>The goal of Pharo is to sustain and grow business.</para>
		<para>Pharo is supported by the industrial Pharo consortium.</para>
		<para>Pharo has also an association of users: Pharo association</para>
    </section>
</article>'! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 4/26/2015 14:52'!
docBookExampleSource
	^ '<!!DOCTYPE example
	PUBLIC "-//OASIS//DTD DocBook XML V4.1.2//EN"
	"http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd">
	<example>
		<title>An Example</title>
		<programlisting>
		XMLDocument root:
			((XMLElement named: ''test'')
				addNode: ''An example'' asXMLString;
				yourself)
		</programlisting>
	</example>'! !

!XMLExternalEntityTest methodsFor: 'accessing' stamp: 'monty 10/14/2016 22:31'!
encodingNames
	^ #('UTF-8' 'UTF-16' 'UTF-16-LE' 'UTF-32' 'UTF-32-LE')! !

!XMLExternalEntityTest methodsFor: 'accessing' stamp: 'monty 5/18/2017 20:23'!
feedURL
	^ 'http://www.squeaksource.com/feed.rss'! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 4/26/2015 23:59'!
musicXMLDocument
	^ '<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!!DOCTYPE score-partwise PUBLIC
    "-//Recordare//DTD MusicXML 3.0 Partwise//EN"
    "http://www.musicxml.org/dtds/partwise.dtd">
<score-partwise version="3.0">
  <part-list>
    <score-part id="P1">
      <part-name>Music</part-name>
    </score-part>
  </part-list>
  <part id="P1">
    <measure number="1">
      <attributes>
        <divisions>1</divisions>
        <key>
          <fifths>0</fifths>
        </key>
        <time>
          <beats>4</beats>
          <beat-type>4</beat-type>
        </time>
        <clef>
          <sign>G</sign>
          <line>2</line>
        </clef>
      </attributes>
      <note>
        <pitch>
          <step>C</step>
          <octave>4</octave>
        </pitch>
        <duration>4</duration>
        <type>whole</type>
      </note>
    </measure>
  </part>
</score-partwise>
'.! !

!XMLExternalEntityTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 15:53'!
tempFileManager
	^ tempFileManager ifNil: [tempFileManager := XMLTempFileManager new]! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testExternalSubsetReadLimit
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testExternalSubsetReadLimit.

	self tempFileManager newFileHandleDo: [:fileHandle |
		| xml externalSubset parser |

		externalSubset := '<?xml encoding="UTF-8"?><!!ELEMENT test EMPTY>'.
		self tempFileManager
			createFileWithContents: externalSubset
			forHandle: fileHandle.
		xml := '<!!DOCTYPE test SYSTEM "', fileHandle path, '"><test/>'.

		self
			shouldnt: [
				(parser := SAXHandler on: xml)
					externalEntityResolver externalSubsetReadLimit:
						externalSubset size.
				parser
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLLimitException.

		self
			should: [
				(parser := SAXHandler on: xml)
					externalEntityResolver externalSubsetReadLimit:
						externalSubset size - 1.
				parser
					resolvesExternalEntities: true;
					parseDocument]
			raise: XMLLimitException].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testOnFileNamed
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testOnFileNamed.

	self tempFileManager newFileHandleDo: [:fileHandle | | parser |
		self tempFileManager
			createFileWithContents: '<test/>'
			forHandle: fileHandle.
		self
			shouldnt: [parser := SAXHandler onFileNamed: fileHandle path]
			raise: XMLFileException.
		self
			assert: parser documentURI = fileHandle path;
			assert: parser documentURI asXMLURI isLocalURI].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/10/2016 03:07'!
testOnURL
	| parser |

	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testOnURL.

	self
		shouldnt: [parser := SAXHandler onURL: self feedURL]
		raise: XMLHTTPException.
	self
		assert: parser documentURI = self feedURL;
		deny: parser documentURI asXMLURI isLocalURI.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/10/2016 03:08'!
testOnURLUpToLimit
	| parser size |

	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testOnURLUpToLimit.

	size :=
		(self feedURL asXMLURI
			getUpToLimit: nil
			decoding: false) size.
	self
		shouldnt: [
			parser :=
				SAXHandler
					onURL: self feedURL
					upToLimit: size]
		raise: XMLLimitException.
	self assert: parser documentReadLimit = size.

	self
		should: [
			(SAXHandler
				onURL: self feedURL
				upToLimit: size - 1)
				parseDocument]
		raise: XMLLimitException.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/10/2016 03:08'!
testParsingDocBookArticle
	"This uses HTTP so is skipped by default"

	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingDocBookArticle.

	self
		shouldnt: [
			(SAXHandler on: self docBookArticleSource)
				resolvesExternalEntities: true;
				removeLimits;
				parseDocument]
		raise: XMLParserException.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/10/2016 03:10'!
testParsingDocBookExample
	"This uses HTTP so is skipped by default"

	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingDocBookExample.

	self
		shouldnt: [
			(SAXHandler on: self docBookExampleSource)
				resolvesExternalEntities: true;
				removeLimits;
				parseDocument]
		raise: XMLParserException.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 10/14/2016 22:32'!
testParsingEncodedFile
	"This test creates/deletes a file so is skipped by default"
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingEncodedFile.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self encodingNames do: [:encoding | | document documentFromFile |
			document := XMLDOMParser parse: self wideCharacterXML.
			fileHandle writeStreamDo: [:stream |
				stream
					streamConverter: encoding asXMLStreamConverter;
					nextPutAll: document printString].
			self
				shouldnt: [
					documentFromFile :=
						XMLDOMParser parseFileNamed: fileHandle path]
				raise: XMLFileException.
			self
				assert: documentFromFile encoding = '';
				assert: documentFromFile printString = document printString]].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 10/14/2016 22:33'!
testParsingEncodedFileWithBOM
	"This test creates/deletes a file so is skipped by default"
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingEncodedFileWithBOM.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self encodingNames do: [:encoding | | document documentFromFile |
			document := XMLDOMParser parse: self wideCharacterXML.
			fileHandle writeStreamDo: [:stream |
				stream
					streamConverter: encoding asXMLStreamConverter;
					nextPutByteOrderMark;
					nextPutAll: document printString].
			self
				shouldnt: [
					documentFromFile :=
						XMLDOMParser parseFileNamed: fileHandle path]
				raise: XMLFileException.
			self
				assert: documentFromFile encoding = '';
				assert: documentFromFile printString = document printString]].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 10/14/2016 22:35'!
testParsingEncodedFileWithEncodingAttribute
	"This test creates/deletes a file so is skipped by default"
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingEncodedFileWithEncodingAttribute.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self encodingNames do: [:encoding | | document documentFromFile |
			document := XMLDOMParser parse: self wideCharacterXML.
			document encoding: encoding.
			fileHandle writeStreamDo: [:stream |
				stream
					streamConverter: encoding asXMLStreamConverter;
					nextPutAll: document printString].
			self
				shouldnt: [
					documentFromFile :=
						XMLDOMParser parseFileNamed: fileHandle path]
				raise: XMLFileException.
			self
				assert: documentFromFile encoding = encoding;
				assert: documentFromFile printString = document printString]].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 10/14/2016 22:36'!
testParsingEncodedFileWithEncodingAttributeAndBOM
	"This test creates/deletes a file so is skipped by default"
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingEncodedFileWithEncodingAttributeAndBOM.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self encodingNames do: [:encoding | | document documentFromFile |
			document := XMLDOMParser parse: self wideCharacterXML.
			document encoding: encoding.
			fileHandle writeStreamDo: [:stream |
				stream
					streamConverter: encoding asXMLStreamConverter;
					nextPutByteOrderMark;
					nextPutAll: document printString].
			self
				shouldnt: [
					documentFromFile :=
						XMLDOMParser parseFileNamed: fileHandle path]
				raise: XMLFileException.
			self
				assert: documentFromFile encoding = encoding;
				assert: documentFromFile printString = document printString]].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 10/3/2016 16:41'!
testParsingExternalEntities
	"This test uses HTTP so is skipped by default."
	| entityCacheCopy |

	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingExternalEntities.

	DTDCachingExternalEntityResolver clearEntityCache.
	self assert: DTDCachingExternalEntityResolver entityCache isEmpty.

	SAXHandler
		parse: self musicXMLDocument
		usingNamespaces: true
		validation: true
		externalEntities: true.
	self deny: DTDCachingExternalEntityResolver entityCache isEmpty.

	"ensure there is no re-requesting of cached entities"
	entityCacheCopy := DTDCachingExternalEntityResolver entityCache copy.
	SAXHandler
		parse: self musicXMLDocument
		usingNamespaces: true
		validation: true
		externalEntities: true.
	DTDCachingExternalEntityResolver entityCache keysAndValuesDo: [:key :value |
		self assert:
			(entityCacheCopy
				at: key
				ifAbsent: [self fail]) == value].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/19/2017 07:23'!
testParsingExternalEntitiesLimit
	"This test uses HTTP so is skipped by default."
	| handler parser limitedResolver totalResolvedExternalEntities |

	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingExternalEntitiesLimit.

	DTDCachingExternalEntityResolver clearEntityCache.

	(handler := SAXHandler on: self musicXMLDocument)
		resolvesExternalEntities: true.
	parser := handler parser.
	(limitedResolver := parser driver externalEntityResolver)
		maxExternalEntities: nil.
	parser parseDocument.
	totalResolvedExternalEntities := limitedResolver totalResolvedExternalEntities.
	self assert: totalResolvedExternalEntities > 0.

	"should report the same number of resolved entities each time, even if
	they were cached, to ensure deterministic behavior regardless of which
	resolver is used or the state of the cache"
	(handler := SAXHandler on: self musicXMLDocument)
		resolvesExternalEntities: true.
	parser := handler parser.
	(limitedResolver := parser driver externalEntityResolver)
		maxExternalEntities: totalResolvedExternalEntities.
	parser parseDocument.
	self assert:
		limitedResolver totalResolvedExternalEntities =
			totalResolvedExternalEntities.

	(handler := SAXHandler on: self musicXMLDocument)
		resolvesExternalEntities: true.
	parser := handler parser.
	(limitedResolver := parser driver externalEntityResolver)
		maxExternalEntities: totalResolvedExternalEntities - 1.
	self
		should: [parser parseDocument]
		raise: XMLLimitException.! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testParsingFile
	"This test creates/deletes a file so is skipped by default"
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingFile.

	self tempFileManager newFileHandleDo: [:fileHandle | | document |
		self
			should: [XMLDOMParser parseFileNamed: fileHandle path]
			raise: XMLFileException.

		self tempFileManager
			createFileWithContents: self musicXMLDocument
			forHandle: fileHandle.
		self
			shouldnt: [document := XMLDOMParser parseFileNamed: fileHandle path]
			raise: XMLFileException.
		self assert: (document root isNamed: 'score-partwise')].! !

!XMLExternalEntityTest methodsFor: 'tests' stamp: 'monty 5/18/2017 20:25'!
testParsingURL
	"This uses HTTP so is skipped by default"
	| doc |

	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testParsingURL.

	self
		shouldnt: [doc := XMLDOMParser parseURL: self feedURL]
		raise: XMLHTTPException.
	self assert: (doc root isNamed: 'rss').! !

!XMLExternalEntityTest methodsFor: 'source' stamp: 'monty 10/3/2016 17:02'!
wideCharacterXML
	^ '<?xml version="1.0"?>
		<currency>
			<name>Euro</name>
			<symbol>{1}</symbol>
			<sub>
				<name>Cent</name>
				<symbol>{2}</symbol>
				<total>100</total>
			</sub>
		</currency>'
			format:
				(Array
					with: 16r20AC asCharacter
					with: 16rA2 asCharacter)! !

XMLSkippableTest subclass: #XMLFileHandleTest
	instanceVariableNames: 'tempFileManager currentWorkingDirectoryFileHandle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Files'!

!XMLFileHandleTest class methodsFor: 'testing' stamp: 'monty 9/16/2016 15:09'!
isAbstract
	^ false! !

!XMLFileHandleTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 11:08'!
shouldInheritSelectors
	^ true! !

!XMLFileHandleTest class methodsFor: 'accessing' stamp: 'monty 9/17/2016 11:19'!
skippableTests
	^ #(#testContents #testDelete
		#testExists #testExtension
		#testGet #testGetUpToLimitDecoding
		#testIsFile #testIsXMLDocumentFile
		#testRawReadStream #testRawWriteStream
		#testReadStream #testReadStreamDo
		#testSize #testStreamGet
		#testStreamGetUpToLimitDecoding
		#testWriteStream #testWriteStreamDo)! !

!XMLFileHandleTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 16:34'!
currentWorkingDirectoryFileHandle
	^ currentWorkingDirectoryFileHandle
		ifNil: [
			currentWorkingDirectoryFileHandle :=
				XMLFileHandle currentWorkingDirectory asXMLFileHandle]! !

!XMLFileHandleTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:05'!
decodedFileContents
	^ 'test'! !

!XMLFileHandleTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:07'!
encodedFileContents
	^ 'test'! !

!XMLFileHandleTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:41'!
encodedFileContentsWithByteOrderMark
	^ self streamConverterClass byteOrderMark, self encodedFileContents! !

!XMLFileHandleTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:23'!
streamConverterClass
	^ XMLNullStreamConverter! !

!XMLFileHandleTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 16:17'!
tempFileManager
	^ tempFileManager
		ifNil: [
			tempFileManager :=
				XMLTempFileManager
					streamConverter: self streamConverterClass new
					fileContents: self decodedFileContents
					fileSuffix: '.txt']! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/22/2016 16:21'!
testAsXMLFileHandle
	XMLFileHandle hasSupportedImplementation
		ifTrue: [| fileHandle |
			fileHandle := '' asXMLFileHandle.
			self
				assert: fileHandle class == XMLFileHandle implementation;
				assert: fileHandle asXMLFileHandle == fileHandle]! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testContents
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testContents.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self
			should: [fileHandle contents]
			raise: XMLFileException.
		self
			should: [self currentWorkingDirectoryFileHandle contents]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.
		self assert: fileHandle contents = self decodedFileContents].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:35'!
testDelete
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testDelete.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self
			should: [fileHandle delete]
			raise: XMLFileException.

		self tempFileManager createFileForHandle: fileHandle.
		self
			assert: fileHandle delete == fileHandle;
			deny: fileHandle exists.

		self
			should: [fileHandle delete]
			raise: XMLFileException].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:35'!
testExists
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testExists.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self
			deny: fileHandle exists;
			assert: self currentWorkingDirectoryFileHandle exists.

		self tempFileManager createFileForHandle: fileHandle.
		self assert: fileHandle exists].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/16/2016 16:06'!
testExtension
	XMLFileHandle hasSupportedImplementation
		ifFalse: [^ self].

	self
		assert: '' asXMLFileHandle extension = '';
		assert: 'one' asXMLFileHandle extension = '';
		assert: 'one.two' asXMLFileHandle extension = 'two';
		assert: 'one.two.three' asXMLFileHandle extension = 'two.three';
		assert: '/' asXMLFileHandle extension = '';
		assert: '/one' asXMLFileHandle extension = '';
		assert: '/one.two' asXMLFileHandle extension = 'two';
		assert: '/one.two.three' asXMLFileHandle extension = 'two.three';
		assert: 'one/' asXMLFileHandle extension = '';
		assert: 'one/two' asXMLFileHandle extension = '';
		assert: 'one/two.three' asXMLFileHandle extension = 'three';
		assert: 'one/two.three.four' asXMLFileHandle extension = 'three.four';
		assert: 'one/two/' asXMLFileHandle extension = '';
		assert: 'one/two.three/' asXMLFileHandle extension = '';
		assert: 'one/two.three.four/' asXMLFileHandle extension = ''.! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testGet
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testGet.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self
			should: [fileHandle get]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.
		self assert: fileHandle get = self decodedFileContents].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testGetUpToLimitDecoding
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testGetUpToLimitDecoding.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self
			should: [
				fileHandle
					getUpToLimit: nil
					decoding: true]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.

		self assert:
			(fileHandle
				getUpToLimit: nil
				decoding: true) = self decodedFileContents.
		self assert:
			(fileHandle
				getUpToLimit: nil
				decoding: false) = self encodedFileContentsWithByteOrderMark.

		self assert:
			(fileHandle
				getUpToLimit: self encodedFileContentsWithByteOrderMark size
				decoding: true) = self decodedFileContents.
		self assert:
			(fileHandle
				getUpToLimit: self encodedFileContentsWithByteOrderMark size
				decoding: false) = self encodedFileContentsWithByteOrderMark.

		self
			should: [
				fileHandle
					getUpToLimit: self encodedFileContentsWithByteOrderMark size - 1
					decoding: true]
			raise: XMLLimitException.
		self
			should: [
				fileHandle
					getUpToLimit: self encodedFileContentsWithByteOrderMark size - 1
					decoding: false]
			raise: XMLLimitException].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:35'!
testIsFile
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testIsFile.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self
			deny: fileHandle isFile;
			deny: self currentWorkingDirectoryFileHandle isFile.

		self tempFileManager createFileForHandle: fileHandle.
		self assert: fileHandle isFile].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/21/2016 00:10'!
testIsXMLDocumentFile
	XMLFileHandle hasSupportedImplementation
		ifFalse: [^ self].

	#('atom' 'dbk' 'docm' 'docx' 'pptm' 'pptx' 'rdf' 'rss' 'svg' 'xbel'
		'xfd' 'xfdl' 'xhtml' 'xlsm' 'xlsx' 'xml' 'xsd' 'xspf' 'xul')
		do: [:each | | file |
			file := 'test.', each.
			self
				assert: file asXMLFileHandle isXMLDocumentFile;
				assert: file asUppercase asXMLFileHandle isXMLDocumentFile].

	#('txt' 'html' 'jpeg' 'jpg' 'gif' 'dtd' 'ent')
		do: [:each | | file |
			file := 'test.', each.
			self
				deny: file asXMLFileHandle isXMLDocumentFile;
				deny: file asUppercase asXMLFileHandle isXMLDocumentFile].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/22/2016 16:21'!
testPath
	XMLFileHandle hasSupportedImplementation
		ifTrue: [| fileHandle |
			fileHandle := XMLFileHandle implementation path: 'test'.
			self
				assert: fileHandle class == XMLFileHandle implementation;
				assert: fileHandle path = 'test']! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testRawReadStream
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testRawReadStream.

	self tempFileManager newFileHandleDo: [:fileHandle | | readStream |
		self
			should: [fileHandle rawReadStream]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.
		readStream := fileHandle rawReadStream.
		self
			deny: readStream isXMLConvertingStreamAdapter;
			assert: readStream upToEnd = self encodedFileContentsWithByteOrderMark.
		readStream close].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 10/3/2016 22:12'!
testRawWriteStream
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testRawWriteStream.

	self tempFileManager newFileHandleDo: [:fileHandle |
		"evaluate twice to ensure it truncates existing contents when opening"
		2 timesRepeat: [| writeStream |
			writeStream := fileHandle rawWriteStream.
			self deny: writeStream isXMLConvertingStreamAdapter.

			writeStream
				nextPutAll: self encodedFileContentsWithByteOrderMark;
				close.
			self assert: fileHandle contents = self decodedFileContents]].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testReadStream
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testReadStream.

	self tempFileManager newFileHandleDo: [:fileHandle | | readStream |
		self
			should: [fileHandle readStream]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.
		readStream := fileHandle readStream.
		self
			assert: readStream isXMLConvertingStreamAdapter;
			assert: readStream upToEnd = self decodedFileContents.
		readStream close].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testReadStreamDo
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testReadStreamDo.

	self tempFileManager newFileHandleDo: [:fileHandle | | contents |
		self
			should: [fileHandle readStreamDo: [:readStream | ]]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.
		fileHandle readStreamDo: [:readStream |
			self assert: readStream isXMLConvertingStreamAdapter.
			"saved to a temp to ensure the block was evaluated"
			contents := readStream upToEnd].
		self assert: contents = self decodedFileContents].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testSize
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testSize.

	self tempFileManager newFileHandleDo: [:fileHandle |
		self
			should: [fileHandle size]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.
		self assert:
			fileHandle size >=
				self encodedFileContentsWithByteOrderMark size].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testStreamGet
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testStreamGet.

	self tempFileManager newFileHandleDo: [:fileHandle | | readStream |
		self
			should: [fileHandle streamGet]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.
		readStream := fileHandle streamGet.
		self
			assert: readStream isXMLConvertingStreamAdapter;
			assert: readStream upToEnd = self decodedFileContents.
		readStream close].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 9/18/2016 16:36'!
testStreamGetUpToLimitDecoding
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testStreamGetUpToLimitDecoding.

	self tempFileManager newFileHandleDo: [:fileHandle | | readStream |
		self
			should: [
				fileHandle
					streamGetUpToLimit: nil
					decoding: true]
			raise: XMLFileException.

		self tempFileManager createFileWithContentsForHandle: fileHandle.

		readStream :=
			fileHandle
				streamGetUpToLimit: nil
				decoding: true.
		self
			assert: readStream isXMLConvertingStreamAdapter;
			assert: readStream upToEnd = self decodedFileContents.
		readStream close.
		readStream :=
			fileHandle
				streamGetUpToLimit: nil
				decoding: false.
		self
			deny: readStream isXMLConvertingStreamAdapter;
			assert: readStream upToEnd = self encodedFileContentsWithByteOrderMark.
		readStream close.

		readStream :=
			fileHandle
				streamGetUpToLimit: self encodedFileContentsWithByteOrderMark size
				decoding: true.
		self
			assert: readStream isXMLConvertingStreamAdapter;
			assert: readStream upToEnd = self decodedFileContents.
		readStream close.
		readStream :=
			fileHandle
				streamGetUpToLimit: self encodedFileContentsWithByteOrderMark size
				decoding: false.
		self
			deny: readStream isXMLConvertingStreamAdapter;
			assert: readStream upToEnd = self encodedFileContentsWithByteOrderMark.
		readStream close.

		self
			should: [
				fileHandle
					streamGetUpToLimit:
						self encodedFileContentsWithByteOrderMark size - 1
					decoding: true]
			raise: XMLLimitException.
		self
			should: [
				fileHandle
					streamGetUpToLimit:
						self encodedFileContentsWithByteOrderMark size - 1
					decoding: false]
			raise: XMLLimitException].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 10/3/2016 22:12'!
testWriteStream
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testWriteStream.

	self tempFileManager newFileHandleDo: [:fileHandle |
		"evaluate twice to ensure it truncates existing contents when opening"
		2 timesRepeat: [| writeStream |
			writeStream := fileHandle writeStream.
			self
				assert: writeStream isXMLConvertingStreamAdapter;
				assert: writeStream hasDefaultStreamConverter.

			writeStream
				streamConverter: self streamConverterClass new;
				nextPutByteOrderMark;
				nextPutAll: self decodedFileContents;
				close.
			self assert: fileHandle contents = self decodedFileContents]].! !

!XMLFileHandleTest methodsFor: 'tests' stamp: 'monty 10/3/2016 22:12'!
testWriteStreamDo
	self
		skipOrReturnWith: [^ self]
		ifSkippable: #testWriteStreamDo.

	self tempFileManager newFileHandleDo: [:fileHandle |
		"evaluate twice to ensure it truncates existing contents when opening"
		2 timesRepeat: [
			fileHandle writeStreamDo: [:writeStream |
				self
					assert: writeStream isXMLConvertingStreamAdapter;
					assert: writeStream hasDefaultStreamConverter.

				writeStream
					streamConverter: self streamConverterClass new;
					nextPutByteOrderMark;
					nextPutAll: self decodedFileContents].
			self assert: fileHandle contents = self decodedFileContents]].! !

XMLFileHandleTest subclass: #XMLFileHandleUTF16BETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Files'!

!XMLFileHandleUTF16BETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:07'!
decodedFileContents
	^ XMLStreamAdapterTest decodedUTF16String! !

!XMLFileHandleUTF16BETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:07'!
encodedFileContents
	^ XMLStreamAdapterTest encodedUTF16BEString! !

!XMLFileHandleUTF16BETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:24'!
streamConverterClass
	^ XMLUTF16BigEndianStreamConverter! !

XMLFileHandleTest subclass: #XMLFileHandleUTF16LETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Files'!

!XMLFileHandleUTF16LETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:07'!
decodedFileContents
	^ XMLStreamAdapterTest decodedUTF16String! !

!XMLFileHandleUTF16LETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:07'!
encodedFileContents
	^ XMLStreamAdapterTest encodedUTF16LEString! !

!XMLFileHandleUTF16LETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:24'!
streamConverterClass
	^ XMLUTF16LittleEndianStreamConverter! !

XMLFileHandleTest subclass: #XMLFileHandleUTF32BETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Files'!

!XMLFileHandleUTF32BETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:06'!
decodedFileContents
	^ XMLStreamAdapterTest decodedUTF32String! !

!XMLFileHandleUTF32BETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:07'!
encodedFileContents
	^ XMLStreamAdapterTest encodedUTF32BEString! !

!XMLFileHandleUTF32BETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:25'!
streamConverterClass
	^ XMLUTF32BigEndianStreamConverter! !

XMLFileHandleTest subclass: #XMLFileHandleUTF32LETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Files'!

!XMLFileHandleUTF32LETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:06'!
decodedFileContents
	^ XMLStreamAdapterTest decodedUTF32String! !

!XMLFileHandleUTF32LETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:05'!
encodedFileContents
	^ XMLStreamAdapterTest encodedUTF32LEString! !

!XMLFileHandleUTF32LETest methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:25'!
streamConverterClass
	^ XMLUTF32LittleEndianStreamConverter! !

XMLFileHandleTest subclass: #XMLFileHandleUTF8Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Files'!

!XMLFileHandleUTF8Test methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:05'!
decodedFileContents
	^ XMLStreamAdapterTest decodedUTF8String! !

!XMLFileHandleUTF8Test methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:05'!
encodedFileContents
	^ XMLStreamAdapterTest encodedUTF8String! !

!XMLFileHandleUTF8Test methodsFor: 'accessing' stamp: 'monty 9/18/2016 11:25'!
streamConverterClass
	^ XMLUTF8StreamConverter! !

!XMLSkippableTest class methodsFor: 'testing' stamp: 'monty 9/10/2016 02:54'!
isAbstract
	^ true! !

!XMLSkippableTest class methodsFor: 'testing' stamp: 'monty 9/10/2016 02:56'!
isSkipping
	^ isSkipping ifNil: [isSkipping := true]! !

!XMLSkippableTest class methodsFor: 'accessing' stamp: 'monty 9/10/2016 02:56'!
isSkipping: aBoolean
	isSkipping := aBoolean! !

!XMLSkippableTest class methodsFor: 'accessing' stamp: 'monty 9/10/2016 03:02'!
skippableTests
	"subclasses should override to return a collection of skippable test selectors"
	^ #()! !

!XMLSkippableTest class methodsFor: 'skipping' stamp: 'monty 9/22/2016 15:11'!
startSkipping
	self isSkipping: true! !

!XMLSkippableTest class methodsFor: 'skipping' stamp: 'monty 9/22/2016 15:10'!
startSkippingAll
	self startSkipping.
	self allSubclassesDo: [:each | each startSkipping]! !

!XMLSkippableTest class methodsFor: 'skipping' stamp: 'monty 9/22/2016 15:11'!
stopSkipping
	self isSkipping: false! !

!XMLSkippableTest class methodsFor: 'skipping' stamp: 'monty 9/22/2016 15:10'!
stopSkippingAll
	self stopSkipping.
	self allSubclassesDo: [:each | each stopSkipping]! !

!XMLSkippableTest methodsFor: 'testing' stamp: 'monty 9/10/2016 05:16'!
isSkipping
	^ self class isSkipping! !

!XMLSkippableTest methodsFor: 'private' stamp: 'monty 9/10/2016 03:22'!
skipOrReturnWith: aBlock
	"skip is not portable to Squeak, so a return block is used as a backup"
	(self respondsTo: #skip)
		ifTrue: [self skip]
		ifFalse: [aBlock value]! !

!XMLSkippableTest methodsFor: 'private' stamp: 'monty 9/10/2016 05:17'!
skipOrReturnWith: aBlock ifSkippable: aSelector
	"skip is not portable to Squeak, so a return block is used as a backup"
	(self isSkipping
		and: [self skippableTests includes: aSelector])
		ifTrue: [self skipOrReturnWith: aBlock]! !

!XMLSkippableTest methodsFor: 'accessing' stamp: 'monty 9/10/2016 02:58'!
skippableTests
	"make it a set for faster lookup"
	^ skippableTests ifNil: [skippableTests := self class skippableTests asSet]! !

TestCase subclass: #XMLStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLStreamAdapterTest commentStamp: 'monty 9/18/2016 10:10' prior: 0!
Abstract, do not run.!

XMLStreamAdapterTest subclass: #XMLReadStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLReadStreamAdapterTest subclass: #XMLBinaryReadStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLBinaryReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ super inputCollection asArray collect: [:each | each asciiValue]! !

!XMLBinaryReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLBinaryReadStreamAdapter! !

!XMLBinaryReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 9/29/2017 21:28'!
testOnStreamIfBinary
	| stream adapter |

	stream := self newStreamOn: '1'.
	self assert: (self streamAdapterClass onStreamIfBinary: stream) == stream.

	stream next.
	self assert: (self streamAdapterClass onStreamIfBinary: stream) == stream.

	stream := self newStreamOn: #(1).
	adapter := self streamAdapterClass onStreamIfBinary: stream.
	self assert: adapter class == self streamAdapterClass.

	stream next.
	self assert: (self streamAdapterClass onStreamIfBinary: stream) == stream.! !

XMLReadStreamAdapterTest subclass: #XMLDecodingReadStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLDecodingReadStreamAdapterTest subclass: #XMLDecodingReadStreamAdapterByteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLDecodingReadStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:12'!
inputCollection
	^ self encodedByteString! !

!XMLDecodingReadStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 4/28/2017 10:01'!
invalidEncodedInputCollections
	^ Array with: (self stringFrom: #(16r100))! !

!XMLDecodingReadStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:13'!
outputCollection
	^ self decodedByteString! !

!XMLDecodingReadStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:24'!
streamConverterClass
	^ XMLByteStreamConverter! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 11/22/2016 18:41'!
inputCollectionWithBOM
	^ self streamConverterClass byteOrderMark, self inputCollection! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:22'!
invalidEncodedInputCollections
	^ #('')! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:21'!
invalidEncodedInputCollectionsWithBOM
	^ self invalidEncodedInputCollections collect: [:each |
		self streamConverterClass byteOrderMark, each]! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:22'!
invalidStreamCollections
	^ self invalidEncodedInputCollections! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'testing' stamp: 'monty 11/22/2016 18:40'!
isDetecting
	^ false! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 11/22/2016 18:40'!
newStreamAdapterOn: aStream
	| adapter |

	adapter := super newStreamAdapterOn: aStream.
	self isDetecting
		ifTrue: [adapter detectEncoding]
		ifFalse: [adapter streamConverter: self streamConverterClass new].
	^ adapter.! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLDecodingReadStreamAdapter! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:24'!
streamConverterClass
	^ XMLNullStreamConverter! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 16:09'!
testHasDefaultStreamConverter
	| adapter |

	adapter := self newStreamAdapter.
	self assert:
		adapter hasDefaultStreamConverter = adapter streamConverter isDefault.! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 9/18/2016 12:05'!
testHasNullStreamConverter
	| adapter |

	adapter := self newStreamAdapter.
	self assert: adapter hasNullStreamConverter = adapter streamConverter isNull.! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 9/26/2017 09:19'!
testInvalidCharacters
	self invalidStreamCollections do: [:each | | streamAdapter |
		streamAdapter := self newStreamAdapterOn: (self newStreamOn: each).
		[streamAdapter atEnd]
			whileFalse: [
				self
					should: [streamAdapter next]
					raise: XMLEncodingException].
		self assert: streamAdapter atEnd]! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/1/2016 00:55'!
testIsXMLConvertingStreamAdapter
	self assert: self newStreamAdapter isXMLConvertingStreamAdapter! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 9/29/2017 21:26'!
testOn
	| stream adapter |

	super testOn.

	stream := self newStreamOn: #(1).
	adapter := self newStreamAdapterOn: stream.
	self
		assert: adapter class == self streamAdapterClass;
		assert: adapter stream class == XMLBinaryReadStreamAdapter;
		assert: adapter stream stream == stream.! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 9/29/2017 21:27'!
testOnStreamIfBinary
	| stream adapter |

	stream := self newStreamOn: '1'.
	self assert: (self streamAdapterClass onStreamIfBinary: stream) == stream.

	stream next.
	self assert: (self streamAdapterClass onStreamIfBinary: stream) == stream.

	stream := self newStreamOn: #(1).
	adapter := self streamAdapterClass onStreamIfBinary: stream.
	self
		assert: adapter class == self streamAdapterClass;
		assert: adapter hasDefaultStreamConverter.

	stream next.
	self assert: (self streamAdapterClass onStreamIfBinary: stream) == stream.! !

!XMLDecodingReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testStreamConverter
	| adapter newConverter |

	adapter := self newStreamAdapter.
	self
		deny: adapter streamConverter isNil;
		assert: adapter streamConverter class == self streamConverterClass.

	newConverter := self streamConverterClass new.
	self
		assert: (adapter streamConverter: newConverter) == adapter;
		assert: adapter streamConverter == newConverter.

	self
		assert: (adapter streamConverter: nil) == adapter;
		assert: adapter streamConverter class == XMLNullStreamConverter.! !

XMLDecodingReadStreamAdapterTest subclass: #XMLDecodingReadStreamAdapterUTF16BETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLDecodingReadStreamAdapterUTF16BETest subclass: #XMLDecodingReadStreamAdapterUTF16BEBOMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLDecodingReadStreamAdapterUTF16BEBOMTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:23'!
invalidStreamCollections
	^ self invalidEncodedInputCollectionsWithBOM! !

!XMLDecodingReadStreamAdapterUTF16BEBOMTest methodsFor: 'testing' stamp: 'monty 11/22/2016 18:39'!
isDetecting
	^ true! !

!XMLDecodingReadStreamAdapterUTF16BEBOMTest methodsFor: 'accessing' stamp: 'monty 11/22/2016 18:43'!
streamCollection
	^ self inputCollectionWithBOM! !

!XMLDecodingReadStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ self encodedUTF16BEString! !

!XMLDecodingReadStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 4/28/2017 21:20'!
invalidEncodedInputCollections
	"code points greater than U+10FFFF can't be encoded using UTF-16, so
	they aren't tested for here"
	^ #(
			#(16rDC 16r00 16rDC 16r00) "first illegal leading surrogate"
			#(16rDF 16rFF 16rDC 16r00) "last illegal leading surrogate"
			#(16rD8 16r00 16rD8 16r00) "first illegal trailing surrogate"
			#(16rD8 16r00 16rDB 16rFF) "last illegal trailing surrogate"
		) collect: [:each | self stringFrom: each]! !

!XMLDecodingReadStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:07'!
outputCollection
	^ self decodedUTF16String! !

!XMLDecodingReadStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:09'!
streamConverterClass
	^ XMLUTF16BigEndianStreamConverter! !

XMLDecodingReadStreamAdapterTest subclass: #XMLDecodingReadStreamAdapterUTF16LETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLDecodingReadStreamAdapterUTF16LETest subclass: #XMLDecodingReadStreamAdapterUTF16LEBOMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLDecodingReadStreamAdapterUTF16LEBOMTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:23'!
invalidStreamCollections
	^ self invalidEncodedInputCollectionsWithBOM! !

!XMLDecodingReadStreamAdapterUTF16LEBOMTest methodsFor: 'testing' stamp: 'monty 11/22/2016 18:39'!
isDetecting
	^ true! !

!XMLDecodingReadStreamAdapterUTF16LEBOMTest methodsFor: 'accessing' stamp: 'monty 11/22/2016 18:43'!
streamCollection
	^ self inputCollectionWithBOM! !

!XMLDecodingReadStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ self encodedUTF16LEString! !

!XMLDecodingReadStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 4/28/2017 21:20'!
invalidEncodedInputCollections
	"code points greater than U+10FFFF can't be encoded using UTF-16, so
	they aren't tested for here"
	^ #(
			#(16r00 16rDC 16r00 16rDC) "first illegal leading surrogate"
			#(16rFF 16rDF 16r00 16rDC) "last illegal leading surrogate"
			#(16r00 16rD8 16r00 16rD8) "first illegal trailing surrogate"
			#(16r00 16rD8 16rFF 16rDB) "last illegal trailing surrogate"
		) collect: [:each | self stringFrom: each]! !

!XMLDecodingReadStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:10'!
outputCollection
	^ self decodedUTF16String! !

!XMLDecodingReadStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:10'!
streamConverterClass
	^ XMLUTF16LittleEndianStreamConverter! !

XMLDecodingReadStreamAdapterTest subclass: #XMLDecodingReadStreamAdapterUTF32BETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLDecodingReadStreamAdapterUTF32BETest subclass: #XMLDecodingReadStreamAdapterUTF32BEBOMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLDecodingReadStreamAdapterUTF32BEBOMTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:23'!
invalidStreamCollections
	^ self invalidEncodedInputCollectionsWithBOM! !

!XMLDecodingReadStreamAdapterUTF32BEBOMTest methodsFor: 'testing' stamp: 'monty 11/22/2016 18:39'!
isDetecting
	^ true! !

!XMLDecodingReadStreamAdapterUTF32BEBOMTest methodsFor: 'accessing' stamp: 'monty 11/22/2016 18:43'!
streamCollection
	^ self inputCollectionWithBOM! !

!XMLDecodingReadStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ self encodedUTF32BEString! !

!XMLDecodingReadStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 4/28/2017 10:02'!
invalidEncodedInputCollections
	^ #(
			#(16r00 16r00 16rD8 16r00) "first surrogate code point"
			#(16r00 16r00 16rDB 16rFF) "last surrogate code point"
			#(16r00 16r11 16r00 16r00) "greater than U+10FFFF"
		) collect: [:each | self stringFrom: each]! !

!XMLDecodingReadStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:19'!
outputCollection
	^ self decodedUTF32String! !

!XMLDecodingReadStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:20'!
streamConverterClass
	^ XMLUTF32BigEndianStreamConverter! !

XMLDecodingReadStreamAdapterTest subclass: #XMLDecodingReadStreamAdapterUTF32LETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLDecodingReadStreamAdapterUTF32LETest subclass: #XMLDecodingReadStreamAdapterUTF32LEBOMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLDecodingReadStreamAdapterUTF32LEBOMTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:23'!
invalidStreamCollections
	^ self invalidEncodedInputCollectionsWithBOM! !

!XMLDecodingReadStreamAdapterUTF32LEBOMTest methodsFor: 'testing' stamp: 'monty 11/22/2016 18:39'!
isDetecting
	^ true! !

!XMLDecodingReadStreamAdapterUTF32LEBOMTest methodsFor: 'accessing' stamp: 'monty 11/22/2016 18:43'!
streamCollection
	^ self inputCollectionWithBOM! !

!XMLDecodingReadStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ self encodedUTF32LEString! !

!XMLDecodingReadStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 4/28/2017 10:02'!
invalidEncodedInputCollections
	^ #(
			#(16r00 16rD8 16r00 16r00) "first surrogate code point"
			#(16rFF 16rDB 16r00 16r00) "last surrogate code point"
			#(16r00 16r00 16r11 16r00) "greater than U+10FFFF"
		) collect: [:each | self stringFrom: each]! !

!XMLDecodingReadStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:12'!
outputCollection
	^ self decodedUTF32String! !

!XMLDecodingReadStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:12'!
streamConverterClass
	^ XMLUTF32LittleEndianStreamConverter! !

XMLDecodingReadStreamAdapterTest subclass: #XMLDecodingReadStreamAdapterUTF8Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLDecodingReadStreamAdapterUTF8Test subclass: #XMLDecodingReadStreamAdapterUTF8BOMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLDecodingReadStreamAdapterUTF8BOMTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 18:23'!
invalidStreamCollections
	^ self invalidEncodedInputCollectionsWithBOM! !

!XMLDecodingReadStreamAdapterUTF8BOMTest methodsFor: 'testing' stamp: 'monty 11/22/2016 18:39'!
isDetecting
	^ true! !

!XMLDecodingReadStreamAdapterUTF8BOMTest methodsFor: 'accessing' stamp: 'monty 11/22/2016 18:43'!
streamCollection
	^ self inputCollectionWithBOM! !

!XMLDecodingReadStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ self encodedUTF8String! !

!XMLDecodingReadStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 4/28/2017 10:05'!
invalidEncodedInputCollections
	^ #(
			#(16rC0 16r80) "first two byte overlong"
			#(16rC1 16rBF) "last two byte overlong"
			#(16rE0 16r80 16r80) "first three byte overlong"
			#(16rE0 16r9F 16rBF) "last three byte overlong"
			#(16rED 16rA0 16r80) "first surrogate"
			#(16rED 16rBF 16rBF) "last surrogate"
			#(16rF0 16r80 16r80 16r80) "first four byte overlong"
			#(16rF0 16r8F 16rBF 16rBF) "last four byte overlong"
			#(16rF4 16r9F 16rBF 16rBF) "greater than U+10FFFF"
		) collect: [:each | self stringFrom: each]! !

!XMLDecodingReadStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:07'!
outputCollection
	^ self decodedUTF8String! !

!XMLDecodingReadStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 2/11/2016 04:06'!
streamConverterClass
	^ XMLUTF8StreamConverter! !

XMLDecodingReadStreamAdapterTest subclass: #XMLPercentDecodingReadStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLPercentDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ self percentEncodedUTF8String! !

!XMLPercentDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 08:41'!
outputCollection
	^ self decodedUTF8String! !

!XMLPercentDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLPercentDecodingReadStreamAdapter! !

!XMLPercentDecodingReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 08:41'!
streamConverterClass
	^ XMLUTF8StreamConverter! !

!XMLReadStreamAdapterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:20'!
isAbstract
	^ false! !

!XMLReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
inputCollection
	^ 'test'! !

!XMLReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 03:41'!
outputCollection
	^ 'test'! !

!XMLReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLReadStreamAdapter! !

!XMLReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/26/2017 08:23'!
streamClass
	^ XMLExceptionRaisingReadStream! !

!XMLReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:17'!
streamCollection
	^ self inputCollection! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testAtEnd
	| adapter |

	adapter := self newStreamAdapter.
	self outputCollection size timesRepeat: [
		self deny: adapter atEnd.
		adapter next].
	self assert: adapter atEnd.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 12/3/2016 02:22'!
testContents
	| adapter |

	adapter := self newStreamAdapter.
	self outputCollection do: [:each |
		"use #= because wide chars aren't #== pre-Spur"
		self
			assert: adapter peek = each;
			assert: adapter contents = self outputCollection;
			assert: adapter peek = each;
			assert: adapter next = each].
	self assert: adapter contents = self outputCollection.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 12/3/2016 02:24'!
testNext
	| adapter |

	adapter := self newStreamAdapter.
	self outputCollection do: [:each |
		"use #= because wide chars aren't #== pre-Spur"
		self assert: adapter next = each].
	self assert: adapter next isNil.

	0 to: self outputCollection size do: [:i |
		adapter := self newStreamAdapter.
		self assert: (adapter next: i) = (self outputCollection copyFrom: 1 to: i)].

	adapter := self newStreamAdapter.
	self
		assert: (adapter next: self outputCollection size + 1) = self outputCollection;
		assert: (adapter next: 1) isEmpty.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 12/3/2016 02:24'!
testPeek
	| adapter |

	adapter := self newStreamAdapter.
	self outputCollection do: [:each |
		"use #= because wide chars aren't #== pre-Spur"
		self assert: adapter peek = each.
		adapter next].
	self assert: adapter peek isNil.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 9/25/2017 12:56'!
testPeekFor
	| adapter |

	adapter := self newStreamAdapter.
	self outputCollection do: [:each |
		self
			deny: (adapter peekFor: #absent);
			deny: (adapter peekFor: nil);
			assert: (adapter peekFor: each);
			deny: (adapter peekFor: #absent);
			deny: (adapter peekFor: nil)].
	self
		deny: (adapter peekFor: #absent);
		deny: (adapter peekFor: nil).! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 12/3/2016 02:24'!
testPosition
	| adapter startPosition position |

	adapter := self newStreamAdapter.
	startPosition := adapter position. "1 or 0 depending on the stream on GS"
	position := startPosition.
	self outputCollection do: [:each |
		self
			assert: adapter position = position;
			"use #= because wide chars aren't #== pre-Spur"
			assert: adapter peek = each;
			assert: adapter position = position;
			assert: adapter next = each;
			assert: adapter position > position.
		
		adapter peek.
		self
			assert: (adapter position: position) == adapter;
			assert: adapter peek = each;
			assert: adapter position = position;
			assert: adapter next = each;
			assert: adapter position > position.
		position := adapter position].
	self assert: position = (startPosition + self inputCollection size).! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/30/2017 00:17'!
testReset
	| adapter |

	adapter := self newStreamAdapter.
	self
		assert: adapter upToEnd = self outputCollection;
		assert: adapter upToEnd isEmpty;
		assert: adapter reset == adapter;
		assert: adapter upToEnd = self outputCollection;
		assert: adapter upToEnd isEmpty.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testSkip
	| adapter |

	0 to: self outputCollection size do: [:i |
		adapter := self newStreamAdapter.
		self
			assert: (adapter skip: i) == adapter;
			assert: adapter upToEnd = (self outputCollection allButFirst: i)].

	adapter := self newStreamAdapter.
	self
		assert: (adapter skip: self outputCollection size + 1) == adapter;
		assert: adapter upToEnd isEmpty.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testSkipTo
	| adapter |

	self outputCollection do: [:each |
		adapter := self newStreamAdapter.
		self
			assert: (adapter skipTo: each);
			assert: adapter upToEnd = (self outputCollection copyAfter: each)].

	adapter := self newStreamAdapter.
	self
		deny: (adapter skipTo: #absent);
		assert: adapter atEnd.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/18/2016 23:18'!
testUpTo
	self outputCollection do: [:each | | adapter |
		adapter := self newStreamAdapter.
		self assert:
			(adapter upTo: each) =
				(self outputCollection copyUpTo: each).
		self assert:
			adapter upToEnd =
				(self outputCollection copyAfter: each)].
	self assert: (self newStreamAdapter upTo: #absent) = self outputCollection.! !

!XMLReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/18/2016 23:16'!
testUpToEnd
	| adapter |

	self outputCollection withIndexDo: [:each :i |
		adapter := self newStreamAdapter.
		adapter next: i.
		self
			assert: adapter upToEnd = (self outputCollection allButFirst: i);
			assert: adapter upToEnd = ''].
	adapter := self newStreamAdapter.
	self
		assert: adapter upToEnd = self outputCollection;
		assert: adapter upToEnd = ''.! !

!XMLStreamAdapterTest class methodsFor: 'converting' stamp: 'monty 2/12/2016 05:57'!
asciiToUTF16BE: anASCIIString
	^ String streamContents: [:stream |
		anASCIIString do: [:each |
			stream
				nextPut: 0 asCharacter;
				nextPut: each]]! !

!XMLStreamAdapterTest class methodsFor: 'converting' stamp: 'monty 2/12/2016 05:57'!
asciiToUTF16LE: anASCIIString
	^ String streamContents: [:stream |
		anASCIIString do: [:each |
			stream
				nextPut: each;
				nextPut: 0 asCharacter]]! !

!XMLStreamAdapterTest class methodsFor: 'converting' stamp: 'monty 2/12/2016 05:58'!
asciiToUTF32BE: anASCIIString
	^ String streamContents: [:stream |
		anASCIIString do: [:each |
			stream
				nextPut: 0 asCharacter;
				nextPut: 0 asCharacter;
				nextPut: 0 asCharacter;
				nextPut: each]]! !

!XMLStreamAdapterTest class methodsFor: 'converting' stamp: 'monty 2/12/2016 05:58'!
asciiToUTF32LE: anASCIIString
	^ String streamContents: [:stream |
		anASCIIString do: [:each |
			stream
				nextPut: each;
				nextPut: 0 asCharacter;
				nextPut: 0 asCharacter;
				nextPut: 0 asCharacter]]! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:12'!
decodedByteString
	"avoid ASCII null for GS compatibility"
	^ self stringFrom: #(16r01 16r0F 16r10 16rFF)! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:15'!
decodedUTF16String
	^ self stringFrom:
		#(16rFF 16r0100 16rD7FF 16rE000 16rFFFF 16r10000 16r10437 16r24B62 16r10FFFF)! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:14'!
decodedUTF32String
	^ self stringFrom: #(16rFE 16rD7FE 16r10FFFF)! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:14'!
decodedUTF8String
	^ self stringFrom:
		#(16r7F 16r80 16r7FF 16r800 16rFFFF 16r10000 16r10FFFF)! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:15'!
encodedByteString
	^ self decodedByteString! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:14'!
encodedUTF16BEString
	^ self stringFrom:
		#(16r00 16rFF
			16r01 16r00
			16rD7 16rFF
			16rE0 16r00
			16rFF 16rFF
			16rD8 16r00 16rDC 16r00 "first surrogate pair"
			16rD8 16r01 16rDC 16r37
			16rD8 16r52 16rDF 16r62
			16rDB 16rFF 16rDF 16rFF) "last surrogate pair"! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:13'!
encodedUTF16LEString
	^ self stringFrom:
		#(16rFF 16r00
			16r00 16r01
			16rFF 16rD7
			16r00 16rE0
			16rFF 16rFF
			16r00 16rD8 16r00 16rDC "first surrogate pair"
			16r01 16rD8 16r37 16rDC
			16r52 16rD8 16r62 16rDF
			16rFF 16rDB 16rFF 16rDF) "last surrogate pair"! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:13'!
encodedUTF32BEString
	^ self stringFrom:
		#(16r00 16r00 16r00 16rFE
			16r00 16r00 16rD7 16rFE
			16r00 16r10 16rFF 16rFF)! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:13'!
encodedUTF32LEString
	^ self stringFrom:
		#(16rFE 16r00 16r00 16r00
			16rFE 16rD7 16r00 16r00
			16rFF 16rFF 16r10 16r00)! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:12'!
encodedUTF8String
	^ self stringFrom:
		#(16r7F
			16rC2 16r80
			16rDF 16rBF
			16rE0 16rA0 16r80
			16rEF 16rBF 16rBF
			16rF0 16r90 16r80 16r80
			16rF4 16r8F 16rBF 16rBF)! !

!XMLStreamAdapterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:07'!
isAbstract
	^ true! !

!XMLStreamAdapterTest class methodsFor: 'converting' stamp: 'monty 3/28/2016 01:18'!
percentEncodeCharacter: aCharacter
	| hexString |

	(hexString := aCharacter asciiValue printStringHex asUppercase) size > 1
		ifTrue: [^ '%', hexString]
		ifFalse: [^ '%0', hexString]! !

!XMLStreamAdapterTest class methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:18'!
percentEncodedUTF8String
	^ String streamContents: [:stream |
		self encodedUTF8String do: [:each |
			stream nextPutAll: (self percentEncodeCharacter: each)]]! !

!XMLStreamAdapterTest class methodsFor: 'testing' stamp: 'monty 2/10/2016 22:57'!
shouldInheritSelectors
	^ true! !

!XMLStreamAdapterTest class methodsFor: 'converting' stamp: 'monty 2/14/2016 04:01'!
stringFrom: aCollection
	"avoid asString for portability"
	^ String withAll: (aCollection collect: [:each | each asCharacter])! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:13'!
decodedByteString
	^ self class decodedByteString! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:15'!
decodedUTF16String
	^ self class decodedUTF16String! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:14'!
decodedUTF32String
	^ self class decodedUTF32String! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:14'!
decodedUTF8String
	^ self class decodedUTF8String! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:13'!
encodedByteString
	^ self class encodedByteString! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:14'!
encodedUTF16BEString
	^ self class encodedUTF16BEString! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:14'!
encodedUTF16LEString
	^ self class encodedUTF16LEString! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:13'!
encodedUTF32BEString
	^ self class encodedUTF32BEString! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:13'!
encodedUTF32LEString
	^ self class encodedUTF32LEString! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:12'!
encodedUTF8String
	^ self class encodedUTF8String! !

!XMLStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 2/15/2016 09:17'!
newStream
	^ self newStreamOn: self streamCollection! !

!XMLStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 3/5/2016 12:39'!
newStreamAdapter
	^ self newStreamAdapterOn: self newStream! !

!XMLStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 3/5/2016 12:39'!
newStreamAdapterOn: aStream
	^ self streamAdapterClass on: aStream! !

!XMLStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 2/15/2016 09:17'!
newStreamOn: aCollection
	^ self streamClass on: aCollection! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 9/16/2016 21:18'!
percentEncodedUTF8String
	^ self class percentEncodedUTF8String! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLStreamAdapter! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/10/2016 22:58'!
streamClass
	^ ReadStream! !

!XMLStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:19'!
streamCollection
	^ String new! !

!XMLStreamAdapterTest methodsFor: 'converting' stamp: 'monty 2/14/2016 04:02'!
stringFrom: aCollection
	^ self class stringFrom: aCollection! !

!XMLStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testClose
	self
		shouldnt: [self newStreamAdapter close]
		raise: Error! !

!XMLStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testIsBinary
	self deny: self newStreamAdapter isBinary! !

!XMLStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testIsStream
	self assert: self newStreamAdapter isStream! !

!XMLStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/1/2016 00:55'!
testIsXMLConvertingStreamAdapter
	self deny: self newStreamAdapter isXMLConvertingStreamAdapter! !

!XMLStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/6/2016 08:28'!
testOn
	| stream adapter |

	stream := self newStream.
	adapter := self newStreamAdapterOn: stream.
	self
		assert: adapter class == self streamAdapterClass;
		assert: adapter stream == stream.! !

XMLStreamAdapterTest subclass: #XMLWriteStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLWriteStreamAdapterTest subclass: #XMLEncodingWriteStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

XMLEncodingWriteStreamAdapterTest subclass: #XMLEncodingWriteStreamAdapterByteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLEncodingWriteStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:13'!
inputCollection
	^ self decodedByteString! !

!XMLEncodingWriteStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ self invalidInputCollections! !

!XMLEncodingWriteStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 9/18/2016 12:13'!
outputCollection
	^ self encodedByteString! !

!XMLEncodingWriteStreamAdapterByteTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:28'!
streamConverterClass
	^ XMLByteStreamConverter! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:12'!
invalidInputCollections
	"code points greater than U+10FFFF aren't tested for because Characters on GS
	can only contain values in the range of 0-10FFFF"
	^ Array
		with: (String with: 16rD800 asCharacter) "first surrogate code point"
		with: (String with: 16rDFFF asCharacter) "last surrogate code point"! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ #()! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 3/5/2016 12:39'!
newStreamAdapterOn: aStream
	^ (super newStreamAdapterOn: aStream)
		streamConverter: self streamConverterClass new! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLEncodingWriteStreamAdapter! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:26'!
streamConverterClass
	^ XMLNullStreamConverter! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 16:09'!
testHasDefaultStreamConverter
	| adapter |

	adapter := self newStreamAdapter.
	self assert:
		adapter hasDefaultStreamConverter = adapter streamConverter isDefault.! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 9/18/2016 12:05'!
testHasNullStreamConverter
	| adapter |

	adapter := self newStreamAdapter.
	self assert: adapter hasNullStreamConverter = adapter streamConverter isNull.! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/27/2017 19:14'!
testInvalidCharacters
	self invalidStreamCollections do: [:each | | streamAdapter |
		streamAdapter := self newStreamAdapter.
		self
			should: [streamAdapter nextPutAll: each]
			raise: XMLEncodingException].! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/1/2016 00:55'!
testIsXMLConvertingStreamAdapter
	self assert: self newStreamAdapter isXMLConvertingStreamAdapter! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testNextPutByteOrderMark
	| adapter |

	adapter := self newStreamAdapter.
	self
		assert: adapter nextPutByteOrderMark == adapter;
		assert: adapter contents = self streamConverterClass byteOrderMark.! !

!XMLEncodingWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testStreamConverter
	| adapter newConverter |

	adapter := self newStreamAdapter.
	self
		deny: adapter streamConverter isNil;
		assert: adapter streamConverter class == self streamConverterClass.

	newConverter := self streamConverterClass new.
	self
		assert: (adapter streamConverter: newConverter) == adapter;
		assert: adapter streamConverter == newConverter.

	self
		assert: (adapter streamConverter: nil) == adapter;
		assert: adapter streamConverter class == XMLNullStreamConverter.! !

XMLEncodingWriteStreamAdapterTest subclass: #XMLEncodingWriteStreamAdapterUTF16BETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLEncodingWriteStreamAdapterUTF16BETest methodsFor: 'converting' stamp: 'monty 9/16/2016 21:16'!
contentsFromCharacter: aCharacter
	^ self class asciiToUTF16BE: aCharacter asString! !

!XMLEncodingWriteStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 23:36'!
inputCollection
	^ self decodedUTF16String! !

!XMLEncodingWriteStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ self invalidInputCollections! !

!XMLEncodingWriteStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 23:36'!
outputCollection
	^ self encodedUTF16BEString! !

!XMLEncodingWriteStreamAdapterUTF16BETest methodsFor: 'accessing' stamp: 'monty 2/11/2016 23:36'!
streamConverterClass
	^ XMLUTF16BigEndianStreamConverter! !

XMLEncodingWriteStreamAdapterTest subclass: #XMLEncodingWriteStreamAdapterUTF16LETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLEncodingWriteStreamAdapterUTF16LETest methodsFor: 'converting' stamp: 'monty 9/16/2016 21:16'!
contentsFromCharacter: aCharacter
	^ self class asciiToUTF16LE: aCharacter asString! !

!XMLEncodingWriteStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:00'!
inputCollection
	^ self decodedUTF16String! !

!XMLEncodingWriteStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ self invalidInputCollections! !

!XMLEncodingWriteStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:01'!
outputCollection
	^ self encodedUTF16LEString! !

!XMLEncodingWriteStreamAdapterUTF16LETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:00'!
streamConverterClass
	^ XMLUTF16LittleEndianStreamConverter! !

XMLEncodingWriteStreamAdapterTest subclass: #XMLEncodingWriteStreamAdapterUTF32BETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLEncodingWriteStreamAdapterUTF32BETest methodsFor: 'converting' stamp: 'monty 9/16/2016 21:16'!
contentsFromCharacter: aCharacter
	^ self class asciiToUTF32BE: aCharacter asString! !

!XMLEncodingWriteStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:02'!
inputCollection
	^ self decodedUTF32String! !

!XMLEncodingWriteStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ self invalidInputCollections! !

!XMLEncodingWriteStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:03'!
outputCollection
	^ self encodedUTF32BEString! !

!XMLEncodingWriteStreamAdapterUTF32BETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:02'!
streamConverterClass
	^ XMLUTF32BigEndianStreamConverter! !

XMLEncodingWriteStreamAdapterTest subclass: #XMLEncodingWriteStreamAdapterUTF32LETest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLEncodingWriteStreamAdapterUTF32LETest methodsFor: 'converting' stamp: 'monty 9/16/2016 21:16'!
contentsFromCharacter: aCharacter
	^ self class asciiToUTF32LE: aCharacter asString! !

!XMLEncodingWriteStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:02'!
inputCollection
	^ self decodedUTF32String! !

!XMLEncodingWriteStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ self invalidInputCollections! !

!XMLEncodingWriteStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:03'!
outputCollection
	^ self encodedUTF32LEString! !

!XMLEncodingWriteStreamAdapterUTF32LETest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:02'!
streamConverterClass
	^ XMLUTF32LittleEndianStreamConverter! !

XMLEncodingWriteStreamAdapterTest subclass: #XMLEncodingWriteStreamAdapterUTF8Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLEncodingWriteStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:03'!
inputCollection
	^ self decodedUTF8String! !

!XMLEncodingWriteStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ self invalidInputCollections! !

!XMLEncodingWriteStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:03'!
outputCollection
	^ self encodedUTF8String! !

!XMLEncodingWriteStreamAdapterUTF8Test methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:04'!
streamConverterClass
	^ XMLUTF8StreamConverter! !

XMLEncodingWriteStreamAdapterTest subclass: #XMLPercentEncodingWriteStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLPercentEncodingWriteStreamAdapterTest methodsFor: 'converting' stamp: 'monty 9/16/2016 21:19'!
contentsFromCharacter: aCharacter
	^ self class percentEncodeCharacter: aCharacter! !

!XMLPercentEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:05'!
inputCollection
	^ self decodedUTF8String! !

!XMLPercentEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 4/27/2017 19:15'!
invalidStreamCollections
	^ self invalidInputCollections! !

!XMLPercentEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:05'!
outputCollection
	^ self percentEncodedUTF8String! !

!XMLPercentEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLPercentEncodingWriteStreamAdapter! !

!XMLPercentEncodingWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/12/2016 00:05'!
streamConverterClass
	^ XMLUTF8StreamConverter! !

!XMLPercentEncodingWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testNextPutByteOrderMark
	self
		should: [self newStreamAdapter nextPutByteOrderMark]
		raise: Error! !

!XMLWriteStreamAdapterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:23'!
isAbstract
	^ false! !

!XMLWriteStreamAdapterTest methodsFor: 'converting' stamp: 'monty 2/12/2016 06:00'!
contentsFromCharacter: aCharacter
	^ aCharacter asString! !

!XMLWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:20'!
inputCollection
	^ 'test'! !

!XMLWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:20'!
outputCollection
	^ 'test'! !

!XMLWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:38'!
streamAdapterClass
	^ XMLWriteStreamAdapter! !

!XMLWriteStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 2/11/2016 22:22'!
streamClass
	^ WriteStream! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/5/2016 06:43'!
testCR
	| adapter |

	adapter := self newStreamAdapter.
	self
		assert: adapter cr = Character cr;
		assert: adapter contents = (self contentsFromCharacter: Character cr).! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/5/2016 06:43'!
testLF
	| adapter |

	adapter := self newStreamAdapter.
	self
		assert: adapter lf = Character lf;
		assert: adapter contents = (self contentsFromCharacter: Character lf).! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 12/3/2016 02:27'!
testNextPut
	| adapter |

	adapter := self newStreamAdapter.
	self inputCollection do: [:each |
		"use #= because wide chars aren't #== pre-Spur"
		self assert: (adapter nextPut: each) = each].
	self assert: adapter contents = self outputCollection.! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testNextPutAll
	| adapter |

	adapter := self newStreamAdapter.
	self
		assert: (adapter nextPutAll: self inputCollection) = self inputCollection;
		assert: adapter contents = self outputCollection.! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testPosition
	| adapter startPosition position |

	adapter := self newStreamAdapter.
	startPosition := adapter position. "1 or 0 depending on the stream on GS"
	position := startPosition.
	self inputCollection do: [:each |
		adapter nextPut: each.
		self assert: adapter position > position.
		position := adapter position].

	adapter position: startPosition.
	self assert: adapter position = startPosition.! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:39'!
testReset
	| adapter startPosition |

	adapter := self newStreamAdapter.
	startPosition := adapter position. "1 or 0 depending on the stream on GS"
	adapter nextPutAll: self inputCollection.
	self
		assert: adapter reset == adapter;
		assert: adapter position = startPosition.! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/5/2016 06:43'!
testSpace
	| adapter |

	adapter := self newStreamAdapter.
	self
		assert: adapter space = Character space;
		assert: adapter contents = (self contentsFromCharacter: Character space).! !

!XMLWriteStreamAdapterTest methodsFor: 'tests' stamp: 'monty 4/5/2016 06:43'!
testTab
	| adapter |

	adapter := self newStreamAdapter.
	self
		assert: adapter tab = Character tab;
		assert: adapter contents = (self contentsFromCharacter: Character tab).! !

TestCase subclass: #XMLStreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLStreamConverterTest commentStamp: 'monty 9/18/2016 10:12' prior: 0!
Abstract, do not run.!

XMLStreamConverterTest subclass: #XMLByteStreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLByteStreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:11'!
isAbstract
	^ false! !

!XMLByteStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:43'!
streamConverterClass
	^ XMLByteStreamConverter! !

XMLStreamConverterTest subclass: #XMLNullStreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLNullStreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:12'!
isAbstract
	^ false! !

!XMLNullStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:43'!
streamConverterClass
	^ XMLNullStreamConverter! !

!XMLNullStreamConverterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:43'!
testIsNull
	self assert: self newStreamConverter isNull! !

!XMLStreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:11'!
isAbstract
	^ true! !

!XMLStreamConverterTest class methodsFor: 'testing' stamp: 'monty 3/5/2016 12:50'!
shouldInheritSelectors
	^ true! !

!XMLStreamConverterTest methodsFor: 'accessing' stamp: 'monty 9/20/2017 14:14'!
caseInvertedEncodingNameFrom: anEncodingName
	| shouldUppercase |

	^ anEncodingName collect: [:each |
		(shouldUppercase ifNil: [shouldUppercase := each isLowercase])
			ifTrue: [
				shouldUppercase := false.
				each asUppercase]
			ifFalse: [
				shouldUppercase := true.
				each asLowercase]]! !

!XMLStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 16:17'!
encodingNames
	^ self streamConverterClass encodingNames! !

!XMLStreamConverterTest methodsFor: 'accessing' stamp: 'monty 9/20/2017 14:17'!
encodingNamesWithCaseInversions
	| encodingNamesWithCaseInversions |

	encodingNamesWithCaseInversions := self encodingNames copy.
	self encodingNames do: [:each |
		"add the case inversion, as well as its inversion"
		encodingNamesWithCaseInversions add:
			(self caseInvertedEncodingNameFrom:
				(encodingNamesWithCaseInversions add:
					(self caseInvertedEncodingNameFrom: each)))].
	^ encodingNamesWithCaseInversions.! !

!XMLStreamConverterTest methodsFor: 'instance creation' stamp: 'monty 3/5/2016 12:40'!
newStreamConverter
	^ self streamConverterClass new! !

!XMLStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:40'!
streamConverterClass
	^ XMLStreamConverter! !

!XMLStreamConverterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 16:30'!
testAsXMLStreamConverter
	| streamConverter |

	streamConverter := self newStreamConverter.
	self assert: streamConverter asXMLStreamConverter == streamConverter.! !

!XMLStreamConverterTest methodsFor: 'tests' stamp: 'monty 9/20/2017 14:20'!
testCanConvertEncoding
	self encodingNamesWithCaseInversions do: [:each |
		self assert: (self streamConverterClass canConvertEncoding: each)].
	self unconvertableEncodingNames do: [:each |
		self deny: (self streamConverterClass canConvertEncoding: each)].! !

!XMLStreamConverterTest methodsFor: 'tests' stamp: 'monty 9/20/2017 14:17'!
testEncoding
	self encodingNamesWithCaseInversions do: [:each | | streamConverter |
		streamConverter := XMLStreamConverter newForEncoding: each.
		self assert: streamConverter class == self streamConverterClass.
		self assert:
			streamConverter encoding =
				self streamConverterClass primaryEncodingName]! !

!XMLStreamConverterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:41'!
testIsDefault
	self deny: self newStreamConverter isDefault! !

!XMLStreamConverterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:41'!
testIsNull
	self deny: self newStreamConverter isNull! !

!XMLStreamConverterTest methodsFor: 'accessing' stamp: 'monty 9/20/2017 14:19'!
unconvertableEncodingNames
	^ #('unconvertableEncodingName')! !

XMLStreamConverterTest subclass: #XMLUTF16BigEndianStreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLUTF16BigEndianStreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:11'!
isAbstract
	^ false! !

!XMLUTF16BigEndianStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:46'!
streamConverterClass
	^ XMLUTF16BigEndianStreamConverter! !

XMLStreamConverterTest subclass: #XMLUTF16LittleEndianStreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLUTF16LittleEndianStreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:12'!
isAbstract
	^ false! !

!XMLUTF16LittleEndianStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:46'!
streamConverterClass
	^ XMLUTF16LittleEndianStreamConverter! !

XMLStreamConverterTest subclass: #XMLUTF32BigEndianStreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLUTF32BigEndianStreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:12'!
isAbstract
	^ false! !

!XMLUTF32BigEndianStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:47'!
streamConverterClass
	^ XMLUTF32BigEndianStreamConverter! !

XMLStreamConverterTest subclass: #XMLUTF32LittleEndianStreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLUTF32LittleEndianStreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:12'!
isAbstract
	^ false! !

!XMLUTF32LittleEndianStreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:46'!
streamConverterClass
	^ XMLUTF32LittleEndianStreamConverter! !

XMLStreamConverterTest subclass: #XMLUTF8StreamConverterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLUTF8StreamConverterTest class methodsFor: 'testing' stamp: 'monty 9/18/2016 10:12'!
isAbstract
	^ false! !

!XMLUTF8StreamConverterTest methodsFor: 'accessing' stamp: 'monty 3/5/2016 12:44'!
streamConverterClass
	^ XMLUTF8StreamConverter! !

!XMLUTF8StreamConverterTest methodsFor: 'tests' stamp: 'monty 3/5/2016 12:50'!
testIsDefault
	self assert: self newStreamConverter isDefault! !

TestCase subclass: #XMLStringMethodsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLStringMethodsTest class methodsFor: 'accessing' stamp: 'monty 3/24/2016 21:43'!
badNCNames
	"all NC (non-qualified) names are names, but not all names are NC names"
	^ self badNames, self nonNCNameNames! !

!XMLStringMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/6/2017 00:01'!
badNames
	"all names are Nmtokens, but not all Nmtokens are names"
	^ self badNmtokens, self nonNameNmtokens! !

!XMLStringMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/3/2017 22:53'!
badNmtokens
	^ #('' ' ' '	'),
		(XMLCharacterMethodsTest nonNameChars collect: [:each |
			'test' copyWith: each])! !

!XMLStringMethodsTest class methodsFor: 'accessing' stamp: 'monty 3/24/2016 21:43'!
nonNCNameNames
	^ #(':' 'test:test' 'test:' ':test')! !

!XMLStringMethodsTest class methodsFor: 'accessing' stamp: 'monty 5/3/2017 22:55'!
nonNameNmtokens
	^ XMLCharacterMethodsTest nonNameStartCharNameChars collect: [:each |
		'test' copyWithFirst: each]! !

!XMLStringMethodsTest methodsFor: 'accessing' stamp: 'monty 3/24/2016 21:43'!
badNCNames
	^ self class badNCNames! !

!XMLStringMethodsTest methodsFor: 'accessing' stamp: 'monty 3/24/2016 21:43'!
badNames
	^ self class badNames! !

!XMLStringMethodsTest methodsFor: 'accessing' stamp: 'monty 3/24/2016 21:43'!
badNmtokens
	^ self class badNmtokens! !

!XMLStringMethodsTest methodsFor: 'accessing' stamp: 'monty 3/24/2016 21:43'!
nonNCNameNames
	^ self class nonNCNameNames! !

!XMLStringMethodsTest methodsFor: 'accessing' stamp: 'monty 3/24/2016 21:43'!
nonNameNmtokens
	^ self class nonNameNmtokens! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 2/15/2016 23:37'!
testAsXMLEscapedString
	self assert:
		'<test name="&name;">''&value;''</test>' asXMLEscapedString =
			'&lt;test name="&amp;name;"&gt;''&amp;value;''&lt;/test&gt;'! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 9/22/2016 16:40'!
testAsXMLFileHandle
	XMLFileHandle hasSupportedImplementation
		ifTrue: [| path fileHandle |
			path := 'test.xml'.
			fileHandle := path asXMLFileHandle.
			self
				assert: fileHandle class == XMLFileHandle implementation;
				assert: fileHandle path = path]! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 9/22/2016 16:40'!
testAsXMLHTTPRequest
	XMLHTTPRequest hasSupportedImplementation
		ifTrue: [| url request |
			url := 'test.xml'.
			request := url asXMLHTTPRequest.
			self
				assert: request class == XMLHTTPRequest implementation;
				assert: request url = url]! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 3/5/2016 16:20'!
testAsXMLStreamConverter
	XMLStreamConverter allSubclassesDo: [:class |
		class encodingNames do: [:each |
			self assert: each asXMLStreamConverter class == class]]! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 8/5/2016 16:39'!
testAsXMLStringNode
	| node |

	node := 'test' asXMLStringNode.
	self
		assert: node class == XMLString;
		assert: node string = 'test'.! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 4/1/2016 07:15'!
testIsXMLNCName
	self badNCNames do: [:each |
		self deny: each isXMLNCName]! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 6/24/2016 00:45'!
testIsXMLNSAttributeName
	self
		deny: '' isXMLNSAttributeName;
		deny: 'name' isXMLNSAttributeName;
		deny: 'name:xml' isXMLReservedAttributeName;
		deny: 'name:xmlns' isXMLReservedAttributeName;
		deny: 'xml:base' isXMLNSAttributeName;
		deny: 'xml:space' isXMLNSAttributeName;
		assert: 'xmlns' isXMLNSAttributeName;
		assert: 'xmlns:' isXMLNSAttributeName;
		assert: 'xmlns:name' isXMLNSAttributeName! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 3/24/2016 21:44'!
testIsXMLName
	self nonNCNameNames do: [:each |
		self assert: each isXMLName].
	self badNames do: [:each |
		self deny: each isXMLName].! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 3/24/2016 21:44'!
testIsXMLNmtoken
	self nonNCNameNames do: [:each |
		self assert: each isXMLNmtoken].
	self nonNameNmtokens do: [:each |
		self assert: each isXMLNmtoken].
	self badNmtokens do: [:each |
		self deny: each isXMLNmtoken].! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 6/23/2016 20:06'!
testIsXMLQualifiedOrLocalName
	self
		deny: ('' isXMLQualifiedOrLocalName: 'name');
		deny: ('' isXMLQualifiedOrLocalName: 'prefix:name');
		assert: ('name' isXMLQualifiedOrLocalName: 'name');
		assert: ('prefix:name' isXMLQualifiedOrLocalName: 'name');
		assert: ('prefix:name' isXMLQualifiedOrLocalName: 'prefix:name');
		deny: ('name' isXMLQualifiedOrLocalName: 'different');
		deny: ('name' isXMLQualifiedOrLocalName: 'prefix:name');
		deny: ('prefix:name' isXMLQualifiedOrLocalName: 'prefix:different');
		deny: ('prefix:name' isXMLQualifiedOrLocalName: 'different:name').

	"test wide char equality (redundant on Spur, but should remain as long
	as Cog and older VMs are supported)"
	self assert:
		((String with: 256 asCharacter)
			isXMLQualifiedOrLocalName:
				(String with: 256 asCharacter)).
	self assert:
		((String with: 16r039A asCharacter with: $: with: 16r039B asCharacter)
			isXMLQualifiedOrLocalName:
				(String with: 16r039B asCharacter)).! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 6/23/2016 20:01'!
testIsXMLReservedAttributeName
	self
		deny: '' isXMLReservedAttributeName;
		deny: 'name' isXMLReservedAttributeName;
		deny: 'name:xml' isXMLReservedAttributeName;
		deny: 'name:xmlns' isXMLReservedAttributeName;
		assert: 'xml:base' isXMLReservedAttributeName;
		assert: 'xml:space' isXMLReservedAttributeName;
		assert: 'xmlns' isXMLReservedAttributeName;
		assert: 'xmlns:' isXMLReservedAttributeName;
		assert: 'xmlns:name' isXMLReservedAttributeName! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 3/7/2016 20:11'!
testParseXML
	| xml |

	xml := XMLParserTest addressBookXML.
	self assert: xml parseXML printString = (XMLDOMParser parse: xml) printString.! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 4/1/2016 01:01'!
testXMLLocalNameAfterPrefix
	self
		assert: 'name' xmlLocalNameAfterPrefix = 'name';
		assert: ':name' xmlLocalNameAfterPrefix = ':name';
		assert: 'prefix:name' xmlLocalNameAfterPrefix = 'name';
		assert: '::name' xmlLocalNameAfterPrefix = 'name';
		assert: 'invalid:prefix:name' xmlLocalNameAfterPrefix = 'name';
		assert: ':::name' xmlLocalNameAfterPrefix = 'name';
		assert: ':invalid:prefix:name' xmlLocalNameAfterPrefix = 'name'.! !

!XMLStringMethodsTest methodsFor: 'tests' stamp: 'monty 4/1/2016 01:02'!
testXMLPrefixBeforeLocalName
	self
		assert: 'name' xmlPrefixBeforeLocalName = '';
		assert: ':name' xmlPrefixBeforeLocalName = '';
		assert: 'prefix:name' xmlPrefixBeforeLocalName = 'prefix';
		assert: '::name' xmlPrefixBeforeLocalName = ':';
		assert: 'invalid:prefix:name' xmlPrefixBeforeLocalName = 'invalid:prefix';
		assert: ':::name' xmlPrefixBeforeLocalName = '::';
		assert: ':invalid:prefix:name' xmlPrefixBeforeLocalName = ':invalid:prefix'.! !

TestCase subclass: #XMLURITest
	instanceVariableNames: 'asciiCharacters reservedCharacters unreservedCharacters percentEncodedASCIICharacters percentEncodedReservedCharacters percentEncodedAlphaNumericCharacters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-URI'!

!XMLURITest class methodsFor: 'private' stamp: 'monty 3/22/2015 03:15'!
generateStandardURICombiningTest
	"self generateStandardURICombiningTest"
	| readStream isFirstTest source |

	readStream := self standardURICombiningTestTemplate readStream.
	isFirstTest := true.
	source :=
		String streamContents: [:writeStream |
			writeStream nextPutAll: 'testStandardURICombining
	| baseURI |

	baseURI := ''', self standardURICombiningTestBaseURI, ''' asXMLURI.
	self'.
			[readStream atEnd]
				whileFalse: [| argument result |
					readStream skipTo: $".
					argument := readStream upTo: $".
					readStream skipTo: $".
					result := readStream upTo: $".
					(argument isEmpty and: [result isEmpty])
						ifFalse: [
							isFirstTest
								ifTrue: [isFirstTest := false]
								ifFalse: [writeStream nextPut: $;].
							writeStream nextPutAll: '
		assert: (baseURI / ''', argument, ''' asXMLURI) = ''', result, ''' asXMLURI']]].

	self
		compile: source
		classified: 'tests'.! !

!XMLURITest class methodsFor: 'private' stamp: 'monty 2/9/2015 07:06'!
standardURICombiningTestBaseURI
	^ 'http://a/b/c/d;p?q'! !

!XMLURITest class methodsFor: 'private' stamp: 'monty 2/9/2015 07:06'!
standardURICombiningTestTemplate
	^ '
      "g:h"           =  "g:h"
      "g"             =  "http://a/b/c/g"
      "./g"           =  "http://a/b/c/g"
      "g/"            =  "http://a/b/c/g/"
      "/g"            =  "http://a/g"
      "//g"           =  "http://g"
      "?y"            =  "http://a/b/c/d;p?y"
      "g?y"           =  "http://a/b/c/g?y"
      "#s"            =  "http://a/b/c/d;p?q#s"
      "g#s"           =  "http://a/b/c/g#s"
      "g?y#s"         =  "http://a/b/c/g?y#s"
      ";x"            =  "http://a/b/c/;x"
      "g;x"           =  "http://a/b/c/g;x"
      "g;x?y#s"       =  "http://a/b/c/g;x?y#s"
      ""              =  "http://a/b/c/d;p?q"
      "."             =  "http://a/b/c/"
      "./"            =  "http://a/b/c/"
      ".."            =  "http://a/b/"
      "../"           =  "http://a/b/"
      "../g"          =  "http://a/b/g"
      "../.."         =  "http://a/"
      "../../"        =  "http://a/"
      "../../g"       =  "http://a/g"

      "../../../g"    =  "http://a/g"
      "../../../../g" =  "http://a/g"


      "/./g"          =  "http://a/g"
      "/../g"         =  "http://a/g"
      "g."            =  "http://a/b/c/g."
      ".g"            =  "http://a/b/c/.g"
      "g.."           =  "http://a/b/c/g.."
      "..g"           =  "http://a/b/c/..g"

      "./../g"        =  "http://a/b/g"
      "./g/."         =  "http://a/b/c/g/"
      "g/./h"         =  "http://a/b/c/g/h"
      "g/../h"        =  "http://a/b/c/h"
      "g;x=1/./y"     =  "http://a/b/c/g;x=1/y"
      "g;x=1/../y"    =  "http://a/b/c/y"

      "g?y/./x"       =  "http://a/b/c/g?y/./x"
      "g?y/../x"      =  "http://a/b/c/g?y/../x"
      "g#s/./x"       =  "http://a/b/c/g#s/./x"
      "g#s/../x"      =  "http://a/b/c/g#s/../x"

      "http:g"        =  "http:g"
'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absolute
	^ '/absolute/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absoluteDir
	^ '/absolute/path/'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absoluteDirRelativeCombined
	^ '/absolute/path/relative/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/6/2016 02:46'!
absoluteDirRelativeCombinedSegments
	^ #('' 'absolute' 'path' 'relative' 'path') asOrderedCollection! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/6/2016 02:46'!
absoluteDirSegments
	^ #('' 'absolute' 'path' '') asOrderedCollection! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
absoluteRelativeCombined
	^ '/absolute/relative/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/6/2016 02:47'!
absoluteRelativeCombinedSegments
	^ #('' 'absolute' 'relative' 'path') asOrderedCollection! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/6/2016 02:46'!
absoluteSegments
	^ #('' 'absolute' 'path') asOrderedCollection! !

!XMLURITest methodsFor: 'enumerating' stamp: 'monty 1/13/2016 06:39'!
allURIStringsDo: aBlock
	aBlock
		value: '';
		value: '/';
		value: self absolute;
		value: self absoluteDir;
		value: self absoluteDirRelativeCombined;
		value: self absoluteRelativeCombined;
		value: self domainURIString;
		value: self domainURIWithPortString;
		value: self emailURIString;
		value: self fileURIWithHostString;
		value: self fileURIString;
		value: self fragmentURIString;
		value: self fullURIString;
		value: self fullURIWithPortString;
		value: self queryURIString;
		value: self relative;
		value: self relativeAbsoluteCombined;
		value: self schemelessURIString;
		value: self schemelessURIWithPortString! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/11/2016 08:12'!
alphaNumericCharacters
	^ 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 3/30/2016 21:43'!
asciiCharacters
	asciiCharacters ifNil: [
		asciiCharacters :=
			String streamContents: [:stream |
				"0 is ignored for GS compatibility, because it uses it as a string
				terminator"
				1 to: 127 do: [:i |
					stream nextPut: i asCharacter]]].
	^ asciiCharacters.! !

!XMLURITest methodsFor: 'asserting' stamp: 'monty 1/7/2016 03:22'!
assertURI: aFirstURI atHostEquals: aSecondURI
	self assert: aFirstURI host = aSecondURI host.
	self
		assertURI: aFirstURI
		atPortEquals: aSecondURI.! !

!XMLURITest methodsFor: 'asserting' stamp: 'monty 1/7/2016 03:23'!
assertURI: aFirstURI atPathEquals: aSecondURI
	self assert: aFirstURI pathSegments = aSecondURI pathSegments.
	self
		assertURI: aFirstURI
		atQueryEquals: aSecondURI.! !

!XMLURITest methodsFor: 'asserting' stamp: 'monty 1/7/2016 03:23'!
assertURI: aFirstURI atPortEquals: aSecondURI
	self assert: aFirstURI port = aSecondURI port.
	self
		assertURI: aFirstURI
		atPathEquals: aSecondURI.! !

!XMLURITest methodsFor: 'asserting' stamp: 'monty 1/7/2016 03:24'!
assertURI: aFirstURI atQueryEquals: aSecondURI
	self
		assert: aFirstURI query = aSecondURI query;
		assert: aFirstURI fragment = aSecondURI fragment! !

!XMLURITest methodsFor: 'asserting' stamp: 'monty 1/7/2016 03:22'!
assertURI: aFirstURI atUserInfoEquals: aSecondURI
	self  assert: aFirstURI userInfo = aSecondURI userInfo.
	self
		assertURI: aFirstURI
		atHostEquals: aSecondURI.! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2016 05:18'!
domainURIString
	^ 'http://www.example.com'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2016 05:18'!
domainURIWithPortString
	^ self domainURIString, ':80'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/5/2016 06:17'!
emailURIString
	^ 'mailto:userName@', self host! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
fileURIString
	^ 'file://', self absolute! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2016 05:19'!
fileURIWithHostString
	^ 'file://', self host, self absolute! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/13/2016 06:38'!
fragment
	^ self fragmentURIString allButFirst! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/13/2016 06:31'!
fragmentURIString
	^ '#fragmentID'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/13/2016 06:39'!
fullURIString
	^ self domainURIString, self absolute, self queryURIString, self fragmentURIString! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/13/2016 06:39'!
fullURIWithPortString
	^ self domainURIWithPortString, self absolute, self queryURIString, self fragmentURIString! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2016 05:18'!
host
	^ self domainURIString copyAfterLast: $/! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/11/2016 08:13'!
nonPercentEncodedPathCharacters
	^ self unreservedCharacters, self subDelimiterCharacters, ':@'! !

!XMLURITest methodsFor: 'converting' stamp: 'monty 3/28/2016 01:20'!
percentEncodeCharacter: aCharacter
	^ XMLStreamAdapterTest percentEncodeCharacter: aCharacter! !

!XMLURITest methodsFor: 'converting' stamp: 'monty 4/15/2017 03:29'!
percentEncodeCharacters: aCharacterCollection
	^ String streamContents: [:stream |
		aCharacterCollection do: [:each |
			stream nextPutAll:
				(self percentEncodeCharacter: each)]]! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 4/15/2017 03:29'!
percentEncodedASCIICharacters
	^ percentEncodedASCIICharacters
		ifNil: [
			percentEncodedASCIICharacters :=
				self percentEncodeCharacters: self asciiCharacters]! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 4/15/2017 03:29'!
percentEncodedAlphaNumericCharacters
	^ percentEncodedAlphaNumericCharacters
		ifNil: [
			percentEncodedAlphaNumericCharacters :=
				self percentEncodeCharacters: self alphaNumericCharacters]! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 3/30/2016 21:48'!
percentEncodedReservedCharacters
	percentEncodedReservedCharacters ifNil: [
		percentEncodedReservedCharacters :=
			String streamContents: [:stream |
				self reservedCharacters do: [:each |
					stream nextPutAll: (self percentEncodeCharacter: each)]]].
	^ percentEncodedReservedCharacters.! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 2/11/2017 23:41'!
query
	^ OrderedCollection
		with: 'name1' -> 'value1'
		with: 'name2' -> 'value2'
		with: 'name1' -> 'value3'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 2/11/2017 23:42'!
queryURIString
	^ '?name1=value1&name2=value2&name1=value3'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/8/2014 18:17'!
relative
	^ 'relative/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 2/9/2015 00:47'!
relativeAbsoluteCombined
	^ 'relative/absolute/path'! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/6/2016 02:50'!
relativeAbsoluteCombinedSegments
	^ #('relative' 'absolute' 'path') asOrderedCollection! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/6/2016 02:50'!
relativeSegments
	^ #('relative' 'path') asOrderedCollection! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 3/30/2016 21:41'!
reservedCharacters
	reservedCharacters
		ifNil: [
			reservedCharacters :=
				String streamContents: [:stream |
					self asciiCharacters do: [:each |
						(self unreservedCharacters includes: each)
							ifFalse: [stream nextPut: each]]]].
	^ reservedCharacters.! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/13/2016 06:39'!
schemelessURIString
	^ (self domainURIString copyAfter: $:), self absolute, self queryURIString, self fragmentURIString! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/13/2016 06:39'!
schemelessURIWithPortString
	^ (self domainURIWithPortString copyAfter: $:), self absolute, self queryURIString, self fragmentURIString! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 1/11/2016 08:13'!
subDelimiterCharacters
	^ '!!$&''()*+,;='! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/22/2016 16:39'!
testAsRetrievableResource
	(XMLFileHandle hasSupportedImplementation
		and: [XMLHTTPRequest hasSupportedImplementation])
		ifFalse: [^ self].

	self allURIStringsDo: [:each | | uri retrievableResource |
		uri := each asXMLURI.
		retrievableResource := uri asRetrievableResource.
		uri isLocalURI
			ifTrue: [
				self
					assert: retrievableResource class == XMLFileHandle implementation;
					assert: retrievableResource path = uri path]
			ifFalse: [
				self
					assert: retrievableResource class == XMLHTTPRequest implementation;
					assert: retrievableResource url = uri printString]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/7/2016 04:23'!
testAsString
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		self assert: uri asString = uri printString]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/5/2016 23:54'!
testAsXMLURI
	self allURIStringsDo: [:each | | uri |
		uri := XMLURI fromString: each.
		self
			assert: uri class == XMLURI;
			assert: uri uriString = each;
			assert: uri asXMLURI == uri]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 11:39'!
testCombining
	self allURIStringsDo: [:uriString | | uri |
		uri := uriString asXMLURI.
		self allURIStringsDo: [:uriStringToCombineWith | | uriToCombineWith combinedURI |
			uriToCombineWith := uriStringToCombineWith asXMLURI.
			combinedURI := uri / uriToCombineWith.
			uriToCombineWith isRelative
				ifTrue: [
					self assert: combinedURI scheme = uri scheme.
					uriToCombineWith hasUserInfo
						ifTrue: [
							self
								assertURI: combinedURI
								atUserInfoEquals: uriToCombineWith]
						ifFalse: [
							self assert: combinedURI userInfo = uri userInfo.
							uriToCombineWith hasHost
								ifTrue: [
									self
										assertURI: combinedURI
										atHostEquals: uriToCombineWith]
								ifFalse: [
									self assert: combinedURI host = uri host.
									uriToCombineWith hasPort
										ifTrue: [
											self
												assertURI: combinedURI
												atPortEquals: uriToCombineWith]
										ifFalse: [
											self assert: combinedURI port = uri port.
											uriToCombineWith hasPath
												ifTrue: [
													uriToCombineWith hasAbsolutePath
														ifTrue: [
															self
																assertURI: combinedURI
																atPathEquals: uriToCombineWith]
														ifFalse: [self deny: combinedURI = uri path]]
												ifFalse: [
													self assert: combinedURI pathSegments = uri pathSegments.
													uriToCombineWith hasQuery
														ifTrue: [
															self
																assertURI: combinedURI
																atQueryEquals: uriToCombineWith]
														ifFalse: [
															self assert: combinedURI query = uri query.
															uriToCombineWith hasFragment
																ifTrue: [
																	self assert:
																		combinedURI fragment =
																			uriToCombineWith fragment]
																ifFalse: [
																	self assert:
																		combinedURI fragment =
																			uri fragment]]]]]].
					uriToCombineWith isEmpty
						ifTrue: [self assert: combinedURI == uri]
						ifFalse: [self deny: combinedURI == uri]]
				ifFalse: [
					"if the arg was an absolute URI, it should have been returned"
					self assert: combinedURI == uriToCombineWith].
			"receiver and arg should be unchanged by combining"
			self
				assert: uri = uriString asXMLURI;
				assert: uriToCombineWith = uriStringToCombineWith asXMLURI]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 05:18'!
testCombiningAbsoluteURIs
	| domainURI fullURI fileURI |

	domainURI := self domainURIString asXMLURI.
	fullURI := self fullURIString asXMLURI.
	fileURI := self fileURIString asXMLURI.
	self
		assert: domainURI / self fullURIString = fullURI;
		assert: domainURI / self domainURIString = domainURI;
		assert: domainURI / self fileURIString = fileURI;
		assert: fullURI / self fullURIString = fullURI;
		assert: fullURI / self domainURIString = domainURI;
		assert: fullURI / self fileURIString = fileURI;
		assert: fileURI / self fullURIString = fullURI;
		assert: fileURI / self domainURIString = domainURI;
		assert: fileURI / self fileURIString = fileURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 05:18'!
testCombiningDotPathURIs
	| relativePathURI absolutePathURI fullURI |

	relativePathURI := self relative asXMLURI.
	self
		assert: relativePathURI / '.' = 'relative/' asXMLURI;
		assert: relativePathURI / './.' = 'relative/' asXMLURI;
		assert: relativePathURI / './path' = relativePathURI;
		assert: relativePathURI / ('.' , self absolute) = self relativeAbsoluteCombined asXMLURI.

	absolutePathURI := self absolute asXMLURI.
	self
		assert: absolutePathURI / '.' = '/absolute/' asXMLURI;
		assert: absolutePathURI / './.' = '/absolute/' asXMLURI;
		assert: absolutePathURI / './path' = absolutePathURI;
		assert: absolutePathURI / ('./' , self relative) = self absoluteRelativeCombined asXMLURI.

	fullURI := self fullURIString asXMLURI.
	self
		assert: fullURI / '.' = (self domainURIString , '/absolute/') asXMLURI;
		assert: fullURI / './.' = (self domainURIString , '/absolute/') asXMLURI;
		assert: fullURI / './path' = (self domainURIString , self absolute) asXMLURI;
		assert: fullURI / ('./' , self relative) = (self domainURIString , self absoluteRelativeCombined) asXMLURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 05:18'!
testCombiningDoubleDotPathURIs
	| relativePathURI absolutePathURI fullURI |

	relativePathURI := self relative asXMLURI.
	self
		assert: (relativePathURI / '..') isEmpty;
		assert: (relativePathURI / '../..') isEmpty;
		assert: relativePathURI / ('..' , self absolute) = 'absolute/path' asXMLURI;
		assert: relativePathURI / ('../..' , self absolute) = 'absolute/path' asXMLURI;
		assert: relativePathURI / ('../..' , self absolute , '/..') = 'absolute/' asXMLURI;
		assert: (relativePathURI / ('../..' , self absolute , '/../..')) isEmpty.

	absolutePathURI := self absolute asXMLURI.
	self
		assert: (absolutePathURI / '..') hasRootPath;
		assert: (absolutePathURI / '../..') isEmpty;
		assert: absolutePathURI / ('..' , self absolute) = absolutePathURI;
		assert: absolutePathURI / ('../..' , self absolute) = 'absolute/path' asXMLURI;
		assert: absolutePathURI / ('../..' , self absolute , '/..') = 'absolute/' asXMLURI;
		assert: (absolutePathURI / ('../..' , self absolute , '/../..')) isEmpty.

	fullURI := self fullURIString asXMLURI.
	self
		assert: (fullURI / '..') hasRootPath;
		deny: (fullURI / '../..') hasPath;
		assert: fullURI / ('..' , self absolute) = (self domainURIString , self absolute) asXMLURI;
		assert: fullURI / ('../..' , self absolute) = (self domainURIString , self absolute) asXMLURI;
		assert: fullURI / ('../..' , self absolute , '/..') = (self domainURIString , '/absolute/') asXMLURI;
		assert: fullURI / ('../..' , self absolute , '/../') = (self domainURIString , '/absolute/') asXMLURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testCombiningRelativeURIs
	| domainURI domainURIWithPort absolutePathURI absoluteDirPathURI |

	domainURI := self domainURIString asXMLURI.
	domainURIWithPort := self domainURIWithPortString asXMLURI.
	absolutePathURI := (self domainURIString , self absolute) asXMLURI.
	absoluteDirPathURI := (self domainURIString , self absoluteDir) asXMLURI.
	self
		assert: domainURI / self relative = (self domainURIString , '/' , self relative) asXMLURI;
		assert: domainURI / self absolute = (self domainURIString , self absolute) asXMLURI;
		assert: domainURI / self absoluteDir = (self domainURIString , self absoluteDir) asXMLURI;
		assert: domainURIWithPort / self relative = (self domainURIWithPortString , '/' , self relative) asXMLURI;
		assert: domainURIWithPort / self absolute = (self domainURIWithPortString , self absolute) asXMLURI;
		assert: domainURIWithPort / self absoluteDir = (self domainURIWithPortString , self absoluteDir) asXMLURI;
		assert: absolutePathURI / self relative = (self domainURIString , self absoluteRelativeCombined) asXMLURI;
		assert: absoluteDirPathURI / self relative = (self domainURIString , self absoluteDirRelativeCombined) asXMLURI;
		assert: absolutePathURI / self queryURIString = (self domainURIString , self absolute , self queryURIString) asXMLURI;
		assert: absolutePathURI / self fragmentURIString = (self domainURIString , self absolute , self fragmentURIString) asXMLURI;
		assert: domainURI / self schemelessURIString = self fullURIString asXMLURI.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/4/2016 08:07'!
testCopy
	self allURIStringsDo: [:each | | uri copy |
		uri := each asXMLURI.
		copy := uri copy.
		self
			assert: uri uriString = each;
			assert: copy uriString isNil;
			assert: uri = each asXMLURI;
			deny: uri == copy;
			assert: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			assert: uri userInfo = copy userInfo;
			assert: uri host = copy host;
			assert: uri port = copy port;
			assert: uri pathSegments = copy pathSegments;
			assert: uri query = copy query;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/6/2016 18:40'!
testCopyWithFragment
	self allURIStringsDo: [:each | | uri oldFragment newFragment copy |
		uri := each asXMLURI.
		oldFragment := uri fragment.
		newFragment := oldFragment, 'new'.
		copy := uri copyWithFragment: newFragment.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			assert: uri userInfo = copy userInfo;
			assert: uri host = copy host;
			assert: uri port = copy port;
			assert: uri pathSegments = copy pathSegments;
			assert: uri query = copy query;
			deny: uri fragment = copy fragment;
			assert: uri fragment = oldFragment;
			assert: copy fragment = newFragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/6/2016 18:40'!
testCopyWithHost
	self allURIStringsDo: [:each | | uri oldHost newHost copy |
		uri := each asXMLURI.
		oldHost := uri host.
		newHost := oldHost, 'new'.
		copy := uri copyWithHost: newHost.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			assert: uri userInfo = copy userInfo;
			deny: uri host = copy host;
			assert: uri host = oldHost;
			assert: copy host = newHost;
			assert: uri port = copy port;
			assert: uri pathSegments = copy pathSegments;
			assert: uri query = copy query;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/12/2016 07:28'!
testCopyWithPath
	self allURIStringsDo: [:each | | uri oldPath newPath copy |
		uri := each asXMLURI.
		oldPath := uri path.
		newPath := oldPath, '/new'.
		copy := uri copyWithPath: newPath.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			assert: uri userInfo = copy userInfo;
			assert: uri host = copy host;
			assert: uri port = copy port;
			deny: uri path = copy path;
			assert: uri path = oldPath;
			assert: copy path = newPath;
			assert: uri query = copy query;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/30/2016 22:18'!
testCopyWithPathSegments
	self allURIStringsDo: [:each | | uri oldPathSegments oldRawPathSegments newPathSegments newRawPathSegments copy |
		uri := each asXMLURI.
		oldPathSegments := uri pathSegments.
		oldRawPathSegments := uri rawPathSegments.
		newPathSegments := oldPathSegments copyWith: 'new', self reservedCharacters.
		newRawPathSegments :=
			oldRawPathSegments copyWith: 'new', self percentEncodedReservedCharacters.
		copy := uri copyWithPathSegments: newPathSegments.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			assert: uri userInfo = copy userInfo;
			assert: uri host = copy host;
			assert: uri port = copy port;
			deny: uri pathSegments = copy pathSegments;
			deny: uri rawPathSegments = copy rawPathSegments;
			assert: uri pathSegments = oldPathSegments;
			assert: uri rawPathSegments = oldRawPathSegments;
			assert: copy pathSegments = newPathSegments;
			assert: copy rawPathSegments = newRawPathSegments;
			assert: uri query = copy query;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/6/2016 18:41'!
testCopyWithPort
	self allURIStringsDo: [:each | | uri oldPort newPort copy |
		uri := each asXMLURI.
		oldPort := uri port.
		newPort := (oldPort ifNil: [0]) + 1.
		copy := uri copyWithPort: newPort.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			assert: uri userInfo = copy userInfo;
			assert: uri host = copy host;
			deny: uri port = copy port;
			assert: uri port = oldPort;
			assert: copy port = newPort;
			assert: uri pathSegments = copy pathSegments;
			assert: uri query = copy query;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 08:16'!
testCopyWithQuery
	self allURIStringsDo: [:each |
		| uri oldQuery oldRawQuery newQuery newRawQuery copy |
		uri := each asXMLURI.
		oldQuery := uri query.
		oldRawQuery := uri rawQuery.
		newQuery :=
			oldQuery copyWith:
				('newKey', self reservedCharacters) ->
					('newValue', self reservedCharacters).
		newRawQuery :=
			oldRawQuery copyWith:
				('newKey', self percentEncodedReservedCharacters) ->
					('newValue', self percentEncodedReservedCharacters).
		copy := uri copyWithQuery: newQuery.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			assert: uri userInfo = copy userInfo;
			assert: uri host = copy host;
			assert: uri port = copy port;
			assert: uri pathSegments = copy pathSegments;
			deny: uri query = copy query;
			deny: uri rawQuery = copy rawQuery;
			assert: uri query = oldQuery;
			assert: uri rawQuery = oldRawQuery;
			assert: copy query = newQuery;
			assert: copy rawQuery = newRawQuery;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:40'!
testCopyWithScheme
	self allURIStringsDo: [:each | | uri oldScheme oldHasAuthorityPrefix newScheme copy |
		uri := each asXMLURI.
		oldScheme := uri scheme.
		oldHasAuthorityPrefix := uri hasAuthorityPrefix.
		newScheme := oldScheme, 'new'.
		copy := uri copyWithScheme: newScheme.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			deny: uri scheme = copy scheme;
			assert: uri scheme = oldScheme;
			assert: copy scheme = newScheme;
			assert: uri hasAuthorityPrefix = oldHasAuthorityPrefix.
		"If the original had no scheme and no // prefix, then the copy should
		gain one. Otherwise it should only have one if the original did."
		(oldScheme = ''
			and: [oldHasAuthorityPrefix not])
			ifTrue: [self assert: copy hasAuthorityPrefix]
			ifFalse: [self assert: copy hasAuthorityPrefix = oldHasAuthorityPrefix].
		self
			assert: uri userInfo = copy userInfo;
			assert: uri host = copy host;
			assert: uri port = copy port;
			assert: uri pathSegments = copy pathSegments;
			assert: uri query = copy query;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/30/2016 22:13'!
testCopyWithUserInfo
	self allURIStringsDo: [:each | | uri oldUserInfo oldRawUserInfo newUserInfo newRawUserInfo copy |
		uri := each asXMLURI.
		oldUserInfo := uri userInfo.
		oldRawUserInfo := uri rawUserInfo.
		newUserInfo := oldUserInfo, 'new', self reservedCharacters.
		newRawUserInfo := oldUserInfo, 'new', self percentEncodedReservedCharacters.
		copy := uri copyWithUserInfo: newUserInfo.
		self
			assert: uri = each asXMLURI;
			assert: uri uriString = each;
			assert: copy uriString isNil;
			deny: uri == copy;
			deny: uri = copy;
			assert: uri scheme = copy scheme;
			assert: uri hasAuthorityPrefix = copy hasAuthorityPrefix;
			deny: uri userInfo = copy userInfo;
			deny: uri rawUserInfo = copy rawUserInfo;
			assert: uri userInfo = oldUserInfo;
			assert: uri rawUserInfo = oldRawUserInfo;
			assert: copy userInfo = newUserInfo;
			assert: copy rawUserInfo = newRawUserInfo;
			assert: uri host = copy host;
			assert: uri port = copy port;
			assert: uri pathSegments = copy pathSegments;
			assert: uri query = copy query;
			assert: uri fragment = copy fragment]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testDefaultAuthorityPrefixPrinting
	| uri copy |

	uri := '' asXMLURI.

	copy := uri copyWithUserInfo: 'userInfo'.
	self assert: copy printString = ('//userInfo@').

	copy := uri copyWithHost: self host.
	self assert: copy printString = ('//', self host).

	copy := uri copyWithPort: 80.
	self assert: copy printString = '//:80'.

	copy := uri copyWithPath: self relative.
	self assert: copy printString = self relative.

	copy := uri copyWithPath: self absolute.
	self assert: copy printString = self absolute.

	copy := uri copyWithQuery: self query.
	self assert: copy printString = self queryURIString.

	copy := uri copyWithFragment: self fragment.
	self assert: copy printString = self fragmentURIString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testDefaultPathPrefixPrinting
	| uri copy |

	uri := self relative asXMLURI.

	copy := uri copyWithUserInfo: 'userInfo'.
	self assert: copy printString = ('//userInfo@/', self relative).

	copy := uri copyWithHost: self host.
	self assert: copy printString = ('//', self host, '/', self relative).

	copy := uri copyWithPort: 80.
	self assert: copy printString = ('//:80/', self relative).

	copy := uri copyWithScheme: 'http'.
	self assert: copy printString = ('http:///', self relative).

	copy := uri copyWithQuery: self query.
	self assert: copy printString = (self relative, self queryURIString).

	copy := uri copyWithFragment: self fragment.
	self assert: copy printString = (self relative, self fragmentURIString).! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/17/2016 15:15'!
testEquals
	self allURIStringsDo: [:each | | uri otherURI |
		uri := each asXMLURI.

		otherURI := each asXMLURI.
		self
			assert: uri = otherURI;
			assert: otherURI = uri.
		otherURI scheme: uri scheme, 'new'.
		self
			deny: uri = otherURI;
			deny: otherURI = uri.

		otherURI := each asXMLURI.
		self
			assert: uri = otherURI;
			assert: otherURI = uri.
		otherURI rawUserInfo: uri userInfo, 'new'.
		self
			deny: uri = otherURI;
			deny: otherURI = uri.

		otherURI := each asXMLURI.
		self
			assert: uri = otherURI;
			assert: otherURI = uri.
		otherURI rawHost: uri host, 'new'.
		self
			deny: uri = otherURI;
			deny: otherURI = uri.

		otherURI := each asXMLURI.
		self
			assert: uri = otherURI;
			assert: otherURI = uri.
		otherURI rawPathSegments: (uri pathSegments copyWith: 'new').
		self
			deny: uri = otherURI;
			deny: otherURI = uri.

		otherURI := each asXMLURI.
		self
			assert: uri = otherURI;
			assert: otherURI = uri.
		otherURI rawQuery:
			(uri query copy
				add: 'new' -> '';
				yourself).
		self
			deny: uri = otherURI;
			deny: otherURI = uri.

		otherURI := each asXMLURI.
		self
			assert: uri = otherURI;
			assert: otherURI = uri.
		otherURI rawFragment: uri fragment, 'new'.
		self
			deny: uri = otherURI;
			deny: otherURI = uri]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:37'!
testFragment
	self
		assert: '' asXMLURI fragment = '';
		assert: '/' asXMLURI fragment = '';
		assert: self absolute asXMLURI fragment = '';
		assert: self absoluteDir asXMLURI fragment = '';
		assert: self absoluteDirRelativeCombined asXMLURI fragment = '';
		assert: self absoluteRelativeCombined asXMLURI fragment = '';
		assert: self domainURIString asXMLURI fragment = '';
		assert: self domainURIWithPortString asXMLURI fragment = '';
		assert: self emailURIString asXMLURI fragment = '';
		assert: self fileURIWithHostString asXMLURI fragment = '';
		assert: self fileURIString asXMLURI fragment = '';
		assert: self fragmentURIString asXMLURI fragment = self fragment;
		assert: self fullURIString asXMLURI fragment = self fragment;
		assert: self fullURIWithPortString asXMLURI fragment = self fragment;
		assert: self queryURIString asXMLURI fragment = '';
		assert: self relative asXMLURI fragment = '';
		assert: self relativeAbsoluteCombined asXMLURI fragment = '';
		assert: self schemelessURIString asXMLURI fragment = self fragment;
		assert: self schemelessURIWithPortString asXMLURI fragment = self fragment! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:08'!
testFragmentNonPercentEncodedCharacters
	| fragment uriString uri |

	fragment := self nonPercentEncodedPathCharacters , '/?'.
	uriString := '#', fragment.
	uri := uriString asXMLURI.
	self
		assert: uri fragment = fragment;
		assert: uri rawFragment = fragment.
	
	uri uriString: nil.
	self assert: uri printString = uriString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:08'!
testFragmentPercentEncodedCharacters
	| encoded decoded encodedURIString uri |

	encoded := self percentEncodedASCIICharacters, '+'.
	decoded := self asciiCharacters, '+'.
	encodedURIString := '#', encoded.
	uri := encodedURIString asXMLURI.
	self
		assert: uri fragment = decoded;
		assert: uri rawFragment = encoded.

	uri uriString: nil.
	self assert: uri printString = encodedURIString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/15/2016 13:30'!
testFromStream
	self allURIStringsDo: [:each | | stream uri |
		stream := each readStream.
		uri := XMLURI fromStream: stream.
		self
			assert: uri class == XMLURI;
			assert: uri uriString isNil;
			assert: uri = each asXMLURI;
			assert: stream atEnd]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/5/2016 09:19'!
testFromString
	self allURIStringsDo: [:each | | uri |
		uri := XMLURI fromString: each.
		self
			assert: uri class == XMLURI;
			assert: uri uriString = each;
			assert: uri = each asXMLURI]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasAbsolutePath
	self
		deny: '' asXMLURI hasAbsolutePath;
		assert: '/' asXMLURI hasAbsolutePath;
		assert: self absolute asXMLURI hasAbsolutePath;
		assert: self absoluteDir asXMLURI hasAbsolutePath;
		assert: self absoluteDirRelativeCombined asXMLURI hasAbsolutePath;
		assert: self absoluteRelativeCombined asXMLURI hasAbsolutePath;
		deny: self domainURIString asXMLURI hasAbsolutePath;
		deny: self domainURIWithPortString asXMLURI hasAbsolutePath;
		deny: self emailURIString asXMLURI hasAbsolutePath;
		assert: self fileURIWithHostString asXMLURI hasAbsolutePath;
		assert: self fileURIString asXMLURI hasAbsolutePath;
		deny: self fragmentURIString asXMLURI hasAbsolutePath;
		assert: self fullURIString asXMLURI hasAbsolutePath;
		assert: self fullURIWithPortString asXMLURI hasAbsolutePath;
		deny: self queryURIString asXMLURI hasAbsolutePath;
		deny: self relative asXMLURI hasAbsolutePath;
		deny: self relativeAbsoluteCombined asXMLURI hasAbsolutePath;
		assert: self schemelessURIString asXMLURI hasAbsolutePath;
		assert: self schemelessURIWithPortString asXMLURI hasAbsolutePath! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasAuthority
	self
		deny: '' asXMLURI hasAuthority;
		deny: '/' asXMLURI hasAuthority;
		deny: self absolute asXMLURI hasAuthority;
		deny: self absoluteDir asXMLURI hasAuthority;
		deny: self absoluteDirRelativeCombined asXMLURI hasAuthority;
		deny: self absoluteRelativeCombined asXMLURI hasAuthority;
		assert: self domainURIString asXMLURI hasAuthority;
		assert: self domainURIWithPortString asXMLURI hasAuthority;
		assert: self emailURIString asXMLURI hasAuthority;
		assert: self fileURIWithHostString asXMLURI hasAuthority;
		deny: self fileURIString asXMLURI hasAuthority;
		deny: self fragmentURIString asXMLURI hasAuthority;
		assert: self fullURIString asXMLURI hasAuthority;
		assert: self fullURIWithPortString asXMLURI hasAuthority;
		deny: self queryURIString asXMLURI hasAuthority;
		deny: self relative asXMLURI hasAuthority;
		deny: self relativeAbsoluteCombined asXMLURI hasAuthority;
		assert: self schemelessURIString asXMLURI hasAuthority;
		assert: self schemelessURIWithPortString asXMLURI hasAuthority! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasAuthorityPrefix
	self
		deny: '' asXMLURI hasAuthorityPrefix;
		deny: '/' asXMLURI hasAuthorityPrefix;
		deny: self absolute asXMLURI hasAuthorityPrefix;
		deny: self absoluteDir asXMLURI hasAuthorityPrefix;
		deny: self absoluteDirRelativeCombined asXMLURI hasAuthorityPrefix;
		deny: self absoluteRelativeCombined asXMLURI hasAuthorityPrefix;
		assert: self domainURIString asXMLURI hasAuthorityPrefix;
		assert: self domainURIWithPortString asXMLURI hasAuthorityPrefix;
		deny: self emailURIString asXMLURI hasAuthorityPrefix;
		assert: self fileURIWithHostString asXMLURI hasAuthorityPrefix;
		assert: self fileURIString asXMLURI hasAuthorityPrefix;
		deny: self fragmentURIString asXMLURI hasAuthorityPrefix;
		assert: self fullURIString asXMLURI hasAuthorityPrefix;
		assert: self fullURIWithPortString asXMLURI hasAuthorityPrefix;
		deny: self queryURIString asXMLURI hasAuthorityPrefix;
		deny: self relative asXMLURI hasAuthorityPrefix;
		deny: self relativeAbsoluteCombined asXMLURI hasAuthorityPrefix;
		assert: self schemelessURIString asXMLURI hasAuthorityPrefix;
		assert: self schemelessURIWithPortString asXMLURI hasAuthorityPrefix! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasDirectoryPath
	self
		deny: '' asXMLURI hasDirectoryPath;
		assert: '/' asXMLURI hasDirectoryPath;
		deny: self absolute asXMLURI hasDirectoryPath;
		assert: self absoluteDir asXMLURI hasDirectoryPath;
		deny: self absoluteDirRelativeCombined asXMLURI hasDirectoryPath;
		deny: self absoluteRelativeCombined asXMLURI hasDirectoryPath;
		deny: self domainURIString asXMLURI hasDirectoryPath;
		deny: self domainURIWithPortString asXMLURI hasDirectoryPath;
		deny: self emailURIString asXMLURI hasDirectoryPath;
		deny: self fileURIWithHostString asXMLURI hasDirectoryPath;
		deny: self fileURIString asXMLURI hasDirectoryPath;
		deny: self fragmentURIString asXMLURI hasDirectoryPath;
		deny: self fullURIString asXMLURI hasDirectoryPath;
		deny: self fullURIWithPortString asXMLURI hasDirectoryPath;
		deny: self queryURIString asXMLURI hasDirectoryPath;
		deny: self relative asXMLURI hasDirectoryPath;
		deny: self relativeAbsoluteCombined asXMLURI hasDirectoryPath;
		deny: self schemelessURIString asXMLURI hasDirectoryPath;
		deny: self schemelessURIWithPortString asXMLURI hasDirectoryPath! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 12:17'!
testHasFragment
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		(each includes: $#)
			ifTrue: [self assert: uri hasFragment]
			ifFalse: [self deny: uri hasFragment]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasHost
	self
		deny: '' asXMLURI hasHost;
		deny: '/' asXMLURI hasHost;
		deny: self absolute asXMLURI hasHost;
		deny: self absoluteDir asXMLURI hasHost;
		deny: self absoluteDirRelativeCombined asXMLURI hasHost;
		deny: self absoluteRelativeCombined asXMLURI hasHost;
		assert: self domainURIString asXMLURI hasHost;
		assert: self domainURIWithPortString asXMLURI hasHost;
		assert: self emailURIString asXMLURI hasHost;
		assert: self fileURIWithHostString asXMLURI hasHost;
		deny: self fileURIString asXMLURI hasHost;
		deny: self fragmentURIString asXMLURI hasHost;
		assert: self fullURIString asXMLURI hasHost;
		assert: self fullURIWithPortString asXMLURI hasHost;
		deny: self queryURIString asXMLURI hasHost;
		deny: self relative asXMLURI hasHost;
		deny: self relativeAbsoluteCombined asXMLURI hasHost;
		assert: self schemelessURIString asXMLURI hasHost;
		assert: self schemelessURIWithPortString asXMLURI hasHost! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasNonDirectoryPath
	self
		deny: '' asXMLURI hasNonDirectoryPath;
		deny: '/' asXMLURI hasNonDirectoryPath;
		assert: self absolute asXMLURI hasNonDirectoryPath;
		deny: self absoluteDir asXMLURI hasNonDirectoryPath;
		assert: self absoluteDirRelativeCombined asXMLURI hasNonDirectoryPath;
		assert: self absoluteRelativeCombined asXMLURI hasNonDirectoryPath;
		deny: self domainURIString asXMLURI hasNonDirectoryPath;
		deny: self domainURIWithPortString asXMLURI hasNonDirectoryPath;
		deny: self emailURIString asXMLURI hasNonDirectoryPath;
		assert: self fileURIWithHostString asXMLURI hasNonDirectoryPath;
		assert: self fileURIString asXMLURI hasNonDirectoryPath;
		deny: self fragmentURIString asXMLURI hasNonDirectoryPath;
		assert: self fullURIString asXMLURI hasNonDirectoryPath;
		assert: self fullURIWithPortString asXMLURI hasNonDirectoryPath;
		deny: self queryURIString asXMLURI hasNonDirectoryPath;
		assert: self relative asXMLURI hasNonDirectoryPath;
		assert: self relativeAbsoluteCombined asXMLURI hasNonDirectoryPath;
		assert: self schemelessURIString asXMLURI hasNonDirectoryPath;
		assert: self schemelessURIWithPortString asXMLURI hasNonDirectoryPath! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasPath
	self
		deny: '' asXMLURI hasPath;
		assert: '/' asXMLURI hasPath;
		assert: self absolute asXMLURI hasPath;
		assert: self absoluteDir asXMLURI hasPath;
		assert: self absoluteDirRelativeCombined asXMLURI hasPath;
		assert: self absoluteRelativeCombined asXMLURI hasPath;
		deny: self domainURIString asXMLURI hasPath;
		deny: self domainURIWithPortString asXMLURI hasPath;
		deny: self emailURIString asXMLURI hasPath;
		assert: self fileURIWithHostString asXMLURI hasPath;
		assert: self fileURIString asXMLURI hasPath;
		deny: self fragmentURIString asXMLURI hasPath;
		assert: self fullURIString asXMLURI hasPath;
		assert: self fullURIWithPortString asXMLURI hasPath;
		deny: self queryURIString asXMLURI hasPath;
		assert: self relative asXMLURI hasPath;
		assert: self relativeAbsoluteCombined asXMLURI hasPath;
		assert: self schemelessURIString asXMLURI hasPath;
		assert: self schemelessURIWithPortString asXMLURI hasPath! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasPort
	self
		deny: '' asXMLURI hasPort;
		deny: '/' asXMLURI hasPort;
		deny: self absolute asXMLURI hasPort;
		deny: self absoluteDir asXMLURI hasPort;
		deny: self absoluteDirRelativeCombined asXMLURI hasPort;
		deny: self absoluteRelativeCombined asXMLURI hasPort;
		deny: self domainURIString asXMLURI hasPort;
		assert: self domainURIWithPortString asXMLURI hasPort;
		deny: self emailURIString asXMLURI hasPort;
		deny: self fileURIWithHostString asXMLURI hasPort;
		deny: self fileURIString asXMLURI hasPort;
		deny: self fragmentURIString asXMLURI hasPort;
		deny: self fullURIString asXMLURI hasPort;
		assert: self fullURIWithPortString asXMLURI hasPort;
		deny: self queryURIString asXMLURI hasPort;
		deny: self relative asXMLURI hasPort;
		deny: self relativeAbsoluteCombined asXMLURI hasPort;
		deny: self schemelessURIString asXMLURI hasPort;
		assert: self schemelessURIWithPortString asXMLURI hasPort! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 12:15'!
testHasQuery
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		(each includes: $?)
			ifTrue: [self assert: uri hasQuery]
			ifFalse: [self deny: uri hasQuery]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/5/2016 08:01'!
testHasRootPath
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		each = '/'
			ifTrue: [self assert: uri hasRootPath]
			ifFalse: [self deny: uri hasRootPath]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testHasScheme
	self
		deny: '' asXMLURI hasScheme;
		deny: '/' asXMLURI hasScheme;
		deny: self absolute asXMLURI hasScheme;
		deny: self absoluteDir asXMLURI hasScheme;
		deny: self absoluteDirRelativeCombined asXMLURI hasScheme;
		deny: self absoluteRelativeCombined asXMLURI hasScheme;
		assert: self domainURIString asXMLURI hasScheme;
		assert: self domainURIWithPortString asXMLURI hasScheme;
		assert: self emailURIString asXMLURI hasScheme;
		assert: self fileURIWithHostString asXMLURI hasScheme;
		assert: self fileURIString asXMLURI hasScheme;
		deny: self fragmentURIString asXMLURI hasScheme;
		assert: self fullURIString asXMLURI hasScheme;
		assert: self fullURIWithPortString asXMLURI hasScheme;
		deny: self queryURIString asXMLURI hasScheme;
		deny: self relative asXMLURI hasScheme;
		deny: self relativeAbsoluteCombined asXMLURI hasScheme;
		deny: self schemelessURIString asXMLURI hasScheme;
		deny: self schemelessURIWithPortString asXMLURI hasScheme! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 12:14'!
testHasUserInfo
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		uri scheme = 'mailto'
			ifTrue: [self assert: uri hasUserInfo]
			ifFalse: [self deny: uri hasUserInfo]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/19/2016 10:07'!
testHash
	"We can only safely test that equal objects have the same hash; testing
	that different objects have different hashes would be unreliable
	because #hash is non-cryptographic and has collisions."
	self allURIStringsDo: [:each |
		self assert: each asXMLURI hash = each asXMLURI hash]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 4/15/2017 03:34'!
testHashPercentEncoding
	| uriTemplate unencodedURI encodedURI |

	uriTemplate :=
		'http://{1}@{1}:80/{1}/{1}?{1}={1}&{1}={1}#{1}'.
	unencodedURI :=
		(uriTemplate format:
			(Array with: self alphaNumericCharacters)) asXMLURI.
	encodedURI :=
		(uriTemplate format:
			(Array with: self percentEncodedAlphaNumericCharacters)) asXMLURI.
	self assert: unencodedURI hash = unencodedURI hash.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:38'!
testHost
	self
		assert: '' asXMLURI host = '';
		assert: '/' asXMLURI host = '';
		assert: self absolute asXMLURI host = '';
		assert: self absoluteDir asXMLURI host = '';
		assert: self absoluteDirRelativeCombined asXMLURI host = '';
		assert: self absoluteRelativeCombined asXMLURI host = '';
		assert: self domainURIString asXMLURI host = self host;
		assert: self domainURIWithPortString asXMLURI host = self host;
		assert: self emailURIString asXMLURI host = self host;
		assert: self fileURIWithHostString asXMLURI host = self host;
		assert: self fileURIString asXMLURI host = '';
		assert: self fragmentURIString asXMLURI host = '';
		assert: self fullURIString asXMLURI host = self host;
		assert: self fullURIWithPortString asXMLURI host = self host;
		assert: self queryURIString asXMLURI host = '';
		assert: self relative asXMLURI host = '';
		assert: self relativeAbsoluteCombined asXMLURI host = '';
		assert: self schemelessURIString asXMLURI host = self host;
		assert: self schemelessURIWithPortString asXMLURI host = self host! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:07'!
testHostNonPercentEncodedCharacters
	| host uriString uri |

	host := self unreservedCharacters, self subDelimiterCharacters.
	uriString := 'http://', host.
	uri := uriString asXMLURI.
	self
		assert: uri scheme = 'http';
		assert: uri host = host asLowercase;
		assert: uri rawHost = host.

	uri uriString: nil.
	self assert: uri printString = uriString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:18'!
testHostPercentEncodedCharacters
	| prefix encoded decoded encodedURIString uri |

	prefix := 'http://'.
	encoded := self percentEncodedASCIICharacters, '+'.
	decoded := self asciiCharacters, '+'.
	encodedURIString := prefix, encoded.
	uri := encodedURIString asXMLURI.
	self
		assert: uri scheme = 'http';
		assert: uri host = decoded asLowercase;
		assert: uri rawHost = encoded.

	uri uriString: nil.
	self assert: uri printString = encodedURIString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:38'!
testIPv6Hosts
	| ipv6Host uriString uri |

	ipv6Host := '[FEDC:BA98:7654:3210:FEDC:BA98:7654:3210]'.
	uriString := 'http://', ipv6Host, ':80', self absolute.
	uri := uriString asXMLURI.
	self
		assert: uri scheme = 'http';
		assert: uri host = ipv6Host;
		assert: uri port = 80;
		assert: uri path = self absolute;
		assert: uri query isEmpty;
		assert: uri fragment = ''.
	uri uriString: nil.
	self assert: uri printString = uriString.

	uriString := 'http://', ipv6Host, self absolute.
	uri := uriString asXMLURI.
	self
		assert: uri scheme = 'http';
		assert: uri host = ipv6Host;
		assert: uri port isNil;
		assert: uri path = self absolute;
		assert: uri query isEmpty;
		assert: uri fragment = ''.
	uri uriString: nil.
	self assert: uri printString = uriString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testInvalidPort
	| uri |

	uri := (self domainURIString, ':invalid', self absolute) asXMLURI.
	self
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri path = self absolute.

	uri := (self domainURIString, ':invalid', self queryURIString) asXMLURI.
	self
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri pathSegments isEmpty.

	uri := (self domainURIString, ':invalid', self fragmentURIString) asXMLURI.
	self
		assert: uri host = self host;
		assert: uri port isNil;
		assert: uri pathSegments isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testInvalidPortSuffix
	| uri |

	uri := (self domainURIWithPortString, 'invalid', self absolute) asXMLURI.
	self
		assert: uri host = self host;
		assert: uri port = 80;
		assert: uri path = self absolute.

	uri := (self domainURIWithPortString, 'invalid', self queryURIString) asXMLURI.
	self
		assert: uri host = self host;
		assert: uri port = 80;
		assert: uri pathSegments isEmpty.

	uri := (self domainURIWithPortString, 'invalid', self fragmentURIString) asXMLURI.
	self
		assert: uri host = self host;
		assert: uri port = 80;
		assert: uri pathSegments isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:39'!
testIsEmpty
	| uri |

	self allURIStringsDo: [:each |
		uri := each asXMLURI.
		each = ''
			ifTrue: [self assert: uri isEmpty]
			ifFalse: [self deny: uri isEmpty].

		uri
			parseURIStringIfUnparsed;
			uriString: nil.
		each isEmpty
			ifTrue: [self assert: uri isEmpty]
			ifFalse: [self deny: uri isEmpty]].

	uri := '//:?#' asXMLURI.
	self assert: uri isEmpty.
	uri
		parseURIStringIfUnparsed;
		uriString: nil.
	self assert: uri isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/8/2016 12:13'!
testIsFileURI
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		uri scheme = 'file'
			ifTrue: [self assert: uri isFileURI]
			ifFalse: [self deny: uri isFileURI]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testIsLocalURI
	self
		assert: '' asXMLURI isLocalURI;
		assert: '/' asXMLURI isLocalURI;
		assert: self absolute asXMLURI isLocalURI;
		assert: self absoluteDir asXMLURI isLocalURI;
		assert: self absoluteDirRelativeCombined asXMLURI isLocalURI;
		assert: self absoluteRelativeCombined asXMLURI isLocalURI;
		deny: self domainURIString asXMLURI isLocalURI;
		deny: self domainURIWithPortString asXMLURI isLocalURI;
		deny: self emailURIString asXMLURI isLocalURI;
		assert: self fileURIWithHostString asXMLURI isLocalURI;
		assert: self fileURIString asXMLURI isLocalURI;
		assert: self fragmentURIString asXMLURI isLocalURI;
		deny: self fullURIString asXMLURI isLocalURI;
		deny: self fullURIWithPortString asXMLURI isLocalURI;
		assert: self queryURIString asXMLURI isLocalURI;
		assert: self relative asXMLURI isLocalURI;
		assert: self relativeAbsoluteCombined asXMLURI isLocalURI;
		deny: self schemelessURIString asXMLURI isLocalURI;
		deny: self schemelessURIWithPortString asXMLURI isLocalURI! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testIsRelative
	self
		assert: '' asXMLURI isRelative;
		assert: '/' asXMLURI isRelative;
		assert: self absolute asXMLURI isRelative;
		assert: self absoluteDir asXMLURI isRelative;
		assert: self absoluteDirRelativeCombined asXMLURI isRelative;
		assert: self absoluteRelativeCombined asXMLURI isRelative;
		deny: self domainURIString asXMLURI isRelative;
		deny: self domainURIWithPortString asXMLURI isRelative;
		deny: self emailURIString asXMLURI isRelative;
		deny: self fileURIWithHostString asXMLURI isRelative;
		deny: self fileURIString asXMLURI isRelative;
		assert: self fragmentURIString asXMLURI isRelative;
		deny: self fullURIString asXMLURI isRelative;
		deny: self fullURIWithPortString asXMLURI isRelative;
		assert: self queryURIString asXMLURI isRelative;
		assert: self relative asXMLURI isRelative;
		assert: self relativeAbsoluteCombined asXMLURI isRelative;
		assert: self schemelessURIString asXMLURI isRelative;
		assert: self schemelessURIWithPortString asXMLURI isRelative! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/4/2016 23:39'!
testNew
	| uri |

	uri := XMLURI new.
	self
		assert: uri uriString = '';
		assert: uri isEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/15/2016 13:32'!
testNotEmpty
	| uri |

	self allURIStringsDo: [:each |
		uri := each asXMLURI.
		each notEmpty
			ifTrue: [self assert: uri notEmpty]
			ifFalse: [self deny: uri notEmpty].

		uri
			parseURIStringIfUnparsed;
			uriString: nil.
		each notEmpty
			ifTrue: [self assert: uri notEmpty]
			ifFalse: [self deny: uri notEmpty]].

	uri := '//:?#' asXMLURI.
	self deny: uri notEmpty.
	uri
		parseURIStringIfUnparsed;
		uriString: nil.
	self deny: uri notEmpty.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 00:47'!
testParsingQueryString
	#('' '?' '?&' '?&&') do: [:each |
		self assert:
			each asXMLURI query =
				OrderedCollection new].

	#('?a=b' '?&a=b&' '?&&a=b&&') do: [:each |
		self assert:
			each asXMLURI query =
				(OrderedCollection with: 'a' -> 'b')].

	#('?=&a=b' '?&=&a=b' '?&&=&&a=b') do: [:each |
		self assert:
			each asXMLURI query =
				(OrderedCollection
					with: '' -> ''
					with: 'a' -> 'b')].

	#('?a=b&=' '?a=b&=&' '?a=b&&=&&') do: [:each |
		self assert:
			each asXMLURI query =
				(OrderedCollection
					with: 'a' -> 'b'
					with: '' -> '')].

	#('?c=&a=b' '?&c=&a=b' '?&&c=&&a=b') do: [:each |
		self assert:
			each asXMLURI query =
				(OrderedCollection
					with: 'c' -> ''
					with: 'a' -> 'b')].

	#('?a=b&c=' '?a=b&c=&' '?a=b&&c=&&') do: [:each |
		self assert:
			each asXMLURI query =
				(OrderedCollection
					with: 'a' -> 'b'
					with: 'c' -> '')].! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:39'!
testPath
	self
		assert: '' asXMLURI path = '';
		assert: '/' asXMLURI path = '/';
		assert: self absolute asXMLURI path = self absolute;
		assert: self absoluteDir asXMLURI path = self absoluteDir;
		assert: self absoluteDirRelativeCombined asXMLURI path = self absoluteDirRelativeCombined;
		assert: self absoluteRelativeCombined asXMLURI path = self absoluteRelativeCombined;
		assert: self domainURIString asXMLURI path = '';
		assert: self domainURIWithPortString asXMLURI path = '';
		assert: self emailURIString asXMLURI path = '';
		assert: self fileURIWithHostString asXMLURI path = self absolute;
		assert: self fileURIString asXMLURI path = self absolute;
		assert: self fragmentURIString asXMLURI path = '';
		assert: self fullURIString asXMLURI path = self absolute;
		assert: self fullURIWithPortString asXMLURI path = self absolute;
		assert: self queryURIString asXMLURI path = '';
		assert: self relative asXMLURI path = self relative;
		assert: self relativeAbsoluteCombined asXMLURI path = self relativeAbsoluteCombined;
		assert: self schemelessURIString asXMLURI path = self absolute;
		assert: self schemelessURIWithPortString asXMLURI path = self absolute! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:04'!
testPathNonPercentEncodedCharacters
	| firstSegment secondSegment uriString uri |

	firstSegment := self nonPercentEncodedPathCharacters copyWithout: $:.
	secondSegment := self nonPercentEncodedPathCharacters.
	uriString := firstSegment, '/', secondSegment.
	uri := uriString asXMLURI.
	self assert: uri path = (firstSegment, '/', secondSegment).
	self assert:
		uri pathSegments =
			(OrderedCollection with: firstSegment with: secondSegment).
	self assert:
		uri rawPathSegments =
			(OrderedCollection with: firstSegment with: secondSegment).

	uri uriString: nil.
	self assert: uri printString = uriString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:18'!
testPathPercentEncodedCharacters
	| encoded decoded encodedURIString uri |

	encoded := self percentEncodedASCIICharacters, '+'.
	decoded := self asciiCharacters, '+'.
	encodedURIString := encoded, '/', encoded.
	uri := encodedURIString asXMLURI.
	self assert: uri path = (decoded, '/', decoded).
	self assert:
		uri pathSegments = (OrderedCollection with: decoded with: decoded).
	self assert:
		uri rawPathSegments = (OrderedCollection with: encoded with: encoded).

	uri uriString: nil.
	self assert: uri printString = encodedURIString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testPathSegments
	self
		assert: '' asXMLURI pathSegments isEmpty;
		assert: '/' asXMLURI pathSegments = #('' '') asOrderedCollection;
		assert: self absolute asXMLURI pathSegments = self absoluteSegments;
		assert: self absoluteDir asXMLURI pathSegments = self absoluteDirSegments;
		assert: self absoluteDirRelativeCombined asXMLURI pathSegments = self absoluteDirRelativeCombinedSegments;
		assert: self absoluteRelativeCombined asXMLURI pathSegments = self absoluteRelativeCombinedSegments;
		assert: self domainURIString asXMLURI pathSegments isEmpty;
		assert: self domainURIWithPortString asXMLURI pathSegments isEmpty;
		assert: self emailURIString asXMLURI pathSegments isEmpty;
		assert: self fileURIWithHostString asXMLURI pathSegments = self absoluteSegments;
		assert: self fileURIString asXMLURI pathSegments = self absoluteSegments;
		assert: self fragmentURIString asXMLURI pathSegments isEmpty;
		assert: self fullURIString asXMLURI pathSegments = self absoluteSegments;
		assert: self fullURIWithPortString asXMLURI pathSegments = self absoluteSegments;
		assert: self queryURIString asXMLURI pathSegments isEmpty;
		assert: self relative asXMLURI pathSegments = self relativeSegments;
		assert: self relativeAbsoluteCombined asXMLURI pathSegments = self relativeAbsoluteCombinedSegments;
		assert: self schemelessURIString asXMLURI pathSegments = self absoluteSegments;
		assert: self schemelessURIWithPortString asXMLURI pathSegments = self absoluteSegments! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/6/2016 07:54'!
testPathSegmentsDo
	self allURIStringsDo: [:uriString | | uri visited |
		uri := uriString asXMLURI.
		visited := OrderedCollection new.
		uri pathSegmentsDo: [:each | visited addLast: each].
		self assert: visited = uri pathSegments]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testPort
	self
		assert: '' asXMLURI port isNil;
		assert: '/' asXMLURI port isNil;
		assert: self absolute asXMLURI port isNil;
		assert: self absoluteDir asXMLURI port isNil;
		assert: self absoluteDirRelativeCombined asXMLURI port isNil;
		assert: self absoluteRelativeCombined asXMLURI port isNil;
		assert: self domainURIString asXMLURI port isNil;
		assert: self domainURIWithPortString asXMLURI port = 80;
		assert: self emailURIString asXMLURI port isNil;
		assert: self fileURIWithHostString asXMLURI port isNil;
		assert: self fileURIString asXMLURI port isNil;
		assert: self fragmentURIString asXMLURI port isNil;
		assert: self fullURIString asXMLURI port isNil;
		assert: self fullURIWithPortString asXMLURI port = 80;
		assert: self queryURIString asXMLURI port isNil;
		assert: self relative asXMLURI port isNil;
		assert: self relativeAbsoluteCombined asXMLURI port isNil;
		assert: self schemelessURIString asXMLURI port isNil;
		assert: self schemelessURIWithPortString asXMLURI port = 80! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/6/2016 04:07'!
testPrintOn
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		self assert: uri printString = each.

		uri
			parseURIStringIfUnparsed;
			uriString: nil.
		self
			assert: uri uriString isNil;
			assert: uri printString = each;
			assert: uri uriString = each]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/13/2016 06:39'!
testQuery
	self
		assert: '' asXMLURI query isEmpty;
		assert: '/' asXMLURI query isEmpty;
		assert: self absolute asXMLURI query isEmpty;
		assert: self absoluteDir asXMLURI query isEmpty;
		assert: self absoluteDirRelativeCombined asXMLURI query isEmpty;
		assert: self absoluteRelativeCombined asXMLURI query isEmpty;
		assert: self domainURIString asXMLURI query isEmpty;
		assert: self domainURIWithPortString asXMLURI query isEmpty;
		assert: self emailURIString asXMLURI query isEmpty;
		assert: self fileURIWithHostString asXMLURI query isEmpty;
		assert: self fileURIString asXMLURI query isEmpty;
		assert: self fragmentURIString asXMLURI query isEmpty;
		assert: self fullURIString asXMLURI query = self query;
		assert: self fullURIWithPortString asXMLURI query = self query;
		assert: self queryURIString asXMLURI query = self query;
		assert: self relative asXMLURI query isEmpty;
		assert: self relativeAbsoluteCombined asXMLURI query isEmpty;
		assert: self schemelessURIString asXMLURI query = self query;
		assert: self schemelessURIWithPortString asXMLURI query = self query! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 08:11'!
testQueryAt
	self allURIStringsDo: [:uriString | | uri visitedKeys |
		uri := uriString asXMLURI.
		visitedKeys := Set new.
		uri query reverseDo: [:each |
			(visitedKeys includes: each key)
				ifFalse: [
					self assert:
						(uri queryAt: each key) = each value.
					visitedKeys add: each key]].
		self assert: (uri queryAt: 'absent') = '']! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 08:11'!
testQueryAtIfAbsent
	self allURIStringsDo: [:uriString | | uri visitedKeys |
		uri := uriString asXMLURI.
		visitedKeys := Set new.
		uri query reverseDo: [:each |
			(visitedKeys includes: each key)
				ifFalse: [
					self assert:
						(uri
							queryAt: each key
							ifAbsent: [self fail]) = each value.
					visitedKeys add: each key]].
		self assert:
			(uri
				queryAt: 'absentKey'
				ifAbsent: ['absentValue']) = 'absentValue']! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 00:48'!
testQueryIncludesKey
	self allURIStringsDo: [:uriString | | uri |
		uri := uriString asXMLURI.
		uri query do: [:each |
			self assert: (uri queryIncludesKey: each key)].
		self deny: (uri queryIncludesKey: 'absent')]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 00:49'!
testQueryKeys
	self allURIStringsDo: [:uriString | | uri uniqueQueryKeys |
		uri := uriString asXMLURI.
		uniqueQueryKeys := OrderedCollection new.
		uri query do: [:each |
			(uniqueQueryKeys includes: each key)
				ifFalse: [uniqueQueryKeys addLast: each key]].
		self assert: uri queryKeys = uniqueQueryKeys]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 01:14'!
testQueryKeysAndValuesDo
	self allURIStringsDo: [:each | | uri visited |
		uri := each asXMLURI.
		visited := OrderedCollection new.
		self assert:
			(uri queryKeysAndValuesDo: [:key :value |
				visited addLast: key -> value]) == uri.
		self assert: visited = uri query]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 01:14'!
testQueryKeysDo
	self allURIStringsDo: [:uriString | | uri visited |
		uri := uriString asXMLURI.
		visited := OrderedCollection new.
		self assert:
			(uri queryKeysDo: [:each |
				visited addLast: each]) == uri.
		self assert: visited = uri queryKeys]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:23'!
testQueryNonPercentOrPlusEncodedCharacters
	| queryKey queryValue uriString uri |

	queryKey :=
		(self nonPercentEncodedPathCharacters copyWithoutAll: '=&+'), '/?'.
	queryValue :=
		(self nonPercentEncodedPathCharacters copyWithoutAll: '&+'), '/?'.
	uriString := '?', queryKey, '=', queryValue.
	uri := uriString asXMLURI.
	self
		assert: uri query = (OrderedCollection with: queryKey -> queryValue);
		assert: (uri queryAt: queryKey) = queryValue;
		assert:
			(uri
				queryAt: queryKey
				ifAbsent: ['absent']) = queryValue;
		assert:
			(uri queryValuesAt: queryKey) = (OrderedCollection with: queryValue);
		assert:
			(uri
				queryValuesAt: queryKey
				ifAbsent: [#('absent')]) = (OrderedCollection with: queryValue);
		assert: uri queryKeys = (OrderedCollection with: queryKey);
		assert: (uri queryIncludesKey: queryKey);
		assert: uri rawQuery = (OrderedCollection with: queryKey -> queryValue).

	uri uriString: nil.
	self assert: uri printString = uriString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:22'!
testQueryPercentOrPlusEncodedCharacters
	| encoded decoded encodedURIString uri |

	encoded := self percentEncodedASCIICharacters, '+'.
	decoded := self asciiCharacters, ' '.
	encodedURIString := '?', encoded, '=', encoded.
	uri := encodedURIString asXMLURI.
	self
		assert: uri query = (OrderedCollection with: decoded -> decoded);
		assert: (uri queryAt: decoded) = decoded;
		assert:
			(uri
				queryAt: decoded
				ifAbsent: ['absent']) = decoded;
		assert: (uri queryValuesAt: decoded) = (OrderedCollection with: decoded);
		assert:
			(uri
				queryValuesAt: decoded
				ifAbsent: [#()]) = (OrderedCollection with: decoded);
		assert: uri queryKeys = (OrderedCollection with: decoded);
		assert: (uri queryIncludesKey: decoded);
		assert: uri rawQuery = (OrderedCollection with: encoded -> encoded).

	uri uriString: nil.
	self assert: uri printString = encodedURIString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 01:01'!
testQueryValuesAt
	self allURIStringsDo: [:uriString | | uri valuesForKeys |
		uri := uriString asXMLURI.
		valuesForKeys := Dictionary new.
		uri query do: [:each |
			(valuesForKeys
				at: each key
				ifAbsentPut: [OrderedCollection new])
					addLast: each value].
		valuesForKeys keysAndValuesDo: [:key :values |
			self assert: (uri queryValuesAt: key) = values].
		self assert:
			(uri queryValuesAt: 'absent') = OrderedCollection new]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 01:13'!
testQueryValuesAtDo
	self allURIStringsDo: [:uriString | | uri valuesForKeys |
		uri := uriString asXMLURI.
		valuesForKeys := Dictionary new.
		uri query do: [:each |
			(valuesForKeys
				at: each key
				ifAbsentPut: [OrderedCollection new])
					addLast: each value].
		valuesForKeys keysAndValuesDo: [:key :values | | enumerated |
			enumerated := OrderedCollection new.
			self assert:
				(uri
					queryValuesAt: key
					do: [:each | enumerated addLast: each]) == uri.
			self assert: enumerated = values]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:22'!
testQueryValuesAtIfAbsent
	self allURIStringsDo: [:uriString | | uri valuesForKeys |
		uri := uriString asXMLURI.
		valuesForKeys := Dictionary new.
		uri query do: [:each |
			(valuesForKeys
				at: each key
				ifAbsentPut: [OrderedCollection new])
					addLast: each value].
		valuesForKeys keysAndValuesDo: [:key :values |
			self assert:
				(uri
					queryValuesAt: key
					ifAbsent: [self fail]) = values].
		self assert:
			(uri
				queryValuesAt: 'absent'
				ifAbsent: [#()]) = #()]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/15/2016 13:30'!
testReadFrom
	self allURIStringsDo: [:each | | stream uri |
		stream := each readStream.
		uri := XMLURI readFrom: stream.
		self
			assert: uri class == XMLURI;
			assert: uri uriString isNil;
			assert: uri = each asXMLURI;
			assert: stream atEnd.

		uri := XMLURI readFrom: each.
		self
			assert: uri class == XMLURI;
			assert: uri uriString = each;
			assert: uri = each asXMLURI]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:39'!
testScheme
	self
		assert: '' asXMLURI scheme = '';
		assert: '/' asXMLURI scheme = '';
		assert: self absolute asXMLURI scheme = '';
		assert: self absoluteDir asXMLURI scheme = '';
		assert: self absoluteDirRelativeCombined asXMLURI scheme = '';
		assert: self absoluteRelativeCombined asXMLURI scheme = '';
		assert: self domainURIString asXMLURI scheme = 'http';
		assert: self domainURIWithPortString asXMLURI scheme = 'http';
		assert: self emailURIString asXMLURI scheme = 'mailto';
		assert: self fileURIWithHostString asXMLURI scheme = 'file';
		assert: self fileURIString asXMLURI scheme  = 'file';
		assert: self fragmentURIString asXMLURI scheme = '';
		assert: self fullURIString asXMLURI scheme = 'http';
		assert: self fullURIWithPortString asXMLURI scheme = 'http';
		assert: self queryURIString asXMLURI scheme = '';
		assert: self relative asXMLURI scheme = '';
		assert: self relativeAbsoluteCombined asXMLURI scheme = '';
		assert: self schemelessURIString asXMLURI scheme = '';
		assert: self schemelessURIWithPortString asXMLURI scheme = ''! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/5/2016 23:55'!
testSchemeAndHostCaseInsensitivity
	self allURIStringsDo: [:each | | uri uppercaseURI |
		uri := each asXMLURI.
		uppercaseURI := each asUppercase asXMLURI.
		self
			assert: uri scheme = uppercaseURI scheme;
			assert: uri hasAuthorityPrefix = uppercaseURI hasAuthorityPrefix.
		uri hasUserInfo
			ifTrue: [self deny: uri userInfo = uppercaseURI userInfo].
		self
			assert: uri host = uppercaseURI host;
			assert: uri port = uppercaseURI port.
		(uri hasPath
			and: [uri hasRootPath not])
			ifTrue: [self deny: uri pathSegments = uppercaseURI pathSegments].
		uri hasQuery
			ifTrue: [self deny: uri query = uppercaseURI query].
		uri hasFragment
			ifTrue: [self deny: uri fragment = uppercaseURI fragment]]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/11/2016 08:21'!
testSchemeCharacters
	| scheme uri |

	scheme := self alphaNumericCharacters, '+-.'.
	uri := (scheme, '://', self host) asXMLURI.
	self
		assert: uri scheme = scheme asLowercase;
		assert: uri host = self host.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 1/5/2016 02:48'!
testStandardURICombining
	"Generated from RFC 3986, page 34-36"

	| baseURI |

	baseURI := 'http://a/b/c/d;p?q' asXMLURI.
	self
		assert: (baseURI / 'g:h' asXMLURI) = 'g:h' asXMLURI;
		assert: (baseURI / 'g' asXMLURI) = 'http://a/b/c/g' asXMLURI;
		assert: (baseURI / './g' asXMLURI) = 'http://a/b/c/g' asXMLURI;
		assert: (baseURI / 'g/' asXMLURI) = 'http://a/b/c/g/' asXMLURI;
		assert: (baseURI / '/g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '//g' asXMLURI) = 'http://g' asXMLURI;
		assert: (baseURI / '?y' asXMLURI) = 'http://a/b/c/d;p?y' asXMLURI;
		assert: (baseURI / 'g?y' asXMLURI) = 'http://a/b/c/g?y' asXMLURI;
		assert: (baseURI / '#s' asXMLURI) = 'http://a/b/c/d;p?q#s' asXMLURI;
		assert: (baseURI / 'g#s' asXMLURI) = 'http://a/b/c/g#s' asXMLURI;
		assert: (baseURI / 'g?y#s' asXMLURI) = 'http://a/b/c/g?y#s' asXMLURI;
		assert: (baseURI / ';x' asXMLURI) = 'http://a/b/c/;x' asXMLURI;
		assert: (baseURI / 'g;x' asXMLURI) = 'http://a/b/c/g;x' asXMLURI;
		assert: (baseURI / 'g;x?y#s' asXMLURI) = 'http://a/b/c/g;x?y#s' asXMLURI;
		assert: (baseURI / '' asXMLURI) = 'http://a/b/c/d;p?q' asXMLURI;
		assert: (baseURI / '.' asXMLURI) = 'http://a/b/c/' asXMLURI;
		assert: (baseURI / './' asXMLURI) = 'http://a/b/c/' asXMLURI;
		assert: (baseURI / '..' asXMLURI) = 'http://a/b/' asXMLURI;
		assert: (baseURI / '../' asXMLURI) = 'http://a/b/' asXMLURI;
		assert: (baseURI / '../g' asXMLURI) = 'http://a/b/g' asXMLURI;
		assert: (baseURI / '../..' asXMLURI) = 'http://a/' asXMLURI;
		assert: (baseURI / '../../' asXMLURI) = 'http://a/' asXMLURI;
		assert: (baseURI / '../../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '../../../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '../../../../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '/./g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / '/../g' asXMLURI) = 'http://a/g' asXMLURI;
		assert: (baseURI / 'g.' asXMLURI) = 'http://a/b/c/g.' asXMLURI;
		assert: (baseURI / '.g' asXMLURI) = 'http://a/b/c/.g' asXMLURI;
		assert: (baseURI / 'g..' asXMLURI) = 'http://a/b/c/g..' asXMLURI;
		assert: (baseURI / '..g' asXMLURI) = 'http://a/b/c/..g' asXMLURI;
		assert: (baseURI / './../g' asXMLURI) = 'http://a/b/g' asXMLURI;
		assert: (baseURI / './g/.' asXMLURI) = 'http://a/b/c/g/' asXMLURI;
		assert: (baseURI / 'g/./h' asXMLURI) = 'http://a/b/c/g/h' asXMLURI;
		assert: (baseURI / 'g/../h' asXMLURI) = 'http://a/b/c/h' asXMLURI;
		assert: (baseURI / 'g;x=1/./y' asXMLURI) = 'http://a/b/c/g;x=1/y' asXMLURI;
		assert: (baseURI / 'g;x=1/../y' asXMLURI) = 'http://a/b/c/y' asXMLURI;
		assert: (baseURI / 'g?y/./x' asXMLURI) = 'http://a/b/c/g?y/./x' asXMLURI;
		assert: (baseURI / 'g?y/../x' asXMLURI) = 'http://a/b/c/g?y/../x' asXMLURI;
		assert: (baseURI / 'g#s/./x' asXMLURI) = 'http://a/b/c/g#s/./x' asXMLURI;
		assert: (baseURI / 'g#s/../x' asXMLURI) = 'http://a/b/c/g#s/../x' asXMLURI;
		assert: (baseURI / 'http:g' asXMLURI) = 'http:g' asXMLURI! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:39'!
testUserInfo
	self allURIStringsDo: [:each | | uri |
		uri := each asXMLURI.
		uri scheme = 'mailto'
			ifTrue: [self assert: uri userInfo = 'userName']
			ifFalse: [self assert: uri userInfo = '']]! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 3/30/2016 02:05'!
testUserInfoNonPercentEncodedCharacters
	| userInfo uriString uri |

	userInfo := self unreservedCharacters, self subDelimiterCharacters, ':'.
	uriString := 'mailto:', userInfo, '@', self host.
	uri := uriString asXMLURI.
	self
		assert: uri scheme = 'mailto';
		assert: uri userInfo = userInfo;
		assert: uri host = self host.

	uri uriString: nil.
	self assert: uri printString = uriString.! !

!XMLURITest methodsFor: 'tests' stamp: 'monty 2/12/2017 06:19'!
testUserInfoPercentEncodedCharacters
	| prefix encoded decoded suffix encodedURIString uri |

	prefix := 'mailto:'.
	encoded := self percentEncodedASCIICharacters, '+'.
	decoded := self asciiCharacters, '+'.
	suffix := '@', self host.
	encodedURIString := prefix, encoded, suffix.
	uri := encodedURIString asXMLURI.
	self
		assert: uri scheme = 'mailto';
		assert: uri userInfo = decoded;
		assert: uri rawUserInfo = encoded.

	uri uriString: nil.
	self assert: uri printString = encodedURIString.! !

!XMLURITest methodsFor: 'accessing' stamp: 'monty 3/30/2016 21:49'!
unreservedCharacters
	^ unreservedCharacters
		ifNil: [unreservedCharacters := self alphaNumericCharacters, '-._~']! !

XMLString subclass: #XMLFString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFString commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLString!

XMLNodeList subclass: #XMLFNodeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFNodeList commentStamp: 'monty 9/8/2016 09:57' prior: 0!
A dummy subclass of XMLFNodeList!

OrderPreservingStringDictionaryTest subclass: #XMLAttributeDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLAttributeDictionaryTest methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:39'!
dictionaryClass
	^ XMLAttributeDictionary! !

!XMLAttributeDictionaryTest methodsFor: 'testing' stamp: 'monty 6/26/2017 04:04'!
isTestingLazyDictionary
	^ false! !

!XMLAttributeDictionaryTest methodsFor: 'accessing' stamp: 'monty 7/10/2017 05:26'!
namespaceScope
	^ XMLNamespaceScope new
		mapPrefix: '' to: 'defaultNS';
		mapPrefix: 'prefix' to: 'prefixNS';
		mapPrefix: 'otherPrefix' to: 'otherPrefixNS';
		yourself! !

!XMLAttributeDictionaryTest methodsFor: 'accessing' stamp: 'monty 7/12/2017 07:07'!
prefixedAttributeDictionary
	^ (self dictionaryClass new setNamespaceScope: self namespaceScope)
		at: 'name' put: 'value';
		at: 'xml:id' put: 'id';
		at: 'prefix:name' put: 'prefixValue';
		at: 'otherPrefix:name' put: 'otherPrefixValue';
		yourself! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 10/3/2017 11:34'!
testAsXMLAttributeDictionary
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: dictionary asXMLAttributeDictionary == dictionary.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 9/22/2017 10:32'!
testAssociationAtName
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary associationAtName: 'id') = ('xml:id' -> 'id').
	self assert:
		(dictionary associationAtName: 'xml:id') = ('xml:id' -> 'id').
	self assert:
		(dictionary associationAtName: 'name') = ('name' -> 'value').
	self assert:
		(dictionary associationAtName: 'prefix:name') = ('prefix:name' -> 'prefixValue').
	self assert:
		(dictionary associationAtName: 'otherPrefix:name') =
			('otherPrefix:name' -> 'otherPrefixValue').
	self assert: (dictionary associationAtName: self absentKey) isNil.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 9/22/2017 10:28'!
testAssociationAtNameIfAbsent
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			associationAtName: 'id'
			ifAbsent: [self fail]) = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			ifAbsent: [self fail]) = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'name'
			ifAbsent: [self fail]) = ('name' -> 'value').
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			ifAbsent: [self fail]) = ('prefix:name' -> 'prefixValue').
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			ifAbsent: [self fail]) = ('otherPrefix:name' -> 'otherPrefixValue').
	self assert:
		(dictionary
			associationAtName: self absentKey
			ifAbsent: [self absentValue]) = self absentValue.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 8/25/2017 21:43'!
testAssociationAtNameNamespaceURI
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) isNil.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: 'defaultNS') isNil.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: '') = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) isNil.
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: 'defaultNS') isNil.
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: '') = ('xml:id' -> 'id').

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'prefixNS') isNil.
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'prefixNS') isNil.
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'defaultNS') isNil.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'otherPrefixNS') isNil.
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS') isNil.
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'defaultNS') isNil.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: '') = ('name' -> 'value').
	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'defaultNS') isNil.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 9/22/2017 10:23'!
testAssociationAtNameNamespaceURIIfAbsent
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: ''
			ifAbsent: [self fail]) = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: ''
			ifAbsent: [self fail]) = ('xml:id' -> 'id').

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: ''
			ifAbsent: [self fail]) = ('name' -> 'value').
	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 9/22/2017 10:21'!
testAtName
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self
		assert: (dictionary atName: 'id') = 'id';
		assert: (dictionary atName: 'xml:id') = 'id';
		assert: (dictionary atName: 'name') = 'value';
		assert: (dictionary atName: 'prefix:name') = 'prefixValue';
		assert: (dictionary atName: 'otherPrefix:name') = 'otherPrefixValue';
		assert: (dictionary atName: self absentKey) = ''.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 9/22/2017 10:25'!
testAtNameIfAbsent
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			atName: 'id'
			ifAbsent: [self fail]) = 'id'.
	self assert:
		(dictionary
			atName: 'xml:id'
			ifAbsent: [self fail]) = 'id'.
	self assert:
		(dictionary
			atName: 'name'
			ifAbsent: [self fail]) = 'value'.
	self assert:
		(dictionary
			atName: 'prefix:name'
			ifAbsent: [self fail]) = 'prefixValue'.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			ifAbsent: [self fail]) = 'otherPrefixValue'.
	self assert:
		(dictionary
			atName: self absentKey
			ifAbsent: [self absentValue]) = self absentValue.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 8/25/2017 21:49'!
testAtNameNamespaceURI
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) = ''.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: 'defaultNS') = ''.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: '') = 'id'.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) = ''.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: 'defaultNS') = ''.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: '') = 'id'.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'prefixNS') = ''.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'prefixNS') = ''.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'defaultNS') = ''.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'otherPrefixNS') = ''.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS') = ''.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'defaultNS') = ''.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: '') = 'value'.
	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'defaultNS') = ''.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 9/22/2017 10:22'!
testAtNameNamespaceURIIfAbsent
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: ''
			ifAbsent: [self fail]) = 'id'.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: ''
			ifAbsent: [self fail]) = 'id'.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self absentValue]) = self absentValue.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: ''
			ifAbsent: [self fail]) = 'value'.
	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'defaultNS'
			ifAbsent: [self absentValue]) = self absentValue.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 10/2/2017 17:33'!
testLazyDictionary
	| dictionary |

	self isTestingLazyDictionary
		ifFalse: [^ self].

	self assert:
		self emptyDictionary attributeDictionary ==
			self dictionaryClass emptyAttributeDictionary.
	self assert:
		self dictionaryClass emptyAttributeDictionary isEmpty.

	"protocols must be the same as the non-lazy dictionaries"
	dictionary := self emptyDictionary.
	XMLAttributeDictionary selectors do: [:each |
		self assert: (dictionary respondsTo: each)].! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 8/25/2017 21:54'!
testNamespaceURIOf
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self
		assert: (dictionary namespaceURIOf: 'xml:id') = '';
		assert: (dictionary namespaceURIOf: 'prefix:name') = '';
		assert: (dictionary namespaceURIOf: 'otherPrefix:name') = '';
		assert: (dictionary namespaceURIOf: 'name') = ''.! !

!XMLAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 10/2/2017 17:43'!
testUsesNamespaces
	self deny: self emptyDictionary usesNamespaces! !

XMLAttributeDictionaryTest subclass: #XMLLazyAttributeDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLLazyAttributeDictionaryTest methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:23'!
dictionaryClass
	^ XMLLazyAttributeDictionary! !

!XMLLazyAttributeDictionaryTest methodsFor: 'testing' stamp: 'monty 6/26/2017 04:04'!
isTestingLazyDictionary
	^ true! !

XMLAttributeDictionaryTest subclass: #XMLNamespacedAttributeDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

XMLNamespacedAttributeDictionaryTest subclass: #XMLLazyNamespacedAttributeDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLLazyNamespacedAttributeDictionaryTest methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:39'!
dictionaryClass
	^ XMLLazyNamespacedAttributeDictionary! !

!XMLLazyNamespacedAttributeDictionaryTest methodsFor: 'testing' stamp: 'monty 6/26/2017 04:04'!
isTestingLazyDictionary
	^ true! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'accessing' stamp: 'monty 6/26/2017 00:40'!
dictionaryClass
	^ XMLNamespacedAttributeDictionary! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 7/13/2017 06:44'!
testAssociationAtNameNamespaceURI
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: 'defaultNS') isNil.
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: 'defaultNS') isNil.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'prefixNS') = ('prefix:name' -> 'prefixValue').
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'prefixNS') = ('prefix:name' -> 'prefixValue').
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'defaultNS') isNil.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'otherPrefixNS')  = ('otherPrefix:name' -> 'otherPrefixValue').
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS')  = ('otherPrefix:name' -> 'otherPrefixValue').
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'defaultNS') isNil.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: '') = ('name' -> 'value').
	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'defaultNS') isNil.! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 7/13/2017 06:45'!
testAssociationAtNameNamespaceURIIfAbsent
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self fail]) = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'id'
			namespaceURI: 'defaultNS'
			ifAbsent: [#absent]) = #absent.
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self fail]) = ('xml:id' -> 'id').
	self assert:
		(dictionary
			associationAtName: 'xml:id'
			namespaceURI: 'defaultNS'
			ifAbsent: [#absent]) = #absent.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self fail]) = ('prefix:name' -> 'prefixValue').
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self fail]) = ('prefix:name' -> 'prefixValue').
	self assert:
		(dictionary
			associationAtName: 'prefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: [#absent]) = #absent.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self fail]) = ('otherPrefix:name' -> 'otherPrefixValue').
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self fail]) = ('otherPrefix:name' -> 'otherPrefixValue').
	self assert:
		(dictionary
			associationAtName: 'otherPrefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: [#absent]) = #absent.

	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: ''
			ifAbsent: [self fail]) = ('name' -> 'value').
	self assert:
		(dictionary
			associationAtName: 'name'
			namespaceURI: 'defaultNS'
			ifAbsent: [#absent]) = #absent.! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 7/13/2017 06:47'!
testAtNameNamespaceURI
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) = 'id'.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: 'defaultNS') = ''.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI) = 'id'.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: 'defaultNS') = ''.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'prefixNS') = 'prefixValue'.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'prefixNS') = 'prefixValue'.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'defaultNS') = ''.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'otherPrefixNS') = 'otherPrefixValue'.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS') = 'otherPrefixValue'.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'defaultNS') = ''.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: '') = 'value'.
	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'defaultNS') = ''.! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 7/13/2017 06:47'!
testAtNameNamespaceURIIfAbsent
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self fail]) = 'id'.
	self assert:
		(dictionary
			atName: 'id'
			namespaceURI: 'defaultNS'
			ifAbsent: ['absent']) = 'absent'.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: XMLNamespaceScope xmlNamespaceURI
			ifAbsent: [self fail]) = 'id'.
	self assert:
		(dictionary
			atName: 'xml:id'
			namespaceURI: 'defaultNS'
			ifAbsent: ['absent']) = 'absent'.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self fail]) = 'prefixValue'.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'prefixNS'
			ifAbsent: [self fail]) = 'prefixValue'.
	self assert:
		(dictionary
			atName: 'prefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: ['absent']) = 'absent'.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self fail]) = 'otherPrefixValue'.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'otherPrefixNS'
			ifAbsent: [self fail]) = 'otherPrefixValue'.
	self assert:
		(dictionary
			atName: 'otherPrefix:name'
			namespaceURI: 'defaultNS'
			ifAbsent: ['absent']) = 'absent'.

	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: ''
			ifAbsent: [self fail]) = 'value'.
	self assert:
		(dictionary
			atName: 'name'
			namespaceURI: 'defaultNS'
			ifAbsent: ['absent']) = 'absent'.! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 10/3/2017 11:55'!
testCopy
	| dictionary copy |

	super testCopy.
	dictionary := self prefixedAttributeDictionary.
	copy := dictionary copy.
	self assert: dictionary namespaceScope == copy namespaceScope.! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 7/5/2017 11:44'!
testNamespaceURIOf
	| dictionary |

	dictionary := self prefixedAttributeDictionary.
	self assert:
		(dictionary namespaceURIOf: 'xml:id') =
			XMLNamespaceScope xmlNamespaceURI.
	self
		assert: (dictionary namespaceURIOf: 'prefix:name') = 'prefixNS';
		assert: (dictionary namespaceURIOf: 'otherPrefix:name') = 'otherPrefixNS';
		assert: (dictionary namespaceURIOf: 'name') = ''.! !

!XMLNamespacedAttributeDictionaryTest methodsFor: 'tests' stamp: 'monty 10/2/2017 17:43'!
testUsesNamespaces
	self assert: self emptyDictionary usesNamespaces! !

Object subclass: #SAX2SampleBook
	instanceVariableNames: 'title isbn authors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2SampleBook commentStamp: 'monty 8/16/2016 04:02' prior: 0!
The sample book object parsed by the SAX2ElementParser.!

!SAX2SampleBook methodsFor: 'adding' stamp: 'monty 8/16/2016 03:42'!
addAuthor: aString
	^ self authors addLast: aString! !

!SAX2SampleBook methodsFor: 'accessing' stamp: 'monty 8/16/2016 03:39'!
authors
	^ authors! !

!SAX2SampleBook methodsFor: 'initialization' stamp: 'monty 8/16/2016 03:40'!
initialize
	super initialize.

	title := ''.
	isbn := ''.
	authors := OrderedCollection new.! !

!SAX2SampleBook methodsFor: 'accessing' stamp: 'monty 8/16/2016 03:40'!
isbn
	^ isbn! !

!SAX2SampleBook methodsFor: 'accessing' stamp: 'monty 8/16/2016 03:40'!
isbn: aString
	isbn := aString! !

!SAX2SampleBook methodsFor: 'accessing' stamp: 'monty 8/16/2016 03:40'!
title
	^ title! !

!SAX2SampleBook methodsFor: 'accessing' stamp: 'monty 8/16/2016 03:40'!
title: aString
	title := aString! !

Object subclass: #SAX2SamplePerson
	instanceVariableNames: 'name dateOfBirth emailAddresses residence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-ElementHandlers'!

!SAX2SamplePerson commentStamp: 'monty 8/16/2016 04:02' prior: 0!
The sample person object parsed by the SAX2ElementParser.!

!SAX2SamplePerson methodsFor: 'adding' stamp: 'monty 8/17/2016 01:30'!
addEmailAddress: aString
	^ self emailAddresses addLast: aString! !

!SAX2SamplePerson methodsFor: 'accessing' stamp: 'monty 8/15/2016 04:12'!
dateOfBirth
	^ dateOfBirth! !

!SAX2SamplePerson methodsFor: 'accessing' stamp: 'monty 8/15/2016 04:14'!
dateOfBirth: aDate
	dateOfBirth := aDate! !

!SAX2SamplePerson methodsFor: 'accessing' stamp: 'monty 8/15/2016 04:13'!
emailAddresses
	^ emailAddresses! !

!SAX2SamplePerson methodsFor: 'initialization' stamp: 'monty 8/17/2016 22:03'!
initialize
	super initialize.

	name := ''.
	dateOfBirth := nil.
	emailAddresses := OrderedCollection new.
	residence := ''.! !

!SAX2SamplePerson methodsFor: 'accessing' stamp: 'monty 8/15/2016 04:12'!
name
	^ name! !

!SAX2SamplePerson methodsFor: 'accessing' stamp: 'monty 8/15/2016 04:14'!
name: aString
	name := aString! !

!SAX2SamplePerson methodsFor: 'accessing' stamp: 'monty 8/17/2016 22:03'!
residence
	^ residence! !

!SAX2SamplePerson methodsFor: 'accessing' stamp: 'monty 8/17/2016 22:03'!
residence: aString
	residence := aString! !

Object subclass: #XMLExceptionRaisingReadStream
	instanceVariableNames: 'stream wasClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-Streams'!

!XMLExceptionRaisingReadStream commentStamp: 'monty 4/10/2016 00:59' prior: 0!
This is a read stream that raises errors if sent peek or next when atEnd, which streams on other platforms disallow, or if sent close multiple times or if sent atEnd, next, or peek when closed, which StandardFileStream disallows . Used to test portability.!

!XMLExceptionRaisingReadStream class methodsFor: 'instance creation' stamp: 'monty 2/15/2016 23:29'!
on: aCollection
	^ self new on: aCollection! !

!XMLExceptionRaisingReadStream methodsFor: 'testing' stamp: 'monty 11/27/2016 18:34'!
atEnd
	wasClosed
		ifTrue: [self errorClosedStreamCannotBeSent: #atEnd].
	^ stream atEnd! !

!XMLExceptionRaisingReadStream methodsFor: 'closing' stamp: 'monty 11/27/2016 18:34'!
close
	wasClosed
		ifTrue: [self errorClosedStreamCannotBeSent: #close].

	"must use respondsTo: to support streams only implementing the basic
	protocol"
	(stream respondsTo: #close)
		ifTrue: [stream close].
	wasClosed := true.! !

!XMLExceptionRaisingReadStream methodsFor: 'private' stamp: 'monty 11/27/2016 18:35'!
errorAtEndStreamCannotBeSent: aSelector
	Error signal:
		'Cannot send ', aSelector printString, ' on this stream when it''s atEnd'! !

!XMLExceptionRaisingReadStream methodsFor: 'private' stamp: 'monty 11/27/2016 18:34'!
errorClosedStreamCannotBeSent: aSelector
	Error signal:
		'Cannot send ', aSelector printString, ' on this stream when closed'! !

!XMLExceptionRaisingReadStream methodsFor: 'testing' stamp: 'monty 5/26/2015 01:46'!
isBinary
	^ false! !

!XMLExceptionRaisingReadStream methodsFor: 'testing' stamp: 'monty 10/13/2014 22:00'!
isStream
	^ true! !

!XMLExceptionRaisingReadStream methodsFor: 'accessing' stamp: 'monty 11/27/2016 22:51'!
next
	stream atEnd
		ifTrue: [self errorAtEndStreamCannotBeSent: #next].
	^ stream next.! !

!XMLExceptionRaisingReadStream methodsFor: 'initialization' stamp: 'monty 10/26/2016 04:54'!
on: aCollection
	stream := aCollection readStream.
	wasClosed := false.! !

!XMLExceptionRaisingReadStream methodsFor: 'accessing' stamp: 'monty 11/27/2016 22:51'!
peek
	stream atEnd
		ifTrue: [self errorAtEndStreamCannotBeSent: #peek].
	^ stream peek.! !

!XMLExceptionRaisingReadStream methodsFor: 'positioning' stamp: 'monty 11/27/2016 18:34'!
position
	wasClosed
		ifTrue: [self errorClosedStreamCannotBeSent: #position].
	^ stream position! !

!XMLExceptionRaisingReadStream methodsFor: 'positioning' stamp: 'monty 11/27/2016 18:34'!
position: anInteger
	wasClosed
		ifTrue: [self errorClosedStreamCannotBeSent: #position:].
	stream position: anInteger.! !

!XMLExceptionRaisingReadStream methodsFor: 'positioning' stamp: 'monty 11/27/2016 18:34'!
reset
	wasClosed
		ifTrue: [self errorClosedStreamCannotBeSent: #reset].
	stream reset.! !

!XMLExceptionRaisingReadStream methodsFor: 'testing' stamp: 'monty 10/26/2016 04:54'!
wasClosed
	^ wasClosed! !

Object subclass: #XMLMessageRecorder
	instanceVariableNames: 'messageQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLMessageRecorder commentStamp: 'monty 4/12/2015 08:28' prior: 0!
This class records sent messages in a queue.!

!XMLMessageRecorder methodsFor: 'accessing' stamp: 'monty 4/12/2015 07:56'!
clearMessages
	^ self messageQueue removeAll! !

!XMLMessageRecorder methodsFor: 'testing' stamp: 'monty 4/12/2015 07:56'!
hasMessages
	^ self messageQueue notEmpty! !

!XMLMessageRecorder methodsFor: 'private' stamp: 'monty 4/12/2015 07:53'!
messageQueue
	^ messageQueue ifNil: [messageQueue := OrderedCollection new]! !

!XMLMessageRecorder methodsFor: 'accessing' stamp: 'monty 9/17/2017 09:54'!
messages
	^ messageQueue copy! !

!XMLMessageRecorder methodsFor: 'enumerating' stamp: 'monty 4/12/2015 08:24'!
messagesCollect: aBlock
	^ self messageQueue collect: aBlock! !

!XMLMessageRecorder methodsFor: 'enumerating' stamp: 'monty 4/12/2015 08:21'!
messagesDo: aBlock
	self messageQueue do: aBlock! !

!XMLMessageRecorder methodsFor: 'enumerating' stamp: 'monty 4/12/2015 08:22'!
messagesSelect: aBlock
	^ self messageQueue select: aBlock! !

!XMLMessageRecorder methodsFor: 'accessing' stamp: 'monty 7/28/2016 10:33'!
nextMessage
	^ self hasMessages
		ifTrue: [self messageQueue removeFirst]
		ifFalse: [nil]! !

!XMLMessageRecorder methodsFor: 'accessing' stamp: 'monty 7/28/2016 10:33'!
peekMessage
	^ self hasMessages
		ifTrue: [self messageQueue first]
		ifFalse: [nil]! !

!XMLMessageRecorder methodsFor: 'recording' stamp: 'monty 4/12/2015 08:05'!
recordMessage: aMessage
	self messageQueue addLast: aMessage! !

!XMLMessageRecorder methodsFor: 'recording' stamp: 'monty 11/26/2016 02:06'!
recordMessageReceiver: anObject selector: aSelector
	self
		recordMessageReceiver: anObject
		selector: aSelector
		arguments: Array new! !

!XMLMessageRecorder methodsFor: 'recording' stamp: 'monty 11/26/2016 02:05'!
recordMessageReceiver: anObject selector: aSelector argument: anArgument
	self
		recordMessageReceiver: anObject
		selector: aSelector
		arguments: (Array with: anArgument)! !

!XMLMessageRecorder methodsFor: 'recording' stamp: 'monty 6/24/2016 23:44'!
recordMessageReceiver: anObject selector: aSelector arguments: aSequenceableCollection
	self recordMessage:
		(MessageSend
			receiver: anObject
			selector: aSelector
			arguments: aSequenceableCollection asArray)! !

Object subclass: #XMLRecordingListObserver
	instanceVariableNames: 'messageRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLRecordingListObserver commentStamp: 'monty 4/12/2015 08:27' prior: 0!
This observer records notifications using an XMLMessageRecorder.!

XMLRecordingListObserver subclass: #XMLRecordingAttributeListObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLRecordingAttributeListObserver commentStamp: 'monty 1/17/2015 11:03' prior: 0!
This observer records notifications from XMLAttributeLists.!

!XMLRecordingAttributeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:02'!
addedAttribute: anAttribute
	self messageRecorder
		recordMessageReceiver: self
		selector: #addedAttribute:
		arguments: (Array with: anAttribute)! !

!XMLRecordingAttributeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:03'!
removedAttribute: anAttribute
	self messageRecorder
		recordMessageReceiver: self
		selector: #removedAttribute:
		arguments: (Array with: anAttribute)! !

!XMLRecordingListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:00'!
added: anObject to: aList
	self messageRecorder
		recordMessageReceiver: self
		selector: #added:to:
		arguments: (Array with: anObject with: aList)! !

!XMLRecordingListObserver methodsFor: 'accesing' stamp: 'monty 4/12/2015 07:59'!
clearNotifications
	self messageRecorder clearMessages! !

!XMLRecordingListObserver methodsFor: 'testing' stamp: 'monty 4/12/2015 08:01'!
hasNotifications
	^ self messageRecorder hasMessages! !

!XMLRecordingListObserver methodsFor: 'accesing' stamp: 'monty 4/12/2015 07:59'!
messageRecorder
	^ messageRecorder ifNil: [messageRecorder := XMLMessageRecorder new]! !

!XMLRecordingListObserver methodsFor: 'accesing' stamp: 'monty 4/12/2015 07:59'!
nextNotification
	^ self messageRecorder nextMessage! !

!XMLRecordingListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:02'!
removed: anObject from: aList
	self messageRecorder
		recordMessageReceiver: self
		selector: #removed:from:
		arguments: (Array with: anObject with: aList)! !

XMLRecordingListObserver subclass: #XMLRecordingNodeListObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLRecordingNodeListObserver commentStamp: 'monty 1/17/2015 10:45' prior: 0!
This observer records notifications from XMLNodeLists.!

!XMLRecordingNodeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:03'!
addedNode: aNode
	self messageRecorder
		recordMessageReceiver: self
		selector: #addedNode:
		arguments: (Array with: aNode)! !

!XMLRecordingNodeListObserver methodsFor: 'notifying' stamp: 'monty 4/12/2015 08:02'!
removedNode: aNode
	self messageRecorder
		recordMessageReceiver: self
		selector: #removedNode:
		arguments: (Array with: aNode)! !

Object subclass: #XMLTempFileManager
	instanceVariableNames: 'uniqueFileNames streamConverter fileContents fileSuffix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!XMLTempFileManager commentStamp: 'monty 9/18/2016 21:12' prior: 0!
A class for managing temp files using XMLFileHandles. This has race conditions in it and could leak temp files, so it is only to be used for testing in tests that are normally skipped.!

!XMLTempFileManager class methodsFor: 'instance creation' stamp: 'monty 9/18/2016 16:16'!
streamConverter: aStreamConverter fileContents: aString fileSuffix: aSuffix
	^ self new
		setStreamConverter: aStreamConverter
		fileContents: aString
		fileSuffix: aSuffix! !

!XMLTempFileManager methodsFor: 'file creation' stamp: 'monty 9/19/2016 10:05'!
createFileForHandle: aFileHandle
	self
		createFileWithContents: ''
		forHandle: aFileHandle! !

!XMLTempFileManager methodsFor: 'file creation' stamp: 'monty 9/18/2016 16:36'!
createFileWithContents: aString forHandle: aFileHandle
	aFileHandle writeStream
		streamConverter: self streamConverter;
		nextPutByteOrderMark;
		nextPutAll: aString;
		close! !

!XMLTempFileManager methodsFor: 'file creation' stamp: 'monty 9/18/2016 16:36'!
createFileWithContentsForHandle: aFileHandle
	self
		createFileWithContents: self fileContents
		forHandle: aFileHandle! !

!XMLTempFileManager methodsFor: 'accessing' stamp: 'monty 9/18/2016 15:43'!
fileContents
	^ fileContents ifNil: [fileContents := '']! !

!XMLTempFileManager methodsFor: 'accessing' stamp: 'monty 9/18/2016 15:52'!
fileSuffix
	^ fileSuffix ifNil: [fileSuffix := '.temp']! !

!XMLTempFileManager methodsFor: 'instance creation' stamp: 'monty 9/18/2016 15:56'!
newFileHandle
	^ self newFileHandleWithSuffix: self fileSuffix! !

!XMLTempFileManager methodsFor: 'instance creation' stamp: 'monty 9/18/2016 15:57'!
newFileHandleDo: aBlock
	^ self
		newFileHandleWithSuffix: self fileSuffix
		do: aBlock! !

!XMLTempFileManager methodsFor: 'instance creation' stamp: 'monty 9/19/2016 13:58'!
newFileHandleWithSuffix: aSuffix
	| fileHandle |

	"This is an obvious race condition and may also leak temp files,
	but it's good enough for tests that are skipped by default.
	(must avoid doWhileTrue: for GS compatibility)"
	[fileHandle isNil
		or: [fileHandle exists]]
		whileTrue: [
			fileHandle :=
				(self newUniqueFileNameWithSuffix: aSuffix) asXMLFileHandle].
	^ fileHandle.! !

!XMLTempFileManager methodsFor: 'instance creation' stamp: 'monty 9/18/2016 15:56'!
newFileHandleWithSuffix: aSuffix do: aBlock
	| fileHandle |

	"This is an obvious race condition and may also leak temp files,
	but it's good enough for tests that are skipped by default."
	fileHandle := self newFileHandleWithSuffix: aSuffix.
	[aBlock value: fileHandle]
		ensure: [
			fileHandle exists
				ifTrue: [fileHandle delete]]! !

!XMLTempFileManager methodsFor: 'instance creation' stamp: 'monty 9/18/2016 15:57'!
newUniqueFileName
	^ self newUniqueFileNameWithSuffix: self fileSuffix! !

!XMLTempFileManager methodsFor: 'instance creation' stamp: 'monty 9/19/2016 13:58'!
newUniqueFileNameWithSuffix: aSuffix
	| uniqueFileName oldSize |

	"Try to come up with a unique file name.
	This is good enough for tests that are skipped by default.
	(must avoid doWhileTrue: for GS compatibility)"
	[uniqueFileName isNil
		or: [
			oldSize := self uniqueFileNames size.
			(self uniqueFileNames
				add: uniqueFileName;
				size) = oldSize]]
		whileTrue: [
			uniqueFileName :=
				'XMLTempFile{1}-{2}{3}' format:
					(Array
						with: self identityHash asString
						with: (0 to: 100000) atRandom asString
						with: aSuffix)].
	^ uniqueFileName.! !

!XMLTempFileManager methodsFor: 'initialization' stamp: 'monty 9/18/2016 16:16'!
setStreamConverter: aStreamConverter fileContents: aString fileSuffix: aSuffix
	streamConverter := aStreamConverter.
	fileContents := aString.
	fileSuffix := aSuffix.! !

!XMLTempFileManager methodsFor: 'accessing' stamp: 'monty 9/18/2016 16:15'!
streamConverter
	^ streamConverter ifNil: [streamConverter := XMLStreamConverter default]! !

!XMLTempFileManager methodsFor: 'private' stamp: 'monty 9/18/2016 15:33'!
uniqueFileNames
	^ uniqueFileNames ifNil: [uniqueFileNames := Set new]! !

XMLComment subclass: #XMLFComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFComment commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLComment!

SAXHandler subclass: #SAXRecordingHandler
	instanceVariableNames: 'messageRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXRecordingHandler commentStamp: 'monty 6/25/2016 03:05' prior: 0!
This class records the final element events (startElement:attributes: and #endElement:) used when no others are defined, as well as every other non-element event.!

!SAXRecordingHandler class methodsFor: 'private' stamp: 'monty 6/24/2016 23:45'!
generateRecordingHandlerMethods
	"
	self generateRecordingHandlerMethods
	"

	#(#'handling - content'
		#'handling - lexical'
		#'handling - declaration')
		do: [:handlerCategory |
			(SAXHandler selectorsInCategory: handlerCategory) do: [:handlerSelector | | parsedMethod sourceStream |
				parsedMethod := RBParser parseMethod: (SAXHandler sourceCodeAt: handlerSelector).
				(sourceStream := String new writeStream)
					nextPutAll: parsedMethod selectorAndArgumentNames;
					cr;
					nextPutAll: '	self messageRecorder';
					cr;
					nextPutAll: '		recordMessageReceiver: self';
					cr;
					nextPutAll: '		selector: #', handlerSelector asString.
				parsedMethod arguments
					ifNotEmpty: [
						sourceStream
							cr;
							nextPutAll: '		arguments:';
							cr;
							nextPutAll: '			(OrderedCollection new'.
						parsedMethod argumentNames do: [:each |
							sourceStream
								cr;
								nextPutAll: '				addLast: ', each, ';'].
						sourceStream
							cr;
							nextPutAll: '				yourself)'].

				self
					compile: sourceStream contents
					classified: handlerCategory]]! !

!SAXRecordingHandler methodsFor: 'accessing' stamp: 'monty 9/17/2017 09:56'!
allSentMessages
	^ self messageRecorder messages asArray! !

!SAXRecordingHandler methodsFor: 'accessing' stamp: 'monty 9/17/2017 09:56'!
allSentMessagesNamed: aName
	^ (self messageRecorder messagesSelect: [:each |
		each selector = aName asSymbol]) asArray! !

!SAXRecordingHandler methodsFor: 'accessing' stamp: 'monty 9/17/2017 09:56'!
allSentSelectors
	^ (self messageRecorder messagesCollect: [:each |
		each selector]) asArray! !

!SAXRecordingHandler methodsFor: 'accessing' stamp: 'monty 6/24/2016 23:35'!
argumentsSentWith: aSelector
	self messageRecorder messagesDo: [:each |
		each selector = aSelector
			ifTrue: [^ each arguments]].
	^ #().! !

!SAXRecordingHandler methodsFor: 'handling - declaration' stamp: 'monty 9/17/2017 08:35'!
attributeDeclaration: anElementName name: anAttributeName type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	self
		recordMessageReceiver: self
		selector: #attributeDeclaration:name:type:defaultPragma:defaultValue:
		arguments:
			(OrderedCollection new
				addLast: anElementName;
				addLast: anAttributeName;
				addLast: aType;
				addLast: aDefaultPragma;
				addLast: aDefaultValue;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:34'!
characters: aString
	self
		recordMessageReceiver: self
		selector: #characters:
		arguments:
			(OrderedCollection new
				addLast: aString;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:36'!
comment: aString
	self
		recordMessageReceiver: self
		selector: #comment:
		arguments:
			(OrderedCollection new
				addLast: aString;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - declaration' stamp: 'monty 9/17/2017 08:35'!
elementDeclaration: anElementName contentModel: aContentModel
	self
		recordMessageReceiver: self
		selector: #elementDeclaration:contentModel:
		arguments:
			(OrderedCollection new
				addLast: anElementName;
				addLast: aContentModel;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:36'!
endCData
	self
		recordMessageReceiver: self
		selector: #endCData! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:36'!
endDTD
	self
		recordMessageReceiver: self
		selector: #endDTD! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:34'!
endDocument
	self
		recordMessageReceiver: self
		selector: #endDocument! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
endElement: aQualifiedName
	self
		recordMessageReceiver: self
		selector: #endElement:
		arguments:
			(OrderedCollection new
				addLast: aQualifiedName;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:36'!
endEntity: anEntityName
	self
		recordMessageReceiver: self
		selector: #endEntity:
		arguments:
			(OrderedCollection new
				addLast: anEntityName;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
endPrefixMapping: aPrefix
	self
		recordMessageReceiver: self
		selector: #endPrefixMapping:
		arguments:
			(OrderedCollection new
				addLast: aPrefix;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - declaration' stamp: 'monty 9/17/2017 08:36'!
generalEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName
	self
		recordMessageReceiver: self
		selector: #generalEntityDeclaration:publicID:systemID:ndata:
		arguments:
			(OrderedCollection new
				addLast: aName;
				addLast: aPublicID;
				addLast: aSystemID;
				addLast: aNotationName;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - declaration' stamp: 'monty 9/17/2017 08:36'!
generalEntityDeclaration: aName replacement: aReplacement
	self
		recordMessageReceiver: self
		selector: #generalEntityDeclaration:replacement:
		arguments:
			(OrderedCollection new
				addLast: aName;
				addLast: aReplacement;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
ignorableWhitespace: aString
	self
		recordMessageReceiver: self
		selector: #ignorableWhitespace:
		arguments:
			(OrderedCollection new
				addLast: aString;
				yourself)! !

!SAXRecordingHandler methodsFor: 'accessing' stamp: 'monty 4/12/2015 08:04'!
messageRecorder
	^ messageRecorder ifNil: [messageRecorder := XMLMessageRecorder new]! !

!SAXRecordingHandler methodsFor: 'handling - declaration' stamp: 'monty 9/17/2017 08:36'!
notationDeclaration: aName publicID: aPublicID systemID: aSystemID
	self
		recordMessageReceiver: self
		selector: #notationDeclaration:publicID:systemID:
		arguments:
			(OrderedCollection new
				addLast: aName;
				addLast: aPublicID;
				addLast: aSystemID;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - declaration' stamp: 'monty 9/17/2017 08:36'!
parameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID
	self
		recordMessageReceiver: self
		selector: #parameterEntityDeclaration:publicID:systemID:
		arguments:
			(OrderedCollection new
				addLast: aName;
				addLast: aPublicID;
				addLast: aSystemID;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - declaration' stamp: 'monty 9/17/2017 08:36'!
parameterEntityDeclaration: aName replacement: aReplacement
	self
		recordMessageReceiver: self
		selector: #parameterEntityDeclaration:replacement:
		arguments:
			(OrderedCollection new
				addLast: aName;
				addLast: aReplacement;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
processingInstruction: aTargetString data: aDataString
	self
		recordMessageReceiver: self
		selector: #processingInstruction:data:
		arguments:
			(OrderedCollection new
				addLast: aTargetString;
				addLast: aDataString;
				yourself)! !

!SAXRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 08:33'!
recordMessage: aMessage
	self messageRecorder recordMessage: aMessage! !

!SAXRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 08:33'!
recordMessageReceiver: anObject selector: aSelector
	self messageRecorder
		recordMessageReceiver: anObject
		selector: aSelector! !

!SAXRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 08:34'!
recordMessageReceiver: anObject selector: aSelector argument: anArgument
	self messageRecorder
		recordMessageReceiver: anObject
		selector: aSelector
		argument: anArgument! !

!SAXRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 08:34'!
recordMessageReceiver: anObject selector: aSelector arguments: aSequenceableCollection
	self messageRecorder
		recordMessageReceiver: anObject
		selector: aSelector
		arguments: aSequenceableCollection! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
skippedEntity: anEntityName
	self
		recordMessageReceiver: self
		selector: #skippedEntity:
		arguments:
			(OrderedCollection new
				addLast: anEntityName;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:36'!
startCData
	self
		recordMessageReceiver: self
		selector: #startCData! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:37'!
startDTD: aRootElementName publicID: aPublicID systemID: aSystemID
	self
		recordMessageReceiver: self
		selector: #startDTD:publicID:systemID:
		arguments:
			(OrderedCollection new
				addLast: aRootElementName;
				addLast: aPublicID;
				addLast: aSystemID;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
startDocument
	self
		recordMessageReceiver: self
		selector: #startDocument! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
startElement: aQualifiedName attributes: anAttributeDictionary
	self
		recordMessageReceiver: self
		selector: #startElement:attributes:
		arguments:
			(OrderedCollection new
				addLast: aQualifiedName;
				addLast: anAttributeDictionary;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:37'!
startEntity: anEntityName
	self
		recordMessageReceiver: self
		selector: #startEntity:
		arguments:
			(OrderedCollection new
				addLast: anEntityName;
				yourself)! !

!SAXRecordingHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:35'!
startPrefixMapping: aPrefix uri: aURI
	self
		recordMessageReceiver: self
		selector: #startPrefixMapping:uri:
		arguments:
			(OrderedCollection new
				addLast: aPrefix;
				addLast: aURI;
				yourself)! !

!SAXRecordingHandler methodsFor: 'testing' stamp: 'monty 6/27/2016 21:02'!
wasSentSelector: aSelector
	^ self allSentSelectors includes: aSelector asSymbol! !

!SAXRecordingHandler methodsFor: 'testing' stamp: 'monty 6/24/2016 23:35'!
wasSentSelectors: aSelectorArray
	^ self allSentSelectors = aSelectorArray asArray! !

!SAXRecordingHandler methodsFor: 'handling - lexical' stamp: 'monty 9/17/2017 08:37'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	self
		recordMessageReceiver: self
		selector: #xmlVersion:encoding:standalone:
		arguments:
			(OrderedCollection new
				addLast: aVersionFloat;
				addLast: anEncoding;
				addLast: aBoolean;
				yourself)! !

SAXRecordingHandler subclass: #SAXRecordingPrefixURIHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXRecordingPrefixURIHandler commentStamp: 'monty 6/18/2015 00:41' prior: 0!
This class records the second element events (#startElement:prefix:uri:attributes: and #endElement:prefix:uri:) used when the first aren't defined.!

!SAXRecordingPrefixURIHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:37'!
endElement: aQualifiedName prefix: aPrefix uri: aURI
	self
		recordMessageReceiver: self
		selector: #endElement:prefix:uri:
		arguments:
			(OrderedCollection new
				addLast: aQualifiedName;
				addLast: aPrefix;
				addLast: aURI;
				yourself)! !

!SAXRecordingPrefixURIHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:37'!
startElement: aQualifiedName prefix: aPrefix uri: aURI attributes: anAttributeDictionary
	self
		recordMessageReceiver: self
		selector: #startElement:prefix:uri:attributes:
		arguments:
			(OrderedCollection new
				addLast: aQualifiedName;
				addLast: aPrefix;
				addLast: aURI;
				addLast: anAttributeDictionary;
				yourself)! !

SAXRecordingPrefixURIHandler subclass: #SAXRecordingPrefixURILocalNameHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXRecordingPrefixURILocalNameHandler commentStamp: 'monty 6/18/2015 00:57' prior: 0!
This class records the first element events (#startElement:prefix:uri:attributes:localName: and #endElement:prefix:uri:localName:) sent before the others.!

SAXRecordingPrefixURILocalNameHandler subclass: #SAXInterruptingRecordingPrefixURILocalNameHandler
	instanceVariableNames: 'interruptOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXInterruptingRecordingPrefixURILocalNameHandler commentStamp: 'monty 6/26/2016 00:07' prior: 0!
An interrupting version to test #interruptParsing.!

!SAXInterruptingRecordingPrefixURILocalNameHandler class methodsFor: 'private' stamp: 'monty 6/26/2016 00:16'!
generateInterruptingRecordingHandlerMethods
	"
	self generateInterruptingRecordingHandlerMethods
	"

	#(#'handling - content'
		#'handling - lexical'
		#'handling - declaration')
		do: [:handlerCategory |
			(SAXHandler selectorsInCategory: handlerCategory) do: [:handlerSelector | | parsedMethod sourceStream |
				parsedMethod := RBParser parseMethod: (SAXHandler sourceCodeAt: handlerSelector).
				(sourceStream := String new writeStream)
					nextPutAll: parsedMethod selectorAndArgumentNames;
					cr;
					nextPutAll: '	super'.
				1 to: parsedMethod keywords size do: [:i |
					parsedMethod keywords size > 1
						ifTrue: [
							sourceStream
								cr;
								nextPutAll: '		']
						ifFalse: [sourceStream space].
					sourceStream nextPutAll: (parsedMethod keywords at: i).
					parsedMethod arguments
						ifNotEmpty: [
							sourceStream
								space;
								nextPutAll: (parsedMethod argumentNames at: i)]].
				sourceStream
					nextPut: $.;
					cr;
					cr;
					nextPutAll: '	self interruptOn = #', handlerSelector asString;
					cr;
					nextPutAll: '		ifTrue: [self interruptParsing].'.
				self
					compile: sourceStream contents
					classified: handlerCategory]]! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - declaration' stamp: 'monty 6/26/2016 00:16'!
attributeDeclaration: anElementName name: anAttributeName type: aType defaultPragma: aDefaultPragma defaultValue: aDefaultValue
	super
		attributeDeclaration: anElementName
		name: anAttributeName
		type: aType
		defaultPragma: aDefaultPragma
		defaultValue: aDefaultValue.

	self interruptOn = #attributeDeclaration:name:type:defaultPragma:defaultValue:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
characters: aString
	super characters: aString.

	self interruptOn = #characters:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
comment: aString
	super comment: aString.

	self interruptOn = #comment:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - declaration' stamp: 'monty 6/26/2016 00:16'!
elementDeclaration: anElementName contentModel: aContentModel
	super
		elementDeclaration: anElementName
		contentModel: aContentModel.

	self interruptOn = #elementDeclaration:contentModel:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
endCData
	super endCData.

	self interruptOn = #endCData
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
endDTD
	super endDTD.

	self interruptOn = #endDTD
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
endDocument
	super endDocument.

	self interruptOn = #endDocument
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
endElement: aQualifiedName
	super endElement: aQualifiedName.

	self interruptOn = #endElement:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
endElement: aQualifiedName prefix: aPrefix uri: aURI
	super
		endElement: aQualifiedName
		prefix: aPrefix
		uri: aURI.

	self interruptOn = #endElement:prefix:uri:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	super
		endElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		localName: aLocalName.

	self interruptOn = #endElement:prefix:uri:localName:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
endEntity: anEntityName
	super endEntity: anEntityName.

	self interruptOn = #endEntity:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
endPrefixMapping: aPrefix
	super endPrefixMapping: aPrefix.

	self interruptOn = #endPrefixMapping:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - declaration' stamp: 'monty 6/26/2016 00:16'!
generalEntityDeclaration: aName publicID: aPublicID systemID: aSystemID ndata: aNotationName
	super
		generalEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID
		ndata: aNotationName.

	self interruptOn = #generalEntityDeclaration:publicID:systemID:ndata:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - declaration' stamp: 'monty 6/26/2016 00:16'!
generalEntityDeclaration: aName replacement: aReplacement
	super
		generalEntityDeclaration: aName
		replacement: aReplacement.

	self interruptOn = #generalEntityDeclaration:replacement:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
ignorableWhitespace: aString
	super ignorableWhitespace: aString.

	self interruptOn = #ignorableWhitespace:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'accessing' stamp: 'monty 6/26/2016 00:03'!
interruptOn
	^ interruptOn! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'accessing' stamp: 'monty 6/26/2016 00:06'!
interruptOn: aSelector
	interruptOn := aSelector! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - declaration' stamp: 'monty 6/26/2016 00:16'!
notationDeclaration: aName publicID: aPublicID systemID: aSystemID
	super
		notationDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID.

	self interruptOn = #notationDeclaration:publicID:systemID:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - declaration' stamp: 'monty 6/26/2016 00:16'!
parameterEntityDeclaration: aName publicID: aPublicID systemID: aSystemID
	super
		parameterEntityDeclaration: aName
		publicID: aPublicID
		systemID: aSystemID.

	self interruptOn = #parameterEntityDeclaration:publicID:systemID:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - declaration' stamp: 'monty 6/26/2016 00:16'!
parameterEntityDeclaration: aName replacement: aReplacement
	super
		parameterEntityDeclaration: aName
		replacement: aReplacement.

	self interruptOn = #parameterEntityDeclaration:replacement:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
processingInstruction: aTargetString data: aDataString
	super
		processingInstruction: aTargetString
		data: aDataString.

	self interruptOn = #processingInstruction:data:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
skippedEntity: anEntityName
	super skippedEntity: anEntityName.

	self interruptOn = #skippedEntity:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
startCData
	super startCData.

	self interruptOn = #startCData
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
startDTD: aRootElementName publicID: aPublicID systemID: aSystemID
	super
		startDTD: aRootElementName
		publicID: aPublicID
		systemID: aSystemID.

	self interruptOn = #startDTD:publicID:systemID:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
startDocument
	super startDocument.

	self interruptOn = #startDocument
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:35'!
startElement: aQualifiedName attributes: anAttributeDictionary
	super
		startElement: aQualifiedName
		attributes: anAttributeDictionary.

	self interruptOn = #startElement:attributes:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:34'!
startElement: aQualifiedName prefix: aPrefix uri: aURI attributes: anAttributeDictionary
	super
		startElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		attributes: anAttributeDictionary.

	self interruptOn = #startElement:prefix:uri:attributes:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 8/31/2017 23:31'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	super
		startElement: aQualifiedName
		prefix: aPrefix
		uri: aURI
		localName: aLocalName
		attributes: anAttributeDictionary.

	self interruptOn = #startElement:prefix:uri:localName:attributes:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
startEntity: anEntityName
	super startEntity: anEntityName.

	self interruptOn = #startEntity:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 6/26/2016 00:16'!
startPrefixMapping: aPrefix uri: aURI
	super
		startPrefixMapping: aPrefix
		uri: aURI.

	self interruptOn = #startPrefixMapping:uri:
		ifTrue: [self interruptParsing].! !

!SAXInterruptingRecordingPrefixURILocalNameHandler methodsFor: 'handling - lexical' stamp: 'monty 6/26/2016 00:16'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	super
		xmlVersion: aVersionFloat
		encoding: anEncoding
		standalone: aBoolean.

	self interruptOn = #xmlVersion:encoding:standalone:
		ifTrue: [self interruptParsing].! !

!SAXRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:37'!
endElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName
	self
		recordMessageReceiver: self
		selector: #endElement:prefix:uri:localName:
		arguments:
			(OrderedCollection new
				addLast: aQualifiedName;
				addLast: aPrefix;
				addLast: aURI;
				addLast: aLocalName;
				yourself)! !

!SAXRecordingPrefixURILocalNameHandler methodsFor: 'handling - content' stamp: 'monty 9/17/2017 08:37'!
startElement: aQualifiedName prefix: aPrefix uri: aURI localName: aLocalName attributes: anAttributeDictionary
	self
		recordMessageReceiver: self
		selector: #startElement:prefix:uri:localName:attributes:
		arguments:
			(OrderedCollection new
				addLast: aQualifiedName;
				addLast: aPrefix;
				addLast: aURI;
				addLast: aLocalName;
				addLast: anAttributeDictionary;
				yourself)! !

SAXRecordingHandler subclass: #SAXTestingMessageRecordingHandler
	instanceVariableNames: 'isInContentResults isInCDataSectionResults hasParserResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser'!

!SAXTestingMessageRecordingHandler commentStamp: 'monty 9/19/2017 06:15' prior: 0!
This handler records the results of testing messages from within handlers.!

!SAXTestingMessageRecordingHandler methodsFor: 'accessing' stamp: 'monty 9/18/2017 06:02'!
hasParserResults
	^ hasParserResults ifNil: [hasParserResults := OrderedCollection new]! !

!SAXTestingMessageRecordingHandler methodsFor: 'accessing' stamp: 'monty 9/17/2017 09:43'!
isInCDataSectionResults
	^ isInCDataSectionResults ifNil: [isInCDataSectionResults := OrderedCollection new]! !

!SAXTestingMessageRecordingHandler methodsFor: 'accessing' stamp: 'monty 9/17/2017 10:32'!
isInContentResults
	^ isInContentResults ifNil: [isInContentResults := OrderedCollection new]! !

!SAXTestingMessageRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 10:32'!
recordMessage: aMessage
	self recordTestingMessages.
	super recordMessage: aMessage.! !

!SAXTestingMessageRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 10:32'!
recordMessageReceiver: anObject selector: aSelector
	self recordTestingMessages.
	super
		recordMessageReceiver: anObject
		selector: aSelector.! !

!SAXTestingMessageRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 10:32'!
recordMessageReceiver: anObject selector: aSelector argument: anArgument
	self recordTestingMessages.
	super
		recordMessageReceiver: anObject
		selector: aSelector
		argument: anArgument.! !

!SAXTestingMessageRecordingHandler methodsFor: 'recording' stamp: 'monty 9/17/2017 10:32'!
recordMessageReceiver: anObject selector: aSelector arguments: aSequenceableCollection
	self recordTestingMessages.
	super
		recordMessageReceiver: anObject
		selector: aSelector
		arguments: aSequenceableCollection.! !

!SAXTestingMessageRecordingHandler methodsFor: 'recording' stamp: 'monty 9/18/2017 06:02'!
recordTestingMessages
	self hasParserResults addLast: self hasParser.
	self isInCDataSectionResults addLast: self isInCDataSection.
	self isInContentResults addLast: self isInContent.! !

XMLElement subclass: #XMLElementWithCachingNodeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementWithCachingNodeList commentStamp: 'monty 9/1/2016 08:19' prior: 0!
A class for testing elements that use XMLCachingNodeList instead of XMLNodeList.!

!XMLElementWithCachingNodeList methodsFor: 'defaults' stamp: 'monty 8/31/2016 06:56'!
nodeListClass
	^ XMLCachingNodeList! !

XMLElement subclass: #XMLElementWithoutCachingAttributeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLElementWithoutCachingAttributeList commentStamp: 'monty 9/3/2016 21:07' prior: 0!
A class for testing elements that use XMLAttributeList instead of XMLCachingAttributeList.!

!XMLElementWithoutCachingAttributeList methodsFor: 'defaults' stamp: 'monty 9/2/2016 13:57'!
attributeListClass
	^ XMLAttributeList! !

XMLElement subclass: #XMLFDateElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFDateElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFRealNameElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFRealNameElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFSerializationFormatElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFSerializationFormatElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFTableElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFTableElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFUserElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFUserElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFUsernameElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFUsernameElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLElement subclass: #XMLFWrongElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFWrongElement commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLElement!

XMLCData subclass: #XMLFCData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFCData commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLCData!

OrderedCollection subclass: #XMLStubOrderedListCustomCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM'!

!XMLStubOrderedListCustomCollection commentStamp: 'monty 3/29/2016 06:39' prior: 0!
This is a stub custom collection for XMLOrderedLists to test that #= and #hash do not depend on the type of the internal collection used.!

XMLAttributeList subclass: #XMLFAttributeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFAttributeList commentStamp: 'monty 9/8/2016 09:56' prior: 0!
A dummy subclass of XMLAttributeList!

XMLPI subclass: #XMLFPI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Tests-Parser-DOM-Factories'!

!XMLFPI commentStamp: '<historical>' prior: 0!
A dummy subclass of XMLPI!
